<?php

require("../../config/dbconn.php");

class BPDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_bp_list($v)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT id,code,name,tag,classification,
account_type,
(SELECT count(*) count from mt_bp_credit where bp_id=t1.id ),
(SELECT credit_days from mt_bp_credit 
  where account_type='ACCOUNTS RECEIVABLE' and  bp_id=t1.id ),
  status,
  ADDTIME(created_date, '05:30:00') created_date,created_by,
  ADDTIME(modified_date, '05:30:00') modified_date,modified_by from mt_business_partner t1 where code like ? or name like ? or status like ? or tag like ? order by id limit 20");
$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(4, "%$v%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_country_search($v)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT * from mt_country_master where country_name like ?");
$statement ->bindValue(1, "$v%", PDO::PARAM_STR);
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function delete_bank($c)
{
$data=0;
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_bp_bank 
    where id=:id");

$statement->execute(array(
':id'=>$c));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function delete_credit($c)
{
$data=0;
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_bp_credit 
    where id=:id");

$statement->execute(array(
':id'=>$c));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function delete_contact($c)
{
$data=0;
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_bp_contact 
		where id=:id");

$statement->execute(array(
':id'=>$c));

if ($statement->rowCount()){
	$data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
	$data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function delete_address($c)
{
$data=0;
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_bp_address 
		where id=:id");

$statement->execute(array(
':id'=>$c));

if ($statement->rowCount()){
	$data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
	$data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function delete_business_type($c)
{
$data=0;
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_bp_business_types 
		where id=:id");

$statement->execute(array(
':id'=>$c));

if ($statement->rowCount()){
	$data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
	$data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_business_type($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("UPDATE mt_bp_business_types set 
	business_activity=:business_activity,
	account_type=:account_type,default_address=:default_address,
	status=:status,
	ip=:ip,uid=:uid,ua=:ua,ekey=:ekey,created_date= now() 
	where id=:id and bp_id=:bp_id");

$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':business_activity'=>$c->business_activity,
':account_type'=>$c->account_type,
':default_address'=>$c->default_address,
':status'=>$c->status,
':bp_id'=>$c->bp_id,
':id'=>$c->id));

if ($statement->rowCount()){
	$data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
	$data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_bp($dev,$c)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("UPDATE mt_business_partner set 
modified_by=:uid,modified_date= now(),
name=:name  
where id=:id");

$statement->execute(array(':uid'=>$dev->username ,

':id'=>$c->bp_id,
':name'=>$c->name));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_basic_info($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("UPDATE mt_business_partner set
name=:name,
tag=:tag,
classification=:classification,
parent_company=:parent_company,
status=:status,
pan=:pan,
gstin=:gstin,
salesman=:salesman,
account_type=:account_type,modified_by=:uid,modified_date= now() 
where id=:id");

$statement->execute(array(':uid'=>$dev->username ,
':name'=>$c->name,
':tag'=>$c->tag,
':classification'=>$c->classification,
':parent_company'=>$c->parent_company,
':status'=>$c->status,
':account_type'=>$c->account_type,
':pan'=>$c->pan,
':gstin'=>$c->gstin,
':salesman'=>$c->salesman,
':id'=>$c->id));

if ($statement->rowCount()){
	$data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
	$data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_address($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("UPDATE mt_bp_address SET type=:type,
  fax=:fax,
address=:address,
address2=:address2,
address3=:address3,
party_type=:party_type,
isdefault=:isdefault,
country=:country,
state=:state,
city=:city,
zip=:zip,
po_box_no=:po_box_no,
po_box_name=:po_box_name,
phone=:phone,
mobile1=:mobile1,
mobile2=:mobile2,
email1=:email1,
email2=:email2,
ip=:ip,uid=:uid,ua=:ua,ekey=:ekey,created_date= now() 
  where id=:id and bp_id=:bp_id");

$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':type'=>$c->type,
':address'=>$c->address,
':address2'=>$c->address2,
':address3'=>$c->address3,
':party_type'=>$c->party_type,
':isdefault'=>$c->isdefault,
':country'=>$c->country,
':state'=>$c->state,
':city'=>$c->city,
':zip'=>$c->zip,
':po_box_no'=>$c->po_box_no,
':po_box_name'=>$c->po_box_name,
':phone'=>$c->phone,
':mobile1'=>$c->mobile1,
':mobile2'=>$c->mobile2,
':email1'=>$c->email1,
':email2'=>$c->email2,
':bp_id'=>$c->bp_id,
':id'=>$c->id,
':fax'=>$c->fax));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



public static function update_contact($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("UPDATE mt_bp_contact SET 
  salutation=:salutation,
gender=:gender,
first_name=:first_name,
middle_name=:middle_name,
last_name=:last_name,
phone=:phone,
mobile=:mobile,
residence=:residence,
email1=:email1,
email2=:email2,
email3=:email3,
ip=:ip,uid=:uid,ua=:ua,ekey=:ekey,created_date= now() 
  where id=:id and bp_id=:bp_id
");

$statement->execute(array(
  ':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':salutation'=>$c->salutation,
':gender'=>$c->gender,
':first_name'=>$c->first_name,
':middle_name'=>$c->middle_name,
':last_name'=>$c->last_name,
':phone'=>$c->phone,
':mobile'=>$c->mobile,
':residence'=>$c->residence,
':email1'=>$c->email1,
':email2'=>$c->email2,
':email3'=>$c->email3,
':bp_id'=>$c->bp_id,
':id'=>$c->id));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_contact($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_bp_contact(salutation,gender,first_name,middle_name,last_name,phone,mobile,residence,email1,email2,email3,ip,uid ,ua,ekey,created_date,bp_id,created_by,temp_code) 
values(:salutation,:gender,:first_name,:middle_name,:last_name,:phone,:mobile,:residence,:email1,:email2,:email3,:ip ,:uid ,
:ua ,:ekey,now(),:bp_id,:created_by,:temp_code)");

$statement->execute(array(
  ':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':salutation'=>$c->salutation,
':gender'=>$c->gender,
':first_name'=>$c->first_name,
':middle_name'=>$c->middle_name,
':last_name'=>$c->last_name,
':phone'=>$c->phone,
':mobile'=>$c->mobile,
':residence'=>$c->residence,
':email1'=>$c->email1,
':email2'=>$c->email2,
':email3'=>$c->email3,
':bp_id'=>$c->bp_id,

':temp_code'=>$temp_code,
':created_by'=>$dev->username
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_bp_contact where uid=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function save_address($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_bp_address(fax,type,address,address2,address3,party_type,isdefault,country,state,city,zip,po_box_no,po_box_name,phone,mobile1,mobile2,email1,email2,ip,uid ,ua,ekey,created_date,bp_id,created_by,temp_code) 
values(:fax,:type,
:address,
:address2,
:address3,
:party_type,
:isdefault,
:country,
:state,
:city,
:zip,
:po_box_no,
:po_box_name,
:phone,
:mobile1,
:mobile2,
:email1,
:email2,:ip ,:uid ,
:ua ,:ekey,now(),:bp_id,:created_by,:temp_code)");

$statement->execute(array(
  ':fax'=>$c->fax,
  ':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':type'=>$c->type,
':address'=>$c->address,
':address2'=>$c->address2,
':address3'=>$c->address3,
':party_type'=>$c->party_type,
':isdefault'=>(int)$c->isdefault,
':country'=>$c->country,
':state'=>$c->state,
':city'=>$c->city,
':zip'=>$c->zip,
':po_box_no'=>$c->po_box_no,
':po_box_name'=>$c->po_box_name,
':phone'=>$c->phone,
':mobile1'=>$c->mobile1,
':mobile2'=>$c->mobile2,
':email1'=>$c->email1,
':email2'=>$c->email2,
':bp_id'=>$c->bp_id,

':temp_code'=>$temp_code,
':created_by'=>$dev->username));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_bp_address where uid=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_credit($dev,$c)
{
$data=0;
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_bp_credit SET 
  account_type=:account_type,
currency=:currency,
limit_amount=:limit_amount,
overdue_amount=:overdue_amount,
buffer_percentage=:buffer_percentage,
final_limit=:final_limit,
pdc_days=:pdc_days,
credit_days=:credit_days,
late_payment_type=:late_payment_type,
late_payment =:late_payment ,
last_review_date=:last_review_date,
next_review_date=:next_review_date,
ip=:ip,uid=:uid,ua=:ua,ekey=:ekey,created_date= now() 
  where id=:id and bp_id=:bp_id ");

$statement->execute(array(
':account_type'=>$c->account_type,
':currency'=>$c->currency,
':limit_amount'=>$c->limit_amount,
':overdue_amount'=>$c->overdue_amount,
':buffer_percentage'=>$c->buffer_percentage,
':final_limit'=>$c->final_limit,
':pdc_days'=>$c->pdc_days,
':credit_days'=>$c->credit_days,
':late_payment_type'=>$c->late_payment_type,
':late_payment'=>$c->late_payment ,
':last_review_date'=>$c->last_review_date,
':next_review_date'=>$c->next_review_date,
':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':bp_id'=>$c->bp_id,
':id'=>$c->id));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_credit($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_bp_credit(
  account_type,currency,limit_amount,overdue_amount,buffer_percentage,
  final_limit,pdc_days,credit_days,late_payment_type,late_payment,
  last_review_date,next_review_date,ip,uid ,ua,ekey,created_date,bp_id,temp_code) 
values(
:account_type,
:currency,
:limit_amount,
:overdue_amount,
:buffer_percentage,
:final_limit,
:pdc_days,
:credit_days,
:late_payment_type,
:late_payment,
:last_review_date,
:next_review_date,:ip ,:uid ,
:ua ,:ekey,now(),:bp_id,:temp_code)");

if($c->pdc_days=="")
{
  $c->pdc_days=null;
}
if($c->credit_days=="")
{
  $c->credit_days=null;
}

if($c->last_review_date=="NULL")
{
  $c->last_review_date=null;
}

if($c->next_review_date=="NULL")
{
  $c->next_review_date=null;
}


$statement->execute(array(
':account_type'=>$c->account_type,
':currency'=>$c->currency,
':limit_amount'=>$c->limit_amount,
':overdue_amount'=>$c->overdue_amount,
':buffer_percentage'=>$c->buffer_percentage,
':final_limit'=>$c->final_limit,
':pdc_days'=>$c->pdc_days,
':credit_days'=>$c->credit_days,
':late_payment_type'=>$c->late_payment_type,
':late_payment'=>$c->late_payment ,
':last_review_date'=>$c->last_review_date,
':next_review_date'=>$c->next_review_date,
':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':bp_id'=>$c->bp_id,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_bp_credit where uid=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_bank($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("UPDATE mt_bp_bank SET priority=:priority,
bank_name=:bank_name,
account_no=:account_no,
currency=:currency,
swift=:swift,
iban=:iban,
sort=:sort,
ifsc=:ifsc,
rtgs=:rtgs,
status=:status,modified_by=:uid,modified_date= now() 
  where id=:id and bp_id=:bp_id ");

$statement->execute(array(':uid'=>$dev->username ,


':priority'=>$c->priority,
':bank_name'=>$c->bank_name,
':account_no'=>$c->account_no,
':currency'=>$c->currency,
':swift'=>$c->swift,
':iban'=>$c->iban,
':sort'=>$c->sort,
':ifsc'=>$c->ifsc,
':rtgs'=>$c->rtgs,
':status'=>$c->status,
':bp_id'=>$c->bp_id,
':id'=>$c->id));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_bank($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_bp_bank(priority,bank_name,account_no,currency,swift,iban,sort,ifsc,rtgs,status,ip,uid ,ua,ekey,created_date,bp_id,temp_code,created_by) 
values(:priority,:bank_name,:account_no,:currency,:swift,:iban,:sort,:ifsc,:rtgs,:status,:ip ,:uid ,
:ua ,:ekey,now(),:bp_id,:temp_code,:created_by)");

$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':priority'=>$c->priority,
':bank_name'=>$c->bank_name,
':account_no'=>$c->account_no,
':currency'=>$c->currency,
':swift'=>$c->swift,
':iban'=>$c->iban,
':sort'=>$c->sort,
':ifsc'=>$c->ifsc,
':rtgs'=>$c->rtgs,
':status'=>$c->status,
':bp_id'=>$c->bp_id,
':temp_code'=>$temp_code,

':created_by'=>$dev->username
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_bp_bank  
  where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function delete_kyc($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_bp_kyc 
  where id=:id");

$statement->execute(array(':id'=>$c));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_kyc($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("UPDATE mt_bp_kyc SET doc_name=:doc_name,
doc_no=:doc_no,
validity=:validity,
file=:file,
status=:status,modified_by=:modified_by,modified_date= now() 
  where id=:id and bp_id=:bp_id");

if($c->validity=="null")
{
  $c->validity=null;
}

$statement->execute(array(':modified_by'=>$dev->username ,

':doc_name'=>$c->doc_name,
':doc_no'=>$c->doc_no,
':validity'=>$c->validity,
':file'=>$c->file,
':status'=>$c->status,
':bp_id'=>$c->bp_id,
':id'=>$c->id));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_kyc1($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_bp_kyc(
 doc_name,doc_no,validity,file,status,ip,uid ,ua,ekey,created_date,bp_id,temp_code,created_by,file_url) 
values(:doc_name,
:doc_no,
:validity,
:file,
:status,:ip ,:uid ,
:ua ,:ekey,now(),:bp_id,:temp_code,:created_by,:file_url)");

if($c->validity=="null")
{
  $c->validity=null;
}
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':doc_name'=>$c->doc_name,
':doc_no'=>$c->doc_no,
':validity'=>$c->validity,
':file'=>$c->file,
':status'=>$c->status,
':bp_id'=>$c->bp_id,
':temp_code'=>$temp_code,
':created_by'=>$dev->username,
':file_url'=>$c->file_url
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_bp_kyc where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_kyc($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_bp_kyc(
 doc_name,doc_no,validity,file,status,ip,uid ,ua,ekey,created_date,bp_id,temp_code,created_by) 
values(:doc_name,
:doc_no,
:validity,
:file,
:status,:ip ,:uid ,
:ua ,:ekey,now(),:bp_id,:temp_code,:created_by)");

if($c->validity=="null")
{
  $c->validity=null;
}
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':doc_name'=>$c->doc_name,
':doc_no'=>$c->doc_no,
':validity'=>$c->validity,
':file'=>$c->file,
':status'=>$c->status,
':bp_id'=>$c->bp_id,
':temp_code'=>$temp_code,
':created_by'=>$dev->username
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_bp_kyc where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_business_type($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_bp_business_types(
	business_activity,account_type,default_address,status,ip,uid ,ua,ekey,created_date,bp_id,temp_code,created_by) 
values(:business_activity,:account_type,:default_address,
:status,:ip ,:uid ,
:ua ,:ekey,now(),:bp_id,:temp_code,:created_by)");

$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':business_activity'=>$c->business_activity,
':account_type'=>$c->account_type,
':default_address'=>$c->default_address,
':status'=>$c->status,
':bp_id'=>$c->bp_id,
':temp_code'=>$temp_code,
':created_by'=>$dev->username
));

if ($statement->rowCount()){
	$data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
	$data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_bp_business_types where uid=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_others($dev,$c)
{
$data=0;
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("UPDATE mt_bp_others SET registered_client=:registered_client,
group_company=:group_company,
transaction_currency=:transaction_currency,
local_currency=:local_currency,
advance_percent_client=:advance_percent_client,
advance_percent_pa=:advance_percent_pa,
job_no_id=:job_no_id,
sailing_email=:sailing_email,ip=:ip,uid=:uid,ua=:ua,ekey=:ekey,created_date= now() 
  where id=:id and bp_id=:bp_id");

$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':registered_client'=>$c->registered_client,
':group_company'=>$c->group_company,
':transaction_currency'=>$c->transaction_currency,
':local_currency'=>$c->local_currency,
':advance_percent_client'=>$c->advance_percent_client,
':advance_percent_pa'=>$c->advance_percent_pa,
':job_no_id'=>$c->job_no_id,
':sailing_email'=>$c->sailing_email,
':bp_id'=>$c->bp_id,
':id'=>$c->id));

if ($statement->rowCount()){
  $data=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_others($dev,$c)
{
$data=0;
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_bp_others(
  registered_client,group_company,transaction_currency,local_currency,advance_percent_client,advance_percent_pa,job_no_id,sailing_email,ip,uid ,ua,ekey,created_date,bp_id) 
values(:registered_client,:group_company,:transaction_currency,:local_currency,:advance_percent_client,:advance_percent_pa,:job_no_id,:sailing_email,:ip ,:uid ,
:ua ,:ekey,now(),:bp_id)");

$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':registered_client'=>$c->registered_client,
':group_company'=>$c->group_company,
':transaction_currency'=>$c->transaction_currency,
':local_currency'=>$c->local_currency,
':advance_percent_client'=>$c->advance_percent_client,
':advance_percent_pa'=>$c->advance_percent_pa,
':job_no_id'=>$c->job_no_id,
':sailing_email'=>$c->sailing_email,
':bp_id'=>$c->bp_id));

if ($statement->rowCount()){
  $data=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_basic_info($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("SELECT id from mt_business_partner where name=:name and location_id=:location_id");
$statement->execute(array(':name'=>$c->name,':location_id'=>$dev->location));
$data["ed"]=$statement->fetchAll(PDO::FETCH_ASSOC);
if(count($data['ed'])>=1)
{
  $data["status"]=0;
  $data["msg"]="Name already exist.";
}else{
$statement = $db->prepare("INSERT into mt_business_partner(
	code,name,tag,classification,parent_company,status,account_type,ip,uid ,ua,ekey,created_date,temp_code,created_by,pan,gstin,salesman,
  location_id,company_id) 
values(:code,:name,:tag,:classification,:parent_company,
:status,:account_type,:ip ,:uid ,
:ua ,:ekey,now(),:temp_code,:created_by,:pan,:gstin,:salesman,
'$dev->location','$dev->company') ");

$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid,
  ':created_by'=>$dev->username,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':code'=>$c->code,
':name'=>$c->name,
':tag'=>$c->tag,
':classification'=>$c->classification,
':parent_company'=>$c->parent_company,
':status'=>$c->status,
':account_type'=>$c->account_type,
':pan'=>$c->pan,
':gstin'=>$c->gstin,
':salesman'=>$c->salesman,
':temp_code'=>$temp_code));

if ($statement->rowCount()){
	$data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
	$data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_business_partner where uid=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,':uid'=>$dev->uid));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$bp_id=$data["id"][0]["id"];

$ccode="F".self::setFourDigit($bp_id);
$data["code"]=$ccode;

$statement = $db->prepare("UPDATE mt_business_partner SET code=:code 
  where id=:id");
$statement->execute(array(':id'=>$bp_id,':code'=>$ccode));

if ($statement->rowCount()){
  $data["id_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["id_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function setFourDigit($v)
{
  $len=strlen($v);

if($len==1)
{
  $v="0000".$v;
}else if($len==2)
{
  $v="000".$v;
}else if($len==3)
{
  $v="00".$v;
}else if($len==4)
{
  $v="0".$v;
}else if($len==5)
{
  $v=$v;
}

return $v;
}


public static function get_possible_values()
{
//var_dump($code);
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT value from mt_master where module='booking' and page='order-entry' and code='principal'"); 
$statement->execute();
$data["principal"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='tag'"); 
$statement->execute();
$data["tag"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='classification'"); 
$statement->execute();
$data["classification"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='account_type'"); 
$statement->execute();
$data["account_type"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='status'"); 
$statement->execute();
$data["status"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='business_activity'"); 
$statement->execute();
$data["business_activity"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["bt_account_type"]=$data["account_type"];
$data["bt_status"]=$data["status"];

$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='address_type'"); 
$statement->execute();
$data["address_type"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='address_party_type'"); 
$statement->execute();
$data["address_party_type"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='salutation'"); 
$statement->execute();
$data["salutation"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='gender'"); 
$statement->execute();
$data["gender"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["ct_status"]=$data["status"];
$data["cr_account_type"]=$data["account_type"];

$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='late_payment_type'"); 
$statement->execute();
$data["late_payment_type"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$data["bank_status"]=$data["status"];

$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='doc_name'"); 
$statement->execute();
$data["doc_name"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='registered_client'"); 
$statement->execute();
$data["registered_client"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='group_company'"); 
$statement->execute();
$data["group_company"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["kyc_status"]=$data["status"];


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_possible_values_bylocationid($dev)
{
//var_dump($code);
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT value from mt_master where module='booking' and page='order-entry' and code='principal' and location_id='$dev->location' "); 
$statement->execute();
$data["principal"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='tag'"); 
$statement->execute();
$data["tag"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='classification'"); 
$statement->execute();
$data["classification"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='account_type'"); 
$statement->execute();
$data["account_type"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='status'"); 
$statement->execute();
$data["status"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='business_activity'"); 
$statement->execute();
$data["business_activity"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["bt_account_type"]=$data["account_type"];
$data["bt_status"]=$data["status"];

$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='address_type'"); 
$statement->execute();
$data["address_type"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='address_party_type'"); 
$statement->execute();
$data["address_party_type"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='salutation'"); 
$statement->execute();
$data["salutation"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='gender'"); 
$statement->execute();
$data["gender"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["ct_status"]=$data["status"];
$data["cr_account_type"]=$data["account_type"];

$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='late_payment_type'"); 
$statement->execute();
$data["late_payment_type"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$data["bank_status"]=$data["status"];

$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='doc_name'"); 
$statement->execute();
$data["doc_name"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='registered_client'"); 
$statement->execute();
$data["registered_client"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT value from mt_master where module='config' and page='business-partner' and code='group_company'"); 
$statement->execute();
$data["group_company"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["kyc_status"]=$data["status"];


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_others($code)
{
//var_dump($code);
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,bp_id,registered_client,group_company,transaction_currency,local_currency,advance_percent_client,advance_percent_pa,job_no_id,sailing_email from mt_bp_others 
where id=:id");

$statement->bindValue(':id',$code); 
$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_basic_info($code)
{
//var_dump($code);
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,code,name,tag,classification,
parent_company,status,account_type,pan,gstin,salesman from mt_business_partner 
where id=:id");

$statement->bindValue(':id',$code); 
$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_address_list($id)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT bp_id,id,type,address,address2,address3,party_type,isdefault,country,state,city,zip,po_box_no,po_box_name,phone,mobile1,mobile2,email1,email2,fax from mt_bp_address where bp_id=:id ");
 
$statement->execute(array(':id'=>$id));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_contact_list($id)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,salutation,gender,first_name,
  middle_name,last_name,phone,mobile,residence,email1,email2,email3,
  bp_id from mt_bp_contact where bp_id=:id");
 
$statement->execute(array(':id'=>$id));

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_credit_list($id)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT bp_id, id,
  account_type,currency,limit_amount,overdue_amount,buffer_percentage,final_limit,pdc_days,credit_days,late_payment_type,late_payment ,last_review_date,next_review_date
  ,'0' edit from mt_bp_credit
  where bp_id=:id");
 
$statement->execute(array(':id'=>$id));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_bank_list($id)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT bp_id, id,priority,bank_name,account_no,currency,swift,iban,sort,ifsc,rtgs,status,'0' edit from mt_bp_bank 
  where bp_id=:id");
 
$statement->execute(array(':id'=>$id));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_kyc_list1($id)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT bp_id, id,doc_name,doc_no,validity,file,status,'0' edit,file_url from mt_bp_kyc 
  where bp_id=:id");
 
$statement->execute(array(':id'=>$id));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_kyc_list($id)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT bp_id, id,doc_name,doc_no,validity,file,status,'0' edit from mt_bp_kyc 
  where bp_id=:id");
 
$statement->execute(array(':id'=>$id));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_business_types_list($id)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT bp_id, id,business_activity,account_type,default_address,status,'0' edit from mt_bp_business_types where bp_id=:id");
 
$statement->execute(array(':id'=>$id));

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_business_partner_list($dev,$code)
{

$data=false;
try
{
$db = Factory::getConnection();
$aq=Factory::getRestrictionQuery1($dev,"t1");

$statement = $db->prepare("SELECT id,code,name,tag,classification,
account_type,
(SELECT count(*) count from mt_bp_credit where bp_id=t1.id ) count,
(SELECT credit_days from mt_bp_credit 
  where account_type='ACCOUNTS RECEIVABLE' 
  and  bp_id=t1.id ) credit_days,
  status,ADDTIME(created_date, '05:30:00')created_date,created_by,ADDTIME(modified_date, '05:30:00') modified_date,modified_by from mt_business_partner t1 
  where $aq   
  order by id limit :sta,50");

$statement->bindValue(':sta',(int) $code->start, PDO::PARAM_INT); 
$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_tds_list($id)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT bp_id,id,lower_tax_tds,applicable_from,applicable_to,'0' edit
  from mt_bp_tds_rate where bp_id=:id");
 
$statement->execute(array(':id'=>$id));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_tds($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_bp_tds_rate(
  lower_tax_tds,applicable_from,applicable_to,ip,uid ,ua,ekey,created_date,bp_id,temp_code,created_by) 
values(:lower_tax_tds,:applicable_from,:applicable_to,:ip ,:uid ,
:ua ,:ekey,now(),:bp_id,:temp_code,:created_by)");

$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':lower_tax_tds'=>$c->lower_tax_tds,
':applicable_from'=>$c->applicable_from,
':applicable_to'=>$c->applicable_to,
':bp_id'=>$c->bp_id,
':temp_code'=>$temp_code,
':created_by'=>$dev->username
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_bp_tds_rate where uid=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_tds($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("UPDATE mt_bp_tds_rate set 
  lower_tax_tds=:lower_tax_tds,
  applicable_from=:applicable_from,
  ip=:ip,uid=:uid,ua=:ua,ekey=:ekey,created_date= now() 
  where id=:id and bp_id=:bp_id");

$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':lower_tax_tds'=>$c->lower_tax_tds,
':applicable_from'=>$c->applicable_from,
':bp_id'=>$c->bp_id,
':id'=>$c->id));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function delete_tds($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_bp_tds_rate 
    where id=:id");

$statement->execute(array(
':id'=>$c));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


}

?>