<?php


require("../config/dbconn.php");

class BrokerageDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



public static function delete_brokerage_setup($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("DELETE from mt_brokerage_setup where id=:id");

$statement->execute(array(':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


//upate

public static function update_brokerage_setup($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("UPDATE mt_brokerage_setup SET 
vessel=:vessel,
ap_code=:ap_code,
charge_basis=:charge_basis,
charge_code=:charge_code,
currency=:currency,
amount=:amount,
validity_from=:validity_from,
validity_to=:validity_to,
remarks=:remarks,
modified_by=:modified_by,modified_date=now() 
where id=:id");

$statement->execute(array(
	':modified_by'=>$dev->username ,
':id'=>$c->id,

':vessel'=>$c->vessel,
':ap_code'=>$c->ap_code,
':charge_basis'=>$c->charge_basis,
':charge_code'=>$c->charge_code,
':currency'=>$c->currency,
':amount'=>$c->amount,
':validity_from'=>$c->validity_from,
':validity_to'=>$c->validity_to,
':remarks'=>$c->remarks

));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_brokerage_setup($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_brokerage_setup(vessel,ap_code,charge_basis,charge_code,currency,amount,validity_from,validity_to,remarks, 
ip,created_by ,ua,ekey,created_date,temp_code) 
values(:vessel,:ap_code,:charge_basis,:charge_code,:currency,:amount,:validity_from,:validity_to,:remarks,
:ip,:created_by,:ua,:ekey,now(),:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,
	':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,


':vessel'=>$c->vessel,
':ap_code'=>$c->ap_code,
':charge_basis'=>$c->charge_basis,
':charge_code'=>$c->charge_code,
':currency'=>$c->currency,
':amount'=>$c->amount,
':validity_from'=>$c->validity_from,
':validity_to'=>$c->validity_to,
':remarks'=>$c->remarks,

':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement = $db->prepare("SELECT id from mt_brokerage_setup where created_by=:uid and temp_code=:temp_code ");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


//get list
public static function search_brokerage_setup_list($v) 
{
$data=false;
try
{
$db = Factory::getConnection();

$v2='';
$spv=explode(",",$v);
if(count($spv)>1)
{
  $v2=" vessel like '%".$spv[0]."%' and ap_code like '%".$spv[1]."%'";
}else{
  $v2=" vessel like '%".$v."%' or ap_code like '%".$spv[0]."%' ";
}

$statement = $db->prepare("SELECT id,vessel,ap_code,charge_basis,charge_code,currency,amount,validity_from,validity_to,remarks,'0' edit 
from mt_brokerage_setup where $v2 order by id desc limit 50");
//$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
//$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

//get list
public static function get_brokerage_setup_list($code) 
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,vessel,ap_code,charge_basis,charge_code,currency,amount,validity_from,validity_to,remarks,'0' edit 
from mt_brokerage_setup  order by id desc limit :sta,50");
$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT);
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

//get count
public static function get_container_count($code) 
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT count(*) cc from mt_manifest_entry_landingcraft where mnf_entry_pk in ( SELECT id FROM mt_manifest_entry where voyage=:voyage and  manifest_type like '%IMPORT%')");
$statement->execute(array(':voyage'=>$code));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_commission_data1($code) 
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,vessel,ap_code,charge_basis,charge_code,currency,
  '' famt,'' lamt,amount,
  '1' ex_rate,validity_from,validity_to,remarks
  FROM mt_brokerage_setup where vessel=(SELECT vessel from mt_voyage where voyage=:voyage and brokerage_calculated is null limit 1) and '$code->custom_date' between validity_from and validity_to");
$statement->execute(array(':voyage'=>$code->voyage));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_commission_data($code) 
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,vessel,ap_code,charge_basis,charge_code,currency,
	'' famt,'' lamt,amount,
	'1' ex_rate,validity_from,validity_to,remarks
	FROM mt_brokerage_setup where vessel=(SELECT vessel from mt_voyage where voyage=:voyage and brokerage_calculated is null limit 1)");
$statement->execute(array(':voyage'=>$code));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

//save commission
public static function save_brokerage_calculation($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

//check voyage exist or not
/*$statement = $db->prepare("SELECT * from mt_brokerage_calculation where voyage=:voyage");
$statement->execute(array(':voyage'=>$c->voyage));
$voyageData=$statement->fetchAll(PDO::FETCH_ASSOC);

if(count($voyageData)>0)
{
$data["status"]=0;

}else
*/
$cds=$c->cd;
for($i=0;$i<count($cds);$i++)
{
$r=$cds[$i];
$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_brokerage_calculation (
voyage,
tot_containers,
ap_code,
charge_basis,
currency,
ex_rate,
f_amount,
l_amount,
created_by,created_date,ip,ua,ekey,temp_code,location_id,company_id) 
values (
:voyage,
:tot_containers,
:ap_code,
:charge_basis,
:currency,
:ex_rate,
:f_amount,
:l_amount,
:created_by,now(),:ip,:ua,:ekey,:temp_code,:location_id,:company_id)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':voyage'=>$c->voyage,
':tot_containers'=>$c->cc,
':ap_code'=>$r->ap_code,
':charge_basis'=>$r->charge_basis,
':currency'=>$r->currency,
':ex_rate'=>$r->ex_rate,
':f_amount'=>$r->famt,
':l_amount'=>$r->lamt,


':temp_code'=>$temp_code,
':company_id'=>$dev->company,
':location_id'=>$dev->location
));

  
if ($statement->rowCount()){
    $data["status".($i+1)]=1;
  } else{
    $data["status".($i+1)]=0;
  }


  //FINANCE POSTING TO BE DONE
//THIS CODE I'LL GIVE YOU SHORTLY
//$doc_date=date('Y-m-d');
$doc_date=$c->custom_date;

//QUERY TO SELECT NEW ID
$statement = $db->prepare("SELECT id from mt_brokerage_calculation 
WHERE created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

$fid=self::setFourDigit($op[0]["id"]);
$brkg_fid='BRKG/'.$fid;

//QUERY - AR_TRANS
$statement = $db->prepare(" INSERT into mt_ap_trans 
(apt_company,apt_code,apt_type,apt_number,apt_other_reference,apt_doc_date,
apt_gl_date,apt_year,apt_period,apt_currency,apt_ex_rate,apt_foreign_amount,
apt_local_amount,apt_foreign_balance,
apt_local_balance,apt_balance_status,
apt_description,apt_notes,ip,created_by ,ua,ekey,created_date,
company_id,location_id)
SELECT 'FISA',ap_code,'BROKERAGE','".$brkg_fid."',charge_basis,
'$doc_date','$doc_date',
 ".self::getFinancialYear().",
".self::getFinancialPeriod($doc_date).",currency,ex_rate,
  -f_amount,-l_amount,-f_amount,-l_amount,'A',
  concat(voyage,'/',(select concat(vessel,'/',date_format(eta,'%Y-%m-%d')) from mt_voyage where voyage=t1.voyage),'/',tot_containers),tot_containers,
  '$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$dev->company','$dev->location' 
FROM mt_brokerage_calculation t1 where id=:id");
$statement->execute(array(':id'=>$op[0]["id"]));

if ($statement->rowCount()){
  $data["ap_trans_status".($i+1)]=1;
} else{
  $data["ap_trans_status".($i+1)]=0;
}


//QUERY - AR_TRANS_BALANCE
$statement = $db->prepare("INSERT into mt_ap_trans_balance
(apdm_company,apdm_code,apdm_doc_type,apdm_doc_number,
  apdm_serial,apdm_other_reference,apdm_date,apdm_currency,
  apdm_ex_rate,apdm_of_amount,apdm_ol_amount,apdm_bf_amount,
  apdm_bl_amount,apdm_pf_amount,apdm_pl_amount,apdm_status,
ip,created_by ,ua,ekey,created_date,temp_code,
company_id,location_id)
SELECT apt_company,apt_code,apt_type,apt_number,
apt_serial,apt_other_reference,apt_gl_date,apt_currency,
apt_ex_rate,apt_foreign_amount,apt_local_amount,
apt_foreign_balance,apt_local_balance,
0,0,'PENDING',ip,created_by,ua,ekey,now(),'',
'$dev->company','$dev->location' 
 from mt_ap_trans where apt_number=:apt_number ");

$statement->execute(array(':apt_number'=>$brkg_fid));

if ($statement->rowCount()){
  $data["tb_status".($i+1)]=1;
} else{
  $data["tb_status".($i+1)]=0;
}

}

$statement = $db->prepare("UPDATE mt_voyage SET 
brokerage_calculated='YES',
modified_by=:modified_by,
modified_date=now() where voyage=:voyage");

$statement->execute(array(
':voyage'=>$c->voyage,
':modified_by'=>$dev->username
));

 if ($statement->rowCount()){
    $data["voyage_status"]=1;
    $data["status"]=1;
  } else{
    $data["voyage_status"]=0;
    $data["status"]=0;

  }



//}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function setFourDigit($v)
{
  $len=strlen($v);

if($len==1)
{
  $v="000".$v;
}else if($len==2)
{
  $v="00".$v;
}else if($len==3)
{
  $v="0".$v;
}

return $v;
}



public static function getFinancialYear()
{
//$year = ( date('m') > 4) ? date('Y') + 1 : date('Y');
$year=date('Y');
return $year;
}

public static function getFinancialPeriod($doc_date)
{

//$year = ( date('m') > 4) ? date('Y') + 1 : date('Y');
//$period=4;
//return $period;
$data=false;
try
{
$db = Factory::getConnection();

//$aq=self::getRestrictionQuery($dev);
//$doc_date="2019-12-15";
$date=date_create($doc_date);
$m= date_format($date,"F");
$y= date_format($date,"Y");

$statement = $db->prepare("SELECT enumber from mt_period 
  where period=:period and year=:year and open_max='OPEN'");

$statement->execute(array(':period'=>$m,':year'=>$y));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
//var_dump($statement->debugDumpParams());
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  $p=-10;
  if(count($data)==1)
  {
    $p=$data[0]["enumber"];
  }
  return $p;
}




}

?>