<?php


require("../config/dbconn.php");

class BulkCargoDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_avl_qty($c) 
{
$data=false;
try
{
$db = Factory::getConnection();
if($c->type=="VOYAGE WISE")
{
$q=" voyage=:voyage";
$ar=array(':voyage'=>$c->voyage);
}else{
$q=" bl_no=:bl_no";
$ar=array(':bl_no'=>$c->bl_no);

}
$statement = $db->prepare("SELECT id,
bal_qty
FROM mt_bulkcargo_discharge where $q order by id desc limit 1");
$statement->execute($ar);
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
//if no data found then return total qty
if(count($data)==0)
{
  $q="";
if($c->type=="VOYAGE WISE")
{
$q="SELECT sum(gross_weight) bal_qty FROM mt_manifest_entry_cargo
where mnf_entry_pk in 
(select id from mt_manifest_entry where voyage='$c->voyage')";
}else{
$q="SELECT gross_weight bal_qty FROM mt_manifest_entry_cargo
where mnf_entry_pk = 
(select id from mt_manifest_entry where bl_no='$c->bl_no')";
}
$statement = $db->prepare($q);
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function get_bulk_cargo_list($code) 
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,
discharge_type,
vessel,
voyage,
bl_no,
delivery_type,
tot_qty,
avl_qty,
dis_qty,
bal_qty,
customer,
discharge_datetime,
es_qty,
email,'0' edit 
FROM mt_bulkcargo_discharge where voyage=:voyage");
$statement->execute(array(':voyage'=>$code));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}


public static function get_total_weight($code) 
{
$data=false;
try
{
$db = Factory::getConnection();
$q="";
if($code->type=="VOYAGE WISE")
{
$q="SELECT sum(gross_weight) gw FROM mt_manifest_entry_cargo
where mnf_entry_pk in 
(select id from mt_manifest_entry where voyage=:code)";
}else{
$q="SELECT gross_weight gw FROM mt_manifest_entry_cargo
where mnf_entry_pk = 
(select id from mt_manifest_entry where bl_no=:code)";
}
$statement = $db->prepare($q);
$statement->execute(array(':code'=>$code->val));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}


public static function save_bulk_cargo($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_bulkcargo_discharge(discharge_type,vessel,voyage,bl_no,delivery_type,tot_qty,avl_qty,dis_qty,bal_qty,customer,discharge_datetime,email,created_by,created_date,ip,ua,ekey,temp_code,es_qty) 
values(:discharge_type,:vessel,:voyage,:bl_no,:delivery_type,:tot_qty,:avl_qty,:dis_qty,:bal_qty,:customer,:discharge_datetime,:email,:created_by,now(),:ip,:ua,:ekey,:temp_code,:es_qty)");


$statement->execute(array(':ip'=>$dev->ip,
':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':discharge_type'=>$c->discharge_type,
':vessel'=>$c->vessel,
':voyage'=>$c->voyage,
':bl_no'=>$c->bl_no,
':delivery_type'=>$c->delivery_type,
':tot_qty'=>$c->tot_qty,
':avl_qty'=>$c->avl_qty,
':dis_qty'=>$c->dis_qty,
':bal_qty'=>$c->bal_qty,
':customer'=>$c->customer,
':discharge_datetime'=>$c->discharge_datetime,
':email'=>$c->email,

':temp_code'=>$temp_code,
':es_qty'=>$c->es_qty
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement = $db->prepare("SELECT id from mt_bulkcargo_discharge where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



public static function delete_bulk_cargo($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_bulkcargo_discharge 
	where id=:id");
$statement->execute(array(
':id'=>$c
));
if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


}
?>