<?php


require("../config/dbconn.php");

class FinanceDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));
$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}



public static function get_jv_info($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("SELECT id,jvh_company,jvh_doc_number,jvh_base_doc,jvh_doc_type,jvh_date,jvh_gl_date,jvh_batch,jvh_narration,jvh_remarks,jvh_currency,jvh_ex_rate,jvh_foreign_amount,jvh_local_amount,jvh_auto_reversal,jvh_other_reference,jvh_status,jvh_notes,jvh_cancellation_remarks,child,temp_code from mt_jv_header where id=:id");

$statement->execute(array(':id'=>$code));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_jv_list($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("SELECT id,jvh_company,jvh_doc_number,jvh_base_doc,jvh_doc_type,jvh_date,jvh_gl_date,jvh_batch,jvh_narration,jvh_remarks,jvh_currency,jvh_ex_rate,jvh_foreign_amount,jvh_local_amount,jvh_auto_reversal,jvh_other_reference,jvh_status,jvh_notes,jvh_cancellation_remarks,created_by,created_date from mt_jv_header order by id desc limit :sta,50");
$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_jv_list($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("SELECT id,jvh_company,jvh_doc_number,jvh_base_doc,jvh_doc_type,jvh_date,jvh_gl_date,jvh_batch,jvh_narration,jvh_remarks,jvh_currency,jvh_ex_rate,jvh_foreign_amount,jvh_local_amount,jvh_auto_reversal,jvh_other_reference,jvh_status,jvh_notes,jvh_cancellation_remarks,created_by,created_date from mt_jv_header where jvh_doc_number like ? order by id desc limit 50");
$i=1;
$statement ->bindValue($i++, "%$code%", PDO::PARAM_STR);
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function setFourDigit($v)
{
  $len=strlen($v);

if($len==1)
{
  $v="000".$v;
}else if($len==2)
{
  $v="00".$v;
}else if($len==3)
{
  $v="0".$v;
}

return $v;
}

public static function getFinancialYear()
{
//$year = ( date('m') > 4) ? date('Y') + 1 : date('Y');
$year=date('Y');
return $year;
}

public static function getFinancialPeriod($doc_date)
{

//$year = ( date('m') > 4) ? date('Y') + 1 : date('Y');
//$period=4;
//return $period;
$data=false;
try
{
$db = Factory::getConnection();

//$aq=self::getRestrictionQuery($dev);
//$doc_date="2019-12-15";
$date=date_create($doc_date);
$m= date_format($date,"F");
$y= date_format($date,"Y");

$statement = $db->prepare("SELECT enumber from mt_period 
  where period=:period and year=:year and open_max='OPEN'");

$statement->execute(array(':period'=>$m,':year'=>$y));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
//var_dump($statement->debugDumpParams());
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  $p=-10;
  if(count($data)==1)
  {
    $p=$data[0]["enumber"];
  }
  return $p;
}

public static function save_jv($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();
$cds=$code->cds;
$c=$code->info;

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_jv_header(jvh_company,jvh_base_doc,jvh_doc_type,jvh_date,jvh_gl_date,jvh_batch,jvh_narration,jvh_remarks,jvh_currency,jvh_ex_rate,jvh_foreign_amount,jvh_local_amount,jvh_other_reference,jvh_status,jvh_notes,ip,created_by,ua,ekey,created_date,temp_code,child,company_id,location_id) 
values(:jvh_company,:jvh_base_doc,:jvh_doc_type,:jvh_date,:jvh_gl_date,:jvh_batch,:jvh_narration,:jvh_remarks,:jvh_currency,:jvh_ex_rate,:jvh_foreign_amount,:jvh_local_amount,:jvh_other_reference,:jvh_status,:jvh_notes,
:ip,:created_by,:ua,:ekey,now(),:temp_code,:child,:company_id,:location_id)");

$statement->execute(array(':ip'=>$dev->ip,
  ':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
//
':jvh_company'=>$dev->company,
':jvh_base_doc'=>$c->jvh_doc_type,
':jvh_doc_type'=>$c->jvh_doc_type,
':jvh_date'=>$c->jvh_date,
':jvh_gl_date'=>$c->jvh_gl_date,
':jvh_batch'=>'',
':jvh_narration'=>$c->jvh_narration,
':jvh_remarks'=>'',
':jvh_currency'=>$c->jvh_currency,
':jvh_ex_rate'=>$c->jvh_ex_rate,
':jvh_foreign_amount'=>$c->jvh_foreign_amount,
':jvh_local_amount'=>$c->jvh_local_amount,
':jvh_other_reference'=>$c->jvh_other_reference,
':jvh_status'=>'POSTED',
':jvh_notes'=>$c->jvh_notes,
//
':temp_code'=>$temp_code,
':child'=>json_encode($cds),
':company_id'=>$dev->company,
':location_id'=>$dev->location
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved.";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to save.";
}

$statement = $db->prepare("SELECT id from mt_jv_header where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$data["temp_code"]=$temp_code;

$four_id=self::setFourDigit($data["id"][0]["id"]);
$fid1=$data["id"][0]["id"];

$prefix="";
if($c->jvh_doc_type=="JV")
{
$prefix="JV";
}

$doc_no=$prefix."/".date("Y")."/".date('m')."/".$four_id;

$statement = $db->prepare("UPDATE mt_jv_header  
  SET jvh_doc_number=:ond where id=:id");
  $statement->execute(array(':id'=>$fid1,':ond'=>$doc_no));
  
    if ($statement->rowCount()){
    $data["jid_status"]=1;
  } else{
    $data["jid_status"]=0;
  }

$data["doc_no"]=$doc_no;

//query 2 child entry
$len=count($cds);
$cord=$cds[0]->cord;
for($i=0;$i<$len;$i++)
{
$cord1=$cds[$i]->cord;

$cd=$cds[$i];
$r=$cd;
$q='';
$qv='';
if($r->allocation=="ACCOUNTS RECEIVABLE")
{
  $gls=self::get_gl_link($dev,'RECEIVABLE');
  $gl_code=$gls[0]["gl_account"];
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$gl_code','$ai->customer_name','$ai->customer_address'";
}
else if($r->allocation=="ACCOUNTS PAYABLE")
{
  $gls=self::get_gl_link($dev,'PAYABLE');
  $gl_code=$gls[0]["gl_account"];
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$gl_code','$ai->customer_name','$ai->customer_address'";
}
else if($r->allocation=="BANK")
{
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->bank_name','$ai->cheque_no','$ai->cheque_date'";
}
else if($r->allocation=="INCOME")
{
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->income', '$ai->gl_group_name','$r->cost_center'";
}
else if($r->allocation=="ASSETS")
{
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->assets', '$ai->gl_group_name', '$r->cost_center'";
}
else if($r->allocation=="LIABILITY")
{
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->liability','$ai->gl_group_name','$r->cost_center'";
}
else if($r->allocation=="BANK TO BANK")
{
  $ai=$r->add_info;
  $q="aloc_detail_1";
  $qv="'$ai->bank_name'";
}
else if($r->allocation=="PETTY CASH")
{
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2";
  $qv="'$ai->petty_cash','$r->cost_center'";
}
else if($r->allocation=="EXPENSES")
{
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->expense','$ai->gl_group_name','$r->cost_center'";
}
else if($r->allocation=="SHIP")
{
  $ai=$r->add_info;
  
    $q="aloc_detail_1,aloc_detail_2,aloc_detail_3,aloc_detail_4,aloc_detail_5,aloc_detail_6";

  $qv="'$ai->voyage','$ai->vessel','$ai->liner',
  '$ai->bl_no','$ai->activity',(
  IFNULL((SELECT income_gl from mt_charge_group_detail 
  where code='$ai->activity'),(SELECT gl_payable_pdc from mt_gl_link where name= (select liner from mt_voyage where voyage='$ai->voyage')))
  )";
}else if($r->allocation=="ORDER")
{
  $ai=$r->add_info;
  
     $q="aloc_detail_1,aloc_detail_2,aloc_detail_3,aloc_detail_4";

  $qv="'$ai->order_type','$ai->order_no','$ai->activity',(SELECT order_income_gl from mt_charge_group_detail 
  where code='$ai->activity')";
}

$famt=0;
$lamt=0;
if($cord=="CREDIT" & $i==0)
{
  $famt=$cd->base_amt_cr;
  $lamt=$cd->local_amt_cr;
}else if($cord=="CREDIT")
{
  $famt=$cd->base_amt_dr;
  $lamt=$cd->local_amt_dr;
}
else if($cord=="DEBIT" & $i==0)
{
  $famt=$cd->base_amt_dr;
  $lamt=$cd->local_amt_dr;
}else if($cord=="DEBIT")
{
  $famt=$cd->base_amt_cr;
  $lamt=$cd->local_amt_cr;
}

if($cord1=="CREDIT")
{
$famt=-$famt;
$lamt=-$lamt;
}

$statement = $db->prepare("INSERT into mt_jv_allocation_details 
(aloc_serial_number,aloc_detail_7,aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,
  aloc_foreign_amount,aloc_local_amount,
  aloc_narration,aloc_currency,aloc_ex_rate,
  reference,ref_date,
ip,created_by ,ua,ekey,created_date,company_id,location_id,$q)
VALUES
(:header,:aloc_detail_7,:company,:voucher_type,
  :doc_type,:doc_no,:allocation,
  :base_amt_cr,:local_amt_cr,
  :narration,:currency,:ex_rate,
:reference,:ref_date,
  :ip ,:created_by ,:ua ,:ekey,now(),:company_id,:location_id,$qv)");
  $statement->execute(array(
    ':ip'=>$dev->ip,
  ':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
//
    ':company'=>$dev->company,
    ':voucher_type'=>$c->jvh_doc_type,
    ':doc_type'=>$c->jvh_doc_type,
    ':doc_no'=>$doc_no,
    ':allocation'=>$cd->allocation,
    ':base_amt_cr'=>$famt,
    ':local_amt_cr'=>$lamt,
    ':narration'=>$cd->narration,
    ':currency'=>$cd->currency,
    ':ex_rate'=>$cd->ex_rate,
    ':reference'=>$cd->ref,
    ':ref_date'=>$cd->ref_date,
    ':company_id'=>$dev->company,
':location_id'=>$dev->location,
':header'=>$cd->header,
':aloc_detail_7'=>$cd->cord
  ));
  
    if ($statement->rowCount()){
    $data["ch_status".($i+1)]=1;
  } else{
    $data["ch_status".($i+1)]=0;
  }

 



}
//end of loop
//insert if accounts receivable
$statement = $db->prepare("INSERT into mt_ar_trans 
(art_company,art_code,art_type,art_number,art_serial,art_group,
art_base_type,art_internal,art_other_reference,art_doc_date,
art_gl_date,art_year,art_period,art_age_date,
art_dp_date,art_currency,art_ex_rate,art_foreign_amount,
art_local_amount,art_foreign_balance,
art_local_balance,art_balance_status,
art_description,art_notes,
ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id)
SELECT aloc_company,aloc_detail_2,aloc_doc_type,aloc_doc_number,
1,aloc_detail_1,aloc_base_doc,0,
aloc_detail_5,
'$c->jvh_date','$c->jvh_date',".self::getFinancialYear().",".self::getFinancialPeriod($c->jvh_date).",
'$c->jvh_date','$c->jvh_date',aloc_currency,aloc_ex_rate,
aloc_foreign_amount,aloc_local_amount,aloc_foreign_amount,
aloc_local_amount,'A',
aloc_narration,aloc_detail_3,
ip,created_by,ua ,ekey,now(),temp_code,
company_id,location_id  
FROM mt_jv_allocation_details where aloc_doc_number=:doc_no and aloc_allocation_type='ACCOUNTS RECEIVABLE'");
$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
    $data["ar_status"]=1;
  } else{
    $data["ar_status"]=0;
  }

//insert if accounts payable

$statement = $db->prepare("INSERT into mt_ap_trans 
(apt_company,apt_code,apt_type,apt_number,apt_serial,apt_group,
apt_base_type,apt_internal,apt_other_reference,apt_doc_date,
apt_gl_date,apt_year,apt_period,apt_age_date,
apt_dp_date,apt_currency,apt_ex_rate,apt_foreign_amount,
apt_local_amount,apt_foreign_balance,
apt_local_balance,apt_balance_status,
apt_description,apt_notes,
ip,created_by ,ua,ekey,created_date,temp_code,
company_id,location_id)
SELECT aloc_company,aloc_detail_2,aloc_doc_type,aloc_doc_number,
1,aloc_detail_1,aloc_base_doc,0,
aloc_detail_5,
'$c->jvh_date','$c->jvh_date',".self::getFinancialYear().",
".self::getFinancialPeriod($c->jvh_date).",
'$c->jvh_date','$c->jvh_date',aloc_currency,aloc_ex_rate,
aloc_foreign_amount,aloc_local_amount,aloc_foreign_amount,
aloc_local_amount,'A',
aloc_narration,aloc_detail_3,
ip,created_by,ua ,ekey,now(),temp_code,
company_id,location_id   
FROM mt_jv_allocation_details where aloc_doc_number=:doc_no and aloc_allocation_type='ACCOUNTS PAYABLE'");
$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
    $data["ap_status"]=1;
  } else{
    $data["ap_status"]=0;
  }



//query 3 gl entry

$statement = $db->prepare("INSERT INTO mt_jv_gl_details
(pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_doc_date,
  pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,
  pre_glt_ex_rate,pre_glt_foreign_amount,
  pre_glt_local_amount,pre_glt_narration,
ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id,
aloc_detail_1,aloc_detail_2,aloc_detail_3,aloc_detail_4,aloc_detail_5,aloc_detail_6,pre_glt_serial_number,aloc_detail_7)
SELECT aloc_company,expense_gl,
aloc_base_doc,aloc_doc_type,
aloc_doc_number,'$c->jvh_date',
'$c->jvh_date',".self::getFinancialYear().",".
self::getFinancialPeriod($c->jvh_date).",aloc_narration,aloc_currency,
aloc_ex_rate,aloc_foreign_amount,
aloc_local_amount,aloc_narration,
ip,created_by,ua ,ekey,now(),'$temp_code',company_id,location_id,
aloc_detail_1,aloc_detail_2,aloc_detail_3,aloc_detail_4,aloc_detail_5,aloc_detail_6,aloc_serial_number,aloc_detail_7   
FROM mt_jv_allocation_details where aloc_doc_number=:doc_no");
  $statement->execute(array(':doc_no'=>$doc_no));
  
    if ($statement->rowCount()){
    $data["gl_status"]=1;
  } else{
    $data["gl_status"]=0;
  }

//query 4
//insert ar trans balance
$statement = $db->prepare("INSERT into mt_ar_trans_balance
(ardm_company,ardm_code,ardm_doc_type,ardm_doc_number,
  ardm_serial,ardm_other_reference,ardm_date,ardm_currency,
  ardm_ex_rate,ardm_of_amount,ardm_ol_amount,ardm_bf_amount,
  ardm_bl_amount,ardm_pf_amount,ardm_pl_amount,ardm_status,
ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id)
SELECT art_company,art_code,art_type,art_number,
art_serial,art_other_reference,art_gl_date,art_currency,
art_ex_rate,art_foreign_amount,art_local_amount,
art_foreign_balance,art_local_balance,
0,0,'PENDING',ip,created_by,ua,ekey,now(),temp_code,
company_id,location_id  
 from mt_ar_trans where art_number=:doc_no");
  $statement->execute(array(':doc_no'=>$doc_no));
  
    if ($statement->rowCount()){
    $data["ar_trans_balance_status"]=1;
  } else{
    $data["ar_trans_balance_status"]=0;
  }
//query 5
// ap trans balance
$statement = $db->prepare("INSERT into mt_ap_trans_balance
(apdm_company,apdm_code,apdm_doc_type,apdm_doc_number,
  apdm_serial,apdm_other_reference,apdm_date,apdm_currency,
  apdm_ex_rate,apdm_of_amount,apdm_ol_amount,apdm_bf_amount,
  apdm_bl_amount,apdm_pf_amount,apdm_pl_amount,apdm_status,
ip,created_by ,ua,ekey,created_date,temp_code,
company_id,location_id)
SELECT apt_company,apt_code,apt_type,apt_number,
apt_serial,apt_other_reference,apt_gl_date,apt_currency,
apt_ex_rate,apt_foreign_amount,apt_local_amount,
apt_foreign_balance,apt_local_balance,
0,0,'PENDING',ip,created_by,ua,ekey,now(),temp_code,
company_id,location_id  
 from mt_ap_trans where apt_number=:doc_no");
  $statement->execute(array(':doc_no'=>$doc_no));
  
    if ($statement->rowCount()){
    $data["ap_trans_balance_status"]=1;
  } else{
    $data["ap_trans_balance_status"]=0;
  }


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

//

public static function get_gl_link($dev,$c)
{
$data=array();
try
{

$db = Factory::getConnection();

$statement = $db->prepare("SELECT gl_account from mt_gl_link where name=:name limit 1");

$statement->execute(array(':name'=>$c));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
}
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}







}
?>