<?php


require("../config/dbconn.php");
require('../booking/get-currency.php');

class LinerAccountingDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_pro_charges_list_sea($dev,$code) 
{
$data=array();
try
{
$db = Factory::getConnection();

//get order no list
$statement = $db->prepare("SELECT order_no from mt_order_ar_header  
where sub_ar_doc_number=:doc_no");
$statement->execute(array(':doc_no'=>$code->doc_no));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$order_nos=$data["info"][0]["order_no"];
$order_no_list='';
$sv=explode(',',$order_nos);
for ($i = 0; $i < count($sv); $i++) 
{
if(strlen($sv[$i])!=0)
{
$order_no_list=$order_no_list."'".$sv[$i]."',";
}
}
$order_no_list=substr_replace($order_no_list,"", -1);


$statement = $db->prepare("SELECT id,billing_party,order_id,charge_desc,
  basis_type, basis_uom, currency,qty,
rate_selling selling_amount,selling_amount famt,ex_rate,selling_base_amount net_amt,'' taxable,'' total_tax_amt,selling_base_amount total_amt,remarks,
invoiced,CASE WHEN invoiced=2 then 'PROFORMA'
  WHEN invoiced=1 then 'INVOICED' ELSE '' END inv_status from mt_order_cost  
where billing_party=:party and order_id in (SELECT id from mt_order_entry 
where order_no in($order_no_list) )");
$statement->execute(array(':party'=>$code->customer));
$data["charges"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_pro_charges_list($dev,$code) 
{
$data=array();
try
{
$db = Factory::getConnection();

//get order no list
$statement = $db->prepare("SELECT order_no from mt_ship_ar_header  
where sub_ar_doc_number=:doc_no");
$statement->execute(array(':doc_no'=>$code->doc_no));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$order_nos=$data["info"][0]["order_no"];
$order_no_list='';
$sv=explode(',',$order_nos);
for ($i = 0; $i < count($sv); $i++) 
{
if(strlen($sv[$i])!=0)
{
$order_no_list=$order_no_list."'".$sv[$i]."',";
}
}
$order_no_list=substr_replace($order_no_list,"", -1);


$statement = $db->prepare("SELECT id,billing_party,order_id,charge_desc,
  basis_type, basis_uom, currency,qty,
rate_selling selling_amount,selling_amount famt,ex_rate,selling_base_amount net_amt,'' taxable,'' total_tax_amt,selling_base_amount total_amt,remarks,
invoiced,CASE WHEN invoiced=2 then 'PROFORMA'
  WHEN invoiced=1 then 'INVOICED' ELSE '' END inv_status from mt_order_cost  
where billing_party=:party and order_id in (SELECT id from mt_order_entry 
where order_no in($order_no_list) )");
$statement->execute(array(':party'=>$code->customer));
$data["charges"]=$statement->fetchAll(PDO::FETCH_ASSOC);

/*

SELECT id,charge_desc,basis_type,basis_uom,currency,
  qty,rate_selling rate,selling_amount,ex_rate,selling_amount net_amt,selling_amount total_amt,invoiced,CASE WHEN invoiced=2 then 'PROFORMA'
  WHEN invoiced=1 then 'INVOICED' ELSE '' END inv_status from mt_order_cost  
where inv_pay_no=:doc_no or proforma=:doc_no

*/
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_matched_list($dev,$code) 
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT arm_t_amount amt,arm_t_balance balance,arm_m_number doc_no,arm_m_amount tamt
from mt_ar_match_details 
where arm_t_number=:doc_no and arm_status!='CANCELLED'

UNION 

SELECT arm_t_amount amt,arm_t_balance balance,arm_m_number doc_no,arm_m_amount tamt
from mt_arap_match_details 
where (arm_t_number=:doc_no or arm_m_number=:doc_no) and arm_status!='CANCELLED'

");
$statement->execute(array(':doc_no'=>$code->doc_no));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function edit_invoice_entry_pro($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$info=$c->info;
$cds=$c->cds;
//q1
//take a row
$statement = $db->prepare("SELECT * FROM `mt_ship_ar_details` 
  WHERE `sub_ard_doc_number`=:doc_no");
$statement->execute(array(':doc_no'=>$info->doc_no));
$old_datas=$statement->fetchAll(PDO::FETCH_ASSOC);
$olds=(object)$old_datas[0];
//q2
//Delete all and insert
$statement = $db->prepare("DELETE FROM `mt_ship_ar_details` 
  WHERE `sub_ard_doc_number`=:doc_no");
$statement->execute(array(':doc_no'=>$info->doc_no));

if ($statement->rowCount()){
  $data["deleted"]=1;
} else{
  $data["deleted"]=0;
}


//q2.1
//update all order cost to null
$statement = $db->prepare("UPDATE mt_order_cost SET invoiced=null,
  proforma=null where proforma=:doc_no");
$statement->execute(array(':doc_no'=>$info->doc_no));

if ($statement->rowCount()){
  $data["cost_updated"]=1;
} else{
  $data["cost_updated"]=0;
}

//q3
//insert in details
$q="INSERT into mt_ship_ar_details(
      sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,sub_ard_currency,sub_ard_ex_rate,sub_ard_foreign_amount,sub_ard_local_amount,sub_ard_narration,sub_ard_notes,sub_ard_detail_1,sub_ard_detail_2,sub_ard_detail_3,sub_ard_detail_4,sub_ard_detail_5,sub_ard_detail_6,sub_ard_basis,sub_ard_rate,sub_ard_quantity,ip,created_by ,ua,ekey,created_date,charge_desc,basis_type,taxable,total_tax_amt,total_amt,inv_status,sub_ard_detail_7,sub_ard_detail_8,sub_ard_detail_9,sub_ard_detail_10) 
      VALUES(:sub_ard_company,'PRO',:sub_ard_doc_number,:sub_ard_serial,:sub_ard_currency,:sub_ard_ex_rate,:sub_ard_foreign_amount,:sub_ard_local_amount,:sub_ard_narration,:sub_ard_notes,:sub_ard_detail_1,:sub_ard_detail_2,:sub_ard_detail_3,:sub_ard_detail_4,:sub_ard_detail_5,:sub_ard_detail_6,:sub_ard_basis,:sub_ard_rate,:sub_ard_quantity,:ip ,:created_by ,
:ua ,:ekey,now(),:charge_desc,:basis_type,:taxable,:total_tax_amt,:total_amt,:inv_status,:sub_ard_detail_7,:sub_ard_detail_8,:sub_ard_detail_9,:sub_ard_detail_10)";
for($i=0;$i<count($cds);$i++)
  {
    $cd=$cds[$i];
    $statement = $db->prepare($q);
    $statement->execute(array(
      ':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
      ':sub_ard_company'=>$dev->company,
      ':sub_ard_doc_number'=>$info->doc_no,
      ':sub_ard_serial'=>($i+1),
      ':sub_ard_currency'=>$cd->currency,

      ':sub_ard_ex_rate'=>$cd->ex_rate,
      ':sub_ard_foreign_amount'=>$cd->famt,
      ':sub_ard_local_amount'=>$cd->net_amt,
      ':sub_ard_narration'=>$cd->remarks,
      ':sub_ard_notes'=>$info->notes,
      ':sub_ard_detail_1'=>$olds->sub_ard_detail_1,


      ':sub_ard_detail_2'=>$olds->sub_ard_detail_2,
      ':sub_ard_detail_3'=>$olds->sub_ard_detail_3,
      ':sub_ard_detail_4'=>$olds->sub_ard_detail_4,
      ':sub_ard_detail_5'=>$olds->sub_ard_detail_5,
      ':sub_ard_detail_6'=>$olds->sub_ard_detail_6,

      ':sub_ard_basis'=>$cd->basis_uom,
      ':sub_ard_rate'=>$cd->selling_amount,
      ':sub_ard_quantity'=>$cd->qty,
      ':charge_desc'=>$cd->charge_desc,
      ':basis_type'=>$cd->basis_type,
      ':taxable'=>$cd->taxable,

      ':total_tax_amt'=>$cd->total_tax_amt,
      ':total_amt'=>$cd->total_amt,
      ':inv_status'=>'PROFORMA',
      ':sub_ard_detail_7'=>$olds->sub_ard_detail_7,
      ':sub_ard_detail_8'=>$olds->sub_ard_detail_8,
      ':sub_ard_detail_9'=>$olds->sub_ard_detail_9,
      ':sub_ard_detail_10'=>$olds->sub_ard_detail_10

    ));

if ($statement->rowCount()){
  $data["dls".($i+1)]=1;
} else{
  $data["dls".($i+1)]=0;
}

    //update order cost
    $statement = $db->prepare("UPDATE mt_order_cost SET invoiced=2,
  proforma=:doc_no where id=:id");
$statement->execute(array(':id'=>$cd->id,':doc_no'=>$info->doc_no));

if ($statement->rowCount()){
  $data["cost".($i+1)]=1;
} else{
  $data["cost".($i+1)]=0;
}

  }
//loop ends
//q4
//update total amt
$statement = $db->prepare("UPDATE mt_ship_ar_header 
  SET total_local_amt=:amt,sub_ar_f_amount=:amt,sub_ar_l_amount=:amt,
  modified_date=now(),modified_by=:uid WHERE `sub_ar_doc_number`=:doc_no");
$statement->execute(array(':doc_no'=>$info->doc_no,':amt'=>$c->total,':uid'=>$dev->username));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Updated";

} else{
  $data["status"]=0;
  $data["msg"]="Unable to update. Please try again.";

}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_do($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

//q1
$statement = $db->prepare("UPDATE mt_delivery_order SET 
 do_party=(SELECT name FROM `mt_business_partner` WHERE code=:code),
 consignee=:code
 where id=:id
  ");

$statement->execute(array(
  ':id'=>$c->id,
  ':code'=>$c->code
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Updated";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to update. Please try again.";
}

//q2

$statement = $db->prepare("UPDATE ship_gl_details SET 
 pre_glt_detail_5=:code
 where pre_glt_doc_number=:do_no
  ");

$statement->execute(array(
  ':do_no'=>$c->do_no,
  ':code'=>$c->code
));

if ($statement->rowCount()){
  $data["status1"]=1;
   
} else{
  $data["status1"]=0;
}

//q3

$statement = $db->prepare("UPDATE mt_ship_receipt_details SET 
 sub_rctd_detail_5=:code
 where sub_rctd_doc_number=:do_no
  ");

$statement->execute(array(
  ':do_no'=>$c->do_no,
  ':code'=>$c->code
));

if ($statement->rowCount()){
  $data["status2"]=1;
   
} else{
  $data["status2"]=0;
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


//

public static function update_invoice($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

//q1
$statement = $db->prepare("UPDATE mt_ship_ar_header 
  SET sub_ar_code=:code where id=:id");

$statement->execute(array(
  ':id'=>$c->id,
  ':code'=>$c->code
));

if ($statement->rowCount()){
  $data["status"]=1;
   $data["msg"]="Updated";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to update. Please try again.";
}

//q2

$statement = $db->prepare("UPDATE mt_ar_trans SET 
 art_code=:code
 where art_number=:do_no");

$statement->execute(array(
  ':do_no'=>$c->doc_no,
  ':code'=>$c->code
));

if ($statement->rowCount()){
  $data["status1"]=1;
   
} else{
  $data["status1"]=0;
}

//q3

$statement = $db->prepare("UPDATE mt_ar_trans_balance SET 
 ardm_code=:code
 where ardm_doc_number=:do_no");

$statement->execute(array(
  ':do_no'=>$c->doc_no,
  ':code'=>$c->code
));

if ($statement->rowCount()){
  $data["status2"]=1;
   
} else{
  $data["status2"]=0;
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

//






}
?>