<?php


require("../config/dbconn.php");
require("func-list.php");

class OrderDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}
//2
public static function save_order_container($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_order_container(serial,unit_type,booked_qty,basis_ops,basis_substitue,contract_type,released_qty,confirmed_qty,empty_release_office,empty_returned,with_shipper,cancelled,order_id,created_by,created_date,ip,ua,ekey,temp_code) 
values(:serial,:unit_type,:booked_qty,:basis_ops,:basis_substitue,:contract_type,:released_qty,:confirmed_qty,:empty_release_office,:empty_returned,:with_shipper,:cancelled,
:order_id,:created_by,now(),:ip,:ua,:ekey,
:temp_code)");

if($c->released_qty=="")
{
  $c->released_qty=null;
}

if($c->confirmed_qty=="")
{
  $c->confirmed_qty=null;
}

if($c->with_shipper=="")
{
  $c->with_shipper=null;
}

if($c->cancelled=="")
{
  $c->cancelled=null;
}

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':serial'=>$c->serial,
':unit_type'=>$c->unit_type,
':booked_qty'=>$c->booked_qty,
':basis_ops'=>$c->basis_ops,
':basis_substitue'=>$c->basis_substitue,
':contract_type'=>$c->contract_type,
':released_qty'=>$c->released_qty,
':confirmed_qty'=>$c->confirmed_qty,
':empty_release_office'=>$c->empty_release_office,
':empty_returned'=>$c->empty_returned,
':with_shipper'=>$c->with_shipper,
':cancelled'=>$c->cancelled,

':order_id'=>$c->order_id,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_order_container where created_by=:uid and temp_code=:temp_code and order_id=:order_id");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid,':order_id'=>$c->order_id));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



public static function update_order_container($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("UPDATE mt_order_container SET serial=:serial,
unit_type=:unit_type,
booked_qty=:booked_qty,
basis_ops=:basis_ops,
basis_substitue=:basis_substitue,
contract_type=:contract_type,
released_qty=:released_qty,
confirmed_qty=:confirmed_qty,
empty_release_office=:empty_release_office,
empty_returned=:empty_returned,
with_shipper=:with_shipper,
cancelled=:cancelled,
ip=:ip,created_by=:created_by,ua=:ua,ekey=:ekey,created_date=now() where id=:id and order_id=:order_id");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':serial'=>$c->serial,
':unit_type'=>$c->unit_type,
':booked_qty'=>$c->booked_qty,
':basis_ops'=>$c->basis_ops,
':basis_substitue'=>$c->basis_substitue,
':contract_type'=>$c->contract_type,
':released_qty'=>$c->released_qty,
':confirmed_qty'=>$c->confirmed_qty,
':empty_release_office'=>$c->empty_release_office,
':empty_returned'=>$c->empty_returned,
':with_shipper'=>$c->with_shipper,
':cancelled'=>$c->cancelled,

':order_id'=>$c->order_id,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function delete_order_container($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_order_container where id=:id");

$statement->execute(array(
':id'=>$c
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

//3
public static function save_order_container_detail($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_order_container_detail(container_no,type,package_type,no_of_pkgs,volume,gr_wgt,nt_wgt,tt_wgt,commodity,cargo_desc,reefer,min_temp,max_temp,oog,oh,ow,ol,haz,un_no,flash_type,
  order_id,created_by,created_date,ip,ua,ekey,temp_code) 
values(:container_no,:type,:package_type,:no_of_pkgs,:volume,:gr_wgt,:nt_wgt,:tt_wgt,:commodity,:cargo_desc,:reefer,:min_temp,:max_temp,:oog,:oh,:ow,:ol,:haz,:un_no,:flash_type,
:order_id,:created_by,now(),:ip,:ua,:ekey,
:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':container_no'=>$c->container_no,
':type'=>$c->type,
':package_type'=>$c->package_type,
':no_of_pkgs'=>$c->no_of_pkgs,
':volume'=>$c->volume,
':gr_wgt'=>$c->gr_wgt,
':nt_wgt'=>$c->nt_wgt,
':tt_wgt'=>$c->tt_wgt,
':commodity'=>$c->commodity,
':cargo_desc'=>$c->cargo_desc,
':reefer'=>$c->reefer,
':min_temp'=>$c->min_temp,
':max_temp'=>$c->max_temp,
':oog'=>$c->oog,
':oh'=>$c->oh,
':ow'=>$c->ow,
':ol'=>$c->ol,
':haz'=>$c->haz,
':un_no'=>$c->un_no,
':flash_type'=>$c->flash_type,

':order_id'=>$c->order_id,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_order_container_detail where created_by=:uid and temp_code=:temp_code and order_id=:order_id");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid,':order_id'=>$c->order_id));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



public static function update_order_container_detail($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("UPDATE mt_order_container_detail SET container_no=:container_no,type=:type,package_type=:package_type,no_of_pkgs=:no_of_pkgs,volume=:volume,gr_wgt=:gr_wgt,nt_wgt=:nt_wgt,tt_wgt=:tt_wgt,commodity=:commodity,cargo_desc=:cargo_desc,reefer=:reefer,min_temp=:min_temp,max_temp=:max_temp,oog=:oog,oh=:oh,ow=:ow,ol=:ol,haz=:haz,un_no=:un_no,flash_type=:flash_type,ip=:ip,created_by=:created_by,ua=:ua,ekey=:ekey,created_date= now() where id=:id and order_id=:order_id");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':container_no'=>$c->container_no,
':type'=>$c->type,
':package_type'=>$c->package_type,
':no_of_pkgs'=>$c->no_of_pkgs,
':volume'=>$c->volume,
':gr_wgt'=>$c->gr_wgt,
':nt_wgt'=>$c->nt_wgt,
':tt_wgt'=>$c->tt_wgt,
':commodity'=>$c->commodity,
':cargo_desc'=>$c->cargo_desc,
':reefer'=>$c->reefer,
':min_temp'=>$c->min_temp,
':max_temp'=>$c->max_temp,
':oog'=>$c->oog,
':oh'=>$c->oh,
':ow'=>$c->ow,
':ol'=>$c->ol,
':haz'=>$c->haz,
':un_no'=>$c->un_no,
':flash_type'=>$c->flash_type,

':order_id'=>$c->order_id,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function delete_order_container_detail($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_order_container_detail where id=:id");

$statement->execute(array(
':id'=>$c
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

//4

public static function save_order_landing_craft($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_order_landingcraft_detail(cargo_type,vehicle_type,vin_no,chassis_no,package_type,no_of_pkgs,volume,gr_wgt,nt_wgt,tt_wgt,commodity,cargo_desc,reefer,min_temp,max_temp,oog,oh,ow,ol,haz,un_no,flash_type,order_id,created_by,created_date,ip,ua,ekey,temp_code) 
values(:cargo_type,:vehicle_type,:vin_no,:chassis_no,:package_type,:no_of_pkgs,:volume,:gr_wgt,:nt_wgt,:tt_wgt,:commodity,:cargo_desc,:reefer,:min_temp,:max_temp,:oog,:oh,:ow,:ol,:haz,:un_no,:flash_type,
:order_id,:created_by,now(),:ip,:ua,:ekey,
:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':cargo_type'=>$c->cargo_type,
':vehicle_type'=>$c->vehicle_type,
':vin_no'=>$c->vin_no,
':chassis_no'=>$c->chassis_no,
':package_type'=>$c->package_type,
':no_of_pkgs'=>$c->no_of_pkgs,
':volume'=>$c->volume,
':gr_wgt'=>$c->gr_wgt,
':nt_wgt'=>$c->nt_wgt,
':tt_wgt'=>$c->tt_wgt,
':commodity'=>$c->commodity,
':cargo_desc'=>$c->cargo_desc,
':reefer'=>$c->reefer,
':min_temp'=>$c->min_temp,
':max_temp'=>$c->max_temp,
':oog'=>$c->oog,
':oh'=>$c->oh,
':ow'=>$c->ow,
':ol'=>$c->ol,
':haz'=>$c->haz,
':un_no'=>$c->un_no,
':flash_type'=>$c->flash_type,

':order_id'=>$c->order_id,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_order_landingcraft_detail where created_by=:uid and temp_code=:temp_code and order_id=:order_id");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid,':order_id'=>$c->order_id));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



public static function update_order_landing_craft($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("UPDATE mt_order_landingcraft_detail SET 
  cargo_type=:cargo_type,
vehicle_type=:vehicle_type,
vin_no=:vin_no,
chassis_no=:chassis_no,
package_type=:package_type,
no_of_pkgs=:no_of_pkgs,
volume=:volume,
gr_wgt=:gr_wgt,
nt_wgt=:nt_wgt,
tt_wgt=:tt_wgt,
commodity=:commodity,
cargo_desc=:cargo_desc,
reefer=:reefer,
min_temp=:min_temp,
max_temp=:max_temp,
oog=:oog,
oh=:oh,
ow=:ow,
ol=:ol,
haz=:haz,
un_no=:un_no,
flash_type=:flash_type,
  ,ip=:ip,created_by=:created_by,ua=:ua,ekey=:ekey,created_date= now() where id=:id and order_id=:order_id");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':cargo_type'=>$c->cargo_type,
':vehicle_type'=>$c->vehicle_type,
':vin_no'=>$c->vin_no,
':chassis_no'=>$c->chassis_no,
':package_type'=>$c->package_type,
':no_of_pkgs'=>$c->no_of_pkgs,
':volume'=>$c->volume,
':gr_wgt'=>$c->gr_wgt,
':nt_wgt'=>$c->nt_wgt,
':tt_wgt'=>$c->tt_wgt,
':commodity'=>$c->commodity,
':cargo_desc'=>$c->cargo_desc,
':reefer'=>$c->reefer,
':min_temp'=>$c->min_temp,
':max_temp'=>$c->max_temp,
':oog'=>$c->oog,
':oh'=>$c->oh,
':ow'=>$c->ow,
':ol'=>$c->ol,
':haz'=>$c->haz,
':un_no'=>$c->un_no,
':flash_type'=>$c->flash_type,


':order_id'=>$c->order_id,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function delete_order_landing_craft($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_order_landingcraft_detail where id=:id");

$statement->execute(array(
':id'=>$c
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


//5
public static function save_order_services($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_order_services(vendor,vendor_status,service_order_no,order_id,created_by,created_date,ip,ua,ekey,temp_code) 
values(:vendor,
:vendor_status,
:service_order_no,
:order_id,:created_by,now(),:ip,:ua,:ekey,
:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':vendor'=>$c->vendor,
':vendor_status'=>$c->vendor_status,
':service_order_no'=>$c->service_order_no,

':order_id'=>$c->order_id,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_order_services where created_by=:uid and temp_code=:temp_code and order_id=:order_id");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid,':order_id'=>$c->order_id));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function save_order_cargo_info($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_order_cargo( unit_type,booked_qty,
  main_commodity,equipment_serial,package_type,no_of_packages,gross_weight,weight_uom,volume,volume_uom,dangerous,reefer,oversize,order_id,created_by,created_date,ip,ua,ekey,temp_code) 
values(:unit_type,:booked_qty,:main_commodity,:equipment_serial,:package_type,:no_of_packages,:gross_weight,:weight_uom,:volume,:volume_uom,:dangerous,
:reefer,:oversize,
:order_id,:created_by,now(),:ip,:ua,:ekey,
:temp_code)");

if($c->no_of_packages=="")
{
  $c->no_of_packages=null;
}

if($c->gross_weight=="")
{
  $c->gross_weight=null;
}

if($c->volume=="")
{
  $c->volume=null;
}


$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':unit_type'=>$c->unit_type,
':booked_qty'=>$c->booked_qty,
':main_commodity'=>$c->main_commodity,
':equipment_serial'=>$c->equipment_serial,
':package_type'=>$c->package_type,
':no_of_packages'=>$c->no_of_packages,
':gross_weight'=>$c->gross_weight,
':weight_uom'=>$c->weight_uom,
':volume'=>$c->volume,
':volume_uom'=>$c->volume_uom,
':dangerous'=>$c->dangerous,
':reefer'=>$c->reefer,
':oversize'=>$c->oversize,


':order_id'=>$c->order_id,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_order_cargo where created_by=:uid and temp_code=:temp_code and order_id=:order_id");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid,':order_id'=>$c->order_id));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_order_cargo($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("UPDATE mt_order_cargo SET 

  unit_type=:unit_type,
  booked_qty=:booked_qty,
  main_commodity=:main_commodity,
equipment_serial=:equipment_serial,
package_type=:package_type,
no_of_packages=:no_of_packages,
gross_weight=:gross_weight,
weight_uom=:weight_uom,
volume=:volume,
volume_uom=:volume_uom,
dangerous=:dangerous,
reefer=:reefer,
oversize=:oversize,
ip=:ip,created_by=:created_by,ua=:ua,ekey=:ekey,created_date= now() where id=:id and order_id=:order_id");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':unit_type'=>$c->unit_type,
':booked_qty'=>$c->booked_qty,
':main_commodity'=>$c->main_commodity,
':equipment_serial'=>$c->equipment_serial,
':package_type'=>$c->package_type,
':no_of_packages'=>$c->no_of_packages,
':gross_weight'=>$c->gross_weight,
':weight_uom'=>$c->weight_uom,
':volume'=>$c->volume,
':volume_uom'=>$c->volume_uom,
':dangerous'=>$c->dangerous,
':reefer'=>$c->reefer,
':oversize'=>$c->oversize,

':order_id'=>$c->order_id,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_order_services($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("UPDATE mt_order_services SET vendor=:vendor,
vendor_status=:vendor_status,
service_order_no=:service_order_no,
  ,ip=:ip,created_by=:created_by,ua=:ua,ekey=:ekey,created_date= now() where id=:id and order_id=:order_id");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':vendor'=>$c->vendor,
':vendor_status'=>$c->vendor_status,
':service_order_no'=>$c->service_order_no,

':order_id'=>$c->order_id,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function delete_order_cargo_info($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_order_cargo where id=:id");

$statement->execute(array(
':id'=>$c
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function delete_order_services($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_order_services where id=:id");

$statement->execute(array(
':id'=>$c
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


//6
public static function save_order_cost($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("SELECT id from mt_order_entry where id=:order_id and status in ('OPEN','PART INVOICED','INVOICED')");
$statement->execute(array(':order_id'=>$c->order_id));
$datas=$statement->fetchAll(PDO::FETCH_ASSOC);
if(count($datas)==1)
{
$statement = $db->prepare("INSERT into mt_order_cost(route,type,charge_desc,pay_at_location,mode_of_pay,basis_type,basis_uom,commodity,calc_method,qty,currency,ex_rate,rate_cost,rate_selling,cost_amount,selling_amount,cost_base_amount,selling_base_amount,remarks,billing_party,all_in,status,order_id,created_by,created_date,ip,ua,ekey,temp_code) 
values(:route,:type,:charge_desc,:pay_at_location,:mode_of_pay,:basis_type,:basis_uom,:commodity,:calc_method,:qty,:currency,:ex_rate,:rate_cost,:rate_selling,:cost_amount,:selling_amount,:cost_base_amount,:selling_base_amount,:remarks,:billing_party,:all_in,:status,
:order_id,:created_by,now(),:ip,:ua,:ekey,
:temp_code)");

if($c->qty=="")
{
  $c->qty=null;
}

if($c->ex_rate=="")
{
  $c->ex_rate=null;
}
if($c->rate_cost=="")
{
  $c->rate_cost=null;
}
if($c->rate_selling=="")
{
  $c->rate_selling=null;
}


if($c->cost_amount=="")
{
  $c->cost_amount=null;
}

if($c->selling_amount=="")
{
  $c->selling_amount=null;
}
if($c->cost_base_amount=="")
{
  $c->cost_base_amount=null;
}
if($c->selling_base_amount=="")
{
  $c->selling_base_amount=null;
}



$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':route'=>$c->route,
':type'=>$c->type,
':charge_desc'=>$c->charge_desc,
':pay_at_location'=>$c->pay_at_location,
':mode_of_pay'=>$c->mode_of_pay,
':basis_type'=>$c->basis_type,
':basis_uom'=>$c->basis_uom,
':commodity'=>$c->commodity,
':calc_method'=>$c->calc_method,
':qty'=>$c->qty,
':currency'=>$c->currency,
':ex_rate'=>$c->ex_rate,
':rate_cost'=>$c->rate_cost,
':rate_selling'=>$c->rate_selling,
':cost_amount'=>$c->cost_amount,
':selling_amount'=>$c->selling_amount,
':cost_base_amount'=>$c->cost_base_amount,
':selling_base_amount'=>$c->selling_base_amount,
':remarks'=>$c->remarks,
':billing_party'=>$c->billing_party,
':all_in'=>$c->all_in,
':status'=>$c->status,

':order_id'=>$c->order_id,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_order_cost where created_by=:uid and temp_code=:temp_code and order_id=:order_id");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid,':order_id'=>$c->order_id));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);
}else{
  $data["status"]=0;
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



public static function update_order_cost($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("SELECT id from mt_order_cost 
  where id=:id and invoiced is null");
$statement->execute(array(
  ':id'=>$c->id));
/*
SELECT id from mt_order_entry where id=:order_id and status in ('OPEN','PART INVOICED','INVOICED') and 
  (SELECT invoiced from mt_order_cost where id=:id) not in(1,2)
*/
$datas=$statement->fetchAll(PDO::FETCH_ASSOC);
if(count($datas)==1)
{

$statement = $db->prepare("UPDATE mt_order_cost SET 
  route=:route,
type=:type,
charge_desc=:charge_desc,
pay_at_location=:pay_at_location,
mode_of_pay=:mode_of_pay,
basis_type=:basis_type,
basis_uom=:basis_uom,
commodity=:commodity,
calc_method=:calc_method,
qty=:qty,
currency=:currency,
ex_rate=:ex_rate,
rate_cost=:rate_cost,
rate_selling=:rate_selling,
cost_amount=:cost_amount,
selling_amount=:selling_amount,
cost_base_amount=:cost_base_amount,
selling_base_amount=:selling_base_amount,
remarks=:remarks,
billing_party=:billing_party,
all_in=:all_in,
status=:status,
ip=:ip,created_by=:created_by,ua=:ua,ekey=:ekey,created_date= now() where id=:id and order_id=:order_id");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':route'=>$c->route,
':type'=>$c->type,
':charge_desc'=>$c->charge_desc,
':pay_at_location'=>$c->pay_at_location,
':mode_of_pay'=>$c->mode_of_pay,
':basis_type'=>$c->basis_type,
':basis_uom'=>$c->basis_uom,
':commodity'=>$c->commodity,
':calc_method'=>$c->calc_method,
':qty'=>$c->qty,
':currency'=>$c->currency,
':ex_rate'=>$c->ex_rate,
':rate_cost'=>$c->rate_cost,
':rate_selling'=>$c->rate_selling,
':cost_amount'=>$c->cost_amount,
':selling_amount'=>$c->selling_amount,
':cost_base_amount'=>$c->cost_base_amount,
':selling_base_amount'=>$c->selling_base_amount,
':remarks'=>$c->remarks,
':billing_party'=>$c->billing_party,
':all_in'=>$c->all_in,
':status'=>$c->status,

':order_id'=>$c->order_id,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
  $data["msg"]="Unable to update";

    //echo 'Failure: 0 rows were affected.';
}

}else{
  $data["status"]=0;
  $data["msg"]="Charge already invoiced";
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function delete_order_cost($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_order_cost where id=:id and invoiced is null");

$statement->execute(array(
':id'=>$c
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
  $data["msg"]="Charge already invoiced";
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

//7
public static function save_order_parties($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_order_parties(party_type,party_name,address,tel,email,poc,controlling_party,status,order_id,created_by,created_date,ip,ua,ekey,temp_code) 
values(:party_type,:party_name,:address,:tel,:email,:poc,:controlling_party,:status,
:order_id,:created_by,now(),:ip,:ua,:ekey,
:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':party_type'=>$c->party_type,
':party_name'=>$c->party_name,
':address'=>$c->address,
':tel'=>$c->tel,
':email'=>$c->email,
':poc'=>$c->poc,
':controlling_party'=>$c->controlling_party,
':status'=>$c->status,

':order_id'=>$c->order_id,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_order_parties where created_by=:uid and temp_code=:temp_code and order_id=:order_id");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid,':order_id'=>$c->order_id));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



public static function update_order_parties($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("UPDATE mt_order_parties SET party_type=:party_type,
party_name=:party_name,
address=:address,
tel=:tel,
email=:email,
poc=:poc,
controlling_party=:controlling_party,
status=:status,
ip=:ip,created_by=:created_by,ua=:ua,ekey=:ekey,created_date= now() where id=:id and order_id=:order_id");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':party_type'=>$c->party_type,
':party_name'=>$c->party_name,
':address'=>$c->address,
':tel'=>$c->tel,
':email'=>$c->email,
':poc'=>$c->poc,
':controlling_party'=>$c->controlling_party,
':status'=>$c->status,

':order_id'=>$c->order_id,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function delete_order_parties($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_order_parties where id=:id");

$statement->execute(array(
':id'=>$c
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

//8


//9


public static function delete_order_route($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_order_route where id=:id");

$statement->execute(array(
':id'=>$c
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_order_route($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("UPDATE mt_order_route SET 

  routing_transport_leg=:routing_transport_leg,
provider=:provider,
efrom=:efrom,
eto=:eto,
vessel=:vessel,
voyage=:voyage,
via=:via,
fpod=:fpod,
eta=:eta,
etd=:etd,
ip=:ip,created_by=:created_by,ua=:ua,ekey=:ekey,created_date= now() where id=:id and order_id=:order_id");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':routing_transport_leg'=>$c->routing_transport_leg,
':provider'=>$c->provider,
':efrom'=>$c->efrom,
':eto'=>$c->eto,
':vessel'=>$c->vessel,
':voyage'=>$c->voyage,
':via'=>$c->via,
':fpod'=>$c->fpod,
':eta'=>$c->eta,
':etd'=>$c->etd,

':order_id'=>$c->order_id,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_order_route($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_order_route(routing_transport_leg,provider,efrom,eto,vessel,voyage,via,fpod,eta,etd,
  order_id,created_by,created_date,ip,ua,ekey,temp_code) 
values(:routing_transport_leg,:provider,:efrom,:eto,:vessel,:voyage,:via,:fpod,:eta,:etd,:order_id,:created_by,now(),:ip,:ua,:ekey,
:temp_code)");

if($c->departure_date=="")
{
  $c->departure_date=null;
}
if($c->eta=="")
{
  $c->eta=null;
}
if($c->etd=="")
{
  $c->etd=null;
}

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':routing_transport_leg'=>$c->routing_transport_leg,
':provider'=>$c->provider,
':efrom'=>$c->efrom,
':eto'=>$c->eto,
':vessel'=>$c->vessel,
':voyage'=>$c->voyage,
':via'=>$c->via,
':fpod'=>$c->fpod,
':eta'=>$c->eta,
':etd'=>$c->etd,

':order_id'=>$c->order_id,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_order_route where created_by=:uid and temp_code=:temp_code and order_id=:order_id");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid,':order_id'=>$c->order_id));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_order_info_part1($code)
{

$data=array();
try
{
$db = Factory::getConnection();
//1
$statement = $db->prepare("SELECT id,order_id,routing_transport_leg,provider,efrom,eto,vessel,voyage,via,fpod,eta,etd, '0' edit from mt_order_route 
  where order_id=:id");
$statement->execute(array(':id'=>$code));
$data["route"]=$statement->fetchAll(PDO::FETCH_ASSOC);
//2
$statement = $db->prepare("SELECT id,order_id,serial,unit_type,booked_qty,basis_ops,basis_substitue,contract_type,released_qty,confirmed_qty,empty_release_office,empty_returned,with_shipper,cancelled, '0' edit from mt_order_container 
  where order_id=:id");
$statement->execute(array(':id'=>$code));
$data["container"]=$statement->fetchAll(PDO::FETCH_ASSOC);
//3
$statement = $db->prepare("SELECT id,order_id,container_no,type,package_type,no_of_pkgs,volume,gr_wgt,nt_wgt,tt_wgt,commodity,cargo_desc,reefer,min_temp,max_temp,oog,oh,ow,ol,haz,un_no,flash_type, '0' edit from mt_order_container_detail 
  where order_id=:id");
$statement->execute(array(':id'=>$code));
$data["container_detail"]=$statement->fetchAll(PDO::FETCH_ASSOC);
//4
$statement = $db->prepare("SELECT id,order_id,cargo_type,vehicle_type,vin_no,chassis_no,package_type,no_of_pkgs,volume,gr_wgt,nt_wgt,tt_wgt,commodity,cargo_desc,reefer,min_temp,max_temp,oog,oh,ow,ol,haz,un_no,flash_type, '0' edit from mt_order_landingcraft_detail 
  where order_id=:id");
$statement->execute(array(':id'=>$code));
$data["craft"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//bl no
$statement = $db->prepare("SELECT id,bl_no,(select id from mt_manifest_entry where bl_no=t1.bl_no) bl_id from mt_order_entry t1  
  where id=:id");
$statement->execute(array(':id'=>$code));
$data["bl"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_order_info_part2($code)
{

$data=array();
try
{
$db = Factory::getConnection();
//1

$statement = $db->prepare("SELECT id,order_id, unit_type, booked_qty, main_commodity,equipment_serial,package_type,no_of_packages,gross_weight,weight_uom,volume,volume_uom,dangerous,reefer,oversize, '0' edit from mt_order_cargo 
  where order_id=:id");
$statement->execute(array(':id'=>$code));
$data["cargo"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT id,order_id,vendor,vendor_status,service_order_no, '0' edit from mt_order_services 
  where order_id=:id");
$statement->execute(array(':id'=>$code));
$data["service"]=$statement->fetchAll(PDO::FETCH_ASSOC);
//2
$statement = $db->prepare("SELECT id,order_id,route,type,charge_desc,pay_at_location,mode_of_pay,basis_type,basis_uom,commodity,calc_method,qty,currency,ex_rate,rate_cost,rate_selling,cost_amount,selling_amount,cost_base_amount,selling_base_amount,remarks,billing_party,all_in,status, '0' edit from mt_order_cost 
  where order_id=:id");
$statement->execute(array(':id'=>$code));
$data["cost"]=$statement->fetchAll(PDO::FETCH_ASSOC);
//3
$statement = $db->prepare("SELECT id,order_id,party_type,party_name,address,tel,email,poc,controlling_party,status, '0' edit from mt_order_parties  
  where order_id=:id");
$statement->execute(array(':id'=>$code));
$data["parties"]=$statement->fetchAll(PDO::FETCH_ASSOC);
//4

  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_order_info($code)
{

$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,cargo_type,status,order_type,quote,copy_from,customer,expected_date,order_executive,shipment_from,shipment_to,requested_office,enquiry_reference,vendor_service_base_currency,vendor_service_total_selling,vendor_service_total_cost,vendor_service_profit,
  order_no,temp_code,shipment_type,to_invoice,shipment_terms,depot,remarks, principal,job_close_date from mt_order_entry where id=:id");

$statement->execute(array(':id'=>$code));

$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

/*
$statement = $db->prepare("SELECT id,erc_id,equipment_type,qty,status,remarks, '0' edit  
  from mt_erc_equip_detail
  where erc_id=:id");
$statement->execute(array(':id'=>$code));
$data["equip"]=$statement->fetchAll(PDO::FETCH_ASSOC);
*/

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_order_list($dev,$code)
{

$data=false;
try
{
$db = Factory::getConnection();
$aq=Factory::getRestrictionQuery1($dev,"t1");
$statement = $db->prepare("SELECT t1.id,t1.order_no,t1.order_type,(select name from mt_business_partner where code=t1.customer) customer,t1.status,t1.expected_date, t1.order_executive, t1.shipment_from, t1.shipment_to, t1.bl_no, t1.cargo_type, (select count(container_no) from  mt_order_container_detail where order_id=t1.id) units, '' provider,''transport_reference, (select sum(selling_base_amount) from mt_order_cost where order_id=t1.id) tot_revenue,t1.created_by,t1.created_date,
t1.modified_date,t1.modified_by   
  from mt_order_entry t1 where $aq   
  order by t1.id desc limit :sta,50");
/*
old query removed provider

SELECT t1.id,t1.order_no,t1.order_type,(select name from mt_business_partner where code=t1.customer) customer,t1.status,t1.expected_date, t1.order_executive, t1.shipment_from, t1.shipment_to, t1.bl_no, t1.cargo_type, (select count(container_no) from  mt_order_container_detail where order_id=t1.id) units, t3.provider, t3.transport_reference, (select sum(selling_base_amount) from mt_order_cost where order_id=t1.id) tot_revenue,t1.created_by,t1.created_date,
t1.modified_date,t1.modified_by   
  from mt_order_entry t1 LEFT JOIN
  ( SELECT order_id, GROUP_CONCAT(provider) provider,
  GROUP_CONCAT(transport_reference) transport_reference FROM mt_order_route GROUP BY order_id) t3
  ON t1.id=t3.order_id  
  order by t1.id desc limit :sta,50

*/   
$statement->bindValue(':sta',(int) $code->start, PDO::PARAM_INT); 
$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_order_list($v)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT t1.id,t1.order_no,t1.order_type,(select name from mt_business_partner where code=t1.customer) customer,t1.status,t1.expected_date, t1.order_executive, t1.shipment_from, t1.shipment_to, t1.bl_no, t1.cargo_type, (select count(container_no) from  mt_order_container_detail where order_id=t1.id) units, '' provider,'' transport_reference, (select sum(selling_base_amount) from mt_order_cost where order_id=t1.id) tot_revenue,t1.created_by,t1.created_date,
t1.modified_date,t1.modified_by 
  from mt_order_entry t1 
  
  WHERE (bl_no like ? or order_no like ? or (select name from mt_business_partner where code=t1.customer) like ? or status like ? or order_type like ?) 
   order by t1.id desc limit 50");

$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(4, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(5, "%$v%", PDO::PARAM_STR);

/*
old query removed provider and transport reference

SELECT t1.id,t1.order_no,t1.order_type,(select name from mt_business_partner where code=t1.customer) customer,t1.status,t1.expected_date, t1.order_executive, t1.shipment_from, t1.shipment_to, t1.bl_no, t1.cargo_type, (select count(container_no) from  mt_order_container_detail where order_id=t1.id) units, t3.provider, t3.transport_reference, (select sum(selling_base_amount) from mt_order_cost where order_id=t1.id) tot_revenue,t1.created_by,t1.created_date,
t1.modified_date,t1.modified_by 
  from mt_order_entry t1 
  LEFT JOIN
  ( SELECT order_id, GROUP_CONCAT(provider) provider,
  GROUP_CONCAT(transport_reference) transport_reference FROM mt_order_route GROUP BY order_id) t3
  ON t1.id=t3.order_id
  WHERE (bl_no like ? or order_no like ? or (select name from mt_business_partner where code=t1.customer) like ? or status like ? or order_type like ?) 
   order by t1.id desc limit 50

*/
$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function copy_order_from_quote($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();

if($code->status!="BOOKED")
{

  $db->beginTransaction();

  $temp_code=uniqid($dev->uid);
  $c=$code->id;
  //1
  $statement = $db->prepare("INSERT into mt_order_entry(status,order_type,cargo_type,quote,customer,
    expected_date,order_executive,shipment_from,shipment_to,created_by,created_date,ip,ua,ekey,temp_code,location_id,company_id) 
  SELECT 'OPEN','$code->order_type',shipment_mode,quote_no,requested_by,curdate(),prepared_by,origin,destination,'$dev->username',now(),
  '$dev->ip','$dev->ua','$dev->ekey','$temp_code',
  '$dev->location','$dev->company' 
  from mt_quote_list
  where id=:id");

  $statement->execute(array(':id'=>$c));

  if ($statement->rowCount()){
    $data["status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }
  //1 ends

  //updating order no in table

  $statement = $db->prepare("SELECT id,shipment_from,order_type from mt_order_entry where created_by=:uid and temp_code=:temp_code");
  $statement->execute(array(':temp_code'=>$temp_code,':uid'=>$dev->username));
  $op=$statement->fetchAll(PDO::FETCH_ASSOC);

  $data["id"]=$op;
  $order_type=$op[0]["order_type"];

  $fid=self::setFourDigit($op[0]["id"]);

  $ot='';
  if($order_type=="SEA IMPORT")
  {
    $ot="SEA-I/";
  }else if($order_type=="SEA EXPORT")
  {
    $ot="SEA-E/";
  } else if($order_type=="AGENCY EXPORT")
  {
    $ot="AEG-E/";
  }
  else if($order_type=="AGENCY IMPORT")
  {
    $ot="AEG-I/";
  }
  else if($order_type=="AIR IMPORT")
  {
    $ot="AIR-I/";
  }else if($order_type=="AIR EXPORT")
  {
    $ot="AIR-E/";
  }else if($order_type=="LCL IMPORT")
  {
    $ot="LCL-I/";
  }else if($order_type=="LCL EXPORT")
  {
    $ot="LCL-E/";
  }else if($order_type=="RORO IMPORT")
  {
    $ot="RORO-I/";
  }else if($order_type=="RORO EXPORT")
  {
    $ot="RORO-E/";
  }else if($order_type=="SHIP SUPPLIES")
  {
    $ot="SHIP/";
  }else if($order_type=="EPDA")
  {
    $ot="EPDA/";
  }

  //$on=$ot.date("Y")."/".date('m')."/".$op[0]["shipment_from"]."/".$fid;

  $prefix_loc=get_prefix_loc($dev);
  $fid=gen_no_for_order($db,$dev,$data["id"][0]["id"]);
  $fid=self::setFourDigit($fid);
  $on=$ot.date("Y")."/".date('m')."/".$prefix_loc."/".$fid;

   $statement = $db->prepare("UPDATE mt_order_entry 
    SET order_no=:ond where id=:id");
    $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
    
      if ($statement->rowCount()){
      $data["oid_status"]=1;
    } else{
      $data["oid_status"]=0;
    }

  $data["order_no"]=$on;

  $order_id=$op[0]["id"];

  //order no update ends

  //2
  $statement = $db->prepare("INSERT into mt_order_container(order_id, unit_type,booked_qty,created_by,created_date,ip,ua,ekey,temp_code) 
  SELECT '$order_id', container_type,type_qty,
  '$dev->username',now(),
  '$dev->ip','$dev->ua','$dev->ekey','$temp_code'
  from mt_quote_commodity
  where quote_id=:id");
  $statement->execute(array(':id'=>$c));

  if ($statement->rowCount()){
    $data["container_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["container_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

  //2 ends


  //3
  $statement = $db->prepare("INSERT into mt_order_route(order_id,routing_transport_leg,provider,efrom,eto,created_by,created_date,ip,ua,ekey,temp_code)
  SELECT '$order_id',1,provider,origin,destination,
  '$dev->username',now(),
  '$dev->ip','$dev->ua','$dev->ekey','$temp_code' 
  from mt_quote_route
  where quote_id=:id");
  $statement->execute(array(':id'=>$c));

  if ($statement->rowCount()){
    $data["route_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["route_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

  //3 ends

  //4
  $statement = $db->prepare("INSERT into mt_order_cost(order_id,type,charge_desc, pay_at_location,basis_type,
    basis_uom,commodity,currency,qty,ex_rate,
    rate_selling,selling_amount,selling_base_amount,
      rate_cost,cost_amount,cost_base_amount,
      billing_party,created_by,created_date,ip,ua,ekey,temp_code)
  SELECT '$order_id',
  rate_type,charge_description,pay_at_location,basis_type,
    base_unit,commodity,currency,qty,ex_rate,
    case when rate_type='INCOME' then rate ELSE '' end rate_selling,
  case when rate_type='INCOME' then foreign_amount ELSE '' end selling_amount,
  case when rate_type='INCOME' then local_amount ELSE '' end selling_base_amount,
  case when rate_type='COST' then rate ELSE '' end rate_cost,
  case when rate_type='COST' then foreign_amount ELSE '' end cost_amount,
  case when rate_type='COST' then local_amount ELSE '' end cost_base_amount,

    rate_provider,'$dev->username',now(),
  '$dev->ip','$dev->ua','$dev->ekey','$temp_code' 
  from mt_quote_rate
  where quote_id=:id");
  $statement->execute(array(':id'=>$c));

  if ($statement->rowCount()){
    $data["cost_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["cost_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

  //4 ends
  //SET quote status=BOOKED
   $statement = $db->prepare("UPDATE mt_quote_list 
    SET status='BOOKED' where id=:id");
    $statement->execute(array(':id'=>$c));
    
      if ($statement->rowCount()){
      $data["qs_status"]=1;
    } else{
      $data["qs_status"]=0;
    }


  $statement = $db->prepare("");

  $data["temp_code"]=$temp_code;

  if($data["status"]==1 && $data["oid_status"]==1 && $data["qs_status"]==1)
  {
    $db->commit();
  }else{
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
  }
}
else
{
    $data["status"]=2;
    $data["msg"]="Already Booking created for this Quote.";  
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
    print $e->getMessage();
  }
  
  return $data;
}

public static function copy_order($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_order_entry(status,order_type,quote,copy_from,customer,expected_date,order_executive,shipment_from,shipment_to,requested_office,enquiry_reference,vendor_service_base_currency,vendor_service_total_selling,vendor_service_total_cost,vendor_service_profit,created_by,created_date,ip,ua,ekey,temp_code,cargo_type,shipment_type,location_id,company_id) 
SELECT 'OPEN',order_type,quote,order_no,customer,expected_date,order_executive,shipment_from,shipment_to,requested_office,enquiry_reference,vendor_service_base_currency,vendor_service_total_selling,vendor_service_total_cost,vendor_service_profit,
'$dev->username',now(),
'$dev->ip','$dev->ua','$dev->ekey','$temp_code',cargo_type,shipment_type,'$dev->location','$dev->company'  
from mt_order_entry where id=:id");

$statement->execute(array(':id'=>$c->id));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
$data["temp_code"]=$temp_code;

$statement = $db->prepare("SELECT id,shipment_from,order_type from mt_order_entry where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,':uid'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

$fid=self::setFourDigit($op[0]["id"]);


$order_type=$op[0]["order_type"];

$fid=self::setFourDigit($op[0]["id"]);

$ot='';
if($order_type=="SEA IMPORT")
{
  $ot="SEA-I/";
}else if($order_type=="SEA EXPORT")
{
  $ot="SEA-E/";
} else if($order_type=="AGENCY EXPORT")
{
  $ot="AEG-E/";
}
else if($order_type=="AGENCY IMPORT")
{
  $ot="AEG-I/";
}
else if($order_type=="AIR IMPORT")
{
  $ot="AIR-I/";
}else if($order_type=="AIR EXPORT")
{
  $ot="AIR-E/";
}else if($order_type=="LCL IMPORT")
{
  $ot="LCL-I/";
}else if($order_type=="LCL EXPORT")
{
  $ot="LCL-E/";
}else if($order_type=="RORO IMPORT")
{
  $ot="RORO-I/";
}else if($order_type=="RORO EXPORT")
{
  $ot="RORO-E/";
}else if($order_type=="SHIP SUPPLIES")
{
  $ot="SHIP/";
}else if($c->order_type=="EPDA IMPORT")
{
  $ot="EPDA-I/";
}else if($c->order_type=="EPDA EXPORT")
{
  $ot="EPDA-E/";
}

//$on=$ot.date("Y")."/".date('m')."/".$op[0]["shipment_from"]."/".$fid;

$prefix_loc=get_prefix_loc($dev);
$fid=gen_no_for_order($db,$dev,$data["id"][0]["id"]);
$fid=self::setFourDigit($fid);
$on=$ot.date("Y")."/".date('m')."/".$prefix_loc."/".$fid;

 $statement = $db->prepare("UPDATE mt_order_entry 
  SET order_no=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["oid_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["oid_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

$data["order_no"]=$on;

$order_id=$fid;
//1 route

$statement = $db->prepare("INSERT into mt_order_route(routing_transport_leg,provider,efrom,eto,vessel,voyage,fpod,eta,etd, order_id,created_by,created_date,ip,ua,ekey) 
SELECT routing_transport_leg,provider,efrom,eto,vessel,voyage,fpod,eta,etd,$order_id,
'$dev->username',now(),
'$dev->ip','$dev->ua','$dev->ekey' from mt_order_route where order_id=:id");

$statement->execute(array(':id'=>$c->id));

if ($statement->rowCount()){
  $data["route_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["route_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

//2 container

$statement = $db->prepare("INSERT into mt_order_container(serial,unit_type,booked_qty,basis_ops,basis_substitue,contract_type,released_qty,confirmed_qty,empty_release_office,empty_returned,with_shipper,cancelled,order_id,created_by,created_date,ip,ua,ekey)
SELECT serial,unit_type,booked_qty,basis_ops,basis_substitue,contract_type,released_qty,confirmed_qty,empty_release_office,empty_returned,with_shipper,cancelled,
$order_id,'$dev->username',now(),
'$dev->ip','$dev->ua','$dev->ekey' from mt_order_container
 where order_id=:id");

$statement->execute(array(':id'=>$c->id));

if ($statement->rowCount()){
  $data["container_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["container_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

//3 cargo summary

$statement = $db->prepare("INSERT into mt_order_cargo(
  main_commodity,equipment_serial,package_type,no_of_packages,gross_weight,weight_uom,volume,volume_uom,dangerous,reefer,oversize,order_id,created_by,created_date,ip,ua,ekey)
SELECT main_commodity,equipment_serial,package_type,no_of_packages,gross_weight,weight_uom,volume,volume_uom,dangerous,reefer,oversize,
$order_id,'$dev->username',now(),
'$dev->ip','$dev->ua','$dev->ekey' from mt_order_cargo where order_id=:id");

$statement->execute(array(':id'=>$c->id));

if ($statement->rowCount()){
  $data["cargo_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["cargo_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

//4 container detail

/*$statement = $db->prepare("INSERT into mt_order_container_detail(container_no,type,package_type,no_of_pkgs,volume,gr_wgt,nt_wgt,tt_wgt,commodity,cargo_desc,reefer,min_temp,max_temp,oog,oh,ow,ol,haz,un_no,flash_type,
  order_id,created_by,created_date,ip,ua,ekey)
SELECT container_no,type,package_type,no_of_pkgs,volume,gr_wgt,nt_wgt,tt_wgt,commodity,cargo_desc,reefer,min_temp,max_temp,oog,oh,ow,ol,haz,un_no,flash_type,
$order_id,'$dev->username',now(),
'$dev->ip','$dev->ua','$dev->ekey' from mt_order_container_detail
 where order_id=:id");

$statement->execute(array(':id'=>$c->id));

if ($statement->rowCount()){
  $data["cd_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["cd_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}


//5 lc

$statement = $db->prepare("INSERT into mt_order_landingcraft_detail(cargo_type,vehicle_type,vin_no,chassis_no,package_type,no_of_pkgs,volume,gr_wgt,nt_wgt,tt_wgt,commodity,cargo_desc,reefer,min_temp,max_temp,oog,oh,ow,ol,haz,un_no,flash_type,order_id,created_by,created_date,ip,ua,ekey)
SELECT cargo_type,vehicle_type,vin_no,chassis_no,package_type,no_of_pkgs,volume,gr_wgt,nt_wgt,tt_wgt,commodity,cargo_desc,reefer,min_temp,max_temp,oog,oh,ow,ol,haz,un_no,flash_type,
$order_id,'$dev->username',now(),
'$dev->ip','$dev->ua','$dev->ekey' from mt_order_landingcraft_detail where order_id=:id");

$statement->execute(array(':id'=>$c->id));

if ($statement->rowCount()){
  $data["lc_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["lc_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
*/
//6 cost

$statement = $db->prepare("INSERT into mt_order_cost(route,type,charge_desc,pay_at_location,mode_of_pay,basis_type,basis_uom,commodity,calc_method,qty,currency,ex_rate,rate_cost,rate_selling,cost_amount,selling_amount,cost_base_amount,selling_base_amount,remarks,billing_party,all_in,status,order_id,created_by,created_date,ip,ua,ekey)
SELECT route,type,charge_desc,pay_at_location,mode_of_pay,basis_type,basis_uom,commodity,calc_method,qty,currency,ex_rate,rate_cost,rate_selling,cost_amount,selling_amount,cost_base_amount,selling_base_amount,remarks,billing_party,all_in,status,
$order_id,'$dev->username',now(),
'$dev->ip','$dev->ua','$dev->ekey' from mt_order_cost where order_id=:id");

$statement->execute(array(':id'=>$c->id));

if ($statement->rowCount()){
  $data["cost_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["cost_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

//7 parties

$statement = $db->prepare("INSERT into mt_order_parties(party_type,party_name,address,tel,email,poc,controlling_party,status,order_id,created_by,created_date,ip,ua,ekey)
SELECT party_type,party_name,address,tel,email,poc,
controlling_party,status,
$order_id,'$dev->username',now(),
'$dev->ip','$dev->ua','$dev->ekey' from mt_order_parties where order_id=:id");

$statement->execute(array(':id'=>$c->id));

if ($statement->rowCount()){
  $data["party_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["party_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

//8

if($data["status"]==1 && $data["oid_status"]==1)
{
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
  }
  
  return $data;
}

public static function save_order($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_order_entry(cargo_type,
  status,order_type,quote,copy_from,customer,expected_date,order_executive,shipment_from,shipment_to,requested_office,enquiry_reference,vendor_service_base_currency,vendor_service_total_selling,vendor_service_total_cost,vendor_service_profit,created_by,created_date,ip,ua,ekey,temp_code,location_id,company_id,shipment_type,to_invoice,depot,remarks,principal,job_close_date) 
values(:cargo_type,
:status,:order_type,:quote,:copy_from,:customer,:expected_date,:order_executive,:shipment_from,:shipment_to,:requested_office,:enquiry_reference,:vendor_service_base_currency,:vendor_service_total_selling,:vendor_service_total_cost,:vendor_service_profit,:created_by,now(),:ip,:ua,:ekey,
:temp_code,:location_id,:company_id,:shipment_type,:to_invoice,:depot,:remarks,:principal,:job_close_date)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':cargo_type'=>$c->cargo_type,
':status'=>$c->status,
':order_type'=>$c->order_type,
':quote'=>$c->quote,
':copy_from'=>$c->copy_from,
':customer'=>$c->customer,
':expected_date'=>$c->expected_date,
':job_close_date'=>$c->job_close_date,
':order_executive'=>$c->order_executive,
':shipment_from'=>$c->shipment_from,
':shipment_to'=>$c->shipment_to,
':requested_office'=>$c->requested_office,
':enquiry_reference'=>$c->enquiry_reference,
':vendor_service_base_currency'=>$c->vendor_service_base_currency,
':vendor_service_total_selling'=>$c->vendor_service_total_selling,
':vendor_service_total_cost'=>$c->vendor_service_total_cost,
':vendor_service_profit'=>$c->vendor_service_profit,


':temp_code'=>$temp_code,
':company_id'=>$dev->company,
':location_id'=>$dev->location,
':shipment_type'=>$c->shipment_type,
':to_invoice'=>$c->to_invoice,
':depot'=>$c->depot,
':remarks'=>$c->remarks,
':principal'=>$c->principal
));

if ($statement->rowCount()){
  $data["status"]=1;

} else{
  $data["status"]=0;
}

$data["temp_code"]=$temp_code;

$statement = $db->prepare("SELECT id from mt_order_entry where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,':uid'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

$fid=self::setFourDigit($op[0]["id"]);
$ot='';
if($c->order_type=="SEA IMPORT")
{
  $ot="SEA-I/";
}else if($c->order_type=="SEA EXPORT")
{
  $ot="SEA-E/";
} else if($c->order_type=="AGENCY EXPORT")
{
  $ot="AEG-E/";
}
else if($c->order_type=="AGENCY IMPORT")
{
  $ot="AEG-I/";
}
else if($c->order_type=="AIR IMPORT")
{
  $ot="AIR-I/";
}else if($c->order_type=="AIR EXPORT")
{
  $ot="AIR-E/";
}else if($c->order_type=="LCL IMPORT")
{
  $ot="LCL-I/";
}else if($c->order_type=="LCL EXPORT")
{
  $ot="LCL-E/";
}else if($c->order_type=="RORO IMPORT")
{
  $ot="RORO-I/";
}else if($c->order_type=="RORO EXPORT")
{
  $ot="RORO-E/";
}
else if($c->order_type=="SHIP SUPPLIES")
{
  $ot="SHIP/";
}else if($c->order_type=="EPDA IMPORT")
{
  $ot="EPDA-I/";
}else if($c->order_type=="EPDA EXPORT")
{
  $ot="EPDA-E/";
}
//$on=$ot.date("Y")."/".date('m')."/".$c->shipment_from."/".$fid;

$prefix_loc=get_prefix_loc($dev);
$fid=gen_no_for_order($db,$dev,$data["id"][0]["id"]);
$fid=self::setFourDigit($fid);
$on=$ot.date("Y")."/".date('m')."/".$prefix_loc."/".$fid;

 $statement = $db->prepare("UPDATE mt_order_entry 
  SET order_no=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["oid_status"]=1;
  } else{
    $data["oid_status"]=0;
  }

$data["order_no"]=$on;

if($data["status"]==1 && $data["oid_status"]==1)
{
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}

$statement=null;
  }
  catch (PDOException $e) {
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
    print $e->getMessage();
  }
  
  return $data;
}

public static function setFourDigit($v)
{
  $len=strlen($v);

if($len==1)
{
  $v="000".$v;
}else if($len==2)
{
  $v="00".$v;
}else if($len==3)
{
  $v="0".$v;
}

return $v;
}


public static function update_order($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$statement = $db->prepare("UPDATE mt_order_entry SET 
  cargo_type=:cargo_type,
  status=:status,
quote=:quote,
customer=:customer,
expected_date=:expected_date,
order_executive=:order_executive,
shipment_from=:shipment_from,
shipment_to=:shipment_to,
requested_office=:requested_office,
enquiry_reference=:enquiry_reference,
vendor_service_base_currency=:vendor_service_base_currency,
vendor_service_total_selling=:vendor_service_total_selling,
vendor_service_total_cost=:vendor_service_total_cost,
vendor_service_profit=:vendor_service_profit,

modified_by=:modified_by,
modified_date=now(),
shipment_type=:shipment_type,
to_invoice=:to_invoice,
depot=:depot,
remarks=:remarks,
principal=:principal,
shipment_terms=:shipment_terms   
where id=:id");

$statement->execute(array(':modified_by'=>$dev->username ,

':cargo_type'=>$c->cargo_type,
':status'=>$c->status,
':quote'=>$c->quote,
':customer'=>$c->customer,
':expected_date'=>$c->expected_date,
':order_executive'=>$c->order_executive,
':shipment_from'=>$c->shipment_from,
':shipment_to'=>$c->shipment_to,
':requested_office'=>$c->requested_office,
':enquiry_reference'=>$c->enquiry_reference,
':vendor_service_base_currency'=>$c->vendor_service_base_currency,
':vendor_service_total_selling'=>$c->vendor_service_total_selling,
':vendor_service_total_cost'=>$c->vendor_service_total_cost,
':vendor_service_profit'=>$c->vendor_service_profit,

':id'=>$c->id,
':shipment_type'=>$c->shipment_type,
':to_invoice'=>$c->to_invoice,
':depot'=>$c->depot,
':remarks'=>$c->remarks,
':principal'=>$c->principal,
':shipment_terms'=>$c->shipment_terms
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Updated";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to update. Please try again.";

}

if(self::isDate($c->job_close_date))
{

$statement = $db->prepare("SELECT count(*) tc,type FROM mt_order_cost 
  WHERE order_id =(SELECT id from mt_order_entry WHERE order_no=:order_no) 
  GROUP BY type");
$statement->execute(array(':order_no'=>$c->order_no));
$data["act_count"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$type_count=$data["act_count"];
$type_count1=count($type_count);
if($type_count1==0)
{
  $data["status"]=0;
  $data["msg"]="Please add charges and invoice. Then choose the Job Closing Date.";

}else if($type_count1==1)
{
  $data["status"]=0;
  $first=$data["act_count"][0]["type"];
  $second="";
  if($first=="INCOME")
  {
    $second="COST";
  }else{
    $second="INCOME";
  }
  $data["msg"]="Only $first found. Please add $second in the charge section. Then choose the Job Closing Date.";

}else{
  $income_count=0;
  $cost_count=0;

  for($i=0;$i<2;$i++)
  {
    if($data["act_count"][$i]["type"]=="INCOME")
    {
      $income_count=$data["act_count"][$i]["tc"];
    }
    if($data["act_count"][$i]["type"]=="COST")
    {
      $cost_count=$data["act_count"][$i]["tc"];
    }
  }


  $statement = $db->prepare("SELECT count(*) tc,type FROM mt_order_cost
   WHERE order_id =(SELECT id from mt_order_entry WHERE order_no=:order_no) and inv_pay_no is not null GROUP BY type");
$statement->execute(array(':order_no'=>$c->order_no));
$data["inv_count"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$inv_count=$data["inv_count"];
$inv_count1=count($data["inv_count"]);


        if($inv_count1==0)
        {
          $data["status"]=0;
          $data["msg"]="Please invoice charges. Then choose the Job Closing Date.";

        }else if($inv_count1==1)
        {
          $data["status"]=0;
          $first=$data["inv_count"][0]["type"];
          $second="";
          if($first=="INCOME")
          {
            $second="COST";
          }else{
            $second="INCOME";
          }
          $data["msg"]="Only $first invoiced. Please invoice $second. Then choose the Job Closing Date.";

        }else{

          $income_inv_count=0;
          $cost_inv_count=0;

          for($i=0;$i<2;$i++)
          {
            if($data["inv_count"][$i]["type"]=="INCOME")
            {
              $income_inv_count=$data["inv_count"][$i]["tc"];
            }
            if($data["inv_count"][$i]["type"]=="COST")
            {
              $cost_inv_count=$data["inv_count"][$i]["tc"];
            }
          }

          if($income_count==$income_inv_count && $cost_count==$cost_inv_count)
          {

            $statement = $db->prepare("SELECT id,sub_ar_doc_number FROM `mt_ship_ar_header` WHERE order_no LIKE '%$c->order_no%'");
          $statement->execute(array(':order_no'=>$c->order_no));
          $data["inv_list"]=$statement->fetchAll(PDO::FETCH_ASSOC);

          $child_count=0;
          $child_status_count=0;
          for($i=0;$i<count($data["inv_list"]);$i++)
          {
            $child_count+=1;
              $nrow=$data["inv_list"][$i];

              $statement = $db->prepare("UPDATE mt_ship_ar_header SET job_close_date=:job_close_date,modified_by=:username,modified_date=now() 
                WHERE id=:id");
            $statement->execute(array(':id'=>$nrow["id"],
              ':username'=>$dev->username,
              ':job_close_date'=>$c->job_close_date
            ));

                  if ($statement->rowCount()){
                    $child_status_count+=1;
                    $data["upd_status".($i+1)]=1;
                  } else{
                    $data["upd_status".($i+1)]=0;

                  }
          }

          if($child_count==$child_status_count)
          {
            $data["status"]=1;
          }else{
            $data["status"]=0;
            $data["msg"]="Unable to save. Header table data not updated.";
          }

          $statement = $db->prepare("UPDATE mt_order_entry SET job_close_date=:job_close_date,modified_by=:username,modified_date=now() 
                WHERE id=:id");
            $statement->execute(array(':id'=>$c->id,
              ':username'=>$dev->username,
              ':job_close_date'=>$c->job_close_date
            ));

                  if ($statement->rowCount()){
                    $data["job_close_status"]=1;
                  } else{
                    $data["job_close_status"]=0;

                  }


          }else{
            $data["status"]=0;
            $data["msg"]="Please invoice all the charges(INCOME invoiced $income_inv_count of $income_count and COST invoiced $cost_inv_count of $cost_count ). Then choose the Job Closing Date";
          }

        }

}

}


if($data["status"]==1)
{
  $db->commit();
}else{
  $db->rollBack();
  //$data["status"]=0;
  //$data["msg"]="Unable to save. Please try again";
}

$statement=null;
  }
  catch (Exception $e) {
    //print $e->getMessage();
    $data["emsg"]=$e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Exception caused. Unable to save. Please try again";
  }
  
  return $data;
}

public static function isDate($value) {
    if (!$value) {
        return false;
    } else {
        $date = date_parse($value);
        if($date['error_count'] == 0 && $date['warning_count'] == 0){
            return checkdate($date['month'], $date['day'], $date['year']);
        } else {
            return false;
        }
    }
}
public static function save_rate($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_rates(created_by,created_date,ip,ua,ekey,temp_code) 
values(:created_by,now(),:ip,:ua,:ekey,
:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,




':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_erc where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,':uid'=>$dev->uid));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_rate($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_rates SET 

modified_by=:modified_by,
modified_date=now() 
where id=:id");

$statement->execute(array(':modified_by'=>$dev->uid ,

':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_job_profit_list($dev,$c)
{

$data=false;
try
{
$db = Factory::getConnection();
$aq=Factory::getRestrictionQuery1($dev,"t1");
$statement = $db->prepare("SELECT 
order_no,
salesperson,
customer,
bl_no,
billing_party, 
buy_rate,
sell_rate,
ofrt_profit,
ofrt_profit_usd,
rebate,
(ofrt_profit-rebate) ofrt_profit_aft_rebate,
'' other_loss,
'' other_profit,
'' total_profit,
'' payment_status,
'' remarks,
'0' edit 

FROM 
(
SELECT t1.order_no, 
'' salesperson,
t1.customer,
t1.bl_no,
t2.billing_party, 
sum(t2.rate_cost) buy_rate,
sum(t2.rate_selling) sell_rate,
(select sum((it.rate_cost-it.rate_selling)*it.ex_rate) from mt_order_cost it where it.order_id=t1.id) ofrt_profit,
(select sum(it.rate_cost-it.rate_selling) from mt_order_cost it where it.order_id=t1.id) ofrt_profit_usd,
(select sum(it.rate_cost) from mt_order_cost it where it.order_id=t1.id and it.charge_desc='RBT') rebate 
from mt_order_entry t1 
left join mt_order_cost t2
on t1.id=t2.order_id
WHERE t1.expected_date between :from_date and :to_date 
GROUP BY t1.id,t1.order_no,t1.customer,t1.bl_no,t2.billing_party
) gt  

");

$statement->execute(array(':from_date'=>$c->from_date,':to_date'=>$c->to_date));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

}

?>