<?php


require("../config/dbconn.php");

class RFQDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function save_quote_rfq($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);
$data["temp_code"]=$temp_code;
$statement = $db->prepare("INSERT into quote_rfq(agent_name,rfq_sent_date,quote_id,
ip,created_by ,ua,ekey,created_date,temp_code) 
values(:agent_name,CURDATE(),:quote_id,
:ip ,:created_by ,
:ua ,:ekey,now(),:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':agent_name'=>$c->agent_name,



':quote_id'=>$c->quote_id,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again.";
}

$statement = $db->prepare("SELECT id,date(created_date) rfq_sent_date from quote_rfq where created_by=:created_by and temp_code=:temp_code and quote_id=:quote_id");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username,':quote_id'=>$c->quote_id));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$vendor_id=$data["id"][0]["id"];

//pull data from charge list
$statement = $db->prepare("INSERT into quote_rfq_charges_list_vendor(charge_list_id,
  quote_id,charge_code,
ip,created_by ,ua,ekey,created_date) SELECT $vendor_id,quote_id,charge_code,ip,ua,ekey,created_by,now() FROM quote_rfq_charges_list WHERE quote_id=:quote_id");

$statement->execute(array(
':quote_id'=>$c->quote_id
));

if ($statement->rowCount()){
  $data["vendor_status"]=1;
} else{
  $data["vendor_status"]=0;
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



public static function update_quote_rfq($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("UPDATE quote_rfq SET agent_name=:agent_name,
  rfq_sent_date=:rfq_sent_date,reply_date=:reply_date,quote_postion=:quote_postion 
  where id=:id");

$statement->execute(array(

':agent_name'=>$c->agent_name,
':rfq_sent_date'=>$c->rfq_sent_date,
':reply_date'=>$c->reply_date,
':quote_postion'=>$c->quote_postion,

':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function delete_quote_rfq($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("DELETE FROM quote_rfq  where id=:id");

$statement->execute(array(
':id'=>$c
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Deleted";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to delete. Please try again";
}


$statement = $db->prepare("DELETE FROM quote_rfq_charges_list_vendor 
 where charge_list_id=:id");

$statement->execute(array(
':id'=>$c
));

if ($statement->rowCount()){
  $data["vendor_status"]=1;
} else{
  $data["vendor_status"]=0;
}
if($data["status"]==1 && $data["vendor_status"]==1)
{
  $db->commit();
}else{
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
}

$statement=null;
  }
  catch (PDOException $e) {
    $data["emsg"]=$e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
  }
  
  return $data;
}


public static function get_quote_rfq_list($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("SELECT id,quote_id,agent_name,rfq_sent_date,reply_date 
where quote_id=:quote_id");

$statement->execute(array(
':quote_id'=>$c
));

$data=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}




public static function save_quote_rfq_charge($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into quote_rfq_charges_list(charge_code,quote_id,
ip,created_by ,ua,ekey,created_date,temp_code) 
values(:charge_code,:quote_id,
:ip ,:created_by ,
:ua ,:ekey,now(),:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':charge_code'=>$c->charge_code,

':quote_id'=>$c->quote_id,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again.";
}

$statement = $db->prepare("SELECT id from quote_rfq_charges_list where created_by=:created_by and temp_code=:temp_code and quote_id=:quote_id");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username,':quote_id'=>$c->quote_id));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



public static function update_quote_rfq_charge($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("UPDATE quote_rfq_charges_list SET charge_code=:charge_code,modified_by=:modified_by,modified_date=now() where id=:id");

$statement->execute(array(

':charge_code'=>$c->charge_code,
':modified_by'=>$dev->username,

':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Upadted";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to update. Please try again.";

}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function delete_quote_rfq_charge($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("DELETE FROM quote_rfq_charges_list  where id=:id");

$statement->execute(array(
':id'=>$c
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Deleted";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to delete. Please try again";
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_quote_rfq_charge($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("SELECT id,quote_id,charge_code,'0' edit FROM quote_rfq_charges_list
where quote_id=:quote_id");

$statement->execute(array(
':quote_id'=>$c
));

$data=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_quote_rfq_charge_ve($id,$quote_id,$temp_code)
{
$data=array();
try
{
$db = Factory::getConnection();

//$temp_code=uniqid($dev->uid);

$statement = $db->prepare("SELECT id,quote_id,temp_code,agent_name,(SELECT name FROM mt_business_partner WHERE code=agent_name) name,reply_date FROM quote_rfq
where quote_id=:quote_id and id=:id and temp_code=:temp_code");

$statement->execute(array(
':quote_id'=>$quote_id,
':id'=>$id,
':temp_code'=>$temp_code
));
$datas=$statement->fetchAll(PDO::FETCH_ASSOC);
if(count($datas)>=1)
{
  $data["status"]=1;
  $data["agent_name"]=$datas[0]["name"];
  $data["agent_code"]=$datas[0]["agent_name"];
  $data["reply_date"]=$datas[0]["reply_date"];
    $edit=1;
    if($data["reply_date"])
    {
        $edit=0;
    }
  //get charges list

$statement = $db->prepare("SELECT id,quote_id,charge_list_id,(SELECT description FROM mt_charge_group_detail WHERE code=charge_code limit 1) charge_code,currency,ex_rate,famt,lamt,'$edit' edit FROM quote_rfq_charges_list_vendor 
where quote_id=:quote_id and charge_list_id=:id ");

$statement->execute(array(
':quote_id'=>$quote_id,
':id'=>$id
));
$data["charges"]=$statement->fetchAll(PDO::FETCH_ASSOC);

}else{
  $data["status"]=0;
  $data["msg"]="Invalid Credentials";
  $data["temp_code"]=$temp_code;
  $data["id"]=$id;
  $data["quote_id"]=$quote_id;
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function save_quote_rfq_charge_vendor($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();

//$temp_code=uniqid($dev->uid);

$charge_list_id=$code->id;
$quote_id=$code->quote_id;
$temp_code=$code->temp_code;
$charges=$code->charges;

$statement = $db->prepare("SELECT id,quote_id,temp_code FROM quote_rfq
where quote_id=:quote_id and id=:id and temp_code=:temp_code");

$statement->execute(array(
':quote_id'=>$quote_id,
':id'=>$charge_list_id,
':temp_code'=>$temp_code
));
$datas=$statement->fetchAll(PDO::FETCH_ASSOC);
if(count($datas)>=1)
{
$db->beginTransaction();

$child_status_count=0;
for($i=0;$i<count($charges);$i++)
{
  $cd=$charges[$i];
  $statement = $db->prepare("UPDATE quote_rfq_charges_list_vendor SET currency=:currency,
    ex_rate=:ex_rate,
    famt=:famt,
    lamt=:lamt,
    modified_date=now() where id=:id and quote_id=:quote_id and charge_list_id=:charge_list_id");
$statement->execute(array(
':id'=>$cd->id,
':quote_id'=>$quote_id,
':charge_list_id'=>$charge_list_id,

':currency'=>$cd->currency,
':ex_rate'=>$cd->ex_rate,
':famt'=>$cd->famt,
':lamt'=>$cd->lamt
));

if ($statement->rowCount()){
  $data["child_status".($i+1)]=1;
  $child_status_count+=1;
} else{
  $data["child_status".($i+1)]=0;
}

}

$statement = $db->prepare("UPDATE quote_rfq SET reply_date=:reply_date,
  total_amt=:total_amt WHERE id=:id and quote_id=:quote_id");

$statement->execute(array(
':quote_id'=>$quote_id,
':id'=>$charge_list_id,
':total_amt'=>$code->total,
':reply_date'=>date('Y-m-d')
));

if ($statement->rowCount()){
  $data["rfq_status"]=1;
} else{
  $data["rfq_status"]=0;
}
$data["status"]=1;
$data["msg"]="Successfully submitted quote.";
if($data["status"]==1 && count($charges)==$child_status_count && $data["rfq_status"]==1)
{
  $db->commit();
}else{
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
}


}else{
  $data["status"]=0;
  $data["msg"]="Invalid Credentials";
}

$statement=null;
  }
  catch (PDOException $e) {
    $data["emsg"]=$e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again. Exception occurred.";
  }
  
  return $data;
}



public static function get_quote_rfq_charge_ve_email($id,$quote_id,$temp_code)
{
$data=array();
try
{
$db = Factory::getConnection();

//$temp_code=uniqid($dev->uid);

$statement = $db->prepare("SELECT id,quote_id,temp_code,agent_name,(SELECT name FROM mt_business_partner WHERE code=agent_name) name,reply_date FROM quote_rfq
where quote_id=:quote_id and id=:id and temp_code=:temp_code");

$statement->execute(array(
':quote_id'=>$quote_id,
':id'=>$id,
':temp_code'=>$temp_code
));
$datas=$statement->fetchAll(PDO::FETCH_ASSOC);
if(count($datas)>=1)
{
  $data["status"]=1;
  $data["id"]=$id;
  $data["quote_id"]=$quote_id;
  $data["temp_code"]=$temp_code;
  
  $data["agent_name"]=$datas[0]["name"];
  $data["agent_code"]=$datas[0]["agent_name"];
  $data["reply_date"]=$datas[0]["reply_date"];
    $edit=1;
    if($data["reply_date"])
    {
        $edit=0;
    }
  //get charges list

  $statement = $db->prepare("SELECT id,origin,destination FROM mt_quote_list WHERE id=:quote_id");

$statement->execute(array(
':quote_id'=>$quote_id
));
$datas1=$statement->fetchAll(PDO::FETCH_ASSOC);
$data["origin"]=$datas1[0]["origin"];
$data["destination"]=$datas1[0]["destination"];

 $statement = $db->prepare("SELECT id,commodity,container_type,type_qty,gross_weight,
 gw_uom,gross_volume FROM mt_quote_commodity WHERE quote_id=:quote_id");

$statement->execute(array(
':quote_id'=>$quote_id
));
$data["commodity"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT id,email2 FROM mt_bp_contact 
  WHERE bp_id=(SELECT id FROM mt_business_partner WHERE code=:code)");
$statement->execute(array(
':code'=>$data["agent_code"]
));
$data["emails"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT id,quote_id,charge_list_id,(SELECT description FROM mt_charge_group_detail WHERE code=charge_code limit 1) charge_code,currency,ex_rate,famt,lamt,'$edit' edit FROM quote_rfq_charges_list_vendor 
where quote_id=:quote_id and charge_list_id=:id ");

$statement->execute(array(
':quote_id'=>$quote_id,
':id'=>$id
));
$data["charges"]=$statement->fetchAll(PDO::FETCH_ASSOC);

}else{
  $data["status"]=0;
  $data["msg"]="Invalid Credentials";
  $data["temp_code"]=$temp_code;
  $data["id"]=$id;
  $data["quote_id"]=$quote_id;
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



}
?>