<?php


require("../config/dbconn.php");

class StageBarDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_stagebar_info_bydocno($doctype,$docno)
{
$data=array();
try
{
$db = Factory::getConnection();

if($doctype=="QUOTE")
{
  //QUOTE
  $statement = $db->prepare("SELECT id,quote_no,status from mt_quote_list 
  WHERE quote_no=:quote_no ");
  $statement->execute(array(':quote_no'=>$docno));
  $qlist=$statement->fetchAll(PDO::FETCH_ASSOC);  

    $data["quote_id"]=$qlist[0]["id"];
    $data["quote_no"]=$qlist[0]["quote_no"];
    $data["quote_status"]=$qlist[0]["status"];

  //JOB
  $statement = $db->prepare("SELECT id,order_no,status from mt_order_entry
  WHERE quote=:quote_no ");
  $statement->execute(array(':quote_no'=>$docno));
  $job_list=$statement->fetchAll(PDO::FETCH_ASSOC);
  $order_no='';
  $data["order_id"]='';
  $data["order_no"]='';
  $data["order_status"]='';
  if(count($job_list)>=1)
  {   
  $order_no=$job_list[0]["order_no"];
  $data["order_no"]=$order_no;
  $data["order_status"]=$job_list[0]["status"];
  $data["order_id"]=$job_list[0]["id"];
  }

  //MANIFEST
  $statement = $db->prepare("SELECT id,bl_no,status from mt_manifest_entry
  WHERE order_no=:order_no ");
  $statement->execute(array(':order_no'=>$order_no));
  $manifest_list=$statement->fetchAll(PDO::FETCH_ASSOC);  
  $bl_no='';
  $data["bl_id"]='';
  $data["bl_no"]='';
  $data["bl_status"]='';
  if(count($manifest_list)>=1)
  {   
  $bl_no=$manifest_list[0]["bl_no"];
  $data["bl_no"]=$bl_no;
  $data["bl_status"]=$manifest_list[0]["status"];
  $data["bl_id"]=$manifest_list[0]["id"];
  }

  //INVOICE
  $statement = $db->prepare("SELECT id, sub_ar_doc_number doc_no,
        case when sub_ar_status='P' then
    'POSTED'
    else
      sub_ar_status
    end as status from mt_order_ar_header 
  WHERE bl_no=:bl_no ");
  $statement->execute(array(':bl_no'=>$bl_no));
  $invoice_list=$statement->fetchAll(PDO::FETCH_ASSOC);
  $data["invoice_id"]='';
  $data["invoice_no"]='';
  $data["invoice_status"]='';
  if(count($invoice_list)>=1)
  {
    $data["invoice_id"]=$invoice_list[0]["id"];
    $data["invoice_no"]=$invoice_list[0]["doc_no"];
    $data["invoice_status"]=$invoice_list[0]["status"];
  }      

}
else if($doctype=="JOB")
{
  //JOB
  $statement = $db->prepare("SELECT id,order_no,status,quote from mt_order_entry
  WHERE order_no=:order_no ");
  $statement->execute(array(':order_no'=>$docno));
  $job_list=$statement->fetchAll(PDO::FETCH_ASSOC);
  $quote_no=$job_list[0]["quote"];
  $order_no=$job_list[0]["order_no"];
  $data["order_no"]=$order_no;
  $data["order_status"]=$job_list[0]["status"];
  $data["order_id"]=$job_list[0]["id"];

  //QUOTE
  $statement = $db->prepare("SELECT id,quote_no,status from mt_quote_list 
  WHERE quote_no=:quote_no ");
  $statement->execute(array(':quote_no'=>$quote_no));
  $qlist=$statement->fetchAll(PDO::FETCH_ASSOC);  
  $data["quote_id"]='';
  $data["quote_no"]='';
  $data["quote_status"]='';
  if(count($qlist)>=1)
  {   
  $data["quote_no"]=$quote_no;
  $data["quote_status"]=$qlist[0]["status"];
  $data["quote_id"]=$qlist[0]["id"];
  }

  //MANIFEST
  $statement = $db->prepare("SELECT id,bl_no,status from mt_manifest_entry
  WHERE order_no=:order_no ");
  $statement->execute(array(':order_no'=>$order_no));
  $manifest_list=$statement->fetchAll(PDO::FETCH_ASSOC);  
  $bl_no='';
  $data["bl_id"]='';
  $data["bl_no"]='';
  $data["bl_status"]='';
  if(count($manifest_list)>=1)
  {   
  $bl_no=$manifest_list[0]["bl_no"];
  $data["bl_no"]=$bl_no;
  $data["bl_status"]=$manifest_list[0]["status"];
  $data["bl_id"]=$manifest_list[0]["id"];
  }

  //INVOICE
  $statement = $db->prepare("SELECT id, sub_ar_doc_number doc_no,
    case when sub_ar_status='P' then
    'POSTED'
    else
      sub_ar_status
    end as status from mt_order_ar_header
  WHERE bl_no=:bl_no ");
  $statement->execute(array(':bl_no'=>$bl_no));
  $invoice_list=$statement->fetchAll(PDO::FETCH_ASSOC);
  $data["invoice_id"]='';
  $data["invoice_no"]='';
  $data["invoice_status"]='';
  if(count($invoice_list)>=1)
  {
    $data["invoice_id"]=$invoice_list[0]["id"];
    $data["invoice_no"]=$invoice_list[0]["doc_no"];
    $data["invoice_status"]=$invoice_list[0]["status"];
  }   

}
else if($doctype=="MANIFEST")
{
  //MANIFEST
  $statement = $db->prepare("SELECT id,bl_no,status,order_no from mt_manifest_entry
  WHERE bl_no=:bl_no ");
  $statement->execute(array(':bl_no'=>$docno));
  $manifest_list=$statement->fetchAll(PDO::FETCH_ASSOC);  
  $order_no=$manifest_list[0]["order_no"];
  $bl_no=$manifest_list[0]["bl_no"];
  $data["bl_no"]=$bl_no;
  $data["bl_status"]=$manifest_list[0]["status"];
  $data["bl_id"]=$manifest_list[0]["id"];

  //JOB
  $statement = $db->prepare("SELECT id,order_no,status,quote from mt_order_entry
  WHERE order_no=:order_no ");
  $statement->execute(array(':order_no'=>$order_no));
  $job_list=$statement->fetchAll(PDO::FETCH_ASSOC);
  $quote_no='';  
  $data["order_id"]='';
  $data["order_no"]='';
  $data["order_status"]='';
  if(count($job_list)>=1)
  {   
  $quote_no=$job_list[0]["quote"];
  $data["order_no"]=$order_no;
  $data["order_status"]=$job_list[0]["status"];
  $data["order_id"]=$job_list[0]["id"];
  }
      
  //QUOTE
  $statement = $db->prepare("SELECT id,quote_no,status from mt_quote_list 
  WHERE quote_no=:quote_no ");
  $statement->execute(array(':quote_no'=>$quote_no));
  $qlist=$statement->fetchAll(PDO::FETCH_ASSOC);  
  $data["quote_id"]='';
  $data["quote_no"]='';
  $data["quote_status"]='';
  if(count($qlist)>=1)
  {   
  $data["quote_no"]=$quote_no;
  $data["quote_status"]=$qlist[0]["status"];
  $data["quote_id"]=$qlist[0]["id"];
  }

  //INVOICE
  $statement = $db->prepare("SELECT id, sub_ar_doc_number doc_no,
        case when sub_ar_status='P' then
    'POSTED'
    else
      sub_ar_status
    end as status from mt_order_ar_header 
  WHERE bl_no=:bl_no ");
  $statement->execute(array(':bl_no'=>$bl_no));
  $invoice_list=$statement->fetchAll(PDO::FETCH_ASSOC);
  $data["invoice_id"]='';
  $data["invoice_no"]='';
  $data["invoice_status"]='';
  if(count($invoice_list)>=1)
  {
    $data["invoice_id"]=$invoice_list[0]["id"];
    $data["invoice_no"]=$invoice_list[0]["doc_no"];
    $data["invoice_status"]=$invoice_list[0]["status"];
  }   

}
else if($doctype=="INVOICE")
{
  //INVOICE
  $statement = $db->prepare("SELECT id, sub_ar_doc_number doc_no, bl_no, 
        case when sub_ar_status='P' then
    'POSTED'
    else
      sub_ar_status
    end as status from mt_order_ar_header 
  WHERE sub_ar_doc_number=:sub_ar_doc_number ");
  $statement->execute(array(':sub_ar_doc_number'=>$docno));
  $invoice_list=$statement->fetchAll(PDO::FETCH_ASSOC);
  $bl_no=$invoice_list[0]["bl_no"];
  $data["invoice_id"]=$invoice_list[0]["id"];
  $data["invoice_no"]=$invoice_list[0]["doc_no"];
  $data["invoice_status"]=$invoice_list[0]["status"];

  $statement = $db->prepare("SELECT id, sub_ar_doc_number doc_no, bl_no, 
        case when sub_ar_status='P' then
    'POSTED'
    else
      sub_ar_status
    end as status from mt_order_ar_header 
  WHERE bl_no in (select bl_no from mt_order_ar_header where sub_ar_doc_number=:sub_ar_doc_number) ");
  $statement->execute(array(':sub_ar_doc_number'=>$docno));
  $invds_list=$statement->fetchAll(PDO::FETCH_ASSOC);
  $data["invds"]=$invds_list;

  //MANIFEST
  $statement = $db->prepare("SELECT id,bl_no,status,order_no from mt_manifest_entry
  WHERE bl_no=:bl_no ");
  $statement->execute(array(':bl_no'=>$bl_no));
  $manifest_list=$statement->fetchAll(PDO::FETCH_ASSOC); 
  $order_no=''; 
  $data["bl_id"]='';
  $data["bl_no"]='';
  $data["bl_status"]='';
  if(count($manifest_list)>=1)
  {   
  $order_no=$manifest_list[0]["order_no"];
  $data["bl_no"]=$bl_no;
  $data["bl_status"]=$manifest_list[0]["status"];
  $data["bl_id"]=$manifest_list[0]["id"];
  }

  //JOB
  $statement = $db->prepare("SELECT id,order_no,status,quote from mt_order_entry
  WHERE order_no=:order_no ");
  $statement->execute(array(':order_no'=>$order_no));
  $job_list=$statement->fetchAll(PDO::FETCH_ASSOC);
  $quote_no='';  
  $data["order_id"]='';
  $data["order_no"]='';
  $data["order_status"]='';
  if(count($job_list)>=1)
  {   
  $quote_no=$job_list[0]["quote"];
  $data["order_no"]=$order_no;
  $data["order_status"]=$job_list[0]["status"];
  $data["order_id"]=$job_list[0]["id"];
  }

  //QUOTE
  $statement = $db->prepare("SELECT id,quote_no,status from mt_quote_list 
  WHERE quote_no=:quote_no ");
  $statement->execute(array(':quote_no'=>$quote_no));
  $qlist=$statement->fetchAll(PDO::FETCH_ASSOC);  
  $data["quote_id"]='';
  $data["quote_no"]='';
  $data["quote_status"]='';
  if(count($qlist)>=1)
  {   
  $data["quote_no"]=$quote_no;
  $data["quote_status"]=$qlist[0]["status"];
  $data["quote_id"]=$qlist[0]["id"];
  }
   
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

}

?>