<?php



require("../config/dbconn.php");
require('../settings/get-settings.php');
require('../booking/get-currency.php');

class FinanceDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function getFinancialYear()
{
//$year = ( date('m') > 4) ? date('Y') + 1 : date('Y');
$year=date('Y');
return $year;
}

public static function getFinancialPeriod($doc_date)
{

//$year = ( date('m') > 4) ? date('Y') + 1 : date('Y');
//$period=4;
//return $period;
$data=false;
try
{
$db = Factory::getConnection();

//$aq=self::getRestrictionQuery($dev);
//$doc_date="2019-12-15";
$date=date_create($doc_date);
$m= date_format($date,"F");
$y= date_format($date,"Y");

$statement = $db->prepare("SELECT enumber from mt_period 
  where period=:period and year=:year and open_max='OPEN'");

$statement->execute(array(':period'=>$m,':year'=>$y));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
//var_dump($statement->debugDumpParams());
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  $p=-10;
  if(count($data)==1)
  {
    $p=$data[0]["enumber"];
  }
  return $p;
}

public static function exec_delete_payable_queries($db,$query,$doc_no)
{
$status=0;
$statement = $db->prepare($query);
$statement->execute(array(':doc_no'=>$doc_no));
  
if ($statement->rowCount()){
  $status=1;
} else{
  $status=0;
}

return $status;

}


public static function delete_payable($db,$doc_no)
{

$data=array();
//q1
$query1="DELETE FROM mt_ap_header WHERE aph_document_number=:doc_no";
$data["del_status"]=self::exec_delete_payable_queries($db,$query1,$doc_no);

//q2
$query1="DELETE FROM mt_ap_trans WHERE apt_number=:doc_no";
$data["del_ap_trans"]=self::exec_delete_payable_queries($db,$query1,$doc_no);

//q3
$query1="DELETE FROM mt_ar_trans WHERE art_number=:doc_no";
$data["del_ar_trans"]=self::exec_delete_payable_queries($db,$query1,$doc_no);

//q4
$query1="DELETE FROM mt_ship_trans WHERE st_doc_number=:doc_no";
$data["del_ship_trans"]=self::exec_delete_payable_queries($db,$query1,$doc_no);


//q5
$query1="DELETE FROM mt_order_trans WHERE ordt_doc_number=:doc_no";
$data["del_order_trans"]=self::exec_delete_payable_queries($db,$query1,$doc_no);

//q6
$query1="DELETE FROM mt_ap_allocation_details WHERE aloc_doc_number=:doc_no";
$data["del_allocation"]=self::exec_delete_payable_queries($db,$query1,$doc_no);

//q7
$query1="DELETE FROM mt_cost_center WHERE cost_glt_number=:doc_no";
$data["del_cost_center"]=self::exec_delete_payable_queries($db,$query1,$doc_no);

//q8
$query1="DELETE FROM mt_ar_trans_balance WHERE ardm_doc_number=:doc_no";
$data["del_ar_trans_balance"]=self::exec_delete_payable_queries($db,$query1,$doc_no);

//q9
$query1="DELETE FROM mt_ap_gl_details WHERE pre_glt_doc_number=:doc_no";
$data["del_gl"]=self::exec_delete_payable_queries($db,$query1,$doc_no);


//q10
$query1="DELETE FROM mt_ap_trans_balance WHERE apdm_doc_number=:doc_no";
$data["del_ap_trans_balance"]=self::exec_delete_payable_queries($db,$query1,$doc_no);

return $data;


}

public static function get_matching($db,$doc_no)
{

$statement = $db->prepare("SELECT 2 FROM mt_ar_match_details
 WHERE (arm_t_number =:doc_no or arm_m_number=:doc_no) and 
 arm_status in ('PENDING','COMPLETED')
 UNION
 SELECT 2 FROM mt_ap_match_details
 WHERE (apm_t_number =:doc_no or apm_m_number=:doc_no) and 
 apm_status in ('PENDING','COMPLETED')
 UNION
 SELECT 2 FROM mt_arap_match_details
 WHERE (arm_t_number =:doc_no or arm_m_number=:doc_no) and 
 arm_status in ('PENDING','COMPLETED')
 ");
$statement->execute(array(
  ':doc_no'=>$doc_no));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

return $op;
}


//edit payable voucher

public static function edit_voucher_preparation_payable($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();
$dno=$c->info->doc_no;

$op=self::get_matching($db,$dno);
if(count($op)>=1)
{
  $data["status"]=0;
  $data["msg"]="Unable to edit. Voucher already matched. Please unmatch and then try to edit";
}else{

$output=self::delete_payable($db,$dno);
$data["del"]=$output;
$op_status=0;
if($output["del_status"]==1 && $output["del_ap_trans"]==1 && $output["del_allocation"]==1 && $output["del_gl"]==1)
{
$op_status=1;
}
if($op_status==0)
{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to delete old data. Please try again.";

}else{


$info=$c->info;
$vpds=$c->vpd;
$h=$vpds[0];

$customer_code=$h->add_info->customer_name;

$tds_todo=true;
$tds_todo=getTDSApplicable($dev->location,$dev->company);

//SET VALUES TO TDS/GST QUERY VARIABLES
$tds_percent=0;
$tds_desc=$h->narration;
$doc_no="";

//EXCLUDE GST for OFRT
$exclude_amt=0;
$with_ofrt_total_amt=0;

for($i=0;$i<count($vpds);$i++)
{
 $nrow=$vpds[$i];
 if($nrow->allocation=="SHIP")
 {
    $ai=$nrow->add_info;
    if($ai->activity!='OFRT')
    {
      $exclude_amt+=$nrow->local_amt_dr;
    }
    $with_ofrt_total_amt+=$nrow->local_amt_dr;
 }
}


$c->trx_date=$info->doc_date;
$c->doc_type=$info->doc_type;
$c->voucher_type=$h->voucher_type;
$c->tds=0;
$c->tds_appl_amt=$h->tds_amt;
$c->tds_appl_after_deduction=0;
$c->gst_percent=0;
$c->order_no="";
$c->ref_inv_no=$h->ref;
$c->ref_inv_date=$h->ref_date;
$c->trx_date=$info->doc_date;

$c->gst_percent=$h->gst;
$c->narration=$h->narration;
$c->collection_by="";
$c->file_id="";
$c->customer_name=$h->add_info->customer_name;

//PAYABLE VOUCHER under CREDIT entry
//PAYMENT under DEBIT entry

//CALCULATE tds_appl_after_deduction
if($c->tds_appl_amt!=0){
  //$c->tds_appl_after_deduction=($c->tds_appl_amt-$c->deduction);
  $c->tds_appl_after_deduction=$c->tds_appl_amt;
}else{
  $c->tds_appl_after_deduction=0;
}

//CALCULATE amount_after_deduction
//$c->amount_after_deduction=($c->amount-$c->deduction);
$c->amount_after_deduction=$exclude_amt;

//CALCULATE GST
$statement = $db->prepare("SELECT pan,gstin,tds_deductee_type from mt_business_partner 
  where code=:customer_code ");
$statement->execute(array(':customer_code'=>$customer_code));
$cdata=$statement->fetchAll(PDO::FETCH_ASSOC);
$billparty_gstin=$cdata[0]["gstin"];
$billparty_pan=$cdata[0]["pan"];
$tds_deductee_type=$cdata[0]["tds_deductee_type"];

$startString=getGSTINStartString($dev);

$len = strlen($startString);

if(substr($billparty_gstin, 0, $len)==$startString)
{
  $tp=$c->gst_percent/2;
  $tv=($c->amount_after_deduction*$tp)/100;
  $c->cgst=round($tv,2);
  $c->sgst=round($tv,2);
  $c->igst=0;
}else{
  $c->igst=round(($c->amount_after_deduction*$c->gst_percent)/100,2);
  $c->cgst=0;
  $c->sgst=0;  
}

//echo $exclude_amt;
// echo $c->igst;
// echo $c->cgst;
// echo $c->sgst;
// echo $c->amount_after_deduction;
// echo $c->gst_percent;
// echo $c->tds_appl_after_deduction;

//CALCULATE TDS
if($c->tds_appl_after_deduction!=0){

  //CHECK IF SPECIAL TDS EXISTS
  $statement = $db->prepare("SELECT lower_tax_tds 
  FROM mt_bp_tds_rate t1
  left join mt_business_partner t2
  on t1.bp_id=t2.id 
  where t2.code=:customer_code 
  and :ref_inv_date between t1.applicable_from and t1.applicable_to ");
  $statement->execute(array(':customer_code'=>$customer_code,':ref_inv_date'=>$c->ref_inv_date));
  $sp_tdsdata=$statement->fetchAll(PDO::FETCH_ASSOC);

  if ($statement->rowCount()){
      $tds_percent=$sp_tdsdata[0]["lower_tax_tds"];
  }
  //echo $tds_percent;

  $statement = $db->prepare("SELECT 
  case when :deductee_type='P' or :deductee_type='H' THEN
  t1.p_or_h
  ELSE
  t1.others
  end as 'tds_percent',t2.ac_description 
  FROM mt_tds_master t1
  left join mt_ledger_tds_link_master t2
  on t1.section=t2.section 
  where :ref_inv_date between t1.applicable_from and t1.applicable_to ");
  $statement->execute(array(':deductee_type'=>$tds_deductee_type,':ref_inv_date'=>$c->ref_inv_date));
  $tdsdata=$statement->fetchAll(PDO::FETCH_ASSOC);
  //ASSIGN IF SPECIAL RATE NOT EXISTS
  if($tds_percent==0){
    $tds_percent=$tdsdata[0]["tds_percent"];
  }
  //echo $tds_percent;
  //$ac_description=$tdsdata[0]["ac_description"];

  //ROUND TDS DECIMAL ZERO
  $c->tds=round(($c->tds_appl_after_deduction*$tds_percent)/100,2);

}else{
  $c->tds=0;
}
//END TDS CALC

  $c->total=$with_ofrt_total_amt+$c->cgst+$c->sgst+$c->igst;
  

$temp_code=uniqid($dev->uid);
$statement = $db->prepare("SELECT limit_amount,credit_days from mt_bp_credit where account_type in('ACCOUNTS PAYABLE','BOTH') and bp_id=(SELECT id from mt_business_partner 
  where code=:customer_code)");
$statement->execute(array(':customer_code'=>$customer_code));
$cls=$statement->fetchAll(PDO::FETCH_ASSOC);

$due_date=date('Y-m-d');
$lc=0;
if(count($cls)==1)
{
$due_date= date('Y-m-d', strtotime("+".$cls[0]["credit_days"]." day", strtotime($info->doc_date)));
$lc=$cls[0]["limit_amount"];
}


$statement = $db->prepare("INSERT into mt_ap_header 
(aph_company,aph_code,aph_group,aph_document_base,aph_document_type,aph_limit_base,aph_document_date,aph_gl_date,aph_due_date,aph_other_reference,aph_currency,aph_exchange_rate,aph_foreign_amount,aph_local_amount,aph_narration,aph_post_date,aph_status,aph_notes,aph_loc_reference,
  ref_inv_no, ref_inv_date, collection_by,exl_upd_pk,
  ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id,child) 
VALUES
( :company,:customer_code,'ACCOUNTS PAYABLE',:voucher_type,:doc_type,
  :limit_amount,
  :doc_date,:doc_date,:due_date,:ref,'INR',1,:base_amt_dr,:local_amt_dr,:narration,:doc_date,'POSTED','',:ref_date,
    :ref_inv_no, :ref_inv_date, :collection_by,:exl_upd_pk,
  :ip ,:created_by ,:ua ,:ekey,now(),:temp_code,:company_id,:location_id,:child) ");


$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company'=>$dev->company,
':customer_code'=>$customer_code,
':voucher_type'=>$c->voucher_type,
':doc_type'=>$c->doc_type,

':limit_amount'=>$lc,
':doc_date'=>$c->trx_date,
':due_date'=>$due_date,
':ref'=>$c->order_no,
':ref_date'=>$c->trx_date,
':base_amt_dr'=>$c->total,
':local_amt_dr'=>$c->total,
':narration'=>$c->narration,

':ref_inv_no'=>$c->ref_inv_no,
':ref_inv_date'=>$c->ref_inv_date,
':collection_by'=>$c->collection_by,
':exl_upd_pk'=>$c->file_id,

':temp_code'=>$temp_code,
':company_id'=>$dev->company,
':location_id'=>$dev->location,

':child'=>json_encode($vpds)
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}
$data["temp_code"]=$temp_code;


$statement = $db->prepare("SELECT id from mt_ap_header where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

//set doc number

//$fid=self::setFourDigit($op[0]["id"]);
//$aphid=$fid;
$vtype="";

if($info->doc_type=="GENERAL INVOICE")
{
  $vtype="PGN";
}else if($info->doc_type=="DEBIT NOTE")
{
  $vtype="PDN";
}else if($info->doc_type=="CREDIT NOTE")
{
  $vtype="PCN";
}

//$fid=self::generate_voucher_no1($db,$dev,$vtype,$temp_code);
//$fid=self::setFourDigit($fid);
//$fid1=$fid;

//$on=$vtype."/".date("Y")."/".date('m')."/".$fid;
$on=$dno;
 $statement = $db->prepare("UPDATE mt_ap_header 
  SET aph_document_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["docid_status"]=1;
  } else{
    $data["docid_status"]=0;
  }

$data["doc_no"]=$on;

$doc_no=$on;

//exclude header in child table
//query 2
$child_ar_count=0;
$child_ar_status_count=0;
$child_ap_count=0;
$child_ap_status_count=0;
$child_ar_ship_count=0;
$child_ar_ship_status_count=0;
$child_ar_order_count=0;
$child_ar_order_status_count=0;
$child_ar_cc_count=0;
$child_ar_cc_status_count=0;

$child_apd_status_count=0;

for($i=1;$i<count($vpds);$i++)
{

$r=$vpds[$i];

//for credit note, child should be "credit" amount
if ($info->doc_type=="CREDIT NOTE")
{
  $r->base_amt_dr=$r->base_amt_cr*(-1);
  $r->local_amt_dr=$r->local_amt_cr*(-1);
}



$temp_code=uniqid($dev->uid);
$q="";
$qv="";
if($r->allocation=="ACCOUNTS PAYABLE")
{
  $child_ap_count+=1;
  $ai=$r->add_info; 
  $q="ap_customer,ap_activity,ap_cust_address";
  $qv="'$ai->customer_name','$ai->activity','$ai->customer_address'";

//addition query 1

/*QUERY 1*/
$statement = $db->prepare("INSERT into mt_ap_trans 
(apt_company,apt_code,apt_type,apt_number,apt_serial,apt_group,
apt_base_type,apt_internal,apt_other_reference,apt_doc_date,
apt_gl_date,apt_year,apt_period,apt_age_date,
apt_dp_date,apt_currency,apt_ex_rate,apt_foreign_amount,
apt_local_amount,apt_foreign_balance,
apt_local_balance,apt_balance_status,
apt_description,apt_notes,
ip,created_by ,ua,ekey,created_date,temp_code,
company_id,location_id)
VALUES
(:company,:arh_code,:doc_type,:doc_no,'$i','PAYABLE','PAYABLE VOUCHER',0,'',:doc_date,:doc_date,".self::getFinancialYear().",
".self::getFinancialPeriod($info->doc_date).",:doc_date,:doc_date,:currency,:ex_rate,:base_amt_dr,:local_amt_dr,:base_amt_dr,
:local_amt_dr,'A',:narration,:reference,:ip,:created_by,
:ua,:ekey,now(),:temp_code,'$dev->company','$dev->location')");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code,
//
':company'=>$dev->company,
':arh_code'=>$ai->customer_name,
':doc_type'=>$info->doc_type,
':doc_no'=>$doc_no,
':doc_date'=>$info->doc_date,

':base_amt_dr'=>$r->base_amt_dr,
':local_amt_dr'=>$r->local_amt_dr,
':narration'=>$r->narration,
':currency'=>$r->currency,
':ex_rate'=>$r->ex_rate,

':reference'=>$r->ref

));

 if ($statement->rowCount()){
    $child_ap_status_count+=1;
    $data["ap_ap_status".($i+1)]=1;
  } else{
    $data["ap_ap_status".($i+1)]=0;
  }
/* QUERY 1 ENDS */
}

if($r->allocation=="ACCOUNTS RECEIVABLE")
{
  $child_ar_count+=1;
  $ai=$r->add_info;
  $q="ap_customer,ap_activity,ap_cust_address";
  $qv="'$ai->customer_name','$ai->activity','$ai->customer_address'";

//addition query 1

/*QUERY 1*/

$statement = $db->prepare("INSERT into mt_ar_trans 
(art_company,art_code,art_type,art_number,art_serial,art_group,
art_base_type,art_internal,art_other_reference,art_doc_date,
art_gl_date,art_year,art_period,art_age_date,
art_dp_date,art_currency,art_ex_rate,art_foreign_amount,
art_local_amount,art_foreign_balance,
art_local_balance,art_balance_status,
art_description,art_notes,
ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id)
VALUES
(:company,:arh_code,:doc_type,:doc_no,'$i','RECEIVABLE',:voucher_type,'$i','',:doc_date,:doc_date,".self::getFinancialYear().",
".self::getFinancialPeriod($info->doc_date).",:doc_date,:doc_date,:currency,:ex_rate,:base_amt_cr,:local_amt_cr,:base_amt_cr,
:local_amt_cr,'A',:narration,:reference,:ip,:created_by,:ua,:ekey,
  now(),:temp_code,'$dev->company','$dev->location')");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code,

':company'=>$dev->company,
':arh_code'=>$ai->customer_name,
':voucher_type'=>$r->voucher_type,
':doc_type'=>$info->doc_type,
':doc_no'=>$doc_no,
':doc_date'=>$info->doc_date,

':base_amt_cr'=>$r->base_amt_dr,
':local_amt_cr'=>$r->local_amt_dr,
':narration'=>$r->narration,
':currency'=>$r->currency,
':ex_rate'=>$r->ex_rate,

':reference'=>$r->ref

));

 if ($statement->rowCount()){
    $child_ar_status_count+=1;
    $data["aq_status".($i+1)]=1;
  } else{
    $data["aq_status".($i+1)]=0;
  }

/*QUERY 2*/


//end of additional query
}

$fy=self::getFinancialYear();
$fp=self::getFinancialPeriod($info->doc_date);

if($r->allocation=="SHIP")
{
  $child_ar_ship_count+=1;
  $ai=$r->add_info;
  /*
  $q="voyage,vessel,liner,bl_no,ship_activity";
  $qv="'$ai->voyage','$ai->vessel','$ai->liner',
  '$ai->bl_no','$ai->activity'";
  */

    $q="aloc_detail_1,
    ref_inv_no,ref_inv_date,
    aloc_detail_2,aloc_detail_6,
    aloc_detail_7,aloc_detail_8,
    aloc_detail_4,aloc_detail_3,
    aloc_detail_5,
    expense_gl";

  $qv="(
  IFNULL((SELECT expense_gl from mt_charge_group_detail 
  where code='$ai->activity'),(SELECT gl_payable_pdc from mt_gl_link where name= (select liner from mt_voyage where voyage='$ai->voyage')))
  ),
  '$c->ref_inv_no','$c->ref_inv_date',
  '$customer_code','$ai->vessel',
  '$ai->voyage','$ai->liner',
  '$ai->bl_no','$ai->activity',(
  IFNULL((SELECT expense_gl from mt_charge_group_detail 
  where code='$ai->activity'),(SELECT gl_payable_pdc from mt_gl_link where name= (select liner from mt_voyage where voyage='$ai->voyage')))
  ), 
  (
  IFNULL((SELECT expense_gl from mt_charge_group_detail 
  where code='$ai->activity'),(SELECT gl_payable_pdc from mt_gl_link where name= (select liner from mt_voyage where voyage='$ai->voyage')))
  )";
/*
(select voyage from mt_manifest_entry where bl_no='$ai->bl_no')
*/
  
 //insert in the ship trans
$statement = $db->prepare("INSERT into mt_ship_trans
( st_company,st_doc_type,st_doc_number,st_serial,st_doc_base,st_date,st_gl_date,st_dp_date,st_age_date,st_year,st_period,st_carrier,st_vessel,st_voyage,st_port,st_bl,st_bl_type,st_charge,st_other_reference,st_currency,st_exchange,st_foreign,st_local,st_narration,st_status,
  st_posted_on,
  ip,created_by ,ua,ekey,created_date,temp_code) 
  VALUES
('$dev->company','$info->doc_type','$on','1','$info->voucher_type','$info->doc_date','$info->doc_date',
  '$info->doc_date','$info->doc_date','$fy','$fp','$ai->liner',
  '$ai->vessel','$ai->voyage','','$ai->bl_no',
  '','$ai->activity',(SELECT order_no from mt_manifest_entry where bl_no='$ai->bl_no' limit 1),'$h->currency',
  '$h->ex_rate','$r->base_amt_dr',
  '$r->local_amt_dr',:narration,
  'P',now(),
  '$dev->ip',
  '$dev->username','$dev->ua',
  '$dev->ekey',now(),'$temp_code')");

$statement->execute(array(':narration'=>$r->narration));
if ($statement->rowCount()){
  $child_ar_ship_status_count+=1;
  $data["ship_trans_status-".($i+1)]=1;
} else{
  $data["ship_trans_status-".($i+1)]=0;
}
  

}

if($r->allocation=="ORDER")
{
  $child_ar_order_count+=1;
  $ai=$r->add_info;

     $q="aloc_detail_1,aloc_detail_2,aloc_detail_3,expense_gl";

  $qv="'$ai->order_type','$ai->order_no','$ai->activity',(SELECT order_income_gl from mt_charge_group_detail 
  where code='$ai->activity')";

  
  //insert in the ship trans
$statement = $db->prepare("INSERT into mt_order_trans
( ordt_company,ordt_doc_type,ordt_doc_number,ordt_serial,ordt_doc_base,ordt_doc_date,ordt_gl_date,ordt_dp_date,ordt_age_date,ordt_year,ordt_period,ordt_carrier,ordt_vessel,ordt_voyage,ordt_port,ordt_bl,ordt_bl_type,ordt_charge,ordt_other_reference,ordt_currency,ordt_ex_rate,ordt_foreign_amount,ordt_local_amount,ordt_narration,ordt_status,
ordt_posted_on,
  ip,created_by ,ua,ekey,created_date,temp_code,ordt_code) 
VALUES
('$dev->company','$info->doc_type','$on','1','$info->voucher_type',
  '$info->doc_date',
 '$info->doc_date',
 '$info->doc_date','$info->doc_date','$fy','$fp','liner',
 'vessel','voyage','port','bl_no',
 '$ai->order_type','$ai->activity','$ai->order_no',
 '$r->currency','$r->ex_rate','$r->base_amt_dr',
  '$r->local_amt_dr',:narration,
  'P',now(),
  '$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code',(SELECT customer FROM mt_order_entry WHERE order_no='$ai->order_no' limit 1))");
$statement->execute(array(':narration'=>$r->narration));
  if ($statement->rowCount()){
  $child_ar_order_status_count+=1;
  $data["ord_trans_status-".($i+1)]=1;
} else{
  $data["ord_trans_status-".($i+1)]=0;
}

}

if($r->allocation=="ASSETS")
{
  $ai=$r->add_info;
  $q="expense_gl,aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->assets','$ai->assets', '$ai->gl_group_name', '$r->cost_center'";
}

if($r->allocation=="EXPENSES")
{
  $ai=$r->add_info;
  $q="expense_gl,aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->expense','$ai->expense', '$ai->gl_group_name', '$r->cost_center'";
}
if($r->base_amt_cr=="")
{
  $r->base_amt_cr=null;
}
if($r->local_amt_cr=="")
{
  $r->local_amt_cr=null;
}

if($r->ex_rate=="")
{
  $r->ex_rate=null;
}

$statement = $db->prepare("INSERT into mt_ap_allocation_details 
(aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,aloc_foreign_amount,aloc_local_amount,
  aloc_narration,aloc_currency,aloc_ex_rate,
  reference,ref_date,
  $q,
ip,created_by ,ua,ekey,created_date,temp_code)
VALUES
(:company,:voucher_type,:doc_type,:doc_no,:allocation,
  :base_amt_cr,:local_amt_cr,
  :narration,:currency,:ex_rate,
:reference,:ref_date,
$qv,
  :ip ,:created_by ,:ua ,:ekey,now(),:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code,

':company'=>$dev->company,
':voucher_type'=>$r->voucher_type,
':doc_type'=>$info->doc_type,
':doc_no'=>$doc_no,

':allocation'=>$r->allocation,
':base_amt_cr'=>$r->base_amt_dr*(-1),
':local_amt_cr'=>$r->local_amt_dr*(-1),
':narration'=>$r->narration,
':currency'=>$r->currency,
':ex_rate'=>$r->ex_rate,

':reference'=>$r->ref,
':ref_date'=>$r->ref_date

));

if ($statement->rowCount()){
  $child_apd_status_count+=1;
  $data["ahd_status-".($i+1)]=1;
} else{
  $data["ahd_status-".($i+1)]=0;
}

//query - cost center
if($r->cost_center!="")
{
  $child_ar_cc_count+=1;
  $statement = $db->prepare("INSERT INTO mt_cost_center
  (cost_gl_code, cost_glt_company, cost_glt_doc_base, cost_glt_doc_type, cost_glt_number,  cost_glt_doc_date, cost_glt_gl_date, cost_glt_other_reference,  cost_glt_currency,  cost_glt_ex_rate,  
    cost_glt_foreign_amount, cost_glt_local_amount, cost_glt_narration,  cost_glt_aloc_type, 
  ip,  ua,  ekey,  created_by,  created_date)
  VALUES
  (:cost_gl_code, :company, :voucher_type, :doc_type, :doc_no, :doc_date, :gl_date,
    :ref, :currency, :ex_rate, 
    :base_amt_cr, :local_amt_cr,  :narration, :allocation,
    :ip, :ua, :ekey, :created_by, now()) ");

  $statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
  ':ua'=>$dev->ua,
  ':ekey'=>$dev->ekey,

  ':cost_gl_code'=>$r->cost_center,
  ':company'=>$dev->company,
  ':voucher_type'=>$r->voucher_type,
  ':doc_type'=>$info->doc_type,
  ':doc_no'=>$doc_no,
  ':doc_date'=>$info->doc_date,
  ':gl_date'=>$info->doc_date,

  ':ref'=>$r->ref,
  ':currency'=>$r->currency,
  ':ex_rate'=>$r->ex_rate,
  ':base_amt_cr'=>$r->base_amt_dr,
  ':local_amt_cr'=>$r->local_amt_dr,
  ':narration'=>$r->narration,
  ':allocation'=>$r->allocation

  ));

  if ($statement->rowCount()){
    $child_ar_cc_status_count+=1;
    $data["cc_status"]=1;
  } else{
    $data["cc_status"]=0;
  }
}
//query - cost center ends

}
//query 2 ends

if ($c->doc_type=="DEBIT NOTE"){
  
  $c->cgst=$c->cgst*(-1);
  $c->sgst=$c->sgst*(-1);
  $c->igst=$c->igst*(-1);
  $c->tds=$c->tds*(-1);
}else if ($c->doc_type=="CREDIT NOTE"){
  
  $c->cgst=$c->cgst;
  $c->sgst=$c->sgst;
  $c->igst=$c->igst;
  $c->tds=$c->tds;
}

//cgst 2
//INPUT CGST 2-30-001-0001

if($c->cgst!=0){
  $statement = $db->prepare("INSERT into mt_ap_allocation_details 
  (aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,aloc_foreign_amount,aloc_local_amount,
    aloc_narration,aloc_currency,aloc_ex_rate,
    reference,ref_date,
    ref_inv_no, ref_inv_date,order_no,
    aloc_detail_1,aloc_detail_2,aloc_detail_3, 
    aloc_detail_5,amount_after_deduction,gst_percent,
    expense_gl,
  ip,created_by ,ua,ekey,created_date,temp_code)
  VALUES
  (:company,:voucher_type,'INPUT CGST',:doc_no,'INPUT CGST',
    :base_amt_cr,:local_amt_cr,
    :narration,'INR',1,
  :reference,:ref_date,
  :ref_inv_no, :ref_inv_date,:order_no,
  '2-30-001-0001','$c->customer_name','$c->order_no',
  '2-30-001-0001',:amount_after_deduction,:gst_percent,
  '2-30-001-0001',
    :ip ,:created_by ,:ua ,:ekey,now(),:temp_code) ");

  $statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
  ':ua'=>$dev->ua,
  ':ekey'=>$dev->ekey,
  ':temp_code'=>$temp_code,

  ':company'=>$dev->company,
  ':voucher_type'=>$c->voucher_type,
  ':doc_no'=>$doc_no,

  ':base_amt_cr'=>$c->cgst*(-1),
  ':local_amt_cr'=>$c->cgst*(-1),
  ':amount_after_deduction'=>$c->amount_after_deduction,
  ':narration'=>'INPUT CGST '.$c->gst_percent.'%',

  ':gst_percent'=>$c->gst_percent,

  ':order_no'=>$c->order_no,
  ':ref_inv_no'=>$c->ref_inv_no,
  ':ref_inv_date'=>$c->ref_inv_date,
  ':reference'=>$c->order_no,
  ':ref_date'=>$c->trx_date

  ));

  if ($statement->rowCount()){
    $data["cgst_status"]=1;
  } else{
    $data["cgst_status"]=0;
  }  
}
//cgst 2 ends

//sgst 2
//INPUT SGST 2-30-001-0005

if($c->sgst!=0){
  $statement = $db->prepare("INSERT into mt_ap_allocation_details 
  (aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,aloc_foreign_amount,aloc_local_amount,
    aloc_narration,aloc_currency,aloc_ex_rate,
    reference,ref_date,
    ref_inv_no, ref_inv_date,order_no,
    aloc_detail_1,aloc_detail_2,aloc_detail_3, 
    aloc_detail_5,amount_after_deduction,gst_percent,
    expense_gl,
  ip,created_by ,ua,ekey,created_date,temp_code)
  VALUES
  (:company,:voucher_type,'INPUT SGST',:doc_no,'INPUT SGST',
    :base_amt_cr,:local_amt_cr,
    :narration,'INR',1,
  :reference,:ref_date,
  :ref_inv_no, :ref_inv_date,:order_no,
  '2-30-001-0005','$c->customer_name','$c->order_no',
  '2-30-001-0005',:amount_after_deduction,:gst_percent,
  '2-30-001-0005',
    :ip ,:created_by ,:ua ,:ekey,now(),:temp_code) ");

  $statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
  ':ua'=>$dev->ua,
  ':ekey'=>$dev->ekey,
  ':temp_code'=>$temp_code,

  ':company'=>$dev->company,
  ':voucher_type'=>$c->voucher_type,
  ':doc_no'=>$doc_no,

  ':base_amt_cr'=>$c->sgst*(-1),
  ':local_amt_cr'=>$c->sgst*(-1),
  ':amount_after_deduction'=>$c->amount_after_deduction,
  ':narration'=>'INPUT SGST '.$c->gst_percent.'%',

  ':gst_percent'=>$c->gst_percent,

  ':order_no'=>$c->order_no,
  ':ref_inv_no'=>$c->ref_inv_no,
  ':ref_inv_date'=>$c->ref_inv_date,
  ':reference'=>$c->order_no,
  ':ref_date'=>$c->trx_date

  ));

  if ($statement->rowCount()){
    $data["sgst_status"]=1;
  } else{
    $data["sgst_status"]=0;
  }  
}
//sgst 2 ends

//igst 2
//INPUT IGST  2-30-001-0003

if($c->igst!=0){
  $statement = $db->prepare("INSERT into mt_ap_allocation_details 
  (aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,aloc_foreign_amount,aloc_local_amount,
    aloc_narration,aloc_currency,aloc_ex_rate,
    reference,ref_date,
    ref_inv_no, ref_inv_date,order_no,
    aloc_detail_1,aloc_detail_2,aloc_detail_3, 
    aloc_detail_5,amount_after_deduction,gst_percent,
    expense_gl,
  ip,created_by ,ua,ekey,created_date,temp_code)
  VALUES
  (:company,:voucher_type,'INPUT IGST',:doc_no,'INPUT IGST',
    :base_amt_cr,:local_amt_cr,
    :narration,'INR',1,
  :reference,:ref_date,
  :ref_inv_no, :ref_inv_date,:order_no,
  '2-30-001-0003','$c->customer_name','$c->order_no',
  '2-30-001-0003',:amount_after_deduction,:gst_percent,
  '2-30-001-0003',
    :ip ,:created_by ,:ua ,:ekey,now(),:temp_code) ");

  $statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
  ':ua'=>$dev->ua,
  ':ekey'=>$dev->ekey,
  ':temp_code'=>$temp_code,

  ':company'=>$dev->company,
  ':voucher_type'=>$c->voucher_type,
  ':doc_no'=>$doc_no,

  ':base_amt_cr'=>$c->igst*(-1),
  ':local_amt_cr'=>$c->igst*(-1),
  ':amount_after_deduction'=>$c->amount_after_deduction,
  ':narration'=>'INPUT IGST '.$c->gst_percent.'%',

  ':gst_percent'=>$c->gst_percent,

  ':order_no'=>$c->order_no,
  ':ref_inv_no'=>$c->ref_inv_no,
  ':ref_inv_date'=>$c->ref_inv_date,

  ':reference'=>$c->order_no,
  ':ref_date'=>$c->trx_date

  ));

  if ($statement->rowCount()){
    $data["igst_status"]=1;
  } else{
    $data["igst_status"]=0;
  }  
}
//igst 2 ends
$data["tds"]=$c->tds;
$data["tds_appl_after_deduction"]=$c->tds_appl_after_deduction;
if($tds_todo)
{
  //tdsquery 2
  //2-30-001-0031 - TDS On Contractor - 194C
  //2-30-001-0039 - TDS PAYABLE REVERSE - 194C

  $tds_lc="2-30-001-0031";
  $tds_desc="TDS PAYABLE";

  /*if ($c->doc_type=="DEBIT NOTE"){
    $tds_lc="2-30-001-0039";
    $tds_desc="TDS PAYABLE REVERSE";
  }*/

  if($c->tds!=0){
    $statement = $db->prepare("INSERT into mt_ap_allocation_details 
    (aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,aloc_foreign_amount,aloc_local_amount,
      aloc_narration,aloc_currency,aloc_ex_rate,
      reference,ref_date,
      ref_inv_no, ref_inv_date,order_no,
      aloc_detail_1,aloc_detail_2,aloc_detail_3, 
      aloc_detail_5,tds_appl_amt,tds_appl_after_deduction,gst_percent,
      expense_gl,
    ip,created_by ,ua,ekey,created_date,temp_code)
    VALUES
    (:company,:voucher_type,'$tds_desc',:doc_no,'$tds_desc',
      :base_amt_cr,:local_amt_cr,
      :narration,'INR',1,
    :reference,:ref_date,
    :ref_inv_no, :ref_inv_date,:order_no,
    '$tds_lc','$c->customer_name','$c->order_no',
    '$tds_lc',:tds_appl_amt,:tds_appl_after_deduction,:gst_percent,
    '$tds_lc',
      :ip ,:created_by ,:ua ,:ekey,now(),:temp_code) ");

    $statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
    ':ua'=>$dev->ua,
    ':ekey'=>$dev->ekey,
    ':temp_code'=>$temp_code,

    ':company'=>$dev->company,
    ':voucher_type'=>$c->voucher_type,
    ':doc_no'=>$doc_no,

    ':base_amt_cr'=>$c->tds,
    ':local_amt_cr'=>$c->tds,
    ':tds_appl_amt'=>$c->tds_appl_amt,
    ':tds_appl_after_deduction'=>$c->tds_appl_after_deduction,
    ':narration'=>$tds_desc,

    ':gst_percent'=>$c->gst_percent,

    ':order_no'=>$c->order_no,
    ':ref_inv_no'=>$c->ref_inv_no,
    ':ref_inv_date'=>$c->ref_inv_date,

    ':reference'=>$c->order_no,
    ':ref_date'=>$c->trx_date

    ));

    if ($statement->rowCount()){
      $data["tds_status"]=1;
    } else{
      $data["tds_status"]=0;
    }  
  }
}

//query 3
$statement = $db->prepare("INSERT into mt_ap_trans 
(apt_company,apt_code,apt_type,apt_number,apt_serial,apt_group,
apt_base_type,apt_internal,apt_other_reference,apt_doc_date,
apt_gl_date,apt_year,apt_period,apt_age_date,
apt_dp_date,apt_currency,apt_ex_rate,apt_foreign_amount,
apt_local_amount,apt_foreign_balance,
apt_local_balance,apt_balance_status,
apt_description,apt_notes,
ref_inv_no, ref_inv_date,order_no,
ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id)

SELECT aloc_company,aloc_detail_2,aloc_doc_type,aloc_doc_number,
1,aloc_detail_1,aloc_base_doc,0,
aloc_detail_5,'$c->trx_date',
'$c->trx_date',".self::getFinancialYear().",
".self::getFinancialPeriod($c->trx_date).",
'$c->trx_date','$c->trx_date',aloc_currency,aloc_ex_rate,
aloc_foreign_amount,aloc_local_amount,aloc_foreign_amount,
aloc_local_amount,'A',
aloc_narration,aloc_detail_3,
ref_inv_no, ref_inv_date,order_no,
ip,created_by,ua ,ekey,now(),'$temp_code',
'$dev->company','$dev->location'   
FROM mt_ap_allocation_details where aloc_doc_number=:id ");

$statement->execute(array(':id'=>$doc_no));

if ($statement->rowCount()){
  $data["ap_trans_status"]=1;
} else{
  $data["ap_trans_status"]=0;
}
//query 3 ends

//addition query starts

//AD QUERY 1
$statement = $db->prepare("INSERT into mt_ar_trans_balance
(ardm_company,ardm_code,ardm_doc_type,ardm_doc_number,
  ardm_serial,ardm_other_reference,ardm_date,ardm_currency,
  ardm_ex_rate,ardm_of_amount,ardm_ol_amount,
  ardm_bf_amount,ardm_bl_amount,
  ardm_pf_amount,ardm_pl_amount,ardm_status,
ref_inv_no, ref_inv_date,order_no,
ip,created_by,ua,ekey,created_date,temp_code,company_id,location_id)

SELECT art_company,art_code,art_type,art_number,
art_serial,art_other_reference,art_gl_date,art_currency,
art_ex_rate,art_foreign_amount,art_local_amount,
art_foreign_balance,art_local_balance,
0,0,'PENDING',
ref_inv_no, ref_inv_date,order_no,
ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location' 
 from mt_ar_trans where art_number=:doc_no");
$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
    $data["ar_tb_status"]=1;
  } else{
    $data["ar_tb_status"]=0;
  }


//query 4  

$statement = $db->prepare("INSERT into mt_ap_gl_details
(pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,
  pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,
  pre_glt_ex_rate,pre_glt_foreign_amount,
  pre_glt_local_amount,pre_glt_narration,
  pre_glt_allocation_code,pre_glt_detail_1,
  pre_glt_detail_2,pre_glt_detail_3,pre_glt_detail_4,pre_glt_detail_5,
ip,created_by ,ua,ekey,created_date,temp_code, 
location_id,company_id)
SELECT aloc_company,expense_gl,
aloc_base_doc,aloc_doc_type,
aloc_doc_number,aloc_serial,'$info->doc_date',
'$info->doc_date',".self::getFinancialYear().",".
self::getFinancialPeriod($info->doc_date).",aloc_narration,aloc_currency,
aloc_ex_rate,aloc_foreign_amount,
aloc_local_amount,aloc_narration,
aloc_allocation_type,aloc_detail_1,
aloc_detail_2,aloc_detail_3,aloc_detail_4,aloc_detail_5,
ip,created_by,ua ,ekey,now(),'$temp_code',
'$dev->company','$dev->location'   
FROM mt_ap_allocation_details where aloc_doc_number=:id
");

$statement->execute(array(':id'=>$doc_no));

if ($statement->rowCount()){
  $data["ah_gl_status2"]=1;
} else{
  $data["ah_gl_status2"]=0;
}
//query 4 


//query 5
$statement = $db->prepare("INSERT into mt_ap_trans_balance
(apdm_company,apdm_code,apdm_doc_type,apdm_doc_number,
  apdm_serial,apdm_other_reference,apdm_date,apdm_currency,
  apdm_ex_rate,apdm_of_amount,apdm_ol_amount,apdm_bf_amount,
  apdm_bl_amount,apdm_pf_amount,apdm_pl_amount,apdm_status,
ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id)
SELECT apt_company,apt_code,apt_type,apt_number,
apt_serial,apt_other_reference,apt_gl_date,apt_currency,
apt_ex_rate,apt_foreign_amount,apt_local_amount,
apt_foreign_balance,apt_local_balance,
0,0,'PENDING',ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location'  
 from mt_ap_trans where apt_number=:doc_no
");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["tb_status"]=1;
} else{
  $data["tb_status"]=0;
}
//query 5 ends

//query 6
$statement = $db->prepare("INSERT into mt_ap_balance
( apb_company,apb_code,apb_year,apb_period,apb_debit,apb_credit,
  ip,created_by ,ua,ekey,
  created_date,temp_code,company_id,location_id) 
SELECT '$dev->company','$customer_code',".self::getFinancialYear().",".
self::getFinancialPeriod($info->doc_date).",sum(apt_local_amount),sum(apt_local_amount),
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$temp_code','$dev->company','$dev->location' 
 from mt_ap_trans where apt_number=:doc_no");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["ab_balance_status"]=1;
} else{
  $data["ab_balance_status"]=0;
}
//query 6 ends

//check status of all
$child_status=$child_ar_count==$child_ar_status_count && $child_ap_count==$child_ap_status_count && $child_ar_ship_count==$child_ar_ship_status_count && $child_ar_order_count==$child_ar_order_status_count && $child_ar_cc_count==$child_ar_cc_status_count && (count($vpds)-1)==$child_apd_status_count;

$child_ar_tb_status=true;

if($child_ar_count!=0)
{
  if($data["ar_tb_status"]==0)
  {
  $child_ar_tb_status=false;
  }
}



//$data["status"]=0;

if($data["status"]==1 && $data["docid_status"]==1 && $data["ap_trans_status"]==1 && $child_status && $child_ar_tb_status && $data["ah_gl_status2"]==1 && $data["ab_balance_status"]==1 && $data["tb_status"]==1)
{
  $db->commit();
  
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}


$statement=null;
}
}
  }
  catch (Exception $e) {
    print $e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
  }
  
  return $data;
}



}

?>