<?php


require("../config/dbconn.php");

class FinanceDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));
$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}



public static function get_jv_info($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("SELECT id,jvh_company,jvh_doc_number,jvh_base_doc,jvh_doc_type,jvh_date,jvh_gl_date,jvh_batch,jvh_narration,jvh_remarks,jvh_currency,jvh_ex_rate,jvh_foreign_amount,jvh_local_amount,jvh_auto_reversal,jvh_other_reference,jvh_status,jvh_notes,jvh_cancellation_remarks,child from mt_jv_header where id=:id");

$statement->execute(array(':id'=>$code));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_jv_list($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("SELECT id,jvh_company,jvh_doc_number,jvh_base_doc,jvh_doc_type,jvh_date,jvh_gl_date,jvh_batch,jvh_narration,jvh_remarks,jvh_currency,jvh_ex_rate,jvh_foreign_amount,jvh_local_amount,jvh_auto_reversal,jvh_other_reference,jvh_status,jvh_notes,jvh_cancellation_remarks,created_by,created_date from mt_jv_header order by id desc limit :sta,50");
$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_jv_list($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("SELECT id,jvh_company,jvh_doc_number,jvh_base_doc,jvh_doc_type,jvh_date,jvh_gl_date,jvh_batch,jvh_narration,jvh_remarks,jvh_currency,jvh_ex_rate,jvh_foreign_amount,jvh_local_amount,jvh_auto_reversal,jvh_other_reference,jvh_status,jvh_notes,jvh_cancellation_remarks,created_by,created_date from mt_jv_header where jvh_doc_number like ? order by id desc limit :sta,50");
$i=1;
$statement ->bindValue($i++, "%$code%", PDO::PARAM_STR);
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function setFourDigit($v)
{
  $len=strlen($v);

if($len==1)
{
  $v="000".$v;
}else if($len==2)
{
  $v="00".$v;
}else if($len==3)
{
  $v="0".$v;
}

return $v;
}

public static function getFinancialYear()
{
//$year = ( date('m') > 4) ? date('Y') + 1 : date('Y');
$year=date('Y');
return $year;
}

public static function getFinancialPeriod($doc_date)
{

//$year = ( date('m') > 4) ? date('Y') + 1 : date('Y');
//$period=4;
//return $period;
$data=false;
try
{
$db = Factory::getConnection();

//$aq=self::getRestrictionQuery($dev);
//$doc_date="2019-12-15";
$date=date_create($doc_date);
$m= date_format($date,"F");
$y= date_format($date,"Y");

$statement = $db->prepare("SELECT enumber from mt_period 
  where period=:period and year=:year and open_max='OPEN'");

$statement->execute(array(':period'=>$m,':year'=>$y));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
//var_dump($statement->debugDumpParams());
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  $p=-10;
  if(count($data)==1)
  {
    $p=$data[0]["enumber"];
  }
  return $p;
}

public static function save_jv($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();
$cds=$code->cds;
$c=$code->info;

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_jv_header(jvh_company,jvh_base_doc,jvh_doc_type,jvh_date,jvh_gl_date,jvh_batch,jvh_narration,jvh_remarks,jvh_currency,jvh_ex_rate,jvh_foreign_amount,jvh_local_amount,jvh_other_reference,jvh_status,jvh_notes,ip,created_by,ua,ekey,created_date,temp_code,child,company_id,location_id) 
values(:jvh_company,:jvh_base_doc,:jvh_doc_type,:jvh_date,:jvh_gl_date,:jvh_batch,:jvh_narration,:jvh_remarks,:jvh_currency,:jvh_ex_rate,:jvh_foreign_amount,:jvh_local_amount,:jvh_other_reference,:jvh_status,:jvh_notes,
:ip,:created_by,:ua,:ekey,now(),:temp_code,:child,:company_id,:location_id)");

$statement->execute(array(':ip'=>$dev->ip,
  ':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
//
':jvh_company'=>$dev->company,
':jvh_base_doc'=>$c->jvh_doc_type,
':jvh_doc_type'=>$c->jvh_doc_type,
':jvh_date'=>$c->jvh_date,
':jvh_gl_date'=>$c->jvh_gl_date,
':jvh_batch'=>'',
':jvh_narration'=>$c->jvh_narration,
':jvh_remarks'=>'',
':jvh_currency'=>$c->jvh_currency,
':jvh_ex_rate'=>$c->jvh_ex_rate,
':jvh_foreign_amount'=>$c->jvh_foreign_amount,
':jvh_local_amount'=>$c->jvh_local_amount,
':jvh_other_reference'=>$c->jvh_other_reference,
':jvh_status'=>'POSTED',
':jvh_notes'=>$c->jvh_notes,
//
':temp_code'=>$temp_code,
':child'=>json_encode($cds),
':company_id'=>$dev->company,
':location_id'=>$dev->location
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved.";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to save.";
}

$statement = $db->prepare("SELECT id from mt_jv_header where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$four_id=self::setFourDigit($data["id"][0]["id"]);
$fid1=$data["id"][0]["id"];

$prefix="";
if($c->jvh_doc_type=="JV")
{
$prefix="JV";
}

$doc_no=$prefix."/".date("Y")."/".date('m')."/".$four_id;

$statement = $db->prepare("UPDATE mt_jv_header  
  SET jvh_doc_number=:ond where id=:id");
  $statement->execute(array(':id'=>$fid1,':ond'=>$doc_no));
  
    if ($statement->rowCount()){
    $data["jid_status"]=1;
  } else{
    $data["jid_status"]=0;
  }

$data["doc_no"]=$doc_no;

//query 2 child entry
$len=count($cds);
for($i=0;$i<$len;$i++)
{

$cd=$cds[$i];
$statement = $db->prepare("INSERT into mt_jv_allocation_details 
(aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,
  aloc_foreign_amount,aloc_local_amount,
  aloc_narration,aloc_currency,aloc_ex_rate,
  reference,ref_date,
ip,created_by ,ua,ekey,created_date,company_id,location_id)
VALUES
(:company,:voucher_type,:doc_type,:doc_no,:allocation,
  :base_amt_cr,:local_amt_cr,
  :narration,:currency,:ex_rate,
:reference,:ref_date,
  :ip ,:created_by ,:ua ,:ekey,now(),:company_id,:location_id)");
  $statement->execute(array(
    ':ip'=>$dev->ip,
  ':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
//
    ':company'=>$dev->company,
    ':voucher_type'=>$c->jvh_doc_type,
    ':doc_type'=>$c->jvh_doc_type,
    ':doc_no'=>$doc_no,
    ':allocation'=>$cd->code,
    ':base_amt_cr'=>$cd->famt,
    ':local_amt_cr'=>$cd->lamt,
    ':narration'=>'',
    ':currency'=>$c->jvh_currency,
    ':ex_rate'=>$c->jvh_ex_rate,
    ':reference'=>'',
    ':ref_date'=>'',
    ':company_id'=>$dev->company,
':location_id'=>$dev->location
  ));
  
    if ($statement->rowCount()){
    $data["ch_status".($i+1)]=1;
  } else{
    $data["ch_status".($i+1)]=0;
  }

}

//query 3 gl entry

$statement = $db->prepare("INSERT INTO mt_jv_gl_details
(pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_doc_date,
  pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,
  pre_glt_ex_rate,pre_glt_foreign_amount,
  pre_glt_local_amount,pre_glt_narration,
ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id)
SELECT aloc_company,expense_gl,
aloc_base_doc,aloc_doc_type,
aloc_doc_number,'$c->jvh_date',
'$c->jvh_date',".self::getFinancialYear().",".
self::getFinancialPeriod($c->jvh_date).",aloc_narration,aloc_currency,
aloc_ex_rate,aloc_foreign_amount,
aloc_local_amount,aloc_narration,
ip,created_by,ua ,ekey,now(),'$temp_code',company_id,location_id   
FROM mt_jv_allocation_details where aloc_doc_number=:doc_no");
  $statement->execute(array(':doc_no'=>$doc_no));
  
    if ($statement->rowCount()){
    $data["gl_status"]=1;
  } else{
    $data["gl_status"]=0;
  }



$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}






}
?>