<?php

error_reporting(E_ALL);
ini_set('display_errors', 1);

require("pdf-dao.php");
require("get-address.php");

$fy=$_GET["financial_year"];
$fy1=substr($fy,0,4);
$fy2=substr($fy,5,4);
$username=$_GET["username"];


$data=PDFDao::get_balance_sheet($fy1,$fy2,$username);

if(count($data["info"])>=1)
{
  $trs=$data["info"];
  $trs2=$data["info2"];
  $ards=$data["summary"];
  $ar_details='';

//GET COMPANY DATA
$logo=getBranchLogo($data["location"][0]["location"]);
$address=getAddress($data["location"][0]["location"]);
$tax_disptxt=displayGst_Vat($data["location"][0]["location"]);
//END GET COMPANY DATA

//SET Base Currency
$base_cur= getCurrency($data["location"][0]["location"]);

  $balance=0;

    for($i=0;$i<count($ards);$i++)
    {
         $ar=$ards[$i];

            $balance=$balance+(float)$ar["total"];

            $ar_details=$ar_details.'
            <tr>
            <td width="10%" style="border-bottom: 0.1mm solid #000000;border-left: 0.1mm solid #000000;">'.($i+1).'</td>
            <td style="border-left: 0.1mm solid #ffffff; border-bottom: 0.1mm solid #000000;">
            '.$ar["account_type"].' </td> 
            <td style="border-left: 0.1mm solid #ffffff; border-bottom: 0.1mm solid #000000;">
            '.$ar["account_group"].' </td> 
            <td style="border-left: 0.1mm solid #ffffff; border-bottom: 0.1mm solid #000000;">
            '.$ar["account_sub_group"].' </td>                         
            <td style="text-align:right; border-left: 0.1mm solid #ffffff; border-right: 0.1mm solid #000000;border-bottom: 0.1mm solid #000000;">'.number_format($ar["total"],2).' </td>             
            </tr>';
    }


  $trial_summary='';

  $tr_total1=0;

    for($j=0;$j<count($trs);$j++)
    {
         $ar=$trs[$j];

            $tr_total1=$tr_total1+(float)$ar["total"];

            $trial_summary=$trial_summary.'
            <tr>
            <td style="border-bottom: 0.1mm solid #000000;border-left: 0.1mm solid #000000;">'.$ar["account_serial"].'</td>
            <td style="border-left: 0.1mm solid #ffffff; border-bottom: 0.1mm solid #000000;">'.$ar["account_type"].' </td> 
            <td style="border-left: 0.1mm solid #ffffff; border-bottom: 0.1mm solid #000000;">'.$ar["account_group"].' </td> 
            <td style="border-left: 0.1mm solid #ffffff; border-bottom: 0.1mm solid #000000;">'.$ar["account_sub_group"].' </td> 
            <td style="border-left: 0.1mm solid #ffffff; border-bottom: 0.1mm solid #000000;">'.$ar["ac_description"].' </td> 
            <td style="text-align:right; border-left: 0.1mm solid #ffffff; border-right: 0.1mm solid #000000;border-bottom: 0.1mm solid #000000;">'.number_format($ar["total"],2).' </td>             
            </tr>';
    }


  $trial_summary2='';

  $tr_total2=0;

    for($k=0;$k<count($trs2);$k++)
    {
         $ar=$trs2[$k];

            $tr_total2=$tr_total2+(float)$ar["total"];

            $trial_summary2=$trial_summary2.'
            <tr>
            <td style="border-bottom: 0.1mm solid #000000;border-left: 0.1mm solid #000000;">'.$ar["account_serial"].'</td>
            <td style="border-left: 0.1mm solid #ffffff; border-bottom: 0.1mm solid #000000;">'.$ar["account_type"].' </td> 
            <td style="border-left: 0.1mm solid #ffffff; border-bottom: 0.1mm solid #000000;">'.$ar["account_group"].' </td> 
            <td style="border-left: 0.1mm solid #ffffff; border-bottom: 0.1mm solid #000000;">'.$ar["account_sub_group"].' </td> 
            <td style="border-left: 0.1mm solid #ffffff; border-bottom: 0.1mm solid #000000;">'.$ar["ac_description"].' </td> 
            <td style="text-align:right; border-left: 0.1mm solid #ffffff; border-right: 0.1mm solid #000000;border-bottom: 0.1mm solid #000000;">'.number_format($ar["total"],2).' </td>             
            </tr>';
    }


$html = '

<html>

<head>
    <style>
         body {
            font-family: verdana;
            font-size: 10pt;
        }

        table.items {
            border: 0.1mm solid #000000;
        }

        table.items1 {
            border: 0.1mm solid #000000;
        }

        .items td {
            border-left: 0.1mm solid #000000;
            border-right: 0.1mm solid #000000;
            border-bottom: 0.1mm solid #000000;
        }

        .items1 td {
            border-left: 0.1mm solid #ffffff;
            border-right: 0.1mm solid #ffffff;
            border-bottom: 0.1mm solid #ffffff;
        }

        table thead td {
            background-color: #ffffff;
            text-align: center;
            border: 0.1mm solid #000000;
            color: black;
            font-weight: bold !important;
        }

        td.hdr {
            font-weight: bold !important;
        }

        .pghead {
            font-size: 24pt;
            color: #555555;
            font-family: verdana;
            vertical-align: middle;
        }

        .btxt {
            font-weight: bold !important;
        }

        .bigtxt {
            font-size: 12pt;
            font-weight: bold !important;
        }        

    </style>
</head>

<body>


    <table width="100%" border="0" style="font-family: verdana;" cellspacing="0" cellpadding="0">
        <tr>
            <td width="25%">
            <span >
                <img '.$logo.'  >
            </span>
              <br>'.$address.'          
            </td>
          <td width="50%" >
                <span class="pghead" >
                    <p style=" margin-top: 50px">Balance Sheet <br>FY '.$fy.'</p>
                </span>

            </td>
        </tr>
    </table>
    <br>
    <span class="bigtxt">SUMMARY</span> <span class="btxt">As on '.date("F j, Y").'</span><br><br>
    
    <table class="items1" width="100%" style="font-size: 9pt; border-collapse: collapse; " cellpadding="5">
        
        <tr>
                <td style="border-left: 0.1mm solid #000000; border-bottom: 0.1mm solid #000000;">
                    <span class="btxt">S.No.</span>
                </td>
                <td style="border-left: 0.1mm solid #ffffff; border-bottom: 0.1mm solid #000000;">
                    <span class="btxt">Account Type</span>
                </td>
                <td style="border-left: 0.1mm solid #ffffff; border-bottom: 0.1mm solid #000000;">
                    <span class="btxt">Account Group</span>
                </td>
                <td style="border-left: 0.1mm solid #ffffff; border-bottom: 0.1mm solid #000000;">
                    <span class="btxt">Account Sub-Group</span>
                </td>                                             
                <td style="text-align:right; border-left: 0.1mm solid #ffffff; border-right: 0.1mm solid #000000;border-bottom: 0.1mm solid #000000;">
                    <span class="btxt">FY '.$fy.'</span>
                </td>
                
        </tr>
        
 <!-- ITEMS HERE -->
'.$ar_details.'
<!-- END ITEMS HERE --> 
            <tr>
               <td  style="border-left: 0.1mm solid #000000;border-bottom: 0.1mm solid #000000;">
                    
                </td>
                <td colspan="3" style="border-bottom: 0.1mm solid #000000;">
                    <span class="btxt">BALANCE</span>
                </td>
                <td  style="text-align:right; border-bottom: 0.1mm solid #000000; border-right: 0.1mm solid #000000;">
                    <span class="btxt">'.number_format($balance,2).'</span>
                    
                </td>
            </tr>  
    </table>
    <br><br>    
    <span class="bigtxt">ASSETS</span> <span class="btxt">As on '.date("F j, Y").'</span><br><br>

    <table class="items1" width="100%" style="font-size: 9pt; border-collapse: collapse; " cellpadding="5">
        <tr>
                <td style="border-left: 0.1mm solid #000000; border-bottom: 0.1mm solid #000000;">
                    <span class="btxt">Serial</span>
                </td>
                <td style="border-left: 0.1mm solid #ffffff; border-bottom: 0.1mm solid #000000;">
                    <span class="btxt">Account Type</span>
                </td>
                
                <td style="border-left: 0.1mm solid #ffffff; border-bottom: 0.1mm solid #000000;">
                    <span class="btxt">Account Group</span>
                </td>
                <td style="border-left: 0.1mm solid #ffffff; border-bottom: 0.1mm solid #000000;">
                    <span class="btxt">Sub-Group</span>
                </td>  
                <td style="border-left: 0.1mm solid #ffffff; border-bottom: 0.1mm solid #000000;">
                    <span class="btxt">Account Description</span>
                </td>                                
                <td style="text-align:right; border-bottom: 0.1mm solid #000000; border-right: 0.1mm solid #000000;">
                    <span class="btxt">FY '.$fy.'</span>
                </td>
                
        </tr>
 <!-- ITEMS HERE -->
'.$trial_summary.'
<!-- END ITEMS HERE --> 
            <tr>
               <td  style="border-left: 0.1mm solid #000000;border-bottom: 0.1mm solid #000000;">
                    
                </td>
                <td style="border-bottom: 0.1mm solid #000000;">
                    <span class="btxt">TOTAL ASSETS</span>
                </td>
                <td style="border-bottom: 0.1mm solid #000000;">
                    <span class="btxt"></span>
                </td>
                <td style="border-bottom: 0.1mm solid #000000;">
                    <span class="btxt"></span>
                </td> 
                <td style="border-bottom: 0.1mm solid #000000;">
                    <span class="btxt"></span>
                </td>                                
                 <td  style="text-align:right;border-bottom: 0.1mm solid #000000; border-right: 0.1mm solid #000000;">
                    <span class="btxt">'.number_format($tr_total1,2).'</span>
                    
                </td>
            </tr>                         
    </table>
    <br><br>    
    <span class="bigtxt">LIABILITIES</span> <span class="btxt">As on '.date("F j, Y").'</span><br><br>

    <table class="items1" width="100%" style="font-size: 9pt; border-collapse: collapse; " cellpadding="5">
        <tr>
                <td style="border-left: 0.1mm solid #000000; border-bottom: 0.1mm solid #000000;">
                    <span class="btxt">Serial</span>
                </td>
                <td style="border-left: 0.1mm solid #ffffff; border-bottom: 0.1mm solid #000000;">
                    <span class="btxt">Account Type</span>
                </td>
                
                <td style="border-left: 0.1mm solid #ffffff; border-bottom: 0.1mm solid #000000;">
                    <span class="btxt">Account Group</span>
                </td>
                <td style="border-left: 0.1mm solid #ffffff; border-bottom: 0.1mm solid #000000;">
                    <span class="btxt">Sub-Group</span>
                </td>  
                <td style="border-left: 0.1mm solid #ffffff; border-bottom: 0.1mm solid #000000;">
                    <span class="btxt">Account Description</span>
                </td>                                
                <td style="text-align:right; border-bottom: 0.1mm solid #000000; border-right: 0.1mm solid #000000;">
                    <span class="btxt">FY '.$fy.'</span>
                </td>
                
        </tr>
 <!-- ITEMS HERE -->
'.$trial_summary2.'
<!-- END ITEMS HERE --> 
            <tr>
               <td  style="border-left: 0.1mm solid #000000;border-bottom: 0.1mm solid #000000;">
                    
                </td>
                <td style="border-bottom: 0.1mm solid #000000;">
                    <span class="btxt">TOTAL LIABILITIES</span>
                </td>
                <td style="border-bottom: 0.1mm solid #000000;">
                    <span class="btxt"></span>
                </td>
                <td style="border-bottom: 0.1mm solid #000000;">
                    <span class="btxt"></span>
                </td> 
                <td style="border-bottom: 0.1mm solid #000000;">
                    <span class="btxt"></span>
                </td>                                
                 <td  style="text-align:right;border-bottom: 0.1mm solid #000000; border-right: 0.1mm solid #000000;">
                    <span class="btxt">'.number_format($tr_total2,2).'</span>
                    
                </td>
            </tr>                         
    </table>
    <br><br>        


</body>

</html>


';

require_once 'vendor/autoload.php';
$mpdf = new \Mpdf\Mpdf([
	'margin_left' => 10,
	'margin_right' => 10,
	'margin_top' => 5,
	'margin_bottom' => 10,
	'margin_header' => 2,
	'margin_footer' => 2,
	'tempDir' => 'tmp'
]);

//set utf encode
$html=mb_convert_encoding($html, 'UTF-8', 'UTF-8');
$mpdf->SetProtection(array('print'));
$mpdf->SetTitle("LIVRO - Balance Sheet");
$mpdf->SetAuthor("LIVRO");
$mpdf->SetWatermarkText("");
$mpdf->showWatermarkText = true;
$mpdf->watermark_font = 'DejaVuSansCondensed';
$mpdf->watermarkTextAlpha = 0.1;
$mpdf->SetDisplayMode('fullpage');
$mpdf->WriteHTML($html);
$mpdf->Output();


}else{
  echo "Invalid credentials........";
}



?>