<?php


require("../config/dbconn.php");

class PDFDao

{



public static function get_soa_full($art_code,$from_date,$to_date,$username)
{
$data=array();
try
{
$db = Factory::getConnection();

//Get Location
$statement = $db->prepare("SELECT location from user_master
where username=:username ");
$statement->execute(array(':username'=>$username));
$data["location"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$location_id=$data["location"][0]["location"];

//echo $location_id;

//Get Party info
$statement = $db->prepare("SELECT t1.code, t1.name, t2.address, t3.currency, t3.final_limit, 
  t3.credit_days FROM mt_business_partner t1 
LEFT JOIN mt_bp_address t2
ON t1.id=t2.bp_id and t2.type='HQ'
LEFT JOIN mt_bp_credit t3 
ON t1.id=t3.bp_id 
WHERE t1.code=:art_code");
$statement->execute(array(':art_code'=>$art_code));
$data["head"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get detail info
$statement = $db->prepare("SELECT ART_BASE_TYPE,art_code,ART_GL_DATE,ART_TYPE,ART_NUMBER,art_type_art_notes,
SUM(ART_LOCAL_AMOUNT_WGST) ART_LOCAL_AMOUNT_WGST,
SUM(ART_LOCAL_AMOUNT) ART_LOCAL_AMOUNT 
FROM 
(
SELECT ART_BASE_TYPE,
art_code,
ART_GL_DATE,
ART_TYPE,
ART_NUMBER,
CASE WHEN art_type='P2P' THEN
concat(art_type,' - ',art_notes)
WHEN art_type='EXP-INV' THEN
concat(art_type,' - ',art_notes)
WHEN art_type='ONLINE TRANSFER' THEN
concat(art_type,' - ',art_notes)
WHEN art_type='CHEQUE' THEN
concat(art_type,' - ',art_notes)
ELSE
art_type
END as art_type_art_notes,
ART_LOCAL_AMOUNT,
case when ART_TYPE in ('EXP-INV','GRLD TAX INVOICE','DEBIT NOTE','CREDIT NOTE') THEN

case when art_description in ('LINE DETENTION INCOME') THEN
0
else
(select sum(ART_LOCAL_AMOUNT) from mt_ar_trans ct 
 where ct.art_number=t1.art_number and ct.art_type not in ('TDS RECEIVABLE') ) 
end 

 when t1.art_type in ('OUTPUT IGST','OUTPUT CGST','OUTPUT SGST') THEN
    0
 ELSE
 t1.ART_LOCAL_AMOUNT
 end  ART_LOCAL_AMOUNT_WGST 
FROM mt_ar_trans t1  
WHERE art_code=:art_code and (ART_GL_DATE between :from_date and :to_date)  and art_balance_status!='CANCELLED' 
 

UNION ALL 

select apt_base_type ART_BASE_TYPE,
apt_code art_code,
case when apt_base_type='PAYMENT' THEN
APT_GL_DATE
ELSE
ref_inv_date 
END as ART_GL_DATE,
apt_type ART_TYPE, 
case when apt_base_type='PAYMENT' THEN
  apt_number
 when apt_base_type='JOURNAL VOUCHER' THEN
  apt_number
ELSE
  ref_inv_no 
END as ART_NUMBER,
CASE WHEN apt_type='P2P' THEN
concat(apt_type,' - ',apt_notes)
WHEN apt_type='CHEQUE' THEN
concat(apt_type,' - ',apt_notes)
WHEN apt_type='ONLINE TRANSFER' THEN
concat(apt_type,' - ',apt_notes)
ELSE
apt_type
END as art_type_art_notes,

apt_local_amount ART_LOCAL_AMOUNT,

case when APT_TYPE not in ('TDS PAYABLE') THEN
(select sum(APT_LOCAL_AMOUNT) from mt_ap_trans ct 
 where ct.apt_number=t2.apt_number and ct.apt_type not in ('TDS PAYABLE') ) 
 ELSE
 APT_LOCAL_AMOUNT
 end  ART_LOCAL_AMOUNT_WGST     
from mt_ap_trans t2
WHERE apt_code=:art_code and (APT_GL_DATE between :from_date and :to_date)  and apt_balance_status!='CANCELLED' 
) gt

GROUP BY ART_BASE_TYPE,art_code,ART_GL_DATE,ART_TYPE,ART_NUMBER,art_type_art_notes        
ORDER BY ART_GL_DATE  ");
$statement->execute(array(':art_code'=>$art_code,
  ':from_date'=>$from_date,':to_date'=>$to_date,':location_id'=>$location_id));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get PDC data
$statement = $db->prepare("SELECT
t1.id, 
t1.rh_base_doc_type,
t1.rh_doc_type,
t1.rh_doc_date,
t1.rh_doc_number,
t1.rh_cash_bank_code,
t2.aloc_local_amount rh_local_amount,
t1.rh_cheque_number,
t1.rh_cheque_date 
FROM mt_receipt_header t1
LEFT JOIN mt_receipt_allocation_details t2
ON t1.rh_doc_number= t2.aloc_doc_number
WHERE t1.rh_status='AWAITING CONFIRMATION' and   t2.aloc_detail_2=:id and t2.aloc_doc_type='CHEQUE'and t2.location_id=:location_id  
 UNION
SELECT
t1.id,  
t1.ph_base_doc_type rh_base_doc_type,
t1.ph_doc_type rh_doc_type,
t1.ph_doc_date rh_doc_date,
t1.ph_doc_number rh_doc_number,
t1.ph_cash_bank_code rh_cash_bank_code,
t2.aloc_local_amount rh_local_amount,
t1.ph_cheque_number rh_cheque_number,
t1.ph_cheque_date rh_cheque_date 
FROM mt_payment_header t1
LEFT JOIN mt_payment_allocation_details t2
ON t1.ph_doc_number= t2.aloc_doc_number
WHERE t1.ph_status='AWAITING CONFIRMATION' and   t2.aloc_detail_2=:id and t2.aloc_doc_type='CHEQUE' and t2.location_id=:location_id ");
$statement->execute(array(':id'=>$art_code,':location_id'=>$location_id));
$data["pdc_data"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get Opening Balance 2
$statement = $db->prepare("SELECT ifnull(SUM(CASE
        WHEN art_type='OPENING BALANCE' THEN ART_LOCAL_AMOUNT
        ELSE 0
    END),0) AS 'ob',
    ifnull(SUM(CASE
        WHEN ART_LOCAL_AMOUNT > 0 and art_type!='OPENING BALANCE' THEN ART_LOCAL_AMOUNT
        ELSE 0
    END),0) AS 'pos',
    ifnull(SUM(CASE
        WHEN ART_LOCAL_AMOUNT < 0 and art_type!='OPENING BALANCE' THEN ART_LOCAL_AMOUNT
        ELSE 0
    END),0) AS 'neg' 
FROM mt_ar_trans t1  
WHERE art_code=:art_code  and (ART_GL_DATE < :from_date) and art_balance_status!='CANCELLED' 
and location_id=:location_id ");
$statement->execute(array(':art_code'=>$art_code,
  ':from_date'=>$from_date,':location_id'=>$location_id));
$data["op_bal2"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get Opening Balance 3
$statement = $db->prepare("SELECT ifnull(SUM(CASE
        WHEN apt_type='OPENING BALANCE' THEN APT_LOCAL_AMOUNT
        ELSE 0
    END),0) AS 'ob',
    ifnull(SUM(CASE
        WHEN APT_LOCAL_AMOUNT > 0 and apt_type!='OPENING BALANCE' THEN APT_LOCAL_AMOUNT
        ELSE 0
    END),0) AS 'pos',
    ifnull(SUM(CASE
        WHEN APT_LOCAL_AMOUNT < 0 and apt_type!='OPENING BALANCE' THEN APT_LOCAL_AMOUNT
        ELSE 0
    END),0) AS 'neg' 
FROM mt_ap_trans t1  
WHERE apt_code=:art_code  and (APT_GL_DATE < :from_date) and apt_balance_status!='CANCELLED' 
and location_id=:location_id ");
$statement->execute(array(':art_code'=>$art_code,
  ':from_date'=>$from_date,':location_id'=>$location_id));
$data["op_bal3"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get EPDA detail
$statement = $db->prepare("SELECT sub_ar_code, sub_ar_doc_number, sub_ar_date, sub_ar_currency, sub_ar_l_amount, sub_ar_narration, order_no, bl_no
 from mt_ship_ar_header 
 where sub_ar_code=:art_code 
 and (sub_ar_doc_base in ('EPDA IMPORT','EPDA EXPORT') or sub_ar_doc_type in ('PRO'))    
 and sub_ar_status not in ('CANCELLED', 'P') ");
$statement->execute(array(':art_code'=>$art_code));
$data["epda"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_age_analysis_detail($art_code,$to_date,$st,$username)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT location from user_master
where username=:username ");
$statement->execute(array(':username'=>$username));
$data["location"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$location_id=$data["location"][0]["location"];

//Get Party info
$statement = $db->prepare("SELECT t1.code, t1.name, t2.address, t3.currency, t3.final_limit, 
  t3.credit_days FROM mt_business_partner t1 
LEFT JOIN mt_bp_address t2
ON t1.id=t2.bp_id and t2.type='HQ'
LEFT JOIN mt_bp_credit t3 
ON t1.id=t3.bp_id 
WHERE t1.code=:art_code");
$statement->execute(array(':art_code'=>$art_code));
$data["head"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$ar_st=" ";
$ap_st=" ";
if($st=="WITHOUT ZERO"){
  $ar_st=" and truncate(t1.art_local_balance,2)!=0 ";
  $ap_st=" and truncate(t2.apt_local_balance,2)!=0 ";
}
//Get detail
$statement = $db->prepare("

SELECT t1.art_doc_date, t1.art_number, t1.art_description, 
  t1.art_local_amount,
  case when t1.ART_TYPE not in ('TDS RECEIVABLE') THEN
  (select sum(ART_LOCAL_AMOUNT) from mt_ar_trans ct 
   where ct.art_number=t1.art_number and ct.art_type not in ('TDS RECEIVABLE')  and ct.art_code=:art_code) 
   ELSE
   t1.ART_LOCAL_AMOUNT
   end as 'ART_LOCAL_AMOUNT_WGST',
   t1.art_local_balance, 
   case when t1.ART_TYPE not in ('TDS RECEIVABLE') THEN
  (select sum(art_local_balance) from mt_ar_trans ct 
   where ct.art_number=t1.art_number and ct.art_type not in ('TDS RECEIVABLE')  and ct.art_code=:art_code) 
   ELSE
   t1.art_local_balance
   end as 'ART_LOCAL_BALANCE_WGST',
   DATEDIFF(:to_date, t1.art_doc_date) ageing
from mt_ar_trans t1 
where t1.art_type in ('PETTY CASH','PRO-INV','IMP-INV', 'EXP-INV', 'GENERAL INVOICE', 'DEBIT NOTE', 'CREDIT NOTE', 'CARD', 'CASH','ONLINE TRANSFER','CHEQUE','JV') 
and t1.art_code=:art_code and art_number not like 'PBC%' 
and t1.art_balance_status!='CANCELLED'
and location_id=:location_id 

$ar_st  

UNION


SELECT 
case when apt_base_type='PAYMENT' THEN
t2.APT_GL_DATE
ELSE
t2.ref_inv_date 
END as art_doc_date,
case when t2.apt_base_type='PAYMENT' THEN
  t2.apt_number
ELSE
  t2.ref_inv_no 
END as ART_NUMBER,
 
CASE when t2.apt_type in ('VAT CHARGEABLE','INPUT CGST','INPUT SGST','INPUT IGST','GENERAL INVOICE','TDS PAYABLE') then 
'GENERAL INVOICE'  
ELSE
t2.apt_type  
END as art_description,

sum(t2.apt_local_amount) art_local_amount,
sum(
case when t2.APT_TYPE in ('GENERAL INVOICE') THEN
(select sum(APT_LOCAL_AMOUNT) from mt_ap_trans ct 
 where ct.apt_number=t2.apt_number and ct.apt_type not in ('TDS PAYABLE') ) 
 when t2.apt_type in ('VAT CHARGEABLE','INPUT IGST','INPUT CGST','INPUT SGST') THEN
    0
 ELSE
 t2.APT_LOCAL_AMOUNT
 end  ) ART_LOCAL_AMOUNT_WGST,  
sum(t2.apt_local_balance) art_local_balance, 
sum(
case when t2.APT_TYPE in ('GENERAL INVOICE') THEN
(select sum(apt_local_balance) from mt_ap_trans ct 
 where ct.apt_number=t2.apt_number and ct.apt_type not in ('TDS PAYABLE') ) 
 when t2.apt_type in ('VAT CHARGEABLE','INPUT IGST','INPUT CGST','INPUT SGST') THEN
    0
 ELSE
 t2.apt_local_balance
 end  ) ART_LOCAL_BALANCE_WGST,  
case when apt_base_type='PAYMENT' THEN
DATEDIFF(:to_date, t2.APT_GL_DATE) 
ELSE
DATEDIFF(:to_date, t2.ref_inv_date)  
END as ageing 

FROM mt_ap_trans t2 
WHERE t2.apt_type in ('PETTY CASH','PRO-INV','IMP-INV', 'EXP-INV', 'GENERAL INVOICE', 'DEBIT NOTE', 'CREDIT NOTE', 'CARD', 'CASH','ONLINE TRANSFER','CHEQUE','JV','BROKERAGE') 
and t2.apt_code=:art_code
and t2.apt_balance_status!='CANCELLED' 
and location_id=:location_id 
$ap_st 

GROUP BY art_doc_date,ART_NUMBER,art_description,ageing

ORDER BY art_doc_date ");
$statement->execute(array(':art_code'=>$art_code,
  ':to_date'=>$to_date,':location_id'=>$location_id));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get PDC data
$statement = $db->prepare("SELECT
t1.id, 
t1.rh_base_doc_type,
t1.rh_doc_type,
t1.rh_doc_date,
t1.rh_doc_number,
t1.rh_cash_bank_code,
t2.aloc_local_amount rh_local_amount,
t1.rh_cheque_number,
t1.rh_cheque_date 
FROM mt_receipt_header t1
LEFT JOIN mt_receipt_allocation_details t2
ON t1.rh_doc_number= t2.aloc_doc_number
WHERE t1.rh_status='AWAITING CONFIRMATION' and   t2.aloc_detail_2=:id and t2.aloc_doc_type='CHEQUE' and t2.location_id=:location_id
UNION
SELECT
t1.id,  
t1.ph_base_doc_type rh_base_doc_type,
t1.ph_doc_type rh_doc_type,
t1.ph_doc_date rh_doc_date,
t1.ph_doc_number rh_doc_number,
t1.ph_cash_bank_code rh_cash_bank_code,
t2.aloc_local_amount rh_local_amount,
t1.ph_cheque_number rh_cheque_number,
t1.ph_cheque_date rh_cheque_date 
FROM mt_payment_header t1
LEFT JOIN mt_payment_allocation_details t2
ON t1.ph_doc_number= t2.aloc_doc_number
WHERE t1.ph_status='AWAITING CONFIRMATION' and   t2.aloc_detail_2=:id and t2.aloc_doc_type='CHEQUE' and t2.location_id=:location_id");
$statement->execute(array(':id'=>$art_code,':location_id'=>$location_id));
$data["pdc_data"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get ageing slabs
$statement = $db->prepare(" SELECT sum(c1) c1, sum(c2) c2, sum(c3) c3, sum(c4) c4, sum(c5) c5, sum(total) total
FROM 
(SELECT sum(case when DATEDIFF(:to_date, t1.art_doc_date)  between 0 and 30 then 

   case when t1.ART_TYPE not in ('TDS RECEIVABLE') THEN
  (select sum(art_local_balance) from mt_ar_trans ct 
   where ct.art_number=t1.art_number and ct.art_type not in ('TDS RECEIVABLE')  and ct.art_code=:art_code) 
   ELSE
   t1.art_local_balance
   end 

else 0 
end) 'c1',
sum(case when DATEDIFF(:to_date, t1.art_doc_date)  between 31 and 60 then 

   case when t1.ART_TYPE not in ('TDS RECEIVABLE') THEN
  (select sum(art_local_balance) from mt_ar_trans ct 
   where ct.art_number=t1.art_number and ct.art_type not in ('TDS RECEIVABLE')  and ct.art_code=:art_code) 
   ELSE
   t1.art_local_balance
   end 

else 0 
end) 'c2',
sum(case when DATEDIFF(:to_date, t1.art_doc_date)  between 61 and 90 then 

   case when t1.ART_TYPE not in ('TDS RECEIVABLE') THEN
  (select sum(art_local_balance) from mt_ar_trans ct 
   where ct.art_number=t1.art_number and ct.art_type not in ('TDS RECEIVABLE')  and ct.art_code=:art_code) 
   ELSE
   t1.art_local_balance
   end 

else 0 
end) 'c3',
sum(case when DATEDIFF(:to_date, t1.art_doc_date)  between 91 and 120 then 

   case when t1.ART_TYPE not in ('TDS RECEIVABLE') THEN
  (select sum(art_local_balance) from mt_ar_trans ct 
   where ct.art_number=t1.art_number and ct.art_type not in ('TDS RECEIVABLE')  and ct.art_code=:art_code) 
   ELSE
   t1.art_local_balance
   end 

else 0 
end) 'c4',
sum(case when DATEDIFF(:to_date, t1.art_doc_date)  > 120 then 

   case when t1.ART_TYPE not in ('TDS RECEIVABLE') THEN
  (select sum(art_local_balance) from mt_ar_trans ct 
   where ct.art_number=t1.art_number and ct.art_type not in ('TDS RECEIVABLE')  and ct.art_code=:art_code) 
   ELSE
   t1.art_local_balance
   end 

else 0 
end) 'c5',
sum(
   case when t1.ART_TYPE not in ('TDS RECEIVABLE') THEN
  (select sum(art_local_balance) from mt_ar_trans ct 
   where ct.art_number=t1.art_number and ct.art_type not in ('TDS RECEIVABLE')  and ct.art_code=:art_code) 
   ELSE
   t1.art_local_balance
   end 

) total 
FROM mt_ar_trans t1 
WHERE  t1.art_type in ('TDS RECEIVABLE','OPENING BALANCE','PRO-INV','IMP-INV', 'EXP-INV','GENERAL INVOICE', 'DEBIT NOTE', 'CREDIT NOTE', 'CARD', 'CASH','ONLINE TRANSFER','CHEQUE','P2P','L2P','P2L') 
and t1.art_code=:art_code and t1.art_local_balance!=0 
and t1.art_balance_status!='CANCELLED'
and t1.art_number not in (select arm_m_number from mt_ar_match_details
where  (arm_m_number=t1.art_number or arm_t_number=t1.art_number) and arm_m_ar=:art_code and arm_status!='CANCELLED') 

UNION 

SELECT sum(case when 
( 
case when apt_base_type='PAYMENT' THEN
DATEDIFF(:to_date, t1.apt_doc_date) 
ELSE
DATEDIFF(:to_date, t1.ref_inv_date)  
END) 
  between 0 and 30 then 

  case when t1.APT_TYPE in ('GENERAL INVOICE') THEN
(select sum(apt_local_balance) from mt_ap_trans ct 
 where ct.apt_number=t1.apt_number and ct.apt_type not in ('TDS PAYABLE') ) 
 when t1.apt_type in ('VAT CHARGEABLE','INPUT IGST','INPUT CGST','INPUT SGST') THEN
    0
 ELSE
 t1.apt_local_balance
 end

else 0 
end) 'c1',
sum(case when 
( 
case when apt_base_type='PAYMENT' THEN
DATEDIFF(:to_date, t1.apt_doc_date) 
ELSE
DATEDIFF(:to_date, t1.ref_inv_date)  
END) 
  between 31 and 60 then 

  case when t1.APT_TYPE in ('GENERAL INVOICE') THEN
(select sum(apt_local_balance) from mt_ap_trans ct 
 where ct.apt_number=t1.apt_number and ct.apt_type not in ('TDS PAYABLE') ) 
 when t1.apt_type in ('VAT CHARGEABLE','INPUT IGST','INPUT CGST','INPUT SGST') THEN
    0
 ELSE
 t1.apt_local_balance
 end

else 0 
end) 'c2',
sum(case when 
( 
case when apt_base_type='PAYMENT' THEN
DATEDIFF(:to_date, t1.apt_doc_date) 
ELSE
DATEDIFF(:to_date, t1.ref_inv_date)  
END) 
  between 61 and 90 then 

  case when t1.APT_TYPE in ('GENERAL INVOICE') THEN
(select sum(apt_local_balance) from mt_ap_trans ct 
 where ct.apt_number=t1.apt_number and ct.apt_type not in ('TDS PAYABLE') ) 
 when t1.apt_type in ('VAT CHARGEABLE','INPUT IGST','INPUT CGST','INPUT SGST') THEN
    0
 ELSE
 t1.apt_local_balance
 end

else 0 
end) 'c3',
sum(case when 
( 
case when apt_base_type='PAYMENT' THEN
DATEDIFF(:to_date, t1.apt_doc_date) 
ELSE
DATEDIFF(:to_date, t1.ref_inv_date)  
END) 
  between 91 and 120 then 

  case when t1.APT_TYPE in ('GENERAL INVOICE') THEN
(select sum(apt_local_balance) from mt_ap_trans ct 
 where ct.apt_number=t1.apt_number and ct.apt_type not in ('TDS PAYABLE') ) 
 when t1.apt_type in ('VAT CHARGEABLE','INPUT IGST','INPUT CGST','INPUT SGST') THEN
    0
 ELSE
 t1.apt_local_balance
 end

else 0 
end) 'c4',
sum(case when 
( 
case when apt_base_type='PAYMENT' THEN
DATEDIFF(:to_date, t1.apt_doc_date) 
ELSE
DATEDIFF(:to_date, t1.ref_inv_date)  
END) 
  > 120 then 

  case when t1.APT_TYPE in ('GENERAL INVOICE') THEN
(select sum(apt_local_balance) from mt_ap_trans ct 
 where ct.apt_number=t1.apt_number and ct.apt_type not in ('TDS PAYABLE') ) 
 when t1.apt_type in ('VAT CHARGEABLE','INPUT IGST','INPUT CGST','INPUT SGST') THEN
    0
 ELSE
 t1.apt_local_balance
 end

else 0 
end) 'c5',
sum(

  case when t1.APT_TYPE in ('GENERAL INVOICE') THEN
(select sum(apt_local_balance) from mt_ap_trans ct 
 where ct.apt_number=t1.apt_number and ct.apt_type not in ('TDS PAYABLE') ) 
 when t1.apt_type in ('VAT CHARGEABLE','INPUT IGST','INPUT CGST','INPUT SGST') THEN
    0
 ELSE
 t1.apt_local_balance
 end
 
) total 
FROM mt_ap_trans t1 
WHERE  t1.apt_type in ('OPENING BALANCE','PRO-INV','IMP-INV', 'EXP-INV', 'DEBIT NOTE', 'CREDIT NOTE', 'CARD', 'CASH','ONLINE TRANSFER','CHEQUE','INPUT CGST','INPUT SGST','INPUT IGST','TDS PAYABLE','P2P','L2P','P2L') 
and t1.apt_code=:art_code and t1.apt_local_balance!=0 
and t1.apt_balance_status!='CANCELLED'
and t1.apt_number not in (select apm_m_number from mt_ap_match_details
where  (apm_m_number=t1.apt_number or apm_t_number=t1.apt_number) and apm_m_ar=:art_code and apm_status!='CANCELLED') 

) group_table ");
$statement->execute(array(':art_code'=>$art_code, ':to_date'=>$to_date));
$data["ageing"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get Opening Balance
$statement = $db->prepare("SELECT t1.art_doc_date, t1.art_number, t1.art_local_amount, t1.art_local_balance, DATEDIFF(:to_date, t1.art_doc_date) ageing FROM mt_ar_trans t1  
WHERE t1.art_code=:art_code and t1.art_type='OPENING BALANCE' 
UNION 
SELECT t1.apt_doc_date, t1.apt_number, t1.apt_local_amount, t1.apt_local_balance, DATEDIFF(:to_date, t1.apt_doc_date) ageing FROM mt_ap_trans t1  
WHERE t1.apt_code=:art_code and t1.apt_type='OPENING BALANCE' ");
$statement->execute(array(':art_code'=>$art_code, ':to_date'=>$to_date));
$data["op_bal"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get EPDA detail
$statement = $db->prepare("SELECT sub_ar_code, sub_ar_doc_number, sub_ar_date, sub_ar_currency, sub_ar_l_amount, sub_ar_narration, order_no, bl_no
 from mt_ship_ar_header 
 where sub_ar_code=:art_code and sub_ar_doc_base='EPDA'  and sub_ar_status!='CANCELLED' ");
$statement->execute(array(':art_code'=>$art_code));
$data["epda"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}




public static function get_age_analysis_summary_receivable($st,$to_date,$username)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT location from user_master
where username=:username ");
$statement->execute(array(':username'=>$username));
$data["location"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$location_id=$data["location"][0]["location"];

if($st=="WIH ZERO")
{
$statement = $db->prepare("SELECT mt1.code art_code,mt1.name name,mobile1,
  ifnull(c1,0) c1,ifnull(c2,0) c2,ifnull(c3,0) c3,
  ifnull(c4,0) c4,ifnull(c5,0) c5,ifnull(total,0) total 
  from mt_business_partner mt1
LEFT JOIN
(SELECT art_code, name, mobile1, sum(c1) c1, sum(c2) c2, sum(c3) c3, sum(c4) c4, sum(c5) c5, sum(total) total
FROM 
(SELECT t1.art_code, t2.name, t3.mobile1, 
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  between 0 and 30 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c1',
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  between 31 and 60 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c2',
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  between 61 and 90 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c3',
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  between 91 and 120 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c4',
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  > 120 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c5',
sum(
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
) total 
FROM mt_ar_trans t1 
LEFT JOIN mt_business_partner t2 
ON t1.art_code=t2.code 
LEFT JOIN mt_bp_address t3
ON t2.id=t3.bp_id
WHERE  t1.art_type in ('OPENING BALANCE','PRO-INV','IMP-INV', 'EXP-INV', 'GENERAL INVOICE', 'DEBIT NOTE', 'CREDIT NOTE', 'CARD', 'CASH','ONLINE TRANSFER','CHEQUE','VAT CHARGEABLE') 

and t1.art_balance_status!='CANCELLED'
and t2.tag!='SUPPLIER' 
and t1.location_id=:location_id 

GROUP BY t1.art_code, t2.name, t3.mobile1 
UNION 
SELECT t1.apt_code art_code, t2.name, t3.mobile1,
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  between 0 and 30 then 
(CASE WHEN apt_number like 'LPO/%' then -abs(apt_local_balance) WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c1',
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  between 31 and 60 then 
(CASE WHEN apt_number like 'LPO/%' then -abs(apt_local_balance) WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c2',
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  between 61 and 90 then 
(CASE WHEN apt_number like 'LPO/%' then -abs(apt_local_balance) WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c3',
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  between 91 and 120 then 
(CASE WHEN apt_number like 'LPO/%' then -abs(apt_local_balance) WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c4',
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  > 120 then 
(CASE WHEN apt_number like 'LPO/%' then -abs(apt_local_balance) WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c5',
sum(
(CASE WHEN apt_number like 'LPO/%' then -abs(apt_local_balance) WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
) total 
FROM mt_ap_trans t1 
LEFT JOIN mt_business_partner t2 
ON t1.apt_code=t2.code 
LEFT JOIN mt_bp_address t3
ON t2.id=t3.bp_id
WHERE  t1.apt_type in ('OPENING BALANCE','PRO-INV','IMP-INV', 'EXP-INV', 'GENERAL INVOICE', 'DEBIT NOTE', 'CREDIT NOTE', 'CARD', 'CASH','ONLINE TRANSFER','CHEQUE','VAT CHARGEABLE')  
and t1.apt_balance_status!='CANCELLED' 
and t2.tag!='SUPPLIER' 
and t1.location_id=:location_id 

GROUP BY t1.apt_code, t2.name, t3.mobile1

 ) group_table
 GROUP BY art_code, name, mobile1  
ORDER BY art_code) mt2  
on mt1.code=mt2.art_code order by code");

$statement->execute(array(':to_date'=>$to_date,':location_id'=>$location_id));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

}else{
  //without zero
  //
  $statement = $db->prepare("SELECT art_code,name,c1,c2,c3,c4,c5,total,mobile1 from (SELECT art_code, name,bp_id, sum(c1) c1, sum(c2) c2, sum(c3) c3, sum(c4) c4, sum(c5) c5, sum(total) total
FROM 
(SELECT t1.art_code, t2.name,t2.id bp_id,t1.art_number, sum(case when DATEDIFF(:to_date, t1.art_gl_date)  between 0 and 30 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c1',
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  between 31 and 60 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c2',
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  between 61 and 90 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c3',
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  between 91 and 120 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c4',
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  > 120 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c5',
sum(
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
) total 
FROM mt_ar_trans t1 
LEFT JOIN mt_business_partner t2 
ON t1.art_code=t2.code
WHERE  t1.art_type in ('PETTY CASH','OPENING BALANCE','PRO-INV','IMP-INV', 'EXP-INV', 'GENERAL INVOICE', 'DEBIT NOTE', 'CREDIT NOTE', 'CARD', 'CASH','ONLINE TRANSFER','CHEQUE','JV','BROKERAGE','VAT CHARGEABLE') 
and truncate(t1.art_local_balance,2)!=0 
and t1.art_balance_status!='CANCELLED'
and art_number not like 'PBC%'  
and t2.tag!='SUPPLIER' 
and t1.location_id=:location_id 

GROUP BY t1.art_code, t2.name,t2.id,t1.art_number 
UNION 
SELECT t1.apt_code art_code, t2.name,t2.id bp_id,t1.apt_number art_number,
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  between 0 and 30 then 
(CASE WHEN apt_number like 'LPO/%' then -abs(apt_local_balance) WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c1',
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  between 31 and 60 then 
(CASE WHEN apt_number like 'LPO/%' then -abs(apt_local_balance) WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c2',
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  between 61 and 90 then 
(CASE WHEN apt_number like 'LPO/%' then -abs(apt_local_balance) WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c3',
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  between 91 and 120 then 
(CASE WHEN apt_number like 'LPO/%' then -abs(apt_local_balance) WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c4',
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  > 120 then 
(CASE WHEN apt_number like 'LPO/%' then -abs(apt_local_balance) WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c5',
sum(
(CASE WHEN apt_number like 'LPO/%' then -abs(apt_local_balance) WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
) total 
FROM mt_ap_trans t1 
LEFT JOIN mt_business_partner t2 
ON t1.apt_code=t2.code 
WHERE  t1.apt_type in ('PETTY CASH','OPENING BALANCE','PRO-INV','IMP-INV', 'EXP-INV', 'GENERAL INVOICE', 'DEBIT NOTE', 'CREDIT NOTE', 'CARD', 'CASH','ONLINE TRANSFER','CHEQUE','JV','BROKERAGE','VAT CHARGEABLE') 
and truncate(t1.apt_local_balance,2)!=0 
and t1.apt_balance_status!='CANCELLED' 
and t2.tag!='SUPPLIER' 
and t1.location_id=:location_id 

GROUP BY t1.apt_code, t2.name,t2.id, t1.apt_number  
 ) group_table
 GROUP BY art_code, name,bp_id) nt1 LEFT JOIN (SELECT * from mt_bp_address where type='HQ' limit 1) nt2 on nt1.bp_id=nt2.bp_id");
$statement->execute(array(':to_date'=>$to_date,':location_id'=>$location_id));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

/*
old query

SELECT art_code, name, mobile1, sum(c1) c1, sum(c2) c2, sum(c3) c3, sum(c4) c4, sum(c5) c5, sum(total) total
FROM 
(SELECT t1.art_code, t2.name, t3.mobile1,t1.art_number, sum(case when DATEDIFF(:to_date, t1.art_gl_date)  between 0 and 30 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c1',
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  between 31 and 60 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c2',
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  between 61 and 90 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c3',
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  between 91 and 120 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c4',
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  > 120 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c5',
sum(
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
) total 
FROM mt_ar_trans t1 
LEFT JOIN mt_business_partner t2 
ON t1.art_code=t2.code 
LEFT JOIN mt_bp_address t3
ON t2.id=t3.bp_id
WHERE  t1.art_type in ('PETTY CASH','OPENING BALANCE','PRO-INV','IMP-INV', 'EXP-INV', 'GENERAL INVOICE', 'DEBIT NOTE', 'CREDIT NOTE', 'CARD', 'CASH','ONLINE TRANSFER','CHEQUE','JV') 
and truncate(t1.art_local_balance,2)!=0 
and t1.art_balance_status!='CANCELLED'
and art_number not like 'PBC%'  
and t2.tag!='SUPPLIER' 
and t1.location_id=:location_id 
GROUP BY t1.art_code, t2.name, t3.mobile1,t1.art_number 
UNION 
SELECT t1.apt_code art_code, t2.name, t3.mobile1,t1.apt_number art_number,
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  between 0 and 30 then 
(CASE WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c1',
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  between 31 and 60 then 
(CASE WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c2',
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  between 61 and 90 then 
(CASE WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c3',
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  between 91 and 120 then 
(CASE WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c4',
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  > 120 then 
(CASE WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c5',
sum(
(CASE WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
) total 
FROM mt_ap_trans t1 
LEFT JOIN mt_business_partner t2 
ON t1.apt_code=t2.code 
LEFT JOIN mt_bp_address t3
ON t2.id=t3.bp_id
WHERE  t1.apt_type in ('PETTY CASH','OPENING BALANCE','PRO-INV','IMP-INV', 'EXP-INV', 'GENERAL INVOICE', 'DEBIT NOTE', 'CREDIT NOTE', 'CARD', 'CASH','ONLINE TRANSFER','CHEQUE','JV') 
and truncate(t1.apt_local_balance,2)!=0 
and t1.apt_balance_status!='CANCELLED' 
and t2.tag!='SUPPLIER' 
and t1.location_id=:location_id 

GROUP BY t1.apt_code, t2.name, t3.mobile1,t1.apt_number  
 ) group_table
 GROUP BY art_code, name, mobile1 
 
*/
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_cb_summary($fc,$tc,$from_date,$to_date,$username)
{
$data=array();
try
{
$db = Factory::getConnection();

//Get Location
$statement = $db->prepare("SELECT location,company from user_master
where username=:username ");
$statement->execute(array(':username'=>$username));
$data["location"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT cb_doc_date,cb_gl_date,
    (SELECT description FROM mt_bank_list where bank_code=cb_code limit 1) cb_code,
cb_doc_type,cb_doc_number,cb_cheque_number,cb_cheque_date,cb_clearance_date,cb_foreign_amount,cb_local_amount,
location_id, company_id FROM mt_cash_book_details where (cb_doc_date between :from_date and :to_date) and (cb_code between :fc and :tc) 
and cb_status!='CANCELLED' 
order by cb_gl_date ");

$statement->execute(array(':fc'=>$fc,':tc'=>$tc,
  ':from_date'=>$from_date,':to_date'=>$to_date));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);
}
catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



}
?>