<?php


require("../config/dbconn.php");

class TDSReportDao

{



public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

//TDS PAYABLE
public static function get_output_tds_report($dev,$from_date,$to_date,$username)
{
$data=array();
try
{
$db = Factory::getConnection();

//Get Location
$statement = $db->prepare("SELECT location from user_master
where username=:username ");
$statement->execute(array(':username'=>$username));
$data["location"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$location_id=$data["location"][0]["location"];

$statement = $db->prepare(" 

SELECT '1' as 'Deductee Serial No',
t1.aloc_doc_number as 'Doc Number',
case when t2.aph_document_type='LPO' THEN
(select nature_of_payment from mt_tds_master where section='94C')
ELSE
(select nature_of_payment from mt_tds_master where section='94J')
end as 'GL Description',
(select pan from mt_business_partner where code=t1.aloc_detail_2 limit 1) as 'PAN of the Deductee',
(select name from mt_business_partner where code=t1.aloc_detail_2 limit 1) as 'Name of the Deductee',
t2.aph_document_date as 'Date of payment/ credit',
 t1.aloc_local_amount as 'Amount Paid/ Credited',
 t1.aloc_local_amount as 'TDS',
'0' as 'Surcharge',
'0' as 'Education Cess',
t1.aloc_local_amount as 'Total Tax Deducted',
t1.aloc_local_amount as 'Total Tax Deposited',
t2.aph_document_date as 'Date of Deduction',
 t1.aloc_detail_1,  t1.aloc_detail_3, round((t1.aloc_local_amount/t1.tds_appl_amt)*100,1) as 'Rate at Which Deducted',
(select address from mt_bp_address where bp_id=(select id from mt_business_partner where code=t1.aloc_detail_2 limit 1) limit 1) as 'Deductee Address',

case when t2.aph_document_type='LPO' THEN
'94C'
ELSE
'94J'
end as 'Section'

FROM mt_ap_allocation_details t1
left join mt_ap_header t2
on t1.aloc_doc_number=t2.aph_document_number
WHERE t1.aloc_doc_type='TDS PAYABLE' 
 and t2.aph_document_date between :from_date and :to_date 
 and t2.aph_status!='CANCELLED'  
 and t2.location_id=:location_id 

     ");
$statement->execute(array(':from_date'=>$from_date, ':to_date'=>$to_date,':location_id'=>$location_id));
$data["dList"]=$statement->fetchAll(PDO::FETCH_ASSOC);

  if ($statement->rowCount()){
    $data["status"]=1;
  } else{
    $data["status"]=0;
  }
  
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_input_tds_report($dev,$from_date,$to_date,$username)
{
$data=array();
try
{
$db = Factory::getConnection();

//Get Location
$statement = $db->prepare("SELECT location from user_master
where username=:username ");
$statement->execute(array(':username'=>$username));
$data["location"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$location_id=$data["location"][0]["location"];

$statement = $db->prepare(" 

SELECT '1' as 'Deductee Serial No',
t1.aloc_doc_number as 'Doc Number',
case when t2.aph_document_type='LPO' THEN
(select nature_of_payment from mt_tds_master where section='94C')
ELSE
(select nature_of_payment from mt_tds_master where section='94J')
end as 'GL Description',
(select pan from mt_business_partner where code=t1.aloc_detail_2 limit 1) as 'PAN of the Deductee',
(select name from mt_business_partner where code=t1.aloc_detail_2 limit 1) as 'Name of the Deductee',
t2.aph_document_date as 'Date of payment/ credit',
 t1.aloc_local_amount as 'Amount Paid/ Credited',
 t1.aloc_local_amount as 'TDS',
'0' as 'Surcharge',
'0' as 'Education Cess',
t1.aloc_local_amount as 'Total Tax Deducted',
t1.aloc_local_amount as 'Total Tax Deposited',
t2.aph_document_date as 'Date of Deduction',
 t1.aloc_detail_1,  t1.aloc_detail_3, round((t1.aloc_local_amount/t1.tds_appl_amt)*100,1) as 'Rate at Which Deducted',
(select address from mt_bp_address where bp_id=(select id from mt_business_partner where code=t1.aloc_detail_2 limit 1) limit 1) as 'Deductee Address',

case when t2.aph_document_type='LPO' THEN
'94C'
ELSE
'94J'
end as 'Section'

FROM mt_ap_allocation_details t1
left join mt_ap_header t2
on t1.aloc_doc_number=t2.aph_document_number
WHERE t1.aloc_doc_type='TDS PAYABLE' 
 and t2.aph_document_date between :from_date and :to_date 
 and t2.aph_status!='CANCELLED'  
 and t2.location_id=:location_id 

     ");
$statement->execute(array(':from_date'=>$from_date, ':to_date'=>$to_date,':location_id'=>$location_id));
$data["dList"]=$statement->fetchAll(PDO::FETCH_ASSOC);

  if ($statement->rowCount()){
    $data["status"]=1;
  } else{
    $data["status"]=0;
  }
  
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

}
?>