<?php


require("../config/dbconn.php");
require('../settings/get-settings.php');
require('../booking/get-currency.php');

class FinanceDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


//generating sequence no for voucher doc type
public static function generate_voucher_no1($db,$dev,$table,$temp_code)
{
$data=array();
$result=0;


$table=strtolower($table);
$statement = $db->prepare("INSERT into ".$table."(
  created_by,created_date,temp_code) 
values(:created_by,now(),:temp_code)");
$statement->execute(array(
  ':created_by'=>$dev->username ,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement = $db->prepare("SELECT COUNT(*)+1 rid FROM $table where id<(SELECT id from $table where created_by=:created_by and temp_code=:temp_code) ");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$result=$data["id"][0]["rid"];

  
  return $result;
}

//generating sequence no for voucher doc type
public static function generate_voucher_no($dev,$table,$temp_code)
{
$data=array();
$result=0;
try
{
$db = Factory::getConnection();
//$temp_code=uniqid($dev->uid);
$table=strtolower($table);
$statement = $db->prepare("INSERT into ".$table."(
  created_by,created_date,temp_code) 
values(:created_by,now(),:temp_code)");
$statement->execute(array(
  ':created_by'=>$dev->username ,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement = $db->prepare("SELECT COUNT(*)+1 rid FROM $table where id<(SELECT id from $table where created_by=:created_by and temp_code=:temp_code) ");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$result=$data["id"][0]["rid"];
//echo "es====".$result;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $result;
}

public static function save_voucher_attachment($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_voucher_attach(
mnf_entry_pk,doc_type,
file_name,file_url,
company_id,location_id,ip,created_by, ua,ekey,created_date,temp_code) 
values(
:mnf_entry_pk,
:doc_type,
:file_name,:file_url,
:company_id,:location_id,
:ip,:created_by,:ua,:ekey,now(),:temp_code)");
$statement->execute(array(':ip'=>$dev->ip,
  ':created_by'=>$dev->username ,
  ':ua'=>$dev->ua,':ekey'=>$dev->ekey,

':mnf_entry_pk'=>$c->mnf_entry_pk,
':doc_type'=>$c->doc_type,

':temp_code'=>$temp_code,
':company_id'=>$dev->company,
':location_id'=>$dev->location,
':file_name'=>$c->file_name,
':file_url'=>$c->file_url
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement = $db->prepare("SELECT id from mt_voucher_attach where created_by=:created_by and temp_code=:temp_code and mnf_entry_pk=:mnf_entry_pk");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username,':mnf_entry_pk'=>$c->mnf_entry_pk));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_voucher_attachment($id)
{
$data=false;
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT id,
mnf_entry_pk,doc_type,file_name,file_url,
'0' edit 
from mt_voucher_attach where mnf_entry_pk=:mnf_entry_pk");
$statement->execute(array(':mnf_entry_pk'=>$id));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function delete_voucher_attachment($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("DELETE from mt_voucher_attach 
   where id=:id");
$statement->execute(array(
  ':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function getFinancialYear()
{
//$year = ( date('m') > 4) ? date('Y') + 1 : date('Y');
$year=date('Y');
return $year;
}

public static function getFinancialPeriod($doc_date)
{

//$year = ( date('m') > 4) ? date('Y') + 1 : date('Y');
//$period=4;
//return $period;
$data=false;
try
{
$db = Factory::getConnection();

//$aq=self::getRestrictionQuery($dev);
//$doc_date="2019-12-15";
$date=date_create($doc_date);
$m= date_format($date,"F");
$y= date_format($date,"Y");

$statement = $db->prepare("SELECT enumber from mt_period 
  where period=:period and year=:year and open_max='OPEN'");

$statement->execute(array(':period'=>$m,':year'=>$y));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
//var_dump($statement->debugDumpParams());
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  $p=-10;
  if(count($data)==1)
  {
    $p=$data[0]["enumber"];
  }
  return $p;
}


public static function getRestrictionQuery($dev)
{
  $q="";
  if($dev->view_type=="USER")
  {
    $q=" company_id='$dev->company' and location_id='$dev->location'";
  }
  return $q; 
}

public static function get_pdc_list($code)
{
$data=array();
try
{
$db = Factory::getConnection();

//$aq=self::getRestrictionQuery($dev);

$statement = $db->prepare("SELECT ph_company, ph_doc_number,  ph_base_doc_type, ph_doc_type, ph_doc_date, 
ph_gl_date, ph_cash_bank_code, ph_currency, ph_exchange_rate, ph_foreign_amount, 
ph_local_amount, ph_other_reference, ph_cheque_number, ph_cheque_date, ph_narration, 
ph_notes, ph_status, ph_gl_account, '' bank,'0' saving,'' status,
'' clr_date   
FROM mt_payment_header 
WHERE ph_status='AWAITING CONFIRMATION'");
$statement->execute(array());
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//var_dump($statement->debugDumpParams());

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_pdc_receivable_list($code)
{
$data=array();
try
{
$db = Factory::getConnection();

//$aq=self::getRestrictionQuery($dev);

$statement = $db->prepare("SELECT rh_company ph_company, rh_doc_number ph_doc_number,  rh_base_doc_type ph_base_doc_type, rh_doc_type ph_doc_type, rh_doc_date ph_doc_date, 
rh_gl_date ph_gl_date, rh_cash_bank_code ph_cash_bank_code, rh_currency ph_currency, rh_exchange_rate ph_exchange_rate, rh_foreign_amount ph_foreign_amount, 
rh_local_amount ph_local_amount, rh_other_reference ph_other_reference, rh_cheque_number ph_cheque_number, rh_cheque_date ph_cheque_date, rh_narration ph_narration, 
rh_notes ph_notes, rh_status ph_status, rh_gl_account ph_gl_account,
'' bank,'0' saving,'' status,
'' clr_date 
FROM mt_receipt_header 
WHERE rh_status='AWAITING CONFIRMATION'");
$statement->execute(array());
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//var_dump($statement->debugDumpParams());

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

//SAVE PDC CONFIRM
public static function save_pdc_confirmation($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$doc_date=$c->clr_date;
$doc_no=$c->ph_doc_number;
$temp_code=uniqid($dev->uid);

//query 3
if($c->status=='BOUNCED')
{

$statement = $db->prepare("UPDATE mt_payment_header set ph_status='BOUNCED',ph_clearance_date='$doc_date',ph_cash_bank_code='$c->bank'
  where ph_doc_number=:id");

$statement->execute(array(':id'=>$doc_no
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
  
}


if($data["status"]==1)
{
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}


}else{

//start of clearance
$statement = $db->prepare("INSERT into mt_ap_trans 
(apt_company,apt_code,apt_type,apt_number,apt_serial,apt_group,
apt_base_type,apt_internal,apt_other_reference,apt_doc_date,
apt_gl_date,apt_year,apt_period,apt_age_date,
apt_dp_date,apt_currency,apt_ex_rate,apt_foreign_amount,
apt_local_amount,apt_foreign_balance,
apt_local_balance,apt_balance_status,
apt_description,apt_notes,
ip,created_by ,ua,ekey,created_date,temp_code,
company_id,location_id)
SELECT aloc_company,aloc_detail_2,aloc_doc_type,aloc_doc_number,
1,aloc_detail_1,aloc_base_doc,0,
aloc_detail_5,
'$doc_date','$doc_date',".self::getFinancialYear().",
".self::getFinancialPeriod($doc_date).",
'$doc_date','$doc_date',aloc_currency,aloc_ex_rate,
aloc_foreign_amount,aloc_local_amount,aloc_foreign_amount,
aloc_local_amount,'A',
aloc_narration,aloc_detail_3,
ip,created_by,ua ,ekey,now(),'$temp_code',
'$dev->company','$dev->location'   
FROM mt_payment_allocation_details where aloc_doc_number=:id");

$statement->execute(array(':id'=>$doc_no
));

if ($statement->rowCount()){
  $data["ap_trans_status"]=1;
} else{
  $data["ap_trans_status"]=0;
}
//query 3 ends


//query 4 part1 header

$pcode='';
//if($info->doc_type=="PETTY CASH")
//{
//  $pcode=$bank->petty_cash;
//}
//else
//{
  //$gls=self::get_bank_gl_code($dev,$c->ph_cash_bank_code);
  $gls=self::get_bank_gl_code($dev,$c->bank);
  //$pcode=$gls[0]["account_no"];
  $pcode='';
  if(count($gls)>=1)
  {
    $pcode=$gls[0]["account_no"];
  }else{
    throw new Exception("Value must be 1 or below");
  }
//}

$statement = $db->prepare("INSERT into mt_payment_gl_details
(pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,
  pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,
  pre_glt_ex_rate,pre_glt_foreign_amount,
  pre_glt_local_amount,pre_glt_narration,
ip,created_by ,ua,ekey,created_date,temp_code,pre_glt_detail_1, 
location_id,company_id)
SELECT ph_company,
'$pcode',
ph_base_doc_type,ph_doc_type,
ph_doc_number,ph_internal_number,ph_doc_date,
ph_gl_date,".self::getFinancialYear().",".
self::getFinancialPeriod($doc_date).",ph_other_reference,ph_currency,
ph_exchange_rate,ph_foreign_amount,
ph_local_amount,ph_narration,
ip,created_by,ua ,ekey,now(),'$temp_code',ph_cost_center,
'$dev->company','$dev->location'   
FROM mt_payment_header  where ph_doc_number=:id");

$statement->execute(array(':id'=>$doc_no));

if ($statement->rowCount()){
  $data["ah_gl_status"]=1;
} else{
  $data["ah_gl_status"]=0;
}
//query 4 ends


//query 4 part2 child
$statement = $db->prepare("INSERT into mt_payment_gl_details
(pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,
  pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,
  pre_glt_ex_rate,pre_glt_foreign_amount,
  pre_glt_local_amount,pre_glt_narration,
  pre_glt_allocation_code,pre_glt_detail_1,
  pre_glt_detail_2,pre_glt_detail_3,
ip,created_by ,ua,ekey,created_date,temp_code, 
location_id,company_id)
SELECT aloc_company,aloc_detail_1,
aloc_base_doc,aloc_doc_type,
aloc_doc_number,aloc_serial,'$doc_date',
'$doc_date',".self::getFinancialYear().",".
self::getFinancialPeriod($doc_date).",aloc_narration,aloc_currency,
aloc_ex_rate,aloc_foreign_amount,
aloc_local_amount,aloc_narration,
aloc_allocation_type,aloc_detail_1,
aloc_detail_2,aloc_detail_3,
ip,created_by,ua ,ekey,now(),'$temp_code',
'$dev->company','$dev->location'   
FROM mt_payment_allocation_details where aloc_doc_number=:id
");

$statement->execute(array(':id'=>$doc_no));

if ($statement->rowCount()){
  $data["ah_gl_status2"]=1;
} else{
  $data["ah_gl_status2"]=0;
}
//query 4 part2 ends


//query 5
$statement = $db->prepare("INSERT into mt_ap_trans_balance
(apdm_company,apdm_code,apdm_doc_type,apdm_doc_number,
  apdm_serial,apdm_other_reference,apdm_date,apdm_currency,
  apdm_ex_rate,apdm_of_amount,apdm_ol_amount,apdm_bf_amount,
  apdm_bl_amount,apdm_pf_amount,apdm_pl_amount,apdm_status,
ip,created_by ,ua,ekey,created_date,temp_code,
company_id,location_id)
SELECT apt_company,apt_code,apt_type,apt_number,
apt_serial,apt_other_reference,apt_gl_date,apt_currency,
apt_ex_rate,apt_foreign_amount,apt_local_amount,
apt_foreign_balance,apt_local_balance,
0,0,'PENDING',ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location'  
 from mt_ap_trans where apt_number=:doc_no
");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["tb_status"]=1;
} else{
  $data["tb_status"]=0;
}
//query 5 ends

//get ar trans count
$statement = $db->prepare("SELECT * FROM mt_ar_trans where art_number=:doc_no");
$statement->execute(array(':doc_no'=>$doc_no));
$ar_trans_list=$statement->fetchAll(PDO::FETCH_ASSOC);

//AD QUERY 1
$statement = $db->prepare("INSERT into mt_ar_trans_balance
(ardm_company,ardm_code,ardm_doc_type,ardm_doc_number,
  ardm_serial,ardm_other_reference,ardm_date,ardm_currency,
  ardm_ex_rate,ardm_of_amount,ardm_ol_amount,
  ardm_bf_amount,ardm_bl_amount,
  ardm_pf_amount,ardm_pl_amount,ardm_status,
ip,created_by,ua,ekey,created_date,temp_code,company_id,location_id)

SELECT art_company,art_code,art_type,art_number,
art_serial,art_other_reference,art_gl_date,art_currency,
art_ex_rate,art_foreign_amount,art_local_amount,
art_foreign_balance,art_local_balance,
0,0,'PENDING',
ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location' 
 from mt_ar_trans where art_number=:doc_no");
$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
    $data["pay_artb_status"]=1;
  } else{
    $data["pay_artb_status"]=0;
  }

//query 6
$statement = $db->prepare("INSERT into mt_cash_book_details 
( cb_company,cb_doc_type,cb_doc_number,cb_internal_number,cb_base_doc_type,cb_code,cb_type,cb_gl_date,cb_doc_date,cb_due_pay_date,cb_year,cb_period,cb_currency,cb_ex_rate,cb_foreign_amount,cb_local_amount,cb_cheque_number,cb_cheque_date,cb_account,cb_status,
  ip,created_by ,ua,ekey,
  created_date,temp_code,cb_flex_1) 
SELECT ph_company,ph_doc_type,ph_doc_number,ph_internal_number,
ph_base_doc_type,'$c->bank',ph_type,
ph_gl_date,'$doc_date','$doc_date',".self::getFinancialYear().",".
self::getFinancialPeriod($doc_date).",ph_currency,ph_exchange_rate,
ph_foreign_amount,ph_local_amount,
ph_cheque_number,ph_cheque_date,ph_gl_account,'POSTED',
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$temp_code',ph_cost_center
 from mt_payment_header where ph_doc_number=:doc_no");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["cb_status"]=1;
} else{
  $data["cb_status"]=0;
}
//query 6 ends

//get bank count
$statement = $db->prepare("SELECT * FROM mt_payment_allocation_details where aloc_doc_number=:doc_no and aloc_allocation_type='BANK' ");
$statement->execute(array(':doc_no'=>$doc_no));
$bank_list=$statement->fetchAll(PDO::FETCH_ASSOC);

//add in the cash book details for reporting

$statement = $db->prepare("INSERT into mt_cash_book_details 
( cb_company,cb_doc_type,cb_doc_number,cb_internal_number,cb_base_doc_type,
  cb_code,cb_type,cb_gl_date,cb_doc_date,cb_due_pay_date,cb_year,cb_period,cb_currency,
  cb_ex_rate,cb_foreign_amount,cb_local_amount,cb_account,cb_cheque_number,cb_cheque_date,
  cb_status,
  ip,created_by ,ua,ekey,
  created_date,temp_code) 
SELECT aloc_company,aloc_doc_type,
aloc_doc_number,aloc_serial,aloc_base_doc,'$c->bank',aloc_allocation_type,
'$doc_date','$doc_date','$doc_date',".self::getFinancialYear().",".
self::getFinancialPeriod($doc_date).",aloc_currency,
aloc_ex_rate,aloc_foreign_amount,
aloc_local_amount,aloc_detail_1,
aloc_detail_2,aloc_detail_3,'POSTED',
ip,created_by,ua ,ekey,now(),'$temp_code'  
FROM mt_payment_allocation_details where aloc_doc_number=:doc_no and aloc_allocation_type='BANK' ");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["cb_status_child"]=1;
} else{
  $data["cb_status_child"]=0;
}

//UPDATE QUERY 
$statement = $db->prepare("UPDATE mt_payment_header 
  set ph_status='POSTED' where ph_doc_number=:id");
$statement->execute(array(':id'=>$doc_no));

if ($statement->rowCount()){
  $data["upd_posted_status"]=1;
  $data["status"]=1;
} else{
  $data["upd_posted_status"]=0;
  $data["status"]=0;
}

$ar_trans_status=true;
if(count($ar_trans_list)>0)
{
  if($data["pay_artb_status"]==0)
  {
    $ar_trans_status=false;
  }
}

$bank_child_status=true;
if(count($bank_list)>0)
{
  if($data["cb_status_child"]==0)
  {
    $bank_child_status=false;
  }
}
if($data["status"]==1 && $data["ap_trans_status"]==1 && $data["ah_gl_status"]==1 && $data["ah_gl_status2"]==1 && $data["tb_status"]==1 && $data["cb_status"]==1 && $bank_child_status && $data["upd_posted_status"]==1 && $ar_trans_status)
{
  $db->commit();
}else{
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
}

}// end of clearance


$statement=null;

  }
  catch (Exception $e) {
    //print $e->getMessage();
    $data["msg"]=$e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
  }
  
  return $data;
}

//SAVE PDC RECEIVABLE
public static function save_pdc_confirmation_receivable($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$doc_date=$c->clr_date;
$doc_no=$c->ph_doc_number;
$temp_code=uniqid($dev->uid);

//query 3
if($c->status=='BOUNCED')
{

$statement = $db->prepare("UPDATE mt_receipt_header set rh_status='BOUNCED',rh_clearance_date='$doc_date',rh_cash_bank_code='$c->bank'
  where rh_doc_number=:id");

$statement->execute(array(':id'=>$doc_no
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
  
}


if($data["status"]==1)
{
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}



}else{

  //query 3
$statement = $db->prepare("INSERT into mt_ar_trans 
(art_company,art_code,art_type,art_number,art_serial,art_group,
art_base_type,art_internal,art_other_reference,art_doc_date,
art_gl_date,art_year,art_period,art_age_date,
art_dp_date,art_currency,art_ex_rate,art_foreign_amount,
art_local_amount,art_foreign_balance,
art_local_balance,art_balance_status,
art_description,art_notes,
ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id)
SELECT aloc_company,aloc_detail_2,aloc_doc_type,aloc_doc_number,
1,aloc_detail_1,aloc_base_doc,0,
aloc_detail_5,
'$doc_date','$doc_date',".self::getFinancialYear().",".self::getFinancialPeriod($doc_date).",
'$doc_date','$doc_date',aloc_currency,aloc_ex_rate,
aloc_foreign_amount,aloc_local_amount,aloc_foreign_amount,
aloc_local_amount,'A',
aloc_narration,aloc_detail_3,
ip,created_by,ua ,ekey,now(),'$temp_code','$dev->company','$dev->location'  
FROM mt_receipt_allocation_details where aloc_doc_number=:id");

$statement->execute(array(':id'=>$doc_no
));

if ($statement->rowCount()){
  $data["ar_trans_status"]=1;
} else{
  $data["ar_trans_status"]=0;
}
//query 3 ends


//query 4 part1 header
//$gls=self::get_gl_link($dev,'RECEIVABLE');
$gls=self::get_bank_gl_code($dev,$c->bank);

//$pcode=$gls[0]["account_no"];
  $pcode='';
  if(count($gls)>=1)
  {
    $pcode=$gls[0]["account_no"];
  }else{
    throw new Exception("Value must be 1 or below");
  }

$statement = $db->prepare("INSERT into mt_receipt_gl_details
(pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,
  pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,
  pre_glt_ex_rate,pre_glt_foreign_amount,
  pre_glt_local_amount,pre_glt_narration,
ip,created_by ,ua,ekey,created_date,temp_code, 
location_id,company_id)
SELECT rh_company,
'$pcode',
rh_base_doc_type,rh_doc_type,
rh_doc_number,rh_internal_number,rh_doc_date,
rh_gl_date,".self::getFinancialYear().",".
self::getFinancialPeriod($doc_date).",rh_other_reference,rh_currency,
rh_exchange_rate,rh_foreign_amount,
rh_local_amount,rh_narration,
ip,created_by,ua ,ekey,now(),'$temp_code',
'$dev->company','$dev->location'   
FROM mt_receipt_header  where rh_doc_number=:id");

$statement->execute(array(':id'=>$doc_no));
  
if ($statement->rowCount()){
  $data["ah_gl_status"]=1;
} else{
  $data["ah_gl_status"]=0;
}
//query 4 ends


//query 4 part2 child
$statement = $db->prepare("INSERT into mt_receipt_gl_details
(pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,
  pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,
  pre_glt_ex_rate,pre_glt_foreign_amount,
  pre_glt_local_amount,pre_glt_narration,
  pre_glt_allocation_code,pre_glt_detail_1,
  pre_glt_detail_2,pre_glt_detail_3,
ip,created_by ,ua,ekey,created_date,temp_code, 
location_id,company_id)
SELECT aloc_company,'$pcode',
aloc_base_doc,aloc_doc_type,
aloc_doc_number,aloc_serial,'$doc_date',
'$doc_date',".self::getFinancialYear().",".
self::getFinancialPeriod($doc_date).",aloc_narration,aloc_currency,
aloc_ex_rate,aloc_foreign_amount,
aloc_local_amount,aloc_narration,
aloc_allocation_type,aloc_detail_1,
aloc_detail_2,aloc_detail_3,
ip,created_by,ua ,ekey,now(),'$temp_code',
'$dev->company','$dev->location'   
FROM mt_receipt_allocation_details where aloc_doc_number=:id
");

$statement->execute(array(':id'=>$doc_no));

if ($statement->rowCount()){
  $data["ah_gl_status2"]=1;
} else{
  $data["ah_gl_status2"]=0;
}
//query 4 part2 ends


//query 5
$statement = $db->prepare("INSERT into mt_ar_trans_balance
(ardm_company,ardm_code,ardm_doc_type,ardm_doc_number,
  ardm_serial,ardm_other_reference,ardm_date,ardm_currency,
  ardm_ex_rate,ardm_of_amount,ardm_ol_amount,ardm_bf_amount,
  ardm_bl_amount,ardm_pf_amount,ardm_pl_amount,ardm_status,
ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id)
SELECT art_company,art_code,art_type,art_number,
art_serial,art_other_reference,art_gl_date,art_currency,
art_ex_rate,art_foreign_amount,art_local_amount,
art_foreign_balance,art_local_balance,
0,0,'PENDING',ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location' 
 from mt_ar_trans where art_number=:doc_no
");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["tb_status"]=1;
} else{
  $data["tb_status"]=0;
}
//query 5 ends

//get ar trans count
$statement = $db->prepare("SELECT * FROM mt_ap_trans where apt_number=:doc_no");
$statement->execute(array(':doc_no'=>$doc_no));
$ap_trans_list=$statement->fetchAll(PDO::FETCH_ASSOC);

//query 5
$statement = $db->prepare("INSERT into mt_ap_trans_balance
(apdm_company,apdm_code,apdm_doc_type,apdm_doc_number,
  apdm_serial,apdm_other_reference,apdm_date,apdm_currency,
  apdm_ex_rate,apdm_of_amount,apdm_ol_amount,apdm_bf_amount,
  apdm_bl_amount,apdm_pf_amount,apdm_pl_amount,apdm_status,
ip,created_by ,ua,ekey,created_date,temp_code,
company_id,location_id)
SELECT apt_company,apt_code,apt_type,apt_number,
apt_serial,apt_other_reference,apt_gl_date,apt_currency,
apt_ex_rate,apt_foreign_amount,apt_local_amount,
apt_foreign_balance,apt_local_balance,
0,0,'PENDING',ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location'  
 from mt_ap_trans where apt_number=:doc_no
");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["receipt_aptb_status"]=1;
} else{
  $data["receipt_aptb_status"]=0;
}

//query 6
$statement = $db->prepare("INSERT into mt_cash_book_details 
( cb_company,cb_doc_type,cb_doc_number,cb_internal_number,cb_base_doc_type,cb_code,cb_type,cb_gl_date,cb_doc_date,cb_due_pay_date,cb_year,cb_period,cb_currency,cb_ex_rate,cb_foreign_amount,cb_local_amount,cb_cheque_number,cb_cheque_date,cb_account,cb_status,
  ip,created_by ,ua,ekey,
  created_date,temp_code) 
SELECT rh_company,rh_doc_type,rh_doc_number,rh_internal_number,
rh_base_doc_type,'$c->bank',rh_type,
'$doc_date','$doc_date','$doc_date',".self::getFinancialYear().",".
self::getFinancialPeriod($doc_date).",rh_currency,rh_exchange_rate,
rh_foreign_amount,rh_local_amount,
rh_cheque_number,rh_cheque_date,rh_gl_account,'POSTED',
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$temp_code'
 from mt_receipt_header where rh_doc_number=:doc_no");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["cb_status"]=1;
} else{
  $data["cb_status"]=0;
}
//query 6 ends

//get bank count
$statement = $db->prepare("SELECT * FROM mt_receipt_allocation_details where aloc_doc_number=:doc_no and aloc_allocation_type='BANK'  ");
$statement->execute(array(':doc_no'=>$doc_no));
$bank_list=$statement->fetchAll(PDO::FETCH_ASSOC);

//add in the cash book details for reporting

$statement = $db->prepare("INSERT into mt_cash_book_details 
( cb_company,cb_doc_type,cb_doc_number,cb_internal_number,cb_base_doc_type,
  cb_code,cb_type,cb_gl_date,cb_doc_date,cb_due_pay_date,cb_year,cb_period,cb_currency,
  cb_ex_rate,cb_foreign_amount,cb_local_amount,cb_account,cb_cheque_number,cb_cheque_date,
  cb_status,
  ip,created_by ,ua,ekey,
  created_date,temp_code) 
SELECT aloc_company,aloc_doc_type,
aloc_doc_number,aloc_serial,aloc_base_doc,'$c->bank',aloc_allocation_type,
'$doc_date','$doc_date','$doc_date',".self::getFinancialYear().",".
self::getFinancialPeriod($doc_date).",aloc_currency,
aloc_ex_rate,aloc_foreign_amount,
aloc_local_amount,aloc_detail_1,
aloc_detail_2,aloc_detail_3,'POSTED',
ip,created_by,ua ,ekey,now(),'$temp_code'  
FROM mt_receipt_allocation_details where aloc_doc_number=:doc_no and aloc_allocation_type='BANK' ");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["cb_status_child"]=1;
} else{
  $data["cb_status_child"]=0;
}

//UPDATE QUERY 
$statement = $db->prepare("UPDATE mt_receipt_header 
  set rh_status='POSTED' where rh_doc_number=:id");
$statement->execute(array(':id'=>$doc_no));

if ($statement->rowCount()){
  $data["upd_posted_status"]=1;
  $data["status"]=1;
} else{
  $data["upd_posted_status"]=0;
  $data["status"]=0;
}

//$data["status"]=0;
$ap_trans_status=true;
if(count($ap_trans_list)>0)
{
  if($data["receipt_aptb_status"]==0)
  {
    $ap_trans_status=false;
  }
}

$bank_child_status=true;
if(count($bank_list)>0)
{
  if($data["cb_status_child"]==0)
  {
    $bank_child_status=false;
  }
}
if($data["status"]==1 && $data["ar_trans_status"]==1 && $data["ah_gl_status"]==1 && $data["ah_gl_status2"]==1 && $data["tb_status"]==1 && $data["cb_status"]==1 && $bank_child_status && $data["upd_posted_status"]==1 && $ap_trans_status)
{
  $db->commit();
}else{
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
}

}

$statement=null;

  }
  catch (Exception $e) {
    //print $e->getMessage();
    $data["emsg"]=$e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
  }
  
  return $data;
}
//SAVE PDC RECEIVABLE ENDS

public static function get_matching($db,$c)
{

$statement = $db->prepare("SELECT 2 FROM mt_ar_match_details
 WHERE (arm_t_number =:doc_no or arm_m_number=:doc_no) and 
 arm_status in ('PENDING','COMPLETED')
 UNION
 SELECT 2 FROM mt_ap_match_details
 WHERE (apm_t_number =:doc_no or apm_m_number=:doc_no) and 
 apm_status in ('PENDING','COMPLETED')
 UNION
 SELECT 2 FROM mt_arap_match_details
 WHERE (arm_t_number =:doc_no or arm_m_number=:doc_no) and 
 arm_status in ('PENDING','COMPLETED')
 ");
$statement->execute(array(
  ':doc_no'=>$c->doc_no));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

return $op;
}

public static function cancel_lpo($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

//check voucher matched or not
//if count is 1 or more then dont allow to cancel
//if 0 then there is no match so allow them to cancel
$op=self::get_matching($db,$c);
if(count($op)>=1)
{
  $data["status"]=0;
  $data["msg"]="Unable to Cancel. Voucher already matched. Please unmatch and try to cancel";
}else{

 //query 1
    $q="UPDATE mt_ap_header set aph_status='CANCELLED',aph_notes=:reason,modified_by=:modified_by,modified_date=now() where aph_document_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,
  ':reason'=>$c->notes,':modified_by'=>$dev->username);
    $data["status"]=self::cancel_voucher_queries($db,$q,$ar);
    if($data["status"]==0)
    {
  $data["msg"]="Unable to cancel the LPO";
    }else{
  $data["msg"]="LPO cancelled successfully.";
    }
     //query 2

         $statement = $db->prepare("UPDATE mt_order_cost 
        set inv_pay_no=NULL,invoiced=NULL where inv_pay_no=:doc_no");
        $statement->execute(array(':doc_no'=>$c->doc_no));
        if ($statement->rowCount()){
            $data["inv_cost_status"]=1;
          } else{
            $data["inv_cost_status"]=0;
          }


    //query 3
      $q="UPDATE mt_ap_trans set apt_balance_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where apt_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["ap_trans_status"]=self::cancel_voucher_queries($db,$q,$ar);

        //query 4
      $q="UPDATE mt_ap_gl_details set pre_glt_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where pre_glt_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["gl_status"]=self::cancel_voucher_queries($db,$q,$ar);

        //query 5
      $q="UPDATE mt_ap_trans_balance set apdm_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where apdm_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["tb_status"]=self::cancel_voucher_queries($db,$q,$ar);
    
     

    if($data["inv_cost_status"]==1 && $data["status"]==1 && $data["ap_trans_status"]==1 && $data["gl_status"]==1)
      {
        $db->commit();
      }else{
        $db->rollBack();
        $data["status"]=0;
        $data["msg"]="Unable to save. Please try again";
      }

    }


    $statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
    $db->rollBack();

  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";

  }
  
  return $data;
}

public static function cancel_voucher($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

//check voucher matched or not
//if count is 1 or more then dont allow to cancel
//if 0 then there is no match so allow them to cancel
$statement = $db->prepare("SELECT 2 FROM mt_ar_match_details
 WHERE (arm_t_number =:doc_no or arm_m_number=:doc_no) and 
 arm_status in ('PENDING','COMPLETED')
 UNION
 SELECT 2 FROM mt_ap_match_details
 WHERE (apm_t_number =:doc_no or apm_m_number=:doc_no) and 
 apm_status in ('PENDING','COMPLETED')
 UNION
 SELECT 2 FROM mt_arap_match_details
 WHERE (arm_t_number =:doc_no or arm_m_number=:doc_no) and 
 arm_status in ('PENDING','COMPLETED')
 ");
$statement->execute(array(
  ':doc_no'=>$c->doc_no));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

if(count($op)>=1)
{
  $data["status"]=0;
  $data["msg"]="Unable to Cancel. Voucher already matched. Please unmatch and try to cancel";
}else
{
  //allow to cancel

    if($c->doc_type=='INVOICE')
    {
          /*
          ***************************************
          cancelling invoice
          ***************************************

          */

        $isPro = false;

        if (strpos($c->doc_no, 'PRO/') !== false) {
              $isPro = true;
        }

        $data["isPro"]=$isPro;

          //query 1
        $statement = $db->prepare("UPDATE mt_ship_ar_header SET sub_ar_status='CANCELLED',sub_ar_notes=:reason,modified_by=:modified_by,modified_date=now() WHERE sub_ar_doc_number=:doc_no");
        $statement->execute(array(
          ':doc_no'=>$c->doc_no,
          ':reason'=>$c->notes,
          ':modified_by'=>$dev->username));
        if ($statement->rowCount()){
          $data["status"]=1;
          $data["msg"]="Cancellation of Voucher is successful";

        } else{
          $data["status"]=0;
          $data["msg"]="Unable to cancel";
        }

          //query 2 used to statement of account
        //this query fails sometime
        $statement = $db->prepare("UPDATE mt_ar_trans 
          SET art_balance_status='CANCELLED', modified_by=:modified_by,modified_date=now() 
        WHERE art_number=:doc_no");
        $statement->execute(array(
          ':doc_no'=>$c->doc_no,':modified_by'=>$dev->username));
        if ($statement->rowCount()){
          $data["trans_status"]=1;
        } else{
          $data["trans_status"]=0;
        }

          //query 3
        $statement = $db->prepare("UPDATE mt_ar_trans_balance SET ardm_status='CANCELLED',modified_by=:modified_by,modified_date=now() 
        WHERE ardm_doc_number=:doc_no");
        $statement->execute(array(
          ':doc_no'=>$c->doc_no,':modified_by'=>$dev->username));
        if ($statement->rowCount()){
          $data["tb_status"]=1;
        } else{
          $data["tb_status"]=0;
        }

        //get order no list
        $statement = $db->prepare("SELECT order_no from mt_ship_ar_header where sub_ar_doc_number=:doc_no");
        $statement->execute(
          array(':doc_no'=>$c->doc_no)
        );

        $rows=$statement->fetchAll(PDO::FETCH_ASSOC);
        $cds=explode(',',$rows[0]["order_no"]);
        $order_entry_status_count=0;
        $order_cost_status_count=0;
        $order_id_count=0;

        for($i=0;$i<count($cds);$i++)
        {
          $cd=$cds[$i];
          $data["ono".($i+1)]=$cd;
          
          if(strlen($cd)!=0)
          {
            $order_id_count+=1;
          //query 4
        $statement = $db->prepare("UPDATE mt_order_cost set invoiced=null,inv_pay_no=null,
        modified_by=:modified_by,modified_date=now() where  type='INCOME' and order_id= 
        (select id from mt_order_entry where order_no=:order_no )
        and id in 
        (SELECT  
          charge_id
          from mt_ship_ar_details 
          where sub_ard_doc_number=:doc_no
          and sub_ard_detail_6 !='ADDITIONAL') ");
        $statement->execute(array(
          ':order_no'=>$cd,
          ':doc_no'=>$c->doc_no,':modified_by'=>$dev->username
        ));
        if ($statement->rowCount()){
          $order_cost_status_count+=1;
          $data["ord_cost_status"]=1;
        } else{
          $data["ord_cost_status"]=0;
        }

          //query 5
        $statement = $db->prepare("UPDATE mt_order_entry 
          set status='OPEN',modified_by=:modified_by,modified_date=now() 
        WHERE order_no=:order_no");
        $statement->execute(array(
          ':order_no'=>$cd,':modified_by'=>$dev->username));
        if ($statement->rowCount()){
          $order_entry_status_count+=1;
          $data["ord_entry_status"]=1;
        } else{
          $data["ord_entry_status"]=0;
        }

        }
        }
          //query 6
        $statement = $db->prepare("UPDATE ship_gl_details 
          SET pre_glt_status='CANCELLED',modified_by=:modified_by,modified_date=now() 
        WHERE pre_glt_doc_number=:doc_no");
        $statement->execute(array(
          ':doc_no'=>$c->doc_no,':modified_by'=>$dev->username));
        if ($statement->rowCount()){
          $data["gl_status"]=1;
        } else{
          $data["gl_status"]=0;
        }

          //query 7
        $statement = $db->prepare("UPDATE mt_ship_trans 
          SET st_status='CANCELLED',modified_by=:modified_by,
          modified_date=now() 
        WHERE st_doc_number=:doc_no");
        $statement->execute(array(
          ':doc_no'=>$c->doc_no,':modified_by'=>$dev->username));
        if ($statement->rowCount()){
          $data["st_status"]=1;
        } else{
          $data["st_status"]=0;
        }

        //$data["status"]=0;
        $check_status=false;
        if($isPro)
        {
        $check_status=$data["status"]==1 && $order_cost_status_count==$order_id_count && $order_entry_status_count==$order_id_count;
        }else
        {
        $check_status=$data["status"]==1 && $data["trans_status"]==1 && $data["tb_status"]==1 && $order_cost_status_count==$order_id_count && $order_entry_status_count==$order_id_count && $data["gl_status"]==1 && $data["st_status"]=1;
        }
        if($check_status)
        {
          $db->commit();
        }else{
          $db->rollBack();
          $data["status"]=0;
          $data["msg"]="Unable to cancel. Please try again";
        }

    }//invoice agency cancel ends 
    else if($c->doc_type=='FORWARD')
    {
        //cancel forwarding invoice
          /*
          ***************************************
          cancelling forward invoice
          ***************************************

          */
          //query 1
        $statement = $db->prepare("UPDATE mt_order_ar_header SET sub_ar_status='CANCELLED',sub_ar_notes=:reason,modified_date=now()  WHERE sub_ar_doc_number=:doc_no");
        $statement->execute(array(
          ':doc_no'=>$c->doc_no,
          ':reason'=>$c->notes));
        if ($statement->rowCount()){
          $data["status"]=1;
        } else{
          $data["status"]=110;
          $data["msg"]="Unable to cancel";

        }
        //UPDATE mt_order_ar_header SET sub_ar_status='CANCELLED',sub_ar_notes='madhan requested' WHERE sub_ar_doc_number='IMP-INV/2020/03/DOHA/0018'

          //query 2
        $statement = $db->prepare("UPDATE mt_ar_trans 
          SET art_balance_status='CANCELLED' 
        WHERE art_number=:doc_no");
        $statement->execute(array(
          ':doc_no'=>$c->doc_no));
        if ($statement->rowCount()){
          $data["trans_status"]=1;
        } else{
          $data["trans_status"]=0;
        }
        //UPDATE mt_ar_trans SET art_balance_status='CANCELLED' 
        //WHERE art_number='IMP-INV/2020/03/DOHA/0018'

          //query 3
        $statement = $db->prepare("UPDATE mt_ar_trans_balance SET ardm_status='CANCELLED'
        WHERE ardm_doc_number=:doc_no");
        $statement->execute(array(
          ':doc_no'=>$c->doc_no));
        if ($statement->rowCount()){
          $data["tb_status"]=1;
        } else{
          $data["tb_status"]=0;
        }
        //UPDATE mt_ar_trans_balance SET ardm_status='CANCELLED'
        //WHERE ardm_doc_number='IMP-INV/2020/03/DOHA/0018'

        //get order no list
        $statement = $db->prepare("SELECT order_no from mt_order_ar_header where sub_ar_doc_number=:doc_no");
        $statement->execute(
          array(':doc_no'=>$c->doc_no)
        );

        $rows=$statement->fetchAll(PDO::FETCH_ASSOC);
        $cds=explode(',',$rows[0]["order_no"]);
        for($i=0;$i<count($cds);$i++)
        {
          $cd=$cds[$i];
          if(strlen($cd)!=0)
          {
          //query 4
        $statement = $db->prepare("UPDATE mt_order_cost set invoiced=null where  type='INCOME' and order_id= 
        (select id from mt_order_entry where order_no=:order_no )
        and charge_desc in 
        (SELECT  
          charge_desc
          from mt_order_ar_details 
          where sub_ard_doc_number=:doc_no
          and sub_ard_detail_6 !='ADDITIONAL') ");
        $statement->execute(array(
          ':order_no'=>$cd,
          ':doc_no'=>$c->doc_no
        ));
        if ($statement->rowCount()){
          $data["oc_status"]=1;
        } else{
          $data["oc_status"]=0;
        }
        //UPDATE mt_order_cost set invoiced=null where  type='INCOME' and order_id= 
        //(select id from mt_order_entry where order_no='SEA-I/2020/03/ITGOA/0953' )


          //query 5
        $statement = $db->prepare("UPDATE mt_order_entry 
          set status='OPEN'
        WHERE order_no=:order_no");
        $statement->execute(array(
          ':order_no'=>$cd));
        if ($statement->rowCount()){
          $data["o_status"]=1;
        } else{
          $data["o_status"]=0;
        }

        }
        }
        //UPDATE mt_order_entry set status='OPEN'
        //WHERE order_no='SEA-I/2020/03/ITGOA/0953'

          //query 6
        $statement = $db->prepare("UPDATE mt_order_gl_details 
          SET pre_glt_status='CANCELLED' 
        WHERE pre_glt_doc_number=:doc_no");
        $statement->execute(array(
          ':doc_no'=>$c->doc_no));
        if ($statement->rowCount()){
          $data["gl_status"]=1;
        } else{
          $data["gl_status"]=0;
        }
        /*THERE IS NO DATA IN mt_order_gl_details*/

          //query 7
        $statement = $db->prepare("UPDATE mt_order_trans 
          SET ordt_status='CANCELLED' 
        WHERE ordt_doc_number=:doc_no");
        $statement->execute(array(
          ':doc_no'=>$c->doc_no));
        if ($statement->rowCount()){
          $data["st_status"]=1;
        } else{
          $data["st_status"]=0;
        }

        //UPDATE mt_order_trans SET ordt_status='CANCELLED' WHERE ordt_doc_number='IMP-INV/2020/03/DOHA/0018'

    }//voucher cancel start
    else if($c->doc_type=='JV')
    {

        /*
          ***************************************
          cancelling jv voucher
          ***************************************

          */

           //query 1
        $statement = $db->prepare("UPDATE mt_jv_header 
          SET jvh_status='CANCELLED',jvh_notes=:reason,modified_date=now()  WHERE jvh_doc_number=:doc_no");
        $statement->execute(array(
          ':doc_no'=>$c->doc_no,
          ':reason'=>$c->notes));
        if ($statement->rowCount()){
          $data["status"]=1;
        } else{
          $data["status"]=110;
          $data["msg"]="Unable to cancel";

        }
        //UPDATE mt_order_ar_header SET sub_ar_status='CANCELLED',sub_ar_notes='madhan requested' WHERE sub_ar_doc_number='IMP-INV/2020/03/DOHA/0018'

          //query 2
        $statement = $db->prepare("UPDATE mt_ar_trans 
          SET art_balance_status='CANCELLED' 
        WHERE art_number=:doc_no");
        $statement->execute(array(
          ':doc_no'=>$c->doc_no));
        if ($statement->rowCount()){
          $data["trans_status"]=1;
        } else{
          $data["trans_status"]=0;
        }
        //UPDATE mt_ar_trans SET art_balance_status='CANCELLED' 
        //WHERE art_number='IMP-INV/2020/03/DOHA/0018'

          //query 3
        $statement = $db->prepare("UPDATE mt_ar_trans_balance SET ardm_status='CANCELLED'
        WHERE ardm_doc_number=:doc_no");
        $statement->execute(array(
          ':doc_no'=>$c->doc_no));
        if ($statement->rowCount()){
          $data["tb_status"]=1;
        } else{
          $data["tb_status"]=0;
        }

          //query 4
        $statement = $db->prepare("UPDATE mt_ap_trans 
          SET apt_balance_status='CANCELLED' 
        WHERE apt_number=:doc_no");
        $statement->execute(array(
          ':doc_no'=>$c->doc_no));
        if ($statement->rowCount()){
          $data["ap_trans_status"]=1;
        } else{
          $data["ap_trans_status"]=0;
        }
        //UPDATE mt_ar_trans SET art_balance_status='CANCELLED' 
        //WHERE art_number='IMP-INV/2020/03/DOHA/0018'

          //query 5
        $statement = $db->prepare("UPDATE mt_ap_trans_balance SET apdm_status='CANCELLED'
        WHERE apdm_doc_number=:doc_no");
        $statement->execute(array(
          ':doc_no'=>$c->doc_no));
        if ($statement->rowCount()){
          $data["ap_tb_status"]=1;
        } else{
          $data["ap_tb_status"]=0;
        }

         //query 6
        $statement = $db->prepare("UPDATE mt_jv_gl_details 
          SET pre_glt_status='CANCELLED',modified_by=:modified_by,modified_date=now() 
        WHERE pre_glt_doc_number=:doc_no");
        $statement->execute(array(
          ':doc_no'=>$c->doc_no,':modified_by'=>$dev->username));
        if ($statement->rowCount()){
          $data["gl_status"]=1;
        } else{
          $data["gl_status"]=0;
        }

    }else
    {
            /*
          ***************************************
          cancelling voucher
          ***************************************

          */
          if($c->doc_type=='RECEIVABLE VOUCHER')
          {
            //query 1
            $q="UPDATE mt_ar_header set arh_status='CANCELLED',arh_notes=:reason,modified_by=:modified_by,modified_date=now() where arh_document_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,
          ':reason'=>$c->notes,':modified_by'=>$dev->username);
            $data["status"]=self::cancel_voucher_queries($db,$q,$ar);
            if($data["status"]==0)
            {
          $data["msg"]="Unable to cancel";
              
            } 
             //query 2
            
            $q="UPDATE mt_ship_trans set st_status='CANCELLED',modified_by=:modified_by,modified_date=now() 
            where st_doc_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["st_status"]=self::cancel_voucher_queries($db,$q,$ar);

            //query 3
            $q="UPDATE mt_order_trans set ordt_status='CANCELLED',modified_by=:modified_by,modified_date=now() 
            where ordt_doc_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["ot_status"]=self::cancel_voucher_queries($db,$q,$ar);

            //query 4
              $q="UPDATE mt_ar_trans set art_balance_status='CANCELLED',
              modified_date=now(),modified_by=:modified_by 
              where art_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["ar_trans_status"]=self::cancel_voucher_queries($db,$q,$ar);

                //query 5
              $q="UPDATE mt_ar_gl_details set pre_glt_status='CANCELLED',
              modified_date=now(),modified_by=:modified_by 
              where pre_glt_doc_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["gl_status"]=self::cancel_voucher_queries($db,$q,$ar);

                //query 6
              $q="UPDATE mt_ar_trans_balance set ardm_status='CANCELLED',
              modified_date=now(),modified_by=:modified_by 
              where ardm_doc_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["tb_status"]=self::cancel_voucher_queries($db,$q,$ar);

            //query 7A - IF voucher is AR-AP THEN cancel AP also
              $q="UPDATE mt_ap_trans set apt_balance_status='CANCELLED',
              modified_date=now(),modified_by=:modified_by 
              where apt_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["ap_trans_status"]=self::cancel_voucher_queries($db,$q,$ar);

                //query 7B
              $q="UPDATE mt_ap_trans_balance set apdm_status='CANCELLED',
              modified_date=now(),modified_by=:modified_by 
              where apdm_doc_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["tb1_status"]=self::cancel_voucher_queries($db,$q,$ar);
            //AR-AP cancel ENDS

             //query 7 
              /*$q="UPDATE mt_ar_balance set status='CANCELLED',
              modified_date=now(),modified_by=:modified_by 
              where ardm_doc_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["tb_status"]=self::cancel_voucher_queries($db,$q,$ar);
            */
          }else if($c->doc_type=='PAYABLE VOUCHER' || $c->doc_type=="ACCOUNTS PAYABLE")
          {
            //query 1
            $q="UPDATE mt_ap_header set aph_status='CANCELLED',aph_notes=:reason,modified_by=:modified_by,modified_date=now() where aph_document_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,
          ':reason'=>$c->notes,':modified_by'=>$dev->username);
            $data["status"]=self::cancel_voucher_queries($db,$q,$ar);
            if($data["status"]==0)
            {
          $data["msg"]="Unable to cancel";
              
            }
             //query 2
            $q="UPDATE mt_ship_trans set st_status='CANCELLED',modified_by=:modified_by,modified_date=now() 
            where st_doc_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["st_status"]=self::cancel_voucher_queries($db,$q,$ar);

            //query 3
            $q="UPDATE mt_order_trans set ordt_status='CANCELLED',modified_by=:modified_by,modified_date=now() 
            where ordt_doc_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["ot_status"]=self::cancel_voucher_queries($db,$q,$ar);

            //query 4
              $q="UPDATE mt_ap_trans set apt_balance_status='CANCELLED',
              modified_date=now(),modified_by=:modified_by 
              where apt_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["ap_trans_status"]=self::cancel_voucher_queries($db,$q,$ar);

                //query 5
              $q="UPDATE mt_ap_gl_details set pre_glt_status='CANCELLED',
              modified_date=now(),modified_by=:modified_by 
              where pre_glt_doc_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["gl_status"]=self::cancel_voucher_queries($db,$q,$ar);

                //query 6
              $q="UPDATE mt_ap_trans_balance set apdm_status='CANCELLED',
              modified_date=now(),modified_by=:modified_by 
              where apdm_doc_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["tb_status"]=self::cancel_voucher_queries($db,$q,$ar);

            //query 7A IF AP-AR THEN CANCEL AR Also
              $q="UPDATE mt_ar_trans set art_balance_status='CANCELLED',
              modified_date=now(),modified_by=:modified_by 
              where art_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["ar_trans_status"]=self::cancel_voucher_queries($db,$q,$ar);

                //query 7B
              $q="UPDATE mt_ar_trans_balance set ardm_status='CANCELLED',
              modified_date=now(),modified_by=:modified_by 
              where ardm_doc_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["tb1_status"]=self::cancel_voucher_queries($db,$q,$ar);
            //AP-AR cancel ENDS
            
             //query 7 
              /*$q="UPDATE mt_ar_balance set status='CANCELLED',
              modified_date=now(),modified_by=:modified_by 
              where ardm_doc_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["tb_status"]=self::cancel_voucher_queries($db,$q,$ar);
            */
            if($c->doc_type=="ACCOUNTS PAYABLE")
            {
              $statement = $db->prepare("UPDATE mt_order_cost 
                set inv_pay_no=NULL where inv_pay_no=:doc_no");
          $statement->execute(array(':doc_no'=>$c->doc_no));
          if ($statement->rowCount()){
          $data["inv_cost_status"]=1;
        } else{
          $data["inv_cost_status"]=0;
        }
            }
          }
          else if($c->doc_type=='PAYMENT')
          {
            //query 1
            $q="UPDATE mt_payment_header set ph_status='CANCELLED',ph_notes=:reason,modified_by=:modified_by,modified_date=now() where ph_doc_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,
          ':reason'=>$c->notes,':modified_by'=>$dev->username);
              
             /*
               $statement = $db->prepare($query);
        $statement->execute($ar);
        $rc=$statement->rowCount();
        $data["rc"]=$rc;
        if ($rc==1){
          $data["status"]=1;
        } else{
          $data["status"]=0;
        }
             */

            $data["status"]=self::cancel_voucher_queries($db,$q,$ar);
            if($data["status"]==0)
            {
          $data["msg"]="Unable to cancel";
              
            } 
              //query 3
              $q="UPDATE mt_ap_trans set apt_balance_status='CANCELLED',
              modified_date=now(),modified_by=:modified_by 
              where apt_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["ap_trans_status"]=self::cancel_voucher_queries($db,$q,$ar);

            //query 4
              $q="UPDATE mt_payment_gl_details 
              set pre_glt_status='CANCELLED',
              modified_date=now(),modified_by=:modified_by 
              where pre_glt_doc_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["gl_status"]=self::cancel_voucher_queries($db,$q,$ar);

            //query 5
              $q="UPDATE mt_ap_trans_balance set apdm_status='CANCELLED',
              modified_date=now(),modified_by=:modified_by 
              where apdm_doc_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["tb_status"]=self::cancel_voucher_queries($db,$q,$ar);

            //query 6
              $q="UPDATE mt_cash_book_details set cb_status='CANCELLED',
              modified_date=now(),modified_by=:modified_by 
              where cb_doc_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["cb_status"]=self::cancel_voucher_queries($db,$q,$ar);

            //adding ar trans also

            //query 3
              $q="UPDATE mt_ar_trans set art_balance_status='CANCELLED',
              modified_date=now(),modified_by=:modified_by 
              where art_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["ar_trans_status"]=self::cancel_voucher_queries($db,$q,$ar);


            //query 5
              $q="UPDATE mt_ar_trans_balance set ardm_status='CANCELLED',
              modified_date=now(),modified_by=:modified_by 
              where ardm_doc_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["ar_tb_status"]=self::cancel_voucher_queries($db,$q,$ar);
            

            //
          }
          else if($c->doc_type=='RECEIPT')
          {
            $data["doc_type"]=$c->doc_type;
            //query 1
            $q="UPDATE mt_receipt_header set rh_status='CANCELLED',rh_notes=:reason,modified_by=:modified_by,modified_date=now() where rh_doc_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,
          ':reason'=>$c->notes,':modified_by'=>$dev->username);

            $data["status"]=self::cancel_voucher_queries($db,$q,$ar);

              if($data["status"]==0)
            {
          $data["msg"]="Unable to cancel";
              
            } 

              //query 3
              $q="UPDATE mt_ar_trans set art_balance_status='CANCELLED',
              modified_date=now(),modified_by=:modified_by 
              where art_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["ar_trans_status"]=self::cancel_voucher_queries($db,$q,$ar);

            //query 4
              $q="UPDATE mt_receipt_gl_details 
              set pre_glt_status='CANCELLED',
              modified_date=now(),modified_by=:modified_by 
              where pre_glt_doc_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["gl_status"]=self::cancel_voucher_queries($db,$q,$ar);

            //query 5
              $q="UPDATE mt_ar_trans_balance set ardm_status='CANCELLED',
              modified_date=now(),modified_by=:modified_by 
              where ardm_doc_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["tb_status"]=self::cancel_voucher_queries($db,$q,$ar);

            //query 6
              $q="UPDATE mt_cash_book_details set cb_status='CANCELLED',
              modified_date=now(),modified_by=:modified_by 
              where cb_doc_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["cb_status"]=self::cancel_voucher_queries($db,$q,$ar);

            //adding ap cancel also

            //query 3
              $q="UPDATE mt_ap_trans set apt_balance_status='CANCELLED',
              modified_date=now(),modified_by=:modified_by 
              where apt_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["ap_trans_status"]=self::cancel_voucher_queries($db,$q,$ar);

            //query 5
              $q="UPDATE mt_ap_trans_balance set apdm_status='CANCELLED',
              modified_date=now(),modified_by=:modified_by 
              where apdm_doc_number=:doc_no";
            $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
            $data["ap_tb_status"]=self::cancel_voucher_queries($db,$q,$ar);

          } //receipt ends

      $db->commit(); //COMMIT PAYABLE/RECEIVABLE/PAYMENT/RECEIPT VOUCHERS

  } //voucher cancel ends

}
//allow voucher cancel ends

$statement=null;
}
  catch (PDOException $e) {
    print $e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to cancel. Please try again";
  }
  
  return $data;
}

//
public static function cancel_voucher_queries($db,$query,$ar)
{
$data=10;
$statement = $db->prepare($query);
$statement->execute($ar);
if ($statement->rowCount()){
  $data=1;
} else{
  $data=0;
}
return $data;
}

public static function get_voucher_info($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();

$aq=self::getRestrictionQuery($dev);

if($code->vt=="PAYABLE VOUCHER")
{

$statement = $db->prepare("SELECT
id, 
aph_document_base voucher_type,
aph_document_type doc_type,
aph_document_date doc_date,
aph_document_number doc_no,
aph_narration narration,
aph_foreign_amount deb_total,
aph_local_amount cr_total,
'0' diff_amt,
temp_code,
child 
FROM mt_ap_header where id=:id");
$statement->execute(array(':id'=>$code->id));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT 
  '' header,aloc_company,aloc_base_doc,aloc_doc_type,
aloc_doc_number,aloc_allocation_type allocation,
aloc_foreign_amount base_amt_cr,aloc_local_amount local_amt_cr,
aloc_narration narration,aloc_currency currency,aloc_ex_rate ex_rate,
reference,ref_date,
ap_customer customer_name,ap_activity activity,
ap_cust_address customer_address,
bank bank_name,cheque_no,cheque_date,
income_gl income  
FROM mt_ap_allocation_details 
where aloc_doc_number=:doc_no");
$statement->execute(array(':doc_no'=>$data["info"][0]["doc_no"]));
$data["voucher"]=$statement->fetchAll(PDO::FETCH_ASSOC);

}else if($code->vt=="RECEIVABLE VOUCHER")
{

  $statement = $db->prepare("SELECT
id, 
arh_document_base voucher_type,
arh_document_type doc_type,
arh_document_date doc_date,
arh_document_number doc_no,
arh_narration narration,
arh_local_amount deb_total,
arh_local_amount cr_total,
'0' diff_amt,
temp_code,
child 
FROM mt_ar_header where id=:id");
$statement->execute(array(':id'=>$code->id));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT 
  '' header,aloc_company,aloc_base_doc,aloc_doc_type,
aloc_doc_number,aloc_allocation_type allocation,
aloc_foreign_amount base_amt_cr,aloc_local_amount local_amt_cr,
aloc_narration narration,aloc_currency currency,aloc_ex_rate ex_rate,
reference,ref_date,
ar_customer customer_name,ar_activity activity,
ar_cust_address customer_address,
bank bank_name,cheque_no,cheque_date,
income_gl income  
FROM mt_ar_allocation_details 
where aloc_doc_number=:doc_no");
$statement->execute(array(':doc_no'=>$data["info"][0]["doc_no"]));
$data["voucher"]=$statement->fetchAll(PDO::FETCH_ASSOC);
  
}else if($code->vt=="RECEIPT" || $code->vt=="RECEIPT")
{

  $statement = $db->prepare("SELECT
id, 
rh_base_doc_type voucher_type,
rh_doc_type doc_type,
rh_doc_date doc_date,
rh_doc_number doc_no,
rh_narration narration,
rh_local_amount deb_total,
rh_local_amount cr_total,
'0' diff_amt,
temp_code,
child 
FROM mt_receipt_header where id=:id");
$statement->execute(array(':id'=>$code->id));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);
  
}else if($code->vt=="PAYMENT" || $code->vt=="PAYMENT")
{

  $statement = $db->prepare("SELECT
id, 
ph_base_doc_type voucher_type,
ph_doc_type doc_type,
ph_doc_date doc_date,
ph_doc_number doc_no,
ph_narration narration,
ph_local_amount deb_total,
ph_local_amount cr_total,
'0' diff_amt,
temp_code,
child 
FROM mt_payment_header where id=:id");
$statement->execute(array(':id'=>$code->id));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);
  
}


//var_dump($statement->debugDumpParams());

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

//search voucher preparation list
public static function search_voucher_preparation_list($dev,$v)
{
$data=false;
try
{
$db = Factory::getConnection();

$aq=self::getRestrictionQuery($dev);

$statement = $db->prepare("
SELECT * FROM (( SELECT 
id, arh_company company, arh_code code, arh_document_number doc_number, arh_document_date doc_date, arh_document_base vt, arh_document_type dt, created_by, created_date, '' gl_date, '' currency, '' ex_rate, '' total_debit, '' total_credit, arh_status status, '' prepared_date, '' doc_gen_no, '' matched_doc_no, '' matched_amt, '' balance_amt, '' reversal_doc_no, '' other_reference, '' calendar_year, '' calendar_period, '' fiscal_year, '' fiscal_period, '' group_year, '' group_period, child,'' acc_name, '' cheque_no, arh_narration narration, 
arh_local_amount total_amt  
from
mt_ar_header where  $aq and 
 (arh_narration like ? or arh_document_base like ? or  arh_document_type like ? or arh_document_number like ?) order by id desc limit 20)
UNION

(SELECT 
id, aph_company company, aph_code code, aph_document_number doc_number, aph_document_date doc_date, aph_document_base vt, aph_document_type dt, created_by, created_date, '' gl_date, '' currency, '' ex_rate, '' total_debit, '' total_credit, aph_status status, '' prepared_date, '' doc_gen_no, '' matched_doc_no, '' matched_amt, '' balance_amt, '' reversal_doc_no, '' other_reference, '' calendar_year, '' calendar_period, '' fiscal_year, '' fiscal_period, '' group_year, '' group_period, child,'' acc_name, '' cheque_no, aph_narration narration, 
aph_local_amount total_amt 
from
mt_ap_header where  $aq  and 
aph_document_number not like 'LPO%' and (aph_narration like ? or aph_document_base like ? or  aph_document_type like ? or aph_document_number like ?) order by id desc limit 20)
UNION

(SELECT 
id, ph_company company, ph_cash_bank_code code, ph_doc_number doc_number, ph_doc_date doc_date, ph_base_doc_type vt, ph_doc_type dt, created_by, created_date, '' gl_date, '' currency, '' ex_rate, '' total_debit, '' total_credit, ph_status status, '' prepared_date, '' doc_gen_no, '' matched_doc_no, '' matched_amt, '' balance_amt, '' reversal_doc_no, '' other_reference, '' calendar_year, '' calendar_period, '' fiscal_year, '' fiscal_period, '' group_year, '' group_period, child,CASE WHEN ph_cheque_number IS NULL THEN 
(SELECT ac_description from mt_general_ledger where  code=ph_cash_bank_code limit 1) 
ELSE ph_cash_bank_code END acc_name, ph_cheque_number cheque_no, ph_narration narration, ph_local_amount total_amt    
from
mt_payment_header where  $aq  and 
 (ph_narration like ? or ph_base_doc_type like ? 
or  ph_doc_type like ? or ph_doc_number like ? or ph_cheque_number like ?)
 order by id desc limit 20)
UNION

(SELECT 
id, rh_company company, rh_cash_bank_code code, rh_doc_number doc_number, rh_doc_date doc_date, rh_base_doc_type vt, rh_doc_type dt, created_by, created_date, '' gl_date, '' currency, '' ex_rate, '' total_debit, '' total_credit, rh_status status, '' prepared_date, '' doc_gen_no, '' matched_doc_no, '' matched_amt, '' balance_amt, '' reversal_doc_no, '' other_reference, '' calendar_year, '' calendar_period, '' fiscal_year, '' fiscal_period, '' group_year, '' group_period, child,rh_cash_bank_code acc_name,rh_cheque_number cheque_no,rh_narration narration,
rh_local_amount total_amt  
from
mt_receipt_header where  $aq  and 
 (rh_narration like ? or rh_cheque_number like ? or rh_base_doc_type like ? 
or  rh_doc_type like ? or rh_doc_number like ?) order by id desc limit 20)) t1 order by created_date desc 
");
$i=1;
$statement ->bindValue($i++, "%$v%", PDO::PARAM_STR);
$statement ->bindValue($i++, "%$v%", PDO::PARAM_STR);
$statement ->bindValue($i++, "%$v%", PDO::PARAM_STR);

$statement ->bindValue($i++, "%$v%", PDO::PARAM_STR);
$statement ->bindValue($i++, "%$v%", PDO::PARAM_STR);
$statement ->bindValue($i++, "%$v%", PDO::PARAM_STR);

$statement ->bindValue($i++, "%$v%", PDO::PARAM_STR);
$statement ->bindValue($i++, "%$v%", PDO::PARAM_STR);
$statement ->bindValue($i++, "%$v%", PDO::PARAM_STR);
$statement ->bindValue($i++, "%$v%", PDO::PARAM_STR);


$statement ->bindValue($i++, "%$v%", PDO::PARAM_STR);
$statement ->bindValue($i++, "%$v%", PDO::PARAM_STR);
$statement ->bindValue($i++, "%$v%", PDO::PARAM_STR);

$statement ->bindValue($i++, "%$v%", PDO::PARAM_STR);
$statement ->bindValue($i++, "%$v%", PDO::PARAM_STR);
$statement ->bindValue($i++, "%$v%", PDO::PARAM_STR);
$statement ->bindValue($i++, "%$v%", PDO::PARAM_STR);
$statement ->bindValue($i++, "%$v%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

//var_dump($statement->debugDumpParams());

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_voucher_preparation_list($dev,$code)
{
$data=false;
try
{
$db = Factory::getConnection();

$aq=Factory::getRestrictionQuery($dev);
$ap_only=$aq;
if($aq=="")
{
  $ap_only=" 1=1 ";
}
$statement = $db->prepare("
SELECT * FROM (( SELECT 
id,
arh_company company,
arh_code code,
arh_document_number doc_number,
arh_document_date doc_date,
arh_document_base vt,
arh_document_type dt,
created_by,
created_date,

'' gl_date,
'' currency,
'' ex_rate,
'' total_debit,
'' total_credit,
arh_status status,
'' prepared_date,
'' doc_gen_no,
'' matched_doc_no,
'' matched_amt,
'' balance_amt,
'' reversal_doc_no,
'' other_reference,
'' calendar_year,
'' calendar_period,
'' fiscal_year,
'' fiscal_period,
'' group_year,
'' group_period,
child,(SELECT name from mt_business_partner where code=arh_code) acc_name, '' cheque_no, arh_narration narration, 
arh_local_amount total_amt  
from
mt_ar_header where $aq order by id desc limit :sta,50)
UNION

(SELECT 
id,
aph_company company,
aph_code code,
aph_document_number doc_number,
aph_document_date doc_date,
aph_document_base vt,
aph_document_type dt,
created_by,
created_date,


'' gl_date,
'' currency,
'' ex_rate,
'' total_debit,
'' total_credit,
aph_status status,
'' prepared_date,
'' doc_gen_no,
'' matched_doc_no,
'' matched_amt,
'' balance_amt,
'' reversal_doc_no,
'' other_reference,
'' calendar_year,
'' calendar_period,
'' fiscal_year,
'' fiscal_period,
'' group_year,
'' group_period,
child,(SELECT name from mt_business_partner where code=aph_code) acc_name, '' cheque_no, aph_narration narration, 
aph_local_amount total_amt 
from
mt_ap_header where aph_document_number not like 'LPO%' and 
$ap_only order by id desc limit :sta,50)
UNION

(SELECT 
id,
ph_company company,
ph_cash_bank_code code,
ph_doc_number doc_number,
ph_doc_date doc_date,
ph_base_doc_type vt,
ph_doc_type dt,
created_by,
created_date,


'' gl_date,
'' currency,
'' ex_rate,
'' total_debit,
'' total_credit,
ph_status status,
'' prepared_date,
'' doc_gen_no,
'' matched_doc_no,
'' matched_amt,
'' balance_amt,
'' reversal_doc_no,
'' other_reference,
'' calendar_year,
'' calendar_period,
'' fiscal_year,
'' fiscal_period,
'' group_year,
'' group_period,
child,CASE WHEN ph_cheque_number IS NULL THEN 
(SELECT ac_description from mt_general_ledger where  code=ph_cash_bank_code limit 1) 
ELSE ph_cash_bank_code END acc_name, ph_cheque_number cheque_no, ph_narration narration, ph_local_amount total_amt   
from
mt_payment_header where $aq order by id desc limit :sta,50)
UNION

(SELECT 
id,
rh_company company,
rh_cash_bank_code code,
rh_doc_number doc_number,
rh_doc_date doc_date,
rh_base_doc_type vt,
rh_doc_type dt,
created_by,
created_date,


'' gl_date,
'' currency,
'' ex_rate,
'' total_debit,
'' total_credit,
rh_status status,
'' prepared_date,
'' doc_gen_no,
'' matched_doc_no,
'' matched_amt,
'' balance_amt,
'' reversal_doc_no,
'' other_reference,
'' calendar_year,
'' calendar_period,
'' fiscal_year,
'' fiscal_period,
'' group_year,
'' group_period,
child,rh_cash_bank_code acc_name,rh_cheque_number cheque_no,rh_narration narration,
rh_local_amount total_amt 
from
mt_receipt_header where $aq order by id desc limit :sta,50)) t1 order by created_date desc 
");
$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

//var_dump($statement->debugDumpParams());

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


//search ap 
public static function search_ap_customer($v)
{
$data=false;
try
{
$db = Factory::getConnection();
//$aq=self::getRestrictionQuery($dev);
$statement = $db->prepare("SELECT apt_code, name 
from 
(SELECT distinct apt_code from mt_ap_trans where apt_balance_status = 'A') t1, mt_business_partner t2 where t2.code=t1.apt_code 
 and (apt_code like ? or name like ?) 
order by apt_code desc limit 20");

$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
//var_dump($statement->debugDumpParams());
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}


//search ar customer

public static function search_ar_customer($v)
{
$data=false;
try
{
$db = Factory::getConnection();

//$aq=self::getRestrictionQuery($dev);

$statement = $db->prepare("SELECT art_code, name 
from 
(SELECT distinct art_code from mt_ar_trans 
  where ART_BALANCE_STATUS = 'A' )t1, 
  mt_business_partner t2 where t2.code=t1.art_code 
and (art_code like ? or name like ?) 
order by art_code desc limit 20");

$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

//var_dump($statement->debugDumpParams());

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

//get doc type list

public static function get_ap_doc_list($v)
{
$data=false;
try
{
$db = Factory::getConnection();
//$aq=self::getRestrictionQuery($dev);
$statement = $db->prepare("SELECT distinct apt_type apt_base_type 
from 
mt_ap_trans t1 where apt_code=:code 
and apt_balance_status = 'A' and apt_type in ('ONLINE TRANSFER','CASH','CHEQUE','P2P','P2L') ");
$statement->execute(array(':code'=>$v));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}


//get doc type list

public static function get_ar_doc_list($v)
{
$data=false;
try
{
$db = Factory::getConnection();
//$aq=self::getRestrictionQuery($dev);
$statement = $db->prepare("SELECT distinct art_type art_base_type 
from 
mt_ar_trans t1 where art_code=:code and art_type 
not in('IMP-INV','PRO-INV','EXP-INV','OUTPUT IGST','OUTPUT CGST','OUTPUT SGST')
and ART_BALANCE_STATUS = 'A' ");
$statement->execute(array(':code'=>$v));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

//get ap docno for voucher matching
public static function get_ar_docno_list1($v)
{
$data=false;
try
{
$db = Factory::getConnection();
//$aq=self::getRestrictionQuery($dev);
$statement = $db->prepare("SELECT art_code,art_type art_base_type,art_number,art_local_balance  
from 
mt_ar_trans t1 where  art_number=:art_number 
and art_balance_status = 'A' ");
$statement->execute(array(':art_number'=>$v));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

//get ap docno for voucher matching
public static function get_ap_docno_list1($v)
{
$data=false;
try
{
$db = Factory::getConnection();
//$aq=self::getRestrictionQuery($dev);
$statement = $db->prepare("SELECT apt_code,apt_type apt_base_type,apt_number,apt_local_balance  
from 
mt_ap_trans t1 where  apt_number=:apt_number 
and apt_balance_status = 'A' ");
$statement->execute(array(':apt_number'=>$v));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

//
public static function get_ap_docno_list($v)
{
$data=false;
try
{
$db = Factory::getConnection();
//$aq=self::getRestrictionQuery($dev);

$aq='';
if($v->btype=="ONLINE TRANSFER" or $v->btype=="CASH" or $v->btype=="CHEQUE"){
  $aq='';
}else{
  $aq="and ref_inv_no like '%".$v->cv."%' ";
}

$statement = $db->prepare("SELECT apt_number,  
case when apt_type='GENERAL INVOICE' or apt_type='TDS PAYABLE' then 
ref_inv_no 
else 
(select ph_cheque_number from mt_payment_header where ph_doc_number=apt_number) 
end as trx_no, apt_local_balance,
apt_description    
from 
mt_ap_trans t1 where  apt_code=:code 
and apt_balance_status = 'A' and  apt_type=:btype  $aq ");
$statement->execute(array(':code'=>$v->code,':btype'=>$v->btype));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

//
public static function get_ar_docno_list($v)
{
$data=false;
try
{
$db = Factory::getConnection();
//$aq=self::getRestrictionQuery($dev);
$statement = $db->prepare("SELECT art_number,art_local_balance  
from 
mt_ar_trans t1 where  art_code=:code 
and ART_BALANCE_STATUS = 'A' and  art_type=:btype");
$statement->execute(array(':code'=>$v->code,':btype'=>$v->btype));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}


public static function get_ap_trans_list($dev,$v)
{
$data=false;
try
{
$db = Factory::getConnection();
//$aq=self::getRestrictionQuery($dev);
$query='';
if($dev->location=="MUMBAI")
{
$query="SELECT  t1.id, apt_type apdm_doc_type, apt_number apdm_doc_number, apt_gl_date apdm_date, apt_local_amount apdm_ol_amount,'' matched_amt, 
  convert(apt_local_balance,DECIMAL(9,2)) apdm_bl_amount, 
  convert(apt_local_balance,DECIMAL(9,2)) apdm_bl_amount1,'' other_reference,'' selected,
ref_inv_no  
from mt_ap_trans t1   
where apt_balance_status!='CANCELLED' and 
apt_code=:code 
and apt_type in 
  (SELECT to_doc_type from mt_match_setup 
    where from_doc_type=:fdc 
    and status='ACTIVE') 
and apt_local_balance!=0  and location_id=:location_id order by apdm_doc_number
";
}else{
$query="SELECT  t1.id, apt_type apdm_doc_type, apt_number apdm_doc_number, apt_gl_date apdm_date, apt_local_amount apdm_ol_amount,'' matched_amt, 
  convert(apt_local_balance,DECIMAL(9,2)) apdm_bl_amount, 
  convert(apt_local_balance,DECIMAL(9,2)) apdm_bl_amount1,'' other_reference,'' selected,
ref_inv_no  
from mt_ap_trans t1   
where apt_balance_status!='CANCELLED' and 
apt_code=:code 
and apt_type in 
  (SELECT to_doc_type from mt_match_setup 
    where from_doc_type=:fdc 
    and status='ACTIVE') 
and apt_local_balance!=0   and location_id=:location_id order by apdm_doc_number
";
}
$statement = $db->prepare($query);
$statement->execute(array(
  ':code'=>$v->apt_code,
  ':fdc'=>$v->apt_base_type,
  ':location_id'=>$dev->location));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function search_ap_trans_list($v)
{
$data=false;
try
{
$db = Factory::getConnection();

$concat_output='';
$temp_list=explode(',', $v->ref_inv_no);
$total_count=count($temp_list);
for ($i = 0; $i < $total_count; $i++) {

  if($i+1==$total_count)
  {
    $concat_output=$concat_output."'$temp_list[$i]'";
  }else{
    $concat_output=$concat_output."'$temp_list[$i]',";
  }

}

//$aq=self::getRestrictionQuery($dev);
$statement = $db->prepare("SELECT  t1.id,apdm_doc_type,apdm_doc_number,apdm_date,apdm_ol_amount,'' matched_amt,apdm_bl_amount,apdm_bl_amount apdm_bl_amount1,'' other_reference,'' selected, 
ref_inv_no 
from mt_ap_trans_balance t1 
where apdm_status!='CANCELLED' and 
apdm_code=:code 
and (t1.apdm_doc_number in ($concat_output) or t1.ref_inv_no in ($concat_output) ) 
and apdm_doc_type in 
(SELECT to_doc_type from mt_match_setup 
  where from_doc_type=:fdc 
  and status='ACTIVE') and apdm_bl_amount!=0");
$statement->execute(array(
  ':code'=>$v->apt_code,
  
  ':fdc'=>$v->apt_base_type));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function get_ar_trans_list($dev,$v)
{
  
$data=false;
try
{
$db = Factory::getConnection();
//$aq=self::getRestrictionQuery($dev);
if($dev->location=="MUMBAI")
{
$statement = $db->prepare("  SELECT  id, art_type ardm_doc_type, art_number ardm_doc_number, art_gl_date ardm_date, round(art_local_amount) ardm_ol_amount,'' matched_amt,
convert(art_local_balance,DECIMAL(9,2)) ardm_bl_amount,
convert(art_local_balance,DECIMAL(9,2)) ardm_bl_amount1,

case when art_type='TDS RECEIVABLE' then
(select rh_narration from mt_receipt_header where rh_doc_number=art_number)
else
  ' '
END as other_reference,'' selected

from mt_ar_trans

where art_balance_status!='CANCELLED' 
and art_code=:code 
and art_type in 
(SELECT to_doc_type from mt_match_setup 
  where from_doc_type=:fdc 
  and status='ACTIVE') 
and art_local_balance!=0 
order by id desc 
");
$statement->execute(array(
  ':code'=>$v->art_code,
  ':fdc'=>$v->art_base_type));
}else{
  $statement = $db->prepare("  SELECT  id, art_type ardm_doc_type, art_number ardm_doc_number, art_gl_date ardm_date, round(art_local_amount) ardm_ol_amount,'' matched_amt,
convert(art_local_balance,DECIMAL(9,2)) ardm_bl_amount,
convert(art_local_balance,DECIMAL(9,2)) ardm_bl_amount1,

case when art_type='TDS RECEIVABLE' then
(select rh_narration from mt_receipt_header where rh_doc_number=art_number)
else
  ' '
END as other_reference,'' selected

from mt_ar_trans

where art_balance_status!='CANCELLED' 
and art_code=:code 
and art_type in 
(SELECT to_doc_type from mt_match_setup 
  where from_doc_type=:fdc 
  and status='ACTIVE') 
and art_local_balance!=0 
order by id desc 
");
$statement->execute(array(
  ':code'=>$v->art_code,
  ':fdc'=>$v->art_base_type));
}
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

//save ap match
public static function save_ap_match($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$c=$code->info;
$cds=$code->dt;
$lb=0;
$lb2=0;

$match_status_count=0;
$ar_status_count=0;

for($i=0;$i<count($cds);$i++)
{
  $cd=$cds[$i];
  $lb=$lb+(float)$cd->apdm_bl_amount;
  $lb2=$lb2+(float)$cd->matched_amt;

  $statement = $db->prepare("INSERT INTO mt_ap_match_details(
APM_M_AR,
APM_M_TYPE,
APM_M_NUMBER,
APM_M_AMOUNT,
APM_T_TYPE,
APM_T_NUMBER,
APM_T_DATE,
APM_T_AMOUNT,
APM_T_BALANCE,
APM_MATCH_REFERENCE,ip,ua,ekey,created_by,created_date,APM_status,
apm_t_id)
VALUES(:APM_M_AR,:APM_M_TYPE,:APM_M_NUMBER,:APM_M_AMOUNT,:APM_T_TYPE,:APM_T_NUMBER,:APM_T_DATE,:APM_T_AMOUNT,:APM_T_BALANCE,:APM_MATCH_REFERENCE,:ip,:ua,:ekey,:created_by,now(),:status,
:apm_t_id)");
$ps='PENDING';
if($cd->apdm_bl_amount==0)
{
  $ps='COMPLETED';
}
$statement->execute(array(':ip'=>$dev->ip,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':created_by'=>$dev->username,
':APM_M_AR'=>$c->apt_code,
':APM_M_TYPE'=>$c->apt_base_type,
':APM_M_NUMBER'=>$c->apt_number,
':APM_M_AMOUNT'=>$c->apt_local_balance,
':APM_T_TYPE'=>$cd->apdm_doc_type,
':APM_T_NUMBER'=>$cd->apdm_doc_number,
':APM_T_DATE'=>$cd->apdm_date,
':APM_T_AMOUNT'=>$cd->matched_amt,
':APM_T_BALANCE'=>$cd->apdm_bl_amount,
':APM_MATCH_REFERENCE'=>$cd->other_reference,
':status'=>$ps,
':apm_t_id'=>$cd->id
));

if ($statement->rowCount()){
  $match_status_count+=1;
  $data["match_status".($i+1)]=1;
} else{
  $data["match_status".($i+1)]=0;
}

$data["bl"]=$cd->apdm_bl_amount;


//update ind trans
$ibs='A';
if($cd->apdm_bl_amount==0)
{
  $ibs='C'; //completed
}
$statement = $db->prepare("UPDATE mt_ap_trans 
  set apt_local_balance=:amt,modified_date=now(),
  modified_by=:modified_by, 
  apt_balance_status=:ibs 
  where apt_number=:no and apt_code=:apt_code and id=:id");
$statement->execute(array(':no'=>$cd->apdm_doc_number,
  ':ibs'=>$ibs,
  ':amt'=>$cd->apdm_bl_amount,
':apt_code'=>$c->apt_code,
':modified_by'=>$dev->username,
':id'=>$cd->id
));

if ($statement->rowCount()){
  $ar_status_count+=1;
  $data["trans_status".($i+1)]=1;
} else{
  $data["trans_status".($i+1)]=0;
}

}
//end of for loop

//update main trans

//$temp=(float)abs($c->apt_local_balance)-abs($lb2);
//$data["lb2"]=$lb2;
//$data["temp"]=$temp;

$bs='C';
//if($temp==0)
//{
//  $bs='C'; //completed
//}
//main trans
$statement = $db->prepare("UPDATE mt_ap_trans 
  set apt_local_balance=:lb, apt_balance_status=:bs,
  modified_by=:modified_by,modified_date=now()
    where apt_number=:no and apt_code=:apt_code");
$statement->execute(array(
  ':no'=>$c->apt_number,
  ':lb'=>0,
  ':bs'=>$bs,
  ':modified_by'=>$dev->username,
':apt_code'=>$c->apt_code));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}


$cr_count=count($cds);
$child_status=$ar_status_count==$cr_count &&  $match_status_count==$cr_count;

if($data["status"]==1 && $child_status)
{
  $db->commit();
}else{
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
  }
  return $data;
}



//SAVE AR MATCH
//mt_ar_trans_balance LOGIC REMOVED

public static function save_ar_match($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$c=$code->info;
$cds=$code->dt;
$lb=0;
$lb2=0;
$match_status_count=0;
$ar_status_count=0;

for($i=0;$i<count($cds);$i++)
{
  $cd=$cds[$i];
  $lb=$lb+(float)$cd->ardm_bl_amount;
  $lb2=$lb2+(float)$cd->matched_amt;

  $statement = $db->prepare("INSERT INTO mt_ar_match_details(
ARM_M_AR,
ARM_M_TYPE,
ARM_M_NUMBER,
ARM_M_AMOUNT,
ARM_T_TYPE,
ARM_T_NUMBER,
ARM_T_DATE,
ARM_T_AMOUNT,
ARM_T_BALANCE,
ARM_MATCH_REFERENCE,ip,ua,ekey,created_by,created_date,arm_status,arm_t_id)
VALUES(:ARM_M_AR,:ARM_M_TYPE,:ARM_M_NUMBER,:ARM_M_AMOUNT,:ARM_T_TYPE,:ARM_T_NUMBER,:ARM_T_DATE,:ARM_T_AMOUNT,:ARM_T_BALANCE,:ARM_MATCH_REFERENCE,:ip,:ua,:ekey,:created_by,now(),:status,:arm_t_id)");
$ps='PENDING';
if($cd->ardm_bl_amount==0)
{
  $ps='COMPLETED';
}
$statement->execute(array(':ip'=>$dev->ip,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':created_by'=>$dev->username,
':ARM_M_AR'=>$c->art_code,
':ARM_M_TYPE'=>$c->art_base_type,
':ARM_M_NUMBER'=>$c->art_number,
':ARM_M_AMOUNT'=>$c->art_local_balance,
':ARM_T_TYPE'=>$cd->ardm_doc_type,
':ARM_T_NUMBER'=>$cd->ardm_doc_number,
':ARM_T_DATE'=>$cd->ardm_date,
':ARM_T_AMOUNT'=>$cd->matched_amt,
':ARM_T_BALANCE'=>$cd->ardm_bl_amount,
':ARM_MATCH_REFERENCE'=>$cd->other_reference,
':status'=>$ps,
':arm_t_id'=>$cd->id
));

if ($statement->rowCount()){
  $match_status_count+=1;
  $data["match_status".($i+1)]=1;
} else{
  $data["match_status".($i+1)]=0;
}

$data["bl"]=$cd->ardm_bl_amount;


//update ind trans
$ibs='A';
if($cd->ardm_bl_amount==0)
{
  $ibs='C'; //completed
}
$statement = $db->prepare("UPDATE mt_ar_trans 
  set modified_date=now(),art_local_balance=:amt, art_balance_status=:ibs where art_number=:no and art_code=:art_code and art_type=:art_type and id=:id");
$statement->execute(array(':no'=>$cd->ardm_doc_number,
  ':ibs'=>$ibs,
  ':amt'=>$cd->ardm_bl_amount,
  ':art_code'=>$c->art_code,
  ':art_type'=>$cd->ardm_doc_type,
  ':id'=>$cd->id
));


if ($statement->rowCount()){
  $ar_status_count+=1;
  $data["trans_status".($i+1)]=1;
} else{
  $data["trans_status".($i+1)]=0;
}

}
//end of for loop
//update main trans
//$aq=self::getRestrictionQuery($dev);
$bs='A';
if($lb==0)
{
  $bs='C'; //completed
}
$bs2='A';
$temp=(float)abs($c->art_local_balance)-$lb2;
$data["lb2"]=$lb2;
$data["temp"]=$temp;

if($temp==0)
{
  $bs='C'; //completed
}

$statement = $db->prepare("UPDATE mt_ar_trans 
  set art_local_balance=:lb, art_balance_status=:bs,
  modified_by=:modified_by,modified_date=now()
    where art_number=:no and art_code=:art_code and 
    abs(art_local_amount)=:lamt and art_type=:art_type");
$statement->execute(array(
  ':no'=>$c->art_number,
  ':lb'=>-0,
  ':bs'=>'C',
  ':modified_by'=>$dev->username,
':art_code'=>$c->art_code,
':lamt'=>abs($c->art_local_balance),
':art_type'=>$c->art_base_type ));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}


$cr_count=count($cds);
$child_status=$ar_status_count==$cr_count &&  $match_status_count==$cr_count;

if($data["status"]==1 && $child_status)
{
  $db->commit();
}else{
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
  }
  return $data;
}


//search bank list
public static function search_bank_list($dev,$code)
{
$data=false;
try
{
$db = Factory::getConnection();

$aq=self::getRestrictionQuery($dev);

$statement = $db->prepare("SELECT id,
bank_code,description,account_no,swift_code,country,
currency,contact_person,iban_code,sort_code 
from 
mt_bank_list 
where bank_code like ? or account_no like ?
or country like ? or currency like ? 
order by id desc limit :sta,50");

$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(4, "%$v%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

//var_dump($statement->debugDumpParams());

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_bank_info($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();

$aq=self::getRestrictionQuery($dev);

$statement = $db->prepare("SELECT id,bank_code,description,account_no,swift_code,country,currency,contact_person,iban_code,sort_code,rtgs_code,ifsc_code,account_type,od_limit_dr,od_warning_limit_dr,active_from,active_to,status 
from 
mt_bank_list where id=:id");

$statement->execute(array(':id'=>$code));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT id,bank_pk,address,country,state,city,zip,mobile1,mobile2,email 
from 
mt_bank_address where bank_pk=:id");

$statement->execute(array(':id'=>$code));
$data["address"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT id,bank_pk,cheque_serial,from_no,to_no,warning_leafcount,nexttouse_count,lastused_no,lastused_on,lastused_voucher_no,status 
from 
mt_bank_cheque where bank_pk=:id");

$statement->execute(array(':id'=>$code));
$data["cheque"]=$statement->fetchAll(PDO::FETCH_ASSOC);
//var_dump($statement->debugDumpParams());

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_bank_list($dev,$code)
{
$data=false;
try
{
$db = Factory::getConnection();

$aq=self::getRestrictionQuery($dev);
$country='';
if($dev->location=='MUMBAI')
{
  $country='IN';
}else if($dev->location=='OMAN')
{
  $country='OM';
}
$statement = $db->prepare("SELECT id,
bank_code,description,account_no,swift_code,country,
currency,contact_person,iban_code,sort_code 
from 
mt_bank_list where country='$country' 
order by id desc limit :sta,50");
$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

//var_dump($statement->debugDumpParams());

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_period_ledger_list($dev,$code)
{
$data=false;
try
{
$db = Factory::getConnection();

$aq=self::getRestrictionQuery($dev);

$statement = $db->prepare("SELECT id,
period_id,sub_ledger,sub_status,'0' edit  
from 
mt_period_ledger where period_id=:id order by id asc ");

$statement->execute(array(':id'=>$code));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

//var_dump($statement->debugDumpParams());

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function delete_period_ledger($dev,$code)
{
$data=array();
$c=$code;
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_period_ledger
 where id=:id");

$statement->execute(array(
  ':id'=>$c
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}
//var_dump($statement->debugDumpParams());

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_period_ledger($dev,$code)
{
$data=array();
$c=$code;
try
{
$db = Factory::getConnection();

//$aq=self::getRestrictionQuery($dev);

$statement = $db->prepare("UPDATE mt_period_ledger
  SET sub_ledger=:sub_ledger,sub_status=:sub_status,
  modified_by=:created_by,modified_date=now()
  where id=:id ");

$statement->execute(array(
  ':sub_ledger'=>$c->sub_ledger,
  ':sub_status'=>$c->sub_status,
  

':id'=>$c->company,
':created_by'=>$dev->username
));


if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
//var_dump($statement->debugDumpParams());

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_period_ledger($dev,$code)
{
$data=array();
$c=$code;
try
{
$db = Factory::getConnection();

//$aq=self::getRestrictionQuery($dev);
$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT INTO mt_period_ledger(period_id,sub_ledger,sub_status,ip,ua,ekey,created_by,created_date,temp_code,company_id,location_id)
  VALUES(:period_id,:sub_ledger,:sub_status,:ip,:ua,:ekey,
  :created_by,now(),:temp_code,:company_id,:location_id) 
");

$statement->execute(array(
  ':period_id'=>$c->period_id,
  ':sub_ledger'=>$c->sub_ledger,
  ':sub_status'=>$c->sub_status,
  

':company_id'=>$dev->company,
':location_id'=>$dev->location,
':ip'=>$dev->ip,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':created_by'=>$dev->username,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
//var_dump($statement->debugDumpParams());

  $statement = $db->prepare("SELECT id from mt_period_ledger where 
    created_by=:created_by and temp_code=:temp_code");
  $statement->execute(array(':temp_code'=>$temp_code,
    ':created_by'=>$dev->username));
  $data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_period($dev,$code)
{
$data=array();
$c=$code;
try
{
$db = Factory::getConnection();

$aq=self::getRestrictionQuery($dev);

$statement = $db->prepare("UPDATE mt_period set enumber=:enumber,period=:period,
from_date=:from_date,to_date=:to_date,open_max=:open_max,
auto_close=:auto_close,modified_by=:username,modified_date=now()
 where id=:id");

$statement->execute(array(
  ':enumber'=>$c->enumber,
  ':period'=>$c->period,
  ':from_date'=>$c->from_date,
  ':to_date'=>$c->to_date,
  ':open_max'=>$c->open_max,
  ':auto_close'=>$c->auto_close,

  ':id'=>$c->id,
  ':username'=>$dev->username

));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
//var_dump($statement->debugDumpParams());

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_period_list($dev,$code)
{
$data=false;
try
{
$db = Factory::getConnection();

$aq=self::getRestrictionQuery($dev);

$statement = $db->prepare("SELECT id,
company,year,type,enumber,period,
from_date,to_date,open_max,auto_close,'0' edit  
from 
mt_period order by enumber  limit :sta,50");
$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

//var_dump($statement->debugDumpParams());

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_gl_link_list($dev,$code)
{
$data=false;
try
{
$db = Factory::getConnection();

$aq=self::getRestrictionQuery($dev);

$statement = $db->prepare("SELECT 
name,gl_account,gl_receivable_pdc,gl_payable_pdc,active_from,
active_to,active_status,account_type,account_nature
from
mt_gl_link 
where name=:name 
order by id desc ");
$statement->bindValue(':name',$code, PDO::PARAM_INT); 

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

//var_dump($statement->debugDumpParams());

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function setFourDigit($v)
{
  $len=strlen($v);

if($len==1)
{
  $v="000".$v;
}else if($len==2)
{
  $v="00".$v;
}else if($len==3)
{
  $v="0".$v;
}

return $v;
}

//get gl link code

public static function get_gl_link($dev,$c)
{
$data=array();
try
{

$db = Factory::getConnection();

$statement = $db->prepare("SELECT gl_account from mt_gl_link where name=:name limit 1");

$statement->execute(array(':name'=>$c));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
}
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_bank_gl_code($dev,$c)
{
$data=array();
try
{

$db = Factory::getConnection();

$statement = $db->prepare("SELECT account_no from mt_bank_list where bank_code=:name limit 1");

$statement->execute(array(':name'=>$c));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
}
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


//bank receipt voucher
public static function save_voucher_preparation_bank_receipt($dev,$c)
{
$data=array();
try
{

$tds_todo=true;
$tds_todo=getTDSApplicable($dev->location,$dev->company);

//CHEQUE SAVING STARTS
//If CHEQUE, NO POSTING TO FIN TABLES
if($c->info->doc_type=="CHEQUE")
{

$db = Factory::getConnection();
$db->beginTransaction();

$info=$c->info;
$vpds=$c->vpd;
$h=$vpds[0];

$customer_code=$h->add_info->bank_name;
$bank=$h->add_info;

//SET VALUES TO TDS VARIABLES
$c->voucher_type=$h->voucher_type;
$c->order_no="";
$c->customer_name=$customer_code;
$c->tds_amt=$h->tds_amt;


$temp_code=uniqid($dev->uid);

//query 1
$statement = $db->prepare("INSERT into mt_receipt_header ( rh_company, rh_base_doc_type, rh_doc_type, rh_doc_date, rh_gl_date, rh_cash_bank_code, rh_currency, rh_exchange_rate, rh_foreign_amount, rh_local_amount, rh_other_reference, rh_cheque_number, rh_cheque_date, rh_narration, rh_notes, rh_status, rh_gl_account,
  ip,ua,ekey,created_by,created_date,temp_code,child,company_id,location_id ) VALUES (:company,:voucher_type,:doc_type,:doc_date,:doc_date,
  :bank_name,:currency,:ex_rate,:base_amt_dr,:local_amt_dr,:ref,
  :cheque_no,:cheque_date,:narration,'','AWAITING CONFIRMATION',(SELECT account_no from mt_bank_list where bank_code=:bank_name limit 1),
:ip,:ua,:ekey,:created_by,now(),:temp_code,:child,:company_id,:location_id)");

if($bank->cheque_date=="" or $bank->cheque_date=='NaN-NaN-NaN')
{
  $bank->cheque_date=null;
}
$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company'=>$dev->company,
':voucher_type'=>$h->voucher_type,
':doc_type'=>$info->doc_type,
':doc_date'=>$info->doc_date,

':bank_name'=>$bank->bank_name,
':cheque_no'=>$bank->cheque_no,
':cheque_date'=>$bank->cheque_date,

':ref'=>$h->ref,
':currency'=>$h->currency,
':ex_rate'=>$h->ex_rate,
':base_amt_dr'=>$h->base_amt_dr,
':local_amt_dr'=>$h->local_amt_dr,
':narration'=>$h->narration,

':temp_code'=>$temp_code,
':company_id'=>$dev->company,
':location_id'=>$dev->location,

':child'=>json_encode($vpds)
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";

} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";

}
$data["temp_code"]=$temp_code;
$statement = $db->prepare("SELECT id from mt_receipt_header where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

//set doc number

$fid=self::setFourDigit($op[0]["id"]);
$fid1=$op[0]["id"];

$vtype="PV";
$prefix="";
if($info->doc_type=="CASH")
{
$prefix="RCH";
}else if($info->doc_type=="CHEQUE")
{
$prefix="RBC";
}else if($info->doc_type=="ONLINE TRANSFER")
{
$prefix="ROT";
}else if($info->doc_type=="CARD")
{
$prefix="RCT";
}

$fid=self::generate_voucher_no1($db,$dev,$prefix,$temp_code);
$fid=self::setFourDigit($fid);
$fid1=$fid;

$on=$prefix."/".date("Y")."/".date('m')."/".$fid;

 $statement = $db->prepare("UPDATE mt_receipt_header 
  SET rh_doc_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["pay_id_status"]=1;
  } else{
    $data["pay_id_status"]=0;
  }

$data["doc_no"]=$on;

$doc_no=$on;

//query 1 ends

//exclude header in child table
//query 2
$child_ap_count=0;
$child_ap_status_count=0;
$child_rd_status_count=0;

for($i=1;$i<count($vpds);$i++)
{

$r=$vpds[$i];
$temp_code=uniqid($dev->uid);
$q="";
$qv="";

$gls=self::get_gl_link($dev,'RECEIVABLE');
//$gl_code=$gls[0]["gl_account"];
$gl_code='';
if(count($gls)>=1)
{
$gl_code=$gls[0]["gl_account"];
}

if($r->allocation=="ACCOUNTS RECEIVABLE")
{
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$gl_code','$ai->customer_name','$ai->customer_address'";
}

if($r->allocation=="ACCOUNTS PAYABLE")
{
  $child_ap_count+=1;

  $gls=self::get_gl_link($dev,'PAYABLE');
  //$gl_code=$gls[0]["gl_account"];
  $gl_code='';
  if(count($gls)>=1)
  {
  $gl_code=$gls[0]["gl_account"];
  }
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$gl_code','$ai->customer_name','$ai->customer_address'";

  //addition query 1

/*QUERY 1*/
$statement = $db->prepare("INSERT into mt_ap_trans 
(apt_company,apt_code,apt_type,apt_number,apt_serial,apt_group,
apt_base_type,apt_internal,apt_other_reference,apt_doc_date,
apt_gl_date,apt_year,apt_period,apt_age_date,
apt_dp_date,apt_currency,apt_ex_rate,apt_foreign_amount,
apt_local_amount,apt_foreign_balance,
apt_local_balance,apt_balance_status,
apt_description,apt_notes,
ip,created_by ,ua,ekey,created_date,temp_code,
company_id,location_id)
VALUES
(:company,:arh_code,:doc_type,:doc_no,'$i','PAYABLE','PAYABLE VOUCHER',0,'',:doc_date,:doc_date,".self::getFinancialYear().",
".self::getFinancialPeriod($info->doc_date).",:doc_date,:doc_date,:currency,:ex_rate,:base_amt_dr,:local_amt_dr,:base_amt_dr,
:local_amt_dr,'A',:narration,:reference,:ip,:created_by,
:ua,:ekey,now(),:temp_code,'$dev->company','$dev->location')");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code,
//
':company'=>$dev->company,
':arh_code'=>$ai->customer_name,
':doc_type'=>$info->doc_type,
':doc_no'=>$doc_no,
':doc_date'=>$info->doc_date,

':base_amt_dr'=>$r->base_amt_cr,
':local_amt_dr'=>$r->local_amt_cr,
':narration'=>$r->narration,
':currency'=>$r->currency,
':ex_rate'=>$r->ex_rate,

':reference'=>$r->ref

));

 if ($statement->rowCount()){
    $child_ap_status_count+=1;
    $data["ap_ap_status".($i+1)]=1;
  } else{
    $data["ap_ap_status".($i+1)]=0;
  }
/* QUERY 1 ENDS */
}

if($r->allocation=="BANK")
{
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->bank_name','$ai->cheque_no','$ai->cheque_date'";
}

if($r->allocation=="INCOME")
{
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->income', '$ai->gl_group_name','$r->cost_center'";
}

if($r->allocation=="ASSETS")
{
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->assets', '$ai->gl_group_name', '$r->cost_center'";
}

if($r->allocation=="LIABILITY")
{
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->liability','$ai->gl_group_name','$r->cost_center'";
}

if($r->base_amt_cr=="")
{
  $r->base_amt_cr=null;
}
if($r->local_amt_cr=="")
{
  $r->local_amt_cr=null;
}

if($r->ex_rate=="")
{
  $r->ex_rate=null;
}



$statement = $db->prepare("INSERT into mt_receipt_allocation_details 
(aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,aloc_foreign_amount,aloc_local_amount,aloc_narration,
  aloc_notes,aloc_detail_5,aloc_account,aloc_currency,aloc_ex_rate,$q,
ip,created_by ,ua,ekey,created_date,temp_code,location_id,company_id)
VALUES
(:company,:voucher_type,:doc_type,:doc_no,:allocation,
  :base_amt_cr,:local_amt_cr,
  :narration,'',:ref,'$gl_code',:currency,:ex_rate,$qv,
  :ip,:created_by,:ua ,:ekey,now(),:temp_code,:location_id,:company_id)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code,

':company'=>$dev->company,
':voucher_type'=>$r->voucher_type,
':doc_type'=>$info->doc_type,
':doc_no'=>$doc_no,

':allocation'=>$r->allocation,
':base_amt_cr'=>$r->base_amt_cr*(-1),
':local_amt_cr'=>$r->local_amt_cr*(-1),
':narration'=>$r->narration,
':currency'=>$r->currency,
':ex_rate'=>$r->ex_rate,

':ref'=>$r->ref,
':location_id'=>$dev->location,
':company_id'=>$dev->company
//':ref_date'=>$r->ref_date

));

if ($statement->rowCount()){
  $child_rd_status_count+=1;
  $data["ahd_status-".($i+1)]=1;
} else{
  $data["ahd_status-".($i+1)]=0;
}

}


if($tds_todo)
{
  //tdsquery 2
  //1-30-002-0002 TDS RECEIVABLE
  if($c->tds_amt!=0){
    $statement = $db->prepare("INSERT into mt_receipt_allocation_details 
    (aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,aloc_foreign_amount,aloc_local_amount,aloc_narration,aloc_notes,
      aloc_detail_1,aloc_detail_2,aloc_detail_3, aloc_detail_5,aloc_account,aloc_currency,aloc_ex_rate,
    ip,created_by ,ua,ekey,created_date,temp_code,location_id,company_id)
    VALUES
    (:company,:voucher_type,'TDS RECEIVABLE',:doc_no,'TDS RECEIVABLE',
      :base_amt_cr,:local_amt_cr,
      :narration,:ref,
      '1-30-002-0002','$c->customer_name','$c->order_no',
      '1-30-002-0002','','INR',1,
      :ip,:created_by,:ua ,:ekey,now(),:temp_code,:location_id,:company_id)");

    $statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
    ':ua'=>$dev->ua,
    ':ekey'=>$dev->ekey,
    ':temp_code'=>$temp_code,

    ':company'=>$dev->company,
    ':voucher_type'=>$c->voucher_type,
    ':doc_no'=>$doc_no,

    ':base_amt_cr'=>$c->tds_amt*(-1),
    ':local_amt_cr'=>$c->tds_amt*(-1),
    ':narration'=>'TDS RECEIVABLE',

    ':ref'=>$c->order_no,
    ':location_id'=>$dev->location,
    ':company_id'=>$dev->company

    ));

    if ($statement->rowCount()){
      $data["tds_status-"]=1;
    } else{
      $data["tds_status-"]=0;
    }
  }
  //tdsquery 2 ends
}

$child_status=$child_ap_count==$child_ap_status_count && $child_rd_status_count==(count($vpds)-1);
//$data["status"]=0;
if($data["status"]==1 && $data["pay_id_status"]==1 && $child_status)
{
  $db->commit();

}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}

$statement=null;
//query 2 ends
// CHEQUE SAVING ENDS
}
else
{
//FINANCE POSTING STARTS FOR OTHER RECEIPTS
$db = Factory::getConnection();
$db->beginTransaction();

$info=$c->info;
$vpds=$c->vpd;
$h=$vpds[0];

$customer_code=$h->add_info->bank_name;
$bank=$h->add_info;

//SET VALUES TO TDS VARIABLES
$c->voucher_type=$h->voucher_type;
$c->order_no="";
$c->customer_name=$customer_code;
$c->tds_amt=$h->tds_amt;

$temp_code=uniqid($dev->uid);

//query 1
$statement = $db->prepare("INSERT into mt_receipt_header ( rh_company, rh_base_doc_type, rh_doc_type, rh_doc_date, rh_gl_date, rh_cash_bank_code, rh_currency, rh_exchange_rate, rh_foreign_amount, rh_local_amount, rh_other_reference, rh_cheque_number, rh_cheque_date, rh_narration, rh_notes, rh_status, rh_gl_account,
  ip,ua,ekey,created_by,created_date,temp_code,child,company_id,location_id ) VALUES (:company,:voucher_type,:doc_type,:doc_date,:doc_date,
  :bank_name,:currency,:ex_rate,:base_amt_dr,:local_amt_dr,:ref,
  :cheque_no,:cheque_date,:narration,'','POSTED',(SELECT account_no from mt_bank_list where bank_code=:bank_name limit 1),
:ip,:ua,:ekey,:created_by,now(),:temp_code,:child,:company_id,:location_id)");

if($bank->cheque_date=="" or $bank->cheque_date=='NaN-NaN-NaN')
{
  $bank->cheque_date=null;
}
$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company'=>$dev->company,
':voucher_type'=>$h->voucher_type,
':doc_type'=>$info->doc_type,
':doc_date'=>$info->doc_date,

':bank_name'=>$bank->bank_name,
':cheque_no'=>$bank->cheque_no,
':cheque_date'=>$bank->cheque_date,

':ref'=>$h->ref,
':currency'=>$h->currency,
':ex_rate'=>$h->ex_rate,
':base_amt_dr'=>$h->base_amt_dr,
':local_amt_dr'=>$h->local_amt_dr,
':narration'=>$h->narration,

':temp_code'=>$temp_code,
':company_id'=>$dev->company,
':location_id'=>$dev->location,

':child'=>json_encode($vpds)
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}
$data["temp_code"]=$temp_code;
$statement = $db->prepare("SELECT id from mt_receipt_header where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

//set doc number

$fid=self::setFourDigit($op[0]["id"]);
$fid_n1=$op[0]["id"];

$vtype="PV";
$prefix="";
if($info->doc_type=="CASH")
{
$prefix="RCH";
}else if($info->doc_type=="CHEQUE")
{
$prefix="RBC";
}else if($info->doc_type=="ONLINE TRANSFER")
{
$prefix="ROT";
}else if($info->doc_type=="CARD")
{
$prefix="RCT";
}

$fid=self::generate_voucher_no1($db,$dev,$prefix,$temp_code);
$fid=self::setFourDigit($fid);
$fid1=$fid;

$on=$prefix."/".date("Y")."/".date('m')."/".$fid;

 $statement = $db->prepare("UPDATE mt_receipt_header 
  SET rh_doc_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["pay_id_status"]=1;
  } else{
    $data["pay_id_status"]=0;
  }

$data["doc_no"]=$on;

$doc_no=$on;

//query 1 ends

//exclude header in child table
//query 2
$child_ap_count=0;
$child_ap_status_count=0;
$child_rd_status_count=0;
$child_cc_count=0;
$child_cc_status_count=0;
$child_bank_count=0;

for($i=1;$i<count($vpds);$i++)
{

$r=$vpds[$i];
$temp_code=uniqid($dev->uid);
$q="";
$qv="";

$gls=self::get_gl_link($dev,'RECEIVABLE');
//$gl_code=$gls[0]["gl_account"];
    $gl_code='';
    if(count($gls)>=1)
    {
    $gl_code=$gls[0]["gl_account"];
    }

if($r->allocation=="ACCOUNTS RECEIVABLE")
{
  $ai=$r->add_info;
  $c->customer_name=$ai->customer_name;

  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$gl_code','$ai->customer_name','$ai->customer_address'";
}

if($r->allocation=="ACCOUNTS PAYABLE")
{
  $child_ap_count+=1;
  $gls=self::get_gl_link($dev,'PAYABLE');
  //$gl_code=$gls[0]["gl_account"];
    $gl_code='';
    if(count($gls)>=1)
    {
    $gl_code=$gls[0]["gl_account"];
    }

  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$gl_code','$ai->customer_name','$ai->customer_address'";

  //addition query 1

/*QUERY 1*/
$statement = $db->prepare("INSERT into mt_ap_trans 
(apt_company,apt_code,apt_type,apt_number,apt_serial,apt_group,
apt_base_type,apt_internal,apt_other_reference,apt_doc_date,
apt_gl_date,apt_year,apt_period,apt_age_date,
apt_dp_date,apt_currency,apt_ex_rate,apt_foreign_amount,
apt_local_amount,apt_foreign_balance,
apt_local_balance,apt_balance_status,
apt_description,apt_notes,
ip,created_by ,ua,ekey,created_date,temp_code,
company_id,location_id)
VALUES
(:company,:arh_code,:doc_type,:doc_no,'$i','PAYABLE','PAYABLE VOUCHER',0,'',:doc_date,:doc_date,".self::getFinancialYear().",
".self::getFinancialPeriod($info->doc_date).",:doc_date,:doc_date,:currency,:ex_rate,:base_amt_dr,:local_amt_dr,:base_amt_dr,
:local_amt_dr,'A',:narration,:reference,:ip,:created_by,
:ua,:ekey,now(),:temp_code,'$dev->company','$dev->location')");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code,
//
':company'=>$dev->company,
':arh_code'=>$ai->customer_name,
':doc_type'=>$info->doc_type,
':doc_no'=>$doc_no,
':doc_date'=>$info->doc_date,

':base_amt_dr'=>$r->base_amt_cr,
':local_amt_dr'=>$r->local_amt_cr,
':narration'=>$r->narration,
':currency'=>$r->currency,
':ex_rate'=>$r->ex_rate,

':reference'=>$r->ref

));

 if ($statement->rowCount()){
    $child_ap_status_count+=1;
    $data["ap_ap_status".($i+1)]=1;
  } else{
    $data["ap_ap_status".($i+1)]=0;
  }
/* QUERY 1 ENDS */
}

if($r->allocation=="BANK")
{
  $child_bank_count+=1;
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->bank_name','$ai->cheque_no','$ai->cheque_date'";
}

if($r->allocation=="INCOME")
{
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->income', '$ai->gl_group_name','$r->cost_center'";
}

if($r->allocation=="ASSETS")
{
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->assets', '$ai->gl_group_name', '$r->cost_center'";
}

if($r->allocation=="LIABILITY")
{
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->liability','$ai->gl_group_name','$r->cost_center'";
}

if($r->base_amt_cr=="")
{
  $r->base_amt_cr=null;
}
if($r->local_amt_cr=="")
{
  $r->local_amt_cr=null;
}

if($r->ex_rate=="")
{
  $r->ex_rate=null;
}



$statement = $db->prepare("INSERT into mt_receipt_allocation_details 
(aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,aloc_foreign_amount,aloc_local_amount,aloc_narration,
  aloc_notes,aloc_detail_5,aloc_account,aloc_currency,aloc_ex_rate,$q,
ip,created_by ,ua,ekey,created_date,temp_code,location_id,company_id)
VALUES
(:company,:voucher_type,:doc_type,:doc_no,:allocation,
  :base_amt_cr,:local_amt_cr,
  :narration,'',:ref,'$gl_code',:currency,:ex_rate,$qv,
  :ip,:created_by,:ua ,:ekey,now(),:temp_code,:location_id,:company_id)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code,

':company'=>$dev->company,
':voucher_type'=>$r->voucher_type,
':doc_type'=>$info->doc_type,
':doc_no'=>$doc_no,

':allocation'=>$r->allocation,
':base_amt_cr'=>$r->base_amt_cr*(-1),
':local_amt_cr'=>$r->local_amt_cr*(-1),
':narration'=>$r->narration,
':currency'=>$r->currency,
':ex_rate'=>$r->ex_rate,

':ref'=>$r->ref,
':location_id'=>$dev->location,
':company_id'=>$dev->company
//':ref_date'=>$r->ref_date

));

if ($statement->rowCount()){
  $child_rd_status_count+=1;
  $data["ahd_status-".($i+1)]=1;
} else{
  $data["ahd_status-".($i+1)]=0;
}

//query - cost center
if($r->cost_center!="")
{
  $child_cc_count+=1;
  $statement = $db->prepare("INSERT INTO mt_cost_center
  (cost_gl_code, cost_glt_company, cost_glt_doc_base, cost_glt_doc_type, cost_glt_number, cost_glt_doc_date, cost_glt_gl_date, cost_glt_other_reference,  cost_glt_currency,  cost_glt_ex_rate,  
    cost_glt_foreign_amount, cost_glt_local_amount, cost_glt_narration,  cost_glt_aloc_type, 
  ip,  ua,  ekey,  created_by,  created_date)
  VALUES
  (:cost_gl_code, :company, :voucher_type, :doc_type, :doc_no, :doc_date, :gl_date,
    :ref, :currency, :ex_rate, 
    :base_amt_cr, :local_amt_cr,  :narration, :allocation,
    :ip, :ua, :ekey, :created_by, now()) ");

  $statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
  ':ua'=>$dev->ua,
  ':ekey'=>$dev->ekey,

  ':cost_gl_code'=>$r->cost_center,
  ':company'=>$dev->company,
  ':voucher_type'=>$r->voucher_type,
  ':doc_type'=>$info->doc_type,
  ':doc_no'=>$doc_no,
  ':doc_date'=>$info->doc_date,
  ':gl_date'=>$info->doc_date,

  ':ref'=>$r->ref,
  ':currency'=>$r->currency,
  ':ex_rate'=>$r->ex_rate,
  ':base_amt_cr'=>$r->base_amt_cr*(-1),
  ':local_amt_cr'=>$r->local_amt_cr*(-1),
  ':narration'=>$r->narration,
  ':allocation'=>$r->allocation

  ));

  if ($statement->rowCount()){
    $child_cc_status_count+=1;
    $data["cc_status"]=1;
  } else{
    $data["cc_status"]=0;
  }
}
//query - cost center ends

}
//query 2 ends


if($tds_todo)
{
  //tdsquery 2
  //1-30-002-0002 TDS RECEIVABLE
  if($c->tds_amt!=0){
    $statement = $db->prepare("INSERT into mt_receipt_allocation_details 
    (aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,aloc_foreign_amount,aloc_local_amount,aloc_narration,aloc_notes,
      aloc_detail_1,aloc_detail_2,aloc_detail_3, aloc_detail_5,aloc_account,aloc_currency,aloc_ex_rate,
    ip,created_by ,ua,ekey,created_date,temp_code,location_id,company_id)
    VALUES
    (:company,:voucher_type,'TDS RECEIVABLE',:doc_no,'TDS RECEIVABLE',
      :base_amt_cr,:local_amt_cr,
      :narration,:ref,
      '1-30-002-0002','$c->customer_name','$c->order_no',
      '1-30-002-0002','','INR',1,
      :ip,:created_by,:ua ,:ekey,now(),:temp_code,:location_id,:company_id)");

    $statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
    ':ua'=>$dev->ua,
    ':ekey'=>$dev->ekey,
    ':temp_code'=>$temp_code,

    ':company'=>$dev->company,
    ':voucher_type'=>$c->voucher_type,
    ':doc_no'=>$doc_no,

    ':base_amt_cr'=>$c->tds_amt*(-1),
    ':local_amt_cr'=>$c->tds_amt*(-1),
    ':narration'=>'TDS RECEIVABLE',

    ':ref'=>$c->order_no,
    ':location_id'=>$dev->location,
    ':company_id'=>$dev->company

    ));

    if ($statement->rowCount()){
      $data["tds_status-"]=1;
    } else{
      $data["tds_status-"]=0;
    }
  }
  //tdsquery 2 ends
}

//query 3
$statement = $db->prepare("INSERT into mt_ar_trans 
(art_company,art_code,art_type,art_number,art_serial,art_group,
art_base_type,art_internal,art_other_reference,art_doc_date,
art_gl_date,art_year,art_period,art_age_date,
art_dp_date,art_currency,art_ex_rate,art_foreign_amount,
art_local_amount,art_foreign_balance,
art_local_balance,art_balance_status,
art_description,art_notes,
ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id)
SELECT aloc_company,aloc_detail_2,aloc_doc_type,aloc_doc_number,
1,aloc_detail_1,aloc_base_doc,0,
aloc_detail_5,
'$info->doc_date','$info->doc_date',".self::getFinancialYear().",".self::getFinancialPeriod($info->doc_date).",
'$info->doc_date','$info->doc_date',aloc_currency,aloc_ex_rate,
aloc_foreign_amount,aloc_local_amount,aloc_foreign_amount,
aloc_local_amount,'A',
aloc_narration,aloc_detail_3,
ip,created_by,ua ,ekey,now(),'$temp_code',
'$dev->company','$dev->location'   
FROM mt_receipt_allocation_details where aloc_doc_number=:id");

$statement->execute(array(':id'=>$doc_no
));

if ($statement->rowCount()){
  $data["ar_trans_status"]=1;
} else{
  $data["ar_trans_status"]=0;
}
//query 3 ends


// //query 4 part1 header
$gls=self::get_gl_link($dev,'RECEIVABLE');

  $pcode='';
  if(count($gls)>=1)
  {
    $pcode=$gls[0]["gl_account"];
  }

// $statement = $db->prepare("INSERT into mt_receipt_gl_details
// (pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,
//   pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,
//   pre_glt_gl_date,pre_glt_year,pre_glt_period,
//   pre_glt_other_reference,pre_glt_currency,
//   pre_glt_ex_rate,pre_glt_foreign_amount,
//   pre_glt_local_amount,pre_glt_narration,
// ip,created_by ,ua,ekey,created_date,temp_code)
// SELECT rh_company,
// '$pcode',
// rh_base_doc_type,rh_doc_type,
// rh_doc_number,rh_internal_number,rh_doc_date,
// rh_gl_date,".self::getFinancialYear().",".
// self::getFinancialPeriod($info->doc_date).",rh_other_reference,rh_currency,
// rh_exchange_rate,rh_foreign_amount,
// rh_local_amount,rh_narration,
// ip,created_by,ua ,ekey,now(),'$temp_code'  
// FROM mt_receipt_header where rh_doc_number=:rh_doc_number");

// $statement->execute(array(':rh_doc_number'=>$doc_no));

// if ($statement->rowCount()){
//   $data["ah_gl_status"]=1;
// } else{
//   $data["ah_gl_status"]=0;
// }
// //query 4 ends


//query 4 part2 child
$statement = $db->prepare("INSERT into mt_receipt_gl_details
(pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,
  pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,
  pre_glt_ex_rate,pre_glt_foreign_amount,
  pre_glt_local_amount,pre_glt_narration,
  pre_glt_allocation_code,pre_glt_detail_1,
  pre_glt_detail_2,pre_glt_detail_3,
ip,created_by ,ua,ekey,created_date,temp_code,
location_id,company_id)
SELECT aloc_company,'$pcode',
aloc_base_doc,aloc_doc_type,
aloc_doc_number,aloc_serial,'$info->doc_date',
'$info->doc_date',".self::getFinancialYear().",".
self::getFinancialPeriod($info->doc_date).",aloc_narration,aloc_currency,
aloc_ex_rate,aloc_foreign_amount,
aloc_local_amount,aloc_narration,
aloc_allocation_type,aloc_detail_1,
aloc_detail_2,aloc_detail_3,
ip,created_by,ua ,ekey,now(),'$temp_code',
'$dev->company','$dev->location'   
FROM mt_receipt_allocation_details where aloc_doc_number=:aloc_doc_number");

$statement->execute(array(':aloc_doc_number'=>$doc_no));

if ($statement->rowCount()){
  $data["ah_gl_status2"]=1;
} else{
  $data["ah_gl_status2"]=0;
}
//query 4 part2 ends


//query 5
$statement = $db->prepare("INSERT into mt_ar_trans_balance
(ardm_company,ardm_code,ardm_doc_type,ardm_doc_number,
  ardm_serial,ardm_other_reference,ardm_date,ardm_currency,
  ardm_ex_rate,ardm_of_amount,ardm_ol_amount,ardm_bf_amount,
  ardm_bl_amount,ardm_pf_amount,ardm_pl_amount,ardm_status,
ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id)
SELECT art_company,art_code,art_type,art_number,
art_serial,art_other_reference,art_gl_date,art_currency,
art_ex_rate,art_foreign_amount,art_local_amount,
art_foreign_balance,art_local_balance,
0,0,'PENDING',ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location'  
 from mt_ar_trans where art_number=:doc_no
");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["tb_status"]=1;
} else{
  $data["tb_status"]=0;
}
//query 5 ends

//query 6
$statement = $db->prepare("INSERT into mt_cash_book_details 
( cb_company,cb_doc_type,cb_doc_number,cb_internal_number,cb_base_doc_type,cb_code,cb_type,cb_gl_date,cb_doc_date,cb_due_pay_date,cb_year,cb_period,cb_currency,cb_ex_rate,cb_foreign_amount,cb_local_amount,cb_cheque_number,cb_cheque_date,cb_account,cb_status,
  ip,created_by ,ua,ekey,
  created_date,temp_code) 
SELECT rh_company,rh_doc_type,rh_doc_number,rh_internal_number,
rh_base_doc_type,rh_cash_bank_code,rh_type,
rh_gl_date,rh_doc_date,rh_doc_date,".self::getFinancialYear().",".
self::getFinancialPeriod($info->doc_date).",rh_currency,rh_exchange_rate,
rh_foreign_amount,rh_local_amount,
rh_cheque_number,rh_cheque_date,rh_gl_account,'POSTED',
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$temp_code'
 from mt_receipt_header where rh_doc_number=:doc_no");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["cb_status"]=1;
} else{
  $data["cb_status"]=0;
}
//query 6 ends

//add in the cash book details for reporting
$doc_date=$info->doc_date;
$statement = $db->prepare("INSERT into mt_cash_book_details 
( cb_company,cb_doc_type,cb_doc_number,cb_internal_number,cb_base_doc_type,
  cb_code,cb_type,cb_gl_date,cb_doc_date,cb_due_pay_date,cb_year,cb_period,cb_currency,
  cb_ex_rate,cb_foreign_amount,cb_local_amount,cb_account,cb_cheque_number,cb_cheque_date,
  cb_status,
  ip,created_by ,ua,ekey,
  created_date,temp_code) 
SELECT aloc_company,aloc_doc_type,
aloc_doc_number,aloc_serial,aloc_base_doc,aloc_detail_1,aloc_allocation_type,
'$doc_date','$doc_date','$doc_date',".self::getFinancialYear().",".
self::getFinancialPeriod($doc_date).",aloc_currency,
aloc_ex_rate,aloc_foreign_amount,
aloc_local_amount,aloc_detail_1,
aloc_detail_2,aloc_detail_3,'POSTED',
ip,created_by,ua ,ekey,now(),'$temp_code'  
FROM mt_receipt_allocation_details where aloc_doc_number=:doc_no and aloc_allocation_type='BANK' ");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["cb_status2"]=1;
} else{
  $data["cb_status2"]=0;
}

/*
//query 
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_ar_balance
( arb_company,arb_code,arb_year,arb_period,arb_debit,arb_credit,
  arb_closing,
  ip,created_by ,ua,ekey,created_date,temp_code) 
SELECT '$dev->company','$customer_code',".self::getFinancialYear().",".
self::getFinancialPeriod($info->doc_date).",sum(art_local_amount),sum(art_local_amount),
'PENDING',
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$temp_code' from mt_ar_trans where art_number=:doc_no");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["ab_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["ab_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
//query  ends
*/

/*$child_ap_tb_status=true;

if($child_ap_count!=0)
{
  if($data["ap_trans_status"]==0)
  {
  $child_ap_tb_status=false;
  }
}
*/
$child_cb_status2=true;

if($child_bank_count!=0)
{
  if($data["cb_status2"]==0)
  {
  $child_cb_status2=false;
  }
}

$child_status=$child_ap_count==$child_ap_status_count &&  $child_cc_count==$child_cc_status_count && $child_rd_status_count==(count($vpds)-1) && $child_cb_status2;

//$data["status"]=0;

if($data["status"]==1 && $data["pay_id_status"]==1 && $child_status && $data["ar_trans_status"]==1 && $data["ah_gl_status2"]==1 && $data["tb_status"]==1 && $data["cb_status"]==1)
{
  $db->commit();
  
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}

$statement=null;
}
//FINANCE POSTING ENDS

  }
  catch (PDOException $e) {
    print $e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
  }
  
  return $data;
}


//bank payment voucher

public static function save_voucher_preparation_bank_payment($dev,$c)
{
$data=array();
try
{

//CHEQUE SAVING STARTS
//If CHEQUE, NO POSTING TO FIN TABLES
if($c->info->doc_type=="CHEQUE")
{

$db = Factory::getConnection();
$db->beginTransaction();

$info=$c->info;
$vpds=$c->vpd;
$h=$vpds[0];
//echo "Hello";
//$customer_code=$h->add_info->customer_name;
$bank=$h->add_info;

$temp_code=uniqid($dev->uid);

//query 1
$statement = $db->prepare("INSERT into mt_payment_header ( ph_company, ph_base_doc_type, ph_doc_type, ph_doc_date, ph_gl_date, ph_cash_bank_code, ph_currency, ph_exchange_rate, ph_foreign_amount, ph_local_amount, ph_other_reference, ph_cheque_number, ph_cheque_date, ph_narration, ph_notes, ph_status, ph_gl_account,
  ip,ua,ekey,created_by,created_date,temp_code,child,ph_cost_center,company_id,location_id) VALUES (:company,:voucher_type,:doc_type,:doc_date,:doc_date,
  :bank_name,:currency,:ex_rate,:base_amt_dr,:local_amt_dr,:ref,
  :cheque_no,:cheque_date,:narration,'','AWAITING CONFIRMATION',(SELECT account_no from mt_bank_list where bank_code=:bank_name limit 1),
:ip,:ua,:ekey,:created_by,now(),:temp_code,:child,:ph_cost_center,
:company_id,:location_id)");

if($h->ex_rate=="")
{
  $h->ex_rate=null;
}
if($info->doc_type=='PETTY CASH')
{
$bank->bank_name=$bank->petty_cash;
$bank->cheque_no=null;
$bank->cheque_date=null;

}else{
if($bank->cheque_date=="" or $bank->cheque_date=='NaN-NaN-NaN')
{
  $bank->cheque_date=null;
}
}


$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company'=>$dev->company,
':voucher_type'=>$h->voucher_type,
':doc_type'=>$info->doc_type,
':doc_date'=>$info->doc_date,

':bank_name'=>$bank->bank_name,
':cheque_no'=>$bank->cheque_no,
':cheque_date'=>$bank->cheque_date,

':ref'=>$h->ref,
':currency'=>$h->currency,
':ex_rate'=>$h->ex_rate,
':base_amt_dr'=>$h->base_amt_cr*(-1),
':local_amt_dr'=>$h->local_amt_cr*(-1),
':narration'=>$h->narration,

':temp_code'=>$temp_code,
':company_id'=>$dev->company,
':location_id'=>$dev->location,

':child'=>json_encode($vpds),
':ph_cost_center'=>$h->cost_center
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";

} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";

}
$data["temp_code"]=$temp_code;
$statement = $db->prepare("SELECT id from mt_payment_header where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

//set doc number

$fid=self::setFourDigit($op[0]["id"]);
$vtype="PV";
$prefix="";
if($info->doc_type=="PETTY CASH")
{
$prefix="PTC";
}else if($info->doc_type=="CHEQUE")
{
$prefix="PBC";
}else if($info->doc_type=="CARD")
{
$prefix="PCT";
}else if($info->doc_type=="ONLINE TRANSFER")
{
$prefix="POT";
}

$fid=self::generate_voucher_no1($db,$dev,$prefix,$temp_code);
$fid=self::setFourDigit($fid);
$fid1=$fid;

$on=$prefix.'/'.date("Y")."/".date('m')."/".$fid;

 $statement = $db->prepare("UPDATE mt_payment_header 
  SET ph_doc_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["pay_id_status"]=1;
  } else{
    $data["pay_id_status"]=0;
  }

$data["doc_no"]=$on;

$doc_no=$on;

//query 1 ends

//exclude header in child table
$child_ar_count=0;
$child_ar_status_count=0;
$child_pd_status_count=0;


//query 2
for($i=1;$i<count($vpds);$i++)
{

$r=$vpds[$i];
$temp_code=uniqid($dev->uid);
$q="";
$qv="";

$gls=self::get_gl_link($dev,'PAYABLE');

$gl_code='';
if(count($gls)>=1)
{
$gl_code=$gls[0]["gl_account"];
}

if($r->allocation=="ACCOUNTS PAYABLE")
{
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$gl_code','$ai->customer_name','$ai->customer_address'";
}

//ar gl
if($r->allocation=="ACCOUNTS RECEIVABLE")
{
  $child_ar_count+=1;
  $gls=self::get_gl_link($dev,'RECEIVABLE');
  
    $gl_code='';
    if(count($gls)>=1)
    {
    $gl_code=$gls[0]["gl_account"];
    }


  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$gl_code','$ai->customer_name','$ai->customer_address'";

  //addition query 1

/*QUERY 1*/

$statement = $db->prepare("INSERT into mt_ar_trans 
(art_company,art_code,art_type,art_number,art_serial,art_group,
art_base_type,art_internal,art_other_reference,art_doc_date,
art_gl_date,art_year,art_period,art_age_date,
art_dp_date,art_currency,art_ex_rate,art_foreign_amount,
art_local_amount,art_foreign_balance,
art_local_balance,art_balance_status,
art_description,art_notes,
ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id)
VALUES
(:company,:arh_code,:doc_type,:doc_no,'$i','RECEIVABLE',:voucher_type,'$i','',:doc_date,:doc_date,".self::getFinancialYear().",
".self::getFinancialPeriod($info->doc_date).",:doc_date,:doc_date,:currency,:ex_rate,:base_amt_cr,:local_amt_cr,:base_amt_cr,
:local_amt_cr,'A',:narration,:reference,:ip,:created_by,:ua,:ekey,
  now(),:temp_code,'$dev->company','$dev->location')");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code,

':company'=>$dev->company,
':arh_code'=>$ai->customer_name,
':voucher_type'=>$r->voucher_type,
':doc_type'=>$info->doc_type,
':doc_no'=>$doc_no,
':doc_date'=>$info->doc_date,

':base_amt_cr'=>$r->base_amt_dr,
':local_amt_cr'=>$r->local_amt_dr,
':narration'=>$r->narration,
':currency'=>$r->currency,
':ex_rate'=>$r->ex_rate,

':reference'=>$r->ref

));

 if ($statement->rowCount()){
  $child_ar_status_count+=1;
    $data["aq_status".($i+1)]=1;
  } else{
    $data["aq_status".($i+1)]=0;
  }

/*QUERY 2*/


//end of additional query

}

if($r->allocation=="BANK")
{
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->bank_name','$ai->cheque_no','$ai->cheque_date'";
}
/*
if($r->allocation=="INCOME")
{
  $ai=$r->add_info;
  $q="aloc_detail_1";
  $qv="'$ai->income'";
}
*/
if($r->allocation=="ASSETS")
{
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->assets','$ai->gl_group_name','$r->cost_center'";
}
if($r->allocation=="LIABILITY")
{
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->liability','$ai->gl_group_name','$r->cost_center'";
}

if($r->allocation=="BANK TO BANK")
{
  $ai=$r->add_info;
  $q="aloc_detail_1";
  $qv="'$ai->bank_name'";
}

if($r->allocation=="PETTY CASH")
{
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2";
  $qv="'$ai->petty_cash','$r->cost_center'";
}

if($r->allocation=="EXPENSES")
{
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->expense','$ai->gl_group_name','$r->cost_center'";
}
if($r->base_amt_cr=="")
{
  $r->base_amt_cr=null;
}
if($r->local_amt_cr=="")
{
  $r->local_amt_cr=null;
}

if($r->ex_rate=="")
{
  $r->ex_rate=null;
}



$eq="INSERT into mt_payment_allocation_details 
(aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,aloc_foreign_amount,aloc_local_amount,aloc_narration,
  aloc_notes,aloc_detail_5,aloc_account,aloc_currency,aloc_ex_rate,$q,
ip,created_by ,ua,ekey,created_date,temp_code,location_id,company_id)
VALUES
(:company,:voucher_type,:doc_type,:doc_no,:allocation,:base_amt_cr,
:local_amt_cr,:narration,'',:reference,'$gl_code',:currency,:ex_rate,$qv,:ip,:created_by,:ua,:ekey,now(),:temp_code,:location_id,:company_id)";
//echo $eq;
$statement = $db->prepare($eq);

$statement->execute(array(':ip'=>$dev->ip,
':created_by'=>$dev->username,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code,

':company'=>$dev->company,
':voucher_type'=>$r->voucher_type,
':doc_type'=>$info->doc_type,
':doc_no'=>$doc_no,

':allocation'=>$r->allocation,
':base_amt_cr'=>$r->base_amt_dr,
':local_amt_cr'=>$r->local_amt_dr,
':narration'=>$r->narration,
':currency'=>$r->currency,
':ex_rate'=>$r->ex_rate,

':reference'=>$r->ref,
':location_id'=>$dev->location,
':company_id'=>$dev->company
//':ref_date'=>$r->ref_date

));

//var_dump($statement->debugDumpParams());

if ($statement->rowCount()){
  $child_pd_status_count+=1;
  $data["ahd_status-".($i+1)]=1;
} else{
  $data["ahd_status-".($i+1)]=0;
}

}
//end of for loop
$child_status=$child_ar_count==$child_ar_status_count && $child_pd_status_count==(count($vpds)-1);
//$data["status"]=0;
if($data["status"]==1 && $data["pay_id_status"]==1 && $child_status)
{
  $db->commit();

}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}
$statement=null;
//query 2 ends
// CHEQUE SAVING ENDS
}
else
{  
$db = Factory::getConnection();
$db->beginTransaction();

$info=$c->info;
$vpds=$c->vpd;
$h=$vpds[0];
//echo "Hello";
//$customer_code=$h->add_info->customer_name;
$bank=$h->add_info;

$temp_code=uniqid($dev->uid);

//query 1
$statement = $db->prepare("INSERT into mt_payment_header ( ph_company, ph_base_doc_type, ph_doc_type, ph_doc_date, ph_gl_date, ph_cash_bank_code, ph_currency, ph_exchange_rate, ph_foreign_amount, ph_local_amount, ph_other_reference, ph_cheque_number, ph_cheque_date, ph_narration, ph_notes, ph_status, ph_gl_account,
  ip,ua,ekey,created_by,created_date,temp_code,child,ph_cost_center,company_id,location_id) VALUES (:company,:voucher_type,:doc_type,:doc_date,:doc_date,
  :bank_name,:currency,:ex_rate,:base_amt_dr,:local_amt_dr,:ref,
  :cheque_no,:cheque_date,:narration,'','POSTED',(SELECT account_no from mt_bank_list where bank_code=:bank_name limit 1),
:ip,:ua,:ekey,:created_by,now(),:temp_code,:child,:ph_cost_center,
:company_id,:location_id)");

if($h->ex_rate=="")
{
  $h->ex_rate=null;
}
if($info->doc_type=='PETTY CASH')
{
$bank->bank_name=$bank->petty_cash;
$bank->cheque_no=null;
$bank->cheque_date=null;

}else{
if($bank->cheque_date=="" or $bank->cheque_date=='NaN-NaN-NaN')
{
  $bank->cheque_date=null;
}
}


$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company'=>$dev->company,
':voucher_type'=>$h->voucher_type,
':doc_type'=>$info->doc_type,
':doc_date'=>$info->doc_date,

':bank_name'=>$bank->bank_name,
':cheque_no'=>$bank->cheque_no,
':cheque_date'=>$bank->cheque_date,

':ref'=>$h->ref,
':currency'=>$h->currency,
':ex_rate'=>$h->ex_rate,
':base_amt_dr'=>$h->base_amt_cr*(-1),
':local_amt_dr'=>$h->local_amt_cr*(-1),
':narration'=>$h->narration,

':temp_code'=>$temp_code,
':company_id'=>$dev->company,
':location_id'=>$dev->location,

':child'=>json_encode($vpds),
':ph_cost_center'=>$h->cost_center
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";

} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";

}
$data["temp_code"]=$temp_code;
$statement = $db->prepare("SELECT id from mt_payment_header where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

//set doc number

$fid=self::setFourDigit($op[0]["id"]);
$phid=$fid;
$vtype="PV";
$prefix="";
if($info->doc_type=="PETTY CASH")
{
$prefix="PTC";
}else if($info->doc_type=="CHEQUE")
{
$prefix="PBC";
}else if($info->doc_type=="CARD")
{
$prefix="PCT";
}else if($info->doc_type=="ONLINE TRANSFER")
{
$prefix="POT";
}else if($info->doc_type=="CASH")
{
$prefix="PCC";
}

$fid=self::generate_voucher_no1($db,$dev,$prefix,$temp_code);
$fid=self::setFourDigit($fid);
$fid1=$fid;

$on=$prefix.'/'.date("Y")."/".date('m')."/".$fid;

 $statement = $db->prepare("UPDATE mt_payment_header 
  SET ph_doc_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["pay_id_status"]=1;
  } else{
    $data["pay_id_status"]=0;
  }

$data["doc_no"]=$on;

$doc_no=$on;

//query 1 ends

//exclude header in child table
$child_ar_count=0;
$child_ap_count=0;

$child_ar_status_count=0;
$child_pd_status_count=0;
$child_cc_count=0;
$child_cc_status_count=0;
$child_bank_count=0;
//query 2
for($i=1;$i<count($vpds);$i++)
{

$r=$vpds[$i];
$temp_code=uniqid($dev->uid);
$q="";
$qv="";

$gls=self::get_gl_link($dev,'PAYABLE');
//$gl_code=$gls[0]["gl_account"];
    $gl_code='';
    if(count($gls)>=1)
    {
    $gl_code=$gls[0]["gl_account"];
    }

if($r->allocation=="ACCOUNTS PAYABLE")
{
  $child_ap_count+=1;
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$gl_code','$ai->customer_name','$ai->customer_address'";
}

//ar gl
if($r->allocation=="ACCOUNTS RECEIVABLE")
{
  $child_ar_count+=1;
  $gls=self::get_gl_link($dev,'RECEIVABLE');
  //$gl_code=$gls[0]["gl_account"];
    $gl_code='';
    if(count($gls)>=1)
    {
    $gl_code=$gls[0]["gl_account"];
    }

  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$gl_code','$ai->customer_name','$ai->customer_address'";

  //addition query 1

/*QUERY 1*/

$statement = $db->prepare("INSERT into mt_ar_trans 
(art_company,art_code,art_type,art_number,art_serial,art_group,
art_base_type,art_internal,art_other_reference,art_doc_date,
art_gl_date,art_year,art_period,art_age_date,
art_dp_date,art_currency,art_ex_rate,art_foreign_amount,
art_local_amount,art_foreign_balance,
art_local_balance,art_balance_status,
art_description,art_notes,
ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id)
VALUES
(:company,:arh_code,:doc_type,:doc_no,'$i','RECEIVABLE',:voucher_type,'$i','',:doc_date,:doc_date,".self::getFinancialYear().",
".self::getFinancialPeriod($info->doc_date).",:doc_date,:doc_date,:currency,:ex_rate,:base_amt_cr,:local_amt_cr,:base_amt_cr,
:local_amt_cr,'A',:narration,:reference,:ip,:created_by,:ua,:ekey,
  now(),:temp_code,'$dev->company','$dev->location')");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code,

':company'=>$dev->company,
':arh_code'=>$ai->customer_name,
':voucher_type'=>$r->voucher_type,
':doc_type'=>$info->doc_type,
':doc_no'=>$doc_no,
':doc_date'=>$info->doc_date,

':base_amt_cr'=>$r->base_amt_dr,
':local_amt_cr'=>$r->local_amt_dr,
':narration'=>$r->narration,
':currency'=>$r->currency,
':ex_rate'=>$r->ex_rate,

':reference'=>$r->ref

));

 if ($statement->rowCount()){
    $data["aq_status".($i+1)]=1;
    $child_ar_status_count+=1;
  } else{
    $data["aq_status".($i+1)]=0;
  }

/*QUERY 2*/


//end of additional query

}

if($r->allocation=="BANK")
{
  $child_bank_count+=1;
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->bank_name','$ai->cheque_no','$ai->cheque_date'";
}
/*
if($r->allocation=="INCOME")
{
  $ai=$r->add_info;
  $q="aloc_detail_1";
  $qv="'$ai->income'";
}
*/
if($r->allocation=="ASSETS")
{
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->assets','$ai->gl_group_name','$r->cost_center'";
}
if($r->allocation=="LIABILITY")
{
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->liability','$ai->gl_group_name','$r->cost_center'";
}

if($r->allocation=="BANK TO BANK")
{
  $child_bank_count+=1;
  $ai=$r->add_info;
  $q="aloc_detail_1";
  $qv="'$ai->bank_name'";
}

if($r->allocation=="PETTY CASH")
{
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2";
  $qv="'$ai->petty_cash','$r->cost_center'";
}

if($r->allocation=="EXPENSES")
{
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->expense','$ai->gl_group_name','$r->cost_center'";
}
if($r->base_amt_cr=="")
{
  $r->base_amt_cr=null;
}
if($r->local_amt_cr=="")
{
  $r->local_amt_cr=null;
}

if($r->ex_rate=="")
{
  $r->ex_rate=null;
}



$eq="INSERT into mt_payment_allocation_details 
(aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,aloc_foreign_amount,aloc_local_amount,aloc_narration,
  aloc_notes,aloc_detail_5,aloc_account,aloc_currency,aloc_ex_rate,$q,
ip,created_by ,ua,ekey,created_date,temp_code,location_id,company_id)
VALUES
(:company,:voucher_type,:doc_type,:doc_no,:allocation,:base_amt_cr,
:local_amt_cr,:narration,'',:reference,'$gl_code',:currency,:ex_rate,$qv,:ip,:created_by,:ua,:ekey,now(),:temp_code,:location_id,:company_id)";
//echo $eq;
$statement = $db->prepare($eq);

$statement->execute(array(':ip'=>$dev->ip,
':created_by'=>$dev->username,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code,

':company'=>$dev->company,
':voucher_type'=>$r->voucher_type,
':doc_type'=>$info->doc_type,
':doc_no'=>$doc_no,

':allocation'=>$r->allocation,
':base_amt_cr'=>$r->base_amt_dr,
':local_amt_cr'=>$r->local_amt_dr,
':narration'=>$r->narration,
':currency'=>$r->currency,
':ex_rate'=>$r->ex_rate,

':reference'=>$r->ref,
':location_id'=>$dev->location,
':company_id'=>$dev->company
//':ref_date'=>$r->ref_date

));

//var_dump($statement->debugDumpParams());

if ($statement->rowCount()){
  $data["ahd_status-".($i+1)]=1;
  $child_pd_status_count+=1;
} else{
  $data["ahd_status-".($i+1)]=0;
}


//query - cost center
if($r->cost_center!="")
{
  $child_cc_count+=1;
  $statement = $db->prepare("INSERT INTO mt_cost_center
  (cost_gl_code, cost_glt_company, cost_glt_doc_base, cost_glt_doc_type, cost_glt_number, cost_glt_doc_date, cost_glt_gl_date, cost_glt_other_reference,  cost_glt_currency,  cost_glt_ex_rate,  
    cost_glt_foreign_amount, cost_glt_local_amount, cost_glt_narration,  cost_glt_aloc_type, 
  ip,  ua,  ekey,  created_by,  created_date)
  VALUES
  (:cost_gl_code, :company, :voucher_type, :doc_type, :doc_no, :doc_date, :gl_date,
    :ref, :currency, :ex_rate, 
    :base_amt_cr, :local_amt_cr,  :narration, :allocation,
    :ip, :ua, :ekey, :created_by, now()) ");

  $statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
  ':ua'=>$dev->ua,
  ':ekey'=>$dev->ekey,

  ':cost_gl_code'=>$r->cost_center,
  ':company'=>$dev->company,
  ':voucher_type'=>$r->voucher_type,
  ':doc_type'=>$info->doc_type,
  ':doc_no'=>$doc_no,
  ':doc_date'=>$info->doc_date,
  ':gl_date'=>$info->doc_date,

  ':ref'=>$r->ref,
  ':currency'=>$r->currency,
  ':ex_rate'=>$r->ex_rate,
  ':base_amt_cr'=>$r->base_amt_dr,
  ':local_amt_cr'=>$r->local_amt_dr,
  ':narration'=>$r->narration,
  ':allocation'=>$r->allocation

  ));

  if ($statement->rowCount()){
    $child_cc_status_count+=1;
    $data["cc_status"]=1;
  } else{
    $data["cc_status"]=0;
  }
}
//query - cost center ends

}
//query 2 ends


//query 3
$statement = $db->prepare("INSERT into mt_ap_trans 
(apt_company,apt_code,apt_type,apt_number,apt_serial,apt_group,
apt_base_type,apt_internal,apt_other_reference,apt_doc_date,
apt_gl_date,apt_year,apt_period,apt_age_date,
apt_dp_date,apt_currency,apt_ex_rate,apt_foreign_amount,
apt_local_amount,apt_foreign_balance,
apt_local_balance,apt_balance_status,
apt_description,apt_notes,
ip,created_by ,ua,ekey,created_date,temp_code,
company_id,location_id)
SELECT aloc_company,aloc_detail_2,aloc_doc_type,aloc_doc_number,
1,aloc_detail_1,aloc_base_doc,0,
aloc_detail_5,
'$info->doc_date','$info->doc_date',".self::getFinancialYear().",
".self::getFinancialPeriod($info->doc_date).",
'$info->doc_date','$info->doc_date',aloc_currency,aloc_ex_rate,
aloc_foreign_amount,aloc_local_amount,aloc_foreign_amount,
aloc_local_amount,'A',
aloc_narration,aloc_detail_3,
ip,created_by,ua ,ekey,now(),'$temp_code',
'$dev->company','$dev->location'   
FROM mt_payment_allocation_details where 
aloc_allocation_type='ACCOUNTS PAYABLE' and aloc_doc_number=:id");

$statement->execute(array(':id'=>$doc_no
));

if ($statement->rowCount()){
  $data["ap_trans_status"]=1;
} else{
  $data["ap_trans_status"]=0;
}
//query 3 ends


//query 4 part1 header

$pcode='';
if($info->doc_type=="PETTY CASH")
{
  $pcode=$bank->petty_cash;
}
else
{
  $gls=self::get_bank_gl_code($dev,$bank->bank_name);
  //$pcode=$gls[0]["account_no"];
  $pcode='';
  if(count($gls)>=1)
  {
    $pcode=$gls[0]["account_no"];
  }
}

$statement = $db->prepare("INSERT into mt_payment_gl_details
(pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,
  pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,
  pre_glt_ex_rate,pre_glt_foreign_amount,
  pre_glt_local_amount,pre_glt_narration,
ip,created_by ,ua,ekey,created_date,temp_code,pre_glt_detail_1, 
location_id,company_id)
SELECT ph_company,
'$pcode',
ph_base_doc_type,ph_doc_type,
ph_doc_number,ph_internal_number,ph_doc_date,
ph_gl_date,".self::getFinancialYear().",".
self::getFinancialPeriod($info->doc_date).",ph_other_reference,ph_currency,
ph_exchange_rate,ph_foreign_amount,
ph_local_amount,ph_narration,
ip,created_by,ua ,ekey,now(),'$temp_code',ph_cost_center,
'$dev->company','$dev->location'   
FROM mt_payment_header where id=:id
");

$statement->execute(array(':id'=>$phid));

if ($statement->rowCount()){
  $data["ah_gl_status"]=1;
} else{
  $data["ah_gl_status"]=0;
}
//query 4 ends


//query 4 part2 child
$statement = $db->prepare("INSERT into mt_payment_gl_details
(pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,
  pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,
  pre_glt_ex_rate,pre_glt_foreign_amount,
  pre_glt_local_amount,pre_glt_narration,
  pre_glt_allocation_code,pre_glt_detail_1,
  pre_glt_detail_2,pre_glt_detail_3,
ip,created_by ,ua,ekey,created_date,temp_code, 
location_id,company_id)
SELECT aloc_company,aloc_detail_1,
aloc_base_doc,aloc_doc_type,
aloc_doc_number,aloc_serial,'$info->doc_date',
'$info->doc_date',".self::getFinancialYear().",".
self::getFinancialPeriod($info->doc_date).",aloc_narration,aloc_currency,
aloc_ex_rate,aloc_foreign_amount,
aloc_local_amount,aloc_narration,
aloc_allocation_type,aloc_detail_1,
aloc_detail_2,aloc_detail_3,
ip,created_by,ua ,ekey,now(),'$temp_code',
'$dev->company','$dev->location'   
FROM mt_payment_allocation_details where aloc_doc_number=:id
");

$statement->execute(array(':id'=>$doc_no));

if ($statement->rowCount()){
  $data["ah_gl_status2"]=1;
} else{
  $data["ah_gl_status2"]=0;
}
//query 4 part2 ends


//query 5
$statement = $db->prepare("INSERT into mt_ap_trans_balance
(apdm_company,apdm_code,apdm_doc_type,apdm_doc_number,
  apdm_serial,apdm_other_reference,apdm_date,apdm_currency,
  apdm_ex_rate,apdm_of_amount,apdm_ol_amount,apdm_bf_amount,
  apdm_bl_amount,apdm_pf_amount,apdm_pl_amount,apdm_status,
ip,created_by ,ua,ekey,created_date,temp_code,
company_id,location_id)
SELECT apt_company,apt_code,apt_type,apt_number,
apt_serial,apt_other_reference,apt_gl_date,apt_currency,
apt_ex_rate,apt_foreign_amount,apt_local_amount,
apt_foreign_balance,apt_local_balance,
0,0,'PENDING',ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location'  
 from mt_ap_trans where apt_number=:doc_no
");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["tb_status"]=1;
} else{
  $data["tb_status"]=0;
}
//query 5 ends


//addition query starts

//AD QUERY 1
$statement = $db->prepare("INSERT into mt_ar_trans_balance
(ardm_company,ardm_code,ardm_doc_type,ardm_doc_number,
  ardm_serial,ardm_other_reference,ardm_date,ardm_currency,
  ardm_ex_rate,ardm_of_amount,ardm_ol_amount,
  ardm_bf_amount,ardm_bl_amount,
  ardm_pf_amount,ardm_pl_amount,ardm_status,
ip,created_by,ua,ekey,created_date,temp_code,company_id,location_id)

SELECT art_company,art_code,art_type,art_number,
art_serial,art_other_reference,art_gl_date,art_currency,
art_ex_rate,art_foreign_amount,art_local_amount,
art_foreign_balance,art_local_balance,
0,0,'PENDING',
ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location' 
 from mt_ar_trans where art_number=:doc_no");
$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
    $data["ar_trans_status"]=1;
  } else{
    $data["ar_trans_status"]=0;
  }


//query 6
$statement = $db->prepare("INSERT into mt_cash_book_details 
( cb_company,cb_doc_type,cb_doc_number,cb_internal_number,cb_base_doc_type,cb_code,cb_type,cb_gl_date,cb_doc_date,cb_due_pay_date,cb_year,cb_period,cb_currency,cb_ex_rate,cb_foreign_amount,cb_local_amount,cb_cheque_number,cb_cheque_date,cb_account,cb_status,
  ip,created_by ,ua,ekey,
  created_date,temp_code,cb_flex_1) 
SELECT ph_company,ph_doc_type,ph_doc_number,ph_internal_number,
ph_base_doc_type,ph_cash_bank_code,ph_type,
ph_gl_date,ph_doc_date,ph_doc_date,".self::getFinancialYear().",".
self::getFinancialPeriod($info->doc_date).",ph_currency,ph_exchange_rate,
ph_foreign_amount,ph_local_amount,
ph_cheque_number,ph_cheque_date,ph_gl_account,'POSTED',
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$temp_code',ph_cost_center
 from mt_payment_header where ph_doc_number=:doc_no");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["cb_status"]=1;
} else{
  $data["cb_status"]=0;
}
//query 6 ends

//add in the cash book details for reporting
$doc_date=$info->doc_date;
$statement = $db->prepare("INSERT into mt_cash_book_details 
( cb_company,cb_doc_type,cb_doc_number,cb_internal_number,cb_base_doc_type,
  cb_code,cb_type,cb_gl_date,cb_doc_date,cb_due_pay_date,cb_year,cb_period,cb_currency,
  cb_ex_rate,cb_foreign_amount,cb_local_amount,cb_account,cb_cheque_number,cb_cheque_date,
  cb_status,
  ip,created_by ,ua,ekey,
  created_date,temp_code) 
SELECT aloc_company,aloc_doc_type,
aloc_doc_number,aloc_serial,aloc_base_doc,aloc_detail_1,aloc_allocation_type,
'$doc_date','$doc_date','$doc_date',".self::getFinancialYear().",".
self::getFinancialPeriod($doc_date).",aloc_currency,
aloc_ex_rate,aloc_foreign_amount,
aloc_local_amount,aloc_detail_1,
aloc_detail_2,aloc_detail_3,'POSTED',
ip,created_by,ua ,ekey,now(),'$temp_code'  
FROM mt_payment_allocation_details where aloc_doc_number=:doc_no and aloc_allocation_type in ('BANK','BANK TO BANK') ");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["cb_status2"]=1;
} else{
  $data["cb_status2"]=0;
}

$child_ar_tb_status=true;

if($child_ar_count!=0)
{
  if($data["ar_trans_status"]==0)
  {
  $child_ar_tb_status=false;
  }
}

$child_cb_status2=true;
$data["child_bank_count"]=$child_bank_count;

if($child_bank_count!=0)
{
  if($data["cb_status2"]==0)
  {
  $child_cb_status2=false;
  }
}

//child ap
if($child_ap_count==0)
{
  $data["ap_trans_status"]=1;
  $data["ap_trans_status_nodata"]="true";
  $data["tb_status"]=1;
}

$child_status=$child_ar_count==$child_ar_status_count &&  $child_cc_count==$child_cc_status_count && $child_pd_status_count==(count($vpds)-1) && $child_ar_tb_status && $child_cb_status2;

//$data["status"]=0;

if($data["status"]==1 && $data["pay_id_status"]==1 && $child_status &&$data["ap_trans_status"]==1 && $data["ah_gl_status"]==1 && $data["ah_gl_status2"]==1 && $data["tb_status"]==1 && $data["cb_status"]==1)
{
  $db->commit();
  
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}

$statement=null;
}
//FINANCE POSTING ENDS

  }
  catch (PDOException $e) {
    print $e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
  }
  
  return $data;
}

//voucher preparation payable
public static function save_voucher_preparation_payable($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$info=$c->info;
$vpds=$c->vpd;
$h=$vpds[0];

$customer_code=$h->add_info->customer_name;

$tds_todo=true;
$tds_todo=getTDSApplicable($dev->location,$dev->company);

//SET VALUES TO TDS/GST QUERY VARIABLES
$tds_percent=0;
$tds_desc=$h->narration;
$doc_no="";

//EXCLUDE GST for OFRT
$exclude_amt=0;
$with_ofrt_total_amt=0;

for($i=0;$i<count($vpds);$i++)
{
 $nrow=$vpds[$i];
 if($nrow->allocation=="SHIP")
 {
    $ai=$nrow->add_info;
    if($ai->activity!='OFRT')
    {
      $exclude_amt+=$nrow->local_amt_dr;
    }
    $with_ofrt_total_amt+=$nrow->local_amt_dr;
 }
}


$c->trx_date=$info->doc_date;
$c->doc_type=$info->doc_type;
$c->voucher_type=$h->voucher_type;
$c->tds=0;
$c->tds_appl_amt=$h->tds_amt;
$c->tds_appl_after_deduction=0;
$c->gst_percent=0;
$c->order_no="";
$c->ref_inv_no=$h->ref;
$c->ref_inv_date=$h->ref_date;
$c->trx_date=$info->doc_date;

$c->gst_percent=$h->gst;
$c->narration=$h->narration;
$c->collection_by="";
$c->file_id="";
$c->customer_name=$h->add_info->customer_name;

//PAYABLE VOUCHER under CREDIT entry
//PAYMENT under DEBIT entry

//CALCULATE tds_appl_after_deduction
if($c->tds_appl_amt!=0){
  //$c->tds_appl_after_deduction=($c->tds_appl_amt-$c->deduction);
  $c->tds_appl_after_deduction=$c->tds_appl_amt;
}else{
  $c->tds_appl_after_deduction=0;
}

//CALCULATE amount_after_deduction
//$c->amount_after_deduction=($c->amount-$c->deduction);
$c->amount_after_deduction=$exclude_amt;

//CALCULATE GST
$statement = $db->prepare("SELECT pan,gstin,tds_deductee_type from mt_business_partner 
  where code=:customer_code ");
$statement->execute(array(':customer_code'=>$customer_code));
$cdata=$statement->fetchAll(PDO::FETCH_ASSOC);
$billparty_gstin=$cdata[0]["gstin"];
$billparty_pan=$cdata[0]["pan"];
$tds_deductee_type=$cdata[0]["tds_deductee_type"];

$startString=getGSTINStartString($dev);

$len = strlen($startString);

if(substr($billparty_gstin, 0, $len)==$startString)
{
  $tp=$c->gst_percent/2;
  $tv=($c->amount_after_deduction*$tp)/100;
  $c->cgst=round($tv,2);
  $c->sgst=round($tv,2);
  $c->igst=0;
}else{
  $c->igst=round(($c->amount_after_deduction*$c->gst_percent)/100,2);
  $c->cgst=0;
  $c->sgst=0;  
}

//echo $exclude_amt;
// echo $c->igst;
// echo $c->cgst;
// echo $c->sgst;
// echo $c->amount_after_deduction;
// echo $c->gst_percent;
// echo $c->tds_appl_after_deduction;

//CALCULATE TDS
if($c->tds_appl_after_deduction!=0){

  //CHECK IF SPECIAL TDS EXISTS
  $statement = $db->prepare("SELECT lower_tax_tds 
  FROM mt_bp_tds_rate t1
  left join mt_business_partner t2
  on t1.bp_id=t2.id 
  where t2.code=:customer_code 
  and :ref_inv_date between t1.applicable_from and t1.applicable_to ");
  $statement->execute(array(':customer_code'=>$customer_code,':ref_inv_date'=>$c->ref_inv_date));
  $sp_tdsdata=$statement->fetchAll(PDO::FETCH_ASSOC);

  if ($statement->rowCount()){
      $tds_percent=$sp_tdsdata[0]["lower_tax_tds"];
  }
  //echo $tds_percent;

  $statement = $db->prepare("SELECT 
  case when :deductee_type='P' or :deductee_type='H' THEN
  t1.p_or_h
  ELSE
  t1.others
  end as 'tds_percent',t2.ac_description 
  FROM mt_tds_master t1
  left join mt_ledger_tds_link_master t2
  on t1.section=t2.section 
  where :ref_inv_date between t1.applicable_from and t1.applicable_to ");
  $statement->execute(array(':deductee_type'=>$tds_deductee_type,':ref_inv_date'=>$c->ref_inv_date));
  $tdsdata=$statement->fetchAll(PDO::FETCH_ASSOC);
  //ASSIGN IF SPECIAL RATE NOT EXISTS
  if($tds_percent==0 && count($tdsdata)>=1){
    $tds_percent=$tdsdata[0]["tds_percent"];
    $ac_description=$tdsdata[0]["ac_description"];
  }
  //echo $tds_percent;
  //$ac_description=$tdsdata[0]["ac_description"];

  //ROUND TDS DECIMAL ZERO
  $c->tds=round(($c->tds_appl_after_deduction*$tds_percent)/100,2);

}else{
  $c->tds=0;
}
//END TDS CALC

  $c->total=$with_ofrt_total_amt+$c->cgst+$c->sgst+$c->igst;
  

$temp_code=uniqid($dev->uid);
$statement = $db->prepare("SELECT limit_amount,credit_days from mt_bp_credit where account_type in('ACCOUNTS PAYABLE','BOTH') and bp_id=(SELECT id from mt_business_partner 
  where code=:customer_code)");
$statement->execute(array(':customer_code'=>$customer_code));
$cls=$statement->fetchAll(PDO::FETCH_ASSOC);

$due_date=date('Y-m-d');
$lc=0;
if(count($cls)==1)
{
$due_date= date('Y-m-d', strtotime("+".$cls[0]["credit_days"]." day", strtotime($info->doc_date)));
$lc=$cls[0]["limit_amount"];
}


$statement = $db->prepare("INSERT into mt_ap_header 
(aph_company,aph_code,aph_group,aph_document_base,aph_document_type,aph_limit_base,aph_document_date,aph_gl_date,aph_due_date,aph_other_reference,aph_currency,aph_exchange_rate,aph_foreign_amount,aph_local_amount,aph_narration,aph_post_date,aph_status,aph_notes,aph_loc_reference,
  ref_inv_no, ref_inv_date, collection_by,exl_upd_pk,
  ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id,child) 
VALUES
( :company,:customer_code,'ACCOUNTS PAYABLE',:voucher_type,:doc_type,
  :limit_amount,
  :doc_date,:doc_date,:due_date,:ref,'INR',1,:base_amt_dr,:local_amt_dr,:narration,:doc_date,'POSTED','',:ref_date,
    :ref_inv_no, :ref_inv_date, :collection_by,:exl_upd_pk,
  :ip ,:created_by ,:ua ,:ekey,now(),:temp_code,:company_id,:location_id,:child) ");


$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company'=>$dev->company,
':customer_code'=>$customer_code,
':voucher_type'=>$c->voucher_type,
':doc_type'=>$c->doc_type,

':limit_amount'=>$lc,
':doc_date'=>$c->trx_date,
':due_date'=>$due_date,
':ref'=>$c->order_no,
':ref_date'=>$c->trx_date,
':base_amt_dr'=>$c->total,
':local_amt_dr'=>$c->total,
':narration'=>$c->narration,

':ref_inv_no'=>$c->ref_inv_no,
':ref_inv_date'=>$c->ref_inv_date,
':collection_by'=>$c->collection_by,
':exl_upd_pk'=>$c->file_id,

':temp_code'=>$temp_code,
':company_id'=>$dev->company,
':location_id'=>$dev->location,

':child'=>json_encode($vpds)
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}
$data["temp_code"]=$temp_code;


$statement = $db->prepare("SELECT id from mt_ap_header where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

//set doc number

$fid=self::setFourDigit($op[0]["id"]);
$aphid=$fid;
$vtype="";

if($info->doc_type=="GENERAL INVOICE")
{
  $vtype="PGN";
}else if($info->doc_type=="DEBIT NOTE")
{
  $vtype="PDN";
}else if($info->doc_type=="CREDIT NOTE")
{
  $vtype="PCN";
}

$fid=self::generate_voucher_no1($db,$dev,$vtype,$temp_code);
$fid=self::setFourDigit($fid);
$fid1=$fid;

$on=$vtype."/".date("Y")."/".date('m')."/".$fid;

 $statement = $db->prepare("UPDATE mt_ap_header 
  SET aph_document_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["docid_status"]=1;
  } else{
    $data["docid_status"]=0;
  }

$data["doc_no"]=$on;

$doc_no=$on;

//exclude header in child table
//query 2
$child_ar_count=0;
$child_ar_status_count=0;
$child_ap_count=0;
$child_ap_status_count=0;
$child_ar_ship_count=0;
$child_ar_ship_status_count=0;
$child_ar_order_count=0;
$child_ar_order_status_count=0;
$child_ar_cc_count=0;
$child_ar_cc_status_count=0;

$child_apd_status_count=0;

for($i=1;$i<count($vpds);$i++)
{

$r=$vpds[$i];

//for credit note, child should be "credit" amount
if ($info->doc_type=="CREDIT NOTE")
{
  $r->base_amt_dr=$r->base_amt_cr*(-1);
  $r->local_amt_dr=$r->local_amt_cr*(-1);
}



$temp_code=uniqid($dev->uid);
$q="";
$qv="";
if($r->allocation=="ACCOUNTS PAYABLE")
{
  $child_ap_count+=1;
  $ai=$r->add_info; 
  $q="ap_customer,ap_activity,ap_cust_address";
  $qv="'$ai->customer_name','$ai->activity','$ai->customer_address'";

//addition query 1

/*QUERY 1*/
$statement = $db->prepare("INSERT into mt_ap_trans 
(apt_company,apt_code,apt_type,apt_number,apt_serial,apt_group,
apt_base_type,apt_internal,apt_other_reference,apt_doc_date,
apt_gl_date,apt_year,apt_period,apt_age_date,
apt_dp_date,apt_currency,apt_ex_rate,apt_foreign_amount,
apt_local_amount,apt_foreign_balance,
apt_local_balance,apt_balance_status,
apt_description,apt_notes,
ip,created_by ,ua,ekey,created_date,temp_code,
company_id,location_id)
VALUES
(:company,:arh_code,:doc_type,:doc_no,'$i','PAYABLE','PAYABLE VOUCHER',0,'',:doc_date,:doc_date,".self::getFinancialYear().",
".self::getFinancialPeriod($info->doc_date).",:doc_date,:doc_date,:currency,:ex_rate,:base_amt_dr,:local_amt_dr,:base_amt_dr,
:local_amt_dr,'A',:narration,:reference,:ip,:created_by,
:ua,:ekey,now(),:temp_code,'$dev->company','$dev->location')");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code,
//
':company'=>$dev->company,
':arh_code'=>$ai->customer_name,
':doc_type'=>$info->doc_type,
':doc_no'=>$doc_no,
':doc_date'=>$info->doc_date,

':base_amt_dr'=>$r->base_amt_dr,
':local_amt_dr'=>$r->local_amt_dr,
':narration'=>$r->narration,
':currency'=>$r->currency,
':ex_rate'=>$r->ex_rate,

':reference'=>$r->ref

));

 if ($statement->rowCount()){
    $child_ap_status_count+=1;
    $data["ap_ap_status".($i+1)]=1;
  } else{
    $data["ap_ap_status".($i+1)]=0;
  }
/* QUERY 1 ENDS */
}

if($r->allocation=="ACCOUNTS RECEIVABLE")
{
  $child_ar_count+=1;
  $ai=$r->add_info;
  $q="ap_customer,ap_activity,ap_cust_address";
  $qv="'$ai->customer_name','$ai->activity','$ai->customer_address'";

//addition query 1

/*QUERY 1*/

$statement = $db->prepare("INSERT into mt_ar_trans 
(art_company,art_code,art_type,art_number,art_serial,art_group,
art_base_type,art_internal,art_other_reference,art_doc_date,
art_gl_date,art_year,art_period,art_age_date,
art_dp_date,art_currency,art_ex_rate,art_foreign_amount,
art_local_amount,art_foreign_balance,
art_local_balance,art_balance_status,
art_description,art_notes,
ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id)
VALUES
(:company,:arh_code,:doc_type,:doc_no,'$i','RECEIVABLE',:voucher_type,'$i','',:doc_date,:doc_date,".self::getFinancialYear().",
".self::getFinancialPeriod($info->doc_date).",:doc_date,:doc_date,:currency,:ex_rate,:base_amt_cr,:local_amt_cr,:base_amt_cr,
:local_amt_cr,'A',:narration,:reference,:ip,:created_by,:ua,:ekey,
  now(),:temp_code,'$dev->company','$dev->location')");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code,

':company'=>$dev->company,
':arh_code'=>$ai->customer_name,
':voucher_type'=>$r->voucher_type,
':doc_type'=>$info->doc_type,
':doc_no'=>$doc_no,
':doc_date'=>$info->doc_date,

':base_amt_cr'=>$r->base_amt_dr,
':local_amt_cr'=>$r->local_amt_dr,
':narration'=>$r->narration,
':currency'=>$r->currency,
':ex_rate'=>$r->ex_rate,

':reference'=>$r->ref

));

 if ($statement->rowCount()){
    $child_ar_status_count+=1;
    $data["aq_status".($i+1)]=1;
  } else{
    $data["aq_status".($i+1)]=0;
  }

/*QUERY 2*/


//end of additional query
}

$fy=self::getFinancialYear();
$fp=self::getFinancialPeriod($info->doc_date);

if($r->allocation=="SHIP")
{
  $child_ar_ship_count+=1;
  $ai=$r->add_info;
  /*
  $q="voyage,vessel,liner,bl_no,ship_activity";
  $qv="'$ai->voyage','$ai->vessel','$ai->liner',
  '$ai->bl_no','$ai->activity'";
  */

    $q="aloc_detail_1,
    ref_inv_no,ref_inv_date,
    aloc_detail_2,aloc_detail_6,
    aloc_detail_7,aloc_detail_8,
    aloc_detail_4,aloc_detail_3,
    aloc_detail_5,
    expense_gl";

  $qv="(
  IFNULL((SELECT expense_gl from mt_charge_group_detail 
  where code='$ai->activity'),(SELECT gl_payable_pdc from mt_gl_link where name= (select liner from mt_voyage where voyage='$ai->voyage')))
  ),
  '$c->ref_inv_no','$c->ref_inv_date',
  '$customer_code','$ai->vessel',
  '$ai->voyage','$ai->liner',
  '$ai->bl_no','$ai->activity',(
  IFNULL((SELECT expense_gl from mt_charge_group_detail 
  where code='$ai->activity'),(SELECT gl_payable_pdc from mt_gl_link where name= (select liner from mt_voyage where voyage='$ai->voyage')))
  ), 
  (
  IFNULL((SELECT expense_gl from mt_charge_group_detail 
  where code='$ai->activity'),(SELECT gl_payable_pdc from mt_gl_link where name= (select liner from mt_voyage where voyage='$ai->voyage')))
  )";
/*
(select voyage from mt_manifest_entry where bl_no='$ai->bl_no')
*/
  
 //insert in the ship trans
$statement = $db->prepare("INSERT into mt_ship_trans
( st_company,st_doc_type,st_doc_number,st_serial,st_doc_base,st_date,st_gl_date,st_dp_date,st_age_date,st_year,st_period,st_carrier,st_vessel,st_voyage,st_port,st_bl,st_bl_type,st_charge,st_other_reference,st_currency,st_exchange,st_foreign,st_local,st_narration,st_status,
  st_posted_on,
  ip,created_by ,ua,ekey,created_date,temp_code) 
  VALUES
('$dev->company','$info->doc_type','$on','1','$info->voucher_type','$info->doc_date','$info->doc_date',
  '$info->doc_date','$info->doc_date','$fy','$fp','$ai->liner',
  '$ai->vessel','$ai->voyage','','$ai->bl_no',
  '','$ai->activity',(SELECT order_no from mt_manifest_entry where bl_no='$ai->bl_no' limit 1),'$h->currency',
  '$h->ex_rate','$r->base_amt_dr',
  '$r->local_amt_dr',:narration,
  'P',now(),
  '$dev->ip',
  '$dev->username','$dev->ua',
  '$dev->ekey',now(),'$temp_code')");

$statement->execute(array(':narration'=>$r->narration));
if ($statement->rowCount()){
  $child_ar_ship_status_count+=1;
  $data["ship_trans_status-".($i+1)]=1;
} else{
  $data["ship_trans_status-".($i+1)]=0;
}
  

}

if($r->allocation=="ORDER")
{
  $child_ar_order_count+=1;
  $ai=$r->add_info;

     $q="aloc_detail_1,aloc_detail_2,aloc_detail_3,expense_gl";

  $qv="'$ai->order_type','$ai->order_no','$ai->activity',(SELECT order_income_gl from mt_charge_group_detail 
  where code='$ai->activity')";

  
  //insert in the ship trans
$statement = $db->prepare("INSERT into mt_order_trans
( ordt_company,ordt_doc_type,ordt_doc_number,ordt_serial,ordt_doc_base,ordt_doc_date,ordt_gl_date,ordt_dp_date,ordt_age_date,ordt_year,ordt_period,ordt_carrier,ordt_vessel,ordt_voyage,ordt_port,ordt_bl,ordt_bl_type,ordt_charge,ordt_other_reference,ordt_currency,ordt_ex_rate,ordt_foreign_amount,ordt_local_amount,ordt_narration,ordt_status,
ordt_posted_on,
  ip,created_by ,ua,ekey,created_date,temp_code,ordt_code) 
VALUES
('$dev->company','$info->doc_type','$on','1','$info->voucher_type',
  '$info->doc_date',
 '$info->doc_date',
 '$info->doc_date','$info->doc_date','$fy','$fp','liner',
 'vessel','voyage','port','bl_no',
 '$ai->order_type','$ai->activity','$ai->order_no',
 '$r->currency','$r->ex_rate','$r->base_amt_dr',
  '$r->local_amt_dr',:narration,
  'P',now(),
  '$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code',(SELECT customer FROM mt_order_entry WHERE order_no='$ai->order_no' limit 1))");
$statement->execute(array(':narration'=>$r->narration));
  if ($statement->rowCount()){
  $child_ar_order_status_count+=1;
  $data["ord_trans_status-".($i+1)]=1;
} else{
  $data["ord_trans_status-".($i+1)]=0;
}

}

if($r->allocation=="ASSETS")
{
  $ai=$r->add_info;
  $q="expense_gl,aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->assets','$ai->assets', '$ai->gl_group_name', '$r->cost_center'";
}

if($r->allocation=="EXPENSES")
{
  $ai=$r->add_info;
  $q="expense_gl,aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->expense','$ai->expense', '$ai->gl_group_name', '$r->cost_center'";
}
if($r->base_amt_cr=="")
{
  $r->base_amt_cr=null;
}
if($r->local_amt_cr=="")
{
  $r->local_amt_cr=null;
}

if($r->ex_rate=="")
{
  $r->ex_rate=null;
}

$statement = $db->prepare("INSERT into mt_ap_allocation_details 
(aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,aloc_foreign_amount,aloc_local_amount,
  aloc_narration,aloc_currency,aloc_ex_rate,
  reference,ref_date,
  $q,
ip,created_by ,ua,ekey,created_date,temp_code)
VALUES
(:company,:voucher_type,:doc_type,:doc_no,:allocation,
  :base_amt_cr,:local_amt_cr,
  :narration,:currency,:ex_rate,
:reference,:ref_date,
$qv,
  :ip ,:created_by ,:ua ,:ekey,now(),:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code,

':company'=>$dev->company,
':voucher_type'=>$r->voucher_type,
':doc_type'=>$info->doc_type,
':doc_no'=>$doc_no,

':allocation'=>$r->allocation,
':base_amt_cr'=>$r->base_amt_dr*(-1),
':local_amt_cr'=>$r->local_amt_dr*(-1),
':narration'=>$r->narration,
':currency'=>$r->currency,
':ex_rate'=>$r->ex_rate,

':reference'=>$r->ref,
':ref_date'=>$r->ref_date

));

if ($statement->rowCount()){
  $child_apd_status_count+=1;
  $data["ahd_status-".($i+1)]=1;
} else{
  $data["ahd_status-".($i+1)]=0;
}

//query - cost center
if($r->cost_center!="")
{
  $child_ar_cc_count+=1;
  $statement = $db->prepare("INSERT INTO mt_cost_center
  (cost_gl_code, cost_glt_company, cost_glt_doc_base, cost_glt_doc_type, cost_glt_number,  cost_glt_doc_date, cost_glt_gl_date, cost_glt_other_reference,  cost_glt_currency,  cost_glt_ex_rate,  
    cost_glt_foreign_amount, cost_glt_local_amount, cost_glt_narration,  cost_glt_aloc_type, 
  ip,  ua,  ekey,  created_by,  created_date)
  VALUES
  (:cost_gl_code, :company, :voucher_type, :doc_type, :doc_no, :doc_date, :gl_date,
    :ref, :currency, :ex_rate, 
    :base_amt_cr, :local_amt_cr,  :narration, :allocation,
    :ip, :ua, :ekey, :created_by, now()) ");

  $statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
  ':ua'=>$dev->ua,
  ':ekey'=>$dev->ekey,

  ':cost_gl_code'=>$r->cost_center,
  ':company'=>$dev->company,
  ':voucher_type'=>$r->voucher_type,
  ':doc_type'=>$info->doc_type,
  ':doc_no'=>$doc_no,
  ':doc_date'=>$info->doc_date,
  ':gl_date'=>$info->doc_date,

  ':ref'=>$r->ref,
  ':currency'=>$r->currency,
  ':ex_rate'=>$r->ex_rate,
  ':base_amt_cr'=>$r->base_amt_dr,
  ':local_amt_cr'=>$r->local_amt_dr,
  ':narration'=>$r->narration,
  ':allocation'=>$r->allocation

  ));

  if ($statement->rowCount()){
    $child_ar_cc_status_count+=1;
    $data["cc_status"]=1;
  } else{
    $data["cc_status"]=0;
  }
}
//query - cost center ends

}
//query 2 ends

if ($c->doc_type=="DEBIT NOTE"){
  
  $c->cgst=$c->cgst*(-1);
  $c->sgst=$c->sgst*(-1);
  $c->igst=$c->igst*(-1);
  $c->tds=$c->tds*(-1);
}else if ($c->doc_type=="CREDIT NOTE"){
  
  $c->cgst=$c->cgst;
  $c->sgst=$c->sgst;
  $c->igst=$c->igst;
  $c->tds=$c->tds;
}

//cgst 2
//INPUT CGST 2-30-001-0001

if($c->cgst!=0){
  $statement = $db->prepare("INSERT into mt_ap_allocation_details 
  (aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,aloc_foreign_amount,aloc_local_amount,
    aloc_narration,aloc_currency,aloc_ex_rate,
    reference,ref_date,
    ref_inv_no, ref_inv_date,order_no,
    aloc_detail_1,aloc_detail_2,aloc_detail_3, 
    aloc_detail_5,amount_after_deduction,gst_percent,
    expense_gl,
  ip,created_by ,ua,ekey,created_date,temp_code)
  VALUES
  (:company,:voucher_type,'INPUT CGST',:doc_no,'INPUT CGST',
    :base_amt_cr,:local_amt_cr,
    :narration,'INR',1,
  :reference,:ref_date,
  :ref_inv_no, :ref_inv_date,:order_no,
  '2-30-001-0001','$c->customer_name','$c->order_no',
  '2-30-001-0001',:amount_after_deduction,:gst_percent,
  '2-30-001-0001',
    :ip ,:created_by ,:ua ,:ekey,now(),:temp_code) ");

  $statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
  ':ua'=>$dev->ua,
  ':ekey'=>$dev->ekey,
  ':temp_code'=>$temp_code,

  ':company'=>$dev->company,
  ':voucher_type'=>$c->voucher_type,
  ':doc_no'=>$doc_no,

  ':base_amt_cr'=>$c->cgst*(-1),
  ':local_amt_cr'=>$c->cgst*(-1),
  ':amount_after_deduction'=>$c->amount_after_deduction,
  ':narration'=>'INPUT CGST '.$c->gst_percent.'%',

  ':gst_percent'=>$c->gst_percent,

  ':order_no'=>$c->order_no,
  ':ref_inv_no'=>$c->ref_inv_no,
  ':ref_inv_date'=>$c->ref_inv_date,
  ':reference'=>$c->order_no,
  ':ref_date'=>$c->trx_date

  ));

  if ($statement->rowCount()){
    $data["cgst_status"]=1;
  } else{
    $data["cgst_status"]=0;
  }  
}
//cgst 2 ends

//sgst 2
//INPUT SGST 2-30-001-0005

if($c->sgst!=0){
  $statement = $db->prepare("INSERT into mt_ap_allocation_details 
  (aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,aloc_foreign_amount,aloc_local_amount,
    aloc_narration,aloc_currency,aloc_ex_rate,
    reference,ref_date,
    ref_inv_no, ref_inv_date,order_no,
    aloc_detail_1,aloc_detail_2,aloc_detail_3, 
    aloc_detail_5,amount_after_deduction,gst_percent,
    expense_gl,
  ip,created_by ,ua,ekey,created_date,temp_code)
  VALUES
  (:company,:voucher_type,'INPUT SGST',:doc_no,'INPUT SGST',
    :base_amt_cr,:local_amt_cr,
    :narration,'INR',1,
  :reference,:ref_date,
  :ref_inv_no, :ref_inv_date,:order_no,
  '2-30-001-0005','$c->customer_name','$c->order_no',
  '2-30-001-0005',:amount_after_deduction,:gst_percent,
  '2-30-001-0005',
    :ip ,:created_by ,:ua ,:ekey,now(),:temp_code) ");

  $statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
  ':ua'=>$dev->ua,
  ':ekey'=>$dev->ekey,
  ':temp_code'=>$temp_code,

  ':company'=>$dev->company,
  ':voucher_type'=>$c->voucher_type,
  ':doc_no'=>$doc_no,

  ':base_amt_cr'=>$c->sgst*(-1),
  ':local_amt_cr'=>$c->sgst*(-1),
  ':amount_after_deduction'=>$c->amount_after_deduction,
  ':narration'=>'INPUT SGST '.$c->gst_percent.'%',

  ':gst_percent'=>$c->gst_percent,

  ':order_no'=>$c->order_no,
  ':ref_inv_no'=>$c->ref_inv_no,
  ':ref_inv_date'=>$c->ref_inv_date,
  ':reference'=>$c->order_no,
  ':ref_date'=>$c->trx_date

  ));

  if ($statement->rowCount()){
    $data["sgst_status"]=1;
  } else{
    $data["sgst_status"]=0;
  }  
}
//sgst 2 ends

//igst 2
//INPUT IGST  2-30-001-0003

if($c->igst!=0){
  $statement = $db->prepare("INSERT into mt_ap_allocation_details 
  (aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,aloc_foreign_amount,aloc_local_amount,
    aloc_narration,aloc_currency,aloc_ex_rate,
    reference,ref_date,
    ref_inv_no, ref_inv_date,order_no,
    aloc_detail_1,aloc_detail_2,aloc_detail_3, 
    aloc_detail_5,amount_after_deduction,gst_percent,
    expense_gl,
  ip,created_by ,ua,ekey,created_date,temp_code)
  VALUES
  (:company,:voucher_type,'INPUT IGST',:doc_no,'INPUT IGST',
    :base_amt_cr,:local_amt_cr,
    :narration,'INR',1,
  :reference,:ref_date,
  :ref_inv_no, :ref_inv_date,:order_no,
  '2-30-001-0003','$c->customer_name','$c->order_no',
  '2-30-001-0003',:amount_after_deduction,:gst_percent,
  '2-30-001-0003',
    :ip ,:created_by ,:ua ,:ekey,now(),:temp_code) ");

  $statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
  ':ua'=>$dev->ua,
  ':ekey'=>$dev->ekey,
  ':temp_code'=>$temp_code,

  ':company'=>$dev->company,
  ':voucher_type'=>$c->voucher_type,
  ':doc_no'=>$doc_no,

  ':base_amt_cr'=>$c->igst*(-1),
  ':local_amt_cr'=>$c->igst*(-1),
  ':amount_after_deduction'=>$c->amount_after_deduction,
  ':narration'=>'INPUT IGST '.$c->gst_percent.'%',

  ':gst_percent'=>$c->gst_percent,

  ':order_no'=>$c->order_no,
  ':ref_inv_no'=>$c->ref_inv_no,
  ':ref_inv_date'=>$c->ref_inv_date,

  ':reference'=>$c->order_no,
  ':ref_date'=>$c->trx_date

  ));

  if ($statement->rowCount()){
    $data["igst_status"]=1;
  } else{
    $data["igst_status"]=0;
  }  
}
//igst 2 ends

if($tds_todo)
{
  //tdsquery 2
  //2-30-001-0031 - TDS On Contractor - 194C
  //2-30-001-0039 - TDS PAYABLE REVERSE - 194C

  $tds_lc="2-30-001-0031";
  $tds_desc="TDS PAYABLE";

  /*if ($c->doc_type=="DEBIT NOTE"){
    $tds_lc="2-30-001-0039";
    $tds_desc="TDS PAYABLE REVERSE";
  }*/

  if($c->tds!=0){
    $statement = $db->prepare("INSERT into mt_ap_allocation_details 
    (aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,aloc_foreign_amount,aloc_local_amount,
      aloc_narration,aloc_currency,aloc_ex_rate,
      reference,ref_date,
      ref_inv_no, ref_inv_date,order_no,
      aloc_detail_1,aloc_detail_2,aloc_detail_3, 
      aloc_detail_5,tds_appl_amt,tds_appl_after_deduction,gst_percent,
      expense_gl,
    ip,created_by ,ua,ekey,created_date,temp_code)
    VALUES
    (:company,:voucher_type,'$tds_desc',:doc_no,'$tds_desc',
      :base_amt_cr,:local_amt_cr,
      :narration,'INR',1,
    :reference,:ref_date,
    :ref_inv_no, :ref_inv_date,:order_no,
    '$tds_lc','$c->customer_name','$c->order_no',
    '$tds_lc',:tds_appl_amt,:tds_appl_after_deduction,:gst_percent,
    '$tds_lc',
      :ip ,:created_by ,:ua ,:ekey,now(),:temp_code) ");

    $statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
    ':ua'=>$dev->ua,
    ':ekey'=>$dev->ekey,
    ':temp_code'=>$temp_code,

    ':company'=>$dev->company,
    ':voucher_type'=>$c->voucher_type,
    ':doc_no'=>$doc_no,

    ':base_amt_cr'=>$c->tds,
    ':local_amt_cr'=>$c->tds,
    ':tds_appl_amt'=>$c->tds_appl_amt,
    ':tds_appl_after_deduction'=>$c->tds_appl_after_deduction,
    ':narration'=>$tds_desc,

    ':gst_percent'=>$c->gst_percent,

    ':order_no'=>$c->order_no,
    ':ref_inv_no'=>$c->ref_inv_no,
    ':ref_inv_date'=>$c->ref_inv_date,

    ':reference'=>$c->order_no,
    ':ref_date'=>$c->trx_date

    ));

    if ($statement->rowCount()){
      $data["tds_status"]=1;
    } else{
      $data["tds_status"]=0;
    }  
  }
}

//query 3
$statement = $db->prepare("INSERT into mt_ap_trans 
(apt_company,apt_code,apt_type,apt_number,apt_serial,apt_group,
apt_base_type,apt_internal,apt_other_reference,apt_doc_date,
apt_gl_date,apt_year,apt_period,apt_age_date,
apt_dp_date,apt_currency,apt_ex_rate,apt_foreign_amount,
apt_local_amount,apt_foreign_balance,
apt_local_balance,apt_balance_status,
apt_description,apt_notes,
ref_inv_no, ref_inv_date,order_no,
ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id)

SELECT aloc_company,aloc_detail_2,aloc_doc_type,aloc_doc_number,
1,aloc_detail_1,aloc_base_doc,0,
aloc_detail_5,'$c->trx_date',
'$c->trx_date',".self::getFinancialYear().",
".self::getFinancialPeriod($c->trx_date).",
'$c->trx_date','$c->trx_date',aloc_currency,aloc_ex_rate,
aloc_foreign_amount,aloc_local_amount,aloc_foreign_amount,
aloc_local_amount,'A',
aloc_narration,aloc_detail_3,
ref_inv_no, ref_inv_date,order_no,
ip,created_by,ua ,ekey,now(),'$temp_code',
'$dev->company','$dev->location'   
FROM mt_ap_allocation_details where aloc_doc_number=:id ");

$statement->execute(array(':id'=>$doc_no));

if ($statement->rowCount()){
  $data["ap_trans_status"]=1;
} else{
  $data["ap_trans_status"]=0;
}
//query 3 ends

//addition query starts

//AD QUERY 1
$statement = $db->prepare("INSERT into mt_ar_trans_balance
(ardm_company,ardm_code,ardm_doc_type,ardm_doc_number,
  ardm_serial,ardm_other_reference,ardm_date,ardm_currency,
  ardm_ex_rate,ardm_of_amount,ardm_ol_amount,
  ardm_bf_amount,ardm_bl_amount,
  ardm_pf_amount,ardm_pl_amount,ardm_status,
ref_inv_no, ref_inv_date,order_no,
ip,created_by,ua,ekey,created_date,temp_code,company_id,location_id)

SELECT art_company,art_code,art_type,art_number,
art_serial,art_other_reference,art_gl_date,art_currency,
art_ex_rate,art_foreign_amount,art_local_amount,
art_foreign_balance,art_local_balance,
0,0,'PENDING',
ref_inv_no, ref_inv_date,order_no,
ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location' 
 from mt_ar_trans where art_number=:doc_no");
$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
    $data["ar_tb_status"]=1;
  } else{
    $data["ar_tb_status"]=0;
  }


//query 4  

$statement = $db->prepare("INSERT into mt_ap_gl_details
(pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,
  pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,
  pre_glt_ex_rate,pre_glt_foreign_amount,
  pre_glt_local_amount,pre_glt_narration,
  pre_glt_allocation_code,pre_glt_detail_1,
  pre_glt_detail_2,pre_glt_detail_3,pre_glt_detail_4,pre_glt_detail_5,
ip,created_by ,ua,ekey,created_date,temp_code, 
location_id,company_id)
SELECT aloc_company,expense_gl,
aloc_base_doc,aloc_doc_type,
aloc_doc_number,aloc_serial,'$info->doc_date',
'$info->doc_date',".self::getFinancialYear().",".
self::getFinancialPeriod($info->doc_date).",aloc_narration,aloc_currency,
aloc_ex_rate,aloc_foreign_amount,
aloc_local_amount,aloc_narration,
aloc_allocation_type,aloc_detail_1,
aloc_detail_2,aloc_detail_3,aloc_detail_4,aloc_detail_5,
ip,created_by,ua ,ekey,now(),'$temp_code',
'$dev->company','$dev->location'   
FROM mt_ap_allocation_details where aloc_doc_number=:id
");

$statement->execute(array(':id'=>$doc_no));

if ($statement->rowCount()){
  $data["ah_gl_status2"]=1;
} else{
  $data["ah_gl_status2"]=0;
}
//query 4 


//query 5
$statement = $db->prepare("INSERT into mt_ap_trans_balance
(apdm_company,apdm_code,apdm_doc_type,apdm_doc_number,
  apdm_serial,apdm_other_reference,apdm_date,apdm_currency,
  apdm_ex_rate,apdm_of_amount,apdm_ol_amount,apdm_bf_amount,
  apdm_bl_amount,apdm_pf_amount,apdm_pl_amount,apdm_status,
ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id)
SELECT apt_company,apt_code,apt_type,apt_number,
apt_serial,apt_other_reference,apt_gl_date,apt_currency,
apt_ex_rate,apt_foreign_amount,apt_local_amount,
apt_foreign_balance,apt_local_balance,
0,0,'PENDING',ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location'  
 from mt_ap_trans where apt_number=:doc_no
");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["tb_status"]=1;
} else{
  $data["tb_status"]=0;
}
//query 5 ends

//query 6
$statement = $db->prepare("INSERT into mt_ap_balance
( apb_company,apb_code,apb_year,apb_period,apb_debit,apb_credit,
  ip,created_by ,ua,ekey,
  created_date,temp_code,company_id,location_id) 
SELECT '$dev->company','$customer_code',".self::getFinancialYear().",".
self::getFinancialPeriod($info->doc_date).",sum(apt_local_amount),sum(apt_local_amount),
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$temp_code','$dev->company','$dev->location' 
 from mt_ap_trans where apt_number=:doc_no");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["ab_balance_status"]=1;
} else{
  $data["ab_balance_status"]=0;
}
//query 6 ends

//check status of all
$child_status=$child_ar_count==$child_ar_status_count && $child_ap_count==$child_ap_status_count && $child_ar_ship_count==$child_ar_ship_status_count && $child_ar_order_count==$child_ar_order_status_count && $child_ar_cc_count==$child_ar_cc_status_count && (count($vpds)-1)==$child_apd_status_count;

$child_ar_tb_status=true;

if($child_ar_count!=0)
{
  if($data["ar_tb_status"]==0)
  {
  $child_ar_tb_status=false;
  }
}



//$data["status"]=0;

if($data["status"]==1 && $data["docid_status"]==1 && $data["ap_trans_status"]==1 && $child_status && $child_ar_tb_status && $data["ah_gl_status2"]==1 && $data["ab_balance_status"]==1 && $data["tb_status"]==1)
{
  $db->commit();
  
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
  }
  
  return $data;
}

//voucher preparation accounts receivable

public static function save_voucher_preparation_receivable($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$info=$c->info;
$vpds=$c->vpd;
$h=$vpds[0];

$customer_code=$h->add_info->customer_name;

$temp_code=uniqid($dev->uid);
$statement = $db->prepare("SELECT limit_amount,credit_days from mt_bp_credit where account_type in('ACCOUNTS RECEIVABLE','BOTH') and bp_id=(SELECT id from mt_business_partner 
  where code=:customer_code)");
$statement->execute(array(':customer_code'=>$customer_code));
$cls=$statement->fetchAll(PDO::FETCH_ASSOC);

$due_date=date('Y-m-d');
$lc=0;
if(count($cls)==1)
{
$due_date= date('Y-m-d', strtotime("+".$cls[0]["credit_days"]." day", strtotime($info->doc_date)));
$lc=$cls[0]["limit_amount"];
}

/*
$due_date= date('Y-m-d', strtotime("+".$cls[0]["credit_days"]." day", strtotime($info->doc_date)));
*/
//$due_date=$doc_date+$cls[0]["credit_days"];
//1
$statement = $db->prepare("INSERT into mt_ar_header 
(arh_company,arh_code,arh_group,arh_document_base,arh_document_type,arh_limit_base,arh_document_date,arh_gl_date,arh_due_date,arh_other_reference,arh_currency,arh_exchange_rate,arh_foreign_amount,arh_local_amount,arh_narration,arh_post_date,arh_status,arh_notes,arh_loc_reference,
  ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id,child) 
VALUES
( :company,:customer_code,:activity,:voucher_type,:doc_type,
  :limit_amount,
  :doc_date,:doc_date,:due_date,:ref,:currency,:ex_rate,:base_amt_dr,:local_amt_dr,:narration,:doc_date,'POSTED','',:ref_date,
  :ip ,:created_by ,:ua ,:ekey,now(),:temp_code,:company_id,:location_id,
:child)");

if($h->ex_rate=="")
{
  $h->ex_rate=null;
}
if($h->base_amt_dr=="")
{
  $h->base_amt_dr=null;
}
if($h->local_amt_dr=="")
{
  $h->local_amt_dr=null;
}

//for credit note, header should be "credit" amount
if ($info->doc_type=="CREDIT NOTE")
{
  $h->base_amt_dr=$h->base_amt_cr*(-1);
  $h->local_amt_dr=$h->local_amt_cr*(-1);
}


$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company'=>$dev->company,
':customer_code'=>$customer_code,
':activity'=>$h->add_info->activity,
':voucher_type'=>$h->voucher_type,
':doc_type'=>$info->doc_type,

':limit_amount'=>$lc,
':doc_date'=>$info->doc_date,
':due_date'=>$due_date,
':ref'=>$h->ref,
':ref_date'=>$h->ref_date,
':currency'=>$h->currency,
':ex_rate'=>$h->ex_rate,
':base_amt_dr'=>$h->base_amt_dr,
':local_amt_dr'=>$h->local_amt_dr,
':narration'=>$h->narration,

':temp_code'=>$temp_code,
':company_id'=>$dev->company,
':location_id'=>$dev->location,
':child'=>json_encode($vpds)
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}
$data["temp_code"]=$temp_code;

$statement = $db->prepare("SELECT id from mt_ar_header where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

//set doc number

$fid=self::setFourDigit($op[0]["id"]);
$arhid=$fid;
$vtype="";

if($info->doc_type=="GENERAL INVOICE")
{
  $vtype="RGN";
}else if($info->doc_type=="DEBIT NOTE")
{
  $vtype="RDN";
}else if($info->doc_type=="CREDIT NOTE")
{
  $vtype="RCN";
}

$fid=self::generate_voucher_no1($db,$dev,$vtype,$temp_code);
$fid=self::setFourDigit($fid);
//echo $fid;
$fid1=$fid;

$on=$vtype."/".date("Y")."/".date('m')."/".$fid;

 $statement = $db->prepare("UPDATE mt_ar_header 
  SET arh_document_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["docid_status"]=1;
  } else{
    $data["docid_status"]=0;
  }

$data["doc_no"]=$on;

$doc_no=$on;

//exclude header
//query 2
$child_ar_count=0;
$child_ar_status_count=0;
$child_ap_count=0;
$child_ap_status_count=0;
$child_ar_ship_count=0;
$child_ar_ship_status_count=0;
$child_ar_order_count=0;
$child_ar_order_status_count=0;
$child_ar_cc_count=0;
$child_ar_cc_status_count=0;

$child_ard_status_count=0;

for($i=1;$i<count($vpds);$i++)
{

$r=$vpds[$i];
//var_dump($r);

//for credit note, child should be "debit" amount
if ($info->doc_type=="CREDIT NOTE")
{
  //$r->base_amt_cr=$r->base_amt_dr*(-1);
  //$r->local_amt_cr=$r->local_amt_dr*(-1);
  $r->base_amt_cr=$r->base_amt_dr;
  $r->local_amt_cr=$r->local_amt_dr;
}

$temp_code=uniqid($dev->uid);
$q="";
$qv="";
if($r->allocation=="ACCOUNTS RECEIVABLE")
{
  $child_ar_count+=1;
  $ai=$r->add_info;
  //$q="ar_customer,ar_activity,ar_cust_address";
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->customer_name','$ai->activity','$ai->customer_address'";

//addition query 1

/*QUERY 1*/
$base_amt_cr=$r->base_amt_cr;
$local_amt_cr=$r->local_amt_cr;
if ($info->doc_type=="DEBIT NOTE" || $info->doc_type=='GENERAL INVOICE')
{
  //$r->base_amt_cr=$r->base_amt_dr*(-1);
  //$r->local_amt_cr=$r->local_amt_dr*(-1);
  $base_amt_cr=-$r->base_amt_cr;
  $local_amt_cr=-$r->local_amt_cr;
}

$statement = $db->prepare("INSERT into mt_ar_trans 
(art_company,art_code,art_type,art_number,art_serial,art_group,
art_base_type,art_internal,art_other_reference,art_doc_date,
art_gl_date,art_year,art_period,art_age_date,
art_dp_date,art_currency,art_ex_rate,art_foreign_amount,
art_local_amount,art_foreign_balance,
art_local_balance,art_balance_status,
art_description,art_notes,
ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id)
VALUES
(:company,:arh_code,:doc_type,:doc_no,'$i','RECEIVABLE',:voucher_type,'$i','',:doc_date,:doc_date,".self::getFinancialYear().",
".self::getFinancialPeriod($info->doc_date).",:doc_date,:doc_date,:currency,:ex_rate,:base_amt_cr,:local_amt_cr,:base_amt_cr,
:local_amt_cr,'A',:narration,:reference,:ip,:created_by,:ua,:ekey,
  now(),:temp_code,'$dev->company','$dev->location')");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code,

':company'=>$dev->company,
':arh_code'=>$ai->customer_name,
':voucher_type'=>$r->voucher_type,
':doc_type'=>$info->doc_type,
':doc_no'=>$doc_no,
':doc_date'=>$info->doc_date,

':base_amt_cr'=>$base_amt_cr,
':local_amt_cr'=>$local_amt_cr,
':narration'=>$r->narration,
':currency'=>$r->currency,
':ex_rate'=>$r->ex_rate,

':reference'=>$r->ref

));

 if ($statement->rowCount()){
    $data["aq_status".($i+1)]=1;
    $child_ar_status_count+=1;
  } else{
    $data["aq_status".($i+1)]=0;
  }

//end of additional query

}

if($r->allocation=="ACCOUNTS PAYABLE")
{
  $child_ap_count+=1;
  $ai=$r->add_info;
  //$q="ar_customer,ar_activity,ar_cust_address";
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->customer_name','$ai->activity','$ai->customer_address'";

//query 1 
$statement = $db->prepare("INSERT into mt_ap_trans 
(apt_company,apt_code,apt_type,apt_number,apt_serial,apt_group,
apt_base_type,apt_internal,apt_other_reference,apt_doc_date,
apt_gl_date,apt_year,apt_period,apt_age_date,
apt_dp_date,apt_currency,apt_ex_rate,apt_foreign_amount,
apt_local_amount,apt_foreign_balance,
apt_local_balance,apt_balance_status,
apt_description,apt_notes,
ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id)
VALUES
(:company,:arh_code,:doc_type,:doc_no,'0','PAYABLE','PAYABLE VOUCHER',0,:voucher_type,:doc_date,:doc_date,".self::getFinancialYear().",
".self::getFinancialPeriod($info->doc_date).",:doc_date,:doc_date,:currency,:ex_rate,
  :base_amt_dr,:local_amt_dr, :base_amt_dr,:local_amt_dr,'A',
  :narration,:reference,:ip,:created_by,:ua,:ekey,
  now(),:temp_code,'$dev->company','$dev->location')");

  $statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code,

':company'=>$dev->company,
':arh_code'=>$ai->customer_name,
':voucher_type'=>$r->voucher_type,
':doc_type'=>$info->doc_type,
':doc_no'=>$doc_no,
':doc_date'=>$info->doc_date,

':base_amt_dr'=>$r->base_amt_cr,
':local_amt_dr'=>$r->local_amt_cr,
':narration'=>$r->narration,
':currency'=>$r->currency,
':ex_rate'=>$r->ex_rate,

':reference'=>$r->ref

));

//var_dump($statement->debugDumpParams());

if ($statement->rowCount()){
  $child_ap_status_count+=1;
  $data["ar_ap_status-".($i+1)]=1;
} else{
  $data["ar_ap_status-".($i+1)]=0;
}

//query 2
 
}

if($r->allocation=="BANK")
{
  $ai=$r->add_info;
  $q="bank,cheque_no,cheque_date";
  $qv="'$ai->bank_name','$ai->cheque_no','$ai->cheque_date'";
}

$fy=self::getFinancialYear();
$fp=self::getFinancialPeriod($info->doc_date);

if($r->allocation=="SHIP")
{
  $child_ar_ship_count+=1;
  $ai=$r->add_info;
  //$q="voyage,vessel,liner,bl_no,ship_activity,income_gl";
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3,aloc_detail_4,aloc_detail_5,income_gl";

  $qv="'$ai->voyage','$ai->vessel','$ai->liner',
  '$ai->bl_no','$ai->activity',(
  IFNULL((SELECT income_gl from mt_charge_group_detail 
  where code='$ai->activity'),(SELECT gl_receivable_pdc from mt_gl_link where name= (select liner from mt_voyage where voyage=(select voyage from mt_manifest_entry where bl_no='$ai->bl_no'))))
  )";

  //insert in the ship trans
$statement = $db->prepare("INSERT into mt_ship_trans
( st_company,st_doc_type,st_doc_number,st_serial,st_doc_base,st_date,st_gl_date,st_dp_date,st_age_date,st_year,st_period,st_carrier,st_vessel,st_voyage,st_port,st_bl,st_bl_type,st_charge,st_other_reference,st_currency,st_exchange,st_foreign,st_local,st_narration,st_status,
  st_posted_on,
  ip,created_by ,ua,ekey,created_date,temp_code) 
  VALUES
('$dev->company','$info->doc_type','$on','1','$info->voucher_type','$info->doc_date','$info->doc_date',
  '$info->doc_date','$info->doc_date','$fy','$fp','$ai->liner',
  '$ai->vessel','$ai->voyage','','$ai->bl_no',
  '','$ai->activity',(SELECT order_no from mt_manifest_entry where bl_no='$ai->bl_no' limit 1),'$h->currency',
  '$h->ex_rate','-$r->base_amt_cr',
  '-$r->local_amt_cr','$r->narration',
  'P',now(),
  '$dev->ip',
  '$dev->username','$dev->ua',
  '$dev->ekey',now(),'$temp_code')");

$statement->execute();
if ($statement->rowCount()){
  $child_ar_ship_status_count+=1;
  $data["ship_trans_status-".($i+1)]=1;
} else{
  $data["ship_trans_status-".($i+1)]=0;
}
  //ship trans ends
}

if($r->allocation=="ORDER")
{
  $child_ar_order_count+=1;
  $ai=$r->add_info;
  //$q="order_type,order_no,order_activity,income_gl";
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3,income_gl";

  $qv="'$ai->order_type','$ai->order_no','$ai->activity',(SELECT order_income_gl from mt_charge_group_detail 
  where code='$ai->activity')";

    //insert in the ship trans
$statement = $db->prepare("INSERT into mt_order_trans
( ordt_company,ordt_doc_type,ordt_doc_number,ordt_serial,ordt_doc_base,ordt_doc_date,ordt_gl_date,ordt_dp_date,ordt_age_date,ordt_year,ordt_period,ordt_carrier,ordt_vessel,ordt_voyage,ordt_port,ordt_bl,ordt_bl_type,ordt_charge,ordt_other_reference,ordt_currency,ordt_ex_rate,ordt_foreign_amount,ordt_local_amount,ordt_narration,ordt_status,
ordt_posted_on,
  ip,created_by ,ua,ekey,created_date,temp_code,ordt_code) 
VALUES
('$dev->company','$info->doc_type','$on','1','$info->voucher_type',
  '$info->doc_date',
 '$info->doc_date',
 '$info->doc_date','$info->doc_date','$fy','$fp','liner',
 'vessel','voyage','port','bl_no',
 '$ai->order_type','$ai->activity','$ai->order_no',
 '$r->currency','$r->ex_rate','-$r->base_amt_cr',
  '-$r->local_amt_cr','$r->narration',
  'P',now(),
  '$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code',(SELECT customer FROM mt_order_entry WHERE order_no='$ai->order_no' limit 1))");
$statement->execute();
if ($statement->rowCount()){
  $child_ar_order_status_count+=1;
  $data["ord_trans_status-".($i+1)]=1;
} else{
  $data["ord_trans_status-".($i+1)]=0;
}

}

if($r->allocation=="INCOME")
{
  $ai=$r->add_info;
  $q="income_gl,aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->income','$ai->income','$ai->gl_group_name', '$r->cost_center'";
}

//echo $q.'<br>'.$qv;
$temp_query="INSERT into mt_ar_allocation_details 
(aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,aloc_foreign_amount,aloc_local_amount,
  aloc_narration,aloc_currency,aloc_ex_rate,
  reference,ref_date,
  $q,
ip,created_by ,ua,ekey,created_date,temp_code)
VALUES
(:company,:voucher_type,:doc_type,:doc_no,:allocation,:base_amt_cr,
:local_amt_cr,:narration,:currency,:ex_rate,:reference,:ref_date,
$qv,:ip,:created_by,:ua,:ekey,now(),:temp_code)";

//echo $temp_query;
if($r->base_amt_cr=="")
{
  $r->base_amt_cr=null;
}
if($r->local_amt_cr=="")
{
  $r->local_amt_cr=null;
}

if($r->ex_rate=="")
{
  $r->ex_rate=null;
}

$statement = $db->prepare($temp_query);

$statement->execute(array(':ip'=>$dev->ip,
':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code,

':company'=>$dev->company,
':voucher_type'=>$r->voucher_type,
':doc_type'=>$info->doc_type,
':doc_no'=>$doc_no,

':allocation'=>$r->allocation,
':base_amt_cr'=>$r->base_amt_cr,
':local_amt_cr'=>$r->local_amt_cr,
':narration'=>$r->narration,
':currency'=>$r->currency,
':ex_rate'=>$r->ex_rate,

':reference'=>$r->ref,
':ref_date'=>$r->ref_date

));

//var_dump($statement->debugDumpParams());

if ($statement->rowCount()){
  $data["ahd_status-".($i+1)]=1;
  $child_ard_status_count+=1;
} else{
  $data["ahd_status-".($i+1)]=0;
}

//query - cost center
if($r->cost_center!="")
{
  $child_ar_cc_count+=1;
  $statement = $db->prepare("INSERT INTO mt_cost_center
  (cost_gl_code, cost_glt_company, cost_glt_doc_base, cost_glt_doc_type, cost_glt_number,  cost_glt_doc_date, cost_glt_gl_date, cost_glt_other_reference,  cost_glt_currency,  cost_glt_ex_rate,  
    cost_glt_foreign_amount, cost_glt_local_amount, cost_glt_narration,  cost_glt_aloc_type, 
  ip,  ua,  ekey,  created_by,  created_date)
  VALUES
  (:cost_gl_code, :company, :voucher_type, :doc_type, :doc_no,  :doc_date, :gl_date,
    :ref, :currency, :ex_rate, 
    :base_amt_cr, :local_amt_cr,  :narration, :allocation,
    :ip, :ua, :ekey, :created_by, now()) ");

  $statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
  ':ua'=>$dev->ua,
  ':ekey'=>$dev->ekey,

  ':cost_gl_code'=>$r->cost_center,
  ':company'=>$dev->company,
  ':voucher_type'=>$r->voucher_type,
  ':doc_type'=>$info->doc_type,
  ':doc_no'=>$doc_no,
  ':doc_date'=>$info->doc_date,
  ':gl_date'=>$info->doc_date,
  
  ':ref'=>$r->ref,
  ':currency'=>$r->currency,
  ':ex_rate'=>$r->ex_rate,
  ':base_amt_cr'=>$r->base_amt_cr,
  ':local_amt_cr'=>$r->local_amt_cr,
  ':narration'=>$r->narration,
  ':allocation'=>$r->allocation

  ));

  if ($statement->rowCount()){
    $child_ar_cc_status_count+=1;
    $data["cc_status"]=1;
  } else{
    $data["cc_status"]=0;
  }
}
//query - cost center ends

}
//query 2 ends


//query 3
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_ar_trans 
(art_company,art_code,art_type,art_number,art_serial,art_group,
art_base_type,art_internal,art_other_reference,art_doc_date,
art_gl_date,art_year,art_period,art_age_date,
art_dp_date,art_currency,art_ex_rate,art_foreign_amount,
art_local_amount,art_foreign_balance,
art_local_balance,art_balance_status,
art_description,art_notes,
ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id)
SELECT arh_company,arh_code,arh_document_type,arh_document_number,
arh_internal_number,arh_group,arh_document_base,arh_internal_number,
arh_other_reference,arh_document_date,arh_gl_date,".self::getFinancialYear().",
".self::getFinancialPeriod($info->doc_date).",
arh_gl_date,arh_due_date,arh_currency,arh_exchange_rate,
arh_foreign_amount,arh_local_amount,arh_foreign_amount,
arh_local_amount,'A',
arh_narration,arh_notes,
ip,created_by,ua ,ekey,now(),'$temp_code',
'$dev->company','$dev->location'   
FROM mt_ar_header where id=:id");

$statement->execute(array(':id'=>$arhid));

if ($statement->rowCount()){
  $data["ar_trans_status"]=1;
} else{
  $data["ar_trans_status"]=0;
}

//query 3 ends
//ar ap trans balance

$statement = $db->prepare("INSERT into mt_ap_trans_balance
(apdm_company,apdm_code,apdm_doc_type,apdm_doc_number,
  apdm_serial,apdm_other_reference,apdm_date,apdm_currency,
  apdm_ex_rate,apdm_of_amount,apdm_ol_amount,
  apdm_bf_amount,apdm_bl_amount,
  apdm_pf_amount,apdm_pl_amount,apdm_status,
ip,created_by,ua,ekey,created_date,temp_code,company_id,location_id)

SELECT apt_company,apt_code,apt_type,apt_number,
apt_serial,apt_other_reference,apt_gl_date,apt_currency,
apt_ex_rate,apt_foreign_amount,apt_local_amount,
apt_foreign_balance,apt_local_balance,
0,0,'PENDING',
ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location'  
 from mt_ap_trans where apt_number=:doc_no");

$statement->execute(array(':doc_no'=>$doc_no));

 if ($statement->rowCount()){
  $data["ar_ap_tb_status"]=1;
} else{
  $data["ar_ap_tb_status"]=0;
}

//query 4 part1 header
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_ar_gl_details
(pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,
  pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,
  pre_glt_ex_rate,pre_glt_foreign_amount,
  pre_glt_local_amount,pre_glt_narration,
ip,created_by ,ua,ekey,created_date,temp_code, 
location_id,company_id)
SELECT arh_company,
(select gl_account from mt_gl_link where name='RECEIVABLE' limit 1),
arh_document_base,arh_document_type,
arh_document_number,arh_internal_number,arh_document_date,
arh_gl_date,".self::getFinancialYear().",".
self::getFinancialPeriod($info->doc_date).",arh_other_reference,arh_currency,
arh_exchange_rate,arh_foreign_amount,
arh_local_amount,arh_narration,
ip,created_by,ua ,ekey,now(),'$temp_code',
'$dev->company','$dev->location'   
FROM mt_ar_header where id=:id
");

$statement->execute(array(':id'=>$arhid));

if ($statement->rowCount()){
  $data["ah_gl_status"]=1;
} else{
  $data["ah_gl_status"]=0;
}
//query 4 ends


//query 4 part2 child
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_ar_gl_details
(pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,
  pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,
  pre_glt_ex_rate,pre_glt_foreign_amount,
  pre_glt_local_amount,pre_glt_narration,
  pre_glt_allocation_code,pre_glt_detail_1,
  pre_glt_detail_2,pre_glt_detail_3,pre_glt_detail_4,pre_glt_detail_5,
ip,created_by ,ua,ekey,created_date,temp_code, 
location_id,company_id)
SELECT aloc_company,income_gl,
aloc_base_doc,aloc_doc_type,
aloc_doc_number,aloc_serial,'$info->doc_date',
'$info->doc_date',".self::getFinancialYear().",".
self::getFinancialPeriod($info->doc_date).",aloc_narration,aloc_currency,
aloc_ex_rate,-aloc_foreign_amount,
-aloc_local_amount,aloc_narration,
aloc_allocation_type,aloc_detail_1,
aloc_detail_2,aloc_detail_3,aloc_detail_4,aloc_detail_5,
ip,created_by,ua ,ekey,now(),'$temp_code',
'$dev->company','$dev->location'   
FROM mt_ar_allocation_details where aloc_doc_number=:id
");

$statement->execute(array(':id'=>$doc_no));

if ($statement->rowCount()){
  $data["ah_gl_status2"]=1;
} else{
  $data["ah_gl_status2"]=0;
}
//query 4 part2 ends


//query 5

$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_ar_trans_balance
(ardm_company,ardm_code,ardm_doc_type,ardm_doc_number,
  ardm_serial,ardm_other_reference,ardm_date,ardm_currency,
  ardm_ex_rate,ardm_of_amount,ardm_ol_amount,
  ardm_bf_amount,ardm_bl_amount,
  ardm_pf_amount,ardm_pl_amount,ardm_status,
ip,created_by,ua,ekey,created_date,temp_code,
company_id,location_id)

SELECT art_company,art_code,art_type,art_number,
art_serial,art_other_reference,art_gl_date,art_currency,
art_ex_rate,art_foreign_amount,art_local_amount,
art_foreign_balance,art_local_balance,
0,0,'PENDING',
ip,created_by,ua,ekey,now(),'$temp_code', 
'$dev->company','$dev->location'  
 from mt_ar_trans where art_number=:doc_no
");

$statement->execute(array(':doc_no'=>$doc_no));
//var_dump($statement->debugDumpParams());
if ($statement->rowCount()){
  $data["tb_status"]=1;
} else{
  $data["tb_status"]=0;
}

//query 5 ends

//query 6
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_ar_balance
( arb_company,arb_code,arb_year,arb_period,arb_debit,arb_credit,
  ip,created_by ,ua,ekey,created_date,temp_code,
  company_id,location_id) 
SELECT '$dev->company','$customer_code',".self::getFinancialYear().",".
self::getFinancialPeriod($info->doc_date).",sum(art_local_amount),sum(art_local_amount),
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$temp_code','$dev->company','$dev->location'  
from mt_ar_trans where art_number=:doc_no");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["ar_balance_status"]=1;
} else{
  $data["ar_balance_status"]=0;
}
//query 6 ends

//check status of all
$child_status=$child_ar_count==$child_ar_status_count && $child_ap_count==$child_ap_status_count && $child_ar_ship_count==$child_ar_ship_status_count && $child_ar_order_count==$child_ar_order_status_count && $child_ar_cc_count==$child_ar_cc_status_count && (count($vpds)-1)==$child_ard_status_count;

$child_ap_tb_status=true;

if($child_ap_count!=0)
{
  if($data["ar_ap_tb_status"]==0)
  {
  $child_ap_tb_status=false;
  }
}

/*
$child_ar_tb_status=true;

if($child_ar_count!=0)
{
  if($data["tb_status"]==0)
  {
  $child_ar_tb_status=false;
  }
}
*/

//$data["status"]=0;

if($data["status"]==1 && $data["docid_status"]==1 && $data["ar_trans_status"]==1 && $child_status && $child_ap_tb_status && $data["tb_status"]==1  && $data["ah_gl_status"]==1 && $data["ah_gl_status2"]==1 && $data["ar_balance_status"]==1)
{
  $db->commit();
  
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
  }
  
  return $data;
}


public static function save_rate($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_rates(
  code,description,hs_comm_code,status,ip,uid ,ua,ekey,created_date,temp_code) 
values(:code,:description,:hs_comm_code,:status,:ip ,:uid ,
:ua ,:ekey,now(),:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':code'=>$c->code,
':description'=>$c->description,
':hs_comm_code'=>$c->hs_comm_code,
':status'=>$c->status,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_commodity_master where uid=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,':uid'=>$dev->uid));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_gl_list($code)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
id,
account_type,
account_group,
account_sub_group,
account_serial,
code,
ac_description,
ac_maintype,
ac_nature,
type,
old_account,
language,
language_desc,
posting_allow,
secure_input,
secure_output,
budget_required,
parent_gl_code,
parent_gl_desc,
status,
'0' edit
   from mt_general_ledger order by id limit :sta,20");

$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 
$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


}

?>