<?php


require("../config/dbconn.php");
require('../booking/get-currency.php');
require("func-list.php");

class LinerAccountingDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

//GET LPO RAISED
public static function get_lpo_raised($order_no,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

//check sea freight there or not
//FRT-S
if (strpos($c, 'FRT-S')) {
//found frt-s
//check for cost and lpo raised
  $statement = $db->prepare("SELECT count(*) lc FROM mt_order_cost 
  WHERE order_id in (SELECT id from mt_order_entry where order_no 
  in ($order_no)) and type='COST' and inv_pay_no is not null 
  and charge_desc in ('FRT-S')");

$statement->execute();

$data["fcheck"]=$statement->fetchAll(PDO::FETCH_ASSOC);

if($data["fcheck"][0]["lc"]==0)
{
  $data["status"]=0;
  $data["message"]="Please raise LPO for Sea Freight first. Then try to invoice.";
}else{
  //check charges have cost and lpo raised

$statement = $db->prepare("SELECT count(*) lc FROM mt_order_cost 
  WHERE order_id in (SELECT id from mt_order_entry where order_no 
  in ($order_no)) and type='COST' and inv_pay_no is null 
  and charge_desc in ($c)");

$statement->execute();

$data["lc"]=$statement->fetchAll(PDO::FETCH_ASSOC);
  if($data["lc"][0]["lc"]>=1)
{
$data["status"]=0;
$data["message"]="Please raise LPO first. Then try to invoice.";

}else{
$data["status"]=1;  
}


}

}else{
  //check charges have cost and lpo raised
  $statement = $db->prepare("SELECT count(*) lc FROM mt_order_cost 
  WHERE order_id in (SELECT id from mt_order_entry where order_no 
  in ($order_no)) and type='COST' and inv_pay_no is null 
  and charge_desc in ($c)");

$statement->execute();

$data["lc2"]=$statement->fetchAll(PDO::FETCH_ASSOC);

 if($data["lc2"][0]["lc"]>=1)
{
$data["status"]=0;
$data["message"]="Please raise LPO first. Then try to invoice.";

}else{
$data["status"]=1;  
}

}

/*
if ($statement->rowCount()){
  $data["status"]=1;
   
} else{
  $data["status"]=0;
}
*/

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function getUniqueString($src)
{
$sv=explode(',',$src);
$uv=array_unique($sv);
return implode(',',$uv);
}

public static function save_invoice_printdesc($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_invoice_printdescriptions(
 invoice_no, description, qty, rate,  
ip,created_by ,ua,ekey,created_date,temp_code) 
values(
:invoice_no, :description, :qty, :rate,
:ip ,:created_by , :ua ,:ekey,now(),:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':description'=>$c->description,
':qty'=>$c->qty,
':rate'=>$c->rate,

':invoice_no'=>$c->invoice_no,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement = $db->prepare("SELECT id from mt_invoice_printdescriptions where created_by=:uid and temp_code=:temp_code and invoice_no=:invoice_no");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid,':invoice_no'=>$c->invoice_no));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



public static function update_order_reopen_status($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_order_entry SET 
 status='OPEN',
 re_open_date=:rdate,
 re_open_by=:rby,
 re_open_reason=:reason
 where id=:id
  ");

$statement->execute(array(
  ':id'=>$c->id,
  ':rdate'=>$c->re_open_date ,
':rby'=>$c->re_open_by,
':reason'=>$c->re_open_reason

));

if ($statement->rowCount()){
  $data["status"]=1;
   
} else{
  $data["status"]=0;
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_invoice_printdesc($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_invoice_printdescriptions SET 
 
  description=:description,
qty=:qty,
rate=:rate,
  ip=:ip,created_by=:created_by,ua=:ua,ekey=:ekey,created_date= now() where id=:id and invoice_no=:invoice_no
  ");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':description'=>$c->description,
':qty'=>$c->qty,
':rate'=>$c->rate,

':invoice_no'=>$c->invoice_no,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
   
} else{
  $data["status"]=0;
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function delete_invoice_printdesc($c)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("DELETE FROM mt_invoice_printdescriptions 
  where id=:id");

$statement->execute(array(':id'=>$c));

if ($statement->rowCount()){
  $data["status"]=1;
    
} else{
  $data["status"]=0;
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_voyage_summary_list($code) 
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
t1.id,
t1.voyage,
t1.bl_no,
t1.cargo_type,
(select party_name from mt_manifest_entry_party where party_type='CONSIGNEE' and mnf_entry_pk=t1.id) consignee, 
(select sum(cost_base_amount) from mt_manifest_entry_rate where type='INCOME' and mnf_entry_pk=t1.id) income,
(select sum(cost_base_amount) from mt_manifest_entry_rate where type='COST' and mnf_entry_pk=t1.id) cost,
t1.order_no,
(select status from mt_order_entry where order_no=t1.order_no limit 1) estatus,
t2.poo,
t2.pol,
t2.pod,
t2.pof,
(select party_name from mt_manifest_entry_party where party_type='NOTIFY PARTY' and mnf_entry_pk=t1.id) notify,
t1.manifest_type,
t1.bl_classification,
t1.shipment_terms,
t1.bl_date,
t1.to_order,
t1.master_bl_no,
t1.created_date,
t1.created_by,
t1.modified_by,
t1.modified_date 
  from mt_manifest_entry t1 LEFT JOIN mt_manifest_entry_route t2  ON (t1.manifest_type in('AGENCY IMPORT','SEA IMPORT')   and t1.id=t2.mnf_entry_pk ) 
  order by created_date desc limit :sta,100");
$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT);
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



public static function get_delivery_order_info($code)
{

$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
id,do_no,order_no,bl_no,poo,pol,pod,pof,shipper,consignee,notify,do_party,do_takenby,do_paidby,endorsement_party,do_date,do_validity_date,remarks,narration,
  temp_code,total,advance_do,auto_invoice from mt_delivery_order t1 where id=:id");
/*
,
  (SELECT inv_pay_no from mt_order_cost where order_id =(select id from mt_order_entry where order_no=t1.order_no) limit 1) inv
*/
$statement->execute(array(':id'=>$code));

$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT 
id,do_pk,payment_mode,bank_code,bank_name,credit_cheque_no,card_cheque_expiry_date,currency,foreign_amount,local_amount,cheque_clear_date,notes, '0' edit 
from mt_delivery_order_payment where do_pk=:do_pk");
$statement->execute(array(':do_pk'=>$code));
$data["pay"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_inv_no($code)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT inv_pay_no from mt_order_cost 
  where order_id =(select id from mt_order_entry 
  where order_no=:order_no) and charge_desc='DOF'");

$statement->execute(array(':order_no'=>$code));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_delivery_order_search_list($code)
{

$data=array();
try
{
$db = Factory::getConnection();

 $q="";
$ar=array();

if(strlen($code->bl_no)!=0)
{
$q=$q." and t1.bl_no=:bl_no ";
$ar[':bl_no']=$code->bl_no;

}

if(strlen($code->order_no)!=0)
{
$q=$q."  and t1.order_no=:order_no ";
$ar[':order_no']=$code->order_no;
}

if(strlen($code->voyage)!=0)
{
$q=$q."  and t1.voyage=:voyage ";
$ar[':voyage']=$code->voyage;

}
/*
if(strlen($code->customer)!=0)
{
$q=$q."  and t1.consignee=:consignee ";
$ar[':consignee']=$code->customer;

}
*/
$statement = $db->prepare("SELECT '' selected,
  t1.order_no,t1.bl_no,t2.poo,t2.pol,t2.pod,t2.pof,
(select party_name from mt_manifest_entry_party where party_type='SHIPPER' and mnf_entry_pk=t1.id) shipper,
(select party_name from mt_manifest_entry_party where party_type='CONSIGNEE' and mnf_entry_pk=t1.id) consignee, 
(select party_name from mt_manifest_entry_party where party_type='NOTIFY PARTY' and mnf_entry_pk=t1.id) notify,
t1.manifest_type,
t2.vessel,
t2.voyage,
t1.status,
t2.eline,
t2.port 
 from mt_manifest_entry t1, mt_manifest_entry_route t2 where t1.id=t2.mnf_entry_pk  and 1=(select 1 from mt_order_entry where order_no=t1.order_no and do_status='UNFREEZE') ".$q);

$statement->execute($ar);
$data["orders"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$advance_do="";
if($code->advance_do==true)
{
  $advance_do=" and charge_desc='DOF' ";
}

if(strlen($code->customer)!=0)
{
$cusq=explode("|",$code->customer)[0];
if(strlen($advance_do)>0)
{
$advance_do=" and billing_party='$cusq' ";
}else{
$advance_do=" billing_party='$cusq' ";

}

}


if(count($data["orders"])>=1)
{
$order_no=$data["orders"][0]["order_no"];
//echo $advance_do."----".$order_no;

$statement = $db->prepare("SELECT sum(selling_base_amount) local_amount from mt_order_cost where (invoiced=2 or invoiced is null) and type='INCOME' and order_id=(SELECT id from mt_order_entry where order_no=:order_no and do_status='UNFREEZE') $advance_do");
$statement->execute(array(':order_no'=>$order_no));
$data["order_cost"]=$statement->fetchAll(PDO::FETCH_ASSOC);
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_delivery_order_list($dev,$code)
{

$data=false;
try
{
$db = Factory::getConnection();
$aq=Factory::getRestrictionQuery($dev);
$statement = $db->prepare("SELECT t1.id,t1.do_no,t1.order_no,t1.bl_no, t1.poo,t1.pol,t1.pod,t1.pof,t1.do_date,t1.do_validity_date, (select sum(local_amount) from mt_delivery_order_payment where do_pk=t1.id) do_amount, shipper,consignee,notify,created_by, created_date from mt_delivery_order t1 where $aq order by id desc limit :sta,50");
  
$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 
$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_delivery_order_list($v)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT t1.id,t1.do_no,t1.order_no,t1.bl_no, t1.poo,t1.pol,t1.pod,t1.pof,t1.do_date,t1.do_validity_date, (select sum(local_amount) from mt_delivery_order_payment where do_pk=t1.id) do_amount, shipper,consignee,notify,created_by, created_date from mt_delivery_order t1 
  where t1.do_no like ? or order_no like ? or bl_no like ? or 
  pol like ? or 
  pod like ? or 
  consignee like ? order by id limit 50");

$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(4, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(5, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(6, "%$v%", PDO::PARAM_STR);


$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_order_list($v)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT t1.id,t1.order_no,t1.order_type,t1.customer,t1.status,t1.expected_date, t1.order_executive, t1.shipment_from, t1.shipment_to, t1.bl_no, t1.cargo_type, (select count(container_no) from  mt_order_container_detail where order_id=t1.id) units, t3.provider, t3.transport_reference, (select sum(selling_base_amount) from mt_order_cost where order_id=t1.id) tot_revenue,t1.created_by,t1.created_date,
t1.modified_date,t1.modified_by 
  from mt_order_entry t1 
  LEFT JOIN
  ( SELECT order_id, GROUP_CONCAT(provider) provider,
  GROUP_CONCAT(transport_reference) transport_reference FROM mt_order_route GROUP BY order_id) t3
  ON t1.id=t3.order_id
  WHERE to_invoice=1 and (order_no like ? or customer like ? or status like ? or order_type like ?) 
   order by t1.id desc limit 50");

$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(4, "%$v%", PDO::PARAM_STR);


$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_unbilled_invoice_list($code)
{ 

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT t1.id,t1.order_no,t1.order_type,t1.customer,t1.status,t1.expected_date, t1.order_executive, t1.shipment_from, t1.shipment_to, t1.bl_no, t1.cargo_type, (select count(container_no) from  mt_order_container_detail where order_id=t1.id) units, t3.provider, t3.transport_reference, (select sum(selling_base_amount) from mt_order_cost where order_id=t1.id) tot_revenue,t1.created_by,t1.created_date,
t1.modified_date,t1.modified_by   
  from mt_order_entry t1 LEFT JOIN
  ( SELECT order_id, GROUP_CONCAT(provider) provider,
  GROUP_CONCAT(transport_reference) transport_reference FROM mt_order_route GROUP BY order_id) t3
  ON t1.id=t3.order_id where t1.to_invoice=1 and t1.status !='CLOSED' 
  order by t1.id desc limit :sta,100");
$statement->bindValue(':sta',(int) $code->start, PDO::PARAM_INT); 
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_doc_type_list($code)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,code, description from mt_document_type order by id");

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_invoice_entry_info_forward($code)
{

$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,sub_ar_doc_type,sub_ar_doc_number,sub_ar_doc_base,sub_ar_gl_date,sub_ar_due_date,sub_ar_date,sub_ar_other_reference,sub_ar_currency,sub_ar_ex_rate,sub_place_off_supply,sub_place_off_supply_date,sub_ar_narration,sub_ar_notes,sub_ar_code,sub_ar_status, 
  sub_ar_other_reference_date,temp_code,total_local_amt,order_no,gst_percent from mt_order_ar_header where id=:id");

$statement->execute(array(':id'=>$code));

$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,
  sub_ard_currency currency,
  sub_ard_ex_rate ex_rate,
  sub_ard_foreign_amount,
  sub_ard_local_amount net_amt,
  sub_ard_narration remarks,sub_ard_notes,
  sub_ard_detail_1 order_no,
  sub_ard_detail_2 order_date,
  sub_ard_detail_3 order_type,
  sub_ard_detail_4 bl_no,
  sub_ard_detail_5 customer,sub_ard_detail_6,
  sub_ard_basis basis_uom,
  sub_ard_rate selling_amount,
  sub_ard_quantity qty,
  charge_desc,basis_type,taxable,total_tax_amt,total_amt,
  inv_status from mt_order_ar_details 
  where sub_ard_doc_number=(SELECT sub_ar_doc_number from mt_order_ar_header where id=:id 
  and sub_ard_detail_6 !='ADDITIONAL')");

$statement->execute(array(':id'=>$code));

$data["charge"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,
  sub_ard_currency currency,
  sub_ard_ex_rate ex_rate,
  sub_ard_foreign_amount,
  sub_ard_local_amount net_amt,
  sub_ard_narration remarks,sub_ard_notes,
  sub_ard_detail_1 order_no,
  sub_ard_detail_2 order_date,
  sub_ard_detail_3 order_type,
  sub_ard_detail_4 bl_no,
  sub_ard_detail_5 customer,sub_ard_detail_6,
  sub_ard_basis basis_uom,
  sub_ard_rate selling_amount,
  sub_ard_quantity qty,
  charge_desc,basis_type,taxable,total_tax_amt,total_amt,
  inv_status,'0' edit,id from mt_order_ar_details 
  where sub_ard_doc_number=(SELECT sub_ar_doc_number from mt_order_ar_header where id=:id 
  and sub_ard_detail_6 ='ADDITIONAL')");

$statement->execute(array(':id'=>$code));

$data["add_charge"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT 
id,invoice_no, description, qty, rate, '0' edit   
 from mt_invoice_printdescriptions 
where invoice_no=(SELECT sub_ar_doc_number from mt_order_ar_header where id=:id)");

$statement->execute(array(':id'=>$code));

$data["printdesc"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_invoice_entry_info($code)
{

$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,sub_ar_doc_type,sub_ar_doc_number,sub_ar_doc_base,sub_ar_gl_date,sub_ar_due_date,sub_ar_date,sub_ar_other_reference,sub_ar_currency,sub_ar_ex_rate,sub_place_off_supply,sub_place_off_supply_date,sub_ar_narration,sub_ar_notes,sub_ar_code,sub_ar_status, 
  sub_ar_other_reference_date,temp_code,total_local_amt,order_no,gst_percent from mt_ship_ar_header where id=:id");

$statement->execute(array(':id'=>$code));

$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,
  sub_ard_currency currency,
  sub_ard_ex_rate ex_rate,
  sub_ard_foreign_amount,
  sub_ard_local_amount net_amt,
  sub_ard_narration remarks,sub_ard_notes,
  sub_ard_detail_1 order_no,
  sub_ard_detail_2 order_date,
  sub_ard_detail_3 order_type,
  sub_ard_detail_4 bl_no,
  sub_ard_detail_5 customer,sub_ard_detail_6,
  sub_ard_basis basis_uom,
  sub_ard_rate selling_amount,
  sub_ard_quantity qty,
  charge_desc,basis_type,taxable,total_tax_amt,total_amt,
  inv_status from mt_ship_ar_details 
  where sub_ard_doc_number=(SELECT sub_ar_doc_number from mt_ship_ar_header where id=:id 
  and sub_ard_detail_6 !='ADDITIONAL')");

$statement->execute(array(':id'=>$code));

$data["charge"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,
  sub_ard_currency currency,
  sub_ard_ex_rate ex_rate,
  sub_ard_foreign_amount,
  sub_ard_local_amount net_amt,
  sub_ard_narration remarks,sub_ard_notes,
  sub_ard_detail_1 order_no,
  sub_ard_detail_2 order_date,
  sub_ard_detail_3 order_type,
  sub_ard_detail_4 bl_no,
  sub_ard_detail_5 customer,sub_ard_detail_6,
  sub_ard_basis basis_uom,
  sub_ard_rate selling_amount,
  sub_ard_quantity qty,
  charge_desc,basis_type,taxable,total_tax_amt,total_amt,
  inv_status,'0' edit,id from mt_ship_ar_details 
  where sub_ard_doc_number=(SELECT sub_ar_doc_number from mt_ship_ar_header where id=:id 
  and sub_ard_detail_6 ='ADDITIONAL')");

$statement->execute(array(':id'=>$code));

$data["add_charge"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT 
id,invoice_no, description, qty, rate, '0' edit   
 from mt_invoice_printdescriptions 
where invoice_no=(SELECT sub_ar_doc_number from mt_ship_ar_header where id=:id)");

$statement->execute(array(':id'=>$code));

$data["printdesc"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_invoice_entry_list($dev,$code)
{

$data=false;
try
{
$db = Factory::getConnection();
//$aq=Factory::getRestrictionQuery($dev);
$aq=Factory::getRestrictionQuery1($dev,"t1");

$statement = $db->prepare("SELECT * FROM (

  (SELECT 'red' bg, '' inv_type,id,''  doc_type,'TO BE BILLED' doc_no,(select name from mt_business_partner where code= customer) customer, customer customer_code, order_no, bl_no,
  expected_date doc_date, '' gl_date, order_type reference, '' currency, '' local_amount, status estatus,
  created_date,created_by,modified_date,modified_by 
  from mt_order_entry t1
  where $aq and id in (select order_id from mt_order_cost 
  where invoiced is null and type='INCOME') 
  and to_invoice=1 order by id desc limit :sta,50) 

  UNION 

  (SELECT 'green' bg,'agency' inv_type,t1.id,t1.sub_ar_doc_type doc_type, t1.sub_ar_doc_number doc_no, (select name from mt_business_partner where code= t1.sub_ar_code) customer, t1.sub_ar_code customer_code,
  ifnull(order_no,
  (SELECT GROUP_CONCAT(DISTINCT sub_ard_detail_1 SEPARATOR ', ') 
  from mt_ship_ar_details 
  where sub_ard_doc_number=t1.sub_ar_doc_number))  order_no,
   IFNULL(bl_no,(SELECT GROUP_CONCAT(DISTINCT sub_ard_detail_4 SEPARATOR ', ') 
  from mt_ship_ar_details 
  where sub_ard_doc_number=t1.sub_ar_doc_number))  bl_no,
  t1.sub_ar_date doc_date, t1.sub_ar_gl_date gl_date, t1.sub_ar_other_reference reference, t1.sub_ar_currency currency, t1.sub_ar_l_amount local_amount, t1.sub_ar_status estatus,
  t1.created_date,created_by,modified_date,modified_by from mt_ship_ar_header t1 where $aq 
  order by id desc limit :sta,50)

  UNION 
  
  (SELECT 'green' bg,'forward' inv_type,t1.id,t1.sub_ar_doc_type doc_type, t1.sub_ar_doc_number doc_no, t1.sub_ar_code customer, t1.sub_ar_code customer_code,
  (SELECT GROUP_CONCAT(DISTINCT sub_ard_detail_1 SEPARATOR ', ') 
  from mt_order_ar_details 
  where sub_ard_doc_number=t1.sub_ar_doc_number)  order_no,
    (SELECT GROUP_CONCAT(DISTINCT sub_ard_detail_4 SEPARATOR ', ') 
  from mt_order_ar_details 
  where sub_ard_doc_number=t1.sub_ar_doc_number)  bl_no,
  t1.sub_ar_date doc_date, t1.sub_ar_gl_date gl_date, t1.sub_ar_other_reference reference, t1.sub_ar_currency currency, t1.sub_ar_l_amount local_amount, t1.sub_ar_status estatus,t1.created_date,
  created_by,modified_date,modified_by from mt_order_ar_header t1 
  where $aq 
  order by id desc limit :sta,50)
  ) t1 order by created_date desc
  ");





$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 
$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_orders($code)
{

$data=array();
try
{
$db = Factory::getConnection();

$q="";
$ar=array();

if(strlen($code->btype)!=0)
{
$q=$q." and t1.order_type=:order_type ";
$ar[':order_type']=$code->btype;
}

if(strlen($code->from_date)!=0)
{
$q=$q." and t1.expected_date>=:expected_date1 ";
$ar[':expected_date1']=$code->from_date;
}

if(strlen($code->to_date)!=0)
{
$q=$q." and t1.expected_date<=:expected_date2 ";
$ar[':expected_date2']=$code->to_date;
}

if(strlen($code->bl_no)!=0)
{
$q=$q." and t1.bl_no=:bl_no ";
$ar[':bl_no']=$code->bl_no;
}

if(strlen($code->order_no)!=0)
{
$q=$q." and t1.order_no=:order_no ";
$ar[':order_no']=$code->order_no;
}
$cq="";
if(strlen($code->customer)!=0)
{
$cq=" and billing_party=:customer ";
$ar[":customer"]=$code->customer;

}

$statement = $db->prepare("SELECT '' selected,t1.id,t1.order_type,t1.order_no,t1.expected_date,
t1.customer,t1.bl_no,t1.shipment_from,t1.shipment_to,'' grp,'' parcel_detail,t1.status,
t4.liner,
t4.port,
t4.import_start_calc_date,
t4.voyage,
t4.vessel  
 from mt_order_entry t1 LEFT JOIN (SELECT t3.liner,
t3.port,
t3.import_start_calc_date,
t2.voyage,
t3.vessel,t2.bl_no from mt_manifest_entry t2 ,mt_voyage t3 where t2.voyage=t3.voyage) t4 ON t1.bl_no=t4.bl_no 
  WHERE to_invoice=1 and id in (SELECT distinct order_id from mt_order_cost where 
    type='INCOME' $cq) and 
  t1.status in ('OPEN','PART INVOICED','INVOICED') ".$q);
$statement->execute($ar);
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_orders_copy_old($code)
{

$data=array();
try
{
$db = Factory::getConnection();

$q="";
$ar=array();

if(strlen($code->btype)!=0)
{
$q=$q." and t1.order_type=:order_type ";
$ar[':order_type']=$code->btype;
}

if(strlen($code->from_date)!=0)
{
$q=$q." and t1.expected_date>=:expected_date ";
$ar[':expected_date']=$code->from_date;
}

if(strlen($code->to_date)!=0)
{
$q=$q." and t1.expected_date<=:expected_date ";
$ar[':expected_date']=$code->to_date;
}
$isSea=false;
if(strlen($code->order_no)!=0)
{
$q=$q." and t1.order_no=:order_no ";
$ar[':order_no']=$code->order_no;

$statement = $db->prepare("SELECT '' selected,t1.id,order_type,t1.order_no,expected_date,
customer,'' bl_no,shipment_from,shipment_to,'' grp,'' parcel_detail,t1.status,
'' liner,
'' port,
'' import_start_calc_date,
'' voyage,
'' vessel  
 from mt_order_entry t1 
  WHERE order_no=:order_no and order_type 
  in('SEA IMPORT','SEA EXPORT') and 1=(SELECT 1 from mt_order_cost where order_id=t1.id and billing_party=:customer and type='INCOME' limit 1) ");
$statement->execute(array(':order_no'=>$code->order_no,
  ':customer'=>$code->customer));
$ndatas=$statement->fetchAll(PDO::FETCH_ASSOC);
if(count($ndatas)==1)
{
$isSea=true;
}
}

/*
if(strlen($code->customer)!=0)
{
$q=$q." and t1.customer=:customer ";
$ar[':customer']=$code->customer;
} */

if(strlen($code->voyage)!=0)
{
$q=$q." and t2.voyage=:voyage ";
$ar[':voyage']=$code->voyage;

}

if(strlen($code->bl_no)!=0)
{
$q=$q." and t2.bl_no=:bl_no ";
$ar[':bl_no']=$code->bl_no;

}

if($isSea)
{


$data=$ndatas;

}else{

$ar[":customer"]=$code->customer;

$query="SELECT '' selected,t1.id,order_type,t1.order_no,expected_date,
customer,t2.bl_no,shipment_from,shipment_to,'' grp,'' parcel_detail,t1.status,
t3.liner,
t3.port,
t3.import_start_calc_date,
t2.voyage,
t3.vessel  
 from mt_order_entry t1, mt_manifest_entry t2 ,mt_voyage t3 
  where  1=(SELECT 1 from mt_order_cost where order_id=t1.id and billing_party=:customer and type='INCOME' limit 1) and t1.status in ('OPEN','PART INVOICED') and t1.order_no=t2.order_no and t2.voyage=t3.voyage ".$q;

//echo "---".$query;
$statement = $db->prepare($query);
$statement->execute($ar);
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
}

//another case : search orders by customers
if(count($data)==0)
{
  if(strlen($code->customer)!=0)
  {

  //getting sea data

    $q="";
$ar=array();

if(strlen($code->btype)!=0)
{
$q=$q." and t1.order_type=:order_type ";
$ar[':order_type']=$code->btype;
}

if(strlen($code->from_date)!=0)
{
$q=$q." and t1.expected_date>=:expected_date ";
$ar[':expected_date']=$code->from_date;
}

if(strlen($code->to_date)!=0)
{
$q=$q." and t1.expected_date<=:expected_date ";
$ar[':expected_date']=$code->to_date;
}

$ar[":customer"]=$code->customer;

$statement = $db->prepare("SELECT '' selected,t1.id,order_type,t1.order_no,expected_date,
customer,'' bl_no,shipment_from,shipment_to,'' grp,'' parcel_detail,t1.status,
'' liner,
'' port,
'' import_start_calc_date,
'' voyage,
'' vessel  
 from mt_order_entry t1 
  WHERE  id in (SELECT distinct order_id from mt_order_cost where 
   billing_party=:customer and type='INCOME') and 
  t1.status in ('OPEN','PART INVOICED') ".$q);
$statement->execute($ar);
$data["orders"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$data["part2"]="part2";

  //getting agency data
/*
  $query="SELECT '' selected,t1.id,order_type,t1.order_no,expected_date,
customer,t2.bl_no,shipment_from,shipment_to,'' grp,'' parcel_detail,t1.status,
t3.liner,
t3.port,
t3.import_start_calc_date,
t2.voyage,
t3.vessel  
 from mt_order_entry t1, mt_manifest_entry t2 ,mt_voyage t3 
  where  t1.id in (SELECT distinct order_id from mt_order_cost where 
  billing_party=:customer and type='INCOME' ) and 
  t1.status in ('OPEN','PART INVOICED') ".$q;

//echo "---".$query;
$statement = $db->prepare($query);
$statement->execute($ar);
$data2=$statement->fetchAll(PDO::FETCH_ASSOC);

$data=array_merge($data1,$data2); */
  }
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function save_det_calc_info($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();

//order starts
for($i=0;$i<count($code);$i++)
{

$c=$code[$i];

$statement = $db->prepare("SELECT container_no,type,last_det_calc_amt from mt_manifest_entry_container where mnf_entry_pk=(SELECT id from mt_manifest_entry where order_no=:order_no)");
  $statement->execute(array(":order_no"=>$c->order_no));
$containers=$statement->fetchAll(PDO::FETCH_ASSOC);

//container starts
for($i=0;$i<count($containers);$i++)
{
  $ind_con=$containers[$i];
  //$nr=$c[$i];
  $nr=$c;
  $nr->type=$ind_con["type"];
  $nr->manifest_type=$ind_con["order_type"];
  $nr->chargetype='DETENTION';
  $nr->container_no=$ind_con["container_no"];
  $nr->last_det_calc_amt=$ind_con["last_det_calc_amt"];

  $statement = $db->prepare("SELECT free_days FROM mt_freedays t1, mt_freedays_detail t2 
WHERE t2.freedays_pk=t1.id and voyage=:voyage and bl_no=:bl_no 
and ctype=:ctype and charge_type='DETENTION' and 
manifest_type=:manifest_type and liner=:liner and location=:loc");
  $statement->execute(array(
  ':voyage'=>$nr->voyage,
  ':bl_no'=>$nr->bl_no,
  ':ctype'=>$nr->type,
  ':manifest_type'=>$nr->manifest_type,
  ':liner'=>$nr->liner,
  ':loc'=>$nr->port
));
//var_dump($statement->debugDumpParams());
$fds=$statement->fetchAll(PDO::FETCH_ASSOC);
//var_dump($fds);
if(count($fds)!=0)
{
  $nr->diff_days=$nr->diff_days-$fds[0]["free_days"];
}

if($nr->diff_days>0)
{
  $statement = $db->prepare("SELECT slab_order,slab_from,slab_to,rate from mt_rates_detention_slabs where detention_id=( SELECT id FROM mt_rates_detention WHERE location=:loc and charge_type='DETENTION' and liner=:liner) and slab_from<=:diff_days and ctype=:ctype"); 


$statement->execute(array(':loc'=>$nr->port,
  ':diff_days'=>$nr->diff_days,
  ':liner'=>$nr->liner,
  ':ctype'=>$nr->type
));
$slab_data=$statement->fetchAll(PDO::FETCH_ASSOC);
//calculating det cost
$total_cost=0;
$last_slab_to=0;
//var_dump($slab_data);
$cv='';
$total_len=count($slab_data);
$total_days=0;
for($j=0;$j<$total_len;$j++)
{
$nslab=$slab_data[$j];
if($j+1==$total_len)
{
  $mul=($nr->diff_days-$total_days);
  $total_cost=$total_cost+($nslab["rate"]*$mul);
  //$total_days=$total_days+$mul;
}else{
  $mul=($nslab["slab_to"]-$nslab["slab_from"])+1;
  $total_cost=$total_cost+($nslab["rate"]*$mul);
  $total_days=$total_days+$mul;

}

}
if(!is_null($nr->last_det_calc_amt))
{
  $total_cost=abs($total_cost-$nr->last_det_calc_amt);
}
//save det cost to order cost

$temp_code=uniqid($dev->uid);

$order_id=0;
$statement = $db->prepare("SELECT id from mt_order_entry where order_no=:order_no");

$statement->execute(array(':order_no'=>$nr->order_no));

$temp=$statement->fetchAll(PDO::FETCH_ASSOC);

$order_id=$temp[0]["id"];

$base_currency=getBaseCurrency($dev);

$statement = $db->prepare("INSERT into mt_order_cost(
  qty,
order_id,
charge_desc,

basis_type,
ex_rate,
type,
rate_cost,
rate_selling,
cost_amount,
cost_base_amount,
pay_at_location,
mode_of_pay,
currency,


selling_amount,
selling_base_amount,
remarks,
created_by,
created_date,
ip,
ua,
ekey,
temp_code) 
values(
1,
:order_id,
:charge_desc,

:basis_type,
1,
'INCOME',
:selling_amount,
:selling_amount,
:selling_amount,
:selling_amount,
:pay_at_location,
'COLLECT',
'$base_currency',

:selling_amount,
:selling_base_amount,
:remarks,
:created_by,
now(),
:ip,
:ua,
:ekey,:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,
':created_by'=>$dev->uid,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':order_id'=>$order_id,
':charge_desc'=>$nr->chargetype,
':selling_amount'=>$total_cost,
':selling_base_amount'=>$total_cost,
':remarks'=>$nr->container_no,

':basis_type'=>$nr->type,
':pay_at_location'=>$nr->port,

':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("UPDATE mt_manifest_entry_container set last_det_calc_amt=:amt, last_det_calc_date=CURDATE() where id=:id");

$statement->execute(array(':id'=>$nr->id,':amt'=>$total_cost));



if ($statement->rowCount()){
  $data["ld_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["ld_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

}else{
  $data["status"]=20;
}

}
//container ends
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



public static function get_order_charges($c)
{

$data=false;
$code=$c->ids;
try
{
  $q="";
  $data=$code;
$len=count($data);
for($i=0;$i<$len;$i++)
{
  if($i+1==$len)
  {
    $q=$q." ".$data[$i];
  }else{
  $q=$q." ".$data[$i].",";
  }
  
}

$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,billing_party,order_id,charge_desc,
  basis_type, basis_uom, currency,qty,
rate_selling selling_amount,selling_amount famt,ex_rate,selling_base_amount net_amt,'' taxable,'' total_tax_amt,selling_base_amount total_amt,remarks,
invoiced,
CASE
    WHEN invoiced =1 THEN 'INVOICED' 
    WHEN invoiced =2 THEN 'PROFORMA' 
    ELSE ''
END inv_status,
(select vat_percent from mt_charge_group_detail where code=charge_desc) vat_percent 
 from mt_order_cost where billing_party=:bp and type='INCOME' and order_id in ($q) ");

$statement->execute(array(':bp'=>$c->customer));

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_invoice_entry_list($v)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT * FROM (

  (SELECT 'red' bg, '' inv_type,id,''  doc_type,'TO BE BILLED' doc_no,(select name from mt_business_partner where code=customer) customer, order_no, bl_no,
  expected_date doc_date, '' gl_date, order_type reference, '' currency, '' local_amount, status estatus,
  created_date,created_by,modified_date,modified_by 
  from mt_order_entry 
  where id in (select order_id from mt_order_cost 
  where invoiced is null and type='INCOME') 
  and to_invoice=1 and (bl_no like ? or  order_no like ? or order_type like ? ) order by id desc limit 20) 

  UNION 

  (SELECT 'green' bg,'agency' inv_type,t1.id,t1.sub_ar_doc_type doc_type, t1.sub_ar_doc_number doc_no,
  (select name from mt_business_partner where code= t1.sub_ar_code) customer,
  (SELECT GROUP_CONCAT(DISTINCT sub_ard_detail_1 SEPARATOR ', ') 
  from mt_ship_ar_details 
  where sub_ard_doc_number=t1.sub_ar_doc_number)  order_no,
    (SELECT GROUP_CONCAT(DISTINCT sub_ard_detail_4 SEPARATOR ', ') 
  from mt_ship_ar_details 
  where sub_ard_doc_number=t1.sub_ar_doc_number)  bl_no,
  t1.sub_ar_date doc_date, t1.sub_ar_gl_date gl_date, t1.sub_ar_other_reference reference, t1.sub_ar_currency currency, t1.sub_ar_l_amount local_amount, t1.sub_ar_status estatus,
  t1.created_date,created_by,modified_date,modified_by from mt_ship_ar_header t1 where (sub_ar_doc_type like ? or 
sub_ar_doc_number like ? or 
sub_ar_code like ? or 
order_no like ? or bl_no like ? )
  order by id desc limit 20)

  UNION 
  
  (SELECT 'green' bg,'forward' inv_type,t1.id,t1.sub_ar_doc_type doc_type, t1.sub_ar_doc_number doc_no, t1.sub_ar_code customer,
  (SELECT GROUP_CONCAT(DISTINCT sub_ard_detail_1 SEPARATOR ', ') 
  from mt_order_ar_details 
  where sub_ard_doc_number=t1.sub_ar_doc_number)  order_no,
    (SELECT GROUP_CONCAT(DISTINCT sub_ard_detail_4 SEPARATOR ', ') 
  from mt_order_ar_details 
  where sub_ard_doc_number=t1.sub_ar_doc_number)  bl_no,
  t1.sub_ar_date doc_date, t1.sub_ar_gl_date gl_date, t1.sub_ar_other_reference reference, t1.sub_ar_currency currency, t1.sub_ar_l_amount local_amount, t1.sub_ar_status estatus,t1.created_date,
  created_by,modified_date,modified_by from mt_order_ar_header t1
  where (sub_ar_doc_type like ? or 
sub_ar_doc_number like ? or 
sub_ar_code like ? or 
order_no like ? or bl_no like ? )
  order by id desc limit 20)
  ) t1 order by created_date desc

");

/*
SELECT t1.id,t1.sub_ar_doc_type doc_type, t1.sub_ar_doc_number doc_no, t1.sub_ar_code customer, t2.sub_ard_detail_1 order_no, t2.sub_ard_detail_4 bl_no, t1.sub_ar_date doc_date, t1.sub_ar_gl_date gl_date, t1.sub_ar_other_reference reference, t1.sub_ar_currency currency, t1.sub_ar_l_amount local_amount, t1.sub_ar_status estatus from mt_ship_ar_header t1, mt_ship_ar_details t2 
  where t1.sub_ar_doc_number=t2.sub_ard_doc_number and (sub_ar_doc_type like ? or 
sub_ar_doc_number like ? or 
sub_ar_code like ?)
 order by id limit 50
*/
 $j=0;
$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$v%", PDO::PARAM_STR);

$statement ->bindValue(4, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(5, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(6, "%$v%", PDO::PARAM_STR);

$statement ->bindValue(7, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(8, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(9, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(10, "%$v%", PDO::PARAM_STR);

$statement ->bindValue(11, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(12, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(13, "%$v%", PDO::PARAM_STR);


$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_delivery_order($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();

$c=$code->info;
$do=$code->do;

$can_proceed=1;
/*
//check atleast one dof there
$statement = $db->prepare("SELECT id,charge_desc,type,basis_type,
  basis_uom,qty,currency,ex_rate,rate_selling,selling_amount,selling_base_amount from mt_order_cost where type='INCOME' and charge_desc='DOF' and order_id=(SELECT id from mt_order_entry where order_no=:order_no)");
$statement->execute(array(':order_no'=>$c->order_no));
$dof_list=$statement->fetchAll(PDO::FETCH_ASSOC);
if(count($dof_list)==0)
{
$can_proceed=0;
$data["msg"]="No DOF data. Please add DOF in work order";
}
*/
//check auto invoice ticked 
//if yes please check do is used or not

if($code->auto_invoice==true)
{
 
$statement = $db->prepare("SELECT id,charge_desc,type,basis_type,
  basis_uom,qty,currency,ex_rate,rate_selling,selling_amount,selling_base_amount from mt_order_cost where invoiced is null and type='INCOME' and charge_desc='DOF' and order_id=(SELECT id from mt_order_entry where order_no=:order_no)");
$statement->execute(array(':order_no'=>$c->order_no));
$orders_info=$statement->fetchAll(PDO::FETCH_ASSOC);
$order_cost=0;
$c->total_local_amt=225;
if(count($orders_info)!=0)
{
$can_proceed=1;
}else{
$can_proceed=0;
$data["msg"]="DOF already used. Please check proforma/invoice";

}

}




if($can_proceed==0)
{
  $data["status"]=0;
}else{


//continue if do is not used
$advance_do="";
if($code->advance_do==true)
{
  $advance_do=" and charge_desc='DOF' ";
}

if($code->auto_invoice==true)
{
  //$data["inv"]=self::save_invoice_entry_fordo($dev,$code);
  $advance_do=" and charge_desc='DOF' ";
}
$temp_code=uniqid($dev->uid);

$fy=self::getFinancialYear();
$fp=self::getFinancialPeriod($do->do_date);

$statement = $db->prepare("INSERT into mt_delivery_order(order_no, bl_no, poo, pol, pod, pof, shipper, consignee, notify , do_party , do_takenby , do_paidby , endorsement_party , do_date , do_validity_date, remarks, narration,
  created_by,created_date,ip,ua,ekey,temp_code,company_id,location_id,
  total,advance_do,auto_invoice) 
values(:order_no, :bl_no, :poo, :pol, :pod, :pof, :shipper, :consignee, :notify , :do_party , :do_takenby , :do_paidby , :endorsement_party , :do_date , :do_validity_date, :remarks, :narration,
:created_by,now(),:ip,:ua,:ekey,
:temp_code,:company_id,:location_id,:total,:advance_do,:auto_invoice)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':order_no'=>$c->order_no,
':bl_no'=>$c->bl_no,
':poo'=>$c->poo,
':pol'=>$c->pol,
':pod'=>$c->pod,
':pof'=>$c->pof,
':shipper'=>$c->shipper,
':consignee'=>$c->consignee,
':notify'=>$c->notify ,
':do_party'=>$do->do_party ,
':do_takenby'=>$do->do_takenby ,
':do_paidby'=>$do->do_paidby ,
':endorsement_party'=>$do->endorsement_party ,
':do_date'=>$do->do_date ,
':do_validity_date'=>$do->do_validity_date,
':remarks'=>$do->remarks,
':narration'=>$do->narration,

':temp_code'=>$temp_code,

':company_id'=>$dev->company,
':location_id'=>$dev->location,
':total'=>$code->total,
':advance_do'=>$code->advance_do,
':auto_invoice'=>$code->auto_invoice
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
$data["temp_code"]=$temp_code;

$statement = $db->prepare("SELECT id from mt_delivery_order where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);


$data["id"]=$op;

$fid=self::setFourDigit($op[0]["id"]);

$do_no='DO/'.date('Y').'/'.date('m').'/'.$c->pod.'/'.$fid;


   $statement = $db->prepare("UPDATE mt_delivery_order 
  SET do_no=:do_no where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':do_no'=>$do_no));
  
    if ($statement->rowCount()){
    $data["doid_status"]=1;
    $data["do_no"]=$do_no;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["doid_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

$rd=$code->rd;
$hasCheque=0;
$cheque_total=0;
for($i=0;$i<count($rd);$i++)
{
  $r=$rd[$i];
  if($r->payment_mode=="CHEQUE")
  {
    $hasCheque=1;
    $cheque_total=$cheque_total+(float)$r->local_amount;
  }
//insert delivery order details
$statement = $db->prepare("INSERT INTO mt_delivery_order_payment(do_pk,payment_mode,bank_code,bank_name,credit_cheque_no,card_cheque_expiry_date,currency,foreign_amount,local_amount,cheque_clear_date,notes,ip,ua,created_by,ekey,created_date)
  VALUES(
:do_pk,:payment_mode,:bank_code,:bank_name,:credit_cheque_no,:card_cheque_expiry_date,:currency,:foreign_amount,:local_amount,:cheque_clear_date,:notes,:ip,:ua,:created_by,:ekey,now())");

if($r->card_cheque_expiry_date=="")
{
  $r->card_cheque_expiry_date=null;
}

if($r->cheque_clear_date=="")
{
  $r->cheque_clear_date=null;
}

  $statement->execute(array(
':ip'=>$dev->ip,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':created_by'=>$dev->username,

':do_pk'=>$op[0]["id"],
':payment_mode'=>$r->payment_mode,
':bank_code'=>$r->bank_code,
':bank_name'=>$r->bank_name,
':credit_cheque_no'=>$r->credit_cheque_no,
':card_cheque_expiry_date'=>$r->card_cheque_expiry_date,
':currency'=>$r->currency,
':foreign_amount'=>$r->foreign_amount,
':local_amount'=>$r->local_amount,
':cheque_clear_date'=>$r->cheque_clear_date,
':notes'=>$r->notes

  ));
  
    if ($statement->rowCount()){
    $data["dodetails_status".($i+1)]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["dodetails_status".($i+1)]=0;
      //echo 'Failure: 0 rows were affected.';
  }

$base_currency=getBaseCurrency($dev);
//for every bank or cash payment new header in ship gl details


$statement = $db->prepare("INSERT into ship_gl_details 
( pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  ip,created_by ,ua,ekey,created_date,temp_code,pre_glt_created,
  location_id,company_id)

  VALUES('$dev->company',(select account_no from mt_bank_list where bank_code=:bank_code limit 1),'RCT','DO','$do_no',1,
  '$do->do_date','$do->do_date','$fy','$fp','$c->bl_no',
  '$base_currency',1,:samt,:sbamt,'remarks',
  'RCT','$c->order_no','$do->do_date','$c->manifest_type','$c->bl_no',
  '$c->consignee','charge_desc','$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code',now(),
  :company_id,:location_id )");

$statement->execute(array(':samt'=>$r->foreign_amount,':sbamt'=>$r->local_amount,':bank_code'=>$r->bank_code,
  ':company_id'=>$dev->company,
  ':location_id'=>$dev->location));
    if ($statement->rowCount()){
    $data["gld_header_status".($i+1)]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["gld_header_status".($i+1)]=0;
      //echo 'Failure: 0 rows were affected.';
  }

//gl ends
}


//update manifest entry

   $statement = $db->prepare("UPDATE mt_manifest_entry 
  SET status='DO ISSUED' where bl_no=:bl_no");
  $statement->execute(array(':bl_no'=>$c->bl_no));
  
    if ($statement->rowCount()){
    $data["mnf_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["mnf_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }


//1
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_ship_receipt_header 
( sub_rct_company,sub_rct_doc_type,sub_rct_doc_number,sub_rct_base_doc_type,sub_rct_internal_number,sub_rct_doc_date,sub_rct_gl_date,sub_rct_local_total,sub_rct_cash_total,sub_rct_cheque_total,sub_rct_other_reference,sub_rct_narration,sub_rct_status,sub_rct_created_on,sub_rct_created_by,sub_rct_notes,
  ip,created_by ,ua,ekey,created_date,temp_code,
  company_id,location_id) VALUES
( :sub_rct_company,:sub_rct_doc_type,:sub_rct_doc_number,:sub_rct_base_doc_type,:sub_rct_internal_number,:sub_rct_doc_date,:sub_rct_gl_date,:sub_rct_local_total,:sub_rct_cash_total,:sub_rct_cheque_total,:sub_rct_other_reference,:sub_rct_narration,:sub_rct_status,now(),:sub_rct_created_by,:sub_rct_notes,
  :ip ,:created_by ,:ua ,:ekey,now(),:temp_code,
:company_id,:location_id)");
$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':sub_rct_company'=>$dev->company,
':sub_rct_doc_type'=>'DO',
':sub_rct_doc_number'=>$do_no,
':sub_rct_base_doc_type'=>'SHIP',

':sub_rct_internal_number'=>$op[0]["id"],
':sub_rct_doc_date'=>$do->do_date,
':sub_rct_gl_date'=>$do->do_date,
':sub_rct_local_total'=>$do->local_amount,
':sub_rct_cash_total'=>$do->local_amount,
':sub_rct_cheque_total'=>$cheque_total,
':sub_rct_other_reference'=>$c->bl_no,
':sub_rct_narration'=>$do->narration,
':sub_rct_status'=>'POSTED',


':sub_rct_created_by'=>$dev->username,
':sub_rct_notes'=>$do->remarks,


':temp_code'=>$temp_code,
':location_id'=>$dev->location,
':company_id'=>$dev->company
));

    if ($statement->rowCount()){
    $data["rh_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["rh_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

$statement = $db->prepare("SELECT id from mt_ship_receipt_header where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid));
$rh_op=$statement->fetchAll(PDO::FETCH_ASSOC);
$rh_id=$rh_op[0]["id"];

//2
$temp_code=uniqid($dev->uid);
$order_no=$c->order_no;
$statement = $db->prepare("INSERT into mt_ship_receipt_details 
( sub_rctd_company,sub_rctd_doc_type,sub_rctd_doc_number,sub_rctd_serial,sub_rctd_currency,sub_rctd_ex_rate,sub_rctd_foreign_amount,sub_rctd_local_amount,sub_rctd_narration,sub_rctd_detail_1,sub_rctd_detail_2,sub_rctd_detail_3,sub_rctd_detail_4,sub_rctd_detail_5,sub_rctd_detail_6,sub_rctd_detail_7,sub_rctd_detail_8,
  sub_rctd_detail_9,sub_rctd_detail_10,
  ip,created_by ,ua,ekey,created_date,temp_code,
  company_id,location_id
  )

  SELECT '$dev->company','DO','$do_no','$rh_id',currency,ex_rate,selling_amount,selling_base_amount,remarks,'$order_no','$do->do_date','$c->manifest_type','$c->bl_no','$c->consignee',charge_desc,'$c->vessel','$c->voyage',
  '$c->port','$c->eline'
  ,'$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code',
  '$dev->company','$dev->location' 
   from mt_order_cost 
  where (invoiced=2 or invoiced is null) and order_id=(SELECT id from mt_order_entry 
  where order_no=:order_no) and type='INCOME' $advance_do");

$statement->execute(array(':order_no'=>$order_no));

    if ($statement->rowCount()){
    $data["rhd_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["rhd_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }
//3

$temp_code=uniqid($dev->uid);
//$gds=self::get_gl_Link();
$statement = $db->prepare("INSERT into ship_gl_details 
( pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  ip,created_by ,ua,ekey,created_date,temp_code,
  location_id,company_id)


  SELECT '$dev->company',(
IFNULL((SELECT income_gl from mt_charge_group_detail 
  where code=charge_desc),(SELECT gl_receivable_pdc from mt_gl_link where name= (select liner from mt_voyage where voyage=(select voyage from mt_manifest_entry where bl_no='$c->bl_no' limit 1))))
  ),'RCT','DO','$do_no','$rh_id',
  '$do->do_date','$do->do_date','$fy','$fp','$c->bl_no',
  currency,ex_rate,-selling_amount,-selling_base_amount,remarks,
  'RCT','$order_no','$do->do_date','$c->manifest_type','$c->bl_no',
  '$c->consignee',charge_desc,'$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code',
  '$dev->company','$dev->location' from mt_order_cost 
  where (invoiced=2 or invoiced is null) and order_id=(SELECT id from mt_order_entry 
  where order_no=:order_no) and type='INCOME' $advance_do");

$statement->execute(array(':order_no'=>$order_no));
    if ($statement->rowCount()){
    $data["gld_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["gld_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

//gl header
//get sum values

$statement = $db->prepare("SELECT sum(selling_amount) samt,sum(selling_base_amount) sbamt from mt_order_cost 
  where (invoiced=2 or invoiced is null) and order_id=(SELECT id from mt_order_entry 
  where order_no=:order_no) and type='INCOME' $advance_do");
$statement->execute(array(':order_no'=>$order_no));

$svs=$statement->fetchAll(PDO::FETCH_ASSOC);
$sv=$svs[0];

//moved to receipt for loop
/*
$statement = $db->prepare("INSERT into ship_gl_details 
( pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  ip,created_by ,ua,ekey,created_date,temp_code,pre_glt_created)

  VALUES('$dev->company',(select account_no from mt_bank_list where bank_code=:bank_code),'RCT','DO','$do_no',1,
  '$do->do_date','$do->do_date',2019,1,'$c->bl_no',
  'QAR',1,:samt,:sbamt,'remarks',
  'RCT','$order_no','$do->do_date','$c->manifest_type','$c->bl_no',
  '$c->consignee','charge_desc','$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code',now())");

$statement->execute(array(':samt'=>$sv["samt"],':sbamt'=>$sv["sbamt"]));
    if ($statement->rowCount()){
    $data["gld_header_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["gld_header_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }
*/
//4
$temp_code=uniqid($dev->uid);
//$gds=self::get_gl_Link();
$statement = $db->prepare("INSERT into mt_ship_trans
( st_company,st_doc_type,st_doc_number,st_serial,st_doc_base,st_date,st_gl_date,st_dp_date,st_age_date,st_year,st_period,st_carrier,st_vessel,st_voyage,st_port,st_bl,st_bl_type,st_charge,st_other_reference,st_currency,st_exchange,st_foreign,st_local,st_narration,st_status,
  st_posted_on,
  ip,created_by ,ua,ekey,created_date,temp_code,st_detail_1) 

  SELECT '$dev->company','DO','$do_no','$rh_id','RCT','$do->do_date','$do->do_date',
  '$do->do_date','$do->do_date','$fy','$fp','$c->eline',
  '$c->vessel','$c->voyage','$c->port','$c->bl_no',
  '$c->manifest_type',charge_desc,'$c->order_no'
  ,currency,ex_rate,-selling_amount,
  -selling_base_amount,remarks,
  status,now(),
  '$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),
  '$temp_code',billing_party from mt_order_cost 
  where (invoiced=2 or invoiced is null) and order_id=(SELECT id from mt_order_entry 
  where order_no=:order_no) and type='INCOME' $advance_do");
$statement->execute(array(':order_no'=>$order_no));
    if ($statement->rowCount()){
    $data["sht_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["sht_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

//5
$rd=$code->rd;

//$gds=self::get_gl_Link();
for($i=0;$i<count($rd);$i++)
{

$r=$rd[$i];
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_ship_receipt_bank_details
( sub_rctm_company,sub_rctm_doc_type,sub_rctm_doc_number,sub_rctm_serial,sub_rctm_cash_bank_code,sub_rctm_currency,sub_rctm_exchange_rate,sub_rctm_foreign_amount,sub_rctm_local_amount,sub_rctm_type,sub_rctm_received,sub_rctm_paid,sub_rctm_cheque_number,sub_rctm_drawer_account,sub_rctm_branch,sub_rctm_cheque_date,sub_rctm_clearance_date,sub_rctm_notes,sub_rctm_drawer_name,sub_rctm_gl_date,sub_rctm_doc_date,sub_rctm_pay_date,
  ip,created_by ,ua,ekey,created_date,temp_code)
VALUES
( '$dev->company','DO',:do_no,:rh_id,:bank_code,:currency,:ex_rate,:foreign_amount,:local_amount,:payment_mode,:do_paidby,:do_paidby,:credit_cheque_no,:drawer_account,:branch,:card_cheque_expiry_date,:cheque_clear_date,:notes,
  :drawer_name,:do_date,:do_date,:do_date,
  :ip ,:created_by ,:ua ,:ekey,now(),:temp_code)
");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code,

  ':do_no'=>$do_no,
  ':rh_id'=>$rh_id,
  ':bank_code'=>$r->bank_code,
  ':currency'=>$r->currency,
  ':ex_rate'=>$r->ex_rate,
  ':foreign_amount'=>$r->foreign_amount,
  ':local_amount'=>$r->local_amount,
  ':payment_mode'=>$r->payment_mode,
  ':do_paidby'=>$do->do_paidby,
  ':credit_cheque_no'=>$r->credit_cheque_no,
  ':drawer_account'=>$r->drawer_account,
  ':branch'=>$r->branch,
  ':card_cheque_expiry_date'=>$r->card_cheque_expiry_date,
  ':cheque_clear_date'=>$r->cheque_clear_date,
  ':notes'=>$r->notes,
  ':drawer_name'=>$r->drawer_name,
  ':do_date'=>$do->do_date
));
    if ($statement->rowCount()){
    $data["srbtd_status".($i+1)]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["srbtd_status".($i+1)]=0;
      //echo 'Failure: 0 rows were affected.';
  }

  //6
  $temp_code=uniqid($dev->uid);

  $statement = $db->prepare("INSERT into mt_cash_book_details
( cb_company,cb_doc_type,cb_doc_number,cb_internal_number,cb_base_doc_type,cb_code,cb_type,cb_gl_date,cb_doc_date,cb_due_pay_date,cb_year,cb_period,cb_currency,cb_ex_rate,cb_foreign_amount,cb_local_amount,cb_cheque_number,cb_cheque_date,cb_clearance_date,cb_drawer,cb_branch,cb_account,cb_status,
ip,created_by ,ua,ekey,created_date,temp_code)
VALUES
( '$dev->company','DO',:do_no,:rh_id,'BANK',:bank_code,:payment_mode,:do_date,
  :do_date,:do_date,'$fy','$fp',:currency,:ex_rate,:foreign_amount,:local_amount,:credit_cheque_no,:card_cheque_expiry_date,:cheque_clear_date,:drawer_name,:branch,:drawer_account,'POSTED',
  :ip ,:created_by ,:ua ,:ekey,now(),:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code,

':do_no'=>$do_no,
':rh_id'=>$rh_id,
':bank_code'=>$r->bank_code,
':payment_mode'=>$r->payment_mode,
':do_date'=>$do->do_date,
':currency'=>$r->currency,
':ex_rate'=>$r->ex_rate,
':foreign_amount'=>$r->foreign_amount,
':local_amount'=>$r->local_amount,
':credit_cheque_no'=>$r->credit_cheque_no,
':card_cheque_expiry_date'=>$r->card_cheque_expiry_date,
':cheque_clear_date'=>$r->cheque_clear_date,
':drawer_name'=>$r->drawer_name,
':branch'=>$r->branch,
':drawer_account'=>$r->drawer_account


));
    if ($statement->rowCount()){
    $data["cbd_status".($i+1)]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["cbd_status".($i+1)]=0;
      //echo 'Failure: 0 rows were affected.';
  }
}


if($code->auto_invoice==true)
{
  $data["inv"]=self::save_invoice_entry_fordo($dev,$code);
  //$advance_do=" and charge_desc='DOF' ";
}

//update order cost details
$statement = $db->prepare("UPDATE mt_order_cost SET invoiced=1,
  inv_pay_no=:doc_no where (invoiced=2 or invoiced is null) and order_id=(SELECT id from mt_order_entry 
  where order_no=:order_no) and type='INCOME' $advance_do");

$statement->execute(array(':order_no'=>$order_no,
  ':doc_no'=>$do_no));
    if ($statement->rowCount()){
    $data["ord_cost_status"]=1;
  } else{
    $data["ord_cost_status"]=0;
  }


//update order
//need to change when only advane do - changes done
   $statement = $db->prepare("UPDATE mt_order_entry t1 
  SET status= CASE WHEN (SELECT count(*) FROM `mt_order_cost` WHERE invoiced is null and type='INCOME' and order_id=t1.id)=0 
  THEN 'CLOSED'
    ELSE 'PART INVOICED'
        END ,closed_by=:closed_by, closed_date=now() 
  where order_no=:order_no");
  $statement->execute(array(
    ':order_no'=>$order_no,
    ':closed_by'=>$dev->username
  ));
  
    if ($statement->rowCount()){
    $data["ord_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["ord_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_gl_Link($code)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT code,gl_link from mt_charge_group_detail where code=:code");

//$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 
$statement->execute(array(':code'=>$code));

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;

}
public static function setFourDigit($v)
{
  $len=strlen($v);

if($len==1)
{
  $v="000".$v;
}else if($len==2)
{
  $v="00".$v;
}else if($len==3)
{
  $v="0".$v;
}

return $v;
}


public static function getFinancialYear()
{
//$year = ( date('m') > 4) ? date('Y') + 1 : date('Y');
$year=date('Y');
return $year;
}

public static function getFinancialPeriod($doc_date)
{

//$year = ( date('m') > 4) ? date('Y') + 1 : date('Y');
//$period=4;
//return $period;
$data=false;
try
{
$db = Factory::getConnection();

//$aq=self::getRestrictionQuery($dev);
//$doc_date="2019-12-15";
$date=date_create($doc_date);
$m= date_format($date,"F");
$y= date_format($date,"Y");

$statement = $db->prepare("SELECT enumber from mt_period 
  where period=:period and year=:year and open_max='OPEN'");

$statement->execute(array(':period'=>$m,':year'=>$y));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
//var_dump($statement->debugDumpParams());
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  $p=-10;
  if(count($data)==1)
  {
    $p=$data[0]["enumber"];
  }
  return $p;
}


public static function update_invoice_entry_sea($dev,$code)
{
$data=array();

try
{
$db = Factory::getConnection();


$c=$code;

if($c->sub_ar_doc_type=="PRO-INV")
{
  
//get bl no from performa
$statement = $db->prepare("SELECT bl_no FROM mt_ship_ar_header 
  where sub_ar_doc_number=:sub_ar_doc_number");
$statement->execute(array(':sub_ar_doc_number'=>$c->sub_ar_doc_number));
$op11s=$statement->fetchAll(PDO::FETCH_ASSOC);
$code->bl_no=explode(",",$op11s[0]["bl_no"])[0];
//split by comma
//get vessel voyage info
$statement = $db->prepare("SELECT vessel,voyage,port,liner 
  FROM mt_voyage WHERE voyage=
  (SELECT voyage FROM mt_manifest_entry 
  WHERE bl_no=:bl_no)");
$statement->execute(array(':bl_no'=>$code->bl_no));
$op11s=$statement->fetchAll(PDO::FETCH_ASSOC);
if(count($op11s)>=1)
{
$op11=$op11s[0];
$code->voyage=$op11["voyage"];
$code->vessel=$op11["vessel"];
$code->liner=$op11["liner"];
$code->port=$op11["port"];
}

list($first) = explode("/", $c->sub_ar_doc_number);
$no=str_replace($first,$c->sub_ar_doc_type,$c->sub_ar_doc_number);

$statement = $db->prepare("UPDATE mt_order_ar_header  
  set sub_ar_doc_type=:sub_ar_doc_type,
   sub_ar_doc_number=:sub_ar_doc_number,
  modified_by=:modified_by,modified_date=now() where id=:id");
$statement->execute(array(
':modified_by'=>$dev->username,
':id'=>$c->id,
':sub_ar_doc_type'=>$c->sub_ar_doc_type,
':sub_ar_doc_number'=>$no
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
$data["doc_no"]=$no;


//for sea

  //MT_AR_TRANS table
//mt_order_trans table created using mt_ar_trans
//FINANCIAL YEAR AND PERIOD IS PENDING
$fy=self::getFinancialYear();
$fp=self::getFinancialPeriod($c->sub_ar_date);

$statement = $db->prepare("INSERT into mt_order_trans (
  ordt_company,ordt_code,ordt_doc_type,ordt_doc_number,ordt_serial,ordt_group,ordt_doc_base,ordt_internal,ordt_other_reference,ordt_doc_date,ordt_gl_date,ordt_year,ordt_period,ordt_age_date,ordt_dp_date,ordt_currency,ordt_ex_rate,ordt_foreign_amount,ordt_local_amount,ordt_foreign_balance,ordt_local_balance,ordt_balance_status,ordt_description,ordt_notes,ordt_detail_2,ordt_detail_3,ordt_detail_4,ordt_posted_on,ip,created_by ,ua,ekey,created_date,
  company_id,location_id) 

SELECT sub_ar_company,
sub_ar_code,
sub_ar_doc_type,
sub_ar_doc_number,
sub_ar_internal_number,
sub_ar_group,
sub_ar_doc_base,
sub_ar_internal_number,
sub_ar_other_reference,
sub_ar_date,
sub_ar_gl_date,
'$fy',
'$fp',
sub_ar_age_date,
sub_ar_due_date,
sub_ar_currency,
sub_ar_ex_rate,
sub_ar_f_amount,
sub_ar_l_amount,
sub_ar_f_amount,
sub_ar_l_amount,
'A',
sub_ar_narration,
sub_ar_notes,
sub_place_off_supply,
sub_place_off_supply_date,
sub_ar_other_reference_date,
now(),
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$dev->company','$dev->location'  
FROM mt_order_ar_header WHERE sub_ar_doc_number=:temp_code");

$statement->execute(array(':temp_code'=>$no));

if ($statement->rowCount()){
  $data["AR_TRANS_status"]=1;
} else{
  $data["AR_TRANS_status"]=0;
}

// update order cost to invoiced from proforma
$charge_query="UPDATE mt_order_cost set invoiced=1,inv_pay_no=:doc_no where proforma=:id";
$statement = $db->prepare($charge_query);
$statement->execute(array(':id'=>$c->sub_ar_doc_number,
  ':doc_no'=>$no));

if ($statement->rowCount()){
  $data["cost_status"]=1;
} else{
  $data["cost_status"]=0;
}

$statement = $db->prepare("SELECT distinct order_id from mt_order_cost where proforma=:proforma");
$statement->execute(array(':proforma'=>$c->sub_ar_doc_number));

$ocs=$statement->fetchAll(PDO::FETCH_ASSOC);
//update order status to part invoiced or invoiced
for($i=0;$i<count($ocs);$i++)
{
$cd=$ocs[$i];
$oq="UPDATE mt_order_entry set status=(SELECT CASE WHEN (SELECT count(*) FROM `mt_order_cost` WHERE invoiced is null and type='INCOME' and order_id=:id)=0 THEN 'INVOICED'
    ELSE 'PART INVOICED'
        END)
      WHERE id=:id";

 $statement = $db->prepare($oq);
 $statement->execute(array(':id'=>$cd["order_id"]));

  if ($statement->rowCount()){
  $data["order_status-".$cd["order_id"]]=1;
} else{
  $data["order_status-".$cd["order_id"]]=0;
}
}

//update cost details to invoiced
 $statement = $db->prepare("UPDATE mt_order_ar_details set inv_status='INVOICED' where sub_ard_doc_number=:doc_no");
 $statement->execute(array(':doc_no'=>$c->sub_ar_doc_number));

  if ($statement->rowCount()){
  $data["detail_status"]=1;
} else{
  $data["detail_status"]=0;
}

//update order ar details id

$statement = $db->prepare("UPDATE mt_order_ar_details  
  set
   sub_ard_doc_number=:sub_ar_doc_number where sub_ard_doc_number=:id");
$statement->execute(array(
':id'=>$c->sub_ar_doc_number,
':sub_ar_doc_number'=>$no
));

if ($statement->rowCount()){
  $data["ar_detail_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["ar_detail_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

 //ship gl details
$temp_code=uniqid($dev->uid);

$multiple_order_no='';
$code->order_no=substr_replace($code->order_no, "", -1);
$sa=explode(',', $code->order_no);
$strLength=count($sa);
for ($i = 0; $i < $strLength; $i++) {

  if($i+1==$strLength)
  {
    $multiple_order_no=$multiple_order_no."'$sa[$i]'";
  }else{
    $multiple_order_no=$multiple_order_no."'$sa[$i]',";
  }

}
$on=$no;
$statement = $db->prepare("INSERT into mt_order_gl_details 
( pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  ip,created_by ,ua,ekey,created_date,temp_code)


  SELECT '$dev->company',(SELECT order_income_gl from mt_charge_group_detail where code=charge_desc limit 1),'SHIP','INV','$on','0',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$code->bl_no',
  currency,ex_rate,-selling_amount,-selling_base_amount,remarks,
  'RCT','$code->order_no','$c->sub_ar_date','$c->sub_ar_doc_base',
  '$code->bl_no',
  '$c->sub_ar_code',charge_desc,'$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code' from mt_order_cost 
  where proforma='$c->sub_ar_doc_number' 
  ");
/*
where order_id in (SELECT id from mt_order_entry 
  where order_no in($multiple_order_no)) and type='INCOME' 
*/

$statement->execute();
    if ($statement->rowCount()){
    $data["gld_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["gld_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

//gl header
//get sum values
$statement = $db->prepare("SELECT sum(selling_amount) samt,sum(selling_base_amount) sbamt from mt_order_cost 
  where proforma='$c->sub_ar_doc_number'");
$statement->execute();

$svs=$statement->fetchAll(PDO::FETCH_ASSOC);
$sv=$svs[0];

$base_currency=getBaseCurrency($dev);

$statement = $db->prepare("INSERT into mt_order_gl_details 
( pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  ip,created_by ,ua,ekey,created_date,temp_code,pre_glt_created)

  VALUES('$dev->company',(select gl_account from mt_gl_link where name='RECEIVABLE' limit 1),'ORDER','INV','$on',1,
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$code->bl_no',
  '$base_currency',1,:samt,:sbamt,'remarks',
  'SHIP','$code->order_no','$c->sub_ar_date','$c->sub_ar_doc_base',
  '$code->bl_no',
  '$c->sub_ar_code','charge_desc','$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code',now())");

$statement->execute(array(':samt'=>$sv["samt"],':sbamt'=>$sv["sbamt"]));
    if ($statement->rowCount()){
    $data["gld_header_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["gld_header_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

//ship gl ends

//4
$temp_code=uniqid($dev->uid);
//$gds=self::get_gl_Link();
$statement = $db->prepare("INSERT into mt_order_trans
( ordt_company,ordt_doc_type,ordt_doc_number,ordt_serial,ordt_doc_base,ordt_doc_date,ordt_gl_date,ordt_dp_date,ordt_age_date,ordt_year,ordt_period,ordt_carrier,ordt_vessel,ordt_voyage,ordt_port,ordt_bl,ordt_bl_type,ordt_charge,ordt_other_reference,ordt_currency,ordt_ex_rate,ordt_foreign_amount,ordt_local_amount,ordt_narration,ordt_status,
ordt_posted_on,
  ip,created_by ,ua,ekey,created_date,temp_code,ordt_code) 

  SELECT '$dev->company','INV','$on','0','ORDER','$c->sub_ar_date',
  '$c->sub_ar_date',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$code->liner',
  '$code->vessel','$code->voyage','$code->port','$code->bl_no',
  '$c->sub_ar_doc_base',charge_desc,'$code->order_no'
  ,currency,ex_rate,-selling_amount,
  -selling_base_amount,remarks,
  status,now(),
  '$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code','$c->sub_ar_code'
  from mt_order_cost 
  where proforma='$c->sub_ar_doc_number'
");
$statement->execute();
    if ($statement->rowCount()){
    $data["sht_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["sht_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

//query 5 ar trans

//MT_AR_TRANS table
//FINANCIAL YEAR AND PERIOD IS PENDING
$statement = $db->prepare("INSERT into mt_ar_trans (
  art_company,art_code,art_type,art_number,art_serial,art_group,art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,ip,created_by ,ua,ekey,created_date,
  company_id,location_id) 

SELECT sub_ar_company,
sub_ar_code,
sub_ar_doc_type,
sub_ar_doc_number,
sub_ar_internal_number,
sub_ar_group,
sub_ar_doc_base,
sub_ar_internal_number,
sub_ar_other_reference,
sub_ar_date,
sub_ar_gl_date,
'$fy',
'$fp',
sub_ar_age_date,
sub_ar_due_date,
sub_ar_currency,
sub_ar_ex_rate,
sub_ar_f_amount,
sub_ar_l_amount,
sub_ar_f_amount,
sub_ar_l_amount,
'A',
sub_ar_narration,
sub_ar_notes,
sub_place_off_supply,
sub_place_off_supply_date,
sub_ar_other_reference_date,
now(),
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$dev->company','$dev->location' 
FROM mt_order_ar_header WHERE sub_ar_doc_number=:temp_code");

$statement->execute(array(':temp_code'=>$no));

if ($statement->rowCount()){
  $data["AR_TRANS_status2"]=1;
} else{
  $data["AR_TRANS_status2"]=0;
}

// query 6
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_ar_trans_balance
(ardm_company,ardm_code,ardm_doc_type,ardm_doc_number,
  ardm_serial,ardm_other_reference,ardm_date,ardm_currency,
  ardm_ex_rate,ardm_of_amount,ardm_ol_amount,
  ardm_bf_amount,ardm_bl_amount,
  ardm_pf_amount,ardm_pl_amount,ardm_status,
ip,created_by,ua,ekey,created_date,temp_code,company_id,location_id)

SELECT art_company,art_code,art_type,art_number,
art_serial,art_other_reference,art_gl_date,art_currency,
art_ex_rate,art_foreign_amount,art_local_amount,
art_foreign_balance,art_local_balance,
0,0,'PENDING',
ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location'  
 from mt_ar_trans where art_number=:doc_no
");

$statement->execute(array(':doc_no'=>$no));
//var_dump($statement->debugDumpParams());
if ($statement->rowCount()){
  $data["tb_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["tb_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

}else{
  $statement = $db->prepare("UPDATE mt_order_ar_header  
  set sub_ar_doc_type=:sub_ar_doc_type,
  modified_by=:modified_by,modified_date=now() where id=:id");
$statement->execute(array(
':modified_by'=>$dev->username,
':id'=>$c->id,
':sub_ar_doc_type'=>$c->sub_ar_doc_type
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';

} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
$data["doc_no"]=$c->sub_ar_doc_number;
}
//
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;

}

public static function excludeCharges($charge)
{
  $op=0;
  $charges_list=array('OFRT','SLC');
  for($i=0;$i<count($charges_list);$i++)
  {
    if($charge==$charges_list[$i])
    {
      $op=1;
      break;
    }
  }
  return $op;
}
//agency invoice entry
public static function update_invoice_entry($dev,$code)
{
$data=array();

try
{
$db = Factory::getConnection();
$db->beginTransaction();


$c=$code->inv;
//$data["doc_type"]=$c->sub_ar_doc_type;

if($c->sub_ar_doc_type=="PRO-INV")
{

//START GST CALC
//Get gstin detail
$statement = $db->prepare("SELECT pan, gstin 
  from mt_business_partner    
  where code=:sub_ar_code ");
$statement->execute(array(':sub_ar_code'=>$c->sub_ar_code ));
$data["cngList"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$r=$data["cngList"][0];  
$consignee_pan_no=$r["pan"];
$billparty_gstin=$r["gstin"];

//check state
$startString=getGSTINStartString($dev);

$len = strlen($startString);
$cgst=0;
$sgst=0;
$igst=0;

//taxable
/*
$statement = $db->prepare("SELECT sum(sub_ard_foreign_amount) taxable from mt_ship_ar_details 
where sub_ard_doc_number=:sub_ard_doc_number 
and charge_desc!='OFRT' ");
$statement->execute(array(':sub_ard_doc_number'=>$c->sub_ar_doc_number));
$taxds=$statement->fetchAll(PDO::FETCH_ASSOC);
$rate=$taxds[0]["taxable"];
$data["taxds"]=$taxds;
*/

$rate_total=0;
$cds=$code->cd;
for($i=0;$i<count($cds);$i++)
  {
    $cd=$cds[$i];
    if($cd->charge_desc!='OFRT')
    {
    $rate_total=$rate_total+$cd->total_amt;
    }
  }
$rate=$rate_total;

//$rate=$c->total_local_amt;
#gst perc
$gst_percent=(float)$c->gst_percent;


//$state_cond=(substr($billparty_gstin, 0, $len) === $startString);
if($gst_percent!=0){

  if(substr($billparty_gstin, 0, $len)==$startString)
  {
      $tp=$gst_percent/2;
      $tv=($rate*$tp)/100;
      $cgst=round($tv,2);
      $sgst=round($tv,2);
  }else{
      $igst=round(($rate*$gst_percent)/100,2);
  }
}
$data["igst"]=$igst;
$data["cgst"]=$cgst;
$data["sgst"]=$sgst;

//END GST CALC

//get bl no from performa
$statement = $db->prepare("SELECT bl_no FROM mt_ship_ar_header 
  where sub_ar_doc_number=:sub_ar_doc_number");
$statement->execute(array(':sub_ar_doc_number'=>$c->sub_ar_doc_number));
$op11s=$statement->fetchAll(PDO::FETCH_ASSOC);
$code->bl_no=explode(",",$op11s[0]["bl_no"])[0];
//split by comma
//get vessel voyage info
$statement = $db->prepare("SELECT vessel,voyage,port,liner 
  FROM mt_voyage WHERE voyage=
  (SELECT voyage FROM mt_manifest_entry 
  WHERE bl_no=:bl_no)");
$statement->execute(array(':bl_no'=>$code->bl_no));
$op11s=$statement->fetchAll(PDO::FETCH_ASSOC);
if(count($op11s)>=1)
{
$op11=$op11s[0];
$code->voyage=$op11["voyage"];
$code->vessel=$op11["vessel"];
$code->liner=$op11["liner"];
$code->port=$op11["port"];
}

list($first) = explode("/", $c->sub_ar_doc_number);
$no=str_replace($first,$c->sub_ar_doc_type,$c->sub_ar_doc_number);

$statement = $db->prepare("UPDATE mt_ship_ar_header 
  set sub_ar_doc_type=:sub_ar_doc_type,
   sub_ar_doc_number=:sub_ar_doc_number,
  modified_by=:modified_by,modified_date=now() where id=:id");
$statement->execute(array(
':modified_by'=>$dev->username,
':id'=>$c->id,
':sub_ar_doc_type'=>$c->sub_ar_doc_type,
':sub_ar_doc_number'=>$no
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}
$data["doc_no"]=$no;


//addition entry
$fy=self::getFinancialYear();
$fp=self::getFinancialPeriod($c->sub_ar_date);

$on=$no;

//TAX STARTS

//OUTPUT CGST - 2-30-001-0012
      if($cgst!=0){
        $statement = $db->prepare("INSERT into mt_ar_trans (
          art_company,art_code,art_type,art_number,art_serial,art_group,
          art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,
          art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,
          art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,
          art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,
          ip,created_by ,ua,ekey,created_date,
          company_id,location_id) 
        values 
        ('$dev->company',:art_code,'OUTPUT CGST',:art_number,'1',:art_group,
        'OUTPUT CGST', '0', '', now(), now(),'$fy',
        '$fp', now(),now(), 'INR','1',:art_foreign_amount, 
        :art_local_amount,:art_foreign_balance,:art_local_balance,'A',
        :art_description,'','','','', now(),
        '$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey', now(),
        '$dev->company','$dev->location') ");

        $statement->execute(array(':art_code'=>$c->sub_ar_code, 
          ':art_number'=>$on, 
          ':art_group'=>'2-30-001-0012', 
          ':art_foreign_amount'=>$cgst, 
          ':art_local_amount'=>$cgst, 
          ':art_foreign_balance'=>$cgst, 
          ':art_local_balance'=>$cgst, 
          ':art_description'=>'OUTPUT CGST '.$gst_percent.'%' ));

        if ($statement->rowCount()){
          $data["cgst_status"]=1;
        } else{
          $data["cgst_status"]=0;
        }
    }
    //OUTPUT SGST - 2-30-001-0016
      if($sgst!=0){
        $statement = $db->prepare("INSERT into mt_ar_trans (
          art_company,art_code,art_type,art_number,art_serial,art_group,
          art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,
          art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,
          art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,
          art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,
          ip,created_by ,ua,ekey,created_date,
          company_id,location_id) 
        values 
        ('$dev->company',:art_code,'OUTPUT SGST',:art_number,'1',:art_group,
        'OUTPUT SGST', '0', '', now(), now(),'$fy',
        '$fp', now(),now(), 'INR','1',:art_foreign_amount, 
        :art_local_amount,:art_foreign_balance,:art_local_balance,'A',
        :art_description,'','','','', now(),
        '$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey', now(),
        '$dev->company','$dev->location') ");

        $statement->execute(array(':art_code'=>$c->sub_ar_code, 
          ':art_number'=>$on, 
          ':art_group'=>'2-30-001-0016', 
          ':art_foreign_amount'=>$sgst, 
          ':art_local_amount'=>$sgst, 
          ':art_foreign_balance'=>$sgst, 
          ':art_local_balance'=>$sgst, 
          ':art_description'=>'OUTPUT SGST '.$gst_percent.'%' ));

        if ($statement->rowCount()){
          $data["sgst_status"]=1;
        } else{
          $data["sgst_status"]=0;
        }
    }
    //OUTPUT IGST - 2-30-001-0015
      if($igst!=0){
        $statement = $db->prepare("INSERT into mt_ar_trans (
          art_company,art_code,art_type,art_number,art_serial,art_group,
          art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,
          art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,
          art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,
          art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,
          ip,created_by ,ua,ekey,created_date,
          company_id,location_id) 
        values 
        ('$dev->company',:art_code,'OUTPUT IGST',:art_number,'1',:art_group,
        'OUTPUT IGST', '0', '', now(), now(),'$fy',
        '$fp', now(),now(), 'INR','1',:art_foreign_amount, 
        :art_local_amount,:art_foreign_balance,:art_local_balance,'A',
        :art_description,'','','','', now(),
        '$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey', now(),
        '$dev->company','$dev->location') ");

        $statement->execute(array(':art_code'=>$c->sub_ar_code, 
          ':art_number'=>$on, 
          ':art_group'=>'2-30-001-0015', 
          ':art_foreign_amount'=>$igst, 
          ':art_local_amount'=>$igst, 
          ':art_foreign_balance'=>$igst, 
          ':art_local_balance'=>$igst, 
          ':art_description'=>'OUTPUT IGST '.$gst_percent.'%' ));

        if ($statement->rowCount()){
          $data["igst_status"]=1;
        } else{
          $data["igst_status"]=0;
        }
    }

//TAX ENDS

//MT_AR_TRANS table
//FINANCIAL YEAR AND PERIOD IS PENDING
$statement = $db->prepare("INSERT into mt_ar_trans (
  art_company,art_code,art_type,art_number,art_serial,art_group,art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,ip,created_by ,ua,ekey,created_date,
  company_id,location_id) 

SELECT sub_ar_company,
sub_ar_code,
sub_ar_doc_type,
sub_ar_doc_number,
sub_ar_internal_number,
sub_ar_group,
sub_ar_doc_base,
sub_ar_internal_number,
sub_ar_other_reference,
sub_ar_date,
sub_ar_gl_date,
'$fy',
'$fp',
sub_ar_age_date,
sub_ar_due_date,
sub_ar_currency,
sub_ar_ex_rate,
sub_ar_f_amount,
sub_ar_l_amount,
sub_ar_f_amount,
sub_ar_l_amount,
'A',
sub_ar_narration,
sub_ar_notes,
sub_place_off_supply,
sub_place_off_supply_date,
sub_ar_other_reference_date,
now(),
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$dev->company','$dev->location' 
FROM mt_ship_ar_header WHERE sub_ar_doc_number=:temp_code");

$statement->execute(array(':temp_code'=>$no));

if ($statement->rowCount()){
  $data["ar_trans_status"]=1;
} else{
  $data["ar_trans_status"]=0;
}

//trans balance query

//query 5

$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_ar_trans_balance
(ardm_company,ardm_code,ardm_doc_type,ardm_doc_number,
  ardm_serial,ardm_other_reference,ardm_date,ardm_currency,
  ardm_ex_rate,ardm_of_amount,ardm_ol_amount,
  ardm_bf_amount,ardm_bl_amount,
  ardm_pf_amount,ardm_pl_amount,ardm_status,
ip,created_by,ua,ekey,created_date,temp_code,company_id,location_id)

SELECT art_company,art_code,art_type,art_number,
art_serial,art_other_reference,art_gl_date,art_currency,
art_ex_rate,art_foreign_amount,art_local_amount,
art_foreign_balance,art_local_balance,
0,0,'PENDING',
ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location'  
 from mt_ar_trans where art_number=:doc_no
");

$statement->execute(array(':doc_no'=>$no));
//var_dump($statement->debugDumpParams());
if ($statement->rowCount()){
  $data["tb_status"]=1;
} else{
  $data["tb_status"]=0;
}

$order_id=0;

// update order cost to invoiced from proforma
$charge_query="UPDATE mt_order_cost set invoiced=1,
inv_pay_no=:doc_no,modified_by=:modified_by,modified_date=now() where proforma=:id";
$statement = $db->prepare($charge_query);
$statement->execute(array(':id'=>$c->sub_ar_doc_number,
':doc_no'=>$no,':modified_by'=>$dev->username));

if ($statement->rowCount()){
  $data["cost_status"]=1;
} else{
  $data["cost_status"]=0;
}

$statement = $db->prepare("SELECT distinct order_id from mt_order_cost where proforma=:proforma");
$statement->execute(array(':proforma'=>$c->sub_ar_doc_number));

$ocs=$statement->fetchAll(PDO::FETCH_ASSOC);
//update order status to part invoiced or invoiced
$ocs_count=0;

for($i=0;$i<count($ocs);$i++)
{
$cd=$ocs[$i];
$oq="UPDATE mt_order_entry set modified_date=now(),modified_by=:modified_by,status=(SELECT CASE WHEN (SELECT count(*) FROM `mt_order_cost` WHERE invoiced is null and type='INCOME' and order_id=:id)=0 THEN 'INVOICED'
    ELSE 'PART INVOICED'
        END)
      WHERE id=:id";

 $statement = $db->prepare($oq);
 $statement->execute(array(':id'=>$cd["order_id"],':modified_by'=>$dev->username));

  if ($statement->rowCount()){
  $data["order_status-".$cd["order_id"]]=1;
  $ocs_count+=1;

} else{
  $data["order_status-".$cd["order_id"]]=0;
}
}

//update cost details to invoiced
 $statement = $db->prepare("UPDATE mt_ship_ar_details set inv_status='INVOICED' where sub_ard_doc_number=:doc_no");
 $statement->execute(array(':doc_no'=>$c->sub_ar_doc_number));

  if ($statement->rowCount()){
  $data["detail_status"]=1;
} else{
  $data["detail_status"]=0;
}

$statement = $db->prepare("UPDATE mt_ship_ar_details  
  set
   sub_ard_doc_number=:sub_ar_doc_number where sub_ard_doc_number=:id");
$statement->execute(array(
':id'=>$c->sub_ar_doc_number,
':sub_ar_doc_number'=>$no
));

if ($statement->rowCount()){
  $data["ar_detail_docno_status"]=1;
} else{
  $data["ar_detail_docno_status"]=0;
}

//ship gl details
$temp_code=uniqid($dev->uid);

$multiple_order_no='';
$code->order_no=substr_replace($code->order_no, "", -1);
$sa=explode(',', $code->order_no);
$strLength=count($sa);
for ($i = 0; $i < $strLength; $i++) {

  if($i+1==$strLength)
  {
    $multiple_order_no=$multiple_order_no."'$sa[$i]'";
  }else{
    $multiple_order_no=$multiple_order_no."'$sa[$i]',";
  }

}
$on=$no;

$statement = $db->prepare("INSERT into ship_gl_details 
( pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  ip,created_by ,ua,ekey,created_date,temp_code, 
  location_id,company_id)


  SELECT '$dev->company',(
IFNULL((SELECT income_gl from mt_charge_group_detail 
  where code=charge_desc),(SELECT gl_receivable_pdc from mt_gl_link where name= (select liner from mt_voyage where voyage=(select voyage from mt_manifest_entry where bl_no='$code->bl_no'))))
  ),'SHIP','INV','$on','0',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$code->bl_no',
  currency,ex_rate,-selling_amount,-selling_base_amount,remarks,
  'RCT','$code->order_no','$c->sub_ar_date','$c->sub_ar_doc_base',
  '$code->bl_no',
  '$c->sub_ar_code',charge_desc,'$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code',
  '$dev->company','$dev->location' from mt_order_cost 
  where proforma='$c->sub_ar_doc_number'");


$statement->execute();
    if ($statement->rowCount()){
    $data["gld_status"]=1;
  } else{
    $data["gld_status"]=0;
  }

//Add TAX+GST entries to GL detail table
  $statement = $db->prepare("INSERT into ship_gl_details 
  ( pre_glt_company, pre_glt_code,
  pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_serial,
  pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,
  pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,
  pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,
  pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  ip,created_by ,ua,ekey,created_date,temp_code,pre_glt_created,
  location_id,company_id)

  SELECT art_company,art_group,
  art_type,art_base_type,
  art_number, art_serial,
  art_gl_date,art_gl_date,'$fy','$fp',
  art_other_reference,art_currency,art_ex_rate,
  art_foreign_amount,art_local_amount,art_description,
  'ORDER','$code->order_no','$code->bl_no','$c->sub_ar_date',
  '$c->sub_ar_code',art_group,art_description,
  ip,created_by,ua,ekey,now(),'$temp_code',now(),
  '$dev->company','$dev->location'    
   from mt_ar_trans where art_number=:doc_no and art_type in ('PRO-INV','IMP-INV','EXP-INV','OUTPUT IGST','OUTPUT SGST','OUTPUT CGST') ");

  $statement->execute(array(':doc_no'=>$on));
      if ($statement->rowCount()){
      $data["gld_header_status"]=1;
    } else{
      $data["gld_header_status"]=0;
    }
  //ship gl ends



//4
$temp_code=uniqid($dev->uid);
//$gds=self::get_gl_Link();
$statement = $db->prepare("INSERT into mt_ship_trans
( st_company,st_doc_type,st_doc_number,st_serial,st_doc_base,st_date,st_gl_date,st_dp_date,st_age_date,st_year,st_period,st_carrier,st_vessel,st_voyage,st_port,st_bl,st_bl_type,st_charge,st_other_reference,st_currency,st_exchange,st_foreign,st_local,st_narration,st_status,
  st_posted_on,
  ip,created_by ,ua,ekey,created_date,temp_code) 

  SELECT '$dev->company','INV','$on','0','SHIP','$c->sub_ar_date',
  '$c->sub_ar_date',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$code->liner',
  '$code->vessel','$code->voyage','$code->port','$code->bl_no',
  '$c->sub_ar_doc_base',charge_desc,'$code->order_no'
  ,currency,ex_rate,-selling_amount,
  -selling_base_amount,remarks,
  status,now(),
  '$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code' from mt_order_cost 
  where proforma='$c->sub_ar_doc_number'");
$statement->execute();
    if ($statement->rowCount()){
    $data["sht_status"]=1;
  } else{
    $data["sht_status"]=0;
  }

  //$data["status"]=0;

$gst_status=0;
if($igst!=0)
{
  $gst_status=$data["igst_status"];
}else{
  if($data["cgst_status"]==1 && $data["sgst_status"]==1)
  {
    $gst_status=1;
  }else{
    $gst_status=0;
  }
}

if($data["status"]==1  && count($ocs)==$ocs_count && $data["detail_status"]==1 && $data["ar_detail_docno_status"]==1 && $data["sht_status"]==1 && $data["gld_status"]==1 && $data["gld_header_status"]==1 && $data["ar_trans_status"]==1 && $data["tb_status"]==1 && $gst_status==1)
{
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}
//end of pro inv

}else{
  //updating pro details
  $statement = $db->prepare("UPDATE mt_ship_ar_header  
  set sub_ar_doc_type=:sub_ar_doc_type,
sub_ar_other_reference=:sub_ar_other_reference,
sub_ar_currency=:sub_ar_currency,
sub_ar_ex_rate=:sub_ar_ex_rate,
sub_place_off_supply=:sub_place_off_supply,
sub_ar_narration=:sub_ar_narration,
sub_ar_notes=:sub_ar_notes,
sub_ar_code=:sub_ar_code,
modified_by=:modified_by,modified_date=now(),gst_percent=:gst_percent 
where id=:id");
$statement->execute(array(
':modified_by'=>$dev->username,
':id'=>$c->id,
':sub_ar_doc_type'=>$c->sub_ar_doc_type,

':sub_ar_other_reference'=>$c->sub_ar_other_reference,
':sub_ar_currency'=>$c->sub_ar_currency,
':sub_ar_ex_rate'=>$c->sub_ar_ex_rate,
':sub_place_off_supply'=>$c->sub_place_off_supply,
':sub_ar_narration'=>$c->sub_ar_narration,
':sub_ar_notes'=>$c->sub_ar_notes,
':sub_ar_code'=>$c->sub_ar_code,
':gst_percent'=>$c->gst_percent
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";

}
$data["doc_no"]=$c->sub_ar_doc_number;

//$data["status"]=0;
if($data["status"]==1 )
{
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}

}

//addition entry ends

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
  }
  
  return $data;

}


public static function save_invoice_entry_pro($dev,$code)
{
$data=array();

try
{
$db = Factory::getConnection();
$db->beginTransaction();

$temp_code=uniqid($dev->uid);

$c=$code->inv;

//START GST CALC
//Get gstin detail
$statement = $db->prepare("SELECT pan, gstin 
  from mt_business_partner    
  where code=:sub_ar_code ");
$statement->execute(array(':sub_ar_code'=>$c->sub_ar_code ));
$data["cngList"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$r=$data["cngList"][0];  
$consignee_pan_no=$r["pan"];
$billparty_gstin=$r["gstin"];

//check state
$startString=getGSTINStartString($dev);

$len = strlen($startString);
$cgst=0;
$sgst=0;
$igst=0;

//taxable
/*
$statement = $db->prepare("SELECT sum(selling_base_amount) taxable from mt_order_cost  
where order_id=(select id from mt_order_entry where order_no=REPLACE(:order_no, ',', '') limit 1)
and charge_desc!='OFRT'  and invoiced !=1 ");
$statement->execute(array(':order_no'=>$code->order_no));
$taxds=$statement->fetchAll(PDO::FETCH_ASSOC);
*/
$rate_total=0;
$cds=$code->cd;
for($i=0;$i<count($cds);$i++)
  {
    $cd=$cds[$i];
    if($cd->charge_desc!='OFRT')
    {
    $rate_total=$rate_total+$cd->total_amt;
    }
  }
$rate=$rate_total;
//$rate=($rate_total*18)/100;
//$rate=round($rate,2);
//$rate=$taxds[0]["taxable"];
//$data["taxds"]=$taxds;
$data["taxds"]=$rate;

//$rate=$c->total_local_amt;
#gst perc
$gst_percent=(float)$c->gst_percent;


//$state_cond=(substr($billparty_gstin, 0, $len) === $startString);
$data["billparty_gstin"]=$billparty_gstin;
$data["startString"]=$startString;

if($gst_percent!=0){

  if(substr($billparty_gstin, 0, $len)==$startString)
  {
      $tp=$gst_percent/2;
      $tv=($rate*$tp)/100;
      $cgst=round($tv,2);
      $sgst=round($tv,2);
      $data["cgst"]=$cgst;
      $data["sgst"]=$sgst;
      $data["tv"]=$tv;
      $data["tp"]=$tp;
      $data["rate"]=$rate;
      $data["tp"]=$tp;

  }else{
      $igst=round(($rate*$gst_percent)/100,2);
      $data["igst"]=$igst;
      $data["rate"]=$rate;
      $data["gst_percent"]=$gst_percent;
  }
}
//END GST CALC

$statement = $db->prepare("INSERT into mt_ship_ar_header(sub_ar_company,
  sub_ar_doc_type,sub_ar_doc_number,sub_ar_doc_base,sub_ar_gl_date,sub_ar_due_date,sub_ar_age_date,sub_ar_date,sub_ar_other_reference,sub_ar_currency,sub_ar_ex_rate,sub_place_off_supply,sub_place_off_supply_date,sub_ar_narration,sub_ar_notes,sub_ar_code,
  sub_ar_group,
  sub_ar_status, 
  sub_ar_other_reference_date,
  ip,created_by ,ua,ekey,created_date,temp_code,total_local_amt,order_no,
  bl_no,sub_ar_user,sub_ar_f_amount,sub_ar_l_amount,
  gst_percent, igst, cgst, sgst,
  company_id,location_id) 
values(:company_id,:sub_ar_doc_type,:sub_ar_doc_number,:sub_ar_doc_base,:sub_ar_gl_date,:sub_ar_due_date,:sub_ar_age_date,:sub_ar_date,:sub_ar_other_reference,:sub_ar_currency,:sub_ar_ex_rate,:sub_place_off_supply,:sub_place_off_supply_date,:sub_ar_narration,:sub_ar_notes,:sub_ar_code,
(select gl_account from mt_gl_link where name='RECEIVABLE' limit 1),
:sub_ar_status,
:sub_ar_other_reference_date,
:ip ,:created_by ,
:ua ,:ekey,now(),:temp_code,:total_local_amt,:order_no,
  :bl_no,:sub_ar_user,:total_local_amt,:total_local_amt,
  :gst_percent, :igst, :cgst, :sgst,
:company_id,:location_id)");

if($c->sub_ar_due_date=="")
{
  $c->sub_ar_due_date=null;
}

if($c->sub_ar_other_reference_date=="")
{
  $c->sub_ar_other_reference_date=null;
}

if($c->sub_ar_ex_rate=="")
{
  $c->sub_ar_ex_rate=null;
}

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company_id'=>$dev->company,
':sub_ar_doc_type'=>$c->sub_ar_doc_type,
':sub_ar_doc_number'=>$c->sub_ar_doc_number,
':sub_ar_doc_base'=>$c->sub_ar_doc_base,
':sub_ar_gl_date'=>$c->sub_ar_gl_date,
':sub_ar_due_date'=>$c->sub_ar_due_date,
':sub_ar_age_date'=>$c->sub_ar_date,
':sub_ar_date'=>$c->sub_ar_date,
':sub_ar_other_reference'=>$c->sub_ar_other_reference,
':sub_ar_currency'=>$c->sub_ar_currency,
':sub_ar_ex_rate'=>$c->sub_ar_ex_rate,
':sub_place_off_supply'=>$c->sub_place_off_supply,
':sub_place_off_supply_date'=>$c->sub_place_off_supply_date,
':sub_ar_narration'=>$c->sub_ar_narration,
':sub_ar_notes'=>$c->sub_ar_notes,
':sub_ar_code'=>$c->sub_ar_code,
':sub_ar_status'=>'A', // means PROFORMA
':sub_ar_other_reference_date'=>$c->sub_ar_other_reference_date,

':temp_code'=>$temp_code,
':total_local_amt'=>$c->total_local_amt,
':order_no'=>$code->order_no,
':bl_no'=>$code->bl_no,
':sub_ar_user'=>$dev->username,
':gst_percent'=>$c->gst_percent,

':gst_percent'=>$gst_percent,
':igst'=>$igst,
':cgst'=>$cgst,
':sgst'=>$sgst,

':company_id'=>$dev->company,
':location_id'=>$dev->location
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";

} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";

}

//generate doc number

$data["temp_code"]=$temp_code;

$statement = $db->prepare("SELECT id from mt_ship_ar_header where created_by=:created_by and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

//get count id

$statement = $db->prepare("SELECT COUNT(*)+1 rid FROM mt_ship_ar_header where id<(SELECT id from mt_ship_ar_header where created_by=:created_by and temp_code=:temp_code)");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username));
$row_ids=$statement->fetchAll(PDO::FETCH_ASSOC);
$row_id=$row_ids[0]["rid"];
//

$fid=self::setFourDigit($row_id);

$on=$c->sub_ar_doc_type."/".date("Y")."/".date('m')."/".$c->sub_place_off_supply."/".$fid;

 $statement = $db->prepare("UPDATE mt_ship_ar_header 
  SET sub_ar_doc_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["invid_status"]=1;
  } else{
    $data["invid_status"]=0;
  }

$data["doc_no"]=$on;


//doc number ends


$order_id=0; 
$order_details_insert_count=0;
$order_cost_update_count=0;

if($data["status"]==1)
{
  $cds=$code->cd;
  $ocds=$code->ocd;

  $q="INSERT into mt_ship_ar_details(
      sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,sub_ard_currency,sub_ard_ex_rate,sub_ard_foreign_amount,sub_ard_local_amount,sub_ard_narration,sub_ard_notes,sub_ard_detail_1,sub_ard_detail_2,sub_ard_detail_3,sub_ard_detail_4,sub_ard_detail_5,sub_ard_detail_6,sub_ard_basis,sub_ard_rate,sub_ard_quantity,ip,created_by ,ua,ekey,created_date,charge_desc,basis_type,taxable,total_tax_amt,total_amt,inv_status,sub_ard_detail_7,sub_ard_detail_8,sub_ard_detail_9,
      sub_ard_detail_10,charge_id) 
      VALUES(:sub_ard_company,:sub_ard_doc_type,:sub_ard_doc_number,:sub_ard_serial,:sub_ard_currency,:sub_ard_ex_rate,:sub_ard_foreign_amount,:sub_ard_local_amount,:sub_ard_narration,:sub_ard_notes,:sub_ard_detail_1,:sub_ard_detail_2,:sub_ard_detail_3,:sub_ard_detail_4,:sub_ard_detail_5,:sub_ard_detail_6,:sub_ard_basis,:sub_ard_rate,:sub_ard_quantity,:ip ,:created_by ,
:ua ,:ekey,now(),:charge_desc,:basis_type,:taxable,:total_tax_amt,:total_amt,:inv_status,'$code->liner','$code->vessel','$code->voyage','$code->port',:charge_id)";

$charge_query="UPDATE mt_order_cost set invoiced=2,proforma=:doc_no,modified_by=:modified_by,modified_date=now() where id=:id";
$i=0;
$c->sub_ar_doc_number = $on;

  for(;$i<count($cds);$i++)
  {
    $cd=$cds[$i];
    $statement = $db->prepare($q);
    $ar=self::setChargeDetails('MANIFEST',$cd,$dev,$c,$i);
    $ar[':inv_status']='PROFORMA';
    $statement->execute($ar);

      if ($statement->rowCount()){
    $order_details_insert_count+=1;
  }

    $statement = $db->prepare($charge_query);
    $statement->execute(array(':id'=>$cd->id,':doc_no'=>$on,
      ':modified_by'=>$dev->username));

      if ($statement->rowCount())
      {
    $order_cost_update_count+=1;
      }
  }
}
   
//$data["status"]=0;
if($data["invid_status"]==1 && $data["status"]==1 && count($cds)==$order_details_insert_count && count($cds)==$order_cost_update_count)
{
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
  }
  
  return $data;
}
//for auto invoice from do

public static function save_invoice_entry_fordo($dev,$code)
{
$data=array();

try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$c=$code->info;

//get do fee info
$statement = $db->prepare("SELECT id,charge_desc,type,basis_type,
  basis_uom,qty,currency,ex_rate,rate_selling,selling_amount,selling_base_amount from mt_order_cost where invoiced is null and type='INCOME' and charge_desc='DOF' and order_id=(SELECT id from mt_order_entry where order_no=:order_no)");
$statement->execute(array(':order_no'=>$c->order_no));
$orders_info=$statement->fetchAll(PDO::FETCH_ASSOC);
$order_cost=0;
$c->total_local_amt=225;
if(count($orders_info)!=0)
{
$order_cost=$orders_info[0];
$c->total_local_amt=$order_cost["selling_amount"];

$statement = $db->prepare("INSERT into mt_ship_ar_header(sub_ar_company,
  sub_ar_doc_type,sub_ar_doc_number,sub_ar_doc_base,sub_ar_gl_date,sub_ar_due_date,sub_ar_age_date,sub_ar_date,sub_ar_other_reference,sub_ar_currency,sub_ar_ex_rate,sub_place_off_supply,sub_place_off_supply_date,sub_ar_narration,sub_ar_notes,sub_ar_code,
  sub_ar_group,
  sub_ar_status, 
  sub_ar_other_reference_date,
  ip,created_by ,ua,ekey,created_date,temp_code,total_local_amt,order_no,
  bl_no,sub_ar_user,sub_ar_f_amount,sub_ar_l_amount,
  company_id,location_id) 
values(:company_id,:sub_ar_doc_type,:sub_ar_doc_number,:sub_ar_doc_base,:sub_ar_gl_date,:sub_ar_due_date,:sub_ar_age_date,:sub_ar_date,:sub_ar_other_reference,:sub_ar_currency,:sub_ar_ex_rate,:sub_place_off_supply,:sub_place_off_supply_date,:sub_ar_narration,:sub_ar_notes,:sub_ar_code,
'ACCOUNTS RECEIVABLE',
:sub_ar_status,
:sub_ar_other_reference_date,
:ip ,:created_by ,
:ua ,:ekey,now(),:temp_code,:total_local_amt,:order_no,
  :bl_no,:sub_ar_user,:total_local_amt,:total_local_amt,
:company_id,:location_id)");

$do=$code->do;
$c->sub_ar_due_date=$do->do_date;
$c->sub_ar_other_reference_date=$do->do_date;
$c->sub_ar_gl_date=$do->do_date;
$c->sub_ar_date=$do->do_date;

$c->sub_ar_ex_rate=$order_cost["ex_rate"];;
$c->sub_ar_other_reference='';
$c->sub_ar_currency=$order_cost["currency"];
$c->sub_place_off_supply=$dev->location;
$c->sub_place_off_supply_date=$do->do_date;
$c->sub_ar_narration=$do->narration;
$c->sub_ar_notes=$do->remarks;
$c->sub_ar_code=$c->consignee;

$c->order_no=$c->order_no;
$c->bl_no=$c->bl_no;

$c->vessel=$c->vessel;
$c->voyage=$c->voyage;
$c->port=$c->pof;
$c->liner=$c->eline;

$c->sub_ar_doc_type="IMP-INV";
$c->sub_ar_doc_base="AGENCY IMPORT";
$c->sub_ar_doc_number='';

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company_id'=>$dev->company,
':sub_ar_doc_type'=>$c->sub_ar_doc_type,
':sub_ar_doc_number'=>$c->sub_ar_doc_number,
':sub_ar_doc_base'=>$c->sub_ar_doc_base,
':sub_ar_gl_date'=>$c->sub_ar_gl_date, //do date
':sub_ar_due_date'=>$c->sub_ar_due_date,
':sub_ar_age_date'=>$c->sub_ar_date,
':sub_ar_date'=>$c->sub_ar_date,
':sub_ar_other_reference'=>$c->sub_ar_other_reference, //empty
':sub_ar_currency'=>$c->sub_ar_currency, // 
':sub_ar_ex_rate'=>$c->sub_ar_ex_rate, //1
':sub_place_off_supply'=>$c->sub_place_off_supply, //dev-location
':sub_place_off_supply_date'=>$c->sub_place_off_supply_date,
':sub_ar_narration'=>$c->sub_ar_narration, //narration
':sub_ar_notes'=>$c->sub_ar_notes, //remarks
':sub_ar_code'=>$c->sub_ar_code, // consignee
':sub_ar_status'=>'P', // means POSTED
':sub_ar_other_reference_date'=>$c->sub_ar_other_reference_date,

':temp_code'=>$temp_code,
':total_local_amt'=>$c->total_local_amt, // do fee 225
':order_no'=>$c->order_no,
':bl_no'=>$c->bl_no,
':sub_ar_user'=>$dev->username,

':company_id'=>$dev->company,
':location_id'=>$dev->location
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';

} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

//generate doc number

$data["temp_code"]=$temp_code;

$statement = $db->prepare("SELECT id from mt_ship_ar_header where created_by=:created_by and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

$fid=self::setFourDigit($op[0]["id"]);

$on=$c->sub_ar_doc_type."/".date("Y")."/".date('m')."/".$c->sub_place_off_supply."/".$fid;

 $statement = $db->prepare("UPDATE mt_ship_ar_header 
  SET sub_ar_doc_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["invid_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["invid_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

$data["doc_no"]=$on;

$fy=self::getFinancialYear();
$fp=self::getFinancialPeriod($c->sub_ar_date);
//doc number ends

//MT_AR_TRANS table
//FINANCIAL YEAR AND PERIOD IS PENDING
$statement = $db->prepare("INSERT into mt_ar_trans (
  art_company,art_code,art_type,art_number,art_serial,art_group,art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,ip,created_by ,ua,ekey,created_date,
  company_id,location_id) 

SELECT sub_ar_company,
sub_ar_code,
sub_ar_doc_type,
sub_ar_doc_number,
sub_ar_internal_number,
sub_ar_group,
sub_ar_doc_base,
sub_ar_internal_number,
sub_ar_other_reference,
sub_ar_date,
sub_ar_gl_date,
'$fy',
'$fp',
sub_ar_age_date,
sub_ar_due_date,
sub_ar_currency,
sub_ar_ex_rate,
sub_ar_f_amount,
sub_ar_l_amount,
sub_ar_f_amount,
sub_ar_l_amount,
'A',
sub_ar_narration,
sub_ar_notes,
sub_place_off_supply,
sub_place_off_supply_date,
sub_ar_other_reference_date,
now(),
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$dev->company','$dev->location'  
FROM mt_ship_ar_header WHERE temp_code=:temp_code");

$statement->execute(array(':temp_code'=>$temp_code));

if ($statement->rowCount()){
  $data["AR_TRANS_status"]=1;
} else{
  $data["AR_TRANS_status"]=0;
}

//trans balance


// query 6
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_ar_trans_balance
(ardm_company,ardm_code,ardm_doc_type,ardm_doc_number,
  ardm_serial,ardm_other_reference,ardm_date,ardm_currency,
  ardm_ex_rate,ardm_of_amount,ardm_ol_amount,
  ardm_bf_amount,ardm_bl_amount,
  ardm_pf_amount,ardm_pl_amount,ardm_status,
ip,created_by,ua,ekey,created_date,temp_code,company_id,location_id)

SELECT art_company,art_code,art_type,art_number,
art_serial,art_other_reference,art_gl_date,art_currency,
art_ex_rate,art_foreign_amount,art_local_amount,
art_foreign_balance,art_local_balance,
0,0,'PENDING',
ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location'  
 from mt_ar_trans where art_number=:doc_no
");

$statement->execute(array(':doc_no'=>$on));
//var_dump($statement->debugDumpParams());
if ($statement->rowCount()){
  $data["tb_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["tb_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

//trans balance ends
$order_id=0;
if($data["status"]==1)
{
  

  $q="INSERT into mt_ship_ar_details(
      sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,sub_ard_currency,sub_ard_ex_rate,sub_ard_foreign_amount,sub_ard_local_amount,sub_ard_narration,sub_ard_notes,sub_ard_detail_1,sub_ard_detail_2,sub_ard_detail_3,sub_ard_detail_4,sub_ard_detail_5,sub_ard_detail_6,sub_ard_basis,sub_ard_rate,sub_ard_quantity,ip,created_by ,ua,ekey,created_date,charge_desc,basis_type,taxable,total_tax_amt,total_amt,inv_status,sub_ard_detail_7,sub_ard_detail_8,sub_ard_detail_9,sub_ard_detail_10) 
      VALUES(:sub_ard_company,:sub_ard_doc_type,:sub_ard_doc_number,:sub_ard_serial,:sub_ard_currency,:sub_ard_ex_rate,:sub_ard_foreign_amount,:sub_ard_local_amount,:sub_ard_narration,:sub_ard_notes,:sub_ard_detail_1,:sub_ard_detail_2,:sub_ard_detail_3,:sub_ard_detail_4,:sub_ard_detail_5,:sub_ard_detail_6,:sub_ard_basis,:sub_ard_rate,:sub_ard_quantity,:ip ,:created_by ,
:ua ,:ekey,now(),:charge_desc,:basis_type,:taxable,:total_tax_amt,:total_amt,:inv_status,'$c->eline',
  '$c->vessel','$c->voyage','$c->pof')";
$charge_query="UPDATE mt_order_cost 
set invoiced=1,inv_pay_no=:docno where id=:id";
$i=0;
$c->sub_ar_doc_number = $on;
$order_cost_ids=$order_cost["id"];

//$order_cost_ids=$order_cost_ids."'".$cd->id."',";

$statement = $db->prepare($q);
$ar=array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':sub_ard_company'=>$dev->company,
':sub_ard_doc_type'=>$c->sub_ar_doc_type, //IMP_INV
':sub_ard_doc_number'=>$c->sub_ar_doc_number,
':sub_ard_serial'=>$i+1,
':sub_ard_currency'=>$c->sub_ar_currency,
':sub_ard_ex_rate'=>$c->sub_ar_ex_rate,
':sub_ard_foreign_amount'=>$order_cost["selling_amount"], 
':sub_ard_local_amount'=>$order_cost["selling_base_amount"],
':sub_ard_narration'=>$do->narration, 
':sub_ard_notes'=>$do->remarks, //remarks
':sub_ard_detail_1'=>$c->order_no,
':sub_ard_detail_2'=>$do->do_date, //do date
':sub_ard_detail_3'=>'AGENCT IMPORT', //AGENCT IMPORT
':sub_ard_detail_4'=>$c->bl_no,
':sub_ard_detail_5'=>$c->consignee, //consignee
':sub_ard_detail_6'=>'MANIFEST', //MANIFEST
':sub_ard_basis'=>'', //
':sub_ard_rate'=>$order_cost["selling_amount"], //225
':sub_ard_quantity'=>$order_cost["qty"], //1
':charge_desc'=>'DOF', //DOF
':basis_type'=>$order_cost["basis_type"],
':taxable'=>'',

':total_tax_amt'=>'',
':total_amt'=>$order_cost["selling_amount"],
':inv_status'=>'INVOICED'
);
    $statement->execute($ar);

    $statement = $db->prepare($charge_query);
    $statement->execute(array(':id'=>$order_cost_ids,
      ':docno'=>$on));

      //update order status
  $oq="UPDATE mt_order_entry t1 set modified_date=now(),status=CASE WHEN (SELECT count(*) FROM `mt_order_cost` WHERE invoiced is null and order_id=t1.id 
  and type='INCOME')=0 THEN 'INVOICED'
    ELSE 'PART INVOICED'
        END 
      WHERE order_no=:id";

      $statement = $db->prepare($oq);
      $statement->execute(array(':id'=>$c->order_no));
      
      if ($statement->rowCount()){
  $data["ord_inv_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["ord_inv_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
 

//$order_cost_ids=substr_replace($order_cost_ids,"",-1);

  //ship gl details
$temp_code=uniqid($dev->uid);
/*
$multiple_order_no='';
$sa=explode(',', $code->order_no);
$strLength=count($sa);
for ($i = 0; $i < $strLength; $i++) {

  if($i+1==$strLength)
  {
    $multiple_order_no=$multiple_order_no."'$sa[$i]'";
  }else{
    $multiple_order_no=$multiple_order_no."'$sa[$i]',";
  }

}*/

$statement = $db->prepare("INSERT into ship_gl_details 
( pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  ip,created_by ,ua,ekey,created_date,temp_code, 
  location_id,company_id)


  SELECT '$dev->company',(
  IFNULL((SELECT income_gl from mt_charge_group_detail 
  where code=charge_desc),(SELECT gl_receivable_pdc from mt_gl_link where name= (select liner from mt_voyage where voyage=(select voyage from mt_manifest_entry where bl_no='$c->bl_no'))))
  ),'SHIP','INV','$on','0',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$c->bl_no',
  currency,ex_rate,-selling_amount,-selling_base_amount,remarks,
  'SHIP','$c->order_no','$c->sub_ar_date','$c->sub_ar_doc_base',
  '$c->bl_no',
  '$c->sub_ar_code',charge_desc,'$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code',
  '$dev->company','$dev->location' from mt_order_cost 
  where id ='$order_cost_ids' and type='INCOME' 
  and charge_desc='DOF'");
//charge desc DOF

$statement->execute();
    if ($statement->rowCount()){
    $data["gld_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["gld_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

//gl header
//get sum values

$statement = $db->prepare("SELECT sum(selling_amount) samt,sum(selling_base_amount) sbamt from mt_order_cost 
  where id='$order_cost_ids' and charge_desc='DOF'
   and type='INCOME'");
$statement->execute();

$svs=$statement->fetchAll(PDO::FETCH_ASSOC);
$sv=$svs[0];

$base_currency=getBaseCurrency($dev);

$statement = $db->prepare("INSERT into ship_gl_details 
( pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  ip,created_by ,ua,ekey,created_date,temp_code,pre_glt_created,
  location_id,company_id)

  VALUES('$dev->company',(select gl_account from mt_gl_link where name='RECEIVABLE' limit 1),'SHIP','INV','$on',1,
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$c->bl_no',
  '$base_currency',1,:samt,:sbamt,'remarks',
  'SHIP','$c->order_no','$c->sub_ar_date','$c->sub_ar_doc_base',
  '$c->bl_no',
  '$c->sub_ar_code','charge_desc','$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code',now(),
  :company_id,:location_id 
)");

$statement->execute(array(':samt'=>$sv["samt"],':sbamt'=>$sv["sbamt"],
':company_id'=>$dev->company,
':location_id'=>$dev->location));
    if ($statement->rowCount()){
    $data["gld_header_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["gld_header_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

  //ship gl ends

//4
$temp_code=uniqid($dev->uid);
//$gds=self::get_gl_Link();
$statement = $db->prepare("INSERT into mt_ship_trans
( st_company,st_doc_type,st_doc_number,st_serial,st_doc_base,st_date,st_gl_date,st_dp_date,st_age_date,st_year,st_period,st_carrier,st_vessel,st_voyage,st_port,st_bl,st_bl_type,st_charge,st_other_reference,st_currency,st_exchange,st_foreign,st_local,st_narration,st_status,
  st_posted_on,
  ip,created_by ,ua,ekey,created_date,temp_code,st_detail_1) 

  SELECT '$dev->company','INV','$on','0','SHIP','$c->sub_ar_date',
  '$c->sub_ar_date',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$c->eline',
  '$c->vessel','$c->voyage','$c->pof','$c->bl_no',
  '$c->sub_ar_doc_base',charge_desc,'$c->order_no'
  ,currency,ex_rate,-selling_amount,
  -selling_base_amount,remarks,
  status,now(),
  '$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code','$c->sub_ar_code' from mt_order_cost 
  where id='$order_cost_ids' and charge_desc='DOF'
   and type='INCOME'
");
$statement->execute();
    if ($statement->rowCount()){
    $data["sht_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["sht_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }


}
}
//end of if conditions


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

//end of auto invoice do
public static function save_invoice_entry($dev,$code)
{
$data=array();

try
{
$db = Factory::getConnection();
$db->beginTransaction();

$temp_code=uniqid($dev->uid);

$c=$code->inv;


//FETCH USER RIGHTS
$view_type="";
$location_id="";
$addl_location_id="";

$statement = $db->prepare(" SELECT view_type,location,company FROM user_master 
WHERE username=:username ");
$statement->execute(array(':username'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$view_type=$op[0]["view_type"];
$location=$op[0]["location"];
$company=$op[0]["company"];


//START GST CALC
//Get gstin detail
$statement = $db->prepare("SELECT pan, gstin 
  from mt_business_partner    
  where code=:sub_ar_code ");
$statement->execute(array(':sub_ar_code'=>$c->sub_ar_code ));
$data["cngList"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$r=$data["cngList"][0];  
$consignee_pan_no=$r["pan"];
$billparty_gstin=$r["gstin"];

//check state
$startString=getGSTINStartString($dev);

$len = strlen($startString);
$cgst=0;
$sgst=0;
$igst=0;

//taxable
/*
$statement = $db->prepare("SELECT sum(sub_ard_foreign_amount) taxable from mt_ship_ar_details 
where sub_ard_doc_number=:sub_ard_doc_number 
and charge_desc!='OFRT' ");
$statement->execute(array(':sub_ard_doc_number'=>$c->sub_ar_doc_number));
$taxds=$statement->fetchAll(PDO::FETCH_ASSOC);
$rate=$taxds[0]["taxable"];
$data["taxds"]=$taxds;
*/

$rate_total=0;
$cds=$code->cd;
for($i=0;$i<count($cds);$i++)
  {
    $cd=$cds[$i];
    //$cd->charge_desc!='OFRT'
    if(self::excludeCharges($cd->charge_desc)==0)
    {
    $rate_total=$rate_total+$cd->total_amt;
    }
  }
$rate=$rate_total;

//$rate=$c->total_local_amt;
#gst perc
$gst_percent=(float)$c->gst_percent;
$is_igst=0;
$data["rate_total"]=$rate;
$is_cs_gst=0;
//$state_cond=(substr($billparty_gstin, 0, $len) === $startString);
if($gst_percent!=0){

  if(substr($billparty_gstin, 0, $len)==$startString)
  {
      $tp=$gst_percent/2;
      $tv=($rate*$tp)/100;
      $cgst=round($tv,2);
      $sgst=round($tv,2);
      $data["cgst_amt"]=$cgst;
      $data["sgst_amt"]=$sgst;
      $is_cs_gst=1;

  }else{
      $igst=round(($rate*$gst_percent)/100,2);
      $is_igst=1;
      $data["igst_amt"]=$igst;
  }
}
//END GST CALC

$statement = $db->prepare("INSERT into mt_ship_ar_header(sub_ar_company,
  sub_ar_doc_type,sub_ar_doc_number,sub_ar_doc_base,sub_ar_gl_date,sub_ar_due_date,sub_ar_age_date,sub_ar_date,sub_ar_other_reference,sub_ar_currency,sub_ar_ex_rate,sub_place_off_supply,sub_place_off_supply_date,sub_ar_narration,sub_ar_notes,sub_ar_code,
  sub_ar_group,
  sub_ar_status, 
  sub_ar_other_reference_date,
  ip,created_by ,ua,ekey,created_date,temp_code,total_local_amt,order_no,
  bl_no,sub_ar_user,sub_ar_f_amount,sub_ar_l_amount,
  company_id,location_id,gst_percent,igst,cgst,sgst) 
values(:company_id,:sub_ar_doc_type,:sub_ar_doc_number,:sub_ar_doc_base,:sub_ar_gl_date,:sub_ar_due_date,:sub_ar_age_date,:sub_ar_date,:sub_ar_other_reference,:sub_ar_currency,:sub_ar_ex_rate,:sub_place_off_supply,:sub_place_off_supply_date,:sub_ar_narration,:sub_ar_notes,:sub_ar_code,
(select gl_account from mt_gl_link where name='RECEIVABLE' limit 1),
:sub_ar_status,
:sub_ar_other_reference_date,
:ip ,:created_by ,
:ua ,:ekey,now(),:temp_code,:total_local_amt,:order_no,
  :bl_no,:sub_ar_user,:total_local_amt,:total_local_amt,
:company_id,:location_id,:gst_percent,:igst,:cgst,:sgst)");

if($c->sub_ar_due_date=="")
{
  $c->sub_ar_due_date=null;
}

if($c->sub_ar_other_reference_date=="")
{
  $c->sub_ar_other_reference_date=null;
}

if($c->sub_ar_ex_rate=="")
{
  $c->sub_ar_ex_rate=null;
}

$code->order_no=substr_replace($code->order_no,"", -1);
$code->bl_no=substr_replace($code->bl_no,"", -1);

$code->vessel=substr_replace($code->vessel,"", -1);
$code->voyage=substr_replace($code->voyage,"", -1);
$code->port=substr_replace($code->port,"", -1);
$code->liner=substr_replace($code->liner,"", -1);


//get unique values
$code->vessel=self::getUniqueString($code->vessel);
$code->voyage=self::getUniqueString($code->voyage);
$code->port=self::getUniqueString($code->port);
$code->liner=self::getUniqueString($code->liner);

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company_id'=>$dev->company,
':sub_ar_doc_type'=>$c->sub_ar_doc_type,
':sub_ar_doc_number'=>$c->sub_ar_doc_number,
':sub_ar_doc_base'=>$c->sub_ar_doc_base,
':sub_ar_gl_date'=>$c->sub_ar_gl_date,
':sub_ar_due_date'=>$c->sub_ar_due_date,
':sub_ar_age_date'=>$c->sub_ar_date,
':sub_ar_date'=>$c->sub_ar_date,
':sub_ar_other_reference'=>$c->sub_ar_other_reference,
':sub_ar_currency'=>$c->sub_ar_currency,
':sub_ar_ex_rate'=>$c->sub_ar_ex_rate,
':sub_place_off_supply'=>$c->sub_place_off_supply,
':sub_place_off_supply_date'=>$c->sub_place_off_supply_date,
':sub_ar_narration'=>$c->sub_ar_narration,
':sub_ar_notes'=>$c->sub_ar_notes,
':sub_ar_code'=>$c->sub_ar_code,
':sub_ar_status'=>'P', // means POSTED
':sub_ar_other_reference_date'=>$c->sub_ar_other_reference_date,

':temp_code'=>$temp_code,
':total_local_amt'=>$c->total_local_amt,
':order_no'=>$code->order_no,
':bl_no'=>$code->bl_no,
':sub_ar_user'=>$dev->username,

':gst_percent'=>$gst_percent,
':igst'=>$igst,
':cgst'=>$cgst,
':sgst'=>$sgst,

':company_id'=>$dev->company,
':location_id'=>$dev->location
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";

} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}

$data["temp_code"]=$temp_code;
//generate doc number
$on=gen_no_for_invoice($db,$dev,$code->order_no);

  $statement = $db->prepare("SELECT id from mt_ship_ar_header where created_by=:created_by and temp_code=:temp_code");
  $statement->execute(array(':temp_code'=>$temp_code,
    ':created_by'=>$dev->username));
  $op=$statement->fetchAll(PDO::FETCH_ASSOC);

  $data["id"]=$op;

  $statement = $db->prepare("UPDATE mt_ship_ar_header 
  SET sub_ar_doc_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["invid_status"]=1;
  } else{
    $data["invid_status"]=0;
  }

$data["doc_no"]=$on;

$fy=self::getFinancialYear();
$fp=self::getFinancialPeriod($c->sub_ar_date);
//doc number ends

//MT_AR_TRANS table
//FINANCIAL YEAR AND PERIOD IS PENDING
$statement = $db->prepare("INSERT into mt_ar_trans (
  art_company,art_code,art_type,art_number,art_serial,art_group,art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,ip,created_by ,ua,ekey,created_date,
  company_id,location_id) 

SELECT sub_ar_company,
sub_ar_code,
sub_ar_doc_type,
sub_ar_doc_number,
sub_ar_internal_number,
sub_ar_group,
sub_ar_doc_base,
sub_ar_internal_number,
sub_ar_other_reference,
sub_ar_date,
sub_ar_gl_date,
'$fy',
'$fp',
sub_ar_age_date,
sub_ar_due_date,
sub_ar_currency,
sub_ar_ex_rate,
sub_ar_f_amount,
sub_ar_l_amount,
sub_ar_f_amount,
sub_ar_l_amount,
'A',
sub_ar_narration,
sub_ar_notes,
sub_place_off_supply,
sub_place_off_supply_date,
sub_ar_other_reference_date,
now(),
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$dev->company','$dev->location'  
FROM mt_ship_ar_header WHERE temp_code=:temp_code");

$statement->execute(array(':temp_code'=>$temp_code));

if ($statement->rowCount()){
  $data["ar_trans_status"]=1;
} else{
  $data["ar_trans_status"]=0;
}


//TAX STARTS

//OUTPUT CGST - 2-30-001-0012
      if($cgst!=0){
        $statement = $db->prepare("INSERT into mt_ar_trans (
          art_company,art_code,art_type,art_number,art_serial,art_group,
          art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,
          art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,
          art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,
          art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,
          ip,created_by ,ua,ekey,created_date,
          company_id,location_id) 
        values 
        ('$dev->company',:art_code,'OUTPUT CGST',:art_number,'1',:art_group,
        'OUTPUT CGST', '0', '', now(), now(),'$fy',
        '$fp', now(),now(), 'INR','1',:art_foreign_amount, 
        :art_local_amount,:art_foreign_balance,:art_local_balance,'A',
        :art_description,'','','','', now(),
        '$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey', now(),
        '$dev->company','$dev->location') ");

        $statement->execute(array(':art_code'=>$c->sub_ar_code, 
          ':art_number'=>$on, 
          ':art_group'=>'2-30-001-0012', 
          ':art_foreign_amount'=>$cgst, 
          ':art_local_amount'=>$cgst, 
          ':art_foreign_balance'=>$cgst, 
          ':art_local_balance'=>$cgst, 
          ':art_description'=>'OUTPUT CGST '.$gst_percent.'%' ));

        if ($statement->rowCount()){
          $data["cgst_status"]=1;
        } else{
          $data["cgst_status"]=0;
        }
    }
    //OUTPUT SGST - 2-30-001-0016
      if($sgst!=0){
        $statement = $db->prepare("INSERT into mt_ar_trans (
          art_company,art_code,art_type,art_number,art_serial,art_group,
          art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,
          art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,
          art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,
          art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,
          ip,created_by ,ua,ekey,created_date,
          company_id,location_id) 
        values 
        ('$dev->company',:art_code,'OUTPUT SGST',:art_number,'1',:art_group,
        'OUTPUT SGST', '0', '', now(), now(),'$fy',
        '$fp', now(),now(), 'INR','1',:art_foreign_amount, 
        :art_local_amount,:art_foreign_balance,:art_local_balance,'A',
        :art_description,'','','','', now(),
        '$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey', now(),
        '$dev->company','$dev->location') ");

        $statement->execute(array(':art_code'=>$c->sub_ar_code, 
          ':art_number'=>$on, 
          ':art_group'=>'2-30-001-0016', 
          ':art_foreign_amount'=>$sgst, 
          ':art_local_amount'=>$sgst, 
          ':art_foreign_balance'=>$sgst, 
          ':art_local_balance'=>$sgst, 
          ':art_description'=>'OUTPUT SGST '.$gst_percent.'%' ));

        if ($statement->rowCount()){
          $data["sgst_status"]=1;
        } else{
          $data["sgst_status"]=0;
        }
    }
    //OUTPUT IGST - 2-30-001-0015
      if($igst!=0){
        $statement = $db->prepare("INSERT into mt_ar_trans (
          art_company,art_code,art_type,art_number,art_serial,art_group,
          art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,
          art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,
          art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,
          art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,
          ip,created_by ,ua,ekey,created_date,
          company_id,location_id) 
        values 
        ('$dev->company',:art_code,'OUTPUT IGST',:art_number,'1',:art_group,
        'OUTPUT IGST', '0', '', now(), now(),'$fy',
        '$fp', now(),now(), 'INR','1',:art_foreign_amount, 
        :art_local_amount,:art_foreign_balance,:art_local_balance,'A',
        :art_description,'','','','', now(),
        '$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey', now(),
        '$dev->company','$dev->location') ");

        $statement->execute(array(':art_code'=>$c->sub_ar_code, 
          ':art_number'=>$on, 
          ':art_group'=>'2-30-001-0015', 
          ':art_foreign_amount'=>$igst, 
          ':art_local_amount'=>$igst, 
          ':art_foreign_balance'=>$igst, 
          ':art_local_balance'=>$igst, 
          ':art_description'=>'OUTPUT IGST '.$gst_percent.'%' ));

        if ($statement->rowCount()){
          $data["igst_status"]=1;
        } else{
          $data["igst_status"]=0;
        }
    }

//TAX ENDS

//trans balance


// query 6
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_ar_trans_balance
(ardm_company,ardm_code,ardm_doc_type,ardm_doc_number,
  ardm_serial,ardm_other_reference,ardm_date,ardm_currency,
  ardm_ex_rate,ardm_of_amount,ardm_ol_amount,
  ardm_bf_amount,ardm_bl_amount,
  ardm_pf_amount,ardm_pl_amount,ardm_status,
ip,created_by,ua,ekey,created_date,temp_code,company_id,location_id)

SELECT art_company,art_code,art_type,art_number,
art_serial,art_other_reference,art_gl_date,art_currency,
art_ex_rate,art_foreign_amount,art_local_amount,
art_foreign_balance,art_local_balance,
0,0,'PENDING',
ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location' 
 from mt_ar_trans where art_number=:doc_no
");

$statement->execute(array(':doc_no'=>$on));
//var_dump($statement->debugDumpParams());
if ($statement->rowCount()){
  $data["tb_status"]=1;
} else{
  $data["tb_status"]=0;
}

//trans balance ends
$order_id=0;
$order_details_insert_count=0;
$order_cost_update_count=0;

if($data["status"]==1)
{
  $cds=$code->cd;
  $ocds=$code->ocd;

  $q="INSERT into mt_ship_ar_details(
      sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,sub_ard_currency,sub_ard_ex_rate,sub_ard_foreign_amount,sub_ard_local_amount,sub_ard_narration,sub_ard_notes,sub_ard_detail_1,sub_ard_detail_2,sub_ard_detail_3,sub_ard_detail_4,sub_ard_detail_5,sub_ard_detail_6,sub_ard_basis,sub_ard_rate,sub_ard_quantity,ip,created_by ,ua,ekey,created_date,charge_desc,basis_type,taxable,total_tax_amt,total_amt,inv_status,sub_ard_detail_7,sub_ard_detail_8,sub_ard_detail_9,sub_ard_detail_10,charge_id) 
      VALUES(:sub_ard_company,:sub_ard_doc_type,:sub_ard_doc_number,:sub_ard_serial,:sub_ard_currency,:sub_ard_ex_rate,:sub_ard_foreign_amount,:sub_ard_local_amount,:sub_ard_narration,:sub_ard_notes,:sub_ard_detail_1,:sub_ard_detail_2,:sub_ard_detail_3,:sub_ard_detail_4,:sub_ard_detail_5,:sub_ard_detail_6,:sub_ard_basis,:sub_ard_rate,:sub_ard_quantity,:ip ,:created_by ,
      :ua ,:ekey,now(),:charge_desc,:basis_type,:taxable,:total_tax_amt,:total_amt,:inv_status,'$code->liner',
        '$code->vessel','$code->voyage','$code->port',:charge_id)";
      $charge_query="UPDATE mt_order_cost set invoiced=1,
      inv_pay_no=:doc_no,modified_by=:modified_by,modified_date=now() where id=:id";
      $i=0;
      $c->sub_ar_doc_number = $on;
      $order_ids=array();
      $order_cost_ids='';

  for(;$i<count($cds);$i++)
  {
    $cd=$cds[$i];
    $order_cost_ids=$order_cost_ids."'".$cd->id."',";
    array_push($order_ids,$cd->order_id);

    $statement = $db->prepare($q);
    $ar=self::setChargeDetails('MANIFEST',$cd,$dev,$c,$i);
    $statement->execute($ar);

    if ($statement->rowCount())
        {
          $order_details_insert_count+=1;
        }

    $statement = $db->prepare($charge_query);
    $statement->execute(array(':id'=>$cd->id,':doc_no'=>$on,
      ':modified_by'=>$dev->username));

      if ($statement->rowCount()){
          $order_cost_update_count+=1;
        }

 
  }


  $order_ids_unique=array_unique($order_ids);
  $order_entry_status_count=0;

  for ($i = 0; $i < count($order_ids_unique); $i++) 
  {

     //update order status
    $oq="UPDATE mt_order_entry set modified_date=now(),modified_by=:modified_by, status=(SELECT CASE WHEN (SELECT count(*) FROM `mt_order_cost` WHERE invoiced is null and order_id=:id and type='INCOME')=0 THEN 'INVOICED'
      ELSE 'PART INVOICED'
          END) WHERE id=:id";

        $statement = $db->prepare($oq);
        $statement->execute(array(':id'=>$order_ids_unique[$i],
          ':modified_by'=>$dev->username));

          if ($statement->rowCount()){
            $data["order_entry_status"]=1;
            $order_entry_status_count+=1;
          }else{
            $data["order_entry_status"]=0;
          }

  }

  for($j=0;$j<count($ocds);$j++)
  {
    $ocd=$ocds[$j];
    $statement = $db->prepare($q);
    $ar=self::setChargeDetails('ADDITIONAL',$ocd,$dev,$c,$i+$j);
    $statement->execute($ar);

  }

$order_cost_ids=substr_replace($order_cost_ids,"",-1);

  //ship gl details
$temp_code=uniqid($dev->uid);

$multiple_order_no='';
$sa=explode(',', $code->order_no);
$strLength=count($sa);
for ($i = 0; $i < $strLength; $i++) {

  if($i+1==$strLength)
  {
    $multiple_order_no=$multiple_order_no."'$sa[$i]'";
  }else{
    $multiple_order_no=$multiple_order_no."'$sa[$i]',";
  }

}

$statement = $db->prepare("INSERT into ship_gl_details 
( pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  ip,created_by ,ua,ekey,created_date,temp_code, 
  location_id,company_id)


  SELECT '$dev->company',(
  IFNULL((SELECT income_gl from mt_charge_group_detail 
  where code=charge_desc),(SELECT gl_receivable_pdc from mt_gl_link where name= (select liner from mt_voyage where voyage=(select voyage from mt_manifest_entry where bl_no='$code->bl_no'))))
  ),'SHIP','INV','$on','0',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$code->bl_no',
  currency,ex_rate,-selling_amount,-selling_base_amount,remarks,
  'SHIP','$code->order_no','$c->sub_ar_date','$c->sub_ar_doc_base',
  '$code->bl_no',
  '$c->sub_ar_code',charge_desc,'$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code',
  '$dev->company','$dev->location' from mt_order_cost 
  where id in($order_cost_ids) and order_id in (SELECT id from mt_order_entry 
  where order_no in($multiple_order_no)) and type='INCOME' 
  ");


$statement->execute();
    if ($statement->rowCount()){
    $data["gld_status"]=1;
  } else{
    $data["gld_status"]=0;
  }

//Add TAX+GST entries to GL detail table
  $statement = $db->prepare("INSERT into ship_gl_details 
  ( pre_glt_company, pre_glt_code,
  pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_serial,
  pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,
  pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,
  pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,
  pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  ip,created_by ,ua,ekey,created_date,temp_code,pre_glt_created,
  location_id,company_id)

  SELECT art_company,art_group,
  art_type,art_base_type,
  art_number, art_serial,
  art_gl_date,art_gl_date,'$fy','$fp',
  art_other_reference,art_currency,art_ex_rate,
  art_foreign_amount,art_local_amount,art_description,
  'ORDER','$code->order_no','$code->bl_no','$c->sub_ar_date',
  '$c->sub_ar_code',art_group,art_description,
  ip,created_by,ua,ekey,now(),'$temp_code',now(),
  '$dev->company','$dev->location'    
   from mt_ar_trans where art_number=:doc_no and art_type in ('IMP-INV','EXP-INV','OUTPUT IGST','OUTPUT SGST','OUTPUT CGST') ");

  $statement->execute(array(':doc_no'=>$on));
      if ($statement->rowCount()){
      $data["gld_header_status"]=1;
    } else{
      $data["gld_header_status"]=0;
    }
  //ship gl ends

//4
$temp_code=uniqid($dev->uid);
//$gds=self::get_gl_Link();
$statement = $db->prepare("INSERT into mt_ship_trans
( st_company,st_doc_type,st_doc_number,st_serial,st_doc_base,st_date,st_gl_date,st_dp_date,st_age_date,st_year,st_period,st_carrier,st_vessel,st_voyage,st_port,st_bl,st_bl_type,st_charge,st_other_reference,st_currency,st_exchange,st_foreign,st_local,st_narration,st_status,
  st_posted_on,
  ip,created_by ,ua,ekey,created_date,temp_code,st_detail_1) 

  SELECT '$dev->company','INV','$on','0','SHIP','$c->sub_ar_date',
  '$c->sub_ar_date',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$code->liner',
  '$code->vessel','$code->voyage','$code->port','$code->bl_no',
  '$c->sub_ar_doc_base',charge_desc,'$code->order_no'
  ,currency,ex_rate,-selling_amount,
  -selling_base_amount,remarks,
  status,now(),
  '$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code','$c->sub_ar_code' from mt_order_cost 
  where id in($order_cost_ids) and 
  order_id in (SELECT id from mt_order_entry 
  where order_no in($multiple_order_no)) and type='INCOME'
");
$statement->execute();
    if ($statement->rowCount()){
    $data["sht_status"]=1;
  } else{
    $data["sht_status"]=0;
  }


}

$gst_status=0;




if($igst!=0)
{
  $gst_status=$data["igst_status"];
}else if($igst==0 && $is_igst==1) //count($cds)==1 && $cds[0]->charge_desc=='OFRT'
{
  $gst_status=1;
}else
{
  if($cgst==0 && $sgst==0)
  {
    $gst_status=1;
  }
  else if($data["cgst_status"]==1 && $data["sgst_status"]==1)
  {
    $gst_status=1;
  }else{
    $gst_status=0;
  }
}
//$data["status"]=0;
if($data["invid_status"]==1 && $data["status"]==1 && count($cds)==$order_details_insert_count && count($cds)==$order_cost_update_count && $data["ar_trans_status"]==1 && $data["tb_status"]==1 && count($order_ids_unique)==$order_entry_status_count && $data["gld_status"]==1 && $data["gld_header_status"]==1 && $data["sht_status"]==1 && $gst_status==1  )
{
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_invoice_entry_vat($dev,$code)
{
$data=array();

try
{
$db = Factory::getConnection();
$db->beginTransaction();
$temp_code=uniqid($dev->uid);


$c=$code->inv;
//$data["doc_type"]=$c->sub_ar_doc_type;

if($c->sub_ar_doc_type=="PRO-INV")
{

$vat_amt=0;
$vat_percent=$c->gst_percent;
$cds=$code->cd;

for($i=0;$i<count($cds);$i++)
{
  //$cd=$cds[$i];
  //$vat_amt+=round($cd->selling_amount*$vat_percent/100,2);
  //$vat_percent=$cd->vat_percent;

  $cd=$cds[$i];
  if(self::excludeCharges($cd->charge_desc)==0)
    {
      $vat_amt+=round($cd->total_amt*$vat_percent/100,2);
      //$vat_percent=$cd->vat_percent;
    }
}

//get bl no from performa
$statement = $db->prepare("SELECT bl_no FROM mt_ship_ar_header 
  where sub_ar_doc_number=:sub_ar_doc_number");
$statement->execute(array(':sub_ar_doc_number'=>$c->sub_ar_doc_number));
$op11s=$statement->fetchAll(PDO::FETCH_ASSOC);
$code->bl_no=explode(",",$op11s[0]["bl_no"])[0];
//split by comma
//get vessel voyage info
$statement = $db->prepare("SELECT vessel,voyage,port,liner 
  FROM mt_voyage WHERE voyage=
  (SELECT voyage FROM mt_manifest_entry 
  WHERE bl_no=:bl_no)");
$statement->execute(array(':bl_no'=>$code->bl_no));
$op11s=$statement->fetchAll(PDO::FETCH_ASSOC);
if(count($op11s)>=1)
{
$op11=$op11s[0];
$code->voyage=$op11["voyage"];
$code->vessel=$op11["vessel"];
$code->liner=$op11["liner"];
$code->port=$op11["port"];
}

//list($first) = explode("/", $c->sub_ar_doc_number);
//$no=str_replace($first,$c->sub_ar_doc_type,$c->sub_ar_doc_number);

$order_no=$code->order_no;

  $statement = $db->prepare("INSERT into bl_dxb_invno_autogen (temp_code,order_no,container_no,created_by,created_date) 
  values(:temp_code,:order_no,'$dev->location','$dev->username',now())");

  $data["temp_code"]=$temp_code;

  $statement->execute(array(':temp_code'=>$temp_code,':order_no'=>$order_no));

      if ($statement->rowCount()){
      $data["autogen_inv_status"]=1;
    } else{
      $data["autogen_inv_status"]=0;
    }

   $statement = $db->prepare("SELECT COUNT(*)+11 rid from bl_dxb_invno_autogen 
      where id <(SELECT id from bl_dxb_invno_autogen 
        where temp_code=:temp_code and created_by=:created_by)");
    
    $statement->execute(array(':temp_code'=>$temp_code,
        ':created_by'=>$dev->username));
       $row_ids=$statement->fetchAll(PDO::FETCH_ASSOC);
        $row_id=$row_ids[0]["rid"];

    $fid=self::setFourDigit($row_id);

  //LVRS/INV/DXB/22/NUM
  $no="LVRS/INV/DXB/".date("y")."/".$fid; 

$statement = $db->prepare("UPDATE mt_ship_ar_header 
  set sub_ar_doc_type=:sub_ar_doc_type,
   sub_ar_doc_number=:sub_ar_doc_number,
  modified_by=:modified_by,modified_date=now() where id=:id");
$statement->execute(array(
':modified_by'=>$dev->username,
':id'=>$c->id,
':sub_ar_doc_type'=>$c->sub_ar_doc_type,
':sub_ar_doc_number'=>$no
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}
$data["doc_no"]=$no;


//addition entry
$fy=self::getFinancialYear();
$fp=self::getFinancialPeriod($c->sub_ar_date);

$on=$no;

//TAX STARTS

//OUTPUT VAT - 2-30-001-0020
      if($vat_amt!=0){
        $statement = $db->prepare("INSERT into mt_ar_trans (
          art_company,art_code,art_type,art_number,art_serial,art_group,
          art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,
          art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,
          art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,
          art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,
          ip,created_by ,ua,ekey,created_date,
          company_id,location_id) 
        values 
        ('$dev->company',:art_code,'OUTPUT VAT',:art_number,'1',:art_group,
        'OUTPUT VAT', '0', '', now(), now(),'$fy',
        '$fp', now(),now(), 'AED','1',:art_foreign_amount, 
        :art_local_amount,:art_foreign_balance,:art_local_balance,'A',
        :art_description,'','','','', now(),
        '$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey', now(),
        '$dev->company','$dev->location') ");

        $statement->execute(array(':art_code'=>$c->sub_ar_code, 
          ':art_number'=>$on, 
          ':art_group'=>'2-30-001-0020', 
          ':art_foreign_amount'=>$vat_amt, 
          ':art_local_amount'=>$vat_amt, 
          ':art_foreign_balance'=>$vat_amt, 
          ':art_local_balance'=>$vat_amt, 
          ':art_description'=>'OUTPUT VAT '.$vat_percent.'%' ));

        if ($statement->rowCount()){
          $data["vat_status"]=1;
        } else{
          $data["vat_status"]=0;
        }
    }

//TAX ENDS

//MT_AR_TRANS table
//FINANCIAL YEAR AND PERIOD IS PENDING
$statement = $db->prepare("INSERT into mt_ar_trans (
  art_company,art_code,art_type,art_number,art_serial,art_group,art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,ip,created_by ,ua,ekey,created_date,
  company_id,location_id) 

SELECT sub_ar_company,
sub_ar_code,
sub_ar_doc_type,
sub_ar_doc_number,
sub_ar_internal_number,
sub_ar_group,
sub_ar_doc_base,
sub_ar_internal_number,
sub_ar_other_reference,
sub_ar_date,
sub_ar_gl_date,
'$fy',
'$fp',
sub_ar_age_date,
sub_ar_due_date,
sub_ar_currency,
sub_ar_ex_rate,
sub_ar_f_amount,
sub_ar_l_amount,
sub_ar_f_amount,
sub_ar_l_amount,
'A',
sub_ar_narration,
sub_ar_notes,
sub_place_off_supply,
sub_place_off_supply_date,
sub_ar_other_reference_date,
now(),
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$dev->company','$dev->location' 
FROM mt_ship_ar_header WHERE sub_ar_doc_number=:temp_code");

$statement->execute(array(':temp_code'=>$no));

if ($statement->rowCount()){
  $data["ar_trans_status"]=1;
} else{
  $data["ar_trans_status"]=0;
}

//trans balance query

//query 5

$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_ar_trans_balance
(ardm_company,ardm_code,ardm_doc_type,ardm_doc_number,
  ardm_serial,ardm_other_reference,ardm_date,ardm_currency,
  ardm_ex_rate,ardm_of_amount,ardm_ol_amount,
  ardm_bf_amount,ardm_bl_amount,
  ardm_pf_amount,ardm_pl_amount,ardm_status,
ip,created_by,ua,ekey,created_date,temp_code,company_id,location_id)

SELECT art_company,art_code,art_type,art_number,
art_serial,art_other_reference,art_gl_date,art_currency,
art_ex_rate,art_foreign_amount,art_local_amount,
art_foreign_balance,art_local_balance,
0,0,'PENDING',
ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location'  
 from mt_ar_trans where art_number=:doc_no
");

$statement->execute(array(':doc_no'=>$no));
//var_dump($statement->debugDumpParams());
if ($statement->rowCount()){
  $data["tb_status"]=1;
} else{
  $data["tb_status"]=0;
}

$order_id=0;

// update order cost to invoiced from proforma
$charge_query="UPDATE mt_order_cost set invoiced=1,
inv_pay_no=:doc_no,modified_by=:modified_by,modified_date=now() where proforma=:id";
$statement = $db->prepare($charge_query);
$statement->execute(array(':id'=>$c->sub_ar_doc_number,
':doc_no'=>$no,':modified_by'=>$dev->username));

if ($statement->rowCount()){
  $data["cost_status"]=1;
} else{
  $data["cost_status"]=0;
}

$statement = $db->prepare("SELECT distinct order_id from mt_order_cost where proforma=:proforma");
$statement->execute(array(':proforma'=>$c->sub_ar_doc_number));

$ocs=$statement->fetchAll(PDO::FETCH_ASSOC);
//update order status to part invoiced or invoiced
$ocs_count=0;

for($i=0;$i<count($ocs);$i++)
{
$cd=$ocs[$i];
$oq="UPDATE mt_order_entry set modified_date=now(),modified_by=:modified_by,status=(SELECT CASE WHEN (SELECT count(*) FROM `mt_order_cost` WHERE invoiced is null and type='INCOME' and order_id=:id)=0 THEN 'INVOICED'
    ELSE 'PART INVOICED'
        END)
      WHERE id=:id";

 $statement = $db->prepare($oq);
 $statement->execute(array(':id'=>$cd["order_id"],':modified_by'=>$dev->username));

  if ($statement->rowCount()){
  $data["order_status-".$cd["order_id"]]=1;
  $ocs_count+=1;

} else{
  $data["order_status-".$cd["order_id"]]=0;
}
}

//update cost details to invoiced
 $statement = $db->prepare("UPDATE mt_ship_ar_details set inv_status='INVOICED' where sub_ard_doc_number=:doc_no");
 $statement->execute(array(':doc_no'=>$c->sub_ar_doc_number));

  if ($statement->rowCount()){
  $data["detail_status"]=1;
} else{
  $data["detail_status"]=0;
}

$statement = $db->prepare("UPDATE mt_ship_ar_details  
  set
   sub_ard_doc_number=:sub_ar_doc_number where sub_ard_doc_number=:id");
$statement->execute(array(
':id'=>$c->sub_ar_doc_number,
':sub_ar_doc_number'=>$no
));

if ($statement->rowCount()){
  $data["ar_detail_docno_status"]=1;
} else{
  $data["ar_detail_docno_status"]=0;
}

//ship gl details
$temp_code=uniqid($dev->uid);

$multiple_order_no='';
$code->order_no=substr_replace($code->order_no, "", -1);
$sa=explode(',', $code->order_no);
$strLength=count($sa);
for ($i = 0; $i < $strLength; $i++) {

  if($i+1==$strLength)
  {
    $multiple_order_no=$multiple_order_no."'$sa[$i]'";
  }else{
    $multiple_order_no=$multiple_order_no."'$sa[$i]',";
  }

}
$on=$no;

$statement = $db->prepare("INSERT into ship_gl_details 
( pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  ip,created_by ,ua,ekey,created_date,temp_code,
  location_id,company_id)


  SELECT '$dev->company',(
IFNULL((SELECT income_gl from mt_charge_group_detail 
  where code=charge_desc),(SELECT gl_receivable_pdc from mt_gl_link where name= (select liner from mt_voyage where voyage=(select voyage from mt_manifest_entry where bl_no='$code->bl_no'))))
  ),'SHIP','INV','$on','0',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$code->bl_no',
  currency,ex_rate,-selling_amount,-selling_base_amount,remarks,
  'RCT','$code->order_no','$c->sub_ar_date','$c->sub_ar_doc_base',
  '$code->bl_no',
  '$c->sub_ar_code',charge_desc,'$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code',
  '$dev->company','$dev->location' from mt_order_cost 
  where proforma='$c->sub_ar_doc_number'");


$statement->execute();
    if ($statement->rowCount()){
    $data["gld_status"]=1;
  } else{
    $data["gld_status"]=0;
  }

//Add TAX+GST entries to GL detail table
  $statement = $db->prepare("INSERT into ship_gl_details 
  ( pre_glt_company, pre_glt_code,
  pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_serial,
  pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,
  pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,
  pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,
  pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  ip,created_by ,ua,ekey,created_date,temp_code,pre_glt_created,
  location_id,company_id)

  SELECT art_company,art_group,
  art_type,art_base_type,
  art_number, art_serial,
  art_gl_date,art_gl_date,'$fy','$fp',
  art_other_reference,art_currency,art_ex_rate,
  art_foreign_amount,art_local_amount,art_description,
  'ORDER','$code->order_no','$code->bl_no','$c->sub_ar_date',
  '$c->sub_ar_code',art_group,art_description,
  ip,created_by,ua,ekey,now(),'$temp_code',now(),
  '$dev->company','$dev->location'    
   from mt_ar_trans where art_number=:doc_no and art_type in ('IMP-INV','EXP-INV','OUTPUT VAT') ");

  $statement->execute(array(':doc_no'=>$on));
      if ($statement->rowCount()){
      $data["gld_header_status"]=1;
    } else{
      $data["gld_header_status"]=0;
    }
  //ship gl ends



//4
$temp_code=uniqid($dev->uid);
//$gds=self::get_gl_Link();
$statement = $db->prepare("INSERT into mt_ship_trans
( st_company,st_doc_type,st_doc_number,st_serial,st_doc_base,st_date,st_gl_date,st_dp_date,st_age_date,st_year,st_period,st_carrier,st_vessel,st_voyage,st_port,st_bl,st_bl_type,st_charge,st_other_reference,st_currency,st_exchange,st_foreign,st_local,st_narration,st_status,
  st_posted_on,
  ip,created_by ,ua,ekey,created_date,temp_code) 

  SELECT '$dev->company','INV','$on','0','SHIP','$c->sub_ar_date',
  '$c->sub_ar_date',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$code->liner',
  '$code->vessel','$code->voyage','$code->port','$code->bl_no',
  '$c->sub_ar_doc_base',charge_desc,'$code->order_no'
  ,currency,ex_rate,-selling_amount,
  -selling_base_amount,remarks,
  status,now(),
  '$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code' from mt_order_cost 
  where proforma='$c->sub_ar_doc_number'");
$statement->execute();
    if ($statement->rowCount()){
    $data["sht_status"]=1;
  } else{
    $data["sht_status"]=0;
  }

  //$data["status"]=0;

$vat_status=0;
if($vat_amt!=0)
{
  $vat_status=$data["vat_status"];
}else{
  $vat_status=1;
  $data["vat_amt"]=$vat_amt;
  $data["vat_status"]='NA';
}

if($data["status"]==1  && $data["cost_status"]==1 &&  $data["detail_status"]==1 && $data["ar_detail_docno_status"]==1 && $data["sht_status"]==1 && $data["gld_status"]==1 && $data["gld_header_status"]==1 && $data["ar_trans_status"]==1 && $data["tb_status"]==1 && $vat_status==1)
{
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}
//end of pro inv

}else{
  //updating pro details
  $statement = $db->prepare("UPDATE mt_ship_ar_header  
  set sub_ar_doc_type=:sub_ar_doc_type,
sub_ar_other_reference=:sub_ar_other_reference,
sub_ar_currency=:sub_ar_currency,
sub_ar_ex_rate=:sub_ar_ex_rate,
sub_place_off_supply=:sub_place_off_supply,
sub_ar_narration=:sub_ar_narration,
sub_ar_notes=:sub_ar_notes,
sub_ar_code=:sub_ar_code,
modified_by=:modified_by,modified_date=now(),gst_percent=:gst_percent 
where id=:id");
$statement->execute(array(
':modified_by'=>$dev->username,
':id'=>$c->id,
':sub_ar_doc_type'=>$c->sub_ar_doc_type,

':sub_ar_other_reference'=>$c->sub_ar_other_reference,
':sub_ar_currency'=>$c->sub_ar_currency,
':sub_ar_ex_rate'=>$c->sub_ar_ex_rate,
':sub_place_off_supply'=>$c->sub_place_off_supply,
':sub_ar_narration'=>$c->sub_ar_narration,
':sub_ar_notes'=>$c->sub_ar_notes,
':sub_ar_code'=>$c->sub_ar_code,
':gst_percent'=>$c->gst_percent
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";

}
$data["doc_no"]=$c->sub_ar_doc_number;

//$data["status"]=0;
if($data["status"]==1 )
{
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}

}

//addition entry ends

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
  }
  
  return $data;

}

public static function save_invoice_entry_vat_pro($dev,$code)
{
$data=array();

try
{
$db = Factory::getConnection();
$db->beginTransaction();

$temp_code=uniqid($dev->uid);

$c=$code->inv;


//FETCH USER RIGHTS
$view_type="";
$location_id="";
$addl_location_id="";

$statement = $db->prepare(" SELECT view_type,location,company FROM user_master 
WHERE username=:username ");
$statement->execute(array(':username'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$view_type=$op[0]["view_type"];
$location=$op[0]["location"];
$company=$op[0]["company"];

$vat_amt=0;
$vat_percent=$c->gst_percent;
$cds=$code->cd;

for($i=0;$i<count($cds);$i++)
{
  $cd=$cds[$i];
  if(self::excludeCharges($cd->charge_desc)==0)
    {
      $vat_amt+=round($cd->total_amt*$vat_percent/100,2);
      //$vat_percent=$cd->vat_percent;
    }
  //$vat_amt+=round($cd->selling_amount*$vat_percent/100,2);
  //$vat_percent=$cd->vat_percent;
}

$statement = $db->prepare("INSERT into mt_ship_ar_header(sub_ar_company,
  sub_ar_doc_type,sub_ar_doc_number,sub_ar_doc_base,sub_ar_gl_date,sub_ar_due_date,sub_ar_age_date,sub_ar_date,sub_ar_other_reference,sub_ar_currency,sub_ar_ex_rate,sub_place_off_supply,sub_place_off_supply_date,sub_ar_narration,sub_ar_notes,sub_ar_code,
  sub_ar_group,
  sub_ar_status, 
  sub_ar_other_reference_date,
  ip,created_by ,ua,ekey,created_date,temp_code,total_local_amt,order_no,
  bl_no,sub_ar_user,sub_ar_f_amount,sub_ar_l_amount,
  company_id,location_id,vat_amt,gst_percent) 
values(:company_id,:sub_ar_doc_type,:sub_ar_doc_number,:sub_ar_doc_base,:sub_ar_gl_date,:sub_ar_due_date,:sub_ar_age_date,:sub_ar_date,:sub_ar_other_reference,:sub_ar_currency,:sub_ar_ex_rate,:sub_place_off_supply,:sub_place_off_supply_date,:sub_ar_narration,:sub_ar_notes,:sub_ar_code,
(select gl_account from mt_gl_link where name='RECEIVABLE' limit 1),
:sub_ar_status,
:sub_ar_other_reference_date,
:ip ,:created_by ,
:ua ,:ekey,now(),:temp_code,:total_local_amt,:order_no,
  :bl_no,:sub_ar_user,:total_local_amt,:total_local_amt,
:company_id,:location_id,:vat_amt,:gst_percent)");

if($c->sub_ar_due_date=="")
{
  $c->sub_ar_due_date=null;
}

if($c->sub_ar_other_reference_date=="")
{
  $c->sub_ar_other_reference_date=null;
}

if($c->sub_ar_ex_rate=="")
{
  $c->sub_ar_ex_rate=null;
}

$code->order_no=substr_replace($code->order_no,"", -1);
$code->bl_no=substr_replace($code->bl_no,"", -1);

$code->vessel=substr_replace($code->vessel,"", -1);
$code->voyage=substr_replace($code->voyage,"", -1);
$code->port=substr_replace($code->port,"", -1);
$code->liner=substr_replace($code->liner,"", -1);


//get unique values
$code->vessel=self::getUniqueString($code->vessel);
$code->voyage=self::getUniqueString($code->voyage);
$code->port=self::getUniqueString($code->port);
$code->liner=self::getUniqueString($code->liner);

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company_id'=>$dev->company,
':sub_ar_doc_type'=>$c->sub_ar_doc_type,
':sub_ar_doc_number'=>$c->sub_ar_doc_number,
':sub_ar_doc_base'=>$c->sub_ar_doc_base,
':sub_ar_gl_date'=>$c->sub_ar_gl_date,
':sub_ar_due_date'=>$c->sub_ar_due_date,
':sub_ar_age_date'=>$c->sub_ar_date,
':sub_ar_date'=>$c->sub_ar_date,
':sub_ar_other_reference'=>$c->sub_ar_other_reference,
':sub_ar_currency'=>$c->sub_ar_currency,
':sub_ar_ex_rate'=>$c->sub_ar_ex_rate,
':sub_place_off_supply'=>$c->sub_place_off_supply,
':sub_place_off_supply_date'=>$c->sub_place_off_supply_date,
':sub_ar_narration'=>$c->sub_ar_narration,
':sub_ar_notes'=>$c->sub_ar_notes,
':sub_ar_code'=>$c->sub_ar_code,
':sub_ar_status'=>'P', // means POSTED
':sub_ar_other_reference_date'=>$c->sub_ar_other_reference_date,

':temp_code'=>$temp_code,
':total_local_amt'=>$c->total_local_amt,
':order_no'=>$code->order_no,
':bl_no'=>$code->bl_no,
':sub_ar_user'=>$dev->username,

':vat_amt'=>$vat_amt,
':gst_percent'=>$c->gst_percent,

':company_id'=>$dev->company,
':location_id'=>$dev->location
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";

} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}

  //generate doc number
  $order_no=$code->order_no;

  $statement = $db->prepare("INSERT into bl_dxb_invno_autogen_pro (temp_code,order_no,container_no,created_by,created_date) 
  values(:temp_code,:order_no,'$dev->location','$dev->username',now())");

  $data["temp_code"]=$temp_code;

  $statement->execute(array(':temp_code'=>$temp_code,':order_no'=>$order_no));

      if ($statement->rowCount()){
      $data["autogen_inv_status"]=1;
    } else{
      $data["autogen_inv_status"]=0;
    }

   $statement = $db->prepare("SELECT COUNT(*)+1 rid from bl_dxb_invno_autogen_pro 
      where id <(SELECT id from bl_dxb_invno_autogen_pro 
        where temp_code=:temp_code and created_by=:created_by)");
    
    $statement->execute(array(':temp_code'=>$temp_code,
        ':created_by'=>$dev->username));
       $row_ids=$statement->fetchAll(PDO::FETCH_ASSOC);
        $row_id=$row_ids[0]["rid"];

    $fid=self::setFourDigit($row_id);
    
  //PRO/LVRS/INV/DXB/22/NUM
  $on="PRO/LVRS/INV/DXB/".date("y")."/".$fid; 


  $statement = $db->prepare("SELECT id from mt_ship_ar_header where created_by=:created_by and temp_code=:temp_code");
  $statement->execute(array(':temp_code'=>$temp_code,
    ':created_by'=>$dev->username));
  $op=$statement->fetchAll(PDO::FETCH_ASSOC);

  $data["id"]=$op;

  $statement = $db->prepare("UPDATE mt_ship_ar_header 
  SET sub_ar_doc_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["invid_status"]=1;
  } else{
    $data["invid_status"]=0;
  }

$data["doc_no"]=$on;

$fy=self::getFinancialYear();
$fp=self::getFinancialPeriod($c->sub_ar_date);
//doc number ends


$order_id=0;
$order_details_insert_count=0;
$order_cost_update_count=0;

if($data["status"]==1)
{
  $cds=$code->cd;
  $ocds=$code->ocd;

  $q="INSERT into mt_ship_ar_details(
      sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,sub_ard_currency,sub_ard_ex_rate,sub_ard_foreign_amount,sub_ard_local_amount,sub_ard_narration,sub_ard_notes,sub_ard_detail_1,sub_ard_detail_2,sub_ard_detail_3,sub_ard_detail_4,sub_ard_detail_5,sub_ard_detail_6,sub_ard_basis,sub_ard_rate,sub_ard_quantity,ip,created_by ,ua,ekey,created_date,charge_desc,basis_type,taxable,total_tax_amt,total_amt,inv_status,sub_ard_detail_7,sub_ard_detail_8,sub_ard_detail_9,sub_ard_detail_10,charge_id,vat_percent) 
      VALUES(:sub_ard_company,:sub_ard_doc_type,:sub_ard_doc_number,:sub_ard_serial,:sub_ard_currency,:sub_ard_ex_rate,:sub_ard_foreign_amount,:sub_ard_local_amount,:sub_ard_narration,:sub_ard_notes,:sub_ard_detail_1,:sub_ard_detail_2,:sub_ard_detail_3,:sub_ard_detail_4,:sub_ard_detail_5,:sub_ard_detail_6,:sub_ard_basis,:sub_ard_rate,:sub_ard_quantity,:ip ,:created_by ,
      :ua ,:ekey,now(),:charge_desc,:basis_type,:taxable,:total_tax_amt,:total_amt,:inv_status,'$code->liner',
        '$code->vessel','$code->voyage','$code->port',:charge_id,:vat_percent)";
      $charge_query="UPDATE mt_order_cost set invoiced=2,
      proforma=:doc_no,modified_by=:modified_by,modified_date=now() where id=:id";
      $i=0;
      $c->sub_ar_doc_number = $on;
      $order_ids=array();
      $order_cost_ids='';

  for(;$i<count($cds);$i++)
  {
    $cd=$cds[$i];
    $order_cost_ids=$order_cost_ids."'".$cd->id."',";
    array_push($order_ids,$cd->order_id);

    $statement = $db->prepare($q);
    $ar=self::setChargeDetails_vat('MANIFEST',$cd,$dev,$c,$i);
    $ar[':inv_status']='PROFORMA';
    $statement->execute($ar);

    if ($statement->rowCount())
        {
          $order_details_insert_count+=1;
        }

    $statement = $db->prepare($charge_query);
    $statement->execute(array(':id'=>$cd->id,':doc_no'=>$on,
      ':modified_by'=>$dev->username));

      if ($statement->rowCount()){
          $order_cost_update_count+=1;
        }

 }

}


//$data["status"]=0;
if($data["invid_status"]==1 && $data["status"]==1 && count($cds)==$order_details_insert_count && count($cds)==$order_cost_update_count)
{
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save(Not committed). Please try again.";
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
    $data["status"]=0;
    $data["msg"]="Unable to save(Exception occurred). Please try again.";
  }
  
  return $data;
}


public static function save_invoice_entry_sea_vat_pro($dev,$code)
{
$data=array();

try
{
$db = Factory::getConnection();
$db->beginTransaction();

$temp_code=uniqid($dev->uid);

$c=$code->inv;


//FETCH USER RIGHTS
$view_type="";
$location_id="";
$addl_location_id="";

$statement = $db->prepare(" SELECT view_type,location,company FROM user_master 
WHERE username=:username ");
$statement->execute(array(':username'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$view_type=$op[0]["view_type"];
$location=$op[0]["location"];
$company=$op[0]["company"];

$vat_amt=0;
$vat_percent=$c->gst_percent;
$cds=$code->cd;

for($i=0;$i<count($cds);$i++)
{
  $cd=$cds[$i];
  if(self::excludeCharges($cd->charge_desc)==0)
    {
      $vat_amt+=round($cd->total_amt*$vat_percent/100,2);
      //$vat_percent=$cd->vat_percent;
    }
  //$vat_amt+=round($cd->selling_amount*$vat_percent/100,2);
  //$vat_percent=$cd->vat_percent;
}

$statement = $db->prepare("INSERT into mt_order_ar_header(sub_ar_company,
  sub_ar_doc_type,sub_ar_doc_number,sub_ar_doc_base,sub_ar_gl_date,sub_ar_due_date,sub_ar_age_date,sub_ar_date,sub_ar_other_reference,sub_ar_currency,sub_ar_ex_rate,sub_place_off_supply,sub_place_off_supply_date,sub_ar_narration,sub_ar_notes,sub_ar_code,
  sub_ar_group,
  sub_ar_status, 
  sub_ar_other_reference_date,
  ip,created_by ,ua,ekey,created_date,temp_code,total_local_amt,order_no,
  bl_no,sub_ar_user,sub_ar_f_amount,sub_ar_l_amount,
  company_id,location_id,vat_amt,gst_percent) 
values(:company_id,:sub_ar_doc_type,:sub_ar_doc_number,:sub_ar_doc_base,:sub_ar_gl_date,:sub_ar_due_date,:sub_ar_age_date,:sub_ar_date,:sub_ar_other_reference,:sub_ar_currency,:sub_ar_ex_rate,:sub_place_off_supply,:sub_place_off_supply_date,:sub_ar_narration,:sub_ar_notes,:sub_ar_code,
(select gl_account from mt_gl_link where name='RECEIVABLE' limit 1),
:sub_ar_status,
:sub_ar_other_reference_date,
:ip ,:created_by ,
:ua ,:ekey,now(),:temp_code,:total_local_amt,:order_no,
  :bl_no,:sub_ar_user,:total_local_amt,:total_local_amt,
:company_id,:location_id,:vat_amt,:gst_percent)");

if($c->sub_ar_due_date=="")
{
  $c->sub_ar_due_date=null;
}

if($c->sub_ar_other_reference_date=="")
{
  $c->sub_ar_other_reference_date=null;
}

if($c->sub_ar_ex_rate=="")
{
  $c->sub_ar_ex_rate=null;
}

$code->order_no=substr_replace($code->order_no,"", -1);
$code->bl_no=substr_replace($code->bl_no,"", -1);

$code->vessel=substr_replace($code->vessel,"", -1);
$code->voyage=substr_replace($code->voyage,"", -1);
$code->port=substr_replace($code->port,"", -1);
$code->liner=substr_replace($code->liner,"", -1);


//get unique values
$code->vessel=self::getUniqueString($code->vessel);
$code->voyage=self::getUniqueString($code->voyage);
$code->port=self::getUniqueString($code->port);
$code->liner=self::getUniqueString($code->liner);

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company_id'=>$dev->company,
':sub_ar_doc_type'=>$c->sub_ar_doc_type,
':sub_ar_doc_number'=>$c->sub_ar_doc_number,
':sub_ar_doc_base'=>$c->sub_ar_doc_base,
':sub_ar_gl_date'=>$c->sub_ar_gl_date,
':sub_ar_due_date'=>$c->sub_ar_due_date,
':sub_ar_age_date'=>$c->sub_ar_date,
':sub_ar_date'=>$c->sub_ar_date,
':sub_ar_other_reference'=>$c->sub_ar_other_reference,
':sub_ar_currency'=>$c->sub_ar_currency,
':sub_ar_ex_rate'=>$c->sub_ar_ex_rate,
':sub_place_off_supply'=>$c->sub_place_off_supply,
':sub_place_off_supply_date'=>$c->sub_place_off_supply_date,
':sub_ar_narration'=>$c->sub_ar_narration,
':sub_ar_notes'=>$c->sub_ar_notes,
':sub_ar_code'=>$c->sub_ar_code,
':sub_ar_status'=>'P', // means POSTED
':sub_ar_other_reference_date'=>$c->sub_ar_other_reference_date,

':temp_code'=>$temp_code,
':total_local_amt'=>$c->total_local_amt,
':order_no'=>$code->order_no,
':bl_no'=>$code->bl_no,
':sub_ar_user'=>$dev->username,

':vat_amt'=>$vat_amt,
':gst_percent'=>$c->gst_percent,

':company_id'=>$dev->company,
':location_id'=>$dev->location
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";

} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}

  //generate doc number
  $order_no=$code->order_no;

  $statement = $db->prepare("INSERT into bl_dxb_invno_autogen_pro (temp_code,order_no,container_no,created_by,created_date) 
  values(:temp_code,:order_no,'$dev->location','$dev->username',now())");

  $data["temp_code"]=$temp_code;

  $statement->execute(array(':temp_code'=>$temp_code,':order_no'=>$order_no));

      if ($statement->rowCount()){
      $data["autogen_inv_status"]=1;
    } else{
      $data["autogen_inv_status"]=0;
    }

   $statement = $db->prepare("SELECT COUNT(*)+1 rid from bl_dxb_invno_autogen_pro 
      where id <(SELECT id from bl_dxb_invno_autogen_pro 
        where temp_code=:temp_code and created_by=:created_by)");
    
    $statement->execute(array(':temp_code'=>$temp_code,
        ':created_by'=>$dev->username));
       $row_ids=$statement->fetchAll(PDO::FETCH_ASSOC);
        $row_id=$row_ids[0]["rid"];

    $fid=self::setFourDigit($row_id);
    
  //PRO/LVRS/INV/DXB/22/NUM
  $on="PRO/LVRS/INV/DXB/".date("y")."/".$fid; 


  $statement = $db->prepare("SELECT id from mt_order_ar_header where created_by=:created_by and temp_code=:temp_code");
  $statement->execute(array(':temp_code'=>$temp_code,
    ':created_by'=>$dev->username));
  $op=$statement->fetchAll(PDO::FETCH_ASSOC);

  $data["id"]=$op;

  $statement = $db->prepare("UPDATE mt_order_ar_header 
  SET sub_ar_doc_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["invid_status"]=1;
  } else{
    $data["invid_status"]=0;
  }

$data["doc_no"]=$on;

$fy=self::getFinancialYear();
$fp=self::getFinancialPeriod($c->sub_ar_date);
//doc number ends


$order_id=0;
$order_details_insert_count=0;
$order_cost_update_count=0;

if($data["status"]==1)
{
  $cds=$code->cd;
  $ocds=$code->ocd;

  $q="INSERT into mt_order_ar_details(
      sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,sub_ard_currency,sub_ard_ex_rate,sub_ard_foreign_amount,sub_ard_local_amount,sub_ard_narration,sub_ard_notes,sub_ard_detail_1,sub_ard_detail_2,sub_ard_detail_3,sub_ard_detail_4,sub_ard_detail_5,sub_ard_detail_6,sub_ard_basis,sub_ard_rate,sub_ard_quantity,ip,created_by ,ua,ekey,created_date,charge_desc,basis_type,taxable,total_tax_amt,total_amt,inv_status,sub_ard_detail_7,sub_ard_detail_8,sub_ard_detail_9,sub_ard_detail_10,charge_id,vat_percent) 
      VALUES(:sub_ard_company,:sub_ard_doc_type,:sub_ard_doc_number,:sub_ard_serial,:sub_ard_currency,:sub_ard_ex_rate,:sub_ard_foreign_amount,:sub_ard_local_amount,:sub_ard_narration,:sub_ard_notes,:sub_ard_detail_1,:sub_ard_detail_2,:sub_ard_detail_3,:sub_ard_detail_4,:sub_ard_detail_5,:sub_ard_detail_6,:sub_ard_basis,:sub_ard_rate,:sub_ard_quantity,:ip ,:created_by ,
      :ua ,:ekey,now(),:charge_desc,:basis_type,:taxable,:total_tax_amt,:total_amt,:inv_status,'$code->liner',
        '$code->vessel','$code->voyage','$code->port',:charge_id,:vat_percent)";
      $charge_query="UPDATE mt_order_cost set invoiced=2,
      proforma=:doc_no,modified_by=:modified_by,modified_date=now() where id=:id";
      $i=0;
      $c->sub_ar_doc_number = $on;
      $order_ids=array();
      $order_cost_ids='';

  for(;$i<count($cds);$i++)
  {
    $cd=$cds[$i];
    $order_cost_ids=$order_cost_ids."'".$cd->id."',";
    array_push($order_ids,$cd->order_id);

    $statement = $db->prepare($q);
    $ar=self::setChargeDetails_vat('MANIFEST',$cd,$dev,$c,$i);
    $ar[':inv_status']='PROFORMA';
    $statement->execute($ar);

    if ($statement->rowCount())
        {
          $order_details_insert_count+=1;
        }

    $statement = $db->prepare($charge_query);
    $statement->execute(array(':id'=>$cd->id,':doc_no'=>$on,
      ':modified_by'=>$dev->username));

      if ($statement->rowCount()){
          $order_cost_update_count+=1;
        }

 }

}


//$data["status"]=0;
if($data["invid_status"]==1 && $data["status"]==1 && count($cds)==$order_details_insert_count && count($cds)==$order_cost_update_count)
{
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save(Not committed). Please try again.";
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
    $data["status"]=0;
    $data["msg"]="Unable to save(Exception occurred). Please try again.";
  }
  
  return $data;
}


public static function save_invoice_entry_vat($dev,$code)
{
$data=array();

try
{
$db = Factory::getConnection();
$db->beginTransaction();

$temp_code=uniqid($dev->uid);

$c=$code->inv;


//FETCH USER RIGHTS
$view_type="";
$location_id="";
$addl_location_id="";

$statement = $db->prepare(" SELECT view_type,location,company FROM user_master 
WHERE username=:username ");
$statement->execute(array(':username'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$view_type=$op[0]["view_type"];
$location=$op[0]["location"];
$company=$op[0]["company"];

$vat_amt=0;
$vat_percent=$c->gst_percent;
$cds=$code->cd;

for($i=0;$i<count($cds);$i++)
{
  $cd=$cds[$i];
  if(self::excludeCharges($cd->charge_desc)==0)
    {
      $vat_amt+=round($cd->total_amt*$vat_percent/100,2);
      //$vat_percent=$cd->vat_percent;
    }

}

$statement = $db->prepare("INSERT into mt_ship_ar_header(sub_ar_company,
  sub_ar_doc_type,sub_ar_doc_number,sub_ar_doc_base,sub_ar_gl_date,sub_ar_due_date,sub_ar_age_date,sub_ar_date,sub_ar_other_reference,sub_ar_currency,sub_ar_ex_rate,sub_place_off_supply,sub_place_off_supply_date,sub_ar_narration,sub_ar_notes,sub_ar_code,
  sub_ar_group,
  sub_ar_status, 
  sub_ar_other_reference_date,
  ip,created_by ,ua,ekey,created_date,temp_code,total_local_amt,order_no,
  bl_no,sub_ar_user,sub_ar_f_amount,sub_ar_l_amount,
  company_id,location_id,vat_amt,gst_percent) 
values(:company_id,:sub_ar_doc_type,:sub_ar_doc_number,:sub_ar_doc_base,:sub_ar_gl_date,:sub_ar_due_date,:sub_ar_age_date,:sub_ar_date,:sub_ar_other_reference,:sub_ar_currency,:sub_ar_ex_rate,:sub_place_off_supply,:sub_place_off_supply_date,:sub_ar_narration,:sub_ar_notes,:sub_ar_code,
(select gl_account from mt_gl_link where name='RECEIVABLE' limit 1),
:sub_ar_status,
:sub_ar_other_reference_date,
:ip ,:created_by ,
:ua ,:ekey,now(),:temp_code,:total_local_amt,:order_no,
  :bl_no,:sub_ar_user,:total_local_amt,:total_local_amt,
:company_id,:location_id,:vat_amt,:gst_percent)");

if($c->sub_ar_due_date=="")
{
  $c->sub_ar_due_date=null;
}

if($c->sub_ar_other_reference_date=="")
{
  $c->sub_ar_other_reference_date=null;
}

if($c->sub_ar_ex_rate=="")
{
  $c->sub_ar_ex_rate=null;
}

$code->order_no=substr_replace($code->order_no,"", -1);
$code->bl_no=substr_replace($code->bl_no,"", -1);

$code->vessel=substr_replace($code->vessel,"", -1);
$code->voyage=substr_replace($code->voyage,"", -1);
$code->port=substr_replace($code->port,"", -1);
$code->liner=substr_replace($code->liner,"", -1);


//get unique values
$code->vessel=self::getUniqueString($code->vessel);
$code->voyage=self::getUniqueString($code->voyage);
$code->port=self::getUniqueString($code->port);
$code->liner=self::getUniqueString($code->liner);

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company_id'=>$dev->company,
':sub_ar_doc_type'=>$c->sub_ar_doc_type,
':sub_ar_doc_number'=>$c->sub_ar_doc_number,
':sub_ar_doc_base'=>$c->sub_ar_doc_base,
':sub_ar_gl_date'=>$c->sub_ar_gl_date,
':sub_ar_due_date'=>$c->sub_ar_due_date,
':sub_ar_age_date'=>$c->sub_ar_date,
':sub_ar_date'=>$c->sub_ar_date,
':sub_ar_other_reference'=>$c->sub_ar_other_reference,
':sub_ar_currency'=>$c->sub_ar_currency,
':sub_ar_ex_rate'=>$c->sub_ar_ex_rate,
':sub_place_off_supply'=>$c->sub_place_off_supply,
':sub_place_off_supply_date'=>$c->sub_place_off_supply_date,
':sub_ar_narration'=>$c->sub_ar_narration,
':sub_ar_notes'=>$c->sub_ar_notes,
':sub_ar_code'=>$c->sub_ar_code,
':sub_ar_status'=>'P', // means POSTED
':sub_ar_other_reference_date'=>$c->sub_ar_other_reference_date,

':temp_code'=>$temp_code,
':total_local_amt'=>$c->total_local_amt,
':order_no'=>$code->order_no,
':bl_no'=>$code->bl_no,
':sub_ar_user'=>$dev->username,

':vat_amt'=>$vat_amt,
':gst_percent'=>$c->gst_percent,

':company_id'=>$dev->company,
':location_id'=>$dev->location
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";

} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}

  //generate doc number
  $order_no=$code->order_no;

  $statement = $db->prepare("INSERT into bl_dxb_invno_autogen (temp_code,order_no,container_no,created_by,created_date) 
  values(:temp_code,:order_no,'$dev->location','$dev->username',now())");

  $data["temp_code"]=$temp_code;

  $statement->execute(array(':temp_code'=>$temp_code,':order_no'=>$order_no));

      if ($statement->rowCount()){
      $data["autogen_inv_status"]=1;
    } else{
      $data["autogen_inv_status"]=0;
    }

   $statement = $db->prepare("SELECT COUNT(*)+11 rid from bl_dxb_invno_autogen 
      where id <(SELECT id from bl_dxb_invno_autogen 
        where temp_code=:temp_code and created_by=:created_by)");
    
    $statement->execute(array(':temp_code'=>$temp_code,
        ':created_by'=>$dev->username));
       $row_ids=$statement->fetchAll(PDO::FETCH_ASSOC);
        $row_id=$row_ids[0]["rid"];

    $fid=self::setFourDigit($row_id);

  //LVRS/INV/DXB/22/NUM
  $on="LVRS/INV/DXB/".date("y")."/".$fid; 


  $statement = $db->prepare("SELECT id from mt_ship_ar_header where created_by=:created_by and temp_code=:temp_code");
  $statement->execute(array(':temp_code'=>$temp_code,
    ':created_by'=>$dev->username));
  $op=$statement->fetchAll(PDO::FETCH_ASSOC);

  $data["id"]=$op;

  $statement = $db->prepare("UPDATE mt_ship_ar_header 
  SET sub_ar_doc_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["invid_status"]=1;
  } else{
    $data["invid_status"]=0;
  }

$data["doc_no"]=$on;

$fy=self::getFinancialYear();
$fp=self::getFinancialPeriod($c->sub_ar_date);
//doc number ends

//MT_AR_TRANS table
//FINANCIAL YEAR AND PERIOD IS PENDING
$statement = $db->prepare("INSERT into mt_ar_trans (
  art_company,art_code,art_type,art_number,art_serial,art_group,art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,ip,created_by ,ua,ekey,created_date,
  company_id,location_id) 

SELECT sub_ar_company,
sub_ar_code,
sub_ar_doc_type,
sub_ar_doc_number,
sub_ar_internal_number,
sub_ar_group,
sub_ar_doc_base,
sub_ar_internal_number,
sub_ar_other_reference,
sub_ar_date,
sub_ar_gl_date,
'$fy',
'$fp',
sub_ar_age_date,
sub_ar_due_date,
sub_ar_currency,
sub_ar_ex_rate,
sub_ar_f_amount,
sub_ar_l_amount,
sub_ar_f_amount,
sub_ar_l_amount,
'A',
sub_ar_narration,
sub_ar_notes,
sub_place_off_supply,
sub_place_off_supply_date,
sub_ar_other_reference_date,
now(),
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$dev->company','$dev->location'  
FROM mt_ship_ar_header WHERE temp_code=:temp_code");

$statement->execute(array(':temp_code'=>$temp_code));

if ($statement->rowCount()){
  $data["ar_trans_status"]=1;
} else{
  $data["ar_trans_status"]=0;
}


//TAX STARTS

    //OUTPUT VAT - 2-30-001-0020
      if($vat_amt!=0){
        $statement = $db->prepare("INSERT into mt_ar_trans (
          art_company,art_code,art_type,art_number,art_serial,art_group,
          art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,
          art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,
          art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,
          art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,
          ip,created_by ,ua,ekey,created_date,
          company_id,location_id) 
        values 
        ('$dev->company',:art_code,'OUTPUT VAT',:art_number,'1',:art_group,
        'OUTPUT VAT', '0', '', now(), now(),'$fy',
        '$fp', now(),now(), 'AED','1',:art_foreign_amount, 
        :art_local_amount,:art_foreign_balance,:art_local_balance,'A',
        :art_description,'','','','', now(),
        '$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey', now(),
        '$dev->company','$dev->location') ");

        $statement->execute(array(':art_code'=>$c->sub_ar_code, 
          ':art_number'=>$on, 
          ':art_group'=>'2-30-001-0020', 
          ':art_foreign_amount'=>$vat_amt, 
          ':art_local_amount'=>$vat_amt, 
          ':art_foreign_balance'=>$vat_amt, 
          ':art_local_balance'=>$vat_amt, 
          ':art_description'=>'OUTPUT VAT '.$vat_percent.'%' ));

        if ($statement->rowCount()){
          $data["vat_status"]=1;
        } else{
          $data["vat_status"]=0;
        }
    }

//TAX ENDS

//trans balance
// query 6
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_ar_trans_balance
(ardm_company,ardm_code,ardm_doc_type,ardm_doc_number,
  ardm_serial,ardm_other_reference,ardm_date,ardm_currency,
  ardm_ex_rate,ardm_of_amount,ardm_ol_amount,
  ardm_bf_amount,ardm_bl_amount,
  ardm_pf_amount,ardm_pl_amount,ardm_status,
ip,created_by,ua,ekey,created_date,temp_code,company_id,location_id)

SELECT art_company,art_code,art_type,art_number,
art_serial,art_other_reference,art_gl_date,art_currency,
art_ex_rate,art_foreign_amount,art_local_amount,
art_foreign_balance,art_local_balance,
0,0,'PENDING',
ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location' 
 from mt_ar_trans where art_number=:doc_no
");

$statement->execute(array(':doc_no'=>$on));
//var_dump($statement->debugDumpParams());
if ($statement->rowCount()){
  $data["tb_status"]=1;
} else{
  $data["tb_status"]=0;
}

//trans balance ends
$order_id=0;
$order_details_insert_count=0;
$order_cost_update_count=0;

if($data["status"]==1)
{
  $cds=$code->cd;
  $ocds=$code->ocd;

  $q="INSERT into mt_ship_ar_details(
      sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,sub_ard_currency,sub_ard_ex_rate,sub_ard_foreign_amount,sub_ard_local_amount,sub_ard_narration,sub_ard_notes,sub_ard_detail_1,sub_ard_detail_2,sub_ard_detail_3,sub_ard_detail_4,sub_ard_detail_5,sub_ard_detail_6,sub_ard_basis,sub_ard_rate,sub_ard_quantity,ip,created_by ,ua,ekey,created_date,charge_desc,basis_type,taxable,total_tax_amt,total_amt,inv_status,sub_ard_detail_7,sub_ard_detail_8,sub_ard_detail_9,sub_ard_detail_10,charge_id,vat_percent) 
      VALUES(:sub_ard_company,:sub_ard_doc_type,:sub_ard_doc_number,:sub_ard_serial,:sub_ard_currency,:sub_ard_ex_rate,:sub_ard_foreign_amount,:sub_ard_local_amount,:sub_ard_narration,:sub_ard_notes,:sub_ard_detail_1,:sub_ard_detail_2,:sub_ard_detail_3,:sub_ard_detail_4,:sub_ard_detail_5,:sub_ard_detail_6,:sub_ard_basis,:sub_ard_rate,:sub_ard_quantity,:ip ,:created_by ,
      :ua ,:ekey,now(),:charge_desc,:basis_type,:taxable,:total_tax_amt,:total_amt,:inv_status,'$code->liner',
        '$code->vessel','$code->voyage','$code->port',:charge_id,:vat_percent)";
      $charge_query="UPDATE mt_order_cost set invoiced=1,
      inv_pay_no=:doc_no,modified_by=:modified_by,modified_date=now() where id=:id";
      $i=0;
      $c->sub_ar_doc_number = $on;
      $order_ids=array();
      $order_cost_ids='';

  for(;$i<count($cds);$i++)
  {
    $cd=$cds[$i];
    $order_cost_ids=$order_cost_ids."'".$cd->id."',";
    array_push($order_ids,$cd->order_id);

    $statement = $db->prepare($q);
    $ar=self::setChargeDetails_vat('MANIFEST',$cd,$dev,$c,$i);
    $statement->execute($ar);

    if ($statement->rowCount())
        {
          $order_details_insert_count+=1;
        }

    $statement = $db->prepare($charge_query);
    $statement->execute(array(':id'=>$cd->id,':doc_no'=>$on,
      ':modified_by'=>$dev->username));

      if ($statement->rowCount()){
          $order_cost_update_count+=1;
        }

 
  }


  $order_ids_unique=array_unique($order_ids);
  $order_entry_status_count=0;

  for ($i = 0; $i < count($order_ids_unique); $i++) 
  {

     //update order status
    $oq="UPDATE mt_order_entry set modified_date=now(),modified_by=:modified_by, status=(SELECT CASE WHEN (SELECT count(*) FROM `mt_order_cost` WHERE invoiced is null and order_id=:id and type='INCOME')=0 THEN 'INVOICED'
      ELSE 'PART INVOICED'
          END) WHERE id=:id";

        $statement = $db->prepare($oq);
        $statement->execute(array(':id'=>$order_ids_unique[$i],
          ':modified_by'=>$dev->username));

          if ($statement->rowCount()){
            $data["order_entry_status"]=1;
            $order_entry_status_count+=1;
          }else{
            $data["order_entry_status"]=0;
          }

  }

  for($j=0;$j<count($ocds);$j++)
  {
    $ocd=$ocds[$j];
    $statement = $db->prepare($q);
    $ar=self::setChargeDetails('ADDITIONAL',$ocd,$dev,$c,$i+$j);
    $statement->execute($ar);

  }

$order_cost_ids=substr_replace($order_cost_ids,"",-1);

  //ship gl details
$temp_code=uniqid($dev->uid);

$multiple_order_no='';
$sa=explode(',', $code->order_no);
$strLength=count($sa);
for ($i = 0; $i < $strLength; $i++) {

  if($i+1==$strLength)
  {
    $multiple_order_no=$multiple_order_no."'$sa[$i]'";
  }else{
    $multiple_order_no=$multiple_order_no."'$sa[$i]',";
  }

}

$statement = $db->prepare("INSERT into ship_gl_details 
( pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  ip,created_by ,ua,ekey,created_date,temp_code, 
  location_id,company_id)


  SELECT '$dev->company',(
  IFNULL((SELECT income_gl from mt_charge_group_detail 
  where code=charge_desc),(SELECT gl_receivable_pdc from mt_gl_link where name= (select liner from mt_voyage where voyage=(select voyage from mt_manifest_entry where bl_no='$code->bl_no'))))
  ),'SHIP','INV','$on','0',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$code->bl_no',
  currency,ex_rate,-selling_amount,-selling_base_amount,remarks,
  'SHIP','$code->order_no','$c->sub_ar_date','$c->sub_ar_doc_base',
  '$code->bl_no',
  '$c->sub_ar_code',charge_desc,'$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code',
  '$dev->company','$dev->location' from mt_order_cost 
  where id in($order_cost_ids) and order_id in (SELECT id from mt_order_entry 
  where order_no in($multiple_order_no)) and type='INCOME' 
  ");


$statement->execute();
    if ($statement->rowCount()){
    $data["gld_status"]=1;
  } else{
    $data["gld_status"]=0;
  }

//Add TAX+GST entries to GL detail table
  $statement = $db->prepare("INSERT into ship_gl_details 
  ( pre_glt_company, pre_glt_code,
  pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_serial,
  pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,
  pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,
  pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,
  pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  ip,created_by ,ua,ekey,created_date,temp_code,pre_glt_created,
  location_id,company_id)

  SELECT art_company,art_group,
  art_type,art_base_type,
  art_number, art_serial,
  art_gl_date,art_gl_date,'$fy','$fp',
  art_other_reference,art_currency,art_ex_rate,
  art_foreign_amount,art_local_amount,art_description,
  'ORDER','$code->order_no','$code->bl_no','$c->sub_ar_date',
  '$c->sub_ar_code',art_group,art_description,
  ip,created_by,ua,ekey,now(),'$temp_code',now(),
  '$dev->company','$dev->location'    
   from mt_ar_trans where art_number=:doc_no and art_type in ('IMP-INV','EXP-INV','OUTPUT VAT') ");

  $statement->execute(array(':doc_no'=>$on));
      if ($statement->rowCount()){
      $data["gld_header_status"]=1;
    } else{
      $data["gld_header_status"]=0;
    }
  //ship gl ends

//4
$temp_code=uniqid($dev->uid);
//$gds=self::get_gl_Link();
$statement = $db->prepare("INSERT into mt_ship_trans
( st_company,st_doc_type,st_doc_number,st_serial,st_doc_base,st_date,st_gl_date,st_dp_date,st_age_date,st_year,st_period,st_carrier,st_vessel,st_voyage,st_port,st_bl,st_bl_type,st_charge,st_other_reference,st_currency,st_exchange,st_foreign,st_local,st_narration,st_status,
  st_posted_on,
  ip,created_by ,ua,ekey,created_date,temp_code,st_detail_1) 

  SELECT '$dev->company','INV','$on','0','SHIP','$c->sub_ar_date',
  '$c->sub_ar_date',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$code->liner',
  '$code->vessel','$code->voyage','$code->port','$code->bl_no',
  '$c->sub_ar_doc_base',charge_desc,'$code->order_no'
  ,currency,ex_rate,-selling_amount,
  -selling_base_amount,remarks,
  status,now(),
  '$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code','$c->sub_ar_code' from mt_order_cost 
  where id in($order_cost_ids) and 
  order_id in (SELECT id from mt_order_entry 
  where order_no in($multiple_order_no)) and type='INCOME'
");
$statement->execute();
    if ($statement->rowCount()){
    $data["sht_status"]=1;
  } else{
    $data["sht_status"]=0;
  }


}

$vat_status=0;
if($vat_amt!=0)
{
  $vat_status=$data["vat_status"];
}else{
  $vat_status=1;
  $data["vat_amt"]=$vat_amt;
  $data["vat_status"]='NA';
}

//$data["status"]=0;
if($data["invid_status"]==1 && $data["status"]==1 && count($cds)==$order_details_insert_count && count($cds)==$order_cost_update_count && $data["ar_trans_status"]==1 && $data["tb_status"]==1 && count($order_ids_unique)==$order_entry_status_count && $data["gld_status"]==1 && $data["gld_header_status"]==1 && $data["sht_status"]==1 && $vat_status==1  )
{
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_invoice_entry_sea_vat($dev,$code)
{
$data=array();

try
{
$db = Factory::getConnection();
$db->beginTransaction();

$temp_code=uniqid($dev->uid);

$c=$code->inv;


//FETCH USER RIGHTS
$view_type="";
$location_id="";
$addl_location_id="";

$statement = $db->prepare(" SELECT view_type,location,company FROM user_master 
WHERE username=:username ");
$statement->execute(array(':username'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$view_type=$op[0]["view_type"];
$location=$op[0]["location"];
$company=$op[0]["company"];

$vat_amt=0;
$vat_percent=$c->gst_percent;
$cds=$code->cd;

for($i=0;$i<count($cds);$i++)
{
  $cd=$cds[$i];
  if(self::excludeCharges($cd->charge_desc)==0)
    {
      $vat_amt+=round($cd->total_amt*$vat_percent/100,2);
      //$vat_percent=$cd->vat_percent;
    }

}

$statement = $db->prepare("INSERT into mt_order_ar_header(sub_ar_company,
  sub_ar_doc_type,sub_ar_doc_number,sub_ar_doc_base,sub_ar_gl_date,sub_ar_due_date,sub_ar_age_date,sub_ar_date,sub_ar_other_reference,sub_ar_currency,sub_ar_ex_rate,sub_place_off_supply,sub_place_off_supply_date,sub_ar_narration,sub_ar_notes,sub_ar_code,
  sub_ar_group,
  sub_ar_status, 
  sub_ar_other_reference_date,
  ip,created_by ,ua,ekey,created_date,temp_code,total_local_amt,order_no,
  bl_no,sub_ar_user,sub_ar_f_amount,sub_ar_l_amount,
  company_id,location_id,vat_amt,gst_percent) 
values(:company_id,:sub_ar_doc_type,:sub_ar_doc_number,:sub_ar_doc_base,:sub_ar_gl_date,:sub_ar_due_date,:sub_ar_age_date,:sub_ar_date,:sub_ar_other_reference,:sub_ar_currency,:sub_ar_ex_rate,:sub_place_off_supply,:sub_place_off_supply_date,:sub_ar_narration,:sub_ar_notes,:sub_ar_code,
(select gl_account from mt_gl_link where name='RECEIVABLE' limit 1),
:sub_ar_status,
:sub_ar_other_reference_date,
:ip ,:created_by ,
:ua ,:ekey,now(),:temp_code,:total_local_amt,:order_no,
  :bl_no,:sub_ar_user,:total_local_amt,:total_local_amt,
:company_id,:location_id,:vat_amt,:gst_percent)");

if($c->sub_ar_due_date=="")
{
  $c->sub_ar_due_date=null;
}

if($c->sub_ar_other_reference_date=="")
{
  $c->sub_ar_other_reference_date=null;
}

if($c->sub_ar_ex_rate=="")
{
  $c->sub_ar_ex_rate=null;
}

$code->order_no=substr_replace($code->order_no,"", -1);
$code->bl_no=substr_replace($code->bl_no,"", -1);

$code->vessel=substr_replace($code->vessel,"", -1);
$code->voyage=substr_replace($code->voyage,"", -1);
$code->port=substr_replace($code->port,"", -1);
$code->liner=substr_replace($code->liner,"", -1);


//get unique values
$code->vessel=self::getUniqueString($code->vessel);
$code->voyage=self::getUniqueString($code->voyage);
$code->port=self::getUniqueString($code->port);
$code->liner=self::getUniqueString($code->liner);

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company_id'=>$dev->company,
':sub_ar_doc_type'=>$c->sub_ar_doc_type,
':sub_ar_doc_number'=>$c->sub_ar_doc_number,
':sub_ar_doc_base'=>$c->sub_ar_doc_base,
':sub_ar_gl_date'=>$c->sub_ar_gl_date,
':sub_ar_due_date'=>$c->sub_ar_due_date,
':sub_ar_age_date'=>$c->sub_ar_date,
':sub_ar_date'=>$c->sub_ar_date,
':sub_ar_other_reference'=>$c->sub_ar_other_reference,
':sub_ar_currency'=>$c->sub_ar_currency,
':sub_ar_ex_rate'=>$c->sub_ar_ex_rate,
':sub_place_off_supply'=>$c->sub_place_off_supply,
':sub_place_off_supply_date'=>$c->sub_place_off_supply_date,
':sub_ar_narration'=>$c->sub_ar_narration,
':sub_ar_notes'=>$c->sub_ar_notes,
':sub_ar_code'=>$c->sub_ar_code,
':sub_ar_status'=>'P', // means POSTED
':sub_ar_other_reference_date'=>$c->sub_ar_other_reference_date,

':temp_code'=>$temp_code,
':total_local_amt'=>$c->total_local_amt,
':order_no'=>$code->order_no,
':bl_no'=>$code->bl_no,
':sub_ar_user'=>$dev->username,

':vat_amt'=>$vat_amt,
':gst_percent'=>$c->gst_percent,

':company_id'=>$dev->company,
':location_id'=>$dev->location
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";

} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}

  //generate doc number
  $order_no=$code->order_no;

  $statement = $db->prepare("INSERT into bl_dxb_invno_autogen (temp_code,order_no,container_no,created_by,created_date) 
  values(:temp_code,:order_no,'$dev->location','$dev->username',now())");

  $data["temp_code"]=$temp_code;

  $statement->execute(array(':temp_code'=>$temp_code,':order_no'=>$order_no));

      if ($statement->rowCount()){
      $data["autogen_inv_status"]=1;
    } else{
      $data["autogen_inv_status"]=0;
    }

   $statement = $db->prepare("SELECT COUNT(*)+11 rid from bl_dxb_invno_autogen 
      where id <(SELECT id from bl_dxb_invno_autogen 
        where temp_code=:temp_code and created_by=:created_by)");
    
    $statement->execute(array(':temp_code'=>$temp_code,
        ':created_by'=>$dev->username));
       $row_ids=$statement->fetchAll(PDO::FETCH_ASSOC);
        $row_id=$row_ids[0]["rid"];

    $fid=self::setFourDigit($row_id);

  //LVRS/INV/DXB/22/NUM
  $on="LVRS/INV/DXB/".date("y")."/".$fid; 


  $statement = $db->prepare("SELECT id from mt_order_ar_header where created_by=:created_by and temp_code=:temp_code");
  $statement->execute(array(':temp_code'=>$temp_code,
    ':created_by'=>$dev->username));
  $op=$statement->fetchAll(PDO::FETCH_ASSOC);

  $data["id"]=$op;

  $statement = $db->prepare("UPDATE mt_order_ar_header 
  SET sub_ar_doc_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["invid_status"]=1;
  } else{
    $data["invid_status"]=0;
  }

$data["doc_no"]=$on;

$fy=self::getFinancialYear();
$fp=self::getFinancialPeriod($c->sub_ar_date);
//doc number ends

//MT_AR_TRANS table
//FINANCIAL YEAR AND PERIOD IS PENDING
$statement = $db->prepare("INSERT into mt_ar_trans (
  art_company,art_code,art_type,art_number,art_serial,art_group,art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,ip,created_by ,ua,ekey,created_date,
  company_id,location_id) 

SELECT sub_ar_company,
sub_ar_code,
sub_ar_doc_type,
sub_ar_doc_number,
sub_ar_internal_number,
sub_ar_group,
sub_ar_doc_base,
sub_ar_internal_number,
sub_ar_other_reference,
sub_ar_date,
sub_ar_gl_date,
'$fy',
'$fp',
sub_ar_age_date,
sub_ar_due_date,
sub_ar_currency,
sub_ar_ex_rate,
sub_ar_f_amount,
sub_ar_l_amount,
sub_ar_f_amount,
sub_ar_l_amount,
'A',
sub_ar_narration,
sub_ar_notes,
sub_place_off_supply,
sub_place_off_supply_date,
sub_ar_other_reference_date,
now(),
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$dev->company','$dev->location'  
FROM mt_order_ar_header WHERE temp_code=:temp_code");

$statement->execute(array(':temp_code'=>$temp_code));

if ($statement->rowCount()){
  $data["ar_trans_status"]=1;
} else{
  $data["ar_trans_status"]=0;
}


//TAX STARTS

    //OUTPUT VAT - 2-30-001-0020
      if($vat_amt!=0){
        $statement = $db->prepare("INSERT into mt_ar_trans (
          art_company,art_code,art_type,art_number,art_serial,art_group,
          art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,
          art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,
          art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,
          art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,
          ip,created_by ,ua,ekey,created_date,
          company_id,location_id) 
        values 
        ('$dev->company',:art_code,'OUTPUT VAT',:art_number,'1',:art_group,
        'OUTPUT VAT', '0', '', now(), now(),'$fy',
        '$fp', now(),now(), 'AED','1',:art_foreign_amount, 
        :art_local_amount,:art_foreign_balance,:art_local_balance,'A',
        :art_description,'','','','', now(),
        '$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey', now(),
        '$dev->company','$dev->location') ");

        $statement->execute(array(':art_code'=>$c->sub_ar_code, 
          ':art_number'=>$on, 
          ':art_group'=>'2-30-001-0020', 
          ':art_foreign_amount'=>$vat_amt, 
          ':art_local_amount'=>$vat_amt, 
          ':art_foreign_balance'=>$vat_amt, 
          ':art_local_balance'=>$vat_amt, 
          ':art_description'=>'OUTPUT VAT '.$vat_percent.'%' ));

        if ($statement->rowCount()){
          $data["vat_status"]=1;
        } else{
          $data["vat_status"]=0;
        }
    }

//TAX ENDS

//trans balance
// query 6
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_ar_trans_balance
(ardm_company,ardm_code,ardm_doc_type,ardm_doc_number,
  ardm_serial,ardm_other_reference,ardm_date,ardm_currency,
  ardm_ex_rate,ardm_of_amount,ardm_ol_amount,
  ardm_bf_amount,ardm_bl_amount,
  ardm_pf_amount,ardm_pl_amount,ardm_status,
ip,created_by,ua,ekey,created_date,temp_code,company_id,location_id)

SELECT art_company,art_code,art_type,art_number,
art_serial,art_other_reference,art_gl_date,art_currency,
art_ex_rate,art_foreign_amount,art_local_amount,
art_foreign_balance,art_local_balance,
0,0,'PENDING',
ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location' 
 from mt_ar_trans where art_number=:doc_no
");

$statement->execute(array(':doc_no'=>$on));
//var_dump($statement->debugDumpParams());
if ($statement->rowCount()){
  $data["tb_status"]=1;
} else{
  $data["tb_status"]=0;
}

//trans balance ends
$order_id=0;
$order_details_insert_count=0;
$order_cost_update_count=0;

if($data["status"]==1)
{
  $cds=$code->cd;
  $ocds=$code->ocd;

  $q="INSERT into mt_order_ar_details(
      sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,sub_ard_currency,sub_ard_ex_rate,sub_ard_foreign_amount,sub_ard_local_amount,sub_ard_narration,sub_ard_notes,sub_ard_detail_1,sub_ard_detail_2,sub_ard_detail_3,sub_ard_detail_4,sub_ard_detail_5,sub_ard_detail_6,sub_ard_basis,sub_ard_rate,sub_ard_quantity,ip,created_by ,ua,ekey,created_date,charge_desc,basis_type,taxable,total_tax_amt,total_amt,inv_status,sub_ard_detail_7,sub_ard_detail_8,sub_ard_detail_9,sub_ard_detail_10,charge_id,vat_percent) 
      VALUES(:sub_ard_company,:sub_ard_doc_type,:sub_ard_doc_number,:sub_ard_serial,:sub_ard_currency,:sub_ard_ex_rate,:sub_ard_foreign_amount,:sub_ard_local_amount,:sub_ard_narration,:sub_ard_notes,:sub_ard_detail_1,:sub_ard_detail_2,:sub_ard_detail_3,:sub_ard_detail_4,:sub_ard_detail_5,:sub_ard_detail_6,:sub_ard_basis,:sub_ard_rate,:sub_ard_quantity,:ip ,:created_by ,
      :ua ,:ekey,now(),:charge_desc,:basis_type,:taxable,:total_tax_amt,:total_amt,:inv_status,'$code->liner',
        '$code->vessel','$code->voyage','$code->port',:charge_id,:vat_percent)";
      $charge_query="UPDATE mt_order_cost set invoiced=1,
      inv_pay_no=:doc_no,modified_by=:modified_by,modified_date=now() where id=:id";
      $i=0;
      $c->sub_ar_doc_number = $on;
      $order_ids=array();
      $order_cost_ids='';

  for(;$i<count($cds);$i++)
  {
    $cd=$cds[$i];
    $order_cost_ids=$order_cost_ids."'".$cd->id."',";
    array_push($order_ids,$cd->order_id);

    $statement = $db->prepare($q);
    $ar=self::setChargeDetails_vat('MANIFEST',$cd,$dev,$c,$i);
    $statement->execute($ar);

    if ($statement->rowCount())
        {
          $order_details_insert_count+=1;
        }

    $statement = $db->prepare($charge_query);
    $statement->execute(array(':id'=>$cd->id,':doc_no'=>$on,
      ':modified_by'=>$dev->username));

      if ($statement->rowCount()){
          $order_cost_update_count+=1;
        }

 
  }


  $order_ids_unique=array_unique($order_ids);
  $order_entry_status_count=0;

  for ($i = 0; $i < count($order_ids_unique); $i++) 
  {

     //update order status
    $oq="UPDATE mt_order_entry set modified_date=now(),modified_by=:modified_by, status=(SELECT CASE WHEN (SELECT count(*) FROM `mt_order_cost` WHERE invoiced is null and order_id=:id and type='INCOME')=0 THEN 'INVOICED'
      ELSE 'PART INVOICED'
          END) WHERE id=:id";

        $statement = $db->prepare($oq);
        $statement->execute(array(':id'=>$order_ids_unique[$i],
          ':modified_by'=>$dev->username));

          if ($statement->rowCount()){
            $data["order_entry_status"]=1;
            $order_entry_status_count+=1;
          }else{
            $data["order_entry_status"]=0;
          }

  }

  for($j=0;$j<count($ocds);$j++)
  {
    $ocd=$ocds[$j];
    $statement = $db->prepare($q);
    $ar=self::setChargeDetails('ADDITIONAL',$ocd,$dev,$c,$i+$j);
    $statement->execute($ar);

  }

$order_cost_ids=substr_replace($order_cost_ids,"",-1);

  //ship gl details
$temp_code=uniqid($dev->uid);

$multiple_order_no='';
$sa=explode(',', $code->order_no);
$strLength=count($sa);
for ($i = 0; $i < $strLength; $i++) {

  if($i+1==$strLength)
  {
    $multiple_order_no=$multiple_order_no."'$sa[$i]'";
  }else{
    $multiple_order_no=$multiple_order_no."'$sa[$i]',";
  }

}

$statement = $db->prepare("INSERT into mt_order_gl_details 
( pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  ip,created_by ,ua,ekey,created_date,temp_code, 
  location_id,company_id)


  SELECT '$dev->company',(
  IFNULL((SELECT income_gl from mt_charge_group_detail 
  where code=charge_desc),(SELECT gl_receivable_pdc from mt_gl_link where name= (select liner from mt_voyage where voyage=(select voyage from mt_manifest_entry where bl_no='$code->bl_no'))))
  ),'SHIP','INV','$on','0',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$code->bl_no',
  currency,ex_rate,-selling_amount,-selling_base_amount,remarks,
  'SHIP','$code->order_no','$c->sub_ar_date','$c->sub_ar_doc_base',
  '$code->bl_no',
  '$c->sub_ar_code',charge_desc,'$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code',
  '$dev->company','$dev->location' from mt_order_cost 
  where id in($order_cost_ids) and order_id in (SELECT id from mt_order_entry 
  where order_no in($multiple_order_no)) and type='INCOME' 
  ");


$statement->execute();
    if ($statement->rowCount()){
    $data["gld_status"]=1;
  } else{
    $data["gld_status"]=0;
  }

//Add TAX+GST entries to GL detail table
  $statement = $db->prepare("INSERT into mt_order_gl_details 
  ( pre_glt_company, pre_glt_code,
  pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_serial,
  pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,
  pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,
  pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,
  pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  ip,created_by ,ua,ekey,created_date,temp_code,pre_glt_created,
  location_id,company_id)

  SELECT art_company,art_group,
  art_type,art_base_type,
  art_number, art_serial,
  art_gl_date,art_gl_date,'$fy','$fp',
  art_other_reference,art_currency,art_ex_rate,
  art_foreign_amount,art_local_amount,art_description,
  'ORDER','$code->order_no','$code->bl_no','$c->sub_ar_date',
  '$c->sub_ar_code',art_group,art_description,
  ip,created_by,ua,ekey,now(),'$temp_code',now(),
  '$dev->company','$dev->location'    
   from mt_ar_trans where art_number=:doc_no and art_type in ('IMP-INV','EXP-INV','OUTPUT VAT') ");

  $statement->execute(array(':doc_no'=>$on));
      if ($statement->rowCount()){
      $data["gld_header_status"]=1;
    } else{
      $data["gld_header_status"]=0;
    }
  //ship gl ends

//4
$temp_code=uniqid($dev->uid);


}

$vat_status=0;
if($vat_amt!=0)
{
  $vat_status=$data["vat_status"];
}else{
  $vat_status=1;
  $data["vat_amt"]=$vat_amt;
  $data["vat_status"]='NA';
}

//$data["status"]=0;
if($data["invid_status"]==1 && $data["status"]==1 && count($cds)==$order_details_insert_count && count($cds)==$order_cost_update_count && $data["ar_trans_status"]==1 && $data["tb_status"]==1 && count($order_ids_unique)==$order_entry_status_count && $data["gld_status"]==1 && $data["gld_header_status"]==1 && $vat_status==1  )
{
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function save_invoice_entry_sea_pro($dev,$code)
{
$data=array();

try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$c=$code->inv;

$statement = $db->prepare("INSERT into 
  mt_order_ar_header(sub_ar_company,
  sub_ar_doc_type,sub_ar_doc_number,sub_ar_doc_base,sub_ar_gl_date,sub_ar_due_date,sub_ar_age_date,sub_ar_date,sub_ar_other_reference,sub_ar_currency,sub_ar_ex_rate,sub_place_off_supply,sub_place_off_supply_date,sub_ar_narration,sub_ar_notes,sub_ar_code,
  sub_ar_group,
  sub_ar_status, 
  sub_ar_other_reference_date,
  ip,created_by ,ua,ekey,created_date,temp_code,total_local_amt,order_no,
  bl_no,sub_ar_user,sub_ar_f_amount,sub_ar_l_amount,
  company_id,location_id) 
values(:company_id,:sub_ar_doc_type,:sub_ar_doc_number,:sub_ar_doc_base,:sub_ar_gl_date,:sub_ar_due_date,:sub_ar_age_date,:sub_ar_date,:sub_ar_other_reference,:sub_ar_currency,:sub_ar_ex_rate,:sub_place_off_supply,:sub_place_off_supply_date,:sub_ar_narration,:sub_ar_notes,:sub_ar_code,
'ACCOUNTS RECEIVABLE',
:sub_ar_status,
:sub_ar_other_reference_date,
:ip ,:created_by ,
:ua ,:ekey,now(),:temp_code,:total_local_amt,:order_no,
  :bl_no,:sub_ar_user,:total_local_amt,:total_local_amt,
:company_id,:location_id)");

if($c->sub_ar_due_date=="")
{
  $c->sub_ar_due_date=null;
}

if($c->sub_ar_other_reference_date=="")
{
  $c->sub_ar_other_reference_date=null;
}

if($c->sub_ar_ex_rate=="")
{
  $c->sub_ar_ex_rate=null;
}

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company_id'=>$dev->company,
':sub_ar_doc_type'=>$c->sub_ar_doc_type,
':sub_ar_doc_number'=>$c->sub_ar_doc_number,
':sub_ar_doc_base'=>$c->sub_ar_doc_base,
':sub_ar_gl_date'=>$c->sub_ar_gl_date,
':sub_ar_due_date'=>$c->sub_ar_due_date,
':sub_ar_age_date'=>$c->sub_ar_date,
':sub_ar_date'=>$c->sub_ar_date,
':sub_ar_other_reference'=>$c->sub_ar_other_reference,
':sub_ar_currency'=>$c->sub_ar_currency,
':sub_ar_ex_rate'=>$c->sub_ar_ex_rate,
':sub_place_off_supply'=>$c->sub_place_off_supply,
':sub_place_off_supply_date'=>$c->sub_place_off_supply_date,
':sub_ar_narration'=>$c->sub_ar_narration,
':sub_ar_notes'=>$c->sub_ar_notes,
':sub_ar_code'=>$c->sub_ar_code,
':sub_ar_status'=>'P',
':sub_ar_other_reference_date'=>$c->sub_ar_other_reference_date,

':temp_code'=>$temp_code,
':total_local_amt'=>$c->total_local_amt,
':order_no'=>$code->order_no,
':bl_no'=>$code->bl_no,
':sub_ar_user'=>$dev->username,

':company_id'=>$dev->company,
':location_id'=>$dev->location
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';

} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

//generate doc number

$data["temp_code"]=$temp_code;

$statement = $db->prepare("SELECT id from mt_order_ar_header where created_by=:created_by and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

$fid=self::setFourDigit($op[0]["id"]);

$on=$c->sub_ar_doc_type."/".date("Y")."/".date('m')."/".$c->sub_place_off_supply."/".$fid;

 $statement = $db->prepare("UPDATE mt_order_ar_header 
  SET sub_ar_doc_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["invid_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["invid_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

$data["doc_no"]=$on;


//doc number ends


$order_id=0;
if($data["status"]==1)
{
  $cds=$code->cd;
  $ocds=$code->ocd;

  $q="INSERT into mt_order_ar_details(
      sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,sub_ard_currency,sub_ard_ex_rate,sub_ard_foreign_amount,sub_ard_local_amount,sub_ard_narration,sub_ard_notes,sub_ard_detail_1,sub_ard_detail_2,sub_ard_detail_3,sub_ard_detail_4,sub_ard_detail_5,sub_ard_detail_6,sub_ard_basis,sub_ard_rate,sub_ard_quantity,ip,created_by ,ua,ekey,created_date,charge_desc,basis_type,taxable,total_tax_amt,total_amt,inv_status) 
      VALUES(:sub_ard_company,:sub_ard_doc_type,:sub_ard_doc_number,:sub_ard_serial,:sub_ard_currency,:sub_ard_ex_rate,:sub_ard_foreign_amount,:sub_ard_local_amount,:sub_ard_narration,:sub_ard_notes,:sub_ard_detail_1,:sub_ard_detail_2,:sub_ard_detail_3,:sub_ard_detail_4,:sub_ard_detail_5,:sub_ard_detail_6,:sub_ard_basis,:sub_ard_rate,:sub_ard_quantity,:ip ,:created_by ,
:ua ,:ekey,now(),:charge_desc,:basis_type,:taxable,:total_tax_amt,:total_amt,:inv_status)";
$charge_query="UPDATE mt_order_cost set invoiced=2,proforma=:doc_no where id=:id";
$i=0;
$c->sub_ar_doc_number = $on;

  for(;$i<count($cds);$i++)
  {
    $cd=$cds[$i];
    $statement = $db->prepare($q);
    $ar=self::setChargeDetails('MANIFEST',$cd,$dev,$c,$i);
    $ar[':inv_status']='PROFORMA';
    $statement->execute($ar);

    $statement = $db->prepare($charge_query);
    $statement->execute(array(':id'=>$cd->id,':doc_no'=>$on));

 
  }
 


}



$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function save_invoice_entry_sea($dev,$code)
{
$data=array();

try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$c=$code->inv;

$statement = $db->prepare("INSERT into 
  mt_order_ar_header(sub_ar_company,
  sub_ar_doc_type,sub_ar_doc_number,sub_ar_doc_base,sub_ar_gl_date,sub_ar_due_date,sub_ar_age_date,sub_ar_date,sub_ar_other_reference,sub_ar_currency,sub_ar_ex_rate,sub_place_off_supply,sub_place_off_supply_date,sub_ar_narration,sub_ar_notes,sub_ar_code,
  sub_ar_group,
  sub_ar_status, 
  sub_ar_other_reference_date,
  ip,created_by ,ua,ekey,created_date,temp_code,total_local_amt,order_no,
  bl_no,sub_ar_user,sub_ar_f_amount,sub_ar_l_amount,
  company_id,location_id) 
values(:company_id,:sub_ar_doc_type,:sub_ar_doc_number,:sub_ar_doc_base,:sub_ar_gl_date,:sub_ar_due_date,:sub_ar_age_date,:sub_ar_date,:sub_ar_other_reference,:sub_ar_currency,:sub_ar_ex_rate,:sub_place_off_supply,:sub_place_off_supply_date,:sub_ar_narration,:sub_ar_notes,:sub_ar_code,
'ACCOUNTS RECEIVABLE',
:sub_ar_status,
:sub_ar_other_reference_date,
:ip ,:created_by ,
:ua ,:ekey,now(),:temp_code,:total_local_amt,:order_no,
  :bl_no,:sub_ar_user,:total_local_amt,:total_local_amt,
:company_id,:location_id)");

if($c->sub_ar_due_date=="")
{
  $c->sub_ar_due_date=null;
}

if($c->sub_ar_other_reference_date=="")
{
  $c->sub_ar_other_reference_date=null;
}

if($c->sub_ar_ex_rate=="")
{
  $c->sub_ar_ex_rate=null;
}

$code->order_no=substr_replace($code->order_no,"", -1);
$code->bl_no=substr_replace($code->bl_no,"", -1);

$code->vessel=substr_replace($code->vessel,"", -1);
$code->voyage=substr_replace($code->voyage,"", -1);
$code->port=substr_replace($code->port,"", -1);
$code->liner=substr_replace($code->liner,"", -1);

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company_id'=>$dev->company,
':sub_ar_doc_type'=>$c->sub_ar_doc_type,
':sub_ar_doc_number'=>$c->sub_ar_doc_number,
':sub_ar_doc_base'=>$c->sub_ar_doc_base,
':sub_ar_gl_date'=>$c->sub_ar_gl_date,
':sub_ar_due_date'=>$c->sub_ar_due_date,
':sub_ar_age_date'=>$c->sub_ar_date,
':sub_ar_date'=>$c->sub_ar_date,
':sub_ar_other_reference'=>$c->sub_ar_other_reference,
':sub_ar_currency'=>$c->sub_ar_currency,
':sub_ar_ex_rate'=>$c->sub_ar_ex_rate,
':sub_place_off_supply'=>$c->sub_place_off_supply,
':sub_place_off_supply_date'=>$c->sub_place_off_supply_date,
':sub_ar_narration'=>$c->sub_ar_narration,
':sub_ar_notes'=>$c->sub_ar_notes,
':sub_ar_code'=>$c->sub_ar_code,
':sub_ar_status'=>'P',
':sub_ar_other_reference_date'=>$c->sub_ar_other_reference_date,

':temp_code'=>$temp_code,
':total_local_amt'=>$c->total_local_amt,
':order_no'=>$code->order_no,
':bl_no'=>$code->bl_no,
':sub_ar_user'=>$dev->username,

':company_id'=>$dev->company,
':location_id'=>$dev->location
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';

} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

//generate doc number

$data["temp_code"]=$temp_code;

$statement = $db->prepare("SELECT id from mt_order_ar_header where created_by=:created_by and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

$fid=self::setFourDigit($op[0]["id"]);

$on=$c->sub_ar_doc_type."/".date("Y")."/".date('m')."/".$c->sub_place_off_supply."/".$fid;

 $statement = $db->prepare("UPDATE mt_order_ar_header 
  SET sub_ar_doc_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["invid_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["invid_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

$data["doc_no"]=$on;

//get financial data
$fy=self::getFinancialYear();
$fp=self::getFinancialPeriod($c->sub_ar_gl_date);

//doc number ends

//MT_AR_TRANS table
//mt_order_trans table created using mt_ar_trans
//FINANCIAL YEAR AND PERIOD IS PENDING
$statement = $db->prepare("INSERT into mt_ar_trans (
  art_company,art_code,art_type,art_number,art_serial,art_group,
  art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,
  ip,created_by ,ua,ekey,created_date,
  company_id,location_id) 

SELECT sub_ar_company,
sub_ar_code,
sub_ar_doc_type,
sub_ar_doc_number,
sub_ar_internal_number,
sub_ar_group,
sub_ar_doc_base,
sub_ar_internal_number,
sub_ar_other_reference,
sub_ar_date,
sub_ar_gl_date,
'$fy',
'$fp',
sub_ar_age_date,
sub_ar_due_date,
sub_ar_currency,
sub_ar_ex_rate,
sub_ar_f_amount,
sub_ar_l_amount,
sub_ar_f_amount,
sub_ar_l_amount,
'A',
sub_ar_narration,
sub_ar_notes,
sub_place_off_supply,
sub_place_off_supply_date,
sub_ar_other_reference_date,
now(),
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$dev->company','$dev->location'  
FROM mt_order_ar_header WHERE temp_code=:temp_code");

$statement->execute(array(':temp_code'=>$temp_code));

if ($statement->rowCount()){
  $data["AR_TRANS_status"]=1;
} else{
  $data["AR_TRANS_status"]=0;
}


//trans balance


// query 6
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_ar_trans_balance
(ardm_company,ardm_code,ardm_doc_type,ardm_doc_number,
  ardm_serial,ardm_other_reference,ardm_date,ardm_currency,
  ardm_ex_rate,ardm_of_amount,ardm_ol_amount,
  ardm_bf_amount,ardm_bl_amount,
  ardm_pf_amount,ardm_pl_amount,ardm_status,
ip,created_by,ua,ekey,created_date,temp_code,company_id,location_id)

SELECT art_company,art_code,art_type,art_number,
art_serial,art_other_reference,art_gl_date,art_currency,
art_ex_rate,art_foreign_amount,art_local_amount,
art_foreign_balance,art_local_balance,
0,0,'PENDING',
ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location'  
 from mt_ar_trans where art_number=:doc_no
");

$statement->execute(array(':doc_no'=>$on));
//var_dump($statement->debugDumpParams());
if ($statement->rowCount()){
  $data["tb_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["tb_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

//trans balance ends


$order_id=0;
if($data["status"]==1)
{
  $cds=$code->cd;
  $ocds=$code->ocd;

  $q="INSERT into mt_order_ar_details(
      sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,sub_ard_currency,sub_ard_ex_rate,sub_ard_foreign_amount,sub_ard_local_amount,sub_ard_narration,sub_ard_notes,sub_ard_detail_1,sub_ard_detail_2,sub_ard_detail_3,sub_ard_detail_4,sub_ard_detail_5,sub_ard_detail_6,sub_ard_basis,sub_ard_rate,sub_ard_quantity,ip,created_by ,ua,ekey,created_date,charge_desc,basis_type,taxable,total_tax_amt,total_amt,inv_status) 
      VALUES(:sub_ard_company,:sub_ard_doc_type,:sub_ard_doc_number,:sub_ard_serial,:sub_ard_currency,:sub_ard_ex_rate,:sub_ard_foreign_amount,:sub_ard_local_amount,:sub_ard_narration,:sub_ard_notes,:sub_ard_detail_1,:sub_ard_detail_2,:sub_ard_detail_3,:sub_ard_detail_4,:sub_ard_detail_5,:sub_ard_detail_6,:sub_ard_basis,:sub_ard_rate,:sub_ard_quantity,:ip ,:created_by ,
:ua ,:ekey,now(),:charge_desc,:basis_type,:taxable,:total_tax_amt,:total_amt,:inv_status)";
$charge_query="UPDATE mt_order_cost set invoiced=1,
inv_pay_no=:doc_no where id=:id";
$i=0;
$c->sub_ar_doc_number = $on;
$order_cost_ids='';
  for(;$i<count($cds);$i++)
  {
    $cd=$cds[$i];
    $order_cost_ids=$order_cost_ids."'".$cd->id."',";

    $statement = $db->prepare($q);
    $ar=self::setChargeDetails('MANIFEST',$cd,$dev,$c,$i);
    $statement->execute($ar);

    $statement = $db->prepare($charge_query);
    $statement->execute(array(':id'=>$cd->id,':doc_no'=>$on));

      //update order status
  $oq="UPDATE mt_order_entry set status=(SELECT CASE WHEN (SELECT count(*) FROM `mt_order_cost` WHERE invoiced is null and order_id=:id and type='INCOME')=0 THEN 'INVOICED'
    ELSE 'PART INVOICED'
        END)
      WHERE id=:id";

      $statement = $db->prepare($oq);
      $statement->execute(array(':id'=>$cd->order_id));
  }
    for($j=0;$j<count($ocds);$j++)
  {
    $ocd=$ocds[$j];
    $statement = $db->prepare($q);
    $ar=self::setChargeDetails('ADDITIONAL',$ocd,$dev,$c,$i+$j);
    $statement->execute($ar);

  }
$order_cost_ids=substr_replace($order_cost_ids,"",-1);
  //ship gl details
$temp_code=uniqid($dev->uid);

$multiple_order_no='';
$sa=explode(',', $code->order_no);
$strLength=count($sa);
for ($i = 0; $i < $strLength; $i++) {

  if($i+1==$strLength)
  {
    $multiple_order_no=$multiple_order_no."'$sa[$i]'";
  }else{
    $multiple_order_no=$multiple_order_no."'$sa[$i]',";
  }

}

$statement = $db->prepare("INSERT into mt_order_gl_details 
( pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  ip,created_by ,ua,ekey,created_date,temp_code)


  SELECT '$dev->company',(SELECT order_income_gl from mt_charge_group_detail where code=charge_desc),'ORDER','INV','$on','0',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$code->bl_no',currency,ex_rate,-selling_amount,-selling_base_amount,remarks,
  'ORDER','$code->order_no','$c->sub_ar_date','$c->sub_ar_doc_base',
  '$code->bl_no',
  '$c->sub_ar_code',charge_desc,'$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code' from mt_order_cost 
  where id in($order_cost_ids) and order_id in (SELECT id from mt_order_entry 
  where order_no in($multiple_order_no)) and type='INCOME' 
  ");


$statement->execute();
    if ($statement->rowCount()){
    $data["gld_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["gld_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

//gl header
//get sum values

$statement = $db->prepare("SELECT sum(selling_amount) samt,sum(selling_base_amount) sbamt from mt_order_cost 
  where id in($order_cost_ids) and order_id in (SELECT id from mt_order_entry 
  where order_no in($multiple_order_no)) and type='INCOME'");
$statement->execute();

$svs=$statement->fetchAll(PDO::FETCH_ASSOC);
$sv=$svs[0];

$statement = $db->prepare("INSERT into mt_order_gl_details 
( pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  ip,created_by ,ua,ekey,created_date,temp_code,pre_glt_created)

  VALUES('$dev->company',(select gl_account from mt_gl_link where name='RECEIVABLE' limit 1),'ORDER','INV','$on',1,
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$code->bl_no',
  '$c->sub_ar_currency',1,:samt,:sbamt,'remarks',
  'ORDER','$code->order_no','$c->sub_ar_date','$c->sub_ar_doc_base',
  '$code->bl_no',
  '$c->sub_ar_code','charge_desc','$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code',now())");

$statement->execute(array(':samt'=>$sv["samt"],':sbamt'=>$sv["sbamt"]));
    if ($statement->rowCount()){
    $data["gld_header_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["gld_header_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

  //ship gl ends




//4
$temp_code=uniqid($dev->uid);
//$gds=self::get_gl_Link();
$statement = $db->prepare("INSERT into mt_order_trans
( ordt_company,ordt_doc_type,ordt_doc_number,ordt_serial,ordt_doc_base,ordt_doc_date,ordt_gl_date,ordt_dp_date,ordt_age_date,ordt_year,ordt_period,ordt_carrier,ordt_vessel,ordt_voyage,ordt_port,ordt_bl,ordt_bl_type,ordt_charge,ordt_other_reference,ordt_currency,ordt_ex_rate,ordt_foreign_amount,ordt_local_amount,ordt_narration,ordt_status,
ordt_posted_on,
  ip,created_by ,ua,ekey,created_date,temp_code,ordt_code,ordt_activity) 

  SELECT '$dev->company','INV','$on','0','ORDER','$c->sub_ar_date',
  '$c->sub_ar_date',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$code->liner',
  '$code->vessel','$code->voyage','$code->port','$code->bl_no',
  '$c->sub_ar_doc_base',charge_desc,'$code->order_no'
  ,currency,ex_rate,-selling_amount,
  -selling_base_amount,remarks,
  status,now(),
  '$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code','$c->sub_ar_code',
  charge_desc
  from mt_order_cost 
  where id in($order_cost_ids) and order_id in (SELECT id from mt_order_entry 
  where order_no in($multiple_order_no)) and type='INCOME'
");
$data["idc"]="id in($order_cost_ids)";
$statement->execute();
    if ($statement->rowCount()){
    $data["sht_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["sht_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }


}



$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function setChargeDetails($type,$cd,$dev,$c,$i)
{
      $cd_id=0;
  if(property_exists($cd,'id'))
  {
  $cd_id=$cd->id;
  }

  $ar=array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':sub_ard_company'=>$dev->company,
':sub_ard_doc_type'=>$c->sub_ar_doc_type,
':sub_ard_doc_number'=>$c->sub_ar_doc_number,
':sub_ard_serial'=>$i+1,
':sub_ard_currency'=>$cd->currency,
':sub_ard_ex_rate'=>$cd->ex_rate,
':sub_ard_foreign_amount'=>$cd->famt,
':sub_ard_local_amount'=>$cd->net_amt,
':sub_ard_narration'=>$cd->remarks,
':sub_ard_notes'=>$c->sub_ar_notes,
':sub_ard_detail_1'=>$cd->order_no,
':sub_ard_detail_2'=>$cd->order_date,
':sub_ard_detail_3'=>$cd->order_type,
':sub_ard_detail_4'=>$cd->bl_no,
':sub_ard_detail_5'=>$cd->customer,
':sub_ard_detail_6'=>$type,
':sub_ard_basis'=>$cd->basis_uom,
':sub_ard_rate'=>$cd->selling_amount,
':sub_ard_quantity'=>$cd->qty,
':charge_desc'=>$cd->charge_desc,
':basis_type'=>$cd->basis_type,
':taxable'=>$cd->taxable,

':total_tax_amt'=>$cd->total_tax_amt,
':total_amt'=>$cd->total_amt,
':inv_status'=>'INVOICED',
':charge_id'=>$cd_id
);

return $ar;
}


public static function setChargeDetails_vat($type,$cd,$dev,$c,$i)
{
  $cd_id=0;
  if(property_exists($cd,'id'))
  {
  $cd_id=$cd->id;
  }

  $ar=array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':sub_ard_company'=>$dev->company,
':sub_ard_doc_type'=>$c->sub_ar_doc_type,
':sub_ard_doc_number'=>$c->sub_ar_doc_number,
':sub_ard_serial'=>$i+1,
':sub_ard_currency'=>$cd->currency,
':sub_ard_ex_rate'=>$cd->ex_rate,
':sub_ard_foreign_amount'=>$cd->famt,
':sub_ard_local_amount'=>$cd->net_amt,
':sub_ard_narration'=>$cd->remarks,
':sub_ard_notes'=>$c->sub_ar_notes,
':sub_ard_detail_1'=>$cd->order_no,
':sub_ard_detail_2'=>$cd->order_date,
':sub_ard_detail_3'=>$cd->order_type,
':sub_ard_detail_4'=>$cd->bl_no,
':sub_ard_detail_5'=>$cd->customer,
':sub_ard_detail_6'=>$type,
':sub_ard_basis'=>$cd->basis_uom,
':sub_ard_rate'=>$cd->selling_amount,
':sub_ard_quantity'=>$cd->qty,
':charge_desc'=>$cd->charge_desc,
':basis_type'=>$cd->basis_type,
':taxable'=>$cd->taxable,

':total_tax_amt'=>$cd->total_tax_amt,
':total_amt'=>$cd->total_amt,
':inv_status'=>'INVOICED',
':charge_id'=>$cd_id,
':vat_percent'=>$cd->vat_percent
);

return $ar;
}

public static function save_invoice_entry_ac($dev,$code)
{
$cd=$code->cd;
$c=$code->c;

$data=array();
try
{
$db = Factory::getConnection();
$temp_code=uniqid($dev->uid);

  $q="INSERT into mt_ship_ar_details(
      sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,sub_ard_currency,sub_ard_ex_rate,sub_ard_foreign_amount,sub_ard_local_amount,sub_ard_narration,sub_ard_notes,sub_ard_detail_1,sub_ard_detail_2,sub_ard_detail_3,sub_ard_detail_4,sub_ard_detail_5,sub_ard_detail_6,sub_ard_basis,sub_ard_rate,sub_ard_quantity,ip,created_by ,ua,ekey,created_date,charge_desc,basis_type,taxable,total_tax_amt,total_amt,inv_status,temp_code) 
      VALUES(:sub_ard_company,:sub_ard_doc_type,:sub_ard_doc_number,:sub_ard_serial,:sub_ard_currency,:sub_ard_ex_rate,:sub_ard_foreign_amount,:sub_ard_local_amount,:sub_ard_narration,:sub_ard_notes,:sub_ard_detail_1,:sub_ard_detail_2,:sub_ard_detail_3,:sub_ard_detail_4,:sub_ard_detail_5,:sub_ard_detail_6,:sub_ard_basis,:sub_ard_rate,:sub_ard_quantity,:ip ,:created_by ,
:ua ,:ekey,now(),:charge_desc,:basis_type,:taxable,:total_tax_amt,:total_amt,:inv_status,:temp_code)";
$statement = $db->prepare($q);

if($cd->ex_rate=="")
{
  $cd->ex_rate=null;
}

if($cd->net_amt=="")
{
  $cd->net_amt=null;
}

$statement->execute(array(

':ip'=>$dev->ip,
':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':sub_ard_company'=>$dev->company,
':sub_ard_doc_type'=>$c->sub_ar_doc_type,
':sub_ard_doc_number'=>$c->sub_ar_doc_number,
':sub_ard_serial'=>'0',
':sub_ard_currency'=>$cd->currency,
':sub_ard_ex_rate'=>$cd->ex_rate,
':sub_ard_foreign_amount'=>0,
':sub_ard_local_amount'=>$cd->net_amt,
':sub_ard_narration'=>$cd->remarks,
':sub_ard_notes'=>$c->sub_ar_notes,
':sub_ard_detail_1'=>$cd->order_no,
':sub_ard_detail_2'=>$cd->order_date,
':sub_ard_detail_3'=>$cd->order_type,
':sub_ard_detail_4'=>$cd->bl_no,
':sub_ard_detail_5'=>$cd->customer,
':sub_ard_detail_6'=>'ADDITIONAL',

':sub_ard_basis'=>$cd->basis_uom,
':sub_ard_rate'=>$cd->selling_amount,
':sub_ard_quantity'=>$cd->qty,
':charge_desc'=>$cd->charge_desc,
':basis_type'=>$cd->basis_type,
':taxable'=>$cd->taxable,

':total_tax_amt'=>$cd->total_tax_amt,
':total_amt'=>$cd->total_amt,
':inv_status'=>'INVOICED',
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_ship_ar_details where created_by=:uid and temp_code=:temp_code and sub_ard_doc_number=:sub_ard_doc_number");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username,
  ':sub_ard_doc_number'=>$c->sub_ar_doc_number));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$acid=$data["id"][0]["id"];

//insert in the order cost
$statement = $db->prepare("INSERT INTO mt_order_cost
(
order_id,
type,
charge_desc,
basis_type,
basis_uom,
qty,
currency,
ex_rate,
rate_selling,
selling_base_amount,
remarks,
billing_party,
ip,ua,ekey,created_by,created_date,acid
)
VALUES
(
(SELECT id from mt_order_entry where order_no='$order_no'),
'INCOME',
:charge_desc,
:basis_type,
:basis_uom,
:qty,
:currency,
:ex_rate,
:selling_amount,
:selling_amount,
:remarks,
:customer,
:ip,:ua,:ekey,:created_by,now(),$acid)");
$statement->execute(array(':ip'=>$dev->ip,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':created_by'=>$dev->username,

':charge_desc'=>$cd->charge_desc,
':basis_type'=>$cd->basis_type,
':basis_uom'=>$cd->basis_uom,
':qty'=>$cd->qty,
':currency'=>$cd->currency,
':ex_rate'=>$cd->ex_rate,

':selling_amount'=>$cd->selling_amount,
':remarks'=>$cd->remarks,
':customer'=>$cd->customer
));
if ($statement->rowCount()){
  $data["oc_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["oc_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;

}


public static function update_invoice_entry_ac($dev,$cd)
{

$data=array();
try
{
$db = Factory::getConnection();
$temp_code=uniqid($dev->uid);

  $q="UPDATE mt_ship_ar_details SET
  sub_ard_currency=:sub_ard_currency,
  sub_ard_ex_rate=:sub_ard_ex_rate,
  sub_ard_local_amount=:sub_ard_local_amount,
  sub_ard_narration=:sub_ard_narration,
  sub_ard_basis=:sub_ard_basis,
  sub_ard_rate=:sub_ard_rate,
  sub_ard_quantity=:sub_ard_quantity,
  charge_desc=:charge_desc,
  basis_type=:basis_type,
  taxable=:taxable,
  total_tax_amt=:total_tax_amt,
  total_amt=:total_amt 
  where id=:id";
$statement = $db->prepare($q);

if($cd->ex_rate=="")
{
  $cd->ex_rate=null;
}

if($cd->net_amt=="")
{
  $cd->net_amt=null;
}

$statement->execute(array(


':sub_ard_currency'=>$cd->currency,
':sub_ard_ex_rate'=>$cd->ex_rate,

':sub_ard_local_amount'=>$cd->net_amt,
':sub_ard_narration'=>$cd->remarks,

':sub_ard_basis'=>$cd->basis_uom,
':sub_ard_rate'=>$cd->selling_amount,
':sub_ard_quantity'=>$cd->qty,
':charge_desc'=>$cd->charge_desc,
':basis_type'=>$cd->basis_type,
':taxable'=>$cd->taxable,

':total_tax_amt'=>$cd->total_tax_amt,
':total_amt'=>$cd->total_amt,
':id'=>$cd->id,

));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}



//insert in the order cost
$statement = $db->prepare("UPDATE mt_order_cost
SET charge_desc,
basis_type,
basis_uom,
qty,
currency,
ex_rate,
rate_selling=:selling_amount,
selling_base_amount=:selling_amount,
remarks=:remarks,

where acid=id");
$statement->execute(array(
':charge_desc'=>$cd->charge_desc,
':basis_type'=>$cd->basis_type,
':basis_uom'=>$cd->basis_uom,
':qty'=>$cd->qty,
':currency'=>$cd->currency,
':ex_rate'=>$cd->ex_rate,

':selling_amount'=>$cd->selling_amount,
':remarks'=>$cd->remarks,
':id'=>$cd->id
));
if ($statement->rowCount()){
  $data["oc_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["oc_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;

}

public static function delete_invoice_entry_ac($dev,$code)
{

$data=array();
try
{
$db = Factory::getConnection();

$q="DELETE from mt_ship_ar_details where id=:id";
$statement = $db->prepare($q);

$statement->execute(array(
':id'=>$code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$q="DELETE from mt_order_cost where acid=:id";
$statement = $db->prepare($q);

$statement->execute(array(
':id'=>$code
));

if ($statement->rowCount()){
  $data["cost_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["cost_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;

}

//START DXB_FF SAVE_WITH_VAT_DRAFT
public static function save_invoice_entry_sea_draft($dev,$code)
{
$data=array();

try
{
$db = Factory::getConnection();
$db->beginTransaction();

$temp_code=uniqid($dev->uid);

$c=$code->inv;

$igst=0;
$cds=$code->cd;

for($i=0;$i<count($cds);$i++)
  {
    $cd=$cds[$i];
    $cd->tax_percentage=$c->gst_percent;
    if($cd->tax_percentage!=0)
    {
    $igst=$igst+round($cd->total_amt*$cd->tax_percentage/100,2);
    }
  }
//END VAT CALC

$data["vat"]=$igst;

$statement = $db->prepare("INSERT into 
  mt_order_ar_header_draft(sub_ar_company,
  sub_ar_doc_type,sub_ar_doc_number,sub_ar_doc_base,sub_ar_gl_date,sub_ar_due_date,sub_ar_age_date,sub_ar_date,sub_ar_other_reference,sub_ar_currency,sub_ar_ex_rate,sub_place_off_supply,sub_place_off_supply_date,sub_ar_narration,sub_ar_notes,sub_ar_code,
  sub_ar_group,
  sub_ar_status, 
  sub_ar_other_reference_date,
  ip,created_by ,ua,ekey,created_date,temp_code,total_local_amt,order_no,
  bl_no,sub_ar_user,sub_ar_f_amount,sub_ar_l_amount,
  company_id,location_id,gst_percent,igst) 
values(:company_id,:sub_ar_doc_type,:sub_ar_doc_number,:sub_ar_doc_base,:sub_ar_gl_date,:sub_ar_due_date,:sub_ar_age_date,:sub_ar_date,:sub_ar_other_reference,:sub_ar_currency,:sub_ar_ex_rate,:sub_place_off_supply,:sub_place_off_supply_date,:sub_ar_narration,:sub_ar_notes,:sub_ar_code,
(select gl_account from mt_gl_link where name='RECEIVABLE' limit 1),
:sub_ar_status,
:sub_ar_other_reference_date,
:ip ,:created_by ,
:ua ,:ekey,now(),:temp_code,:total_local_amt,:order_no,
  :bl_no,:sub_ar_user,:total_local_amt,:total_local_amt,
:company_id,:location_id,:gst_percent,:igst)");

if($c->sub_ar_due_date=="")
{
  $c->sub_ar_due_date=null;
}

if($c->sub_ar_other_reference_date=="")
{
  $c->sub_ar_other_reference_date=null;
}

if($c->sub_ar_ex_rate=="")
{
  $c->sub_ar_ex_rate=null;
}

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company_id'=>$dev->company,
':sub_ar_doc_type'=>$c->sub_ar_doc_type,
':sub_ar_doc_number'=>$c->sub_ar_doc_number,
':sub_ar_doc_base'=>$c->sub_ar_doc_base,
':sub_ar_gl_date'=>$c->sub_ar_gl_date,
':sub_ar_due_date'=>$c->sub_ar_due_date,
':sub_ar_age_date'=>$c->sub_ar_date,
':sub_ar_date'=>$c->sub_ar_date,
':sub_ar_other_reference'=>$c->sub_ar_other_reference,
':sub_ar_currency'=>$c->sub_ar_currency,
':sub_ar_ex_rate'=>$c->sub_ar_ex_rate,
':sub_place_off_supply'=>$c->sub_place_off_supply,
':sub_place_off_supply_date'=>$c->sub_place_off_supply_date,
':sub_ar_narration'=>$c->sub_ar_narration,
':sub_ar_notes'=>$c->sub_ar_notes,
':sub_ar_code'=>$c->sub_ar_code,
':sub_ar_status'=>'P',
':sub_ar_other_reference_date'=>$c->sub_ar_other_reference_date,
':igst'=>$igst,

':temp_code'=>$temp_code,
':total_local_amt'=>$c->total_local_amt,
':order_no'=>$code->order_no,
':bl_no'=>$code->bl_no,
':sub_ar_user'=>$dev->username,
':gst_percent'=>$c->gst_percent,
':company_id'=>$dev->company,
':location_id'=>$dev->location
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";

}

//generate doc number

$data["temp_code"]=$temp_code;

$statement = $db->prepare("SELECT id from mt_order_ar_header_draft where created_by=:created_by and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

$fid=self::setFourDigit($op[0]["id"]);

$on="DRAFT/".$fid;

 $statement = $db->prepare("UPDATE mt_order_ar_header_draft 
  SET sub_ar_doc_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
  if ($statement->rowCount()){
    $data["invid_status"]=1;
  } else{
    $data["invid_status"]=0;
  }

$data["doc_no"]=$on;

//doc number ends

$order_id=0;
$order_details_insert_count=0;

if($data["status"]==1)
{
  $cds=$code->cd;
  $ocds=$code->ocd;

  $q="INSERT into mt_order_ar_details_draft(
      sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,sub_ard_currency,sub_ard_ex_rate,sub_ard_foreign_amount,sub_ard_local_amount,sub_ard_narration,sub_ard_notes,sub_ard_detail_1,sub_ard_detail_2,sub_ard_detail_3,sub_ard_detail_4,sub_ard_detail_5,sub_ard_detail_6,sub_ard_basis,sub_ard_rate,sub_ard_quantity,ip,created_by ,ua,ekey,created_date,charge_desc,basis_type,taxable,total_tax_amt,total_amt,
      inv_status,charge_id,tax_percentage) 
      VALUES(:sub_ard_company,:sub_ard_doc_type,:sub_ard_doc_number,:sub_ard_serial,:sub_ard_currency,:sub_ard_ex_rate,:sub_ard_foreign_amount,:sub_ard_local_amount,:sub_ard_narration,:sub_ard_notes,:sub_ard_detail_1,:sub_ard_detail_2,:sub_ard_detail_3,:sub_ard_detail_4,:sub_ard_detail_5,:sub_ard_detail_6,:sub_ard_basis,:sub_ard_rate,:sub_ard_quantity,:ip,:created_by,:ua,:ekey,now(),:charge_desc,:basis_type,:taxable,:total_tax_amt,:total_amt,
:inv_status,:charge_id,:tax_percentage)";


$i=0;
$c->sub_ar_doc_number = $on;

  for(;$i<count($cds);$i++)
  {
    $cd=$cds[$i];
    $cd->tax_percentage=$c->gst_percent;
    $statement = $db->prepare($q);
    $ar=self::setChargeDetails('MANIFEST',$cd,$dev,$c,$i);
    $ar[':inv_status']='PROFORMA';
    $statement->execute($ar);

    if ($statement->rowCount())
    {
      $order_details_insert_count+=1;
    }
  }
}

//$data["status"]=0;
if($data["invid_status"]==1 && $data["status"]==1 && count($cds)==$order_details_insert_count)
{
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
    $db->rollBack();

  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";

  }
  
  return $data;
}
//END DXB_FF SAVE_WITH_VAT_DRAFT

}

?>