<?php


require("../config/dbconn.php");

class PDFDao

{



public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_notify_parties($orderno)
{

$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT (SELECT name from mt_business_partner where code=party_name) cname FROM `mt_order_parties` WHERE `party_type`='NOTIFY PARTY' and order_id in (SELECT id from mt_order_entry where order_no in ($orderno)) ");

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

//var_dump($statement->debugDumpParams());
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function get_voyage_detail_report($voyage)
{

$data=array();
try
{
$db = Factory::getConnection();

//GET LINE VOYAGE
$statement = $db->prepare("SELECT vessel,line_voyage from mt_voyage
where voyage=:voyage ");

$statement->execute(array(':voyage'=>$voyage));
$data["line_voyage"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$lv="EMPTY";
if(strlen($data["line_voyage"][0]["line_voyage"])!=0 )
{
  $lv=$data["line_voyage"][0]["line_voyage"];
}

//BL wise grouping
$statement = $db->prepare("SELECT 
  st_carrier,
  st_port,
st_vessel,
st_voyage,
st_bl,
st_doc_number,
st_doc_base,
(SELECT name from mt_business_partner where code=st_detail_1 limit 1) customer,
st_currency,
(sum(st_local)*-1) credit,
(SELECT arm_t_amount FROM mt_ar_match_details WHERE arm_t_number=t1.st_doc_number limit 1) receipt
FROM mt_ship_trans t1  
WHERE (st_doc_base='SHIP'  or st_doc_base='RCT')  and st_voyage in (:voyage,:lv)  
and (st_status='ACTIVE')
and st_doc_number not in (select do_no from mt_delivery_order where auto_invoice=1 and do_no=st_doc_number) 
GROUP BY 
st_carrier,
st_port,
st_vessel,
st_voyage,
st_bl,
st_doc_number,
st_doc_base,
st_detail_1,
st_currency 

UNION

SELECT 
  (SELECT liner from mt_voyage where voyage=:voyage) st_carrier,
  (SELECT port from mt_voyage where voyage=:voyage) st_port,
(SELECT vessel from mt_voyage where voyage=:voyage) st_vessel,
'".$voyage."' st_voyage,
'' st_bl,
st_doc_number,
st_doc_base,
(SELECT name from mt_business_partner where code=st_detail_1 limit 1) customer,
st_currency,
(sum(st_local)*-1) credit,
(SELECT arm_t_amount FROM mt_ar_match_details WHERE arm_t_number=t1.st_doc_number limit 1) receipt
FROM (
SELECT * from mt_ship_trans where (st_doc_base='SHIP'  or st_doc_base='RCT') and st_status='ACTIVE' and st_other_reference in (
SELECT order_no from mt_order_entry where id in (select order_id from mt_order_route where transport_reference=:voyage))) t1 
GROUP BY 
st_carrier,
st_port,
st_vessel,
st_voyage,
st_bl,
st_doc_number,
st_doc_base,
st_detail_1,
st_currency

");

$statement->execute(array(':voyage'=>$voyage,':lv'=>$lv));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);
//var_dump($statement->debugDumpParams());

//charge wise grouping
/*$statement = $db->prepare("SELECT 
(select description from mt_charge_group_detail where code=st_charge) st_charge,
(sum(st_local)*-1) credit,sum(st_balance) balance
FROM mt_ship_trans 
WHERE st_doc_base='SHIP' and st_voyage=:voyage 
GROUP BY st_charge");
*/

//show payables
$statement = $db->prepare("SELECT 
st_carrier,
st_vessel,
st_voyage,
st_doc_number,st_narration, (sum(st_local)*-1) credit
FROM mt_ship_trans t1  
WHERE (st_doc_base in ('PAYABLE VOUCHER','ACCOUNTS PAYABLE') )  and st_voyage in (:voyage,:lv)  and st_status in ('ACTIVE','P') 
GROUP BY st_carrier,
st_vessel,
st_voyage,
st_doc_number,st_narration");

$statement->execute(array(':voyage'=>$voyage,':lv'=>$lv));
$data["chargewise"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//show brokerage
$statement = $db->prepare("SELECT (SELECT name from mt_business_partner where code=ap_code) broker, 
CASE charge_basis when 'PER VESSEL' then
(select charge_code from mt_brokerage_setup where ap_code=t1.ap_code and amount=t1.l_amount and vessel=(select vessel from mt_voyage where voyage=t1.voyage) ) 
ELSE
(select charge_code from mt_brokerage_setup where ap_code=t1.ap_code and vessel=(select vessel from mt_voyage where voyage=t1.voyage) limit 1) 
END charge_desc,
charge_basis, tot_containers, currency, f_amount,l_amount  from mt_brokerage_calculation t1 where voyage in (:voyage,:lv)  ");

$statement->execute(array(':voyage'=>$voyage,':lv'=>$lv));
$data["brokerage"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//var_dump($statement->debugDumpParams());
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function get_cargo_manifest($voyage,$mt,$principal)
{

$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT t2.vessel, t2.captain_name, t2.port, t2.next_port, t2.atd, t2.eta, t2.voyage
from mt_voyage t2 where t2.voyage=:voyage");

$statement->execute(array(':voyage'=>$voyage));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT t1.id, t1.bl_no, 
(select case when port_name!=country_name THEN
concat(port_name,', ', country_name) 
ELSE
port_name
end  
from mt_port_master it1 
left join mt_country_master it2
on it1.PORT_COUNTRY=it2.country_code
where port_code=t3.poo) poo, 
(select case when port_name!=country_name THEN
concat(port_name,', ', country_name) 
ELSE
port_name
end  
from mt_port_master it1 
left join mt_country_master it2
on it1.PORT_COUNTRY=it2.country_code
where port_code=t3.pol) pol, 
(select case when port_name!=country_name THEN
concat(port_name,', ', country_name) 
ELSE
port_name
end 
from mt_port_master it1 
left join mt_country_master it2
on it1.PORT_COUNTRY=it2.country_code
where port_code=t3.pod) pod,  
(select case when port_name!=country_name THEN
concat(port_name,', ', country_name) 
ELSE
port_name
end  
from mt_port_master it1 
left join mt_country_master it2
on it1.PORT_COUNTRY=it2.country_code
where port_code=t3.pof) pof, 

(select name from mt_business_partner where code=(select party_name from mt_manifest_entry_party where mnf_entry_pk=t1.id and party_type='SHIPPER' limit 1)) shipper,
  (select address from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=(select party_name from mt_manifest_entry_party where mnf_entry_pk=t1.id and party_type='SHIPPER' limit 1)) limit 1) shipper_address, 
  (select address2 from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=(select party_name from mt_manifest_entry_party where mnf_entry_pk=t1.id and party_type='SHIPPER' limit 1)) limit 1) shipper_address2, 
  (select address3 from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=(select party_name from mt_manifest_entry_party where mnf_entry_pk=t1.id and party_type='SHIPPER' limit 1)) limit 1) shipper_address3,
  
(select name from mt_business_partner where code=(select party_name from mt_manifest_entry_party where mnf_entry_pk=t1.id and party_type='CONSIGNEE' limit 1)) consignee, 
  (select address from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=(select party_name from mt_manifest_entry_party where mnf_entry_pk=t1.id and party_type='CONSIGNEE' limit 1)) limit 1) consignee_address, 
  (select address2 from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=(select party_name from mt_manifest_entry_party where mnf_entry_pk=t1.id and party_type='CONSIGNEE' limit 1)) limit 1) consignee_address2, 
  (select address3 from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=(select party_name from mt_manifest_entry_party where mnf_entry_pk=t1.id and party_type='CONSIGNEE' limit 1)) limit 1) consignee_address3,
  
(select name from mt_business_partner where code=(select party_name from mt_manifest_entry_party where mnf_entry_pk=t1.id and party_type='NOTIFY PARTY' limit 1)) notify,
  (select address from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=(select party_name from mt_manifest_entry_party where mnf_entry_pk=t1.id and party_type='NOTIFY PARTY' limit 1)) limit 1) np_address, 
  (select address2 from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=(select party_name from mt_manifest_entry_party where mnf_entry_pk=t1.id and party_type='NOTIFY PARTY' limit 1)) limit 1) np_address2, 
  (select address3 from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=(select party_name from mt_manifest_entry_party where mnf_entry_pk=t1.id and party_type='NOTIFY PARTY' limit 1)) limit 1) np_address3,

t4.marks,
t4.description

from mt_manifest_entry t1
left join mt_manifest_entry_landingcraft t2
on t1.id=t2.mnf_entry_pk
left join mt_manifest_entry_route t3
on t1.id=t3.mnf_entry_pk
left join mt_manifest_entry_marks t4
on t1.id=t4.mnf_entry_pk
where t3.voyage=:voyage 
and :principal = (select principal from mt_order_entry where bl_no=t1.bl_no limit 1) ");

$statement->execute(array(':voyage'=>$voyage,':principal'=>$principal));
$data["cargos"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}


public static function get_tdr_export($voyage,$mt,$principal)
{

$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT t2.vessel, t2.captain_name, (select port_name from mt_port_master where port_code=t2.port) port, t2.next_port, t2.atd, t2.eta, t2.voyage,
  case when t2.atd is null or t2.atd='' then
    'AWAITING SAIL'
  else
    'SAILED'
  end as sail_status

from mt_voyage t2 where t2.voyage=:voyage");

$statement->execute(array(':voyage'=>$voyage));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT 

(select bl_no from mt_manifest_entry where id=t2.mnf_entry_pk) bl_no,
t2.container_no,
t2.type,
t2.seal_no,
(select shipment_type from mt_order_entry where order_no=(select order_no from mt_manifest_entry where id=t2.mnf_entry_pk limit 1) ) shipment_type, 
(select port_name from mt_port_master where port_code=(select pol from mt_manifest_entry_route where mnf_entry_pk=t2.mnf_entry_pk limit 1) ) pol,
(select port_name from mt_port_master where port_code=(select pod from mt_manifest_entry_route where mnf_entry_pk=t2.mnf_entry_pk limit 1) ) pod, 
(select port_name from mt_port_master where port_code=(select pof from mt_manifest_entry_route where mnf_entry_pk=t2.mnf_entry_pk limit 1) ) pof,
(select name from mt_business_partner where code=(select eline from mt_manifest_entry_route where mnf_entry_pk=t2.mnf_entry_pk limit 1) ) liner,
(select slot_operator from mt_manifest_entry_route where mnf_entry_pk=t2.mnf_entry_pk limit 1)  slot_operator,
(select main_commodity from mt_manifest_entry_cargo where mnf_entry_pk=t2.mnf_entry_pk limit 1) commodity,
'' un_no1,
'' imco1,
'' un_no2,
'' imco2,
'' reefer_set_temp,
'DIRECT' route_type,
(select name from mt_business_partner where code=(select party_name from mt_manifest_entry_party where party_type='DELIVERY AGENT' and mnf_entry_pk=t2.mnf_entry_pk limit 1) ) del_agent,
(select name from mt_business_partner where code=(select party_name from mt_manifest_entry_party where party_type='DELIVERY AGENT' and mnf_entry_pk=t2.mnf_entry_pk limit 1) ) dis_agent,
'' remarks 
from mt_manifest_entry_container t2
where t2.mnf_entry_pk in (select id from mt_manifest_entry where voyage=:voyage )
 ");

$statement->execute(array(':voyage'=>$voyage));
$data["cargos"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT 
t2.type,
count(t2.container_no) cs_count
from mt_manifest_entry_container t2
where t2.mnf_entry_pk in (select id from mt_manifest_entry where voyage=:voyage)
group by t2.type 
 ");

$statement->execute(array(':voyage'=>$voyage));
$data["container_summary"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function get_sob_export($voyage,$mt,$principal)
{

$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT t2.vessel, t2.captain_name, (select port_name from mt_port_master where port_code=t2.port) port, t2.next_port, t2.etd, t2.atd, t2.eta, t2.voyage,
  case when t2.atd is null or t2.atd='' then
    'AWAITING SAIL'
  else
    'SAILED'
  end as sail_status

from mt_voyage t2 where t2.voyage=:voyage");

$statement->execute(array(':voyage'=>$voyage));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT 

(select bl_no from mt_manifest_entry where id=t2.mnf_entry_pk) bl_no,
(select order_no from mt_manifest_entry where id=t2.mnf_entry_pk) order_no,
t2.container_no,
t2.type,
t2.seal_no,
(select shipment_type from mt_order_entry where order_no=(select order_no from mt_manifest_entry where id=t2.mnf_entry_pk limit 1) ) shipment_type, 
(select port_name from mt_port_master where port_code=(select pol from mt_manifest_entry_route where mnf_entry_pk=t2.mnf_entry_pk limit 1) ) pol,
(select port_name from mt_port_master where port_code=(select pod from mt_manifest_entry_route where mnf_entry_pk=t2.mnf_entry_pk limit 1) ) pod, 
(select port_name from mt_port_master where port_code=(select pof from mt_manifest_entry_route where mnf_entry_pk=t2.mnf_entry_pk limit 1) ) pof,
(select name from mt_business_partner where code=(select eline from mt_manifest_entry_route where mnf_entry_pk=t2.mnf_entry_pk limit 1) ) liner,
(select slot_operator from mt_manifest_entry_route where mnf_entry_pk=t2.mnf_entry_pk limit 1)  slot_operator,
(select main_commodity from mt_manifest_entry_cargo where mnf_entry_pk=t2.mnf_entry_pk limit 1) commodity,
'' un_no1,
'' imco1,
'' un_no2,
'' imco2,
'' reefer_set_temp,
'DIRECT' route_type,
(select name from mt_business_partner where code=(select party_name from mt_manifest_entry_party where party_type='DELIVERY AGENT' and mnf_entry_pk=t2.mnf_entry_pk limit 1) ) del_agent,
(select name from mt_business_partner where code=(select party_name from mt_manifest_entry_party where party_type='DELIVERY AGENT' and mnf_entry_pk=t2.mnf_entry_pk limit 1) ) dis_agent,
'' remarks 
from mt_manifest_entry_container t2
where t2.mnf_entry_pk in (select id from mt_manifest_entry where voyage=:voyage and board_status='SHIPPED ON-BOARD' ) 
 ");

$statement->execute(array(':voyage'=>$voyage));
$data["cargos"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT 
t2.type,
count(t2.container_no) cs_count
from mt_manifest_entry_container t2
where t2.mnf_entry_pk in (select id from mt_manifest_entry where voyage=:voyage)
group by t2.type 
 ");

$statement->execute(array(':voyage'=>$voyage));
$data["container_summary"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}


public static function get_receipt_voucher_info($id,$temp_code)
{

$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT 
  aloc_company,
  aloc_base_doc vt,
  aloc_doc_type doc_type,
  aloc_doc_number doc_no,
aloc_allocation_type,
aloc_foreign_amount famt,
aloc_local_amount lamt,
aloc_narration,
  aloc_notes,aloc_detail_5,aloc_account,aloc_currency,aloc_ex_rate,
  (SELECT description from mt_bank_list where bank_code=aloc_detail_1) aloc_detail_1,aloc_detail_2,aloc_detail_3,
  (SELECT name from mt_business_partner where code=aloc_detail_2) customer_name, aloc_detail_2,
  created_by,created_date       
FROM mt_receipt_allocation_details where aloc_doc_number=(SELECT rh_doc_number from mt_receipt_header where id=:id and temp_code=:temp_code limit 1) and aloc_local_amount !=''");

$statement->execute(array(
':id'=>$id,
':temp_code'=>$temp_code
));
$data["details"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT id,
rh_company,
rh_base_doc_type,
rh_doc_type,
rh_doc_number,
rh_internal_number,
rh_doc_date,
rh_gl_date,
rh_clearance_date,
rh_cleared_date,
(select description from mt_bank_list where bank_code=rh_cash_bank_code limit 1) rh_cash_bank_code,
rh_currency currency,
rh_exchange_rate,
rh_foreign_amount,
rh_local_amount,
rh_other_reference,
rh_cheque_number,
rh_cheque_date,
rh_drawer_account,
rh_branch,
rh_narration,
rh_notes,
rh_type,
rh_status status,
rh_created_on,
rh_created_by,
rh_total_tax,
rh_gl_account,
rh_cost_center,
  company_id, location_id 
 from mt_receipt_header where id=:id and temp_code=:temp_code limit 1 ");

$statement->execute(array(
':id'=>$id,
':temp_code'=>$temp_code
));
$data["header"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get Matching Data
$statement = $db->prepare("SELECT (SELECT name from mt_business_partner where code=arm_m_ar limit 1)  party,
  arm_m_ar, arm_t_number doc_no, arm_t_type doc_type,arm_m_amount,
arm_t_balance, arm_t_amount FROM mt_ar_match_details WHERE arm_m_number=(SELECT rh_doc_number from mt_receipt_header where id=:id) and arm_status!='CANCELLED' 

UNION

SELECT (SELECT name from mt_business_partner where code=arm_m_ar limit 1)  party,
  arm_m_ar, arm_t_number doc_no, arm_t_type doc_type,arm_m_amount,
arm_t_balance, arm_t_amount FROM mt_arap_match_details WHERE arm_m_number=(SELECT rh_doc_number from mt_receipt_header where id=:id) and arm_status!='CANCELLED'

");
$statement->execute(array(':id'=>$id));
$data["match"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//check match in t number

$statement = $db->prepare("SELECT (SELECT name from mt_business_partner where code=arm_m_ar limit 1)  party,
  arm_m_ar, arm_m_number doc_no, arm_m_type doc_type,arm_m_amount,
arm_t_balance, arm_t_amount FROM mt_ar_match_details WHERE arm_t_number=(SELECT rh_doc_number from mt_receipt_header where id=:id) and arm_status!='CANCELLED' 

UNION

SELECT (SELECT name from mt_business_partner where code=arm_m_ar limit 1)  party,
  arm_m_ar, arm_m_number doc_no, arm_m_type doc_type,abs(arm_m_amount) arm_m_amount,
abs(arm_t_balance) arm_t_balance, abs(arm_t_amount) arm_t_amount FROM mt_arap_match_details WHERE arm_t_number=(SELECT rh_doc_number from mt_receipt_header where id=:id) and arm_status!='CANCELLED'

");
$statement->execute(array(':id'=>$id));

$data["match1"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["match"]=array_merge($data["match"],$data["match1"]);

//Get clearance date
$statement = $db->prepare("SELECT art_doc_date,art_type FROM mt_ar_trans WHERE art_number=(SELECT rh_doc_number from mt_receipt_header where id=:id)
");
$statement->execute(array(':id'=>$id));
$data["date"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//var_dump($statement->debugDumpParams());
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function get_payment_voucher_info($id,$temp_code)
{

$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("SELECT 
  aloc_company,
  aloc_base_doc vt,
  aloc_doc_type doc_type,
  aloc_doc_number doc_no,
aloc_allocation_type,
aloc_foreign_amount famt,
aloc_local_amount lamt,
aloc_narration,
  aloc_notes,aloc_detail_5,aloc_account,aloc_currency,aloc_ex_rate,
  (SELECT description from mt_bank_list where bank_code=aloc_detail_1) aloc_detail_1,aloc_detail_2,aloc_detail_3,
  (SELECT name from mt_business_partner where code=aloc_detail_2) customer_name, aloc_detail_2 ,
  (SELECT ac_description FROM mt_general_ledger where code=aloc_detail_1) gl_desc, 
  (SELECT cost_description FROM mt_cost_center_master where cost_code=aloc_detail_3) cc_desc,
  created_by,created_date  
FROM mt_payment_allocation_details where aloc_doc_number=(SELECT ph_doc_number from mt_payment_header where id=:id and temp_code=:temp_code limit 1) and aloc_local_amount !=''");

$statement->execute(array(
':id'=>$id,
':temp_code'=>$temp_code
));
$data["details"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT id,
ph_company,
ph_base_doc_type,
ph_doc_type,
ph_doc_number,
ph_internal_number,
ph_doc_date,
ph_gl_date,
ph_clearance_date,
ph_cleared_date,
(select description from mt_bank_list where bank_code=ph_cash_bank_code limit 1) ph_cash_bank_code,
ph_currency currency,
ph_exchange_rate,
ph_foreign_amount,
ph_local_amount,
ph_other_reference,
ph_cheque_number,
ph_cheque_date,
ph_drawer_account,
ph_branch,
ph_narration,
ph_notes,
ph_type,
ph_status status,
ph_created_on,
ph_created_by,
ph_total_tax,
ph_gl_account,
ph_cost_center,
  company_id, location_id  
 from mt_payment_header where id=:id and temp_code=:temp_code limit 1 ");

$statement->execute(array(
':id'=>$id,
':temp_code'=>$temp_code
));
$data["header"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get Matching Data
$statement = $db->prepare("SELECT (SELECT name from mt_business_partner where code=apm_m_ar)  party, apm_t_number doc_no, apm_t_type doc_type,apm_m_amount,
apm_t_balance,apm_m_ar, apm_t_amount FROM mt_ap_match_details WHERE apm_m_number=(SELECT ph_doc_number from mt_payment_header where id=:id) and 
apm_status!='CANCELLED'
UNION
SELECT (SELECT name from mt_business_partner where code=arm_m_ar)  party, arm_t_number doc_no, arm_t_type doc_type,arm_m_amount,
arm_t_balance,arm_m_ar, arm_t_amount FROM mt_arap_match_details WHERE arm_m_number=(SELECT ph_doc_number from mt_payment_header where id=:id) and 
arm_status!='CANCELLED' ");
$statement->execute(array(':id'=>$id));
$data["match"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//var_dump($statement->debugDumpParams());
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function get_payable_voucher_info($id,$temp_code)
{

$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT * FROM mt_ap_header where id=:id 
  and temp_code=:temp_code");
$statement->execute(array(':id'=>$id,':temp_code'=>$temp_code));
$data["info2"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$customer_code=$data["info2"][0]["aph_code"];

$statement = $db->prepare("SELECT 
  aph_company company,
  aph_code code,
  t4.name customer,
  t4.address address,
  t4.phone telephone,
  t4.cr_no cr_no,

  aph_group groups,
  aph_document_base vt,
  aph_document_type doc_type,
  aph_document_number doc_no,
aph_limit_base limit_base,
aph_document_date doc_date,
aph_gl_date gl_date,
aph_due_date due_date,
aph_other_reference ref,
aph_currency currency,
aph_exchange_rate ex_rate,
aph_foreign_amount famt,
aph_local_amount lamt,
aph_narration narration,
aph_post_date post_date,
aph_status status,
aph_notes notes 
FROM mt_ap_header t1,
(SELECT cr_no,code,name,address,phone 
  from mt_business_partner t2 
  LEFT JOIN mt_bp_address t3 
  on t2.id=t3.bp_id and t3.type='HQ'
  where t2.code=:code) t4 
  where t4.code=t1.aph_code and t1.id=:id and t1.temp_code=:temp_code");

$statement->execute(array(':id'=>$id,
  ':temp_code'=>$temp_code,
  ':code'=>$customer_code));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT 
  aloc_company,
  aloc_base_doc,
  aloc_doc_type,
  aloc_doc_number,
  aloc_allocation_type,
aloc_foreign_amount famt,
aloc_local_amount lamt,
  aloc_narration description,
  aloc_currency currency,
  aloc_ex_rate,
  aloc_detail_4,aloc_detail_5,
  (SELECT description from mt_charge_group_detail where code=aloc_narration) charge_desc2,
  (SELECT description from mt_charge_group_detail where code=aloc_detail_3) charge_desc1,
  (SELECT description from mt_charge_group_detail where code=aloc_detail_5) charge_desc,
  aloc_detail_1,  aloc_detail_2,  aloc_detail_3,
   (SELECT ac_description FROM mt_general_ledger where code=aloc_detail_1) gl_desc, 
   (SELECT cost_description FROM mt_cost_center_master where cost_code=aloc_detail_3) cc_desc,
  reference,ref_date,
  ap_customer,ap_activity,ap_cust_address,
voyage,vessel,liner,bl_no,ship_activity,
order_type,order_no,order_activity  
FROM mt_ap_allocation_details where aloc_doc_number=:doc_no and aloc_local_amount !=''");

$statement->execute(array(
':doc_no'=>$data["info"][0]["doc_no"]
));
$data["details"]=$statement->fetchAll(PDO::FETCH_ASSOC);


//Get Matching Data
$statement = $db->prepare("SELECT (SELECT name from mt_business_partner where code=apm_m_ar)  party,apm_m_ar arm_m_ar, apm_t_number doc_no, apm_t_type doc_type,apm_m_amount arm_m_amount,
apm_t_balance arm_t_balance, apm_t_amount arm_t_amount FROM mt_ap_match_details WHERE apm_m_number=(SELECT aph_document_number from mt_ap_header where id=:id)
UNION
SELECT (SELECT name from mt_business_partner where code=arm_m_ar limit 1)  party,
  arm_m_ar , arm_t_number doc_no, arm_t_type doc_type,arm_m_amount,
arm_t_balance, arm_t_amount FROM mt_arap_match_details WHERE 
(arm_m_number=(SELECT aph_document_number from mt_ap_header where id=:id) or
arm_t_number=(SELECT aph_document_number from mt_ap_header where id=:id)
) and arm_status!='CANCELLED'
");
$statement->execute(array(':id'=>$id));
$data["match"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//var_dump($statement->debugDumpParams());
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function get_receivable_voucher_info($id,$temp_code)
{

$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT 
  arh_company company,
  arh_code code,
 (SELECT name from mt_business_partner where code=arh_code) customer, 
 (SELECT address from mt_bp_address where type='HQ' and bp_id=(SELECT id from mt_business_partner where code=arh_code)) address, 
  arh_group groups,
  arh_document_base vt,
  arh_document_type doc_type,
  arh_document_number doc_no,
arh_limit_base limit_base,
arh_document_date doc_date,
arh_gl_date gl_date,
arh_due_date due_date,
arh_other_reference ref,
arh_currency currency,
arh_exchange_rate ex_rate,
arh_foreign_amount famt,
arh_local_amount lamt,
arh_narration narration,
arh_post_date post_date,
arh_status status,
arh_notes notes 
FROM mt_ar_header t1  
  where t1.id=:id and t1.temp_code=:temp_code");

$statement->execute(array(':id'=>$id,':temp_code'=>$temp_code));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT 
  aloc_company,
  aloc_base_doc,
  aloc_doc_type,
  aloc_doc_number,
  aloc_allocation_type,
aloc_foreign_amount famt,
aloc_local_amount lamt,
  aloc_narration description,
  aloc_currency currency,
  aloc_ex_rate,
  reference,ref_date,
  ar_customer,ar_activity,ar_cust_address,
voyage,vessel,liner,bl_no,ship_activity,
order_type,order_no,order_activity, aloc_detail_1, aloc_detail_2, aloc_detail_3,
  (SELECT description from mt_charge_group_detail where code=aloc_narration) charge_desc2,
  (SELECT description from mt_charge_group_detail where code=aloc_detail_3) charge_desc1,
  (SELECT description from mt_charge_group_detail where code=aloc_detail_5) charge_desc    
FROM mt_ar_allocation_details where aloc_doc_number=:doc_no and aloc_local_amount !=''");

$statement->execute(array(
':doc_no'=>$data["info"][0]["doc_no"]
));
$data["details"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get Matching Data
$statement = $db->prepare("SELECT (SELECT name from mt_business_partner where code=arm_m_ar limit 1)  party,
  arm_m_ar, arm_t_number doc_no, arm_t_type doc_type,arm_m_amount,
arm_t_balance, arm_t_amount FROM mt_ar_match_details WHERE arm_m_number=(SELECT arh_document_number from mt_ar_header where id=:id) and arm_status!='CANCELLED' 

UNION

SELECT (SELECT name from mt_business_partner where code=arm_m_ar limit 1)  party,
  arm_m_ar, arm_t_number doc_no, arm_t_type doc_type,arm_m_amount,
arm_t_balance, arm_t_amount FROM mt_arap_match_details WHERE arm_m_number=(SELECT arh_document_number from mt_ar_header where id=:id) and arm_status!='CANCELLED'

");
$statement->execute(array(':id'=>$id));
$data["match"]=$statement->fetchAll(PDO::FETCH_ASSOC);


//var_dump($statement->debugDumpParams());
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function get_cargo_arrival_notice_detail_info($id,$bl_no,$temp_code)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT t1.id,
t1.voyage,
(SELECT vessel from mt_voyage where voyage=t1.voyage) vessel,
(SELECT eta from mt_voyage where voyage=t1.voyage) eta,
t1.bl_no,
t1.cargo_type,
t1.order_no,
(select port_name from mt_port_master where port_code=t2.poo) poo, 
(select port_name from mt_port_master where port_code=t2.pol) pol, 
(select port_name from mt_port_master where port_code=t2.pod) pod,  
(select port_name from mt_port_master where port_code=t2.pof) pof, 
(select name from mt_business_partner where code=(select party_name from mt_manifest_entry_party 
  where party_type='SHIPPER' and mnf_entry_pk=t1.id)) shipper,
t3.party_name consignee ,t3.email consignee_email,
   (select name from mt_business_partner where code=(select party_name from mt_manifest_entry_party 
  where party_type='NOTIFY PARTY' and mnf_entry_pk=t1.id)) notify,
  (select email from mt_manifest_entry_party 
  where party_type='NOTIFY PARTY' and mnf_entry_pk=t1.id)
  notify_email,
(SELECT last_advice_date from mt_cargo_arrival_notice_detail where bl_no=t1.bl_no order by last_advice_date desc limit 1) add1,
'' add2,
'' add3,
t1.temp_code,
t1.location_id,
t1.company_id   
from mt_manifest_entry t1, mt_manifest_entry_route t2 ,
(select (select name from mt_business_partner where code=t5.party_name) party_name,email,mnf_entry_pk from mt_manifest_entry_party t5
  where party_type='CONSIGNEE') t3 
where t1.id=t2.mnf_entry_pk and 
t1.id=t3.mnf_entry_pk  
and  t1.id=:id and t1.bl_no=:bl_no and t1.temp_code=:temp_code");
$statement->execute(array(':id'=>$id,':bl_no'=>$bl_no,
  ':temp_code'=>$temp_code));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT 
(select name from mt_business_partner where code=t1.party_name) party_name,
(select address from mt_bp_address where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name)) address,
email, telephone 
from mt_manifest_entry_party t1 
where party_type='CONSIGNEE'  
 and mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data["consignee"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT 
(select name from mt_business_partner where code=t1.party_name) party_name,
(select address from mt_bp_address where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name)) address,
email, telephone 
from mt_manifest_entry_party t1 
where party_type='NOTIFY PARTY'  
 and mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data["notify"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT 
(select name from mt_business_partner where code=t1.party_name) party_name,
(select address from mt_bp_address where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name)) address,
email, telephone 
from mt_manifest_entry_party t1 
where party_type='SHIPPER'  
 and mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data["shipper"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT  container_no, type, gr_wgt, 
  tt_wgt,ifnull((SELECT description from mt_commodity_master where code=commodity limit 1),commodity) commodity,reefer
from mt_manifest_entry_container 
 where mnf_entry_pk=:id UNION
 SELECT  vin_no container_no,vehicle_type `type`, gr_wgt, 
  tt_wgt,(SELECT description from mt_commodity_master where code=commodity limit 1) commodity,reefer
from mt_manifest_entry_landingcraft 
 where mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data["container"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get BreakBulk
$statement = $db->prepare("SELECT 
id,
mnf_entry_pk,
main_commodity,
equipment_serial,
package_type,
no_of_packages,
gross_weight,
weight_uom FROM mt_manifest_entry_cargo where mnf_entry_pk=:mnf_entry_pk ");

$statement->execute(array(':mnf_entry_pk'=>$id));
$data["breakbulk"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_noc($voyage,$id)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT t1.vessel_name,(select port_name from mt_port_master where port_code=t2.port) as port, t1.gt_nt, (select country_name from mt_country_master where country_code=t1.flag) flag, t2.registration_no,t2.captain_name, (select port_name from mt_port_master where port_code=t2.prev_port) as prev_port, (select port_name from mt_port_master where port_code=t2.next_port) as next_port,
ifnull(t2.ata,t2.eta) eta, ifnull(t2.atd,t2.etd) etd,t1.moulded_depth,t1.oil_consumption_harbour  charter_name, t2.call_type, t2.voyage 
from mt_vessel t1, mt_voyage t2
where t1.vessel_name=t2.vessel 
and t2.voyage=:voyage and t2.id=:id");
$statement->execute(array(':voyage'=>$voyage,':id'=>$id));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_pmc($voyage,$id)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT t1.vessel_name, t1.lloyds_imo_no, 
  t2.port,t2.ata,t2.atd 
from mt_vessel t1, mt_voyage t2
where t1.vessel_name=t2.vessel
and t2.voyage=:voyage and t2.id=:id");
$statement->execute(array(':voyage'=>$voyage,':id'=>$id));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_cargo_entry_ticket($bl_no,$id,$temp_code)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
  (SELECT lloyds_imo_no from mt_vessel WHERE vessel_name=t1.vessel) lloyds_imo_no, 
  t1.vessel,t2.voyage,t1.tot_load  
from mt_voyage t1, mt_manifest_entry t2 
where t1.voyage=t2.voyage and t2.id=:id and t2.bl_no=:bl_no and t2.temp_code=:temp_code
");
$statement->execute(array(':temp_code'=>$temp_code,
':id'=>$id,
':bl_no'=>$bl_no));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT vin_no from mt_manifest_entry_landingcraft
where mnf_entry_pk=:id");
$statement->execute(array(
':id'=>$id));
$data["lcs"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_voyage_summary($voyage)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
t1.id,
t1.voyage,
t1.bl_no,
t1.manifest_type,
t1.cargo_type,
(select party_name from mt_manifest_entry_party where party_type='CONSIGNEE' and mnf_entry_pk=t1.id) consignee, 
(select sum(cost_base_amount) from mt_manifest_entry_rate where type='INCOME' and mnf_entry_pk=t1.id) income,
(select sum(cost_base_amount) from mt_manifest_entry_rate where type='COST' and mnf_entry_pk=t1.id) cost,
(select status from mt_order_entry where order_no=t1.order_no limit 1) estatus 
  from mt_manifest_entry t1 
  where t1.voyage=:voyage ");
$statement->execute(array(':voyage'=>$voyage));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_security_memo($id,$voyage)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT t2.vessel_name,t1.eta,
  t2.vessel_type,t2.lloyds_imo_no imo_no,(select country_name from mt_country_master where country_code=t2.flag) flag,t2.year_built,
  t2.loa, t2.draft_sw,(select port_name from mt_port_master where port_code=t1.prev_port) last_port,t1.etd departure,
  (select port_name from mt_port_master where port_code=t1.next_port) next_port,t1.call_type typeofcargo, SUBSTRING_INDEX(t2.gt_nt, '/', 1) gt, 
  SUBSTRING_INDEX(t2.gt_nt, '/', -1) nt, t1.leg_number, t1.registration_no, t2.beam,
  t1.leg_number, t2.oil_consumption_harbour charter, t2.oil_consumption_sailing charter_nationality 
 from mt_voyage t1, mt_vessel t2  
 where 
 t1.vessel=t2.vessel_name and  
t1.id=:id and t1.voyage=:voyage");
$statement->execute(array(
  ':voyage'=>$voyage,
  ':id'=>$id
));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$db = Factory::getConnection();
$statement = $db->prepare("SELECT vc.validity,vc.cert_no, 
(select t1.parent_company from mt_business_partner t1 
where t1.code=vc.flex1) as parent_company,
(select t2.address from mt_business_partner t1, mt_bp_address t2
where t1.id=t2.bp_id and t1.code=vc.flex1) as address,
(select t2.email1 from mt_business_partner t1, mt_bp_address t2
where t1.id=t2.bp_id AND t1.code=vc.flex1) as email1,
(select t2.mobile1 from mt_business_partner t1, mt_bp_address t2
where t1.id=t2.bp_id and t1.code=vc.flex1) as mobile1,
(select t3.first_name from mt_business_partner t1, mt_bp_contact t3
where t1.id=t3.bp_id and t1.code=vc.flex1) as first_name
from mt_vessel_certificates vc
where vessel_pk=(select id from mt_vessel where vessel_name=(select vessel FROM mt_voyage where id=:id))
and cert_name='CERTIFICATE OF INSURANCE P&I COVERAGE'");
$statement->execute(array(':id'=>$id));
$data["insurance"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$db = Factory::getConnection();
$statement = $db->prepare("SELECT sum(gr_wgt) tot_gr_wgt from mt_manifest_entry_landingcraft where mnf_entry_pk in (select id from mt_manifest_entry where voyage=:voyage)");
$statement->execute(array(':voyage'=>$voyage));
$data["tot_gr_wgt"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT terminal_name,  DATE_FORMAT(berthing_date_time, '%Y-%m-%d') berthing_date_time, DATE_FORMAT(unberthing_date_time, '%Y-%m-%d') unberthing_date_time    
from mt_voyage_terminal
where voy_pk=:voyage");
$statement->execute(array(':voyage'=>$voyage));
$data["terminal"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_pre_arrival_notification($id,$voyage)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT t2.vessel_name,t1.eta,
  t2.vessel_type,t2.lloyds_imo_no imo_no,(select country_name from mt_country_master where country_code=t2.flag) flag,t2.year_built,
  t2.loa, t2.draft_sw,(select port_name from mt_port_master where port_code=t1.prev_port) last_port,t1.etd departure,
  (select port_name from mt_port_master where port_code=t1.next_port) next_port,t1.call_type typeofcargo, SUBSTRING_INDEX(t2.gt_nt, '/', 1) gt, 
  SUBSTRING_INDEX(t2.gt_nt, '/', -1) nt, t1.leg_number, t1.registration_no, t2.beam,
  t1.leg_number, t2.oil_consumption_harbour charter, t2.oil_consumption_sailing charter_nationality 
 from mt_voyage t1, mt_vessel t2  
 where 
 t1.vessel=t2.vessel_name and  
t1.id=:id and t1.voyage=:voyage");
$statement->execute(array(
  ':voyage'=>$voyage,
  ':id'=>$id
));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$db = Factory::getConnection();
$statement = $db->prepare("SELECT vc.validity,vc.cert_no, 
(select t1.parent_company from mt_business_partner t1 
where t1.code=vc.flex1) as parent_company,
(select t2.address from mt_business_partner t1, mt_bp_address t2
where t1.id=t2.bp_id and t1.code=vc.flex1) as address,
(select t2.email1 from mt_business_partner t1, mt_bp_address t2
where t1.id=t2.bp_id AND t1.code=vc.flex1) as email1,
(select t2.mobile1 from mt_business_partner t1, mt_bp_address t2
where t1.id=t2.bp_id and t1.code=vc.flex1) as mobile1,
(select t3.first_name from mt_business_partner t1, mt_bp_contact t3
where t1.id=t3.bp_id and t1.code=vc.flex1) as first_name
from mt_vessel_certificates vc
where vessel_pk=(select id from mt_vessel where vessel_name=(select vessel FROM mt_voyage where id=:id))
and cert_name='CERTIFICATE OF INSURANCE P&I COVERAGE'");
$statement->execute(array(':id'=>$id));
$data["insurance"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$db = Factory::getConnection();
$statement = $db->prepare("SELECT sum(gr_wgt) tot_gr_wgt from mt_manifest_entry_landingcraft where mnf_entry_pk in (select id from mt_manifest_entry where voyage=:voyage)");
$statement->execute(array(':voyage'=>$voyage));
$data["tot_gr_wgt"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_agent_insurance_coverage($id,$voyage)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT vessel, voyage,
  (SELECT lloyds_imo_no from mt_vessel where vessel_name=t1.vessel) imo_no, (SELECT flex1 from mt_vessel_certificates where vessel_pk=(select id from mt_vessel where vessel_name=t1.vessel) and cert_name='CERTIFICATE OF INSURANCE P&I COVERAGE') flex1 from mt_voyage t1 where id=:id and voyage=:voyage");
$statement->execute(array(
  ':voyage'=>$voyage,
  ':id'=>$id
));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT t1.name,t1.parent_company,t2.address, t2.email1, t2.mobile1, t3.first_name from mt_business_partner t1, mt_bp_address t2, mt_bp_contact t3
where t1.id=t2.bp_id AND t1.id=t3.bp_id and 
t1.code=:bp_code");
$statement->execute(array(
  ':bp_code'=>$data["info"][0]["flex1"]));
$data["ins_info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


//
public static function get_eventupdation_inspection_info($id,$pk)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,(SELECT  event_code from mt_event_updation where id=t1.event_upd_pk) event_code, event_upd_pk, inspection_date, valid_till, customer, vessel, eta , re_export_vessel, bl_no, pol, new_ty_no, truck_no, driver_name, driver_id, mobile_no, old_ty_no, chase_no, generator, gen_battery, gps, tyre1_lhs_serial_no, tyre2_lhs_serial_no, tyre3_lhs_serial_no, left_side_light, right_side_light, door_condition, door_lock, spare_tyre, spare_tyre_sr_no, remarks, attachment_1,sig_name,sig_url,min_temp,max_temp,actual_temp from mt_event_updation_inspection t1 
  where id=:id and event_upd_pk=:pk limit 1");
$statement->execute(array(':id'=>$id,':pk'=>$pk));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_payreceipt_details($temp_code,$id,$do_no)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT do_no, order_no, do_date, bl_no, remarks, narration,
  (select name from mt_business_partner where code=t1.consignee ) received_from,
  (select address from mt_bp_address where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.consignee) ) address,
  created_by,narration  
from mt_delivery_order t1
where do_no=:do_no and id=:id and temp_code=:temp_code");
$statement->execute(array(':do_no'=>$do_no,
  ':id'=>$id,':temp_code'=>$temp_code));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);



$statement = $db->prepare("SELECT id,do_pk,payment_mode,bank_code,bank_name,credit_cheque_no,
card_cheque_expiry_date,currency,foreign_amount,local_amount,cheque_clear_date,notes 
from mt_delivery_order_payment where do_pk=:do_pk");
$statement->execute(array(':do_pk'=>$id));
$data["pay"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT sum(local_amount) cheque_amount
from mt_delivery_order_payment where do_pk=:do_pk
and payment_mode='CHEQUE'
");
$statement->execute(array(':do_pk'=>$id));
$data["ca"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT sum(local_amount) total_amount
from mt_delivery_order_payment where do_pk=:do_pk");
$statement->execute(array(':do_pk'=>$id));
$data["ta"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_empty_container_acceptance($id,$c_no,$temp_code)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT t1.id,
  container_no,container_type,event_code,'' inspection_date, event_date,origin,load_port,discharge_port,final_destination,eorder,'' eta, bl_no,truck_no,'' driver_name, '' mobile_no, vessel, '' r1, '' r2 
FROM mt_event_updation t1
WHERE  t1.container_no like '%$c_no%' and t1.id=:id ");

$statement->execute(array(':id'=>$id));
//$data["q"]=$statement->debugDumpParams();
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT chassis_no FROM `mt_manifest_entry_landingcraft` WHERE `mnf_entry_pk`=(SELECT id from mt_manifest_entry WHERE bl_no=:bl_no) and vin_no=:vin_no");

$statement->execute(array(
  ':bl_no'=>$data["info"][0]["bl_no"],
  ':vin_no'=>$data["info"][0]["container_no"]
));
//$data["q"]=$statement->debugDumpParams();
$data["chassis_no"]=$statement->fetchAll(PDO::FETCH_ASSOC);


/*

SELECT t1.id,container_no,container_type,event_code,event_date,origin,load_port,discharge_port,final_destination,eorder,t2.eta, t2.bl_no,t2.truck_no,t2.driver_name, t2.mobile_no, t2.vessel, t1.remarks r1, t2.remarks r2 
FROM 
(SELECT * from mt_event_updation WHERE container_no like '%$c_no%' and event_code='EIC' and bl_no=(SELECT bl_no from mt_event_updation where id=:id and temp_code=:temp_code limit 1)
) 
t1, mt_event_updation_inspection t2
WHERE t1.id=t2.event_upd_pk 
 and t1.container_no like '%$c_no%'

//
SELECT t1.id,container_no,container_type,event_code,event_date,origin,load_port,discharge_port,final_destination,eorder,t2.eta, t2.bl_no,t2.truck_no,t2.driver_name, t2.mobile_no, t2.vessel, t1.remarks r1, t2.remarks r2 
FROM 
(SELECT * from mt_event_updation WHERE trim(container_no)=:c_no and event_code='EIC' and bl_no=(SELECT bl_no from mt_event_updation where id=:id and temp_code=:temp_code limit 1)
) 
t1, mt_event_updation_inspection t2
WHERE t1.id=t2.event_upd_pk 
 and trim(t1.container_no)=:c_no

 /// 

SELECT t1.id,container_no,container_type,event_code,event_date,origin,load_port,discharge_port,final_destination,eorder,t2.eta, t2.bl_no,t2.truck_no,t2.driver_name, t2.mobile_no, t2.vessel, t1.remarks r1, t2.remarks r2 
FROM mt_event_updation t1, mt_event_updation_inspection t2
WHERE t1.id=t2.event_upd_pk 
 and trim(t1.container_no)=:c_no and t1.id=:id and t1.temp_code=:temp_code
*/


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_empty_release_container($id,$temp_code)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,service_order,order_no,doc_date,valid_till,release_from,return_to,cut_off_date,van_location,van_date,instructions,additional_detail  
FROM mt_erc t1
WHERE t1.id=:id 
 and t1.temp_code=:temp_code");

$statement->execute(array(':id'=>$id,':temp_code'=>$temp_code));
//$data["q"]=$statement->debugDumpParams();
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT equipment_type,qty,status,remarks   
FROM mt_erc_equip_detail t1
WHERE t1.erc_id=:id ");

$statement->execute(array(':id'=>$id));
//$data["q"]=$statement->debugDumpParams();
$data["detail"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$order_no=$data["info"][0]["order_no"];

$statement = $db->prepare("SELECT id,
  (SELECT name from mt_business_partner where code=customer) customer,

   (SELECT name from mt_business_partner where code=t1.depot) depot, 
 (SELECT address from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=t1.depot)) d_add1,
 (SELECT address2 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=t1.depot)) d_add2,
 (SELECT address3 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=t1.depot)) d_add3,
  (SELECT city from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=t1.depot)) d_city,
   (SELECT zip from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=t1.depot)) d_zip,
  (SELECT mobile1 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=t1.depot)) d_mobile,
    (SELECT phone from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=t1.depot)) d_phone,
    (SELECT email1 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=t1.depot)) d_email,
    remarks 

from mt_order_entry t1
 where order_no=:order_no");
$statement->execute(array(':order_no'=>$order_no));
$data["depot"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_delivery_details_ebl($temp_code,$id,$do_no)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT do_party, 
  do_no, t1.order_no, do_date, do_validity_date, 
  (select name from mt_business_partner where code=t1.consignee) consignee, 
  t1.bl_no, 
  t2.cargo_type,
  (select port_name from mt_port_master where port_code=t1.poo) poo, 
  (select port_name from mt_port_master where port_code=t1.pol) pol, 
  (select port_name from mt_port_master where port_code=t1.pod) pod, 
  (select port_name from mt_port_master where port_code=t1.pof) pof, t1.remarks, t1.location_id, t1.company_id, 
 t3.vessel,t3.voyage,t3.eta,
 (select name from mt_business_partner where code=t3.liner) liner, 
 (select GROUP_CONCAT(marks) from mt_manifest_entry_marks 
 where mnf_entry_pk=t2.id) seal_no,
 (select port_name from mt_port_master where port_code=(SELECT shipment_to from mt_order_entry where order_no=t1.order_no)) shipment_to  
from mt_delivery_order t1,
mt_manifest_entry t2,
mt_voyage t3 
where do_no=:do_no and t1.id=:id and t1.temp_code=:temp_code 
and t2.voyage=t3.voyage 
and t1.bl_no=t2.bl_no limit 1");
$statement->execute(array(':do_no'=>$do_no,
  ':id'=>$id,':temp_code'=>$temp_code));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$bl_no=$data["info"][0]["bl_no"];
$order_id=$id;

$statement = $db->prepare("SELECT container_no,'' chassis_no,type, cargo_desc,package_type,no_of_pkgs,gr_wgt,nt_wgt, volume from mt_order_container_detail
 where order_id=  (select id from mt_order_entry where order_no=
(SELECT order_no from mt_delivery_order where do_no=:do_no and id=:id and temp_code=:temp_code)) 
UNION
SELECT vin_no container_no,(SELECT GROUP_CONCAT(chassis_no) from mt_manifest_entry_landingcraft where mnf_entry_pk=(
SELECT id from mt_manifest_entry where bl_no='$bl_no') and vin_no=t1.vin_no) chassis_no,vehicle_type type,cargo_desc,package_type,no_of_pkgs,gr_wgt,nt_wgt,volume 
from mt_order_landingcraft_detail t1
 where order_id=  (select id from mt_order_entry where order_no=
(SELECT order_no from mt_delivery_order where do_no=:do_no and id=:id and temp_code=:temp_code))");

$statement->execute(array(':do_no'=>$do_no,
  ':id'=>$id,':temp_code'=>$temp_code));

$data["charge"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get BreakBulk
$statement = $db->prepare("SELECT 
id,
mnf_entry_pk,
ifnull((select description from mt_commodity_master where code=main_commodity limit 1),main_commodity) main_commodity,
equipment_serial,
package_type,
no_of_packages,
gross_weight,
weight_uom,volume FROM mt_manifest_entry_cargo where mnf_entry_pk=(select id from mt_manifest_entry where bl_no=:bl_no limit 1) ");

$statement->execute(array(':bl_no'=>$data["info"][0]["bl_no"]));
$data["breakbulk"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT id,empty_bl_no from mt_manifest_entry where bl_no=:bl_no limit 1");

$statement->execute(array(':bl_no'=>$data["info"][0]["bl_no"]));
$data["ebl"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_delivery_details($temp_code,$id,$do_no)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT do_party, 
  do_no, t1.order_no, do_date, do_validity_date, 
  (select name from mt_business_partner where code=t1.consignee) consignee, 
  t1.bl_no, 
  t2.cargo_type,
  (select port_name from mt_port_master where port_code=t1.poo) poo, 
  (select port_name from mt_port_master where port_code=t1.pol) pol, 
  (select port_name from mt_port_master where port_code=t1.pod) pod, 
  (select port_name from mt_port_master where port_code=t1.pof) pof, t1.remarks, t1.location_id, t1.company_id, 
 t3.vessel,t3.voyage,t3.eta,
 (select name from mt_business_partner where code=t3.liner) liner, 
 (select GROUP_CONCAT(marks) from mt_manifest_entry_marks 
 where mnf_entry_pk=t2.id) seal_no,
 (select port_name from mt_port_master where port_code=(SELECT shipment_to from mt_order_entry where order_no=t1.order_no)) shipment_to  
from mt_delivery_order t1,
mt_manifest_entry t2,
mt_voyage t3 
where do_no=:do_no and t1.id=:id and t1.temp_code=:temp_code 
and t2.voyage=t3.voyage 
and t1.bl_no=t2.bl_no limit 1");
$statement->execute(array(':do_no'=>$do_no,
  ':id'=>$id,':temp_code'=>$temp_code));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$bl_no=$data["info"][0]["bl_no"];
$order_id=$id;

$statement = $db->prepare("SELECT container_no,'' chassis_no,type, cargo_desc,package_type,no_of_pkgs,gr_wgt,nt_wgt, volume from mt_order_container_detail
 where order_id=  (select id from mt_order_entry where order_no=
(SELECT order_no from mt_delivery_order where do_no=:do_no and id=:id and temp_code=:temp_code)) 
UNION
SELECT vin_no container_no,(SELECT GROUP_CONCAT(chassis_no) from mt_manifest_entry_landingcraft where mnf_entry_pk=(
SELECT id from mt_manifest_entry where bl_no='$bl_no') and vin_no=t1.vin_no) chassis_no,vehicle_type type,cargo_desc,package_type,no_of_pkgs,gr_wgt,nt_wgt,volume 
from mt_order_landingcraft_detail t1
 where order_id=  (select id from mt_order_entry where order_no=
(SELECT order_no from mt_delivery_order where do_no=:do_no and id=:id and temp_code=:temp_code))");

$statement->execute(array(':do_no'=>$do_no,
  ':id'=>$id,':temp_code'=>$temp_code));

$data["charge"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get BreakBulk
$statement = $db->prepare("SELECT 
id,
mnf_entry_pk,
ifnull((select description from mt_commodity_master where code=main_commodity limit 1),main_commodity) main_commodity,
equipment_serial,
package_type,
no_of_packages,
gross_weight,
weight_uom,volume FROM mt_manifest_entry_cargo where mnf_entry_pk=(select id from mt_manifest_entry where bl_no=:bl_no limit 1) ");

$statement->execute(array(':bl_no'=>$data["info"][0]["bl_no"]));
$data["breakbulk"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_invoice_details_forward($temp_code,$id,$inv_no)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT (SELECT name from mt_business_partner where code=sub_ar_code) customer,
  sub_ar_doc_type doc_type,
sub_ar_doc_number invoice,
sub_ar_date cdate,
sub_ar_doc_base service_type,
sub_ar_currency currency,
sub_ar_narration narration
 from mt_order_ar_header 
 where id=:id and 
 temp_code=:temp_code and sub_ar_doc_number=:doc_no ");
$statement->execute(array(':doc_no'=>$inv_no,
  ':id'=>$id,':temp_code'=>$temp_code));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$order_id=$id;

$statement = $db->prepare("SELECT description, qty, rate
 from mt_invoice_printdescriptions
 where invoice_no=:doc_no");
$statement->execute(array(':doc_no'=>$inv_no));
$data["charge"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_soa_ap($apt_code,$from_date,$to_date)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT apt_code,
(select name from mt_business_partner where code=t1.apt_code) ap_name,
(select address from mt_bp_address where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.apt_code)) ap_address,
(select currency from mt_bp_credit where bp_id=(select id from mt_business_partner where code=t1.apt_code)) ap_currency,
(select final_limit from mt_bp_credit where bp_id=(select id from mt_business_partner where code=t1.apt_code)) final_limit, 
(select credit_days from mt_bp_credit where bp_id=(select id from mt_business_partner where code=t1.apt_code)) credit_days,
APT_GL_DATE,
APT_TYPE,
APT_NUMBER,
APT_OTHER_REFERENCE,
APT_DESCRIPTION,
APT_LOCAL_AMOUNT,
-APT_LOCAL_AMOUNT,
APT_FOREIGN_AMOUNT,
APT_LOCAL_BALANCE  
FROM mt_ap_trans t1  
WHERE apt_code=:apt_code and (APT_GL_DATE between :from_date and :to_date) and apt_balance_status!='CANCELLED' 
ORDER BY APT_GL_DATE ");
$statement->execute(array(':apt_code'=>$apt_code,
  ':from_date'=>$from_date,':to_date'=>$to_date));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get PDC data
$statement = $db->prepare("SELECT
id, 
ph_base_doc_type,
ph_doc_type,
ph_doc_date,
ph_doc_number,
ph_cash_bank_code,
ph_local_amount,
ph_cheque_number,
ph_cheque_date 
FROM mt_payment_header
  where ph_status='AWAITING CONFIRMATION' and 
  ph_doc_number in (SELECT aloc_doc_number FROM mt_payment_allocation_details 
                    WHERE aloc_detail_2=:id and aloc_doc_type='CHEQUE') ");
$statement->execute(array(':id'=>$apt_code));
$data["pdc_data"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get Opening Balance
$statement = $db->prepare("SELECT apt_local_amount FROM mt_ap_trans t1  
WHERE apt_code=:id and apt_type='OPENING BALANCE'");
$statement->execute(array(':id'=>$apt_code));
$data["op_bal"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_soa_ap_matching($doc_no)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT apm_m_number,apm_m_type,apm_m_amount FROM mt_ap_match_details WHERE apm_t_number=:doc_no");
$statement->execute(array(':doc_no'=>$doc_no));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_soa_ar($art_code,$from_date,$to_date)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT art_code,
(select name from mt_business_partner where code=t1.art_code) ar_name,
(select address from mt_bp_address where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.art_code)) ar_address,
(select currency from mt_bp_credit where bp_id=(select id from mt_business_partner where code=t1.art_code)) ar_currency,
(select final_limit from mt_bp_credit where bp_id=(select id from mt_business_partner where code=t1.art_code)) final_limit, 
(select credit_days from mt_bp_credit where bp_id=(select id from mt_business_partner where code=t1.art_code)) credit_days,
ART_GL_DATE,
ART_TYPE,
ART_NUMBER,
ART_OTHER_REFERENCE,
ART_DESCRIPTION,
ART_LOCAL_AMOUNT,
-ART_LOCAL_AMOUNT,
ART_FOREIGN_AMOUNT,
ART_LOCAL_BALANCE  
FROM mt_ar_trans t1  
WHERE art_code=:art_code and (ART_GL_DATE between :from_date and :to_date)  and art_balance_status!='CANCELLED'
UNION 
SELECT ordt_code art_code,
(select name from mt_business_partner where code=t1.ordt_code) ar_name,
(select address from mt_bp_address where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.ordt_code)) ar_address,
(select currency from mt_bp_credit where bp_id=(select id from mt_business_partner where code=t1.ordt_code)) ar_currency,
(select final_limit from mt_bp_credit where bp_id=(select id from mt_business_partner where code=t1.ordt_code)) final_limit, 
(select credit_days from mt_bp_credit where bp_id=(select id from mt_business_partner where code=t1.ordt_code)) credit_days,
ordt_gl_date ART_GL_DATE,
ordt_doc_type ART_TYPE,
ordt_doc_number ART_NUMBER,
ordt_other_reference ART_OTHER_REFERENCE,
ordt_description ART_DESCRIPTION,
ordt_local_amount ART_LOCAL_AMOUNT,
-ordt_local_amount ,
ordt_foreign_amount ART_FOREIGN_AMOUNT,
ordt_local_balance ART_LOCAL_BALANCE
FROM mt_order_trans t1  
WHERE ordt_code=:art_code and (ORDT_GL_DATE between :from_date and :to_date) 
ORDER BY ART_GL_DATE");
$statement->execute(array(':art_code'=>$art_code,
  ':from_date'=>$from_date,':to_date'=>$to_date));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get PDC data
$statement = $db->prepare("SELECT
id, 
rh_base_doc_type,
rh_doc_type,
rh_doc_date,
rh_doc_number,
rh_cash_bank_code,
rh_local_amount,
rh_cheque_number,
rh_cheque_date 
FROM mt_receipt_header
  where rh_status='AWAITING CONFIRMATION' and rh_doc_number in (SELECT aloc_doc_number FROM mt_receipt_allocation_details WHERE aloc_detail_2=:id and aloc_doc_type='CHEQUE')");
$statement->execute(array(':id'=>$art_code));
$data["pdc_data"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get Opening Balance
$statement = $db->prepare("SELECT art_local_amount FROM mt_ar_trans t1  
WHERE art_code=:id and art_type='OPENING BALANCE'");
$statement->execute(array(':id'=>$art_code));
$data["op_bal"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_soa_full($art_code,$from_date,$to_date,$username)
{
$data=array();
try
{
$db = Factory::getConnection();

//Get Location
$statement = $db->prepare("SELECT location from user_master
where username=:username ");
$statement->execute(array(':username'=>$username));
$data["location"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$location_id=$data["location"][0]["location"];

//echo $location_id;

//Get Party info
$statement = $db->prepare("SELECT t1.code, t1.name, t2.address, t3.currency, t3.final_limit, 
  t3.credit_days FROM mt_business_partner t1 
LEFT JOIN mt_bp_address t2
ON t1.id=t2.bp_id and t2.type='HQ'
LEFT JOIN mt_bp_credit t3 
ON t1.id=t3.bp_id 
WHERE t1.code=:art_code");
$statement->execute(array(':art_code'=>$art_code));
$data["head"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get detail info
$statement = $db->prepare("SELECT ART_BASE_TYPE,art_code,ART_GL_DATE,ART_TYPE,ART_NUMBER,art_type_art_notes,
SUM(ART_LOCAL_AMOUNT_WGST) ART_LOCAL_AMOUNT_WGST,
SUM(ART_LOCAL_AMOUNT) ART_LOCAL_AMOUNT 
FROM 
(
SELECT ART_BASE_TYPE,
art_code,
ART_GL_DATE,
ART_TYPE,
ART_NUMBER,
CASE WHEN art_type='P2P' THEN
concat(art_type,' - ',art_notes)
WHEN art_type='ONLINE TRANSFER' THEN
concat(art_type,' - ',art_notes)
WHEN art_type='CHEQUE' THEN
concat(art_type,' - ',art_notes)
ELSE
art_type
END as art_type_art_notes,
ART_LOCAL_AMOUNT,
case when ART_TYPE in ('EXP-INV','IMP-INV','DEBIT NOTE','CREDIT NOTE') THEN

case when art_description in ('LINE DETENTION INCOME') THEN
0
else
(select sum(ART_LOCAL_AMOUNT) from mt_ar_trans ct 
 where ct.art_number=t1.art_number and ct.art_type not in ('TDS RECEIVABLE') ) 
end 

 when t1.art_type in ('VAT CHARGEABLE','OUTPUT IGST','OUTPUT CGST','OUTPUT SGST') THEN
    0
 ELSE
 t1.ART_LOCAL_AMOUNT
 end  ART_LOCAL_AMOUNT_WGST 
FROM mt_ar_trans t1  
WHERE location_id=:location_id 
  and art_code=:art_code and (ART_GL_DATE between :from_date and :to_date)  and art_balance_status!='CANCELLED' 
 

UNION ALL 

select apt_base_type ART_BASE_TYPE,
apt_code art_code,
case when apt_base_type='PAYMENT' THEN
APT_GL_DATE
ELSE
ref_inv_date 
END as ART_GL_DATE,
apt_type ART_TYPE, 
case when apt_base_type='PAYMENT' THEN
  apt_number
 when apt_base_type='JOURNAL VOUCHER' THEN
  apt_number
ELSE
  ref_inv_no 
END as ART_NUMBER,
CASE WHEN apt_type='P2P' THEN
concat(apt_type,' - ',apt_notes)
WHEN apt_type='CHEQUE' THEN
concat(apt_type,' - ',apt_notes)
WHEN apt_type='ONLINE TRANSFER' THEN
concat(apt_type,' - ',apt_notes)
ELSE
apt_type
END as art_type_art_notes,

apt_local_amount ART_LOCAL_AMOUNT,

case when APT_TYPE not in ('TDS PAYABLE') THEN
(select sum(APT_LOCAL_AMOUNT) from mt_ap_trans ct 
 where ct.apt_number=t2.apt_number and ct.apt_type not in ('TDS PAYABLE') ) 
 ELSE
 APT_LOCAL_AMOUNT
 end  ART_LOCAL_AMOUNT_WGST     
from mt_ap_trans t2
WHERE location_id=:location_id 
  and apt_code=:art_code and (APT_GL_DATE between :from_date and :to_date)  and apt_balance_status!='CANCELLED' 
) gt

GROUP BY ART_BASE_TYPE,art_code,ART_GL_DATE,ART_TYPE,ART_NUMBER,art_type_art_notes        
ORDER BY ART_GL_DATE  ");
$statement->execute(array(':art_code'=>$art_code,
  ':from_date'=>$from_date,':to_date'=>$to_date,':location_id'=>$location_id));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get PDC data
$statement = $db->prepare("SELECT
t1.id, 
t1.rh_base_doc_type,
t1.rh_doc_type,
t1.rh_doc_date,
t1.rh_doc_number,
t1.rh_cash_bank_code,
t2.aloc_local_amount rh_local_amount,
t1.rh_cheque_number,
t1.rh_cheque_date 
FROM mt_receipt_header t1
LEFT JOIN mt_receipt_allocation_details t2
ON t1.rh_doc_number= t2.aloc_doc_number
WHERE t1.rh_status='AWAITING CONFIRMATION' and   t2.aloc_detail_2=:id and t2.aloc_doc_type='CHEQUE'and t2.location_id=:location_id  
 UNION
SELECT
t1.id,  
t1.ph_base_doc_type rh_base_doc_type,
t1.ph_doc_type rh_doc_type,
t1.ph_doc_date rh_doc_date,
t1.ph_doc_number rh_doc_number,
t1.ph_cash_bank_code rh_cash_bank_code,
t2.aloc_local_amount rh_local_amount,
t1.ph_cheque_number rh_cheque_number,
t1.ph_cheque_date rh_cheque_date 
FROM mt_payment_header t1
LEFT JOIN mt_payment_allocation_details t2
ON t1.ph_doc_number= t2.aloc_doc_number
WHERE t1.ph_status='AWAITING CONFIRMATION' and   t2.aloc_detail_2=:id and t2.aloc_doc_type='CHEQUE' and t2.location_id=:location_id ");
$statement->execute(array(':id'=>$art_code,':location_id'=>$location_id));
$data["pdc_data"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get Opening Balance 2
$statement = $db->prepare("SELECT ifnull(SUM(CASE
        WHEN art_type='OPENING BALANCE' THEN ART_LOCAL_AMOUNT
        ELSE 0
    END),0) AS 'ob',
    ifnull(SUM(CASE
        WHEN ART_LOCAL_AMOUNT > 0 and art_type!='OPENING BALANCE' THEN ART_LOCAL_AMOUNT
        ELSE 0
    END),0) AS 'pos',
    ifnull(SUM(CASE
        WHEN ART_LOCAL_AMOUNT < 0 and art_type!='OPENING BALANCE' THEN ART_LOCAL_AMOUNT
        ELSE 0
    END),0) AS 'neg' 
FROM mt_ar_trans t1  
WHERE art_code=:art_code  and (ART_GL_DATE < :from_date) and art_balance_status!='CANCELLED' 
and location_id=:location_id ");
$statement->execute(array(':art_code'=>$art_code,
  ':from_date'=>$from_date,':location_id'=>$location_id));
$data["op_bal2"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get Opening Balance 3
$statement = $db->prepare("SELECT ifnull(SUM(CASE
        WHEN apt_type='OPENING BALANCE' THEN APT_LOCAL_AMOUNT
        ELSE 0
    END),0) AS 'ob',
    ifnull(SUM(CASE
        WHEN APT_LOCAL_AMOUNT > 0 and apt_type!='OPENING BALANCE' THEN APT_LOCAL_AMOUNT
        ELSE 0
    END),0) AS 'pos',
    ifnull(SUM(CASE
        WHEN APT_LOCAL_AMOUNT < 0 and apt_type!='OPENING BALANCE' THEN APT_LOCAL_AMOUNT
        ELSE 0
    END),0) AS 'neg' 
FROM mt_ap_trans t1  
WHERE apt_code=:art_code  and (APT_GL_DATE < :from_date) and apt_balance_status!='CANCELLED' 
and location_id=:location_id ");
$statement->execute(array(':art_code'=>$art_code,
  ':from_date'=>$from_date,':location_id'=>$location_id));
$data["op_bal3"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get EPDA detail
$statement = $db->prepare("SELECT sub_ar_code, sub_ar_doc_number, sub_ar_date, sub_ar_currency, sub_ar_l_amount, sub_ar_narration, order_no, bl_no
 from mt_ship_ar_header 
 where sub_ar_code=:art_code 
 and (sub_ar_doc_base in ('EPDA IMPORT','EPDA EXPORT') or sub_ar_doc_type in ('PRO'))    
 and sub_ar_status not in ('CANCELLED', 'P') ");
$statement->execute(array(':art_code'=>$art_code));
$data["epda"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_age_analysis_summary($art_code,$to_date)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT art_code, name, mobile1, sum(c1) c1, sum(c2) c2, sum(c3) c3, sum(c4) c4, sum(c5) c5, sum(total) total
FROM 
(SELECT t1.art_code, t2.name, t3.mobile1, sum(case when DATEDIFF(:to_date, t1.art_doc_date)  between 0 and 30 then 
t1.art_local_balance
else 0 
end) 'c1',
sum(case when DATEDIFF(:to_date, t1.art_doc_date)  between 31 and 60 then 
t1.art_local_balance
else 0 
end) 'c2',
sum(case when DATEDIFF(:to_date, t1.art_doc_date)  between 61 and 90 then 
t1.art_local_balance
else 0 
end) 'c3',
sum(case when DATEDIFF(:to_date, t1.art_doc_date)  between 91 and 120 then 
t1.art_local_balance
else 0 
end) 'c4',
sum(case when DATEDIFF(:to_date, t1.art_doc_date)  > 120 then 
t1.art_local_balance
else 0 
end) 'c5',
sum(t1.art_local_balance) total 
FROM mt_ar_trans t1 
LEFT JOIN mt_business_partner t2 
ON t1.art_code=t2.code 
LEFT JOIN mt_bp_address t3
ON t2.id=t3.bp_id
WHERE  t1.art_type in ('OPENING BALANCE','PRO-INV','IMP-INV', 'EXP-INV', 'GENERAL INVOICE', 'DEBIT NOTE', 'CREDIT NOTE', 'CARD', 'CASH','ONLINE TRANSFER','CHEQUE') 
and t1.art_local_balance!=0 
and t1.art_balance_status!='CANCELLED'
and t1.art_number not in (select arm_m_number from mt_ar_match_details
where  (arm_m_number=t1.art_number or arm_t_number=t1.art_number) and arm_m_ar=t1.art_code and arm_status!='CANCELLED')
GROUP BY t1.art_code, t2.name, t3.mobile1 
 
 UNION 
SELECT t1.apt_code, t2.name, t3.mobile1,sum(case when DATEDIFF(:to_date, t1.apt_doc_date)  between 0 and 30 then 
t1.apt_local_balance
else 0 
end) 'c1',
sum(case when DATEDIFF(:to_date, t1.apt_doc_date)  between 31 and 60 then 
t1.apt_local_balance
else 0 
end) 'c2',
sum(case when DATEDIFF(:to_date, t1.apt_doc_date)  between 61 and 90 then 
t1.apt_local_balance
else 0 
end) 'c3',
sum(case when DATEDIFF(:to_date, t1.apt_doc_date)  between 91 and 120 then 
t1.apt_local_balance
else 0 
end) 'c4',
sum(case when DATEDIFF(:to_date, t1.apt_doc_date)  > 120 then 
t1.apt_local_balance
else 0 
end) 'c5',
sum(t1.apt_local_balance) total 
FROM mt_ap_trans t1 
LEFT JOIN mt_business_partner t2 
ON t1.apt_code=t2.code 
LEFT JOIN mt_bp_address t3
ON t2.id=t3.bp_id
WHERE  t1.apt_type in ('OPENING BALANCE','PRO-INV','IMP-INV', 'EXP-INV', 'GENERAL INVOICE', 'DEBIT NOTE', 'CREDIT NOTE', 'CARD', 'CASH','ONLINE TRANSFER','CHEQUE') 
and t1.apt_local_balance!=0 
and t1.apt_balance_status!='CANCELLED'
and t1.apt_number not in (select apm_m_number from mt_ap_match_details
where  (apm_m_number=t1.apt_number or apm_t_number=t1.apt_number) and apm_m_ar=t1.apt_code and apm_status!='CANCELLED') 
GROUP BY t1.apt_code, t2.name, t3.mobile1  
 ) group_table
 GROUP BY art_code, name, mobile1  
ORDER BY total desc");
$statement->execute(array(':to_date'=>$to_date));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_age_analysis_summary_receivable($st,$to_date,$username)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT location from user_master
where username=:username ");
$statement->execute(array(':username'=>$username));
$data["location"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$location_id=$data["location"][0]["location"];

if($st=="WIH ZERO")
{
$statement = $db->prepare("SELECT mt1.code art_code,mt1.name name,mobile1,
  ifnull(c1,0) c1,ifnull(c2,0) c2,ifnull(c3,0) c3,
  ifnull(c4,0) c4,ifnull(c5,0) c5,ifnull(total,0) total 
  from mt_business_partner mt1
LEFT JOIN
(SELECT art_code, name, mobile1, sum(c1) c1, sum(c2) c2, sum(c3) c3, sum(c4) c4, sum(c5) c5, sum(total) total
FROM 
(SELECT t1.art_code, t2.name, t3.mobile1, 
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  between 0 and 30 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c1',
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  between 31 and 60 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c2',
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  between 61 and 90 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c3',
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  between 91 and 120 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c4',
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  > 120 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c5',
sum(
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
) total 
FROM mt_ar_trans t1 
LEFT JOIN mt_business_partner t2 
ON t1.art_code=t2.code 
LEFT JOIN mt_bp_address t3
ON t2.id=t3.bp_id
WHERE  t1.art_type in ('OPENING BALANCE','PRO-INV','IMP-INV', 'EXP-INV', 'GENERAL INVOICE', 'DEBIT NOTE', 'CREDIT NOTE', 'CARD', 'CASH','ONLINE TRANSFER','CHEQUE') 

and t1.art_balance_status!='CANCELLED'
and t2.tag!='SUPPLIER' 
and t1.location_id=:location_id 

GROUP BY t1.art_code, t2.name, t3.mobile1 
UNION 
SELECT t1.apt_code art_code, t2.name, t3.mobile1,
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  between 0 and 30 then 
(CASE WHEN apt_number like 'LPO/%' then -abs(apt_local_balance) WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c1',
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  between 31 and 60 then 
(CASE WHEN apt_number like 'LPO/%' then -abs(apt_local_balance) WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c2',
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  between 61 and 90 then 
(CASE WHEN apt_number like 'LPO/%' then -abs(apt_local_balance) WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c3',
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  between 91 and 120 then 
(CASE WHEN apt_number like 'LPO/%' then -abs(apt_local_balance) WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c4',
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  > 120 then 
(CASE WHEN apt_number like 'LPO/%' then -abs(apt_local_balance) WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c5',
sum(
(CASE WHEN apt_number like 'LPO/%' then -abs(apt_local_balance) WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
) total 
FROM mt_ap_trans t1 
LEFT JOIN mt_business_partner t2 
ON t1.apt_code=t2.code 
LEFT JOIN mt_bp_address t3
ON t2.id=t3.bp_id
WHERE  t1.apt_type in ('OPENING BALANCE','PRO-INV','IMP-INV', 'EXP-INV', 'GENERAL INVOICE', 'DEBIT NOTE', 'CREDIT NOTE', 'CARD', 'CASH','ONLINE TRANSFER','CHEQUE')  
and t1.apt_balance_status!='CANCELLED' 
and t2.tag!='SUPPLIER' 
and t1.location_id=:location_id 

GROUP BY t1.apt_code, t2.name, t3.mobile1

 ) group_table
 GROUP BY art_code, name, mobile1  
ORDER BY art_code) mt2  
on mt1.code=mt2.art_code order by code");

$statement->execute(array(':to_date'=>$to_date,':location_id'=>$location_id));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

}else{
  //without zero
  //
  $statement = $db->prepare("SELECT art_code,name,c1,c2,c3,c4,c5,total,mobile1 from (SELECT art_code, name,bp_id, sum(c1) c1, sum(c2) c2, sum(c3) c3, sum(c4) c4, sum(c5) c5, sum(total) total
FROM 
(SELECT t1.art_code, t2.name,t2.id bp_id,t1.art_number, sum(case when DATEDIFF(:to_date, t1.art_gl_date)  between 0 and 30 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c1',
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  between 31 and 60 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c2',
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  between 61 and 90 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c3',
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  between 91 and 120 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c4',
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  > 120 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c5',
sum(
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
) total 
FROM mt_ar_trans t1 
LEFT JOIN mt_business_partner t2 
ON t1.art_code=t2.code
WHERE  t1.art_type in ('PETTY CASH','OPENING BALANCE','PRO-INV','IMP-INV', 'EXP-INV', 'GENERAL INVOICE', 'DEBIT NOTE', 'CREDIT NOTE', 'CARD', 'CASH','ONLINE TRANSFER','CHEQUE','JV','BROKERAGE') 
and truncate(t1.art_local_balance,2)!=0 
and t1.art_balance_status!='CANCELLED'
and art_number not like 'PBC%'  
and t2.tag!='SUPPLIER' 
and t1.location_id=:location_id 

GROUP BY t1.art_code, t2.name,t2.id,t1.art_number 
UNION 
SELECT t1.apt_code art_code, t2.name,t2.id bp_id,t1.apt_number art_number,
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  between 0 and 30 then 
(CASE WHEN apt_number like 'LPO/%' then -abs(apt_local_balance) WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c1',
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  between 31 and 60 then 
(CASE WHEN apt_number like 'LPO/%' then -abs(apt_local_balance) WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c2',
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  between 61 and 90 then 
(CASE WHEN apt_number like 'LPO/%' then -abs(apt_local_balance) WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c3',
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  between 91 and 120 then 
(CASE WHEN apt_number like 'LPO/%' then -abs(apt_local_balance) WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c4',
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  > 120 then 
(CASE WHEN apt_number like 'LPO/%' then -abs(apt_local_balance) WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c5',
sum(
(CASE WHEN apt_number like 'LPO/%' then -abs(apt_local_balance) WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
) total 
FROM mt_ap_trans t1 
LEFT JOIN mt_business_partner t2 
ON t1.apt_code=t2.code 
WHERE  t1.apt_type in ('PETTY CASH','OPENING BALANCE','PRO-INV','IMP-INV', 'EXP-INV', 'GENERAL INVOICE', 'DEBIT NOTE', 'CREDIT NOTE', 'CARD', 'CASH','ONLINE TRANSFER','CHEQUE','JV','BROKERAGE') 
and truncate(t1.apt_local_balance,2)!=0 
and t1.apt_balance_status!='CANCELLED' 
and t2.tag!='SUPPLIER' 
and t1.location_id=:location_id 

GROUP BY t1.apt_code, t2.name,t2.id, t1.apt_number  
 ) group_table
 GROUP BY art_code, name,bp_id) nt1 LEFT JOIN (SELECT * from mt_bp_address where type='HQ' limit 1) nt2 on nt1.bp_id=nt2.bp_id");
$statement->execute(array(':to_date'=>$to_date,':location_id'=>$location_id));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

/*
old query

SELECT art_code, name, mobile1, sum(c1) c1, sum(c2) c2, sum(c3) c3, sum(c4) c4, sum(c5) c5, sum(total) total
FROM 
(SELECT t1.art_code, t2.name, t3.mobile1,t1.art_number, sum(case when DATEDIFF(:to_date, t1.art_gl_date)  between 0 and 30 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c1',
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  between 31 and 60 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c2',
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  between 61 and 90 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c3',
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  between 91 and 120 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c4',
sum(case when DATEDIFF(:to_date, t1.art_gl_date)  > 120 then 
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
else 0 
end) 'c5',
sum(
(CASE WHEN art_type='DEBIT NOTE' then abs(art_local_balance) WHEN art_type='CREDIT NOTE' then -abs(art_local_balance) else art_local_balance 
end) 
) total 
FROM mt_ar_trans t1 
LEFT JOIN mt_business_partner t2 
ON t1.art_code=t2.code 
LEFT JOIN mt_bp_address t3
ON t2.id=t3.bp_id
WHERE  t1.art_type in ('PETTY CASH','OPENING BALANCE','PRO-INV','IMP-INV', 'EXP-INV', 'GENERAL INVOICE', 'DEBIT NOTE', 'CREDIT NOTE', 'CARD', 'CASH','ONLINE TRANSFER','CHEQUE','JV') 
and truncate(t1.art_local_balance,2)!=0 
and t1.art_balance_status!='CANCELLED'
and art_number not like 'PBC%'  
and t2.tag!='SUPPLIER' 
and t1.location_id=:location_id 
GROUP BY t1.art_code, t2.name, t3.mobile1,t1.art_number 
UNION 
SELECT t1.apt_code art_code, t2.name, t3.mobile1,t1.apt_number art_number,
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  between 0 and 30 then 
(CASE WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c1',
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  between 31 and 60 then 
(CASE WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c2',
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  between 61 and 90 then 
(CASE WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c3',
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  between 91 and 120 then 
(CASE WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c4',
sum(case when DATEDIFF(:to_date, t1.apt_gl_date)  > 120 then 
(CASE WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
else 0 
end) 'c5',
sum(
(CASE WHEN apt_type='DEBIT NOTE' then abs(apt_local_balance) WHEN apt_type='CREDIT NOTE' then -abs(apt_local_balance) else apt_local_balance 
end) 
) total 
FROM mt_ap_trans t1 
LEFT JOIN mt_business_partner t2 
ON t1.apt_code=t2.code 
LEFT JOIN mt_bp_address t3
ON t2.id=t3.bp_id
WHERE  t1.apt_type in ('PETTY CASH','OPENING BALANCE','PRO-INV','IMP-INV', 'EXP-INV', 'GENERAL INVOICE', 'DEBIT NOTE', 'CREDIT NOTE', 'CARD', 'CASH','ONLINE TRANSFER','CHEQUE','JV') 
and truncate(t1.apt_local_balance,2)!=0 
and t1.apt_balance_status!='CANCELLED' 
and t2.tag!='SUPPLIER' 
and t1.location_id=:location_id 

GROUP BY t1.apt_code, t2.name, t3.mobile1,t1.apt_number  
 ) group_table
 GROUP BY art_code, name, mobile1 
 
*/
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_age_analysis_summary_payable($art_code,$to_date)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT art_code, name, mobile1, sum(c1) c1, sum(c2) c2, sum(c3) c3, sum(c4) c4, sum(c5) c5, sum(total) total
FROM 
(SELECT t1.apt_code art_code, t2.name, t3.mobile1,sum(case when DATEDIFF(:to_date, t1.apt_doc_date)  between 0 and 30 then 
t1.apt_local_balance
else 0 
end) 'c1',
sum(case when DATEDIFF(:to_date, t1.apt_doc_date)  between 31 and 60 then 
t1.apt_local_balance
else 0 
end) 'c2',
sum(case when DATEDIFF(:to_date, t1.apt_doc_date)  between 61 and 90 then 
t1.apt_local_balance
else 0 
end) 'c3',
sum(case when DATEDIFF(:to_date, t1.apt_doc_date)  between 91 and 120 then 
t1.apt_local_balance
else 0 
end) 'c4',
sum(case when DATEDIFF(:to_date, t1.apt_doc_date)  > 120 then 
t1.apt_local_balance
else 0 
end) 'c5',
sum(t1.apt_local_balance) total 
FROM mt_ap_trans t1 
LEFT JOIN mt_business_partner t2 
ON t1.apt_code=t2.code 
LEFT JOIN mt_bp_address t3
ON t2.id=t3.bp_id
WHERE  t1.apt_type in ('OPENING BALANCE','PRO-INV','IMP-INV', 'EXP-INV', 'GENERAL INVOICE', 'DEBIT NOTE', 'CREDIT NOTE', 'CARD', 'CASH','ONLINE TRANSFER','CHEQUE') 
and t1.apt_local_balance!=0 
and t1.apt_balance_status!='CANCELLED'
and t1.apt_number not in (select apm_m_number from mt_ap_match_details
where  (apm_m_number=t1.apt_number or apm_t_number=t1.apt_number) and apm_m_ar=t1.apt_code and apm_status!='CANCELLED') 
GROUP BY t1.apt_code, t2.name, t3.mobile1  
 ) group_table
 GROUP BY art_code, name, mobile1  
ORDER BY art_code ");
$statement->execute(array(':to_date'=>$to_date));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_age_analysis_detail($art_code,$to_date,$st,$username)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT location from user_master
where username=:username ");
$statement->execute(array(':username'=>$username));
$data["location"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$location_id=$data["location"][0]["location"];

//Get Party info
$statement = $db->prepare("SELECT t1.code, t1.name, t2.address, t3.currency, t3.final_limit, 
  t3.credit_days FROM mt_business_partner t1 
LEFT JOIN mt_bp_address t2
ON t1.id=t2.bp_id and t2.type='HQ'
LEFT JOIN mt_bp_credit t3 
ON t1.id=t3.bp_id 
WHERE t1.code=:art_code");
$statement->execute(array(':art_code'=>$art_code));
$data["head"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$ar_st=" ";
$ap_st=" ";
if($st=="WITHOUT ZERO"){
  $ar_st=" and truncate(t1.art_local_balance,2)!=0 ";
  $ap_st=" and truncate(t2.apt_local_balance,2)!=0 ";
}
//Get detail
$statement = $db->prepare("

SELECT t1.art_doc_date, t1.art_number, t1.art_description, 
  t1.art_local_amount,
  case when t1.ART_TYPE not in ('TDS RECEIVABLE') THEN
  (select sum(ART_LOCAL_AMOUNT) from mt_ar_trans ct 
   where ct.art_number=t1.art_number and ct.art_type not in ('TDS RECEIVABLE')  and ct.art_code=:art_code) 
   ELSE
   t1.ART_LOCAL_AMOUNT
   end as 'ART_LOCAL_AMOUNT_WGST',
   t1.art_local_balance, 
   case when t1.ART_TYPE not in ('TDS RECEIVABLE') THEN
  (select sum(art_local_balance) from mt_ar_trans ct 
   where ct.art_number=t1.art_number and ct.art_type not in ('TDS RECEIVABLE')  and ct.art_code=:art_code) 
   ELSE
   t1.art_local_balance
   end as 'ART_LOCAL_BALANCE_WGST',
   DATEDIFF(:to_date, t1.art_doc_date) ageing
from mt_ar_trans t1 
where t1.art_type in ('PETTY CASH','PRO-INV','IMP-INV', 'EXP-INV', 'GENERAL INVOICE', 'DEBIT NOTE', 'CREDIT NOTE', 'CARD', 'CASH','ONLINE TRANSFER','CHEQUE','JV') 
and t1.art_code=:art_code and art_number not like 'PBC%' 
and t1.art_balance_status!='CANCELLED'
and location_id=:location_id 

$ar_st  

UNION


SELECT 
case when apt_base_type='PAYMENT' THEN
t2.APT_GL_DATE
ELSE
t2.ref_inv_date 
END as art_doc_date,
case when t2.apt_base_type='PAYMENT' THEN
  t2.apt_number
ELSE
  t2.ref_inv_no 
END as ART_NUMBER,
 
CASE when t2.apt_type in ('VAT CHARGEABLE','INPUT CGST','INPUT SGST','INPUT IGST','GENERAL INVOICE','TDS PAYABLE') then 
'GENERAL INVOICE'  
ELSE
t2.apt_type  
END as art_description,

sum(t2.apt_local_amount) art_local_amount,
sum(
case when t2.APT_TYPE in ('GENERAL INVOICE') THEN
(select sum(APT_LOCAL_AMOUNT) from mt_ap_trans ct 
 where ct.apt_number=t2.apt_number and ct.apt_type not in ('TDS PAYABLE') ) 
 when t2.apt_type in ('VAT CHARGEABLE','INPUT IGST','INPUT CGST','INPUT SGST') THEN
    0
 ELSE
 t2.APT_LOCAL_AMOUNT
 end  ) ART_LOCAL_AMOUNT_WGST,  
sum(t2.apt_local_balance) art_local_balance, 
sum(
case when t2.APT_TYPE in ('GENERAL INVOICE') THEN
(select sum(apt_local_balance) from mt_ap_trans ct 
 where ct.apt_number=t2.apt_number and ct.apt_type not in ('TDS PAYABLE') ) 
 when t2.apt_type in ('VAT CHARGEABLE','INPUT IGST','INPUT CGST','INPUT SGST') THEN
    0
 ELSE
 t2.apt_local_balance
 end  ) ART_LOCAL_BALANCE_WGST,  
case when apt_base_type='PAYMENT' THEN
DATEDIFF(:to_date, t2.APT_GL_DATE) 
ELSE
DATEDIFF(:to_date, t2.ref_inv_date)  
END as ageing 

FROM mt_ap_trans t2 
WHERE t2.apt_type in ('PETTY CASH','PRO-INV','IMP-INV', 'EXP-INV', 'GENERAL INVOICE', 'DEBIT NOTE', 'CREDIT NOTE', 'CARD', 'CASH','ONLINE TRANSFER','CHEQUE','JV','BROKERAGE') 
and t2.apt_code=:art_code
and t2.apt_balance_status!='CANCELLED' 
and location_id=:location_id 
$ap_st 

GROUP BY art_doc_date,ART_NUMBER,art_description,ageing

ORDER BY art_doc_date ");
$statement->execute(array(':art_code'=>$art_code,
  ':to_date'=>$to_date,':location_id'=>$location_id));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get PDC data
$statement = $db->prepare("SELECT
t1.id, 
t1.rh_base_doc_type,
t1.rh_doc_type,
t1.rh_doc_date,
t1.rh_doc_number,
t1.rh_cash_bank_code,
t2.aloc_local_amount rh_local_amount,
t1.rh_cheque_number,
t1.rh_cheque_date 
FROM mt_receipt_header t1
LEFT JOIN mt_receipt_allocation_details t2
ON t1.rh_doc_number= t2.aloc_doc_number
WHERE t1.rh_status='AWAITING CONFIRMATION' and   t2.aloc_detail_2=:id and t2.aloc_doc_type='CHEQUE' and t2.location_id=:location_id
UNION
SELECT
t1.id,  
t1.ph_base_doc_type rh_base_doc_type,
t1.ph_doc_type rh_doc_type,
t1.ph_doc_date rh_doc_date,
t1.ph_doc_number rh_doc_number,
t1.ph_cash_bank_code rh_cash_bank_code,
t2.aloc_local_amount rh_local_amount,
t1.ph_cheque_number rh_cheque_number,
t1.ph_cheque_date rh_cheque_date 
FROM mt_payment_header t1
LEFT JOIN mt_payment_allocation_details t2
ON t1.ph_doc_number= t2.aloc_doc_number
WHERE t1.ph_status='AWAITING CONFIRMATION' and   t2.aloc_detail_2=:id and t2.aloc_doc_type='CHEQUE' and t2.location_id=:location_id");
$statement->execute(array(':id'=>$art_code,':location_id'=>$location_id));
$data["pdc_data"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get ageing slabs
$statement = $db->prepare(" SELECT sum(c1) c1, sum(c2) c2, sum(c3) c3, sum(c4) c4, sum(c5) c5, sum(total) total
FROM 
(SELECT sum(case when DATEDIFF(:to_date, t1.art_doc_date)  between 0 and 30 then 

   case when t1.ART_TYPE not in ('TDS RECEIVABLE') THEN
  (select sum(art_local_balance) from mt_ar_trans ct 
   where ct.art_number=t1.art_number and ct.art_type not in ('TDS RECEIVABLE')  and ct.art_code=:art_code) 
   ELSE
   t1.art_local_balance
   end 

else 0 
end) 'c1',
sum(case when DATEDIFF(:to_date, t1.art_doc_date)  between 31 and 60 then 

   case when t1.ART_TYPE not in ('TDS RECEIVABLE') THEN
  (select sum(art_local_balance) from mt_ar_trans ct 
   where ct.art_number=t1.art_number and ct.art_type not in ('TDS RECEIVABLE')  and ct.art_code=:art_code) 
   ELSE
   t1.art_local_balance
   end 

else 0 
end) 'c2',
sum(case when DATEDIFF(:to_date, t1.art_doc_date)  between 61 and 90 then 

   case when t1.ART_TYPE not in ('TDS RECEIVABLE') THEN
  (select sum(art_local_balance) from mt_ar_trans ct 
   where ct.art_number=t1.art_number and ct.art_type not in ('TDS RECEIVABLE')  and ct.art_code=:art_code) 
   ELSE
   t1.art_local_balance
   end 

else 0 
end) 'c3',
sum(case when DATEDIFF(:to_date, t1.art_doc_date)  between 91 and 120 then 

   case when t1.ART_TYPE not in ('TDS RECEIVABLE') THEN
  (select sum(art_local_balance) from mt_ar_trans ct 
   where ct.art_number=t1.art_number and ct.art_type not in ('TDS RECEIVABLE')  and ct.art_code=:art_code) 
   ELSE
   t1.art_local_balance
   end 

else 0 
end) 'c4',
sum(case when DATEDIFF(:to_date, t1.art_doc_date)  > 120 then 

   case when t1.ART_TYPE not in ('TDS RECEIVABLE') THEN
  (select sum(art_local_balance) from mt_ar_trans ct 
   where ct.art_number=t1.art_number and ct.art_type not in ('TDS RECEIVABLE')  and ct.art_code=:art_code) 
   ELSE
   t1.art_local_balance
   end 

else 0 
end) 'c5',
sum(
   case when t1.ART_TYPE not in ('TDS RECEIVABLE') THEN
  (select sum(art_local_balance) from mt_ar_trans ct 
   where ct.art_number=t1.art_number and ct.art_type not in ('TDS RECEIVABLE')  and ct.art_code=:art_code) 
   ELSE
   t1.art_local_balance
   end 

) total 
FROM mt_ar_trans t1 
WHERE  t1.art_type in ('TDS RECEIVABLE','OPENING BALANCE','PRO-INV','IMP-INV', 'EXP-INV','GENERAL INVOICE', 'DEBIT NOTE', 'CREDIT NOTE', 'CARD', 'CASH','ONLINE TRANSFER','CHEQUE','P2P','L2P','P2L') 
and t1.art_code=:art_code and t1.art_local_balance!=0 
and t1.art_balance_status!='CANCELLED'
and t1.art_number not in (select arm_m_number from mt_ar_match_details
where  (arm_m_number=t1.art_number or arm_t_number=t1.art_number) and arm_m_ar=:art_code and arm_status!='CANCELLED') 

UNION 

SELECT sum(case when 
( 
case when apt_base_type='PAYMENT' THEN
DATEDIFF(:to_date, t1.apt_doc_date) 
ELSE
DATEDIFF(:to_date, t1.ref_inv_date)  
END) 
  between 0 and 30 then 

  case when t1.APT_TYPE in ('GENERAL INVOICE') THEN
(select sum(apt_local_balance) from mt_ap_trans ct 
 where ct.apt_number=t1.apt_number and ct.apt_type not in ('TDS PAYABLE') ) 
 when t1.apt_type in ('VAT CHARGEABLE','INPUT IGST','INPUT CGST','INPUT SGST') THEN
    0
 ELSE
 t1.apt_local_balance
 end

else 0 
end) 'c1',
sum(case when 
( 
case when apt_base_type='PAYMENT' THEN
DATEDIFF(:to_date, t1.apt_doc_date) 
ELSE
DATEDIFF(:to_date, t1.ref_inv_date)  
END) 
  between 31 and 60 then 

  case when t1.APT_TYPE in ('GENERAL INVOICE') THEN
(select sum(apt_local_balance) from mt_ap_trans ct 
 where ct.apt_number=t1.apt_number and ct.apt_type not in ('TDS PAYABLE') ) 
 when t1.apt_type in ('VAT CHARGEABLE','INPUT IGST','INPUT CGST','INPUT SGST') THEN
    0
 ELSE
 t1.apt_local_balance
 end

else 0 
end) 'c2',
sum(case when 
( 
case when apt_base_type='PAYMENT' THEN
DATEDIFF(:to_date, t1.apt_doc_date) 
ELSE
DATEDIFF(:to_date, t1.ref_inv_date)  
END) 
  between 61 and 90 then 

  case when t1.APT_TYPE in ('GENERAL INVOICE') THEN
(select sum(apt_local_balance) from mt_ap_trans ct 
 where ct.apt_number=t1.apt_number and ct.apt_type not in ('TDS PAYABLE') ) 
 when t1.apt_type in ('VAT CHARGEABLE','INPUT IGST','INPUT CGST','INPUT SGST') THEN
    0
 ELSE
 t1.apt_local_balance
 end

else 0 
end) 'c3',
sum(case when 
( 
case when apt_base_type='PAYMENT' THEN
DATEDIFF(:to_date, t1.apt_doc_date) 
ELSE
DATEDIFF(:to_date, t1.ref_inv_date)  
END) 
  between 91 and 120 then 

  case when t1.APT_TYPE in ('GENERAL INVOICE') THEN
(select sum(apt_local_balance) from mt_ap_trans ct 
 where ct.apt_number=t1.apt_number and ct.apt_type not in ('TDS PAYABLE') ) 
 when t1.apt_type in ('VAT CHARGEABLE','INPUT IGST','INPUT CGST','INPUT SGST') THEN
    0
 ELSE
 t1.apt_local_balance
 end

else 0 
end) 'c4',
sum(case when 
( 
case when apt_base_type='PAYMENT' THEN
DATEDIFF(:to_date, t1.apt_doc_date) 
ELSE
DATEDIFF(:to_date, t1.ref_inv_date)  
END) 
  > 120 then 

  case when t1.APT_TYPE in ('GENERAL INVOICE') THEN
(select sum(apt_local_balance) from mt_ap_trans ct 
 where ct.apt_number=t1.apt_number and ct.apt_type not in ('TDS PAYABLE') ) 
 when t1.apt_type in ('VAT CHARGEABLE','INPUT IGST','INPUT CGST','INPUT SGST') THEN
    0
 ELSE
 t1.apt_local_balance
 end

else 0 
end) 'c5',
sum(

  case when t1.APT_TYPE in ('GENERAL INVOICE') THEN
(select sum(apt_local_balance) from mt_ap_trans ct 
 where ct.apt_number=t1.apt_number and ct.apt_type not in ('TDS PAYABLE') ) 
 when t1.apt_type in ('VAT CHARGEABLE','INPUT IGST','INPUT CGST','INPUT SGST') THEN
    0
 ELSE
 t1.apt_local_balance
 end
 
) total 
FROM mt_ap_trans t1 
WHERE  t1.apt_type in ('OPENING BALANCE','PRO-INV','IMP-INV', 'EXP-INV', 'DEBIT NOTE', 'CREDIT NOTE', 'CARD', 'CASH','ONLINE TRANSFER','CHEQUE','INPUT CGST','INPUT SGST','INPUT IGST','TDS PAYABLE','P2P','L2P','P2L') 
and t1.apt_code=:art_code and t1.apt_local_balance!=0 
and t1.apt_balance_status!='CANCELLED'
and t1.apt_number not in (select apm_m_number from mt_ap_match_details
where  (apm_m_number=t1.apt_number or apm_t_number=t1.apt_number) and apm_m_ar=:art_code and apm_status!='CANCELLED') 

) group_table ");
$statement->execute(array(':art_code'=>$art_code, ':to_date'=>$to_date));
$data["ageing"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get Opening Balance
$statement = $db->prepare("SELECT t1.art_doc_date, t1.art_number, t1.art_local_amount, t1.art_local_balance, DATEDIFF(:to_date, t1.art_doc_date) ageing FROM mt_ar_trans t1  
WHERE t1.art_code=:art_code and t1.art_type='OPENING BALANCE' 
UNION 
SELECT t1.apt_doc_date, t1.apt_number, t1.apt_local_amount, t1.apt_local_balance, DATEDIFF(:to_date, t1.apt_doc_date) ageing FROM mt_ap_trans t1  
WHERE t1.apt_code=:art_code and t1.apt_type='OPENING BALANCE' ");
$statement->execute(array(':art_code'=>$art_code, ':to_date'=>$to_date));
$data["op_bal"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get EPDA detail
$statement = $db->prepare("SELECT sub_ar_code, sub_ar_doc_number, sub_ar_date, sub_ar_currency, sub_ar_l_amount, sub_ar_narration, order_no, bl_no
 from mt_ship_ar_header 
 where sub_ar_code=:art_code and sub_ar_doc_base='EPDA'  and sub_ar_status!='CANCELLED' ");
$statement->execute(array(':art_code'=>$art_code));
$data["epda"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_soa_ar_matching($doc_no)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT arm_m_number,arm_m_type,arm_m_amount FROM mt_ar_match_details WHERE arm_t_number=:doc_no ");
$statement->execute(array(':doc_no'=>$doc_no));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_gl_trans_register($from_glt_code,$to_glt_code,$from_date,$to_date,$username)
{
$data=array();
try
{
$db = Factory::getConnection();

//Get Location
$statement = $db->prepare("SELECT location from user_master
where username=:username ");
$statement->execute(array(':username'=>$username));
$data["location"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$location_id=$data["location"][0]["location"];

$statement = $db->prepare(" 
SELECT * FROM 
(
SELECT 
pre_glt_status,pre_glt_code,
(select ac_description from mt_general_ledger where code=pre_glt_code limit 1) gl_desc,  
pre_glt_doc_date,pre_glt_doc_number,pre_glt_narration, pre_glt_other_reference, pre_glt_local_amount,pre_glt_detail_1 
FROM mt_ar_gl_details  
WHERE (pre_glt_code=:from_glt_code or pre_glt_detail_1=:from_glt_code) and  (pre_glt_doc_date between :from_date and :to_date) and pre_glt_status is null 
GROUP BY pre_glt_status,pre_glt_code, pre_glt_doc_date,pre_glt_doc_number,pre_glt_narration, pre_glt_other_reference, pre_glt_local_amount,pre_glt_detail_1

union all 

SELECT 
pre_glt_status,pre_glt_code,
(select ac_description from mt_general_ledger where code=pre_glt_code limit 1) gl_desc,  
pre_glt_doc_date,pre_glt_doc_number,pre_glt_narration, pre_glt_other_reference, pre_glt_local_amount,pre_glt_detail_1
FROM mt_ap_gl_details 
WHERE ((pre_glt_code between :from_glt_code and :to_glt_code) or (pre_glt_detail_1 between :from_glt_code and :to_glt_code)) and  (pre_glt_doc_date between :from_date and :to_date) and pre_glt_status is null
GROUP BY pre_glt_status,pre_glt_code, pre_glt_doc_date,pre_glt_doc_number,pre_glt_narration, pre_glt_other_reference, pre_glt_local_amount,pre_glt_detail_1

union all 

SELECT 
pre_glt_status,pre_glt_code,
(select ac_description from mt_general_ledger where code=pre_glt_code limit 1) gl_desc,  
pre_glt_doc_date,pre_glt_doc_number,pre_glt_narration, pre_glt_other_reference, pre_glt_local_amount,pre_glt_detail_1 
FROM mt_payment_gl_details 
WHERE ((pre_glt_code between :from_glt_code and :to_glt_code) or (pre_glt_detail_1 between :from_glt_code and :to_glt_code)) and  (pre_glt_doc_date between :from_date and :to_date) and pre_glt_status is null
GROUP BY pre_glt_status,pre_glt_code, pre_glt_doc_date,pre_glt_doc_number,pre_glt_narration, pre_glt_other_reference, pre_glt_local_amount,pre_glt_detail_1

union all 

SELECT 
pre_glt_status,pre_glt_code,
(select ac_description from mt_general_ledger where code=pre_glt_code limit 1) gl_desc,  
pre_glt_doc_date,pre_glt_doc_number,pre_glt_narration, pre_glt_other_reference, pre_glt_local_amount,pre_glt_detail_1 
FROM mt_receipt_gl_details 
WHERE ((pre_glt_code between :from_glt_code and :to_glt_code) or (pre_glt_detail_1 between :from_glt_code and :to_glt_code)) and  (pre_glt_doc_date between :from_date and :to_date) and pre_glt_status is null
GROUP BY pre_glt_status,pre_glt_code, pre_glt_doc_date,pre_glt_doc_number,pre_glt_narration, pre_glt_other_reference, pre_glt_local_amount,pre_glt_detail_1

union all 

SELECT 
pre_glt_status,pre_glt_code,
(select ac_description from mt_general_ledger where code=pre_glt_code limit 1) gl_desc,  
pre_glt_doc_date,pre_glt_doc_number,pre_glt_narration, pre_glt_other_reference, pre_glt_local_amount,pre_glt_detail_1 
FROM ship_gl_details 
WHERE ((pre_glt_code between :from_glt_code and :to_glt_code) or (pre_glt_detail_1 between :from_glt_code and :to_glt_code)) and  (pre_glt_doc_date between :from_date and :to_date) and pre_glt_status is null
GROUP BY pre_glt_status,pre_glt_code, pre_glt_doc_date,pre_glt_doc_number,pre_glt_narration, pre_glt_other_reference, pre_glt_local_amount,pre_glt_detail_1

union all 

SELECT 
pre_glt_status,pre_glt_code,
(select ac_description from mt_general_ledger where code=pre_glt_code limit 1) gl_desc,  
pre_glt_doc_date,pre_glt_doc_number,pre_glt_narration, pre_glt_other_reference, pre_glt_local_amount,pre_glt_detail_1 
FROM mt_order_gl_details 
WHERE ((pre_glt_code between :from_glt_code and :to_glt_code) or (pre_glt_detail_1 between :from_glt_code and :to_glt_code)) and  (pre_glt_doc_date between :from_date and :to_date) and pre_glt_status is null
GROUP BY pre_glt_status,pre_glt_code, pre_glt_doc_date,pre_glt_doc_number,pre_glt_narration, pre_glt_other_reference, pre_glt_local_amount,pre_glt_detail_1
) gt 


union all 

SELECT pre_glt_status,pre_glt_code,gl_desc,pre_glt_doc_date,pre_glt_doc_number,pre_glt_narration, pre_glt_other_reference, pre_glt_local_amount,'' pre_glt_detail_1 FROM (SELECT 
pre_glt_status,aloc_detail_1 pre_glt_code,
(select ac_description from mt_general_ledger where code=aloc_detail_1 limit 1) gl_desc,  
pre_glt_doc_date,pre_glt_doc_number,pre_glt_narration, pre_glt_other_reference, pre_glt_local_amount 
FROM mt_jv_gl_details 
WHERE (aloc_detail_1 between :from_glt_code and :to_glt_code) and  (pre_glt_doc_date between :from_date and :to_date) and pre_glt_status is null
GROUP BY pre_glt_status,aloc_detail_1, pre_glt_doc_date,pre_glt_doc_number,pre_glt_narration, pre_glt_other_reference, pre_glt_local_amount
) gt 

ORDER BY pre_glt_code,pre_glt_doc_date

 ");
$statement->execute(array(':from_glt_code'=>$from_glt_code,':to_glt_code'=>$to_glt_code,':from_date'=>$from_date,':to_date'=>$to_date));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get PDC data
$statement = $db->prepare("SELECT account_group from mt_general_ledger where code=:glt_code limit 1 ");
$statement->execute(array(':glt_code'=>$from_glt_code));
$data["gl_group"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get Opening Balance 2
$statement = $db->prepare("SELECT SUM(CASE
        WHEN glt_doc_type='OPEN_BAL' THEN GLT_LOCAL_AMOUNT
        ELSE 0
    END) AS 'ob'
FROM mt_gl_details t1  
WHERE glt_code=:glt_code ");
$statement->execute(array(':glt_code'=>$from_glt_code));
$data["op_bal2"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get PDC data
$statement = $db->prepare("SELECT
t1.id, 
t1.rh_base_doc_type,
t1.rh_doc_type,
t1.rh_doc_date,
t1.rh_doc_number,
t1.rh_cash_bank_code,
t2.aloc_local_amount rh_local_amount,
t1.rh_cheque_number,
t1.rh_cheque_date 
FROM mt_receipt_header t1
LEFT JOIN mt_receipt_allocation_details t2
ON t1.rh_doc_number= t2.aloc_doc_number
WHERE t1.rh_status='AWAITING CONFIRMATION' and t2.aloc_doc_type='CHEQUE'  and t2.aloc_detail_1=:glt_code 
UNION
SELECT
t1.id,  
t1.ph_base_doc_type rh_base_doc_type,
t1.ph_doc_type rh_doc_type,
t1.ph_doc_date rh_doc_date,
t1.ph_doc_number rh_doc_number,
t1.ph_cash_bank_code rh_cash_bank_code,
t2.aloc_local_amount rh_local_amount,
t1.ph_cheque_number rh_cheque_number,
t1.ph_cheque_date rh_cheque_date 
FROM mt_payment_header t1
LEFT JOIN mt_payment_allocation_details t2
ON t1.ph_doc_number= t2.aloc_doc_number
WHERE t1.ph_status='AWAITING CONFIRMATION' and t2.aloc_doc_type='CHEQUE' and t2.aloc_detail_1=:glt_code");
$statement->execute(array(':glt_code'=>$from_glt_code));
$data["pdc_data"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_trial_balance($fc,$tc,$fin_year,$fin_period)
{
$data=array();
try
{
$db = Factory::getConnection();

//Get Summary info
$statement = $db->prepare("SELECT t2.account_serial, t2.account_sub_group, sum(case when pre_glt_local_amount > 0 THEN
pre_glt_local_amount
end) debit,
sum(case when pre_glt_local_amount < 0 THEN
pre_glt_local_amount
end) credit
from 
(
SELECT pre_glt_code,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM mt_ar_gl_details
UNION ALL
SELECT pre_glt_code,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM mt_ap_gl_details
UNION ALL
SELECT pre_glt_code,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM mt_payment_gl_details
UNION ALL
SELECT pre_glt_code,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM mt_receipt_gl_details
UNION ALL
SELECT pre_glt_code,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM ship_gl_details
UNION ALL
SELECT pre_glt_code,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM mt_order_gl_details
) t1
left join mt_general_ledger t2
on t2.code=t1.pre_glt_code
where pre_glt_year=:fin_year and pre_glt_period=:fin_period 
group by t2.account_serial, t2.account_sub_group");
$statement->execute(array( ':fin_year'=>$fin_year,
':fin_period'=>$fin_period));
$data["summary"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get Detail info
$statement = $db->prepare("SELECT t2.account_serial, t2.account_sub_group,pre_glt_code, t2.ac_description, '0' open_balance, sum(case when pre_glt_local_amount > 0 THEN
pre_glt_local_amount
end) debit,
sum(case when pre_glt_local_amount < 0 THEN
pre_glt_local_amount
end) credit
from 
(
SELECT pre_glt_code,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM mt_ar_gl_details
UNION ALL
SELECT pre_glt_code,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM mt_ap_gl_details
UNION ALL
SELECT pre_glt_code,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM mt_payment_gl_details
UNION ALL
SELECT pre_glt_code,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM mt_receipt_gl_details
UNION ALL
SELECT pre_glt_code,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM ship_gl_details
UNION ALL
SELECT pre_glt_code,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM mt_order_gl_details
) t1 
left join mt_general_ledger t2
on t2.code=t1.pre_glt_code
where pre_glt_year=:fin_year and pre_glt_period=:fin_period 
group by pre_glt_code, t2.ac_description");
$statement->execute(array( ':fin_year'=>$fin_year,
':fin_period'=>$fin_period));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_balance_sheet($fy1,$fy2,$username)
{
$data=array();
try
{
$db = Factory::getConnection();

//Get Location
$statement = $db->prepare("SELECT location from user_master
where username=:username ");
$statement->execute(array(':username'=>$username));
$data["location"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$location_id=$data["location"][0]["location"];

//Get Summary info
$statement = $db->prepare("



SELECT t2.account_serial, t2.account_type, t2.account_group,t2.account_sub_group,

round(sum(art_local_balance)) total 
from 
(
SELECT art_code, art_group, sum(art_local_balance) art_local_balance FROM mt_ar_trans
where ((date_format(art_doc_date,'%Y')='$fy1' and date_format(art_doc_date,'%m') in ('04','05','06','07','08','09','10','11','12') ) or (date_format(art_doc_date,'%Y')='$fy2' and date_format(art_doc_date,'%m') in ('01','02','03') ))
and art_type in ('PRO-INV','IMP-INV','EXP-INV','OUTPUT IGST','OUTPUT SGST','OUTPUT CGST')
and art_balance_status!='CANCELLED' 
group by art_code, art_group

) t1 
left join mt_general_ledger t2
on t2.code=t1.art_group 
where t2.account_serial in ('130') 
group by t2.account_serial, t2.account_type, t2.account_group,t2.account_sub_group 
having t2.account_serial is not null

UNION ALL 


SELECT t2.account_serial, t2.account_type, t2.account_group,t2.account_sub_group,

round(sum(art_local_balance)) total 
from 
(

SELECT '' art_code, apt_type, apt_description art_group, sum(apt_local_balance) art_local_balance FROM mt_ap_trans
where ((date_format(apt_doc_date,'%Y')='$fy1' and date_format(apt_doc_date,'%m') in ('04','05','06','07','08','09','10','11','12') ) or (date_format(apt_doc_date,'%Y')='$fy2' and date_format(apt_doc_date,'%m') in ('01','02','03') ))
and apt_type in ('LPO','INPUT CGST','INPUT IGST','INPUT SGST','TDS PAYABLE')
and apt_balance_status!='CANCELLED' 
and apt_group!='SHIP'
group by  apt_description, apt_type

UNION ALL 

SELECT apt_code art_code, apt_type, '2-20-001-0000' art_group, sum(apt_local_balance) art_local_balance FROM mt_ap_trans
where ((date_format(apt_doc_date,'%Y')='$fy1' and date_format(apt_doc_date,'%m') in ('04','05','06','07','08','09','10','11','12') ) or (date_format(apt_doc_date,'%Y')='$fy2' and date_format(apt_doc_date,'%m') in ('01','02','03') ))
and apt_balance_status!='CANCELLED' 
and apt_group='SHIP'
group by apt_code, apt_description, apt_type

) t1 
left join mt_general_ledger t2
on t2.code=t1.art_group 
where t2.account_serial in ('220','230') 
group by t2.account_serial, t2.account_type, t2.account_group,t2.account_sub_group 
having t2.account_serial is not null



  ");
$statement->execute(array());
$data["summary"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get Detail info
$statement = $db->prepare("

SELECT t2.account_serial, t2.account_type, t2.account_group,t2.account_sub_group, (select name from mt_business_partner where code=t1.art_code limit 1) ac_description, 

round(sum(art_local_balance)) total 
from 
(
SELECT art_code, art_group, sum(art_local_balance) art_local_balance FROM mt_ar_trans
where ((date_format(art_doc_date,'%Y')='$fy1' and date_format(art_doc_date,'%m') in ('04','05','06','07','08','09','10','11','12') ) or (date_format(art_doc_date,'%Y')='$fy2' and date_format(art_doc_date,'%m') in ('01','02','03') ))
and art_type in ('PRO-INV','IMP-INV','EXP-INV','OUTPUT IGST','OUTPUT SGST','OUTPUT CGST')
and art_balance_status!='CANCELLED' 
group by art_code, art_group

) t1 
left join mt_general_ledger t2
on t2.code=t1.art_group 
where t2.account_serial in ('130') 
group by art_code, art_group, t2.ac_description, t2.account_serial, t2.account_type, t2.account_group,t2.account_sub_group 
having t2.account_serial is not null

 ");
$statement->execute(array());
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);


//Get Detail info2
$statement = $db->prepare("

SELECT t2.account_serial, t2.account_type, t2.account_group,t2.account_sub_group, ifnull((select name from mt_business_partner where code=t1.art_code limit 1),t2.ac_description) ac_description, 

round(sum(art_local_balance)) total 
from 
(

SELECT '' art_code, apt_type, apt_description art_group, sum(apt_local_balance) art_local_balance FROM mt_ap_trans
where ((date_format(apt_doc_date,'%Y')='$fy1' and date_format(apt_doc_date,'%m') in ('04','05','06','07','08','09','10','11','12') ) or (date_format(apt_doc_date,'%Y')='$fy2' and date_format(apt_doc_date,'%m') in ('01','02','03') ))
and apt_type in ('LPO','INPUT CGST','INPUT IGST','INPUT SGST','TDS PAYABLE')
and apt_balance_status!='CANCELLED' 
and apt_group!='SHIP'
group by  apt_description, apt_type

UNION ALL 

SELECT apt_code art_code, apt_type, '2-20-001-0000' art_group, sum(apt_local_balance) art_local_balance FROM mt_ap_trans
where ((date_format(apt_doc_date,'%Y')='$fy1' and date_format(apt_doc_date,'%m') in ('04','05','06','07','08','09','10','11','12') ) or (date_format(apt_doc_date,'%Y')='$fy2' and date_format(apt_doc_date,'%m') in ('01','02','03') ))
and apt_balance_status!='CANCELLED' 
and apt_group='SHIP'
group by apt_code, apt_description, apt_type

) t1 
left join mt_general_ledger t2
on t2.code=t1.art_group 
where t2.account_serial in ('220','230') 
group by art_code, art_group, t2.ac_description, t2.account_serial, t2.account_type, t2.account_group,t2.account_sub_group 
having t2.account_serial is not null

 ");
$statement->execute(array());
$data["info2"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_pl_statement($from_date,$to_date,$username)
{
$data=array();
try
{
$db = Factory::getConnection();

//Get Location
$statement = $db->prepare("SELECT location from user_master
where username=:username ");
$statement->execute(array(':username'=>$username));
$data["location"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$location_id=$data["location"][0]["location"];

//Get INCOME info
$statement = $db->prepare(" 
  SELECT sub_ar_doc_base, round(sum(sub_ar_l_amount),2) income_total from mt_ship_ar_header
WHERE sub_ar_doc_type in ('IMP-INV','EXP-INV') 
and location_id=:location_id  
and sub_ar_status!='CANCELLED' 
and job_close_date between :from_date and :to_date 
GROUP BY sub_ar_doc_base ");
$statement->execute(array( ':from_date'=>$from_date,
':to_date'=>$to_date,':location_id'=>$location_id));

$data["income"]=$statement->fetchAll(PDO::FETCH_ASSOC);


//Get EXPENSES info
$statement = $db->prepare("SELECT t2.account_group, t2.account_sub_group, t1.pre_glt_code, t2.ac_description, sum(pre_glt_local_amount) amount 
from 
(
SELECT pre_glt_code,pre_glt_gl_date,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM mt_ar_gl_details
WHERE location_id=:location_id 
UNION ALL
SELECT pre_glt_code,pre_glt_gl_date,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM mt_ap_gl_details
WHERE location_id=:location_id 
UNION ALL
SELECT pre_glt_code,pre_glt_gl_date,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM mt_payment_gl_details
WHERE location_id=:location_id 
UNION ALL
SELECT pre_glt_code,pre_glt_gl_date,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM mt_receipt_gl_details
WHERE location_id=:location_id 
UNION ALL
SELECT pre_glt_code,pre_glt_gl_date,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM ship_gl_details
WHERE location_id=:location_id 
UNION ALL
SELECT pre_glt_code,pre_glt_gl_date,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM mt_order_gl_details
WHERE location_id=:location_id 
) t1
left join mt_general_ledger t2
on t2.code=t1.pre_glt_code
where t2.account_type in ('EXPENSES') and pre_glt_gl_date between :from_date and :to_date  
group by t2.account_group, t2.account_sub_group, t1.pre_glt_code, t2.ac_description");
$statement->execute(array( ':from_date'=>$from_date,
':to_date'=>$to_date,':location_id'=>$location_id));

$data["expenses"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get OPERTING EXPENSES info
$statement = $db->prepare(" 
  SELECT aph_document_base, round(sum(aph_local_amount),2) opex_total FROM mt_ap_header
WHERE location_id=:location_id 
and aph_status!='CANCELLED' 
and aph_document_base in ('PAYABLE VOUCHER') 
and aph_document_date between :from_date and :to_date 
group by aph_document_base
 ");
$statement->execute(array( ':from_date'=>$from_date,
':to_date'=>$to_date,':location_id'=>$location_id));

$data["opex"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_pl_statement_glwise($from_date,$to_date,$username)
{
$data=array();
try
{
$db = Factory::getConnection();

//Get Location
$statement = $db->prepare("SELECT location from user_master
where username=:username ");
$statement->execute(array(':username'=>$username));
$data["location"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$location_id=$data["location"][0]["location"];

//Get INCOME info
$statement = $db->prepare("SELECT t2.account_group, t2.account_sub_group, t1.pre_glt_code, t2.ac_description, sum(pre_glt_local_amount) amount 
from 
(
SELECT pre_glt_code,pre_glt_gl_date,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM mt_ar_gl_details
  WHERE location_id=:location_id 
UNION ALL
SELECT pre_glt_code,pre_glt_gl_date,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM mt_ap_gl_details
WHERE location_id=:location_id 
UNION ALL
SELECT pre_glt_code,pre_glt_gl_date,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM mt_payment_gl_details
WHERE location_id=:location_id 
UNION ALL
SELECT pre_glt_code,pre_glt_gl_date,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM mt_receipt_gl_details
WHERE location_id=:location_id 
UNION ALL
SELECT pre_glt_code,pre_glt_gl_date,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM ship_gl_details
WHERE location_id=:location_id 
UNION ALL
SELECT pre_glt_code,pre_glt_gl_date,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM mt_order_gl_details
WHERE location_id=:location_id 
) t1
left join mt_general_ledger t2
on t2.code=t1.pre_glt_code
where t2.account_type in ('INCOME') and pre_glt_gl_date between :from_date and :to_date  
group by t2.account_group, t2.account_sub_group, t1.pre_glt_code, t2.ac_description");
$statement->execute(array( ':from_date'=>$from_date,
':to_date'=>$to_date,':location_id'=>$location_id));

$data["income"]=$statement->fetchAll(PDO::FETCH_ASSOC);


//Get EXPENSES info
$statement = $db->prepare("SELECT t2.account_group, t2.account_sub_group, t1.pre_glt_code, t2.ac_description, sum(pre_glt_local_amount) amount 
from 
(
SELECT pre_glt_code,pre_glt_gl_date,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM mt_ar_gl_details
WHERE location_id=:location_id 
UNION ALL
SELECT pre_glt_code,pre_glt_gl_date,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM mt_ap_gl_details
WHERE location_id=:location_id 
UNION ALL
SELECT pre_glt_code,pre_glt_gl_date,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM mt_payment_gl_details
WHERE location_id=:location_id 
UNION ALL
SELECT pre_glt_code,pre_glt_gl_date,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM mt_receipt_gl_details
WHERE location_id=:location_id 
UNION ALL
SELECT pre_glt_code,pre_glt_gl_date,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM ship_gl_details
WHERE location_id=:location_id 
UNION ALL
SELECT pre_glt_code,pre_glt_gl_date,pre_glt_local_amount,pre_glt_year,pre_glt_period FROM mt_order_gl_details
WHERE location_id=:location_id 
) t1
left join mt_general_ledger t2
on t2.code=t1.pre_glt_code
where t2.account_type in ('EXPENSES') and pre_glt_gl_date between :from_date and :to_date  
group by t2.account_group, t2.account_sub_group, t1.pre_glt_code, t2.ac_description");
$statement->execute(array( ':from_date'=>$from_date,
':to_date'=>$to_date,':location_id'=>$location_id));

$data["expenses"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_invoice_details($temp_code,$id,$inv_no)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT (SELECT name from mt_business_partner where code=sub_ar_code) customer,
  sub_ar_doc_type doc_type,
sub_ar_doc_number invoice,
sub_ar_date cdate,
sub_ar_doc_base service_type,
sub_ar_currency currency,
sub_ar_narration narration,
bl_no 
 from mt_ship_ar_header 
 where id=:id and 
 temp_code=:temp_code and sub_ar_doc_number=:doc_no ");
$statement->execute(array(':doc_no'=>$inv_no,
  ':id'=>$id,':temp_code'=>$temp_code));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$order_id=$id;

$statement = $db->prepare("SELECT description, qty, rate
 from mt_invoice_printdescriptions
 where invoice_no=:doc_no");
$statement->execute(array(':doc_no'=>$inv_no));
$data["charge"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//
//vessel,voyage,eta,shipper,pol,pod

$bl_no=$data["info"][0]["bl_no"];
$cv='';
$spv=explode(",",$bl_no);
for($i=0;$i<count($spv);$i++)
{
$sp=$spv[$i];
if(strlen($sp)!=0)
{
  $cv=$cv."'$sp',";
}
}
$cv=substr($cv,0,-1);
$sq="SELECT t1.bl_no,t2.voyage,t2.vessel,t2.eline,t2.pol,t2.pod,t2.eta, (select name from mt_business_partner where code=(select party_name from mt_manifest_entry_party where mnf_entry_pk=t1.id and party_type='SHIPPER')) shipper
from mt_manifest_entry t1, 
mt_manifest_entry_route t2
where t2.mnf_entry_pk=t1.id and t1.bl_no in($cv)";
$statement = $db->prepare($sq);
$statement->execute();
$data["voyage"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$data["q"]=$sq;
//lc container info

$statement = $db->prepare("SELECT t1.bl_no,t2.vin_no, t2.vehicle_type, t2.gr_wgt, t2.commodity, t2.no_of_pkgs
from mt_manifest_entry t1, 
mt_manifest_entry_landingcraft t2
where t2.mnf_entry_pk=t1.id and t1.bl_no in ($cv)
UNION 
SELECT t1.bl_no,main_commodity vin_no,package_type vehicle_type, 
gross_weight gr_wgt,'' commodity,no_of_packages no_of_pkgs
from mt_manifest_entry t1, 
mt_manifest_entry_cargo t2
where t2.mnf_entry_pk=t1.id and t1.bl_no in ($cv)");
$statement->execute();
$data["lc_info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//end
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_invoice_details_format2_forward($temp_code,$id,$inv_no)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT (SELECT name from mt_business_partner where code=sub_ar_code) customer,
   (SELECT address from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=sub_ar_code) limit 1) c_add1,
   (SELECT address2 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=sub_ar_code) limit 1) c_add2,
   (SELECT address3 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=sub_ar_code) limit 1) c_add3,
   (SELECT gstin from mt_business_partner where code=sub_ar_code) c_gstin,
  (SELECT city from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=sub_ar_code) limit 1) c_city,
   (SELECT zip from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=sub_ar_code) limit 1) c_zip,
  sub_ar_status,
  sub_ar_doc_type doc_type,
sub_ar_doc_number invoice,
DATE_FORMAT(sub_ar_date, '%d-%m-%Y') cdate,
sub_ar_doc_base service_type,
sub_ar_currency currency,
sub_ar_ex_rate ex_rate,
sub_ar_narration narration,
bl_no, 
(select master_bl_no from mt_manifest_entry where bl_no in (select bl_no from mt_order_entry where order_no=REPLACE(t1.order_no,',', '')) limit 1) mbl_no,
(select master_bl_no from mt_manifest_entry where bl_no in (select bl_no from mt_order_entry where order_no=t1.order_no) limit 1) mbl_no,
sub_ar_status status,
order_no,
gst_percent,
vat_amt,
igst,
cgst,
sgst,
location_id,
company_id,
sub_ar_user,
sub_ar_notes      
 from mt_order_ar_header t1 
 where id=:id and 
 temp_code=:temp_code and sub_ar_doc_number=:doc_no ");
$statement->execute(array(':doc_no'=>$inv_no,
  ':id'=>$id,':temp_code'=>$temp_code));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$order_id=$id;

$statement = $db->prepare("SELECT charge_desc,(SELECT description from mt_charge_group_detail WHERE code=charge_desc limit 1) description,sub_ard_currency currency,sum(sub_ard_quantity) qty, sum(total_amt) rate,
  sub_ard_rate unit_price,align_no, sub_ard_narration,
  (SELECT sac from mt_charge_group_detail WHERE code=charge_desc limit 1) sac,gst_percent    
 from mt_order_ar_details
 where sub_ard_doc_number=:doc_no group by charge_desc,sub_ard_currency,sub_ard_rate,align_no, sub_ard_narration,gst_percent  
 order by align_no asc");
$statement->execute(array(':doc_no'=>$inv_no));
$data["charge"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT DISTINCT gst_percent FROM `mt_ship_ar_details` WHERE sub_ard_doc_number=:doc_no");
$statement->execute(array(':doc_no'=>$inv_no));
$data["gst_data"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//vessel,voyage,eta,shipper,pol,pod

$bl_no=$data["info"][0]["bl_no"];
$cv='';
$spv=explode(",",$bl_no);
for($i=0;$i<count($spv);$i++)
{
$sp=$spv[$i];
if(strlen($sp)!=0)
{
  $cv=$cv."'$sp',";
}
}
$cv=substr($cv,0,-1);
$statement = $db->prepare("SELECT t1.bl_no,t2.voyage,t2.vessel,t2.eline,t2.pol,t2.pod,t2.eta, (select name from mt_business_partner where code=(select party_name from mt_manifest_entry_party where mnf_entry_pk=t1.id and party_type='SHIPPER')) shipper,
  (select name from mt_business_partner where code=(select party_name from mt_manifest_entry_party where mnf_entry_pk=t1.id and party_type='CONSIGNEE')) consignee 
from mt_manifest_entry t1, 
mt_manifest_entry_route t2
where t2.mnf_entry_pk=t1.id and (t1.bl_no in($cv) or t1.bl_no like '$bl_no%') ");
$statement->execute();
$data["voyage"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT 
container_no,
seal_no,
type,
package_type,
no_of_pkgs,
volume,
gr_wgt,
nt_wgt,
tt_wgt,
(SELECT description from mt_commodity_master where code=commodity limit 1) commodity,
cargo_desc  from mt_manifest_entry_container where mnf_entry_pk in (select id from mt_manifest_entry where bl_no in ($cv) ) ");
$statement->execute();
$data["lc_info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Container numbers only from BL
$statement = $db->prepare(" SELECT GROUP_CONCAT(container_txt1 SEPARATOR '; ') container_txt1
FROM 
(
  SELECT 
GROUP_CONCAT(container_no SEPARATOR ', ') container_txt,
concat(type, ' X ', count(container_no),' - ',GROUP_CONCAT(container_no SEPARATOR ', ') ) container_txt1 
  from mt_manifest_entry_container where mnf_entry_pk in (select id from mt_manifest_entry where bl_no in ($cv) ) 
  group by type 
) gt ");
$statement->execute();
$data["lc1_info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Container numbers only from Order
$statement = $db->prepare(" SELECT GROUP_CONCAT(container_txt1 SEPARATOR '; ') container_txt1
FROM 
(
  SELECT 
GROUP_CONCAT(container_no SEPARATOR ', ') container_txt,
concat(type, ' X ', count(container_no),' - ',GROUP_CONCAT(container_no SEPARATOR ', ') ) container_txt1 
  from mt_order_container_detail where order_id in (select id from mt_order_entry where bl_no in ($cv) ) 
    group by type 
  ) gt ");
$statement->execute();
$data["lc2_info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//ship supplies
$statement = $db->prepare("SELECT id,order_id,routing_transport_leg, voyage, (select eta from mt_voyage where voyage=t1.voyage) eta,
(select vessel from mt_voyage where voyage=t1.voyage) vessel,
(select (select t0.name from mt_business_partner t0 where code=t3.party_name) from mt_order_parties t3 where t3.order_id=t1.order_id and t3.party_type='SHIPPER' ) shipper  from mt_order_route t1 
where order_id=(select id from mt_order_entry where order_no=:order_no)");
$statement->execute(array(':order_no'=>$data["info"][0]["order_no"]));
$data["shipsupply"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_invoice_details_format2($temp_code,$id,$inv_no)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT (SELECT name from mt_business_partner where code=sub_ar_code) customer,
   (SELECT address from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=sub_ar_code) limit 1) c_add1,
   (SELECT address2 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=sub_ar_code) limit 1) c_add2,
   (SELECT address3 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=sub_ar_code) limit 1) c_add3,
   (SELECT gstin from mt_business_partner where code=sub_ar_code) c_gstin,
  (SELECT city from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=sub_ar_code) limit 1) c_city,
   (SELECT zip from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=sub_ar_code) limit 1) c_zip,
  sub_ar_status,
  sub_ar_doc_type doc_type,
sub_ar_doc_number invoice,
DATE_FORMAT(sub_ar_date, '%d-%m-%Y') cdate,
sub_ar_doc_base service_type,
sub_ar_currency currency,
sub_ar_ex_rate ex_rate,
sub_ar_narration narration,
bl_no, 
(select master_bl_no from mt_manifest_entry where bl_no in (select bl_no from mt_order_entry where order_no=REPLACE(t1.order_no,',', '')) limit 1) mbl_no,
(select master_bl_no from mt_manifest_entry where bl_no in (select bl_no from mt_order_entry where order_no=t1.order_no) limit 1) mbl_no,
sub_ar_status status,
order_no,
gst_percent,
vat_amt,
igst,
cgst,
sgst,
location_id,
company_id,
sub_ar_user,
sub_ar_notes      
 from mt_ship_ar_header t1 
 where id=:id and 
 temp_code=:temp_code and sub_ar_doc_number=:doc_no ");
$statement->execute(array(':doc_no'=>$inv_no,
  ':id'=>$id,':temp_code'=>$temp_code));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$order_id=$id;

$statement = $db->prepare("SELECT charge_desc,(SELECT description from mt_charge_group_detail WHERE code=charge_desc limit 1) description,sub_ard_currency currency,sum(sub_ard_quantity) qty, sum(total_amt) rate,
  sub_ard_rate unit_price,align_no, sub_ard_narration,
  (SELECT sac from mt_charge_group_detail WHERE code=charge_desc limit 1) sac,gst_percent    
 from mt_ship_ar_details
 where sub_ard_doc_number=:doc_no group by charge_desc,sub_ard_currency,sub_ard_rate,align_no, sub_ard_narration,gst_percent  
 order by align_no asc");
$statement->execute(array(':doc_no'=>$inv_no));
$data["charge"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT DISTINCT gst_percent FROM `mt_ship_ar_details` WHERE sub_ard_doc_number=:doc_no");
$statement->execute(array(':doc_no'=>$inv_no));
$data["gst_data"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//vessel,voyage,eta,shipper,pol,pod

$bl_no=$data["info"][0]["bl_no"];
$cv='';
$spv=explode(",",$bl_no);
for($i=0;$i<count($spv);$i++)
{
$sp=$spv[$i];
if(strlen($sp)!=0)
{
  $cv=$cv."'$sp',";
}
}
$cv=substr($cv,0,-1);
$statement = $db->prepare("SELECT t1.bl_no,t2.voyage,t2.vessel,t2.eline,t2.pol,t2.pod,t2.eta, (select name from mt_business_partner where code=(select party_name from mt_manifest_entry_party where mnf_entry_pk=t1.id and party_type='SHIPPER')) shipper,
  (select name from mt_business_partner where code=(select party_name from mt_manifest_entry_party where mnf_entry_pk=t1.id and party_type='CONSIGNEE')) consignee 
from mt_manifest_entry t1, 
mt_manifest_entry_route t2
where t2.mnf_entry_pk=t1.id and (t1.bl_no in($cv) or t1.bl_no like '$bl_no%') ");
$statement->execute();
$data["voyage"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//lc container info

// $statement = $db->prepare("SELECT t1.bl_no, t1.cargo_type, t2.vin_no, t2.vehicle_type, t2.gr_wgt, t2.commodity, t2.no_of_pkgs
// from mt_manifest_entry t1, 
// mt_manifest_entry_landingcraft t2
// where t2.mnf_entry_pk=t1.id and t1.bl_no in ($cv)
// UNION 
// SELECT t1.bl_no, t1.cargo_type, main_commodity vin_no,package_type vehicle_type, 
// gross_weight gr_wgt,'' commodity,no_of_packages no_of_pkgs
// from mt_manifest_entry t1, 
// mt_manifest_entry_cargo t2
// where t2.mnf_entry_pk=t1.id and t1.bl_no in ($cv)");
// $statement->execute();
// $data["lc_info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT 
container_no,
seal_no,
type,
package_type,
no_of_pkgs,
volume,
gr_wgt,
nt_wgt,
tt_wgt,
(SELECT description from mt_commodity_master where code=commodity limit 1) commodity,
cargo_desc  from mt_manifest_entry_container where mnf_entry_pk in (select id from mt_manifest_entry where bl_no in ($cv) ) ");
$statement->execute();
$data["lc_info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Container numbers only from BL
$statement = $db->prepare(" SELECT GROUP_CONCAT(container_txt1 SEPARATOR '; ') container_txt1
FROM 
(
  SELECT 
GROUP_CONCAT(container_no SEPARATOR ', ') container_txt,
concat(type, ' X ', count(container_no),' - ',GROUP_CONCAT(container_no SEPARATOR ', ') ) container_txt1 
  from mt_manifest_entry_container where mnf_entry_pk in (select id from mt_manifest_entry where bl_no in ($cv) ) 
  group by type 
) gt ");
$statement->execute();
$data["lc1_info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Container numbers only from Order
$statement = $db->prepare(" SELECT GROUP_CONCAT(container_txt1 SEPARATOR '; ') container_txt1
FROM 
(
  SELECT 
GROUP_CONCAT(container_no SEPARATOR ', ') container_txt,
concat(type, ' X ', count(container_no),' - ',GROUP_CONCAT(container_no SEPARATOR ', ') ) container_txt1 
  from mt_order_container_detail where order_id in (select id from mt_order_entry where bl_no in ($cv) ) 
    group by type 
  ) gt ");
$statement->execute();
$data["lc2_info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//ship supplies
$statement = $db->prepare("SELECT id,order_id,routing_transport_leg, voyage, (select eta from mt_voyage where voyage=t1.voyage) eta,
(select vessel from mt_voyage where voyage=t1.voyage) vessel,
(select (select t0.name from mt_business_partner t0 where code=t3.party_name) from mt_order_parties t3 where t3.order_id=t1.order_id and t3.party_type='SHIPPER' ) shipper  from mt_order_route t1 
where order_id=(select id from mt_order_entry where order_no=:order_no)");
$statement->execute(array(':order_no'=>$data["info"][0]["order_no"]));
$data["shipsupply"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_epda_detail($temp_code,$id,$inv_no)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT (SELECT name from mt_business_partner where code=sub_ar_code) customer,
  sub_ar_status,
  sub_ar_doc_type doc_type,
sub_ar_doc_number invoice,
sub_ar_date cdate,
sub_ar_doc_base service_type,
sub_ar_currency currency,
sub_ar_narration narration,
t1.bl_no, sub_ar_status status,
t1.order_no, sub_ar_notes,
t2.cargo_type ,
  (select port_name from mt_port_master where port_code=t2.shipment_from) shipment_from,  
  (select port_name from mt_port_master where port_code= t2.shipment_to) shipment_to     
  from mt_ship_ar_header t1
 left join mt_order_entry t2
 on trim(TRAILING ',' from t1.order_no) =t2.order_no 
 where t1.id=:id and 
 t1.temp_code=:temp_code and sub_ar_doc_number=:doc_no ");
$statement->execute(array(':doc_no'=>$inv_no,
  ':id'=>$id,':temp_code'=>$temp_code));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$order_id=$id;

$statement = $db->prepare("SELECT t1.charge_desc, t2.description, t2.epda_cat, t1.sub_ard_quantity qty, t1.total_amt rate, t1.sub_ard_rate unit_price
FROM mt_ship_ar_details t1
LEFT JOIN mt_charge_group_detail t2
ON t1.charge_desc=t2.code
WHERE t1.sub_ard_doc_number=:doc_no and t2.epda_cat='OFT'");
$statement->execute(array(':doc_no'=>$inv_no));
$data["charge0"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT t1.charge_desc, t2.description, t2.epda_cat, t1.sub_ard_quantity qty, t1.total_amt rate, t1.sub_ard_rate unit_price
FROM mt_ship_ar_details t1
LEFT JOIN mt_charge_group_detail t2
ON t1.charge_desc=t2.code
WHERE t1.sub_ard_doc_number=:doc_no and t2.epda_cat='DPMC'");
$statement->execute(array(':doc_no'=>$inv_no));
$data["charge1"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT t1.charge_desc, t2.description, t2.epda_cat, t1.sub_ard_quantity qty, t1.total_amt rate, t1.sub_ard_rate unit_price
FROM mt_ship_ar_details t1
LEFT JOIN mt_charge_group_detail t2
ON t1.charge_desc=t2.code
WHERE t1.sub_ard_doc_number=:doc_no and t2.epda_cat='SHCR'");
$statement->execute(array(':doc_no'=>$inv_no));
$data["charge2"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT t1.charge_desc, t2.description, t2.epda_cat, t1.sub_ard_quantity qty, t1.total_amt rate, t1.sub_ard_rate unit_price
FROM mt_ship_ar_details t1
LEFT JOIN mt_charge_group_detail t2
ON t1.charge_desc=t2.code
WHERE t1.sub_ard_doc_number=:doc_no and t2.epda_cat='CCT'");
$statement->execute(array(':doc_no'=>$inv_no));
$data["charge3"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT t1.charge_desc, t2.description, t2.epda_cat, t1.sub_ard_quantity qty, t1.total_amt rate, t1.sub_ard_rate unit_price
FROM mt_ship_ar_details t1
LEFT JOIN mt_charge_group_detail t2
ON t1.charge_desc=t2.code
WHERE t1.sub_ard_doc_number=:doc_no and t2.epda_cat='ACAOC'");
$statement->execute(array(':doc_no'=>$inv_no));
$data["charge4"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT main_commodity,package_type,no_of_packages,gross_weight,weight_uom FROM mt_order_cargo where order_id =(SELECT id from mt_order_entry where order_no=(SELECT REPLACE(order_no,',', '') from mt_ship_ar_header 
  where id=:id))");
$statement->execute(array(':id'=>$id));
$data["cargo_summary"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_order_details($temp_code,$id,$order_no)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT quote, expected_date, status, 
  (SELECT name from mt_business_partner where code=customer) customer, enquiry_reference, order_no, order_type, 
(SELECT name from mt_business_partner where code=(select party_name from mt_order_parties where party_type='SHIPPER' and order_id=t1.id)) shipper, 
(SELECT name from mt_business_partner where code=(select party_name from mt_order_parties where party_type='CONSIGNEE' and order_id=t1.id)) consignee,
(SELECT name from mt_business_partner where code=(select party_name from mt_order_parties where party_type='NOTIFY PARTY' and order_id=t1.id)) notify,company_id,location_id  
from mt_order_entry t1
 where id=:id and temp_code=:temp_code 
 and order_no=:order_no");
$statement->execute(array(':temp_code'=>$temp_code,
  ':id'=>$id,':order_no'=>$order_no));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$order_id=$id;

$statement = $db->prepare("SELECT routing_transport_leg, mode, provider,efrom, eto,transport_reference  
from mt_order_route where order_id=:order_id");
$statement->execute(array(':order_id'=>$order_id));
$data["route"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT  container_no, type, gr_wgt, 
  tt_wgt, (SELECT description from mt_commodity_master where code=commodity limit 1) commodity,reefer
from mt_order_container_detail
 where order_id=:order_id");
$statement->execute(array(':order_id'=>$order_id));
$data["container"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT (SELECT description from mt_charge_group_detail where code =charge_desc) charge_desc,pay_at_location,
  mode_of_pay,basis_type,qty,currency,ex_rate,rate_selling,
  selling_base_amount selling_amount,billing_party,remarks
from mt_order_cost where order_id=:order_id and type='INCOME'");
$statement->execute(array(':order_id'=>$order_id));
$data["charge"]=$statement->fetchAll(PDO::FETCH_ASSOC);



$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_order_cost_sheet_details($temp_code,$id,$order_no)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT quote, expected_date, status, (select name from mt_business_partner where code=customer) customer, enquiry_reference, order_no, order_type, 
(select name from mt_business_partner where code=(select party_name from mt_order_parties where party_type='SHIPPER' and order_id=t1.id)) shipper, 
(select name from mt_business_partner where code=(select party_name from mt_order_parties where party_type='CONSIGNEE' and order_id=t1.id)) consignee,
(select name from mt_business_partner where code=(select party_name from mt_order_parties where party_type='NOTIFY PARTY' and order_id=t1.id)) notify, company_id,
bl_no, (SELECT vessel from mt_voyage where voyage=(SELECT voyage from mt_manifest_entry where bl_no=t1.bl_no)) vessel,
company_id,location_id  
from mt_order_entry t1 
 where id=:id and temp_code=:temp_code 
 and order_no=:order_no");
$statement->execute(array(':temp_code'=>$temp_code,
  ':id'=>$id,':order_no'=>$order_no));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);


//get container count
$statement = $db->prepare("SELECT container_no, type, cargo_desc,package_type,no_of_pkgs,gr_wgt,nt_wgt, volume from mt_order_container_detail
 where order_id=:id UNION
SELECT vin_no container_no,vehicle_type type,cargo_desc,package_type,no_of_pkgs,gr_wgt,nt_wgt,volume 
from mt_order_landingcraft_detail
 where order_id=:id");
$statement->execute(array(':id'=>$id));
$data["cds"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$order_id=$id;

/*
old query
SELECT  (SELECT description from mt_charge_group_detail where code=t1.charge_desc) charge_desc ,qty,IFNULL((select cost_base_amount from mt_order_cost 
  where order_id=:order_id and type='COST' and charge_desc=t1.charge_desc),0) cost_base_amount, IFNULL(selling_base_amount,0) selling_base_amount,
  billing_party,( IFNULL(selling_base_amount,0) - IFNULL((select cost_base_amount from mt_order_cost where order_id=:order_id and type='COST' and charge_desc=t1.charge_desc),0)) profit
from mt_order_cost t1 where order_id=:order_id and type='INCOME'
*/
/*
left join query
SELECT (SELECT description from mt_charge_group_detail where code=t1.charge_desc) charge_desc,
sqty qty ,cost_base_amount,selling_base_amount,selling_base_amount-cost_base_amount profit from (select sum(selling_base_amount) selling_base_amount,charge_desc,sum(qty) sqty from mt_order_cost where order_id=:order_id and type='INCOME' GROUP by charge_desc
) t1 LEFT JOIN (select sum(cost_base_amount) cost_base_amount, charge_desc,sum(qty) cqty from mt_order_cost 
  where order_id=:order_id and type='COST' GROUP by charge_desc) t2 on t1.charge_desc=t2.charge_desc
*/
//outer join applied
$statement = $db->prepare(" SELECT (SELECT description from mt_charge_group_detail where code=t1.charge_desc) charge_desc ,ifnull(cost_base_amount,0) cost_base_amount,selling_base_amount,selling_base_amount-ifnull(cost_base_amount,0) profit from (select sum(selling_base_amount) selling_base_amount,charge_desc from mt_order_cost where order_id=:order_id and type='INCOME' GROUP by charge_desc
) t1 LEFT JOIN (select sum(cost_base_amount) cost_base_amount, charge_desc from mt_order_cost 
  where order_id=:order_id and type='COST' GROUP by charge_desc) t2 on t1.charge_desc=t2.charge_desc
  UNION
  
  SELECT (SELECT description from mt_charge_group_detail where code=t2.charge_desc) charge_desc,
  cost_base_amount,ifnull(selling_base_amount,0) selling_base_amount,ifnull(selling_base_amount,0)-cost_base_amount profit from (select sum(selling_base_amount) selling_base_amount,charge_desc from mt_order_cost where order_id=:order_id and type='INCOME' GROUP by charge_desc
) t1 RIGHT JOIN (select sum(cost_base_amount) cost_base_amount, charge_desc from mt_order_cost 
  where order_id=:order_id and type='COST' GROUP by charge_desc) t2 on t1.charge_desc=t2.charge_desc");
$statement->execute(array(':order_id'=>$order_id));
$data["charge"]=$statement->fetchAll(PDO::FETCH_ASSOC);



$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_quote_details($temp_code,$id,$quote_no)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT (SELECT name from mt_business_partner where code=requested_by limit 1) customer, address, quote_date,quote_no,valid_to,status, remarks, services,location_id,company_id  
 FROM mt_quote_list where id=:id and temp_code=:temp_code 
 and quote_no=:quote_no");
$statement->execute(array(':temp_code'=>$temp_code,
  ':id'=>$id,':quote_no'=>$quote_no));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$quote_id=$id;

$statement = $db->prepare("SELECT 
  (select port_name from mt_port_master where port_code=t1.origin) origin, 
  (select port_name from mt_port_master where port_code=t1.destination) destination, 
  provider, route_mode, duration FROM 
mt_quote_route t1 where quote_id=:quote_id");
$statement->execute(array(':quote_id'=>$quote_id));
$data["route"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT 
(select description from mt_charge_group_detail where code=t1.charge_description) charge_description,
basis_type,base_unit,currency,qty,
Rate,ex_rate,foreign_amount,local_amount
FROM mt_quote_rate t1 where quote_id=:quote_id and rate_type='INCOME'");
$statement->execute(array(':quote_id'=>$quote_id));
$data["charge"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT 
display_name, mobile, email
from user_master
where username in (select prepared_by from mt_quote_list where id=:quote_id)");
$statement->execute(array(':quote_id'=>$quote_id));
$data["salesman"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_vessel_quote_details($temp_code,$id,$quote_no)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT (SELECT name from mt_business_partner where code=requested_by limit 1) customer, address, quote_date,quote_no,valid_to,  location_id,company_id  
 FROM mt_vessel_quote where id=:id and temp_code=:temp_code 
 and quote_no=:quote_no");
$statement->execute(array(':temp_code'=>$temp_code,
  ':id'=>$id,':quote_no'=>$quote_no));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$quote_id=$id;

$statement = $db->prepare("SELECT 
  (select port_name from mt_port_master where port_code=t1.origin) origin, 
  (select port_name from mt_port_master where port_code=t1.destination) destination, 
  provider, route_mode, duration FROM 
mt_vessel_quote_route t1 where quote_id=:quote_id");
$statement->execute(array(':quote_id'=>$quote_id));
$data["route"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT t1.charge_description, t2.description, t2.vessel_ops_cat, t1.foreign_amount, t1.local_amount 
FROM mt_vessel_quote_rate t1
LEFT JOIN mt_charge_group_detail t2
ON t1.charge_description=t2.code
WHERE t1.quote_id=:quote_id and t1.rate_type='INCOME' and t2.vessel_ops_cat='FRT' ");
$statement->execute(array(':quote_id'=>$quote_id));
$data["charge1"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT t1.charge_description, t2.description, t2.vessel_ops_cat, t1.foreign_amount, t1.local_amount 
FROM mt_vessel_quote_rate t1
LEFT JOIN mt_charge_group_detail t2
ON t1.charge_description=t2.code
WHERE t1.quote_id=:quote_id and t1.rate_type='INCOME' and t2.vessel_ops_cat='PE' ");
$statement->execute(array(':quote_id'=>$quote_id));
$data["charge2"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT t1.charge_description, t2.description, t2.vessel_ops_cat, t1.foreign_amount, t1.local_amount 
FROM mt_vessel_quote_rate t1
LEFT JOIN mt_charge_group_detail t2
ON t1.charge_description=t2.code
WHERE t1.quote_id=:quote_id and t1.rate_type='INCOME' and t2.vessel_ops_cat='SC' ");
$statement->execute(array(':quote_id'=>$quote_id));
$data["charge3"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT t1.charge_description, t2.description, t2.vessel_ops_cat, t1.foreign_amount, t1.local_amount 
FROM mt_vessel_quote_rate t1
LEFT JOIN mt_charge_group_detail t2
ON t1.charge_description=t2.code
WHERE t1.quote_id=:quote_id and t1.rate_type='INCOME' and t2.vessel_ops_cat='ISI' ");
$statement->execute(array(':quote_id'=>$quote_id));
$data["charge4"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT t1.charge_description, t2.description, t2.vessel_ops_cat, t1.foreign_amount, t1.local_amount 
FROM mt_vessel_quote_rate t1
LEFT JOIN mt_charge_group_detail t2
ON t1.charge_description=t2.code
WHERE t1.quote_id=:quote_id and t1.rate_type='INCOME' and t2.vessel_ops_cat='AC' ");
$statement->execute(array(':quote_id'=>$quote_id));
$data["charge5"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT t1.charge_description, t2.description, t2.vessel_ops_cat, t1.foreign_amount, t1.local_amount 
FROM mt_vessel_quote_rate t1
LEFT JOIN mt_charge_group_detail t2
ON t1.charge_description=t2.code
WHERE t1.quote_id=:quote_id and t1.rate_type='INCOME' and t2.vessel_ops_cat='BFG' ");
$statement->execute(array(':quote_id'=>$quote_id));
$data["charge6"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT t1.charge_description, t2.description, t2.vessel_ops_cat, t1.foreign_amount, t1.local_amount 
FROM mt_vessel_quote_rate t1
LEFT JOIN mt_charge_group_detail t2
ON t1.charge_description=t2.code
WHERE t1.quote_id=:quote_id and t1.rate_type='INCOME' and t2.vessel_ops_cat='OTH' ");
$statement->execute(array(':quote_id'=>$quote_id));
$data["charge7"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT 
display_name, mobile, email
from user_master
where username in (select prepared_by from mt_vessel_quote where id=:quote_id)");
$statement->execute(array(':quote_id'=>$quote_id));
$data["salesman"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_pre_arrival_report($v,$id)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT vessel,voyage,flag,lloyds_imo_no, eta,captain_name,
port,next_port,etd, t2.registration_no 
from mt_vessel t1,mt_voyage t2
where (t1.vessel_name = t2.vessel) and voyage=:voyage and t2.id=:id");
$statement->execute(array(':voyage'=>$v,':id'=>$id));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT terminal_name,  DATE_FORMAT(berthing_date_time, '%Y-%m-%d') berthing_date_time  
from mt_voyage_terminal
where voy_pk=:voyage");
$statement->execute(array(':voyage'=>$v));
$data["terminal"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_vessel_waste_collection($v,$id)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT t2.vessel_name,t1.eta,captain_name,
  t2.vessel_type,t2.lloyds_imo_no imo_no,(select country_name from mt_country_master where country_code=t2.flag) flag,t2.year_built,
  t2.loa, t1.arrival_dft_fwd, t1.departure_dft_fwd, (select port_name from mt_port_master where port_code=t1.prev_port) last_port,t1.etd departure,
  (select port_name from mt_port_master where port_code=t1.next_port) next_port,t1.call_type typeofcargo, SUBSTRING_INDEX(t2.gt_nt, '/', 1) gt, 
  SUBSTRING_INDEX(t2.gt_nt, '/', -1) nt, t1.leg_number, t1.registration_no, t2.beam,
  t1.leg_number, t2.oil_consumption_harbour charter, t2.oil_consumption_sailing charter_nationality 
 from mt_voyage t1, mt_vessel t2  
 where 
 t1.vessel=t2.vessel_name and  voyage=:voyage and t1.id=:id");
$statement->execute(array(':voyage'=>$v,':id'=>$id));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_bulkcargo_discharge($v,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT t1.id, t1.discharge_type, t1.vessel, t1.voyage, t1.bl_no, t1.delivery_type,
t1.tot_qty, t1.avl_qty, t1.dis_qty, t1.bal_qty, 
(select name from mt_business_partner where code=t1.customer) customer, 
t1.discharge_datetime, t1.email, 
(select main_commodity from mt_manifest_entry_cargo
where mnf_entry_pk=t2.id) commodity,  
(select package_type from mt_manifest_entry_cargo
where mnf_entry_pk=t2.id) pkg_type 
FROM mt_bulkcargo_discharge t1 
left join mt_manifest_entry t2 
on t2.bl_no=t1.bl_no WHERE t1.voyage=:voyage and t1.customer like :customer");
$statement->execute(array(':voyage'=>$v,':customer'=>$c));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT (select vessel from mt_voyage where voyage=t1.voyage) vessel, voyage, bl_no, (select name from mt_business_partner where code=t1.customer) customer,(select main_commodity from mt_manifest_entry_cargo
where mnf_entry_pk=t1.id) commodity,  
(select package_type from mt_manifest_entry_cargo
where mnf_entry_pk=t1.id) pkg_type,
(select gross_weight from mt_manifest_entry_cargo
where mnf_entry_pk=t1.id) bal_qty 
FROM mt_manifest_entry t1
WHERE voyage=:voyage and bl_no not in (select bl_no FROM mt_bulkcargo_discharge where voyage=t1.voyage) ");
$statement->execute(array(':voyage'=>$v));
$data["balance_bl"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT bal_qty FROM mt_bulkcargo_discharge
where id = (SELECT max(id) FROM mt_bulkcargo_discharge t1 
 WHERE t1.voyage=:voyage)");
$statement->execute(array(':voyage'=>$v));
$data["qty_kpi"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT (select ifnull(sum(gross_weight),0) from mt_manifest_entry_cargo
where mnf_entry_pk=t1.id) bal_bl_qty 
FROM mt_manifest_entry t1
WHERE voyage=:voyage and bl_no not in (select bl_no FROM mt_bulkcargo_discharge where voyage=t1.voyage) ");
$statement->execute(array(':voyage'=>$v));
$data["bal_bl_qty_kpi"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT eta,etd from mt_voyage WHERE voyage=:voyage");
$statement->execute(array(':voyage'=>$v));
$data["ata_kpi"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT etd from mt_voyage WHERE voyage=(SELECT voyage from mt_voyage where line_voyage=:voyage) ");
$statement->execute(array(':voyage'=>$v));
$data["atd_kpi"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT discharge_datetime 
from mt_bulkcargo_discharge where id=(SELECT min(t1.id) 
FROM mt_bulkcargo_discharge t1  WHERE t1.voyage=:voyage and t1.customer=:customer)");
$statement->execute(array(':voyage'=>$v,':customer'=>$c));
$data["min_disc"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT discharge_datetime 
from mt_bulkcargo_discharge where id=(SELECT max(t1.id) 
FROM mt_bulkcargo_discharge t1  WHERE t1.voyage=:voyage and t1.customer=:customer)");
$statement->execute(array(':voyage'=>$v,':customer'=>$c));
$data["max_disc"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_port_clearance_certificate($v,$id)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT t2.vessel_name,t1.eta,captain_name,
  t2.vessel_type,t2.lloyds_imo_no imo_no,(select country_name from mt_country_master where country_code=t2.flag) flag,t2.year_built,
  t2.loa, t1.arrival_dft_fwd, t1.departure_dft_fwd, (select port_name from mt_port_master where port_code=t1.prev_port) last_port,t1.etd departure,
  (select port_name from mt_port_master where port_code=t1.next_port) next_port,t1.call_type typeofcargo, SUBSTRING_INDEX(t2.gt_nt, '/', 1) gt, 
  SUBSTRING_INDEX(t2.gt_nt, '/', -1) nt, t1.leg_number, t1.registration_no, t2.beam,
  t1.leg_number, t2.oil_consumption_harbour charter, t2.oil_consumption_sailing charter_nationality 
 from mt_voyage t1, mt_vessel t2  
 where 
 t1.vessel=t2.vessel_name and  voyage=:voyage and t1.id=:id");
$statement->execute(array(':voyage'=>$v,':id'=>$id));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT count(*) tot_load FROM mt_order_landingcraft_detail where order_id=(select id from mt_order_entry where order_no=(select order_no from mt_manifest_entry where voyage=:voyage)) ");
$statement->execute(array(':voyage'=>$v));
$data["total"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_transfer_advice_info($id,$temp_code,$bl_no)
{
//echo $id."---";
//echo $temp_code."---";
//echo $bl_no."---";
  
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("SELECT 
t1.id,
t1.bl_no,
t1.bl_date,
t1.master_bl_no,
t1.remarks,
(select port_name from mt_port_master where port_code=t2.poo) poo, 
(select port_name from mt_port_master where port_code=t2.pol) pol, 
(select port_name from mt_port_master where port_code=t2.pod) pod,  
(select port_name from mt_port_master where port_code=t2.pof) pof, 
t1.order_no,
length(t1.order_no) is_ordered,
t1.company_id,
t1.location_id,
'' selected,
(SELECT vessel from mt_voyage where voyage=t1.voyage) vessel,
t1.voyage voyage,
no_of_original,
(select port_name from mt_port_master where port_code=t1.bl_issue_place)  bl_issue_place    
 from 
mt_manifest_entry t1 ,
mt_manifest_entry_route t2 WHERE 
t2.mnf_entry_pk=t1.id and t1.id=:id and t1.temp_code=:temp_code and
t1.bl_no=:bl_no
");
$statement->execute(array(':id'=>$id,':temp_code'=>$temp_code,
  ':bl_no'=>$bl_no));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT (select name from mt_business_partner where code=t1.party_name) party_name, address from mt_manifest_entry_party t1 where party_type='CONSIGNEE' 
  and mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data["consignee"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT  (select name from mt_business_partner where code=t1.party_name) party_name, 
  (select address from mt_bp_address where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) ) address, 
  (select country from mt_bp_address where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) ) country,
  (select bank_name from mt_bp_bank where priority=1  and  bp_id=(select id from mt_business_partner where code=t1.party_name)) bank_name,
   (select account_no from mt_bp_bank where priority=1  and  bp_id=(select id from mt_business_partner where code=t1.party_name)) account_no,
   (select  swift from mt_bp_bank where priority=1  and  bp_id=(select id from mt_business_partner where code=t1.party_name)) swift 
  from mt_manifest_entry_party t1 where party_type='SHIPPER' 
  and mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data["shipper"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT  sum(qty*ex_rate*rate) rate, sum(qty*ex_rate*cost) cost, sum((qty*ex_rate*rate)-(qty*ex_rate*cost)) profit from mt_manifest_entry_rate
where mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data["profit"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_bl_info($id,$temp_code,$bl_no)
{
//echo $id."---";
//echo $temp_code."---";
//echo $bl_no."---";
  
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("SELECT 
t1.id,
t1.bl_no,
t1.cargo_type,
DATE_FORMAT(t1.bl_date, '%d-%m-%Y') bl_date,
DATE_FORMAT(t1.sob_rfs_date, '%d-%m-%Y') sob_rfs_date,
(select case when port_name!=country_name THEN
concat(port_name,', ', country_name) 
ELSE
port_name
end  
from mt_port_master t1 
left join mt_country_master t2
on t1.PORT_COUNTRY=t2.country_code
where port_code=t2.poo) poo, 
(select case when port_name!=country_name THEN
concat(port_name,', ', country_name) 
ELSE
port_name
end  
from mt_port_master t1 
left join mt_country_master t2
on t1.PORT_COUNTRY=t2.country_code
where port_code=t2.pol) pol, 
(select case when port_name!=country_name THEN
concat(port_name,', ', country_name) 
ELSE
port_name
end 
from mt_port_master t1 
left join mt_country_master t2
on t1.PORT_COUNTRY=t2.country_code
where port_code=t2.pod) pod, 
t2.pod pod_code, 
(select case when port_name!=country_name THEN
concat(port_name,', ', country_name) 
ELSE
port_name
end  
from mt_port_master t1 
left join mt_country_master t2
on t1.PORT_COUNTRY=t2.country_code
where port_code=t2.pof) pof, 
t1.order_no,
length(t1.order_no) is_ordered,
t1.company_id,
t1.location_id,
'' selected,
t2.vessel,
t2.voyage voyage,
no_of_original,
ifnull((select port_name from mt_port_master where port_code=t1.bl_issue_place),t1.bl_issue_place)  bl_issue_place,
(select country_name from mt_country_master where country_code=(select port_country from mt_port_master where port_code=t1.bl_issue_place) limit 1)  bl_issue_country,
t1.to_order,   
t1.remarks,   
t1.remarks2,
t1.free_days    
 from 
mt_manifest_entry t1 ,
mt_manifest_entry_route t2 WHERE 
t2.mnf_entry_pk=t1.id and t1.id=:id and t1.temp_code=:temp_code and
t1.bl_no=:bl_no 
limit 1 
");
$statement->execute(array(':id'=>$id,':temp_code'=>$temp_code,
  ':bl_no'=>$bl_no));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

// $statement = $db->prepare("SELECT (select name from mt_business_partner where code=t1.delivery_agent) party_name, (select address from mt_bp_address where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.delivery_agent) ) address from mt_manifest_entry t1 where id=:id");
// $statement->execute(array(':id'=>$id));
// $data["del_agent"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT (select name from mt_business_partner where code=t1.party_name) party_name, 
  (select address from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) address, 
  (select address2 from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) address2, 
  (select address3 from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) address3,  
    (select phone from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) phone, email, poc from mt_manifest_entry_party t1 where party_type='CONSIGNEE' 
  and mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data["consignee"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT  (select name from mt_business_partner where code=t1.party_name) party_name, 
  (select address from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) address, 
  (select address2 from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) address2, 
  (select address3 from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) address3,    
  (select phone from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) phone, 
  email, poc from mt_manifest_entry_party t1 where party_type='SHIPPER' 
  and mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data["shipper"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT  (select name from mt_business_partner where code=t1.party_name) party_name, 
  (select address from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) address, 
(select address2 from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) address2, 
  (select address3 from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) address3,    
    (select phone from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) phone, email, poc from mt_manifest_entry_party t1 where party_type='NOTIFY PARTY' 
  and mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data["notify"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT  (select name from mt_business_partner where code=t1.party_name) party_name, 
  (select address from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) address, 
  (select address2 from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) address2, 
  (select address3 from mt_bp_address tt where type='HQ' and  bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) address3,  
  (select phone from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) phone, email, poc from mt_manifest_entry_party t1 where party_type='DELIVERY AGENT' 
  and mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data["delivery"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare(" SELECT container_no vin_no, seal_no,  type, no_of_pkgs,package_type,cargo_desc,gr_wgt,nt_wgt,volume from mt_manifest_entry_container where mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data["lc"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare(" SELECT SUBSTRING(marks,1,150) marks, 
SUBSTRING(marks,151,LOCATE('\n',SUBSTRING(marks,151))) marks0, 
SUBSTRING(marks,(151+LOCATE('\n',SUBSTRING(marks,151)))) marks1, 

SUBSTRING(description,1,300) description, 
SUBSTRING(description,301,LOCATE('\n',SUBSTRING(description,301))) description0, 
SUBSTRING(description,(301+LOCATE('\n',SUBSTRING(description,301)))) description1 
from mt_manifest_entry_marks 
  where mnf_entry_pk=:id ");
$statement->execute(array(':id'=>$id));
$data["marks_nos"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT payment_mode, ifnull((select port_name from mt_port_master where port_code=pay_at_location),pay_at_location) pay_at_location, (select country_name from mt_country_master where country_code=(select port_country from mt_port_master where port_code=pay_at_location) limit 1) pay_country from mt_manifest_entry_rate
where charge_desc='OFRT' 
  and mnf_entry_pk=:id
limit 1 ");
$statement->execute(array(':id'=>$id));
$data["payment_mode"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT main_commodity, no_of_packages, package_type, gross_weight, weight_uom, volume, volume_uom FROM mt_manifest_entry_cargo
where mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data["cargo"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_bl_info_smc($id,$temp_code,$bl_no)
{
//echo $id."---";
//echo $temp_code."---";
//echo $bl_no."---";
  
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("SELECT 
t1.id,
t1.bl_no,
t1.cargo_type,
DATE_FORMAT(t1.bl_date, '%d-%m-%Y') bl_date,
DATE_FORMAT(t1.sob_rfs_date, '%d-%m-%Y') sob_rfs_date,
(select case when port_name!=country_name THEN
concat(port_name,', ', country_name) 
ELSE
port_name
end  
from mt_port_master t1 
left join mt_country_master t2
on t1.PORT_COUNTRY=t2.country_code
where port_code=t2.poo) poo, 
(select case when port_name!=country_name THEN
concat(port_name,', ', country_name) 
ELSE
port_name
end  
from mt_port_master t1 
left join mt_country_master t2
on t1.PORT_COUNTRY=t2.country_code
where port_code=t2.pol) pol, 
(select case when port_name!=country_name THEN
concat(port_name,', ', country_name) 
ELSE
port_name
end 
from mt_port_master t1 
left join mt_country_master t2
on t1.PORT_COUNTRY=t2.country_code
where port_code=t2.pod) pod,  
(select case when port_name!=country_name THEN
concat(port_name,', ', country_name) 
ELSE
port_name
end  
from mt_port_master t1 
left join mt_country_master t2
on t1.PORT_COUNTRY=t2.country_code
where port_code=t2.pof) pof, 
t1.order_no,
length(t1.order_no) is_ordered,
t1.company_id,
t1.location_id,
'' selected,
t2.vessel,
t2.voyage voyage,
no_of_original,
ifnull((select port_name from mt_port_master where port_code=t1.bl_issue_place),t1.bl_issue_place)  bl_issue_place,
(select country_name from mt_country_master where country_code=(select port_country from mt_port_master where port_code=t1.bl_issue_place) limit 1)  bl_issue_country,
t1.to_order,   
t1.remarks,   
t1.remarks2,
t1.free_days    
 from 
mt_manifest_entry t1 ,
mt_manifest_entry_route t2 WHERE 
t2.mnf_entry_pk=t1.id and t1.id=:id and t1.temp_code=:temp_code and
t1.bl_no=:bl_no 
limit 1 
");
$statement->execute(array(':id'=>$id,':temp_code'=>$temp_code,
  ':bl_no'=>$bl_no));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

// $statement = $db->prepare("SELECT (select name from mt_business_partner where code=t1.delivery_agent) party_name, (select address from mt_bp_address where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.delivery_agent) ) address from mt_manifest_entry t1 where id=:id");
// $statement->execute(array(':id'=>$id));
// $data["del_agent"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT (select name from mt_business_partner where code=t1.party_name) party_name, address, 
  (select address2 from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) address2, 
  (select address3 from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) address3,  
    (select phone from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) phone, email, poc from mt_manifest_entry_party t1 where party_type='CONSIGNEE' 
  and mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data["consignee"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT  (select name from mt_business_partner where code=t1.party_name) party_name, address, 
  (select address2 from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) address2, 
  (select address3 from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) address3,    
  (select phone from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) phone, 
  email, poc from mt_manifest_entry_party t1 where party_type='SHIPPER' 
  and mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data["shipper"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT  (select name from mt_business_partner where code=t1.party_name) party_name, address, 
(select address2 from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) address2, 
  (select address3 from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) address3,    
    (select phone from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) phone, email, poc from mt_manifest_entry_party t1 where party_type='NOTIFY PARTY' 
  and mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data["notify"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT  (select name from mt_business_partner where code=t1.party_name) party_name, address, 
  (select address2 from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) address2, 
  (select address3 from mt_bp_address tt where type='HQ' and  bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) address3,  
  (select phone from mt_bp_address tt where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name) limit 1) phone, email, poc from mt_manifest_entry_party t1 where party_type='DELIVERY AGENT' 
  and mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data["delivery"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare(" SELECT container_no vin_no, seal_no,  type, no_of_pkgs,package_type,cargo_desc,gr_wgt,nt_wgt,volume from mt_manifest_entry_container where mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data["lc"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare(" SELECT SUBSTRING(marks,1,150) marks, 
SUBSTRING(marks,151,LOCATE('\n',SUBSTRING(marks,151))) marks0, 
SUBSTRING(marks,(151+LOCATE('\n',SUBSTRING(marks,151)))) marks1, 

SUBSTRING(description,1,350) description, 
SUBSTRING(description,351,LOCATE('\n',SUBSTRING(description,351))) description0, 
SUBSTRING(description,(351+LOCATE('\n',SUBSTRING(description,351)))) description1 
from mt_manifest_entry_marks 
  where mnf_entry_pk=:id ");
$statement->execute(array(':id'=>$id));
$data["marks_nos"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT payment_mode, ifnull((select port_name from mt_port_master where port_code=pay_at_location),pay_at_location) pay_at_location, (select country_name from mt_country_master where country_code=(select port_country from mt_port_master where port_code=pay_at_location) limit 1) pay_country from mt_manifest_entry_rate
where charge_desc='OFRT' 
  and mnf_entry_pk=:id
limit 1 ");
$statement->execute(array(':id'=>$id));
$data["payment_mode"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT main_commodity, no_of_packages, package_type, gross_weight, weight_uom, volume, volume_uom FROM mt_manifest_entry_cargo
where mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data["cargo"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_bl_principal($bl_no)
{
  
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare(" SELECT principal from mt_order_entry where bl_no=:bl_no");
$statement->execute(array(':bl_no'=>$bl_no));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_bl_location($bl_no)
{
  
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare(" SELECT location_id from mt_manifest_entry where bl_no=:bl_no");
$statement->execute(array(':bl_no'=>$bl_no));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_bl_info1($id)
{
  
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare(" SELECT container_no vin_no, seal_no,  type, no_of_pkgs,package_type,cargo_desc,gr_wgt,nt_wgt,volume from mt_manifest_entry_container where mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data["lc"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT main_commodity, no_of_packages, package_type, gross_weight, weight_uom, volume, volume_uom FROM mt_manifest_entry_cargo
where mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data["cargo"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT (select upper(description) from mt_charge_group_detail where code=charge_desc)charge_desc,qty, currency, rate, cost_base_amount,basis_type, payment_mode, ifnull((select port_name from mt_port_master where port_code=pay_at_location),pay_at_location) pay_at_location 
from mt_manifest_entry_rate
where mnf_entry_pk=:id ");
$statement->execute(array(':id'=>$id));
$data["rate"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function save_rate($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_rates(created_by,created_date,ip,ua,ekey,temp_code) 
values(:created_by,now(),:ip,:ua,:ekey,
:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,




':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_erc where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,':uid'=>$dev->uid));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_rate($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_rates SET 

modified_by=:modified_by,
modified_date=now() 
where id=:id");

$statement->execute(array(':modified_by'=>$dev->uid ,

':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_cost_center_report($cc_gl,$exp_gl,$from_date,$to_date)
{
$data=array();
try
{
$db = Factory::getConnection();
$aq='';
if(strlen($exp_gl)!=0)
{
  $aq=" AND c_gl like '%$exp_gl%'";
}
$statement = $db->prepare(" SELECT cost_gl_code, c_gl, t4.ac_description,
cost_glt_doc_base,
cost_glt_doc_type,
cost_glt_number,
cost_glt_other_reference,
cost_glt_local_amount,
cost_glt_narration,
cost_glt_aloc_type, 
cost_glt_doc_date 
FROM 
(SELECT CONCAT(t1.cost_gl_code,' / ', t2.cost_description) cost_gl_code,
CASE WHEN cost_glt_doc_base='PAYMENT' THEN
(SELECT pre_glt_code from mt_payment_gl_details where pre_glt_doc_number=t1.cost_glt_number and pre_glt_detail_3=t1.cost_gl_code and pre_glt_local_amount=t1.cost_glt_local_amount limit 1) 
ELSE 
(SELECT pre_glt_code from mt_ap_gl_details where pre_glt_doc_number=t1.cost_glt_number and pre_glt_detail_3=t1.cost_gl_code and pre_glt_local_amount=t1.cost_glt_local_amount limit 1) 
END AS c_gl,
cost_glt_doc_base,
cost_glt_doc_type,
cost_glt_number,
cost_glt_other_reference,
cost_glt_local_amount,
cost_glt_narration,
cost_glt_aloc_type, 
cost_glt_doc_date 
FROM mt_cost_center t1 
LEFT JOIN mt_cost_center_master t2
ON t2.cost_code=t1.cost_gl_code
where t1.cost_gl_code=:cost_gl_code) t3 
LEFT JOIN mt_general_ledger t4
ON t3.c_gl=t4.code 
WHERE cost_glt_doc_date between :from_date and :to_date 
and ((SELECT aph_status FROM mt_ap_header where aph_document_number=t3.cost_glt_number) != 'CANCELLED' or (SELECT ph_status FROM mt_payment_header where ph_doc_number=t3.cost_glt_number) != 'CANCELLED' )  $aq ");
$statement->execute(array(':cost_gl_code'=>$cc_gl,':from_date'=>$from_date,':to_date'=>$to_date));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_pdc_report($pdc_type,$party,$chq_date,$status)
{
$data=array();
try
{
$db = Factory::getConnection();
if($pdc_type=='RECEIPT')
{
$aq='';
if(strlen($party)!=0)
{
  $aq=" and t4.aloc_detail_2='$party' ";
}

if($chq_date!='NaN-NaN-NaN')
{
  $aq=" and t2.rh_cheque_date='$chq_date' ";
}

$statement = $db->prepare("SELECT  t2.rh_doc_number ,  
t2.rh_base_doc_type , 
t2.rh_doc_type , 
t2.rh_cash_bank_code , 
t2.rh_local_amount , 
t2.rh_cheque_number , 
t2.rh_cheque_date , 
t2.rh_narration , 
t2.rh_status , 
t2.rh_gl_account ,
t3.pre_glt_doc_date clr_date ,
t3.pre_glt_code clr_bank ,
(select name from mt_business_partner where code=t4.aloc_detail_2) party 
FROM mt_receipt_header t2
LEFT JOIN mt_receipt_gl_details t3
ON t3.pre_glt_doc_number=t2.rh_doc_number and t3.pre_glt_allocation_code='ACCOUNTS RECEIVABLE'
LEFT JOIN mt_receipt_allocation_details t4 
ON t4.aloc_doc_number=t2.rh_doc_number and t4.aloc_allocation_type='ACCOUNTS RECEIVABLE'
WHERE  t2.rh_base_doc_type='RECEIPT' and t2.rh_doc_type='CHEQUE' and t2.rh_status=:status $aq");
$statement->execute(array(':status'=>$status));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);
}
else{

  $aq='';
if(strlen($party)!=0)
{
  $aq=" and t4.aloc_detail_2='$party' ";
}

if($chq_date!='NaN-NaN-NaN')
{
  $aq=" and t2.ph_cheque_date='$chq_date' ";
}

$statement = $db->prepare("SELECT  t2.ph_doc_number rh_doc_number,  
t2.ph_base_doc_type rh_base_doc_type, 
t2.ph_doc_type rh_doc_type, 
t2.ph_cash_bank_code rh_cash_bank_code, 
t2.ph_local_amount rh_local_amount, 
t2.ph_cheque_number rh_cheque_number, 
t2.ph_cheque_date rh_cheque_date, 
t2.ph_narration rh_narration, 
t2.ph_status rh_status, 
t2.ph_gl_account rh_gl_account,
t3.pre_glt_doc_date clr_date ,
t3.pre_glt_code clr_bank ,
(select name from mt_business_partner where code=t4.aloc_detail_2) party 
FROM mt_payment_header t2
LEFT JOIN mt_payment_gl_details t3
ON t3.pre_glt_doc_number=t2.ph_doc_number and t3.pre_glt_allocation_code='ACCOUNTS PAYABLE'
LEFT JOIN mt_payment_allocation_details t4 
ON t4.aloc_doc_number=t2.ph_doc_number and t4.aloc_allocation_type='ACCOUNTS PAYABLE'
WHERE  t2.ph_base_doc_type='PAYMENT' and t2.ph_doc_type='CHEQUE' and t2.ph_status=:status $aq");
$statement->execute(array(':status'=>$status));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_vessel_soa($art_code,$from_date,$to_date,$username)
{
$data=array();
try
{
$db = Factory::getConnection();

//Get Party info
$statement = $db->prepare("SELECT t1.code, t1.name, t2.address, t3.currency, t3.final_limit, 
  t3.credit_days FROM mt_business_partner t1 
LEFT JOIN mt_bp_address t2
ON t1.id=t2.bp_id and t2.type='HQ'
LEFT JOIN mt_bp_credit t3 
ON t1.id=t3.bp_id 
WHERE t1.code=:art_code");
$statement->execute(array(':art_code'=>$art_code));
$data["head"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get detail info
$statement = $db->prepare("SELECT art_code,
ART_GL_DATE,
ART_TYPE,
ART_NUMBER,
case when art_type='IMP-INV' THEN
ifnull((select bl_no from mt_ship_ar_header
where sub_ar_doc_number=t1.ART_NUMBER),ART_DESCRIPTION)
ELSE ' '
END AS ART_OTHER_REFERENCE,
ART_DESCRIPTION,
ART_LOCAL_AMOUNT,
ART_FOREIGN_AMOUNT,
ART_LOCAL_BALANCE  
FROM mt_ar_trans t1  
WHERE art_code=:art_code and (ART_GL_DATE between :from_date and :to_date)  and art_balance_status!='CANCELLED' 
UNION
SELECT apt_code art_code,
APT_GL_DATE ART_GL_DATE,
APT_TYPE ART_TYPE,
APT_NUMBER ART_NUMBER,
APT_OTHER_REFERENCE ART_OTHER_REFERENCE,
APT_DESCRIPTION ART_DESCRIPTION,
APT_LOCAL_AMOUNT ART_LOCAL_AMOUNT,
APT_FOREIGN_AMOUNT ART_FOREIGN_AMOUNT,
APT_LOCAL_BALANCE ART_LOCAL_BALANCE  
FROM mt_ap_trans t1  
WHERE apt_code=:art_code and (APT_GL_DATE between :from_date and :to_date)  and apt_balance_status!='CANCELLED' 
ORDER BY ART_GL_DATE ");
$statement->execute(array(':art_code'=>$art_code,
  ':from_date'=>$from_date,':to_date'=>$to_date));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get PDC data
$statement = $db->prepare("SELECT
t1.id, 
t1.rh_base_doc_type,
t1.rh_doc_type,
t1.rh_doc_date,
t1.rh_doc_number,
t1.rh_cash_bank_code,
t2.aloc_local_amount rh_local_amount,
t1.rh_cheque_number,
t1.rh_cheque_date 
FROM mt_receipt_header t1
LEFT JOIN mt_receipt_allocation_details t2
ON t1.rh_doc_number= t2.aloc_doc_number
WHERE t1.rh_status='AWAITING CONFIRMATION' and   t2.aloc_detail_2=:id and t2.aloc_doc_type='CHEQUE' UNION
SELECT
t1.id,  
t1.ph_base_doc_type rh_base_doc_type,
t1.ph_doc_type rh_doc_type,
t1.ph_doc_date rh_doc_date,
t1.ph_doc_number rh_doc_number,
t1.ph_cash_bank_code rh_cash_bank_code,
t2.aloc_local_amount rh_local_amount,
t1.ph_cheque_number rh_cheque_number,
t1.ph_cheque_date rh_cheque_date 
FROM mt_payment_header t1
LEFT JOIN mt_payment_allocation_details t2
ON t1.ph_doc_number= t2.aloc_doc_number
WHERE t1.ph_status='AWAITING CONFIRMATION' and   t2.aloc_detail_2=:id and t2.aloc_doc_type='CHEQUE' ");
$statement->execute(array(':id'=>$art_code));
$data["pdc_data"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get Opening Balance 2
$statement = $db->prepare("SELECT ifnull(SUM(CASE
        WHEN art_type='OPENING BALANCE' THEN ART_LOCAL_AMOUNT
        ELSE 0
    END),0) AS 'ob',
    ifnull(SUM(CASE
        WHEN ART_LOCAL_AMOUNT > 0 and art_type!='OPENING BALANCE' THEN ART_LOCAL_AMOUNT
        ELSE 0
    END),0) AS 'pos',
    ifnull(SUM(CASE
        WHEN ART_LOCAL_AMOUNT < 0 and art_type!='OPENING BALANCE' THEN ART_LOCAL_AMOUNT
        ELSE 0
    END),0) AS 'neg' 
FROM mt_ar_trans t1  
WHERE art_code=:art_code  and (ART_GL_DATE < :from_date) and art_balance_status!='CANCELLED' ");
$statement->execute(array(':art_code'=>$art_code,
  ':from_date'=>$from_date));
$data["op_bal2"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get Opening Balance 3
$statement = $db->prepare("SELECT ifnull(SUM(CASE
        WHEN apt_type='OPENING BALANCE' THEN APT_LOCAL_AMOUNT
        ELSE 0
    END),0) AS 'ob',
    ifnull(SUM(CASE
        WHEN APT_LOCAL_AMOUNT > 0 and apt_type!='OPENING BALANCE' THEN APT_LOCAL_AMOUNT
        ELSE 0
    END),0) AS 'pos',
    ifnull(SUM(CASE
        WHEN APT_LOCAL_AMOUNT < 0 and apt_type!='OPENING BALANCE' THEN APT_LOCAL_AMOUNT
        ELSE 0
    END),0) AS 'neg' 
FROM mt_ap_trans t1  
WHERE apt_code=:art_code  and (APT_GL_DATE < :from_date) and apt_balance_status!='CANCELLED' ");
$statement->execute(array(':art_code'=>$art_code,
  ':from_date'=>$from_date));
$data["op_bal3"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//Get EPDA detail
$statement = $db->prepare("SELECT sub_ar_code, sub_ar_doc_number, sub_ar_date, sub_ar_currency, sub_ar_l_amount, sub_ar_narration, order_no, bl_no
 from mt_ship_ar_header 
 where sub_ar_code=:art_code and sub_ar_doc_base='EPDA'  and sub_ar_status!='CANCELLED' ");
$statement->execute(array(':art_code'=>$art_code));
$data["epda"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_vessel_fda_details($temp_code,$id,$fda_no)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT (SELECT name from mt_business_partner where code=customer limit 1) customer, fda_date,fda_no, t1.ch_agr_no, t3.vessel_name, t3.active_from, t3.active_to, t1.quote_no, t2.id, t2.notes, t1.location_id,t1.company_id  
 FROM mt_vessel_fda t1
 left join mt_vessel_quote t2
 on t1.quote_no=t2.quote_no 
 left join mt_vessel_ops t3 
 on t2.ch_agr_no=t3.ch_agr_no 
 where t1.id=:id and t1.temp_code=:temp_code 
 and t1.fda_no=:fda_no");
$statement->execute(array(':temp_code'=>$temp_code,
  ':id'=>$id,':fda_no'=>$fda_no));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$quote_no=$data["info"][0]["quote_no"];
$quote_id=$data["info"][0]["id"];

$statement = $db->prepare("SELECT 
(select port_name from mt_port_master where port_code=origin) origin_d, origin,
(select port_name from mt_port_master where port_code=destination) destination_d, destination 
from mt_vessel_quote_route
where quote_id=:id limit 1 ");
$statement->execute(array(':id'=>$quote_id));
$data["route"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT 
(select description from mt_charge_group_detail where code=t1.charge_desc) charge_description,
basis_type,base_uom,currency,qty,
rate,ex_rate,foreign_amount,local_amount
FROM mt_vessel_fda_details t1 where quote_no=:quote_no and type='INCOME'");
$statement->execute(array(':quote_no'=>$quote_no));
$data["charge"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_vessel_job_cost_sheet_details($temp_code,$id,$job_no)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT ch_agr_no,
quote_no,
quote_date,
requested_by,
address,
prepared_by,
base_currency,
location_id,
company_id,
sales_ops_ref,
job_type   
from mt_vessel_quote 
 where id=:id and temp_code=:temp_code 
 and quote_no=:job_no");
$statement->execute(array(':temp_code'=>$temp_code,
  ':id'=>$id,':job_no'=>$job_no));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);


//outer join applied
$statement = $db->prepare(" SELECT t1.quote_id,
(SELECT description from mt_charge_group_detail where code=t1.charge_description) charge_description,
t1.currency,
t1.qty,
t1.foreign_amount income,
t2.foreign_amount cost,
t1.foreign_amount-t2.foreign_amount profit  
FROM mt_vessel_quote_rate t1
left join mt_vessel_quote_rate t2
on t1.quote_id=t2.quote_id and t1.charge_description=t2.charge_description and t2.rate_type='COST'
WHERE t1.quote_id=:id and t1.rate_type='INCOME' ");
$statement->execute(array(':id'=>$id));
$data["charge"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_customers_notifywise($notify)
{

$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT  
distinct t1.customer, 
(select name from mt_business_partner where code=t2.party_name) notify_name  
from mt_order_entry t1
left join mt_order_parties t2
on t1.id=t2.order_id
where  t2.party_type='NOTIFY PARTY' AND t2.party_name=:notify ");

$statement->execute(array(':notify'=>$notify));
$data["notify_info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//var_dump($statement->debugDumpParams());
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function get_order_detailswithrelease($temp_code,$id,$order_no)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,
order_no,
status,
order_type,
cargo_type,
quote,
copy_from,
bl_no,
DATE_FORMAT(expected_date, '%d-%m-%Y') expected_date,
order_executive,
(select port_name from mt_port_master where port_code=t1.shipment_from) shipment_from,
(select port_name from mt_port_master where port_code=t1.shipment_to) shipment_to,
requested_office,
enquiry_reference,
location_id,
company_id,
shipment_type,
to_invoice,
shipment_terms,
do_status,
carrier_booking_no,
release_no,
seal_collection,
DATE_FORMAT(release_validity_date, '%d-%m-%Y') release_validity_date,
DATE_FORMAT(si_dt, '%d-%m-%Y %H:%i') si_dt, 
  (SELECT name from mt_business_partner where code=customer) customer,

   (SELECT name from mt_business_partner where code=t1.depot) depot, 
 (SELECT address from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=t1.depot)) d_add1,
 (SELECT address2 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=t1.depot)) d_add2,
 (SELECT address3 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=t1.depot)) d_add3,
  (SELECT city from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=t1.depot)) d_city,
   (SELECT zip from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=t1.depot)) d_zip,
  (SELECT mobile1 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=t1.depot)) d_mobile,
    (SELECT phone from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=t1.depot)) d_phone,
    (SELECT email1 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=t1.depot)) d_email,
    remarks 

from mt_order_entry t1
 where id=:id and temp_code=:temp_code 
 and order_no=:order_no");
$statement->execute(array(':temp_code'=>$temp_code,
  ':id'=>$id,':order_no'=>$order_no));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$order_id=$id;

$statement = $db->prepare("SELECT (select port_name from mt_port_master where port_code=efrom) port, 
(select port_name from mt_port_master where port_code=eto) next_port,  
  t1.routing_transport_leg,  vessel,  voyage, fpod,
  etd, 
  eta, 
  '' export_end_calc_date,
  routing_transport_leg leg_number,
  '' berth_number,
  provider     
from mt_order_route t1 
where t1.order_id=:order_id 
order by t1.id asc ");
$statement->execute(array(':order_id'=>$order_id));
$data["route"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT t1.unit_type,
t1.booked_qty,
ifnull((SELECT description from mt_commodity_master where code=t1.main_commodity limit 1),t1.main_commodity) main_commodity,
t1.gross_weight,
t1.weight_uom,
t1.dangerous 
from mt_order_cargo t1
 where t1.order_id=:order_id");
$statement->execute(array(':order_id'=>$order_id));
$data["container"]=$statement->fetchAll(PDO::FETCH_ASSOC);

// (SELECT name from mt_business_partner where code=t1.empty_release_office) depot, 
//  (SELECT address from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=t1.empty_release_office)) d_add1,
//   (SELECT address2 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=t1.empty_release_office)) d_add2,
//    (SELECT address3 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=t1.empty_release_office)) d_add3,
//   (SELECT mobile1 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=t1.empty_release_office)) d_mobile,
//     (SELECT phone from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=t1.empty_release_office)) d_phone,
//     (SELECT fax from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=t1.empty_release_office)) d_fax,
//     (SELECT email1 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=t1.empty_release_office)) d_email,
    
$statement = $db->prepare(" SELECT container_no, type 
  FROM mt_order_container_detail t1 
 where t1.order_id=:order_id");
$statement->execute(array(':order_id'=>$order_id));
$data["container_detail"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare(" SELECT salutation,concat(first_name,' ',middle_name,' ',last_name) cname, mobile,email1 FROM mt_bp_contact
where bp_id=(SELECT id from mt_business_partner where code=(SELECT depot from mt_order_entry where id=:order_id)) ");
$statement->execute(array(':order_id'=>$order_id));
$data["bp_contact"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function check_bl_invoiced($id,$temp_code,$bl_no)
{
  
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT sub_ar_doc_number from mt_ship_ar_header 
where REPLACE(bl_no,',','')=:bl_no and sub_ar_doc_type in ('PRO-INV') and sub_ar_status != 'CANCELLED' ");
$statement->execute(array(':bl_no'=>$bl_no));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_sales_excel($dev,$from_date,$to_date)
{
$data=array();
try
{
$db = Factory::getConnection();

$aq='';           

//FETCH USER RIGHTS
$view_type="";
$location_id="";

//Get Location
$statement = $db->prepare("SELECT location from user_master
where username=:username ");
$statement->execute(array(':username'=>$dev->username));
$data["location"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$location_id=$data["location"][0]["location"];

$statement = $db->prepare(" SELECT view_type FROM user_master 
WHERE username=:username ");
$statement->execute(array(':username'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$view_type=$op[0]["view_type"];

if($view_type=='USER'){
  $aq=" AND t1.location_id='$location_id' ";
}else {
  //$aq=" ";
}

$statement = $db->prepare("SELECT id, enquiry_reference,(SELECT name from mt_business_partner where code=customer) customer, 
  (select count(container_no) from mt_order_container_detail where order_id=t1.id ) teus,
  (select round(sum(selling_base_amount),2) from mt_order_cost where order_id=t1.id and type='INCOME') total_sales,
(select round(ifnull(sum(cost_base_amount),0),2) from mt_order_cost where order_id=t1.id and type='COST') total_cost,
round((select sum(selling_base_amount) from mt_order_cost where order_id=t1.id and type='INCOME')-(select ifnull(sum(cost_base_amount),0) from mt_order_cost where order_id=t1.id and type='COST'),2) profit
from mt_order_entry t1 
          WHERE created_date between :from_date and :to_date 
           $aq 
          order by created_date asc ");
$statement->execute(array(':from_date'=>$from_date, ':to_date'=>$to_date));
$data["dList"]=$statement->fetchAll(PDO::FETCH_ASSOC);

  if ($statement->rowCount()){
    $data["status"]=1;
  } else{
    $data["status"]=0;
  }

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

}
?>